/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var we=["exports","require","vs/base/common/lifecycle","vs/base/common/event","vs/base/browser/dom","vs/base/common/platform","vs/base/common/errors","vs/css!vs/code/electron-sandbox/processExplorer/processExplorerMain","vs/base/common/keyCodes","vs/base/common/arrays","vs/base/common/types","vs/base/common/strings","vs/base/common/async","vs/nls","vs/base/browser/ui/hover/hoverDelegateFactory","vs/base/browser/keyboardEvent","vs/base/common/uri","vs/base/common/charCode","vs/base/browser/browser","vs/base/browser/mouseEvent","vs/base/common/scrollable","vs/base/common/codicons","vs/base/common/themables","vs/base/browser/ui/widget","vs/base/browser/window","vs/base/common/lazy","vs/base/common/observableInternal/debugName","vs/base/common/observableInternal/base","vs/base/common/path","vs/base/browser/event","vs/base/common/equals","vs/base/common/observableInternal/logging","vs/base/browser/touch","vs/base/browser/ui/hover/hoverDelegate2","vs/base/browser/ui/tree/tree","vs/base/common/decorators","vs/base/common/iterator","vs/base/common/numbers","vs/base/common/cancellation","vs/base/common/network","vs/base/parts/sandbox/electron-sandbox/globals","vs/base/browser/ui/list/list","vs/base/common/assert","vs/base/common/map","vs/base/common/observableInternal/autorun","vs/base/common/observableInternal/derived","vs/base/common/range","vs/base/common/buffer","vs/base/common/codiconsUtil","vs/base/common/filters","vs/base/common/resources","vs/base/browser/ui/scrollbar/scrollbarArrow","vs/base/browser/ui/list/listWidget","vs/base/common/actions","vs/platform/instantiation/common/instantiation","vs/base/browser/fastDomNode","vs/base/browser/ui/scrollbar/scrollbarState","vs/base/common/collections","vs/base/common/functional","vs/base/common/linkedList","vs/base/common/marshallingIds","vs/base/browser/canIUse","vs/base/common/observable","vs/base/common/symbols","vs/base/common/objects","vs/base/common/uint","vs/base/common/hash","vs/base/common/iconLabels","vs/base/common/marshalling","vs/base/browser/dnd","vs/base/browser/formattedTextRenderer","vs/base/browser/globalPointerMoveMonitor","vs/base/browser/ui/tree/indexTreeModel","vs/base/browser/ui/scrollbar/abstractScrollbar","vs/base/parts/ipc/common/ipc","vs/css!vs/base/browser/ui/actionbar/actionbar","vs/base/browser/ui/aria/aria","vs/base/browser/ui/contextview/contextview","vs/base/browser/ui/scrollbar/scrollableElement","vs/base/browser/ui/list/listView","vs/base/browser/ui/actionbar/actionViewItems","vs/base/browser/ui/actionbar/actionbar","vs/base/browser/ui/inputbox/inputBox","vs/base/browser/ui/toggle/toggle","vs/platform/registry/common/platform","vs/base/browser/iframe","vs/base/browser/ui/list/splice","vs/base/common/arraysFind","vs/base/common/color","vs/base/common/diff/diffChange","vs/base/common/idGenerator","vs/base/common/jsonSchema","vs/base/common/marked/marked","vs/base/common/naturalLanguage/korean","vs/base/common/navigator","vs/base/common/history","vs/base/common/observableInternal/lazyObservableValue","vs/base/common/observableInternal/api","vs/base/common/keybindings","vs/base/common/process","vs/base/common/mime","vs/base/browser/ui/list/rangeMap","vs/base/common/stopwatch","vs/base/common/cache","vs/base/common/observableInternal/promise","vs/base/common/observableInternal/utils","vs/base/common/stream","vs/base/common/codiconsLibrary","vs/base/common/extpath","vs/base/common/diff/diff","vs/base/common/ternarySearchTree","vs/base/browser/dompurify/dompurify","vs/base/browser/ui/iconLabel/iconLabels","vs/base/browser/ui/list/rowCache","vs/base/browser/ui/scrollbar/scrollbarVisibilityController","vs/base/browser/ui/selectBox/selectBoxNative","vs/base/browser/ui/tree/objectTreeModel","vs/base/browser/ui/scrollbar/horizontalScrollbar","vs/base/browser/ui/scrollbar/verticalScrollbar","vs/base/common/htmlContent","vs/base/browser/markdownRenderer","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/base/parts/contextmenu/electron-sandbox/contextmenu","vs/base/parts/ipc/electron-sandbox/ipc.electron","vs/css!vs/base/browser/ui/aria/aria","vs/css!vs/base/browser/ui/codicons/codicon/codicon","vs/css!vs/base/browser/ui/codicons/codicon/codicon-modifiers","vs/base/browser/ui/codicons/codiconStyles","vs/css!vs/base/browser/ui/contextview/contextview","vs/css!vs/base/browser/ui/findinput/findInput","vs/css!vs/base/browser/ui/inputbox/inputBox","vs/css!vs/base/browser/ui/list/list","vs/css!vs/base/browser/ui/scrollbar/media/scrollbars","vs/css!vs/base/browser/ui/selectBox/selectBox","vs/css!vs/base/browser/ui/selectBox/selectBoxCustom","vs/css!vs/base/browser/ui/toggle/toggle","vs/css!vs/base/browser/ui/tree/media/tree","vs/css!vs/code/electron-sandbox/processExplorer/media/processExplorer","vs/base/browser/ui/selectBox/selectBoxCustom","vs/base/browser/ui/selectBox/selectBox","vs/base/browser/ui/findinput/findInputToggles","vs/base/browser/ui/findinput/findInput","vs/base/browser/ui/tree/abstractTree","vs/base/browser/ui/tree/dataTree","vs/platform/diagnostics/common/diagnostics","vs/platform/files/common/files","vs/platform/ipc/common/mainProcessService","vs/platform/ipc/electron-sandbox/mainProcessService","vs/platform/native/common/nativeHostService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/theme/common/iconRegistry","vs/platform/theme/browser/iconsStyleSheet","vs/platform/window/common/window","vs/platform/window/electron-sandbox/window","vs/code/electron-sandbox/processExplorer/processExplorerMain"],ve=function(re){for(var t=[],i=0,n=re.length;i<n;i++)t[i]=we[re[i]];return t};/*! @license DOMPurify 3.0.5 | (c) Cure53 and other contributors | Released under the Apache license 2.0 and Mozilla Public License 2.0 | github.com/cure53/DOMPurify/blob/3.0.5/LICENSE */const{entries:Ut,setPrototypeOf:Ht,isFrozen:ui,getPrototypeOf:hi,getOwnPropertyDescriptor:ci}=Object;let{freeze:ut,seal:$t,create:fi}=Object,{apply:Mt,construct:jt}=typeof Reflect<"u"&&Reflect;Mt||(Mt=function(t,i,n){return t.apply(i,n)}),ut||(ut=function(t){return t}),$t||($t=function(t){return t}),jt||(jt=function(t,i){return new t(...i)});const di=mt(Array.prototype.forEach),xt=mt(Array.prototype.pop),At=mt(Array.prototype.push),Ft=mt(String.prototype.toLowerCase),Pt=mt(String.prototype.toString),gi=mt(String.prototype.match),pt=mt(String.prototype.replace),mi=mt(String.prototype.indexOf),bi=mt(String.prototype.trim),gt=mt(RegExp.prototype.test),St=$i(TypeError);function mt(re){return function(t){for(var i=arguments.length,n=new Array(i>1?i-1:0),j=1;j<i;j++)n[j-1]=arguments[j];return Mt(re,t,n)}}function $i(re){return function(){for(var t=arguments.length,i=new Array(t),n=0;n<t;n++)i[n]=arguments[n];return jt(re,i)}}function qe(re,t,i){var n;i=(n=i)!==null&&n!==void 0?n:Ft,Ht&&Ht(re,null);let j=t.length;for(;j--;){let F=t[j];if(typeof F=="string"){const N=i(F);N!==F&&(ui(t)||(t[j]=N),F=N)}re[F]=!0}return re}function Dt(re){const t=fi(null);for(const[i,n]of Ut(re))t[i]=n;return t}function Rt(re,t){for(;re!==null;){const n=ci(re,t);if(n){if(n.get)return mt(n.get);if(typeof n.value=="function")return mt(n.value)}re=hi(re)}function i(n){return console.warn("fallback value for",n),null}return i}const zt=ut(["a","abbr","acronym","address","area","article","aside","audio","b","bdi","bdo","big","blink","blockquote","body","br","button","canvas","caption","center","cite","code","col","colgroup","content","data","datalist","dd","decorator","del","details","dfn","dialog","dir","div","dl","dt","element","em","fieldset","figcaption","figure","font","footer","form","h1","h2","h3","h4","h5","h6","head","header","hgroup","hr","html","i","img","input","ins","kbd","label","legend","li","main","map","mark","marquee","menu","menuitem","meter","nav","nobr","ol","optgroup","option","output","p","picture","pre","progress","q","rp","rt","ruby","s","samp","section","select","shadow","small","source","spacer","span","strike","strong","style","sub","summary","sup","table","tbody","td","template","textarea","tfoot","th","thead","time","tr","track","tt","u","ul","var","video","wbr"]),Wt=ut(["svg","a","altglyph","altglyphdef","altglyphitem","animatecolor","animatemotion","animatetransform","circle","clippath","defs","desc","ellipse","filter","font","g","glyph","glyphref","hkern","image","line","lineargradient","marker","mask","metadata","mpath","path","pattern","polygon","polyline","radialgradient","rect","stop","style","switch","symbol","text","textpath","title","tref","tspan","view","vkern"]),Bt=ut(["feBlend","feColorMatrix","feComponentTransfer","feComposite","feConvolveMatrix","feDiffuseLighting","feDisplacementMap","feDistantLight","feDropShadow","feFlood","feFuncA","feFuncB","feFuncG","feFuncR","feGaussianBlur","feImage","feMerge","feMergeNode","feMorphology","feOffset","fePointLight","feSpecularLighting","feSpotLight","feTile","feTurbulence"]),pi=ut(["animate","color-profile","cursor","discard","font-face","font-face-format","font-face-name","font-face-src","font-face-uri","foreignobject","hatch","hatchpath","mesh","meshgradient","meshpatch","meshrow","missing-glyph","script","set","solidcolor","unknown","use"]),Ct=ut(["math","menclose","merror","mfenced","mfrac","mglyph","mi","mlabeledtr","mmultiscripts","mn","mo","mover","mpadded","mphantom","mroot","mrow","ms","mspace","msqrt","mstyle","msub","msup","msubsup","mtable","mtd","mtext","mtr","munder","munderover","mprescripts"]),wi=ut(["maction","maligngroup","malignmark","mlongdiv","mscarries","mscarry","msgroup","mstack","msline","msrow","semantics","annotation","annotation-xml","mprescripts","none"]),Vt=ut(["#text"]),Kt=ut(["accept","action","align","alt","autocapitalize","autocomplete","autopictureinpicture","autoplay","background","bgcolor","border","capture","cellpadding","cellspacing","checked","cite","class","clear","color","cols","colspan","controls","controlslist","coords","crossorigin","datetime","decoding","default","dir","disabled","disablepictureinpicture","disableremoteplayback","download","draggable","enctype","enterkeyhint","face","for","headers","height","hidden","high","href","hreflang","id","inputmode","integrity","ismap","kind","label","lang","list","loading","loop","low","max","maxlength","media","method","min","minlength","multiple","muted","name","nonce","noshade","novalidate","nowrap","open","optimum","pattern","placeholder","playsinline","poster","preload","pubdate","radiogroup","readonly","rel","required","rev","reversed","role","rows","rowspan","spellcheck","scope","selected","shape","size","sizes","span","srclang","start","src","srcset","step","style","summary","tabindex","title","translate","type","usemap","valign","value","width","xmlns","slot"]),_t=ut(["accent-height","accumulate","additive","alignment-baseline","ascent","attributename","attributetype","azimuth","basefrequency","baseline-shift","begin","bias","by","class","clip","clippathunits","clip-path","clip-rule","color","color-interpolation","color-interpolation-filters","color-profile","color-rendering","cx","cy","d","dx","dy","diffuseconstant","direction","display","divisor","dur","edgemode","elevation","end","fill","fill-opacity","fill-rule","filter","filterunits","flood-color","flood-opacity","font-family","font-size","font-size-adjust","font-stretch","font-style","font-variant","font-weight","fx","fy","g1","g2","glyph-name","glyphref","gradientunits","gradienttransform","height","href","id","image-rendering","in","in2","k","k1","k2","k3","k4","kerning","keypoints","keysplines","keytimes","lang","lengthadjust","letter-spacing","kernelmatrix","kernelunitlength","lighting-color","local","marker-end","marker-mid","marker-start","markerheight","markerunits","markerwidth","maskcontentunits","maskunits","max","mask","media","method","mode","min","name","numoctaves","offset","operator","opacity","order","orient","orientation","origin","overflow","paint-order","path","pathlength","patterncontentunits","patterntransform","patternunits","points","preservealpha","preserveaspectratio","primitiveunits","r","rx","ry","radius","refx","refy","repeatcount","repeatdur","restart","result","rotate","scale","seed","shape-rendering","specularconstant","specularexponent","spreadmethod","startoffset","stddeviation","stitchtiles","stop-color","stop-opacity","stroke-dasharray","stroke-dashoffset","stroke-linecap","stroke-linejoin","stroke-miterlimit","stroke-opacity","stroke","stroke-width","style","surfacescale","systemlanguage","tabindex","targetx","targety","transform","transform-origin","text-anchor","text-decoration","text-rendering","textlength","type","u1","u2","unicode","values","viewbox","visibility","version","vert-adv-y","vert-origin-x","vert-origin-y","width","word-spacing","wrap","writing-mode","xchannelselector","ychannelselector","x","x1","x2","xmlns","y","y1","y2","z","zoomandpan"]),qt=ut(["accent","accentunder","align","bevelled","close","columnsalign","columnlines","columnspan","denomalign","depth","dir","display","displaystyle","encoding","fence","frame","height","href","id","largeop","length","linethickness","lspace","lquote","mathbackground","mathcolor","mathsize","mathvariant","maxsize","minsize","movablelimits","notation","numalign","open","rowalign","rowlines","rowspacing","rowspan","rspace","rquote","scriptlevel","scriptminsize","scriptsizemultiplier","selection","separator","separators","stretchy","subscriptshift","supscriptshift","symmetric","voffset","width","xmlns"]),It=ut(["xlink:href","xml:id","xlink:title","xml:space","xmlns:xlink"]),vi=$t(/\{\{[\w\W]*|[\w\W]*\}\}/gm),Di=$t(/<%[\w\W]*|[\w\W]*%>/gm),Ei=$t(/\${[\w\W]*}/gm),yi=$t(/^data-[\-\w.\u00B7-\uFFFF]/),Ai=$t(/^aria-[\-\w]+$/),Gt=$t(/^(?:(?:(?:f|ht)tps?|mailto|tel|callto|sms|cid|xmpp):|[^a-z]|[a-z+.\-]+(?:[^a-z+.\-:]|$))/i),Si=$t(/^(?:\w+script|data):/i),Ti=$t(/[\u0000-\u0020\u00A0\u1680\u180E\u2000-\u2029\u205F\u3000]/g),Xt=$t(/^html$/i);var Yt=Object.freeze({__proto__:null,MUSTACHE_EXPR:vi,ERB_EXPR:Di,TMPLIT_EXPR:Ei,DATA_ATTR:yi,ARIA_ATTR:Ai,IS_ALLOWED_URI:Gt,IS_SCRIPT_OR_DATA:Si,ATTR_WHITESPACE:Ti,DOCTYPE_NAME:Xt});const ki=()=>typeof window>"u"?null:window,Ni=function(t,i){if(typeof t!="object"||typeof t.createPolicy!="function")return null;let n=null;const j="data-tt-policy-suffix";i&&i.hasAttribute(j)&&(n=i.getAttribute(j));const F="dompurify"+(n?"#"+n:"");try{return t.createPolicy(F,{createHTML(N){return N},createScriptURL(N){return N}})}catch{return console.warn("TrustedTypes policy "+F+" could not be created."),null}};function Zt(){let re=arguments.length>0&&arguments[0]!==void 0?arguments[0]:ki();const t=Ue=>Zt(Ue);if(t.version="3.0.5",t.removed=[],!re||!re.document||re.document.nodeType!==9)return t.isSupported=!1,t;const i=re.document,n=i.currentScript;let{document:j}=re;const{DocumentFragment:F,HTMLTemplateElement:N,Node:w,Element:D,NodeFilter:c,NamedNodeMap:p=re.NamedNodeMap||re.MozNamedAttrMap,HTMLFormElement:y,DOMParser:$,trustedTypes:g}=re,e=D.prototype,s=Rt(e,"cloneNode"),r=Rt(e,"nextSibling"),h=Rt(e,"childNodes"),l=Rt(e,"parentNode");if(typeof N=="function"){const Ue=j.createElement("template");Ue.content&&Ue.content.ownerDocument&&(j=Ue.content.ownerDocument)}let v,k="";const{implementation:A,createNodeIterator:d,createDocumentFragment:f,getElementsByTagName:b}=j,{importNode:S}=i;let U={};t.isSupported=typeof Ut=="function"&&typeof l=="function"&&A&&A.createHTMLDocument!==void 0;const{MUSTACHE_EXPR:_,ERB_EXPR:B,TMPLIT_EXPR:E,DATA_ATTR:I,ARIA_ATTR:z,IS_SCRIPT_OR_DATA:O,ATTR_WHITESPACE:C}=Yt;let{IS_ALLOWED_URI:x}=Yt,Z=null;const Y=qe({},[...zt,...Wt,...Bt,...Ct,...Vt]);let q=null;const ee=qe({},[...Kt,..._t,...qt,...It]);let ce=Object.seal(Object.create(null,{tagNameCheck:{writable:!0,configurable:!1,enumerable:!0,value:null},attributeNameCheck:{writable:!0,configurable:!1,enumerable:!0,value:null},allowCustomizedBuiltInElements:{writable:!0,configurable:!1,enumerable:!0,value:!1}})),be=null,ke=null,Fe=!0,ue=!0,Q=!1,he=!0,le=!1,Ne=!1,te=!1,$e=!1,Ae=!1,Oe=!1,Ie=!1,Ce=!0,se=!1;const K="user-content-";let W=!0,a=!1,o={},m=null;const M=qe({},["annotation-xml","audio","colgroup","desc","foreignobject","head","iframe","math","mi","mn","mo","ms","mtext","noembed","noframes","noscript","plaintext","script","style","svg","template","thead","title","video","xmp"]);let R=null;const u=qe({},["audio","video","img","source","image","track"]);let L=null;const T=qe({},["alt","class","for","id","label","name","pattern","placeholder","role","summary","title","value","style","xmlns"]),P="http://www.w3.org/1998/Math/MathML",H="http://www.w3.org/2000/svg",X="http://www.w3.org/1999/xhtml";let ie=X,oe=!1,de=null;const ye=qe({},[P,H,X],Pt);let De;const Le=["application/xhtml+xml","text/html"],Te="text/html";let fe,Re=null;const Ke=j.createElement("form"),Ze=function(ge){return ge instanceof RegExp||ge instanceof Function},tt=function(ge){if(!(Re&&Re===ge)){if((!ge||typeof ge!="object")&&(ge={}),ge=Dt(ge),De=Le.indexOf(ge.PARSER_MEDIA_TYPE)===-1?De=Te:De=ge.PARSER_MEDIA_TYPE,fe=De==="application/xhtml+xml"?Pt:Ft,Z="ALLOWED_TAGS"in ge?qe({},ge.ALLOWED_TAGS,fe):Y,q="ALLOWED_ATTR"in ge?qe({},ge.ALLOWED_ATTR,fe):ee,de="ALLOWED_NAMESPACES"in ge?qe({},ge.ALLOWED_NAMESPACES,Pt):ye,L="ADD_URI_SAFE_ATTR"in ge?qe(Dt(T),ge.ADD_URI_SAFE_ATTR,fe):T,R="ADD_DATA_URI_TAGS"in ge?qe(Dt(u),ge.ADD_DATA_URI_TAGS,fe):u,m="FORBID_CONTENTS"in ge?qe({},ge.FORBID_CONTENTS,fe):M,be="FORBID_TAGS"in ge?qe({},ge.FORBID_TAGS,fe):{},ke="FORBID_ATTR"in ge?qe({},ge.FORBID_ATTR,fe):{},o="USE_PROFILES"in ge?ge.USE_PROFILES:!1,Fe=ge.ALLOW_ARIA_ATTR!==!1,ue=ge.ALLOW_DATA_ATTR!==!1,Q=ge.ALLOW_UNKNOWN_PROTOCOLS||!1,he=ge.ALLOW_SELF_CLOSE_IN_ATTR!==!1,le=ge.SAFE_FOR_TEMPLATES||!1,Ne=ge.WHOLE_DOCUMENT||!1,Ae=ge.RETURN_DOM||!1,Oe=ge.RETURN_DOM_FRAGMENT||!1,Ie=ge.RETURN_TRUSTED_TYPE||!1,$e=ge.FORCE_BODY||!1,Ce=ge.SANITIZE_DOM!==!1,se=ge.SANITIZE_NAMED_PROPS||!1,W=ge.KEEP_CONTENT!==!1,a=ge.IN_PLACE||!1,x=ge.ALLOWED_URI_REGEXP||Gt,ie=ge.NAMESPACE||X,ce=ge.CUSTOM_ELEMENT_HANDLING||{},ge.CUSTOM_ELEMENT_HANDLING&&Ze(ge.CUSTOM_ELEMENT_HANDLING.tagNameCheck)&&(ce.tagNameCheck=ge.CUSTOM_ELEMENT_HANDLING.tagNameCheck),ge.CUSTOM_ELEMENT_HANDLING&&Ze(ge.CUSTOM_ELEMENT_HANDLING.attributeNameCheck)&&(ce.attributeNameCheck=ge.CUSTOM_ELEMENT_HANDLING.attributeNameCheck),ge.CUSTOM_ELEMENT_HANDLING&&typeof ge.CUSTOM_ELEMENT_HANDLING.allowCustomizedBuiltInElements=="boolean"&&(ce.allowCustomizedBuiltInElements=ge.CUSTOM_ELEMENT_HANDLING.allowCustomizedBuiltInElements),le&&(ue=!1),Oe&&(Ae=!0),o&&(Z=qe({},[...Vt]),q=[],o.html===!0&&(qe(Z,zt),qe(q,Kt)),o.svg===!0&&(qe(Z,Wt),qe(q,_t),qe(q,It)),o.svgFilters===!0&&(qe(Z,Bt),qe(q,_t),qe(q,It)),o.mathMl===!0&&(qe(Z,Ct),qe(q,qt),qe(q,It))),ge.ADD_TAGS&&(Z===Y&&(Z=Dt(Z)),qe(Z,ge.ADD_TAGS,fe)),ge.ADD_ATTR&&(q===ee&&(q=Dt(q)),qe(q,ge.ADD_ATTR,fe)),ge.ADD_URI_SAFE_ATTR&&qe(L,ge.ADD_URI_SAFE_ATTR,fe),ge.FORBID_CONTENTS&&(m===M&&(m=Dt(m)),qe(m,ge.FORBID_CONTENTS,fe)),W&&(Z["#text"]=!0),Ne&&qe(Z,["html","head","body"]),Z.table&&(qe(Z,["tbody"]),delete be.tbody),ge.TRUSTED_TYPES_POLICY){if(typeof ge.TRUSTED_TYPES_POLICY.createHTML!="function")throw St('TRUSTED_TYPES_POLICY configuration option must provide a "createHTML" hook.');if(typeof ge.TRUSTED_TYPES_POLICY.createScriptURL!="function")throw St('TRUSTED_TYPES_POLICY configuration option must provide a "createScriptURL" hook.');v=ge.TRUSTED_TYPES_POLICY,k=v.createHTML("")}else v===void 0&&(v=Ni(g,n)),v!==null&&typeof k=="string"&&(k=v.createHTML(""));ut&&ut(ge),Re=ge}},at=qe({},["mi","mo","mn","ms","mtext"]),st=qe({},["foreignobject","desc","title","annotation-xml"]),Ge=qe({},["title","style","font","a","script"]),Qe=qe({},Wt);qe(Qe,Bt),qe(Qe,pi);const J=qe({},Ct);qe(J,wi);const ae=function(ge){let Me=l(ge);(!Me||!Me.tagName)&&(Me={namespaceURI:ie,tagName:"template"});const We=Ft(ge.tagName),Ye=Ft(Me.tagName);return de[ge.namespaceURI]?ge.namespaceURI===H?Me.namespaceURI===X?We==="svg":Me.namespaceURI===P?We==="svg"&&(Ye==="annotation-xml"||at[Ye]):!!Qe[We]:ge.namespaceURI===P?Me.namespaceURI===X?We==="math":Me.namespaceURI===H?We==="math"&&st[Ye]:!!J[We]:ge.namespaceURI===X?Me.namespaceURI===H&&!st[Ye]||Me.namespaceURI===P&&!at[Ye]?!1:!J[We]&&(Ge[We]||!Qe[We]):!!(De==="application/xhtml+xml"&&de[ge.namespaceURI]):!1},pe=function(ge){At(t.removed,{element:ge});try{ge.parentNode.removeChild(ge)}catch{ge.remove()}},Se=function(ge,Me){try{At(t.removed,{attribute:Me.getAttributeNode(ge),from:Me})}catch{At(t.removed,{attribute:null,from:Me})}if(Me.removeAttribute(ge),ge==="is"&&!q[ge])if(Ae||Oe)try{pe(Me)}catch{}else try{Me.setAttribute(ge,"")}catch{}},Pe=function(ge){let Me,We;if($e)ge="<remove></remove>"+ge;else{const dt=gi(ge,/^[\r\n\t ]+/);We=dt&&dt[0]}De==="application/xhtml+xml"&&ie===X&&(ge='<html xmlns="http://www.w3.org/1999/xhtml"><head></head><body>'+ge+"</body></html>");const Ye=v?v.createHTML(ge):ge;if(ie===X)try{Me=new $().parseFromString(Ye,De)}catch{}if(!Me||!Me.documentElement){Me=A.createDocument(ie,"template",null);try{Me.documentElement.innerHTML=oe?k:Ye}catch{}}const ot=Me.body||Me.documentElement;return ge&&We&&ot.insertBefore(j.createTextNode(We),ot.childNodes[0]||null),ie===X?b.call(Me,Ne?"html":"body")[0]:Ne?Me.documentElement:ot},ze=function(ge){return d.call(ge.ownerDocument||ge,ge,c.SHOW_ELEMENT|c.SHOW_COMMENT|c.SHOW_TEXT,null,!1)},Xe=function(ge){return ge instanceof y&&(typeof ge.nodeName!="string"||typeof ge.textContent!="string"||typeof ge.removeChild!="function"||!(ge.attributes instanceof p)||typeof ge.removeAttribute!="function"||typeof ge.setAttribute!="function"||typeof ge.namespaceURI!="string"||typeof ge.insertBefore!="function"||typeof ge.hasChildNodes!="function")},rt=function(ge){return typeof w=="object"?ge instanceof w:ge&&typeof ge=="object"&&typeof ge.nodeType=="number"&&typeof ge.nodeName=="string"},it=function(ge,Me,We){U[ge]&&di(U[ge],Ye=>{Ye.call(t,Me,We,Re)})},ht=function(ge){let Me;if(it("beforeSanitizeElements",ge,null),Xe(ge))return pe(ge),!0;const We=fe(ge.nodeName);if(it("uponSanitizeElement",ge,{tagName:We,allowedTags:Z}),ge.hasChildNodes()&&!rt(ge.firstElementChild)&&(!rt(ge.content)||!rt(ge.content.firstElementChild))&&gt(/<[/\w]/g,ge.innerHTML)&&gt(/<[/\w]/g,ge.textContent))return pe(ge),!0;if(!Z[We]||be[We]){if(!be[We]&&ft(We)&&(ce.tagNameCheck instanceof RegExp&&gt(ce.tagNameCheck,We)||ce.tagNameCheck instanceof Function&&ce.tagNameCheck(We)))return!1;if(W&&!m[We]){const Ye=l(ge)||ge.parentNode,ot=h(ge)||ge.childNodes;if(ot&&Ye){const dt=ot.length;for(let Je=dt-1;Je>=0;--Je)Ye.insertBefore(s(ot[Je],!0),r(ge))}}return pe(ge),!0}return ge instanceof D&&!ae(ge)||(We==="noscript"||We==="noembed"||We==="noframes")&&gt(/<\/no(script|embed|frames)/i,ge.innerHTML)?(pe(ge),!0):(le&&ge.nodeType===3&&(Me=ge.textContent,Me=pt(Me,_," "),Me=pt(Me,B," "),Me=pt(Me,E," "),ge.textContent!==Me&&(At(t.removed,{element:ge.cloneNode()}),ge.textContent=Me)),it("afterSanitizeElements",ge,null),!1)},nt=function(ge,Me,We){if(Ce&&(Me==="id"||Me==="name")&&(We in j||We in Ke))return!1;if(!(ue&&!ke[Me]&&gt(I,Me))){if(!(Fe&&gt(z,Me))){if(!q[Me]||ke[Me]){if(!(ft(ge)&&(ce.tagNameCheck instanceof RegExp&&gt(ce.tagNameCheck,ge)||ce.tagNameCheck instanceof Function&&ce.tagNameCheck(ge))&&(ce.attributeNameCheck instanceof RegExp&&gt(ce.attributeNameCheck,Me)||ce.attributeNameCheck instanceof Function&&ce.attributeNameCheck(Me))||Me==="is"&&ce.allowCustomizedBuiltInElements&&(ce.tagNameCheck instanceof RegExp&&gt(ce.tagNameCheck,We)||ce.tagNameCheck instanceof Function&&ce.tagNameCheck(We))))return!1}else if(!L[Me]){if(!gt(x,pt(We,C,""))){if(!((Me==="src"||Me==="xlink:href"||Me==="href")&&ge!=="script"&&mi(We,"data:")===0&&R[ge])){if(!(Q&&!gt(O,pt(We,C,"")))){if(We)return!1}}}}}}return!0},ft=function(ge){return ge.indexOf("-")>0},ct=function(ge){let Me,We,Ye,ot;it("beforeSanitizeAttributes",ge,null);const{attributes:dt}=ge;if(!dt)return;const Je={attrName:"",attrValue:"",keepAttr:!0,allowedAttributes:q};for(ot=dt.length;ot--;){Me=dt[ot];const{name:bt,namespaceURI:Tt}=Me;if(We=bt==="value"?Me.value:bi(Me.value),Ye=fe(bt),Je.attrName=Ye,Je.attrValue=We,Je.keepAttr=!0,Je.forceKeepAttr=void 0,it("uponSanitizeAttribute",ge,Je),We=Je.attrValue,Je.forceKeepAttr||(Se(bt,ge),!Je.keepAttr))continue;if(!he&&gt(/\/>/i,We)){Se(bt,ge);continue}le&&(We=pt(We,_," "),We=pt(We,B," "),We=pt(We,E," "));const kt=fe(ge.nodeName);if(nt(kt,Ye,We)){if(se&&(Ye==="id"||Ye==="name")&&(Se(bt,ge),We=K+We),v&&typeof g=="object"&&typeof g.getAttributeType=="function"&&!Tt)switch(g.getAttributeType(kt,Ye)){case"TrustedHTML":{We=v.createHTML(We);break}case"TrustedScriptURL":{We=v.createScriptURL(We);break}}try{Tt?ge.setAttributeNS(Tt,bt,We):ge.setAttribute(bt,We),xt(t.removed)}catch{}}}it("afterSanitizeAttributes",ge,null)},wt=function Ue(ge){let Me;const We=ze(ge);for(it("beforeSanitizeShadowDOM",ge,null);Me=We.nextNode();)it("uponSanitizeShadowNode",Me,null),!ht(Me)&&(Me.content instanceof F&&Ue(Me.content),ct(Me));it("afterSanitizeShadowDOM",ge,null)};return t.sanitize=function(Ue){let ge=arguments.length>1&&arguments[1]!==void 0?arguments[1]:{},Me,We,Ye,ot;if(oe=!Ue,oe&&(Ue="<!-->"),typeof Ue!="string"&&!rt(Ue))if(typeof Ue.toString=="function"){if(Ue=Ue.toString(),typeof Ue!="string")throw St("dirty is not a string, aborting")}else throw St("toString is not a function");if(!t.isSupported)return Ue;if(te||tt(ge),t.removed=[],typeof Ue=="string"&&(a=!1),a){if(Ue.nodeName){const bt=fe(Ue.nodeName);if(!Z[bt]||be[bt])throw St("root node is forbidden and cannot be sanitized in-place")}}else if(Ue instanceof w)Me=Pe("<!---->"),We=Me.ownerDocument.importNode(Ue,!0),We.nodeType===1&&We.nodeName==="BODY"||We.nodeName==="HTML"?Me=We:Me.appendChild(We);else{if(!Ae&&!le&&!Ne&&Ue.indexOf("<")===-1)return v&&Ie?v.createHTML(Ue):Ue;if(Me=Pe(Ue),!Me)return Ae?null:Ie?k:""}Me&&$e&&pe(Me.firstChild);const dt=ze(a?Ue:Me);for(;Ye=dt.nextNode();)ht(Ye)||(Ye.content instanceof F&&wt(Ye.content),ct(Ye));if(a)return Ue;if(Ae){if(Oe)for(ot=f.call(Me.ownerDocument);Me.firstChild;)ot.appendChild(Me.firstChild);else ot=Me;return(q.shadowroot||q.shadowrootmode)&&(ot=S.call(i,ot,!0)),ot}let Je=Ne?Me.outerHTML:Me.innerHTML;return Ne&&Z["!doctype"]&&Me.ownerDocument&&Me.ownerDocument.doctype&&Me.ownerDocument.doctype.name&&gt(Xt,Me.ownerDocument.doctype.name)&&(Je="<!DOCTYPE "+Me.ownerDocument.doctype.name+`>
`+Je),le&&(Je=pt(Je,_," "),Je=pt(Je,B," "),Je=pt(Je,E," ")),v&&Ie?v.createHTML(Je):Je},t.setConfig=function(Ue){tt(Ue),te=!0},t.clearConfig=function(){Re=null,te=!1},t.isValidAttribute=function(Ue,ge,Me){Re||tt({});const We=fe(Ue),Ye=fe(ge);return nt(We,Ye,Me)},t.addHook=function(Ue,ge){typeof ge=="function"&&(U[Ue]=U[Ue]||[],At(U[Ue],ge))},t.removeHook=function(Ue){if(U[Ue])return xt(U[Ue])},t.removeHooks=function(Ue){U[Ue]&&(U[Ue]=[])},t.removeAllHooks=function(){U={}},t}var Li=Zt();define("vs/base/browser/dompurify/dompurify",function(){return Li}),define(we[55],ve([1,0]),function(re,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$aU=void 0,t.$bU=j;class i{constructor(N){this.domNode=N,this.a="",this.b="",this.c="",this.d="",this.e="",this.f="",this.g="",this.h="",this.i="",this.j="",this.k="",this.l="",this.m="",this.n="",this.o="",this.p="",this.q="",this.r="",this.s="",this.t="",this.u="",this.v="",this.w="",this.x="",this.y="",this.z="",this.A=!1,this.B="none",this.C=""}setMaxWidth(N){const w=n(N);this.a!==w&&(this.a=w,this.domNode.style.maxWidth=this.a)}setWidth(N){const w=n(N);this.b!==w&&(this.b=w,this.domNode.style.width=this.b)}setHeight(N){const w=n(N);this.c!==w&&(this.c=w,this.domNode.style.height=this.c)}setTop(N){const w=n(N);this.d!==w&&(this.d=w,this.domNode.style.top=this.d)}setLeft(N){const w=n(N);this.e!==w&&(this.e=w,this.domNode.style.left=this.e)}setBottom(N){const w=n(N);this.f!==w&&(this.f=w,this.domNode.style.bottom=this.f)}setRight(N){const w=n(N);this.g!==w&&(this.g=w,this.domNode.style.right=this.g)}setPaddingTop(N){const w=n(N);this.h!==w&&(this.h=w,this.domNode.style.paddingTop=this.h)}setPaddingLeft(N){const w=n(N);this.i!==w&&(this.i=w,this.domNode.style.paddingLeft=this.i)}setPaddingBottom(N){const w=n(N);this.j!==w&&(this.j=w,this.domNode.style.paddingBottom=this.j)}setPaddingRight(N){const w=n(N);this.k!==w&&(this.k=w,this.domNode.style.paddingRight=this.k)}setFontFamily(N){this.l!==N&&(this.l=N,this.domNode.style.fontFamily=this.l)}setFontWeight(N){this.m!==N&&(this.m=N,this.domNode.style.fontWeight=this.m)}setFontSize(N){const w=n(N);this.n!==w&&(this.n=w,this.domNode.style.fontSize=this.n)}setFontStyle(N){this.o!==N&&(this.o=N,this.domNode.style.fontStyle=this.o)}setFontFeatureSettings(N){this.p!==N&&(this.p=N,this.domNode.style.fontFeatureSettings=this.p)}setFontVariationSettings(N){this.q!==N&&(this.q=N,this.domNode.style.fontVariationSettings=this.q)}setTextDecoration(N){this.r!==N&&(this.r=N,this.domNode.style.textDecoration=this.r)}setLineHeight(N){const w=n(N);this.s!==w&&(this.s=w,this.domNode.style.lineHeight=this.s)}setLetterSpacing(N){const w=n(N);this.t!==w&&(this.t=w,this.domNode.style.letterSpacing=this.t)}setClassName(N){this.u!==N&&(this.u=N,this.domNode.className=this.u)}toggleClassName(N,w){this.domNode.classList.toggle(N,w),this.u=this.domNode.className}setDisplay(N){this.v!==N&&(this.v=N,this.domNode.style.display=this.v)}setPosition(N){this.w!==N&&(this.w=N,this.domNode.style.position=this.w)}setVisibility(N){this.x!==N&&(this.x=N,this.domNode.style.visibility=this.x)}setColor(N){this.y!==N&&(this.y=N,this.domNode.style.color=this.y)}setBackgroundColor(N){this.z!==N&&(this.z=N,this.domNode.style.backgroundColor=this.z)}setLayerHinting(N){this.A!==N&&(this.A=N,this.domNode.style.transform=this.A?"translate3d(0px, 0px, 0px)":"")}setBoxShadow(N){this.C!==N&&(this.C=N,this.domNode.style.boxShadow=N)}setContain(N){this.B!==N&&(this.B=N,this.domNode.style.contain=this.B)}setAttribute(N,w){this.domNode.setAttribute(N,w)}removeAttribute(N){this.domNode.removeAttribute(N)}appendChild(N){this.domNode.appendChild(N.domNode)}removeChild(N){this.domNode.removeChild(N.domNode)}}t.$aU=i;function n(F){return typeof F=="number"?`${F}px`:F}function j(F){return new i(F)}}),define(we[85],ve([1,0]),function(re,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$hS=void 0,t.$iS=F;const i=new WeakMap;function n(w){if(!w.parent||w.parent===w)return null;try{const D=w.location,c=w.parent.location;if(D.origin!=="null"&&c.origin!=="null"&&D.origin!==c.origin)return null}catch{return null}return w.parent}class j{static a(D){let c=i.get(D);if(!c){c=[],i.set(D,c);let p=D,y;do y=n(p),y?c.push({window:new WeakRef(p),iframeElement:p.frameElement||null}):c.push({window:new WeakRef(p),iframeElement:null}),p=y;while(p)}return c.slice(0)}static getPositionOfChildWindowRelativeToAncestorWindow(D,c){if(!c||D===c)return{top:0,left:0};let p=0,y=0;const $=this.a(D);for(const g of $){const e=g.window.deref();if(p+=e?.scrollY??0,y+=e?.scrollX??0,e===c||!g.iframeElement)break;const s=g.iframeElement.getBoundingClientRect();p+=s.top,y+=s.left}return{top:p,left:y}}}t.$hS=j;async function F(w,D){if(!crypto.subtle)throw new Error("'crypto.subtle' is not available so webviews will not work. This is likely because the editor is not running in a secure context (https://developer.mozilla.org/en-US/docs/Web/Security/Secure_Contexts).");const c=JSON.stringify({parentOrigin:w,salt:D}),y=new TextEncoder().encode(c),$=await crypto.subtle.digest("sha-256",y);return N($)}function N(w){const c=Array.from(new Uint8Array(w)).map(p=>p.toString(16).padStart(2,"0")).join("");return BigInt(`0x${c}`).toString(32).padStart(52,"0")}}),define(we[33],ve([1,0]),function(re,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$hV=n,t.$iV=j;let i={showHover:()=>{},hideHover:()=>{},showAndFocusLastHover:()=>{},setupManagedHover:()=>null,showManagedHover:()=>{}};function n(F){i=F}function j(){return i}}),define(we[41],ve([1,0]),function(re,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$WU=t.$VU=t.$UU=t.ListDragOverEffectPosition=t.ListDragOverEffectType=void 0;var i;(function(N){N[N.Copy=0]="Copy",N[N.Move=1]="Move"})(i||(t.ListDragOverEffectType=i={}));var n;(function(N){N.Over="drop-target",N.Before="drop-target-before",N.After="drop-target-after"})(n||(t.ListDragOverEffectPosition=n={})),t.$UU={reject(){return{accept:!1}},accept(){return{accept:!0}}};class j extends Error{constructor(w,D){super(`ListError [${w}] ${D}`)}}t.$VU=j;class F{constructor(){this.c=new WeakMap}getHeight(w){return this.c.get(w)??this.d(w)}setDynamicHeight(w,D){D>0&&this.c.set(w,D)}}t.$WU=F}),define(we[86],ve([1,0]),function(re,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$KU=void 0;class i{constructor(j){this.a=j}splice(j,F,N){this.a.forEach(w=>w.splice(j,F,N))}}t.$KU=i}),define(we[56],ve([1,0]),function(re,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$gU=void 0;const i=20;class n{constructor(F,N,w,D,c,p){this.a=Math.round(N),this.b=Math.round(w),this.c=Math.round(F),this.d=D,this.e=c,this.f=p,this.g=0,this.h=!1,this.i=0,this.j=0,this.k=0,this.m()}clone(){return new n(this.c,this.a,this.b,this.d,this.e,this.f)}setVisibleSize(F){const N=Math.round(F);return this.d!==N?(this.d=N,this.m(),!0):!1}setScrollSize(F){const N=Math.round(F);return this.e!==N?(this.e=N,this.m(),!0):!1}setScrollPosition(F){const N=Math.round(F);return this.f!==N?(this.f=N,this.m(),!0):!1}setScrollbarSize(F){this.a=Math.round(F)}setOppositeScrollbarSize(F){this.b=Math.round(F)}static l(F,N,w,D,c){const p=Math.max(0,w-F),y=Math.max(0,p-2*N),$=D>0&&D>w;if(!$)return{computedAvailableSize:Math.round(p),computedIsNeeded:$,computedSliderSize:Math.round(y),computedSliderRatio:0,computedSliderPosition:0};const g=Math.round(Math.max(i,Math.floor(w*y/D))),e=(y-g)/(D-w),s=c*e;return{computedAvailableSize:Math.round(p),computedIsNeeded:$,computedSliderSize:Math.round(g),computedSliderRatio:e,computedSliderPosition:Math.round(s)}}m(){const F=n.l(this.b,this.c,this.d,this.e,this.f);this.g=F.computedAvailableSize,this.h=F.computedIsNeeded,this.i=F.computedSliderSize,this.j=F.computedSliderRatio,this.k=F.computedSliderPosition}getArrowSize(){return this.c}getScrollPosition(){return this.f}getRectangleLargeSize(){return this.g}getRectangleSmallSize(){return this.a}isNeeded(){return this.h}getSliderSize(){return this.i}getSliderPosition(){return this.k}getDesiredScrollPositionFromOffset(F){if(!this.h)return 0;const N=F-this.c-this.i/2;return Math.round(N/this.j)}getDesiredScrollPositionFromOffsetPaged(F){if(!this.h)return 0;const N=F-this.c;let w=this.f;return N<this.k?w-=this.d:w+=this.d,w}getDesiredScrollPositionFromDelta(F){if(!this.h)return 0;const N=this.k+F;return Math.round(N/this.j)}}t.$gU=n}),define(we[34],ve([1,0,41]),function(re,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$UW=t.$TW=t.$SW=t.TreeDragOverBubble=t.TreeMouseEventTarget=t.ObjectTreeElementCollapseState=t.TreeVisibility=void 0;var n;(function(c){c[c.Hidden=0]="Hidden",c[c.Visible=1]="Visible",c[c.Recurse=2]="Recurse"})(n||(t.TreeVisibility=n={}));var j;(function(c){c[c.Expanded=0]="Expanded",c[c.Collapsed=1]="Collapsed",c[c.PreserveOrExpanded=2]="PreserveOrExpanded",c[c.PreserveOrCollapsed=3]="PreserveOrCollapsed"})(j||(t.ObjectTreeElementCollapseState=j={}));var F;(function(c){c[c.Unknown=0]="Unknown",c[c.Twistie=1]="Twistie",c[c.Element=2]="Element",c[c.Filter=3]="Filter"})(F||(t.TreeMouseEventTarget=F={}));var N;(function(c){c[c.Down=0]="Down",c[c.Up=1]="Up"})(N||(t.TreeDragOverBubble=N={})),t.$SW={acceptBubbleUp(){return{accept:!0,bubble:N.Up}},acceptBubbleDown(c=!1){return{accept:!0,bubble:N.Down,autoExpand:c}},acceptCopyBubbleUp(){return{accept:!0,bubble:N.Up,effect:{type:i.ListDragOverEffectType.Copy,position:i.ListDragOverEffectPosition.Over}}},acceptCopyBubbleDown(c=!1){return{accept:!0,bubble:N.Down,effect:{type:i.ListDragOverEffectType.Copy,position:i.ListDragOverEffectPosition.Over},autoExpand:c}}};class w extends Error{constructor(p,y){super(`TreeError [${p}] ${y}`)}}t.$TW=w;class D{constructor(p){this.a=p,this.b=new WeakMap}map(p){let y=this.b.get(p);return y||(y=this.a(p),this.b.set(p,y)),y}}t.$UW=D}),define(we[24],ve([1,0]),function(re,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$WR=void 0,t.$VR=i,t.$XR=n;function i(j,F){const N=j;typeof N.vscodeWindowId!="number"&&Object.defineProperty(N,"vscodeWindowId",{get:()=>F})}t.$WR=window;function n(j){return j===t.$WR?!1:typeof j?.vscodeWindowId=="number"}}),define(we[87],ve([1,0]),function(re,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$lb=void 0,t.$eb=i,t.$fb=n,t.$gb=j,t.$hb=F,t.$ib=N,t.$jb=w,t.$kb=D,t.$mb=p,t.$nb=y,t.$ob=$,t.$pb=g,t.$qb=e;function i(s,r){const h=n(s,r);if(h!==-1)return s[h]}function n(s,r,h=s.length-1){for(let l=h;l>=0;l--){const v=s[l];if(r(v))return l}return-1}function j(s,r){const h=F(s,r);return h===-1?void 0:s[h]}function F(s,r,h=0,l=s.length){let v=h,k=l;for(;v<k;){const A=Math.floor((v+k)/2);r(s[A])?v=A+1:k=A}return v-1}function N(s,r){const h=w(s,r);return h===s.length?void 0:s[h]}function w(s,r,h=0,l=s.length){let v=h,k=l;for(;v<k;){const A=Math.floor((v+k)/2);r(s[A])?k=A:v=A+1}return v}function D(s,r,h=0,l=s.length){const v=w(s,r,h,l);return v===s.length?-1:v}class c{static{this.assertInvariants=!1}constructor(r){this.e=r,this.c=0}findLastMonotonous(r){if(c.assertInvariants){if(this.d){for(const l of this.e)if(this.d(l)&&!r(l))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=r}const h=F(this.e,r,this.c);return this.c=h+1,h===-1?void 0:this.e[h]}}t.$lb=c;function p(s,r){if(s.length===0)return;let h=s[0];for(let l=1;l<s.length;l++){const v=s[l];r(v,h)>0&&(h=v)}return h}function y(s,r){if(s.length===0)return;let h=s[0];for(let l=1;l<s.length;l++){const v=s[l];r(v,h)>=0&&(h=v)}return h}function $(s,r){return p(s,(h,l)=>-r(h,l))}function g(s,r){if(s.length===0)return-1;let h=0;for(let l=1;l<s.length;l++){const v=s[l];r(v,s[h])>0&&(h=l)}return h}function e(s,r){for(const h of s){const l=r(h);if(l!==void 0)return l}}}),define(we[17],ve([1,0]),function(re,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CharCode=void 0;var i;(function(n){n[n.Null=0]="Null",n[n.Backspace=8]="Backspace",n[n.Tab=9]="Tab",n[n.LineFeed=10]="LineFeed",n[n.CarriageReturn=13]="CarriageReturn",n[n.Space=32]="Space",n[n.ExclamationMark=33]="ExclamationMark",n[n.DoubleQuote=34]="DoubleQuote",n[n.Hash=35]="Hash",n[n.DollarSign=36]="DollarSign",n[n.PercentSign=37]="PercentSign",n[n.Ampersand=38]="Ampersand",n[n.SingleQuote=39]="SingleQuote",n[n.OpenParen=40]="OpenParen",n[n.CloseParen=41]="CloseParen",n[n.Asterisk=42]="Asterisk",n[n.Plus=43]="Plus",n[n.Comma=44]="Comma",n[n.Dash=45]="Dash",n[n.Period=46]="Period",n[n.Slash=47]="Slash",n[n.Digit0=48]="Digit0",n[n.Digit1=49]="Digit1",n[n.Digit2=50]="Digit2",n[n.Digit3=51]="Digit3",n[n.Digit4=52]="Digit4",n[n.Digit5=53]="Digit5",n[n.Digit6=54]="Digit6",n[n.Digit7=55]="Digit7",n[n.Digit8=56]="Digit8",n[n.Digit9=57]="Digit9",n[n.Colon=58]="Colon",n[n.Semicolon=59]="Semicolon",n[n.LessThan=60]="LessThan",n[n.Equals=61]="Equals",n[n.GreaterThan=62]="GreaterThan",n[n.QuestionMark=63]="QuestionMark",n[n.AtSign=64]="AtSign",n[n.A=65]="A",n[n.B=66]="B",n[n.C=67]="C",n[n.D=68]="D",n[n.E=69]="E",n[n.F=70]="F",n[n.G=71]="G",n[n.H=72]="H",n[n.I=73]="I",n[n.J=74]="J",n[n.K=75]="K",n[n.L=76]="L",n[n.M=77]="M",n[n.N=78]="N",n[n.O=79]="O",n[n.P=80]="P",n[n.Q=81]="Q",n[n.R=82]="R",n[n.S=83]="S",n[n.T=84]="T",n[n.U=85]="U",n[n.V=86]="V",n[n.W=87]="W",n[n.X=88]="X",n[n.Y=89]="Y",n[n.Z=90]="Z",n[n.OpenSquareBracket=91]="OpenSquareBracket",n[n.Backslash=92]="Backslash",n[n.CloseSquareBracket=93]="CloseSquareBracket",n[n.Caret=94]="Caret",n[n.Underline=95]="Underline",n[n.BackTick=96]="BackTick",n[n.a=97]="a",n[n.b=98]="b",n[n.c=99]="c",n[n.d=100]="d",n[n.e=101]="e",n[n.f=102]="f",n[n.g=103]="g",n[n.h=104]="h",n[n.i=105]="i",n[n.j=106]="j",n[n.k=107]="k",n[n.l=108]="l",n[n.m=109]="m",n[n.n=110]="n",n[n.o=111]="o",n[n.p=112]="p",n[n.q=113]="q",n[n.r=114]="r",n[n.s=115]="s",n[n.t=116]="t",n[n.u=117]="u",n[n.v=118]="v",n[n.w=119]="w",n[n.x=120]="x",n[n.y=121]="y",n[n.z=122]="z",n[n.OpenCurlyBrace=123]="OpenCurlyBrace",n[n.Pipe=124]="Pipe",n[n.CloseCurlyBrace=125]="CloseCurlyBrace",n[n.Tilde=126]="Tilde",n[n.NoBreakSpace=160]="NoBreakSpace",n[n.U_Combining_Grave_Accent=768]="U_Combining_Grave_Accent",n[n.U_Combining_Acute_Accent=769]="U_Combining_Acute_Accent",n[n.U_Combining_Circumflex_Accent=770]="U_Combining_Circumflex_Accent",n[n.U_Combining_Tilde=771]="U_Combining_Tilde",n[n.U_Combining_Macron=772]="U_Combining_Macron",n[n.U_Combining_Overline=773]="U_Combining_Overline",n[n.U_Combining_Breve=774]="U_Combining_Breve",n[n.U_Combining_Dot_Above=775]="U_Combining_Dot_Above",n[n.U_Combining_Diaeresis=776]="U_Combining_Diaeresis",n[n.U_Combining_Hook_Above=777]="U_Combining_Hook_Above",n[n.U_Combining_Ring_Above=778]="U_Combining_Ring_Above",n[n.U_Combining_Double_Acute_Accent=779]="U_Combining_Double_Acute_Accent",n[n.U_Combining_Caron=780]="U_Combining_Caron",n[n.U_Combining_Vertical_Line_Above=781]="U_Combining_Vertical_Line_Above",n[n.U_Combining_Double_Vertical_Line_Above=782]="U_Combining_Double_Vertical_Line_Above",n[n.U_Combining_Double_Grave_Accent=783]="U_Combining_Double_Grave_Accent",n[n.U_Combining_Candrabindu=784]="U_Combining_Candrabindu",n[n.U_Combining_Inverted_Breve=785]="U_Combining_Inverted_Breve",n[n.U_Combining_Turned_Comma_Above=786]="U_Combining_Turned_Comma_Above",n[n.U_Combining_Comma_Above=787]="U_Combining_Comma_Above",n[n.U_Combining_Reversed_Comma_Above=788]="U_Combining_Reversed_Comma_Above",n[n.U_Combining_Comma_Above_Right=789]="U_Combining_Comma_Above_Right",n[n.U_Combining_Grave_Accent_Below=790]="U_Combining_Grave_Accent_Below",n[n.U_Combining_Acute_Accent_Below=791]="U_Combining_Acute_Accent_Below",n[n.U_Combining_Left_Tack_Below=792]="U_Combining_Left_Tack_Below",n[n.U_Combining_Right_Tack_Below=793]="U_Combining_Right_Tack_Below",n[n.U_Combining_Left_Angle_Above=794]="U_Combining_Left_Angle_Above",n[n.U_Combining_Horn=795]="U_Combining_Horn",n[n.U_Combining_Left_Half_Ring_Below=796]="U_Combining_Left_Half_Ring_Below",n[n.U_Combining_Up_Tack_Below=797]="U_Combining_Up_Tack_Below",n[n.U_Combining_Down_Tack_Below=798]="U_Combining_Down_Tack_Below",n[n.U_Combining_Plus_Sign_Below=799]="U_Combining_Plus_Sign_Below",n[n.U_Combining_Minus_Sign_Below=800]="U_Combining_Minus_Sign_Below",n[n.U_Combining_Palatalized_Hook_Below=801]="U_Combining_Palatalized_Hook_Below",n[n.U_Combining_Retroflex_Hook_Below=802]="U_Combining_Retroflex_Hook_Below",n[n.U_Combining_Dot_Below=803]="U_Combining_Dot_Below",n[n.U_Combining_Diaeresis_Below=804]="U_Combining_Diaeresis_Below",n[n.U_Combining_Ring_Below=805]="U_Combining_Ring_Below",n[n.U_Combining_Comma_Below=806]="U_Combining_Comma_Below",n[n.U_Combining_Cedilla=807]="U_Combining_Cedilla",n[n.U_Combining_Ogonek=808]="U_Combining_Ogonek",n[n.U_Combining_Vertical_Line_Below=809]="U_Combining_Vertical_Line_Below",n[n.U_Combining_Bridge_Below=810]="U_Combining_Bridge_Below",n[n.U_Combining_Inverted_Double_Arch_Below=811]="U_Combining_Inverted_Double_Arch_Below",n[n.U_Combining_Caron_Below=812]="U_Combining_Caron_Below",n[n.U_Combining_Circumflex_Accent_Below=813]="U_Combining_Circumflex_Accent_Below",n[n.U_Combining_Breve_Below=814]="U_Combining_Breve_Below",n[n.U_Combining_Inverted_Breve_Below=815]="U_Combining_Inverted_Breve_Below",n[n.U_Combining_Tilde_Below=816]="U_Combining_Tilde_Below",n[n.U_Combining_Macron_Below=817]="U_Combining_Macron_Below",n[n.U_Combining_Low_Line=818]="U_Combining_Low_Line",n[n.U_Combining_Double_Low_Line=819]="U_Combining_Double_Low_Line",n[n.U_Combining_Tilde_Overlay=820]="U_Combining_Tilde_Overlay",n[n.U_Combining_Short_Stroke_Overlay=821]="U_Combining_Short_Stroke_Overlay",n[n.U_Combining_Long_Stroke_Overlay=822]="U_Combining_Long_Stroke_Overlay",n[n.U_Combining_Short_Solidus_Overlay=823]="U_Combining_Short_Solidus_Overlay",n[n.U_Combining_Long_Solidus_Overlay=824]="U_Combining_Long_Solidus_Overlay",n[n.U_Combining_Right_Half_Ring_Below=825]="U_Combining_Right_Half_Ring_Below",n[n.U_Combining_Inverted_Bridge_Below=826]="U_Combining_Inverted_Bridge_Below",n[n.U_Combining_Square_Below=827]="U_Combining_Square_Below",n[n.U_Combining_Seagull_Below=828]="U_Combining_Seagull_Below",n[n.U_Combining_X_Above=829]="U_Combining_X_Above",n[n.U_Combining_Vertical_Tilde=830]="U_Combining_Vertical_Tilde",n[n.U_Combining_Double_Overline=831]="U_Combining_Double_Overline",n[n.U_Combining_Grave_Tone_Mark=832]="U_Combining_Grave_Tone_Mark",n[n.U_Combining_Acute_Tone_Mark=833]="U_Combining_Acute_Tone_Mark",n[n.U_Combining_Greek_Perispomeni=834]="U_Combining_Greek_Perispomeni",n[n.U_Combining_Greek_Koronis=835]="U_Combining_Greek_Koronis",n[n.U_Combining_Greek_Dialytika_Tonos=836]="U_Combining_Greek_Dialytika_Tonos",n[n.U_Combining_Greek_Ypogegrammeni=837]="U_Combining_Greek_Ypogegrammeni",n[n.U_Combining_Bridge_Above=838]="U_Combining_Bridge_Above",n[n.U_Combining_Equals_Sign_Below=839]="U_Combining_Equals_Sign_Below",n[n.U_Combining_Double_Vertical_Line_Below=840]="U_Combining_Double_Vertical_Line_Below",n[n.U_Combining_Left_Angle_Below=841]="U_Combining_Left_Angle_Below",n[n.U_Combining_Not_Tilde_Above=842]="U_Combining_Not_Tilde_Above",n[n.U_Combining_Homothetic_Above=843]="U_Combining_Homothetic_Above",n[n.U_Combining_Almost_Equal_To_Above=844]="U_Combining_Almost_Equal_To_Above",n[n.U_Combining_Left_Right_Arrow_Below=845]="U_Combining_Left_Right_Arrow_Below",n[n.U_Combining_Upwards_Arrow_Below=846]="U_Combining_Upwards_Arrow_Below",n[n.U_Combining_Grapheme_Joiner=847]="U_Combining_Grapheme_Joiner",n[n.U_Combining_Right_Arrowhead_Above=848]="U_Combining_Right_Arrowhead_Above",n[n.U_Combining_Left_Half_Ring_Above=849]="U_Combining_Left_Half_Ring_Above",n[n.U_Combining_Fermata=850]="U_Combining_Fermata",n[n.U_Combining_X_Below=851]="U_Combining_X_Below",n[n.U_Combining_Left_Arrowhead_Below=852]="U_Combining_Left_Arrowhead_Below",n[n.U_Combining_Right_Arrowhead_Below=853]="U_Combining_Right_Arrowhead_Below",n[n.U_Combining_Right_Arrowhead_And_Up_Arrowhead_Below=854]="U_Combining_Right_Arrowhead_And_Up_Arrowhead_Below",n[n.U_Combining_Right_Half_Ring_Above=855]="U_Combining_Right_Half_Ring_Above",n[n.U_Combining_Dot_Above_Right=856]="U_Combining_Dot_Above_Right",n[n.U_Combining_Asterisk_Below=857]="U_Combining_Asterisk_Below",n[n.U_Combining_Double_Ring_Below=858]="U_Combining_Double_Ring_Below",n[n.U_Combining_Zigzag_Above=859]="U_Combining_Zigzag_Above",n[n.U_Combining_Double_Breve_Below=860]="U_Combining_Double_Breve_Below",n[n.U_Combining_Double_Breve=861]="U_Combining_Double_Breve",n[n.U_Combining_Double_Macron=862]="U_Combining_Double_Macron",n[n.U_Combining_Double_Macron_Below=863]="U_Combining_Double_Macron_Below",n[n.U_Combining_Double_Tilde=864]="U_Combining_Double_Tilde",n[n.U_Combining_Double_Inverted_Breve=865]="U_Combining_Double_Inverted_Breve",n[n.U_Combining_Double_Rightwards_Arrow_Below=866]="U_Combining_Double_Rightwards_Arrow_Below",n[n.U_Combining_Latin_Small_Letter_A=867]="U_Combining_Latin_Small_Letter_A",n[n.U_Combining_Latin_Small_Letter_E=868]="U_Combining_Latin_Small_Letter_E",n[n.U_Combining_Latin_Small_Letter_I=869]="U_Combining_Latin_Small_Letter_I",n[n.U_Combining_Latin_Small_Letter_O=870]="U_Combining_Latin_Small_Letter_O",n[n.U_Combining_Latin_Small_Letter_U=871]="U_Combining_Latin_Small_Letter_U",n[n.U_Combining_Latin_Small_Letter_C=872]="U_Combining_Latin_Small_Letter_C",n[n.U_Combining_Latin_Small_Letter_D=873]="U_Combining_Latin_Small_Letter_D",n[n.U_Combining_Latin_Small_Letter_H=874]="U_Combining_Latin_Small_Letter_H",n[n.U_Combining_Latin_Small_Letter_M=875]="U_Combining_Latin_Small_Letter_M",n[n.U_Combining_Latin_Small_Letter_R=876]="U_Combining_Latin_Small_Letter_R",n[n.U_Combining_Latin_Small_Letter_T=877]="U_Combining_Latin_Small_Letter_T",n[n.U_Combining_Latin_Small_Letter_V=878]="U_Combining_Latin_Small_Letter_V",n[n.U_Combining_Latin_Small_Letter_X=879]="U_Combining_Latin_Small_Letter_X",n[n.LINE_SEPARATOR=8232]="LINE_SEPARATOR",n[n.PARAGRAPH_SEPARATOR=8233]="PARAGRAPH_SEPARATOR",n[n.NEXT_LINE=133]="NEXT_LINE",n[n.U_CIRCUMFLEX=94]="U_CIRCUMFLEX",n[n.U_GRAVE_ACCENT=96]="U_GRAVE_ACCENT",n[n.U_DIAERESIS=168]="U_DIAERESIS",n[n.U_MACRON=175]="U_MACRON",n[n.U_ACUTE_ACCENT=180]="U_ACUTE_ACCENT",n[n.U_CEDILLA=184]="U_CEDILLA",n[n.U_MODIFIER_LETTER_LEFT_ARROWHEAD=706]="U_MODIFIER_LETTER_LEFT_ARROWHEAD",n[n.U_MODIFIER_LETTER_RIGHT_ARROWHEAD=707]="U_MODIFIER_LETTER_RIGHT_ARROWHEAD",n[n.U_MODIFIER_LETTER_UP_ARROWHEAD=708]="U_MODIFIER_LETTER_UP_ARROWHEAD",n[n.U_MODIFIER_LETTER_DOWN_ARROWHEAD=709]="U_MODIFIER_LETTER_DOWN_ARROWHEAD",n[n.U_MODIFIER_LETTER_CENTRED_RIGHT_HALF_RING=722]="U_MODIFIER_LETTER_CENTRED_RIGHT_HALF_RING",n[n.U_MODIFIER_LETTER_CENTRED_LEFT_HALF_RING=723]="U_MODIFIER_LETTER_CENTRED_LEFT_HALF_RING",n[n.U_MODIFIER_LETTER_UP_TACK=724]="U_MODIFIER_LETTER_UP_TACK",n[n.U_MODIFIER_LETTER_DOWN_TACK=725]="U_MODIFIER_LETTER_DOWN_TACK",n[n.U_MODIFIER_LETTER_PLUS_SIGN=726]="U_MODIFIER_LETTER_PLUS_SIGN",n[n.U_MODIFIER_LETTER_MINUS_SIGN=727]="U_MODIFIER_LETTER_MINUS_SIGN",n[n.U_BREVE=728]="U_BREVE",n[n.U_DOT_ABOVE=729]="U_DOT_ABOVE",n[n.U_RING_ABOVE=730]="U_RING_ABOVE",n[n.U_OGONEK=731]="U_OGONEK",n[n.U_SMALL_TILDE=732]="U_SMALL_TILDE",n[n.U_DOUBLE_ACUTE_ACCENT=733]="U_DOUBLE_ACUTE_ACCENT",n[n.U_MODIFIER_LETTER_RHOTIC_HOOK=734]="U_MODIFIER_LETTER_RHOTIC_HOOK",n[n.U_MODIFIER_LETTER_CROSS_ACCENT=735]="U_MODIFIER_LETTER_CROSS_ACCENT",n[n.U_MODIFIER_LETTER_EXTRA_HIGH_TONE_BAR=741]="U_MODIFIER_LETTER_EXTRA_HIGH_TONE_BAR",n[n.U_MODIFIER_LETTER_HIGH_TONE_BAR=742]="U_MODIFIER_LETTER_HIGH_TONE_BAR",n[n.U_MODIFIER_LETTER_MID_TONE_BAR=743]="U_MODIFIER_LETTER_MID_TONE_BAR",n[n.U_MODIFIER_LETTER_LOW_TONE_BAR=744]="U_MODIFIER_LETTER_LOW_TONE_BAR",n[n.U_MODIFIER_LETTER_EXTRA_LOW_TONE_BAR=745]="U_MODIFIER_LETTER_EXTRA_LOW_TONE_BAR",n[n.U_MODIFIER_LETTER_YIN_DEPARTING_TONE_MARK=746]="U_MODIFIER_LETTER_YIN_DEPARTING_TONE_MARK",n[n.U_MODIFIER_LETTER_YANG_DEPARTING_TONE_MARK=747]="U_MODIFIER_LETTER_YANG_DEPARTING_TONE_MARK",n[n.U_MODIFIER_LETTER_UNASPIRATED=749]="U_MODIFIER_LETTER_UNASPIRATED",n[n.U_MODIFIER_LETTER_LOW_DOWN_ARROWHEAD=751]="U_MODIFIER_LETTER_LOW_DOWN_ARROWHEAD",n[n.U_MODIFIER_LETTER_LOW_UP_ARROWHEAD=752]="U_MODIFIER_LETTER_LOW_UP_ARROWHEAD",n[n.U_MODIFIER_LETTER_LOW_LEFT_ARROWHEAD=753]="U_MODIFIER_LETTER_LOW_LEFT_ARROWHEAD",n[n.U_MODIFIER_LETTER_LOW_RIGHT_ARROWHEAD=754]="U_MODIFIER_LETTER_LOW_RIGHT_ARROWHEAD",n[n.U_MODIFIER_LETTER_LOW_RING=755]="U_MODIFIER_LETTER_LOW_RING",n[n.U_MODIFIER_LETTER_MIDDLE_GRAVE_ACCENT=756]="U_MODIFIER_LETTER_MIDDLE_GRAVE_ACCENT",n[n.U_MODIFIER_LETTER_MIDDLE_DOUBLE_GRAVE_ACCENT=757]="U_MODIFIER_LETTER_MIDDLE_DOUBLE_GRAVE_ACCENT",n[n.U_MODIFIER_LETTER_MIDDLE_DOUBLE_ACUTE_ACCENT=758]="U_MODIFIER_LETTER_MIDDLE_DOUBLE_ACUTE_ACCENT",n[n.U_MODIFIER_LETTER_LOW_TILDE=759]="U_MODIFIER_LETTER_LOW_TILDE",n[n.U_MODIFIER_LETTER_RAISED_COLON=760]="U_MODIFIER_LETTER_RAISED_COLON",n[n.U_MODIFIER_LETTER_BEGIN_HIGH_TONE=761]="U_MODIFIER_LETTER_BEGIN_HIGH_TONE",n[n.U_MODIFIER_LETTER_END_HIGH_TONE=762]="U_MODIFIER_LETTER_END_HIGH_TONE",n[n.U_MODIFIER_LETTER_BEGIN_LOW_TONE=763]="U_MODIFIER_LETTER_BEGIN_LOW_TONE",n[n.U_MODIFIER_LETTER_END_LOW_TONE=764]="U_MODIFIER_LETTER_END_LOW_TONE",n[n.U_MODIFIER_LETTER_SHELF=765]="U_MODIFIER_LETTER_SHELF",n[n.U_MODIFIER_LETTER_OPEN_SHELF=766]="U_MODIFIER_LETTER_OPEN_SHELF",n[n.U_MODIFIER_LETTER_LOW_LEFT_ARROW=767]="U_MODIFIER_LETTER_LOW_LEFT_ARROW",n[n.U_GREEK_LOWER_NUMERAL_SIGN=885]="U_GREEK_LOWER_NUMERAL_SIGN",n[n.U_GREEK_TONOS=900]="U_GREEK_TONOS",n[n.U_GREEK_DIALYTIKA_TONOS=901]="U_GREEK_DIALYTIKA_TONOS",n[n.U_GREEK_KORONIS=8125]="U_GREEK_KORONIS",n[n.U_GREEK_PSILI=8127]="U_GREEK_PSILI",n[n.U_GREEK_PERISPOMENI=8128]="U_GREEK_PERISPOMENI",n[n.U_GREEK_DIALYTIKA_AND_PERISPOMENI=8129]="U_GREEK_DIALYTIKA_AND_PERISPOMENI",n[n.U_GREEK_PSILI_AND_VARIA=8141]="U_GREEK_PSILI_AND_VARIA",n[n.U_GREEK_PSILI_AND_OXIA=8142]="U_GREEK_PSILI_AND_OXIA",n[n.U_GREEK_PSILI_AND_PERISPOMENI=8143]="U_GREEK_PSILI_AND_PERISPOMENI",n[n.U_GREEK_DASIA_AND_VARIA=8157]="U_GREEK_DASIA_AND_VARIA",n[n.U_GREEK_DASIA_AND_OXIA=8158]="U_GREEK_DASIA_AND_OXIA",n[n.U_GREEK_DASIA_AND_PERISPOMENI=8159]="U_GREEK_DASIA_AND_PERISPOMENI",n[n.U_GREEK_DIALYTIKA_AND_VARIA=8173]="U_GREEK_DIALYTIKA_AND_VARIA",n[n.U_GREEK_DIALYTIKA_AND_OXIA=8174]="U_GREEK_DIALYTIKA_AND_OXIA",n[n.U_GREEK_VARIA=8175]="U_GREEK_VARIA",n[n.U_GREEK_OXIA=8189]="U_GREEK_OXIA",n[n.U_GREEK_DASIA=8190]="U_GREEK_DASIA",n[n.U_IDEOGRAPHIC_FULL_STOP=12290]="U_IDEOGRAPHIC_FULL_STOP",n[n.U_LEFT_CORNER_BRACKET=12300]="U_LEFT_CORNER_BRACKET",n[n.U_RIGHT_CORNER_BRACKET=12301]="U_RIGHT_CORNER_BRACKET",n[n.U_LEFT_BLACK_LENTICULAR_BRACKET=12304]="U_LEFT_BLACK_LENTICULAR_BRACKET",n[n.U_RIGHT_BLACK_LENTICULAR_BRACKET=12305]="U_RIGHT_BLACK_LENTICULAR_BRACKET",n[n.U_OVERLINE=8254]="U_OVERLINE",n[n.UTF8_BOM=65279]="UTF8_BOM",n[n.U_FULLWIDTH_SEMICOLON=65307]="U_FULLWIDTH_SEMICOLON",n[n.U_FULLWIDTH_COMMA=65292]="U_FULLWIDTH_COMMA"})(i||(t.CharCode=i={}))}),define(we[57],ve([1,0]),function(re,t){"use strict";var i;Object.defineProperty(t,"__esModule",{value:!0}),t.$g=void 0,t.$c=n,t.$d=j,t.$e=F,t.$f=N;function n(D,c){const p=Object.create(null);for(const y of D){const $=c(y);let g=p[$];g||(g=p[$]=[]),g.push(y)}return p}function j(D,c){const p=[],y=[];for(const $ of D)c.has($)||p.push($);for(const $ of c)D.has($)||y.push($);return{removed:p,added:y}}function F(D,c){const p=[],y=[];for(const[$,g]of D)c.has($)||p.push(g);for(const[$,g]of c)D.has($)||y.push(g);return{removed:p,added:y}}function N(D,c){const p=new Set;for(const y of c)D.has(y)&&p.add(y);return p}class w{static{i=Symbol.toStringTag}constructor(c,p){this.b=p,this.a=new Map,this[i]="SetWithKey";for(const y of c)this.add(y)}get size(){return this.a.size}add(c){const p=this.b(c);return this.a.set(p,c),this}delete(c){return this.a.delete(this.b(c))}has(c){return this.a.has(this.b(c))}*entries(){for(const c of this.a.values())yield[c,c]}keys(){return this.values()}*values(){for(const c of this.a.values())yield c}clear(){this.a.clear()}forEach(c,p){this.a.forEach(y=>c.call(p,y,y,this))}[Symbol.iterator](){return this.values()}}t.$g=w}),define(we[88],ve([1,0,17]),function(re,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$lu=t.$ku=t.$ju=t.$iu=void 0;function n(D,c){const p=Math.pow(10,c);return Math.round(D*p)/p}class j{constructor(c,p,y,$=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,c))|0,this.g=Math.min(255,Math.max(0,p))|0,this.b=Math.min(255,Math.max(0,y))|0,this.a=n(Math.max(Math.min(1,$),0),3)}static equals(c,p){return c.r===p.r&&c.g===p.g&&c.b===p.b&&c.a===p.a}}t.$iu=j;class F{constructor(c,p,y,$){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,c),0)|0,this.s=n(Math.max(Math.min(1,p),0),3),this.l=n(Math.max(Math.min(1,y),0),3),this.a=n(Math.max(Math.min(1,$),0),3)}static equals(c,p){return c.h===p.h&&c.s===p.s&&c.l===p.l&&c.a===p.a}static fromRGBA(c){const p=c.r/255,y=c.g/255,$=c.b/255,g=c.a,e=Math.max(p,y,$),s=Math.min(p,y,$);let r=0,h=0;const l=(s+e)/2,v=e-s;if(v>0){switch(h=Math.min(l<=.5?v/(2*l):v/(2-2*l),1),e){case p:r=(y-$)/v+(y<$?6:0);break;case y:r=($-p)/v+2;break;case $:r=(p-y)/v+4;break}r*=60,r=Math.round(r)}return new F(r,h,l,g)}static i(c,p,y){return y<0&&(y+=1),y>1&&(y-=1),y<1/6?c+(p-c)*6*y:y<1/2?p:y<2/3?c+(p-c)*(2/3-y)*6:c}static toRGBA(c){const p=c.h/360,{s:y,l:$,a:g}=c;let e,s,r;if(y===0)e=s=r=$;else{const h=$<.5?$*(1+y):$+y-$*y,l=2*$-h;e=F.i(l,h,p+1/3),s=F.i(l,h,p),r=F.i(l,h,p-1/3)}return new j(Math.round(e*255),Math.round(s*255),Math.round(r*255),g)}}t.$ju=F;class N{constructor(c,p,y,$){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,c),0)|0,this.s=n(Math.max(Math.min(1,p),0),3),this.v=n(Math.max(Math.min(1,y),0),3),this.a=n(Math.max(Math.min(1,$),0),3)}static equals(c,p){return c.h===p.h&&c.s===p.s&&c.v===p.v&&c.a===p.a}static fromRGBA(c){const p=c.r/255,y=c.g/255,$=c.b/255,g=Math.max(p,y,$),e=Math.min(p,y,$),s=g-e,r=g===0?0:s/g;let h;return s===0?h=0:g===p?h=((y-$)/s%6+6)%6:g===y?h=($-p)/s+2:h=(p-y)/s+4,new N(Math.round(h*60),r,g,c.a)}static toRGBA(c){const{h:p,s:y,v:$,a:g}=c,e=$*y,s=e*(1-Math.abs(p/60%2-1)),r=$-e;let[h,l,v]=[0,0,0];return p<60?(h=e,l=s):p<120?(h=s,l=e):p<180?(l=e,v=s):p<240?(l=s,v=e):p<300?(h=s,v=e):p<=360&&(h=e,v=s),h=Math.round((h+r)*255),l=Math.round((l+r)*255),v=Math.round((v+r)*255),new j(h,l,v,g)}}t.$ku=N;class w{static fromHex(c){return w.Format.CSS.parseHex(c)||w.red}static equals(c,p){return!c&&!p?!0:!c||!p?!1:c.equals(p)}get hsla(){return this.i?this.i:F.fromRGBA(this.rgba)}get hsva(){return this.j?this.j:N.fromRGBA(this.rgba)}constructor(c){if(c)if(c instanceof j)this.rgba=c;else if(c instanceof F)this.i=c,this.rgba=F.toRGBA(c);else if(c instanceof N)this.j=c,this.rgba=N.toRGBA(c);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}equals(c){return!!c&&j.equals(this.rgba,c.rgba)&&F.equals(this.hsla,c.hsla)&&N.equals(this.hsva,c.hsva)}getRelativeLuminance(){const c=w.k(this.rgba.r),p=w.k(this.rgba.g),y=w.k(this.rgba.b),$=.2126*c+.7152*p+.0722*y;return n($,4)}static k(c){const p=c/255;return p<=.03928?p/12.92:Math.pow((p+.055)/1.055,2.4)}getContrastRatio(c){const p=this.getRelativeLuminance(),y=c.getRelativeLuminance();return p>y?(p+.05)/(y+.05):(y+.05)/(p+.05)}isDarker(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3<128}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(c){const p=this.getRelativeLuminance(),y=c.getRelativeLuminance();return p>y}isDarkerThan(c){const p=this.getRelativeLuminance(),y=c.getRelativeLuminance();return p<y}lighten(c){return new w(new F(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*c,this.hsla.a))}darken(c){return new w(new F(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*c,this.hsla.a))}transparent(c){const{r:p,g:y,b:$,a:g}=this.rgba;return new w(new j(p,y,$,g*c))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new w(new j(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}blend(c){const p=c.rgba,y=this.rgba.a,$=p.a,g=y+$*(1-y);if(g<1e-6)return w.transparent;const e=this.rgba.r*y/g+p.r*$*(1-y)/g,s=this.rgba.g*y/g+p.g*$*(1-y)/g,r=this.rgba.b*y/g+p.b*$*(1-y)/g;return new w(new j(e,s,r,g))}makeOpaque(c){if(this.isOpaque()||c.rgba.a!==1)return this;const{r:p,g:y,b:$,a:g}=this.rgba;return new w(new j(c.rgba.r-g*(c.rgba.r-p),c.rgba.g-g*(c.rgba.g-y),c.rgba.b-g*(c.rgba.b-$),1))}flatten(...c){const p=c.reduceRight((y,$)=>w.o($,y));return w.o(this,p)}static o(c,p){const y=1-c.rgba.a;return new w(new j(y*p.rgba.r+c.rgba.a*c.rgba.r,y*p.rgba.g+c.rgba.a*c.rgba.g,y*p.rgba.b+c.rgba.a*c.rgba.b))}toString(){return this.u||(this.u=w.Format.CSS.format(this)),this.u}static getLighterColor(c,p,y){if(c.isLighterThan(p))return c;y=y||.5;const $=c.getRelativeLuminance(),g=p.getRelativeLuminance();return y=y*(g-$)/g,c.lighten(y)}static getDarkerColor(c,p,y){if(c.isDarkerThan(p))return c;y=y||.5;const $=c.getRelativeLuminance(),g=p.getRelativeLuminance();return y=y*($-g)/$,c.darken(y)}static{this.white=new w(new j(255,255,255,1))}static{this.black=new w(new j(0,0,0,1))}static{this.red=new w(new j(255,0,0,1))}static{this.blue=new w(new j(0,0,255,1))}static{this.green=new w(new j(0,255,0,1))}static{this.cyan=new w(new j(0,255,255,1))}static{this.lightgrey=new w(new j(211,211,211,1))}static{this.transparent=new w(new j(0,0,0,0))}}t.$lu=w,function(D){let c;(function(p){let y;(function($){function g(f){return f.rgba.a===1?`rgb(${f.rgba.r}, ${f.rgba.g}, ${f.rgba.b})`:D.Format.CSS.formatRGBA(f)}$.formatRGB=g;function e(f){return`rgba(${f.rgba.r}, ${f.rgba.g}, ${f.rgba.b}, ${+f.rgba.a.toFixed(2)})`}$.formatRGBA=e;function s(f){return f.hsla.a===1?`hsl(${f.hsla.h}, ${(f.hsla.s*100).toFixed(2)}%, ${(f.hsla.l*100).toFixed(2)}%)`:D.Format.CSS.formatHSLA(f)}$.formatHSL=s;function r(f){return`hsla(${f.hsla.h}, ${(f.hsla.s*100).toFixed(2)}%, ${(f.hsla.l*100).toFixed(2)}%, ${f.hsla.a.toFixed(2)})`}$.formatHSLA=r;function h(f){const b=f.toString(16);return b.length!==2?"0"+b:b}function l(f){return`#${h(f.rgba.r)}${h(f.rgba.g)}${h(f.rgba.b)}`}$.formatHex=l;function v(f,b=!1){return b&&f.rgba.a===1?D.Format.CSS.formatHex(f):`#${h(f.rgba.r)}${h(f.rgba.g)}${h(f.rgba.b)}${h(Math.round(f.rgba.a*255))}`}$.formatHexA=v;function k(f){return f.isOpaque()?D.Format.CSS.formatHex(f):D.Format.CSS.formatRGBA(f)}$.format=k;function A(f){const b=f.length;if(b===0||f.charCodeAt(0)!==i.CharCode.Hash)return null;if(b===7){const S=16*d(f.charCodeAt(1))+d(f.charCodeAt(2)),U=16*d(f.charCodeAt(3))+d(f.charCodeAt(4)),_=16*d(f.charCodeAt(5))+d(f.charCodeAt(6));return new D(new j(S,U,_,1))}if(b===9){const S=16*d(f.charCodeAt(1))+d(f.charCodeAt(2)),U=16*d(f.charCodeAt(3))+d(f.charCodeAt(4)),_=16*d(f.charCodeAt(5))+d(f.charCodeAt(6)),B=16*d(f.charCodeAt(7))+d(f.charCodeAt(8));return new D(new j(S,U,_,B/255))}if(b===4){const S=d(f.charCodeAt(1)),U=d(f.charCodeAt(2)),_=d(f.charCodeAt(3));return new D(new j(16*S+S,16*U+U,16*_+_))}if(b===5){const S=d(f.charCodeAt(1)),U=d(f.charCodeAt(2)),_=d(f.charCodeAt(3)),B=d(f.charCodeAt(4));return new D(new j(16*S+S,16*U+U,16*_+_,(16*B+B)/255))}return null}$.parseHex=A;function d(f){switch(f){case i.CharCode.Digit0:return 0;case i.CharCode.Digit1:return 1;case i.CharCode.Digit2:return 2;case i.CharCode.Digit3:return 3;case i.CharCode.Digit4:return 4;case i.CharCode.Digit5:return 5;case i.CharCode.Digit6:return 6;case i.CharCode.Digit7:return 7;case i.CharCode.Digit8:return 8;case i.CharCode.Digit9:return 9;case i.CharCode.a:return 10;case i.CharCode.A:return 10;case i.CharCode.b:return 11;case i.CharCode.B:return 11;case i.CharCode.c:return 12;case i.CharCode.C:return 12;case i.CharCode.d:return 13;case i.CharCode.D:return 13;case i.CharCode.e:return 14;case i.CharCode.E:return 14;case i.CharCode.f:return 15;case i.CharCode.F:return 15}return 0}})(y=p.CSS||(p.CSS={}))})(c=D.Format||(D.Format={}))}(w||(t.$lu=w={}))}),define(we[35],ve([1,0]),function(re,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$7h=n,t.$8h=j,t.$9h=F;function i(N){return(w,D,c)=>{let p=null,y=null;if(typeof c.value=="function"?(p="value",y=c.value):typeof c.get=="function"&&(p="get",y=c.get),!y)throw new Error("not supported");c[p]=N(y,D)}}function n(N,w,D){let c=null,p=null;if(typeof D.value=="function"?(c="value",p=D.value,p.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof D.get=="function"&&(c="get",p=D.get),!p)throw new Error("not supported");const y=`$memoize$${w}`;D[c]=function(...$){return this.hasOwnProperty(y)||Object.defineProperty(this,y,{configurable:!1,enumerable:!1,writable:!1,value:p.apply(this,$)}),this[y]}}function j(N,w,D){return i((c,p)=>{const y=`$debounce$${p}`,$=`$debounce$result$${p}`;return function(...g){this[$]||(this[$]=D?D():void 0),clearTimeout(this[y]),w&&(this[$]=w(this[$],...g),g=[this[$]]),this[y]=setTimeout(()=>{c.apply(this,g),this[$]=D?D():void 0},N)}})}function F(N,w,D){return i((c,p)=>{const y=`$throttle$timer$${p}`,$=`$throttle$result$${p}`,g=`$throttle$lastRun$${p}`,e=`$throttle$pending$${p}`;return function(...s){if(this[$]||(this[$]=D?D():void 0),(this[g]===null||this[g]===void 0)&&(this[g]=-Number.MAX_VALUE),w&&(this[$]=w(this[$],...s)),this[e])return;const r=this[g]+N;r<=Date.now()?(this[g]=Date.now(),c.apply(this,[this[$]]),this[$]=D?D():void 0):(this[e]=!0,this[y]=setTimeout(()=>{this[e]=!1,this[g]=Date.now(),c.apply(this,[this[$]]),this[$]=D?D():void 0},r-Date.now()))}})}}),define(we[89],ve([1,0]),function(re,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Ot=void 0;class i{constructor(j,F,N,w){this.originalStart=j,this.originalLength=F,this.modifiedStart=N,this.modifiedLength=w}getOriginalEnd(){return this.originalStart+this.originalLength}getModifiedEnd(){return this.modifiedStart+this.modifiedLength}}t.$Ot=i}),define(we[6],ve([1,0]),function(re,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$bb=t.$ab=t.$_=t.$$=t.$0=t.$8=t.$4=t.$V=t.$U=void 0,t.setUnexpectedErrorHandler=n,t.$X=j,t.$Y=F,t.$Z=N,t.$1=w,t.$2=D,t.$3=p,t.$5=$,t.$6=g,t.$7=e,t.$9=r;class i{constructor(){this.b=[],this.a=function(f){setTimeout(()=>{throw f.stack?k.isErrorNoTelemetry(f)?new k(f.message+`

`+f.stack):new Error(f.message+`

`+f.stack):f},0)}}addListener(f){return this.b.push(f),()=>{this.d(f)}}c(f){this.b.forEach(b=>{b(f)})}d(f){this.b.splice(this.b.indexOf(f),1)}setUnexpectedErrorHandler(f){this.a=f}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(f){this.a(f),this.c(f)}onUnexpectedExternalError(f){this.a(f)}}t.$U=i,t.$V=new i;function n(d){t.$V.setUnexpectedErrorHandler(d)}function j(d){if(!d||typeof d!="object")return!1;const f=d;return f.code==="EPIPE"&&f.syscall?.toUpperCase()==="WRITE"}function F(d){p(d)||t.$V.onUnexpectedError(d)}function N(d){p(d)||t.$V.onUnexpectedExternalError(d)}function w(d){if(d instanceof Error){const{name:f,message:b}=d,S=d.stacktrace||d.stack;return{$isError:!0,name:f,message:b,stack:S,noTelemetry:k.isErrorNoTelemetry(d)}}return d}function D(d){let f;return d.noTelemetry?f=new k:(f=new Error,f.name=d.name),f.message=d.message,f.stack=d.stack,f}const c="Canceled";function p(d){return d instanceof y?!0:d instanceof Error&&d.name===c&&d.message===c}class y extends Error{constructor(){super(c),this.name=this.message}}t.$4=y;function $(){const d=new Error(c);return d.name=d.message,d}function g(d){return d?new Error(`Illegal argument: ${d}`):new Error("Illegal argument")}function e(d){return d?new Error(`Illegal state: ${d}`):new Error("Illegal state")}class s extends TypeError{constructor(f){super(f?`${f} is read-only and cannot be changed`:"Cannot change read-only property")}}t.$8=s;function r(d){return d?d.message?d.message:d.stack?d.stack.split(`
`)[0]:String(d):"Error"}class h extends Error{constructor(f){super("NotImplemented"),f&&(this.message=f)}}t.$0=h;class l extends Error{constructor(f){super("NotSupported"),f&&(this.message=f)}}t.$$=l;class v extends Error{constructor(){super(...arguments),this.isExpected=!0}}t.$_=v;class k extends Error{constructor(f){super(f),this.name="CodeExpectedError"}static fromError(f){if(f instanceof k)return f;const b=new k;return b.message=f.message,b.stack=f.stack,b}static isErrorNoTelemetry(f){return f.name==="CodeExpectedError"}}t.$ab=k;class A extends Error{constructor(f){super(f||"An unexpected bug occurred."),Object.setPrototypeOf(this,A.prototype)}}t.$bb=A}),define(we[9],ve([1,0,6,87]),function(re,t,i,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$_b=t.$$b=t.$0b=t.$8b=t.$7b=t.CompareResult=void 0,t.$rb=j,t.$sb=F,t.$tb=N,t.$ub=w,t.$vb=D,t.$wb=c,t.$xb=p,t.$yb=y,t.$zb=$,t.$Ab=g,t.$Bb=e,t.$Cb=s,t.$Db=r,t.top=h,t.$Fb=l,t.$Gb=k,t.$Hb=A,t.$Ib=d,t.$Jb=f,t.$Kb=b,t.$Lb=S,t.$Mb=U,t.$Nb=_,t.$Ob=B,t.$Pb=E,t.$Qb=I,t.$Rb=z,t.$Sb=O,t.$Tb=C,t.$Ub=x,t.$Vb=Z,t.$Wb=Y,t.$Xb=q,t.$Yb=ee,t.$Zb=ce,t.$1b=be,t.$2b=ke,t.$3b=Fe,t.$4b=ue,t.$5b=le,t.$6b=Ne,t.$9b=Ae;function j(se,K=0){return se[se.length-(1+K)]}function F(se){if(se.length===0)throw new Error("Invalid tail call");return[se.slice(0,se.length-1),se[se.length-1]]}function N(se,K,W=(a,o)=>a===o){if(se===K)return!0;if(!se||!K||se.length!==K.length)return!1;for(let a=0,o=se.length;a<o;a++)if(!W(se[a],K[a]))return!1;return!0}function w(se,K){const W=se.length-1;K<W&&(se[K]=se[W]),se.pop()}function D(se,K,W){return c(se.length,a=>W(se[a],K))}function c(se,K){let W=0,a=se-1;for(;W<=a;){const o=(W+a)/2|0,m=K(o);if(m<0)W=o+1;else if(m>0)a=o-1;else return o}return-(W+1)}function p(se,K,W){if(se=se|0,se>=K.length)throw new TypeError("invalid index");const a=K[Math.floor(K.length*Math.random())],o=[],m=[],M=[];for(const R of K){const u=W(R,a);u<0?o.push(R):u>0?m.push(R):M.push(R)}return se<o.length?p(se,o,W):se<o.length+M.length?M[0]:p(se-(o.length+M.length),m,W)}function y(se,K){const W=[];let a;for(const o of se.slice(0).sort(K))!a||K(a[0],o)!==0?(a=[o],W.push(a)):a.push(o);return W}function*$(se,K){let W,a;for(const o of se)a!==void 0&&K(a,o)?W.push(o):(W&&(yield W),W=[o]),a=o;W&&(yield W)}function g(se,K){for(let W=0;W<=se.length;W++)K(W===0?void 0:se[W-1],W===se.length?void 0:se[W])}function e(se,K){for(let W=0;W<se.length;W++)K(W===0?void 0:se[W-1],se[W],W+1===se.length?void 0:se[W+1])}function s(se,K,W){const a=[];function o(R,u,L){if(u===0&&L.length===0)return;const T=a[a.length-1];T&&T.start+T.deleteCount===R?(T.deleteCount+=u,T.toInsert.push(...L)):a.push({start:R,deleteCount:u,toInsert:L})}let m=0,M=0;for(;;){if(m===se.length){o(m,0,K.slice(M));break}if(M===K.length){o(m,se.length-m,[]);break}const R=se[m],u=K[M],L=W(R,u);L===0?(m+=1,M+=1):L<0?(o(m,1,[]),m+=1):L>0&&(o(m,0,[u]),M+=1)}return a}function r(se,K,W){const a=s(se,K,W),o=[],m=[];for(const M of a)o.push(...se.slice(M.start,M.start+M.deleteCount)),m.push(...M.toInsert);return{removed:o,added:m}}function h(se,K,W){if(W===0)return[];const a=se.slice(0,W).sort(K);return v(se,K,a,W,se.length),a}function l(se,K,W,a,o){return W===0?Promise.resolve([]):new Promise((m,M)=>{(async()=>{const R=se.length,u=se.slice(0,W).sort(K);for(let L=W,T=Math.min(W+a,R);L<R;L=T,T=Math.min(T+a,R)){if(L>W&&await new Promise(P=>setTimeout(P)),o&&o.isCancellationRequested)throw new i.$4;v(se,K,u,L,T)}return u})().then(m,M)})}function v(se,K,W,a,o){for(const m=W.length;a<o;a++){const M=se[a];if(K(M,W[m-1])<0){W.pop();const R=(0,n.$jb)(W,u=>K(M,u)<0);W.splice(R,0,M)}}}function k(se){return se.filter(K=>!!K)}function A(se){let K=0;for(let W=0;W<se.length;W++)se[W]&&(se[K]=se[W],K+=1);se.length=K}function d(se,K,W){se.splice(W,0,se.splice(K,1)[0])}function f(se){return!Array.isArray(se)||se.length===0}function b(se){return Array.isArray(se)&&se.length>0}function S(se,K=W=>W){const W=new Set;return se.filter(a=>{const o=K(a);return W.has(o)?!1:(W.add(o),!0)})}function U(se){const K=new Set;return W=>{const a=se(W);return K.has(a)?!1:(K.add(a),!0)}}function _(se,K){return se.length>0?se[0]:K}function B(se,K){return se.length>0?se[se.length-1]:K}function E(se,K,W=(a,o)=>a===o){let a=0;for(let o=0,m=Math.min(se.length,K.length);o<m&&W(se[o],K[o]);o++)a++;return a}function I(se,K){let W=typeof K=="number"?se:0;typeof K=="number"?W=se:(W=0,K=se);const a=[];if(W<=K)for(let o=W;o<K;o++)a.push(o);else for(let o=W;o>K;o--)a.push(o);return a}function z(se,K,W){return se.reduce((a,o)=>(a[K(o)]=W?W(o):o,a),Object.create(null))}function O(se,K){return se.push(K),()=>C(se,K)}function C(se,K){const W=se.indexOf(K);if(W>-1)return se.splice(W,1),K}function x(se,K,W){const a=se.slice(0,K),o=se.slice(K);return a.concat(W,o)}function Z(se,K){let W;if(typeof K=="number"){let a=K;W=()=>{const o=Math.sin(a++)*179426549;return o-Math.floor(o)}}else W=Math.random;for(let a=se.length-1;a>0;a-=1){const o=Math.floor(W()*(a+1)),m=se[a];se[a]=se[o],se[o]=m}}function Y(se,K){const W=se.indexOf(K);W>-1&&(se.splice(W,1),se.unshift(K))}function q(se,K){const W=se.indexOf(K);W>-1&&(se.splice(W,1),se.push(K))}function ee(se,K){for(const W of K)se.push(W)}function ce(se,K){return Array.isArray(se)?se.map(K):K(se)}function be(se){return Array.isArray(se)?se:[se]}function ke(se){return se[Math.floor(Math.random()*se.length)]}function Fe(se,K,W){const a=Q(se,K),o=se.length,m=W.length;se.length=o+m;for(let M=o-1;M>=a;M--)se[M+m]=se[M];for(let M=0;M<m;M++)se[M+a]=W[M]}function ue(se,K,W,a){const o=Q(se,K);let m=se.splice(o,W);return m===void 0&&(m=[]),Fe(se,o,a),m}function Q(se,K){return K<0?Math.max(K+se.length,0):Math.min(K,se.length)}var he;(function(se){function K(m){return m<0}se.isLessThan=K;function W(m){return m<=0}se.isLessThanOrEqual=W;function a(m){return m>0}se.isGreaterThan=a;function o(m){return m===0}se.isNeitherLessOrGreaterThan=o,se.greaterThan=1,se.lessThan=-1,se.neitherLessOrGreaterThan=0})(he||(t.CompareResult=he={}));function le(se,K){return(W,a)=>K(se(W),se(a))}function Ne(...se){return(K,W)=>{for(const a of se){const o=a(K,W);if(!he.isNeitherLessOrGreaterThan(o))return o}return he.neitherLessOrGreaterThan}}const te=(se,K)=>se-K;t.$7b=te;const $e=(se,K)=>(0,t.$7b)(se?1:0,K?1:0);t.$8b=$e;function Ae(se){return(K,W)=>-se(K,W)}class Oe{constructor(K){this.g=K,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(K){let W=this.c;for(;W<this.g.length&&K(this.g[W]);)W++;const a=W===this.c?null:this.g.slice(this.c,W);return this.c=W,a}takeFromEndWhile(K){let W=this.d;for(;W>=0&&K(this.g[W]);)W--;const a=W===this.d?null:this.g.slice(W+1,this.d+1);return this.d=W,a}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const K=this.g[this.c];return this.c++,K}removeLast(){const K=this.g[this.d];return this.d--,K}takeCount(K){const W=this.g.slice(this.c,this.c+K);return this.c+=K,W}}t.$0b=Oe;class Ie{static{this.empty=new Ie(K=>{})}constructor(K){this.iterate=K}forEach(K){this.iterate(W=>(K(W),!0))}toArray(){const K=[];return this.iterate(W=>(K.push(W),!0)),K}filter(K){return new Ie(W=>this.iterate(a=>K(a)?W(a):!0))}map(K){return new Ie(W=>this.iterate(a=>W(K(a))))}some(K){let W=!1;return this.iterate(a=>(W=K(a),!W)),W}findFirst(K){let W;return this.iterate(a=>K(a)?(W=a,!1):!0),W}findLast(K){let W;return this.iterate(a=>(K(a)&&(W=a),!0)),W}findLastMaxBy(K){let W,a=!0;return this.iterate(o=>((a||he.isGreaterThan(K(o,W)))&&(a=!1,W=o),!0)),W}}t.$$b=Ie;class Ce{constructor(K){this.c=K}static createSortPermutation(K,W){const a=Array.from(K.keys()).sort((o,m)=>W(K[o],K[m]));return new Ce(a)}apply(K){return K.map((W,a)=>K[this.c[a]])}inverse(){const K=this.c.slice();for(let W=0;W<this.c.length;W++)K[this.c[W]]=W;return new Ce(K)}}t.$_b=Ce}),define(we[42],ve([1,0,6]),function(re,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ok=n,t.$dd=j,t.$ed=F,t.$fd=N,t.$gd=w,t.$hd=D;function n(c,p){if(!c)throw new Error(p?`Assertion failed (${p})`:"Assertion Failed")}function j(c,p="Unreachable"){throw new Error(p)}function F(c,p="unexpected state"){if(!c)throw new i.$bb(`Assertion Failed: ${p}`)}function N(c){c||(0,i.$Y)(new i.$bb("Soft Assertion Failed"))}function w(c){if(!c()){debugger;c(),(0,i.$Y)(new i.$bb("Assertion Failed"))}}function D(c,p){let y=0;for(;y<c.length-1;){const $=c[y],g=c[y+1];if(!p($,g))return!1;y++}return!0}});var Fi=this&&this.__createBinding||(Object.create?function(re,t,i,n){n===void 0&&(n=i);var j=Object.getOwnPropertyDescriptor(t,i);(!j||("get"in j?!t.__esModule:j.writable||j.configurable))&&(j={enumerable:!0,get:function(){return t[i]}}),Object.defineProperty(re,n,j)}:function(re,t,i,n){n===void 0&&(n=i),re[n]=t[i]}),Ri=this&&this.__setModuleDefault||(Object.create?function(re,t){Object.defineProperty(re,"default",{enumerable:!0,value:t})}:function(re,t){re.default=t}),He=this&&this.__importStar||function(re){if(re&&re.__esModule)return re;var t={};if(re!=null)for(var i in re)i!=="default"&&Object.prototype.hasOwnProperty.call(re,i)&&Fi(t,re,i);return Ri(t,re),t};define(we[30],ve([1,0,9]),function(re,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$5c=void 0,t.$6c=j,t.$7c=F,t.$8c=N,t.$9c=w,t.$0c=D,t.$$c=c,i=He(i);const n=(g,e)=>g===e;t.$5c=n;function j(g=t.$5c){return(e,s)=>i.$tb(e,s,g)}function F(){return(g,e)=>JSON.stringify(g)===JSON.stringify(e)}function N(){return(g,e)=>g.equals(e)}function w(g,e,s){if(s!==void 0){const r=g;return r==null||e===void 0||e===null?e===r:s(r,e)}else{const r=g;return(h,l)=>h==null||l===void 0||l===null?l===h:r(h,l)}}function D(g,e){if(g===e)return!0;if(Array.isArray(g)&&Array.isArray(e)){if(g.length!==e.length)return!1;for(let s=0;s<g.length;s++)if(!D(g[s],e[s]))return!1;return!0}if(g&&typeof g=="object"&&e&&typeof e=="object"&&Object.getPrototypeOf(g)===Object.prototype&&Object.getPrototypeOf(e)===Object.prototype){const s=g,r=e,h=Object.keys(s),l=Object.keys(r),v=new Set(l);if(h.length!==l.length)return!1;for(const k of h)if(!v.has(k)||!D(s[k],r[k]))return!1;return!0}return!1}function c(g){return JSON.stringify($(g))}let p=0;const y=new WeakMap;function $(g){if(Array.isArray(g))return g.map($);if(g&&typeof g=="object")if(Object.getPrototypeOf(g)===Object.prototype){const e=g,s=Object.create(null);for(const r of Object.keys(e).sort())s[r]=$(e[r]);return s}else{let e=y.get(g);return e===void 0&&(e=p++,y.set(g,e)),e+"----2b76a038c20c4bcc"}return g}}),define(we[58],ve([1,0]),function(re,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$cb=i;function i(n,j){const F=this;let N=!1,w;return function(){if(N)return w;if(N=!0,j)try{w=n.apply(F,arguments)}finally{j()}else w=n.apply(F,arguments);return w}}}),define(we[90],ve([1,0]),function(re,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$bQ=t.$aQ=void 0;class i{constructor(j){this.a=j,this.b=0}nextId(){return this.a+ ++this.b}}t.$aQ=i,t.$bQ=new i("id#")}),define(we[36],ve([1,0]),function(re,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Iterable=void 0;var i;(function(n){function j(f){return f&&typeof f=="object"&&typeof f[Symbol.iterator]=="function"}n.is=j;const F=Object.freeze([]);function N(){return F}n.empty=N;function*w(f){yield f}n.single=w;function D(f){return j(f)?f:w(f)}n.wrap=D;function c(f){return f||F}n.from=c;function*p(f){for(let b=f.length-1;b>=0;b--)yield f[b]}n.reverse=p;function y(f){return!f||f[Symbol.iterator]().next().done===!0}n.isEmpty=y;function $(f){return f[Symbol.iterator]().next().value}n.first=$;function g(f,b){let S=0;for(const U of f)if(b(U,S++))return!0;return!1}n.some=g;function e(f,b){for(const S of f)if(b(S))return S}n.find=e;function*s(f,b){for(const S of f)b(S)&&(yield S)}n.filter=s;function*r(f,b){let S=0;for(const U of f)yield b(U,S++)}n.map=r;function*h(f,b){let S=0;for(const U of f)yield*b(U,S++)}n.flatMap=h;function*l(...f){for(const b of f)yield*b}n.concat=l;function v(f,b,S){let U=S;for(const _ of f)U=b(U,_);return U}n.reduce=v;function*k(f,b,S=f.length){for(b<0&&(b+=f.length),S<0?S+=f.length:S>f.length&&(S=f.length);b<S;b++)yield f[b]}n.slice=k;function A(f,b=Number.POSITIVE_INFINITY){const S=[];if(b===0)return[S,f];const U=f[Symbol.iterator]();for(let _=0;_<b;_++){const B=U.next();if(B.done)return[S,n.empty()];S.push(B.value)}return[S,{[Symbol.iterator](){return U}}]}n.consume=A;async function d(f){const b=[];for await(const S of f)b.push(S);return Promise.resolve(b)}n.asyncToArray=d})(i||(t.Iterable=i={}))}),define(we[91],ve([1,0]),function(re,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$5j=i;function i(F){let N=!1;const w=new Map,D=new Map;if(j(F,s=>{if(F===s)return!0;const r=JSON.stringify(s);if(r.length<30)return!0;const h=w.get(r);if(!h){const l={schemas:[s]};return w.set(r,l),D.set(s,l),!0}return h.schemas.push(s),D.set(s,h),N=!0,!1}),w.clear(),!N)return JSON.stringify(F);let p="$defs";for(;F.hasOwnProperty(p);)p+="_";const y=[];function $(s){return JSON.stringify(s,(r,h)=>{if(h!==s){const l=D.get(h);if(l&&l.schemas.length>1)return l.id||(l.id=`_${y.length}`,y.push(l.schemas[0])),{$ref:`#/${p}/${l.id}`}}return h})}const g=$(F),e=[];for(let s=0;s<y.length;s++)e.push(`"_${s}":${$(y[s])}`);return e.length?`${g.substring(0,g.length-1)},"${p}":{${e.join(",")}}}`:g}function n(F){return typeof F=="object"&&F!==null}function j(F,N){if(!F||typeof F!="object")return;const w=(...g)=>{for(const e of g)n(e)&&y.push(e)},D=(...g)=>{for(const e of g)if(n(e))for(const s in e){const r=e[s];n(r)&&y.push(r)}},c=(...g)=>{for(const e of g)if(Array.isArray(e))for(const s of e)n(s)&&y.push(s)},p=g=>{if(Array.isArray(g))for(const e of g)n(e)&&y.push(e);else n(g)&&y.push(g)},y=[F];let $=y.pop();for(;$;)N($)&&(w($.additionalItems,$.additionalProperties,$.not,$.contains,$.propertyNames,$.if,$.then,$.else,$.unevaluatedItems,$.unevaluatedProperties),D($.definitions,$.$defs,$.properties,$.patternProperties,$.dependencies,$.dependentSchemas),c($.anyOf,$.allOf,$.oneOf,$.prefixItems),p($.items)),$=y.pop()}}),define(we[8],ve([1,0]),function(re,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.KeyMod=t.KeyCodeUtils=t.$Ur=t.$Tr=t.$Sr=t.$Rr=t.$Qr=t.ScanCode=t.KeyCode=void 0,t.$Vr=g;var i;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.Unknown=0]="Unknown",e[e.Backspace=1]="Backspace",e[e.Tab=2]="Tab",e[e.Enter=3]="Enter",e[e.Shift=4]="Shift",e[e.Ctrl=5]="Ctrl",e[e.Alt=6]="Alt",e[e.PauseBreak=7]="PauseBreak",e[e.CapsLock=8]="CapsLock",e[e.Escape=9]="Escape",e[e.Space=10]="Space",e[e.PageUp=11]="PageUp",e[e.PageDown=12]="PageDown",e[e.End=13]="End",e[e.Home=14]="Home",e[e.LeftArrow=15]="LeftArrow",e[e.UpArrow=16]="UpArrow",e[e.RightArrow=17]="RightArrow",e[e.DownArrow=18]="DownArrow",e[e.Insert=19]="Insert",e[e.Delete=20]="Delete",e[e.Digit0=21]="Digit0",e[e.Digit1=22]="Digit1",e[e.Digit2=23]="Digit2",e[e.Digit3=24]="Digit3",e[e.Digit4=25]="Digit4",e[e.Digit5=26]="Digit5",e[e.Digit6=27]="Digit6",e[e.Digit7=28]="Digit7",e[e.Digit8=29]="Digit8",e[e.Digit9=30]="Digit9",e[e.KeyA=31]="KeyA",e[e.KeyB=32]="KeyB",e[e.KeyC=33]="KeyC",e[e.KeyD=34]="KeyD",e[e.KeyE=35]="KeyE",e[e.KeyF=36]="KeyF",e[e.KeyG=37]="KeyG",e[e.KeyH=38]="KeyH",e[e.KeyI=39]="KeyI",e[e.KeyJ=40]="KeyJ",e[e.KeyK=41]="KeyK",e[e.KeyL=42]="KeyL",e[e.KeyM=43]="KeyM",e[e.KeyN=44]="KeyN",e[e.KeyO=45]="KeyO",e[e.KeyP=46]="KeyP",e[e.KeyQ=47]="KeyQ",e[e.KeyR=48]="KeyR",e[e.KeyS=49]="KeyS",e[e.KeyT=50]="KeyT",e[e.KeyU=51]="KeyU",e[e.KeyV=52]="KeyV",e[e.KeyW=53]="KeyW",e[e.KeyX=54]="KeyX",e[e.KeyY=55]="KeyY",e[e.KeyZ=56]="KeyZ",e[e.Meta=57]="Meta",e[e.ContextMenu=58]="ContextMenu",e[e.F1=59]="F1",e[e.F2=60]="F2",e[e.F3=61]="F3",e[e.F4=62]="F4",e[e.F5=63]="F5",e[e.F6=64]="F6",e[e.F7=65]="F7",e[e.F8=66]="F8",e[e.F9=67]="F9",e[e.F10=68]="F10",e[e.F11=69]="F11",e[e.F12=70]="F12",e[e.F13=71]="F13",e[e.F14=72]="F14",e[e.F15=73]="F15",e[e.F16=74]="F16",e[e.F17=75]="F17",e[e.F18=76]="F18",e[e.F19=77]="F19",e[e.F20=78]="F20",e[e.F21=79]="F21",e[e.F22=80]="F22",e[e.F23=81]="F23",e[e.F24=82]="F24",e[e.NumLock=83]="NumLock",e[e.ScrollLock=84]="ScrollLock",e[e.Semicolon=85]="Semicolon",e[e.Equal=86]="Equal",e[e.Comma=87]="Comma",e[e.Minus=88]="Minus",e[e.Period=89]="Period",e[e.Slash=90]="Slash",e[e.Backquote=91]="Backquote",e[e.BracketLeft=92]="BracketLeft",e[e.Backslash=93]="Backslash",e[e.BracketRight=94]="BracketRight",e[e.Quote=95]="Quote",e[e.OEM_8=96]="OEM_8",e[e.IntlBackslash=97]="IntlBackslash",e[e.Numpad0=98]="Numpad0",e[e.Numpad1=99]="Numpad1",e[e.Numpad2=100]="Numpad2",e[e.Numpad3=101]="Numpad3",e[e.Numpad4=102]="Numpad4",e[e.Numpad5=103]="Numpad5",e[e.Numpad6=104]="Numpad6",e[e.Numpad7=105]="Numpad7",e[e.Numpad8=106]="Numpad8",e[e.Numpad9=107]="Numpad9",e[e.NumpadMultiply=108]="NumpadMultiply",e[e.NumpadAdd=109]="NumpadAdd",e[e.NUMPAD_SEPARATOR=110]="NUMPAD_SEPARATOR",e[e.NumpadSubtract=111]="NumpadSubtract",e[e.NumpadDecimal=112]="NumpadDecimal",e[e.NumpadDivide=113]="NumpadDivide",e[e.KEY_IN_COMPOSITION=114]="KEY_IN_COMPOSITION",e[e.ABNT_C1=115]="ABNT_C1",e[e.ABNT_C2=116]="ABNT_C2",e[e.AudioVolumeMute=117]="AudioVolumeMute",e[e.AudioVolumeUp=118]="AudioVolumeUp",e[e.AudioVolumeDown=119]="AudioVolumeDown",e[e.BrowserSearch=120]="BrowserSearch",e[e.BrowserHome=121]="BrowserHome",e[e.BrowserBack=122]="BrowserBack",e[e.BrowserForward=123]="BrowserForward",e[e.MediaTrackNext=124]="MediaTrackNext",e[e.MediaTrackPrevious=125]="MediaTrackPrevious",e[e.MediaStop=126]="MediaStop",e[e.MediaPlayPause=127]="MediaPlayPause",e[e.LaunchMediaPlayer=128]="LaunchMediaPlayer",e[e.LaunchMail=129]="LaunchMail",e[e.LaunchApp2=130]="LaunchApp2",e[e.Clear=131]="Clear",e[e.MAX_VALUE=132]="MAX_VALUE"})(i||(t.KeyCode=i={}));var n;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.None=0]="None",e[e.Hyper=1]="Hyper",e[e.Super=2]="Super",e[e.Fn=3]="Fn",e[e.FnLock=4]="FnLock",e[e.Suspend=5]="Suspend",e[e.Resume=6]="Resume",e[e.Turbo=7]="Turbo",e[e.Sleep=8]="Sleep",e[e.WakeUp=9]="WakeUp",e[e.KeyA=10]="KeyA",e[e.KeyB=11]="KeyB",e[e.KeyC=12]="KeyC",e[e.KeyD=13]="KeyD",e[e.KeyE=14]="KeyE",e[e.KeyF=15]="KeyF",e[e.KeyG=16]="KeyG",e[e.KeyH=17]="KeyH",e[e.KeyI=18]="KeyI",e[e.KeyJ=19]="KeyJ",e[e.KeyK=20]="KeyK",e[e.KeyL=21]="KeyL",e[e.KeyM=22]="KeyM",e[e.KeyN=23]="KeyN",e[e.KeyO=24]="KeyO",e[e.KeyP=25]="KeyP",e[e.KeyQ=26]="KeyQ",e[e.KeyR=27]="KeyR",e[e.KeyS=28]="KeyS",e[e.KeyT=29]="KeyT",e[e.KeyU=30]="KeyU",e[e.KeyV=31]="KeyV",e[e.KeyW=32]="KeyW",e[e.KeyX=33]="KeyX",e[e.KeyY=34]="KeyY",e[e.KeyZ=35]="KeyZ",e[e.Digit1=36]="Digit1",e[e.Digit2=37]="Digit2",e[e.Digit3=38]="Digit3",e[e.Digit4=39]="Digit4",e[e.Digit5=40]="Digit5",e[e.Digit6=41]="Digit6",e[e.Digit7=42]="Digit7",e[e.Digit8=43]="Digit8",e[e.Digit9=44]="Digit9",e[e.Digit0=45]="Digit0",e[e.Enter=46]="Enter",e[e.Escape=47]="Escape",e[e.Backspace=48]="Backspace",e[e.Tab=49]="Tab",e[e.Space=50]="Space",e[e.Minus=51]="Minus",e[e.Equal=52]="Equal",e[e.BracketLeft=53]="BracketLeft",e[e.BracketRight=54]="BracketRight",e[e.Backslash=55]="Backslash",e[e.IntlHash=56]="IntlHash",e[e.Semicolon=57]="Semicolon",e[e.Quote=58]="Quote",e[e.Backquote=59]="Backquote",e[e.Comma=60]="Comma",e[e.Period=61]="Period",e[e.Slash=62]="Slash",e[e.CapsLock=63]="CapsLock",e[e.F1=64]="F1",e[e.F2=65]="F2",e[e.F3=66]="F3",e[e.F4=67]="F4",e[e.F5=68]="F5",e[e.F6=69]="F6",e[e.F7=70]="F7",e[e.F8=71]="F8",e[e.F9=72]="F9",e[e.F10=73]="F10",e[e.F11=74]="F11",e[e.F12=75]="F12",e[e.PrintScreen=76]="PrintScreen",e[e.ScrollLock=77]="ScrollLock",e[e.Pause=78]="Pause",e[e.Insert=79]="Insert",e[e.Home=80]="Home",e[e.PageUp=81]="PageUp",e[e.Delete=82]="Delete",e[e.End=83]="End",e[e.PageDown=84]="PageDown",e[e.ArrowRight=85]="ArrowRight",e[e.ArrowLeft=86]="ArrowLeft",e[e.ArrowDown=87]="ArrowDown",e[e.ArrowUp=88]="ArrowUp",e[e.NumLock=89]="NumLock",e[e.NumpadDivide=90]="NumpadDivide",e[e.NumpadMultiply=91]="NumpadMultiply",e[e.NumpadSubtract=92]="NumpadSubtract",e[e.NumpadAdd=93]="NumpadAdd",e[e.NumpadEnter=94]="NumpadEnter",e[e.Numpad1=95]="Numpad1",e[e.Numpad2=96]="Numpad2",e[e.Numpad3=97]="Numpad3",e[e.Numpad4=98]="Numpad4",e[e.Numpad5=99]="Numpad5",e[e.Numpad6=100]="Numpad6",e[e.Numpad7=101]="Numpad7",e[e.Numpad8=102]="Numpad8",e[e.Numpad9=103]="Numpad9",e[e.Numpad0=104]="Numpad0",e[e.NumpadDecimal=105]="NumpadDecimal",e[e.IntlBackslash=106]="IntlBackslash",e[e.ContextMenu=107]="ContextMenu",e[e.Power=108]="Power",e[e.NumpadEqual=109]="NumpadEqual",e[e.F13=110]="F13",e[e.F14=111]="F14",e[e.F15=112]="F15",e[e.F16=113]="F16",e[e.F17=114]="F17",e[e.F18=115]="F18",e[e.F19=116]="F19",e[e.F20=117]="F20",e[e.F21=118]="F21",e[e.F22=119]="F22",e[e.F23=120]="F23",e[e.F24=121]="F24",e[e.Open=122]="Open",e[e.Help=123]="Help",e[e.Select=124]="Select",e[e.Again=125]="Again",e[e.Undo=126]="Undo",e[e.Cut=127]="Cut",e[e.Copy=128]="Copy",e[e.Paste=129]="Paste",e[e.Find=130]="Find",e[e.AudioVolumeMute=131]="AudioVolumeMute",e[e.AudioVolumeUp=132]="AudioVolumeUp",e[e.AudioVolumeDown=133]="AudioVolumeDown",e[e.NumpadComma=134]="NumpadComma",e[e.IntlRo=135]="IntlRo",e[e.KanaMode=136]="KanaMode",e[e.IntlYen=137]="IntlYen",e[e.Convert=138]="Convert",e[e.NonConvert=139]="NonConvert",e[e.Lang1=140]="Lang1",e[e.Lang2=141]="Lang2",e[e.Lang3=142]="Lang3",e[e.Lang4=143]="Lang4",e[e.Lang5=144]="Lang5",e[e.Abort=145]="Abort",e[e.Props=146]="Props",e[e.NumpadParenLeft=147]="NumpadParenLeft",e[e.NumpadParenRight=148]="NumpadParenRight",e[e.NumpadBackspace=149]="NumpadBackspace",e[e.NumpadMemoryStore=150]="NumpadMemoryStore",e[e.NumpadMemoryRecall=151]="NumpadMemoryRecall",e[e.NumpadMemoryClear=152]="NumpadMemoryClear",e[e.NumpadMemoryAdd=153]="NumpadMemoryAdd",e[e.NumpadMemorySubtract=154]="NumpadMemorySubtract",e[e.NumpadClear=155]="NumpadClear",e[e.NumpadClearEntry=156]="NumpadClearEntry",e[e.ControlLeft=157]="ControlLeft",e[e.ShiftLeft=158]="ShiftLeft",e[e.AltLeft=159]="AltLeft",e[e.MetaLeft=160]="MetaLeft",e[e.ControlRight=161]="ControlRight",e[e.ShiftRight=162]="ShiftRight",e[e.AltRight=163]="AltRight",e[e.MetaRight=164]="MetaRight",e[e.BrightnessUp=165]="BrightnessUp",e[e.BrightnessDown=166]="BrightnessDown",e[e.MediaPlay=167]="MediaPlay",e[e.MediaRecord=168]="MediaRecord",e[e.MediaFastForward=169]="MediaFastForward",e[e.MediaRewind=170]="MediaRewind",e[e.MediaTrackNext=171]="MediaTrackNext",e[e.MediaTrackPrevious=172]="MediaTrackPrevious",e[e.MediaStop=173]="MediaStop",e[e.Eject=174]="Eject",e[e.MediaPlayPause=175]="MediaPlayPause",e[e.MediaSelect=176]="MediaSelect",e[e.LaunchMail=177]="LaunchMail",e[e.LaunchApp2=178]="LaunchApp2",e[e.LaunchApp1=179]="LaunchApp1",e[e.SelectTask=180]="SelectTask",e[e.LaunchScreenSaver=181]="LaunchScreenSaver",e[e.BrowserSearch=182]="BrowserSearch",e[e.BrowserHome=183]="BrowserHome",e[e.BrowserBack=184]="BrowserBack",e[e.BrowserForward=185]="BrowserForward",e[e.BrowserStop=186]="BrowserStop",e[e.BrowserRefresh=187]="BrowserRefresh",e[e.BrowserFavorites=188]="BrowserFavorites",e[e.ZoomToggle=189]="ZoomToggle",e[e.MailReply=190]="MailReply",e[e.MailForward=191]="MailForward",e[e.MailSend=192]="MailSend",e[e.MAX_VALUE=193]="MAX_VALUE"})(n||(t.ScanCode=n={}));class j{constructor(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}define(s,r){this._keyCodeToStr[s]=r,this._strToKeyCode[r.toLowerCase()]=s}keyCodeToStr(s){return this._keyCodeToStr[s]}strToKeyCode(s){return this._strToKeyCode[s.toLowerCase()]||i.Unknown}}const F=new j,N=new j,w=new j;t.$Qr=new Array(230),t.$Rr={};const D=[],c=Object.create(null),p=Object.create(null);t.$Sr={lowerCaseToEnum:e=>p[e]||n.None,toEnum:e=>c[e]||n.None,toString:e=>D[e]||"None"},t.$Tr=[],t.$Ur=[];for(let e=0;e<=n.MAX_VALUE;e++)t.$Tr[e]=i.DependsOnKbLayout;for(let e=0;e<=i.MAX_VALUE;e++)t.$Ur[e]=n.DependsOnKbLayout;(function(){const e="",s=[[1,n.None,"None",i.Unknown,"unknown",0,"VK_UNKNOWN",e,e],[1,n.Hyper,"Hyper",i.Unknown,e,0,e,e,e],[1,n.Super,"Super",i.Unknown,e,0,e,e,e],[1,n.Fn,"Fn",i.Unknown,e,0,e,e,e],[1,n.FnLock,"FnLock",i.Unknown,e,0,e,e,e],[1,n.Suspend,"Suspend",i.Unknown,e,0,e,e,e],[1,n.Resume,"Resume",i.Unknown,e,0,e,e,e],[1,n.Turbo,"Turbo",i.Unknown,e,0,e,e,e],[1,n.Sleep,"Sleep",i.Unknown,e,0,"VK_SLEEP",e,e],[1,n.WakeUp,"WakeUp",i.Unknown,e,0,e,e,e],[0,n.KeyA,"KeyA",i.KeyA,"A",65,"VK_A",e,e],[0,n.KeyB,"KeyB",i.KeyB,"B",66,"VK_B",e,e],[0,n.KeyC,"KeyC",i.KeyC,"C",67,"VK_C",e,e],[0,n.KeyD,"KeyD",i.KeyD,"D",68,"VK_D",e,e],[0,n.KeyE,"KeyE",i.KeyE,"E",69,"VK_E",e,e],[0,n.KeyF,"KeyF",i.KeyF,"F",70,"VK_F",e,e],[0,n.KeyG,"KeyG",i.KeyG,"G",71,"VK_G",e,e],[0,n.KeyH,"KeyH",i.KeyH,"H",72,"VK_H",e,e],[0,n.KeyI,"KeyI",i.KeyI,"I",73,"VK_I",e,e],[0,n.KeyJ,"KeyJ",i.KeyJ,"J",74,"VK_J",e,e],[0,n.KeyK,"KeyK",i.KeyK,"K",75,"VK_K",e,e],[0,n.KeyL,"KeyL",i.KeyL,"L",76,"VK_L",e,e],[0,n.KeyM,"KeyM",i.KeyM,"M",77,"VK_M",e,e],[0,n.KeyN,"KeyN",i.KeyN,"N",78,"VK_N",e,e],[0,n.KeyO,"KeyO",i.KeyO,"O",79,"VK_O",e,e],[0,n.KeyP,"KeyP",i.KeyP,"P",80,"VK_P",e,e],[0,n.KeyQ,"KeyQ",i.KeyQ,"Q",81,"VK_Q",e,e],[0,n.KeyR,"KeyR",i.KeyR,"R",82,"VK_R",e,e],[0,n.KeyS,"KeyS",i.KeyS,"S",83,"VK_S",e,e],[0,n.KeyT,"KeyT",i.KeyT,"T",84,"VK_T",e,e],[0,n.KeyU,"KeyU",i.KeyU,"U",85,"VK_U",e,e],[0,n.KeyV,"KeyV",i.KeyV,"V",86,"VK_V",e,e],[0,n.KeyW,"KeyW",i.KeyW,"W",87,"VK_W",e,e],[0,n.KeyX,"KeyX",i.KeyX,"X",88,"VK_X",e,e],[0,n.KeyY,"KeyY",i.KeyY,"Y",89,"VK_Y",e,e],[0,n.KeyZ,"KeyZ",i.KeyZ,"Z",90,"VK_Z",e,e],[0,n.Digit1,"Digit1",i.Digit1,"1",49,"VK_1",e,e],[0,n.Digit2,"Digit2",i.Digit2,"2",50,"VK_2",e,e],[0,n.Digit3,"Digit3",i.Digit3,"3",51,"VK_3",e,e],[0,n.Digit4,"Digit4",i.Digit4,"4",52,"VK_4",e,e],[0,n.Digit5,"Digit5",i.Digit5,"5",53,"VK_5",e,e],[0,n.Digit6,"Digit6",i.Digit6,"6",54,"VK_6",e,e],[0,n.Digit7,"Digit7",i.Digit7,"7",55,"VK_7",e,e],[0,n.Digit8,"Digit8",i.Digit8,"8",56,"VK_8",e,e],[0,n.Digit9,"Digit9",i.Digit9,"9",57,"VK_9",e,e],[0,n.Digit0,"Digit0",i.Digit0,"0",48,"VK_0",e,e],[1,n.Enter,"Enter",i.Enter,"Enter",13,"VK_RETURN",e,e],[1,n.Escape,"Escape",i.Escape,"Escape",27,"VK_ESCAPE",e,e],[1,n.Backspace,"Backspace",i.Backspace,"Backspace",8,"VK_BACK",e,e],[1,n.Tab,"Tab",i.Tab,"Tab",9,"VK_TAB",e,e],[1,n.Space,"Space",i.Space,"Space",32,"VK_SPACE",e,e],[0,n.Minus,"Minus",i.Minus,"-",189,"VK_OEM_MINUS","-","OEM_MINUS"],[0,n.Equal,"Equal",i.Equal,"=",187,"VK_OEM_PLUS","=","OEM_PLUS"],[0,n.BracketLeft,"BracketLeft",i.BracketLeft,"[",219,"VK_OEM_4","[","OEM_4"],[0,n.BracketRight,"BracketRight",i.BracketRight,"]",221,"VK_OEM_6","]","OEM_6"],[0,n.Backslash,"Backslash",i.Backslash,"\\",220,"VK_OEM_5","\\","OEM_5"],[0,n.IntlHash,"IntlHash",i.Unknown,e,0,e,e,e],[0,n.Semicolon,"Semicolon",i.Semicolon,";",186,"VK_OEM_1",";","OEM_1"],[0,n.Quote,"Quote",i.Quote,"'",222,"VK_OEM_7","'","OEM_7"],[0,n.Backquote,"Backquote",i.Backquote,"`",192,"VK_OEM_3","`","OEM_3"],[0,n.Comma,"Comma",i.Comma,",",188,"VK_OEM_COMMA",",","OEM_COMMA"],[0,n.Period,"Period",i.Period,".",190,"VK_OEM_PERIOD",".","OEM_PERIOD"],[0,n.Slash,"Slash",i.Slash,"/",191,"VK_OEM_2","/","OEM_2"],[1,n.CapsLock,"CapsLock",i.CapsLock,"CapsLock",20,"VK_CAPITAL",e,e],[1,n.F1,"F1",i.F1,"F1",112,"VK_F1",e,e],[1,n.F2,"F2",i.F2,"F2",113,"VK_F2",e,e],[1,n.F3,"F3",i.F3,"F3",114,"VK_F3",e,e],[1,n.F4,"F4",i.F4,"F4",115,"VK_F4",e,e],[1,n.F5,"F5",i.F5,"F5",116,"VK_F5",e,e],[1,n.F6,"F6",i.F6,"F6",117,"VK_F6",e,e],[1,n.F7,"F7",i.F7,"F7",118,"VK_F7",e,e],[1,n.F8,"F8",i.F8,"F8",119,"VK_F8",e,e],[1,n.F9,"F9",i.F9,"F9",120,"VK_F9",e,e],[1,n.F10,"F10",i.F10,"F10",121,"VK_F10",e,e],[1,n.F11,"F11",i.F11,"F11",122,"VK_F11",e,e],[1,n.F12,"F12",i.F12,"F12",123,"VK_F12",e,e],[1,n.PrintScreen,"PrintScreen",i.Unknown,e,0,e,e,e],[1,n.ScrollLock,"ScrollLock",i.ScrollLock,"ScrollLock",145,"VK_SCROLL",e,e],[1,n.Pause,"Pause",i.PauseBreak,"PauseBreak",19,"VK_PAUSE",e,e],[1,n.Insert,"Insert",i.Insert,"Insert",45,"VK_INSERT",e,e],[1,n.Home,"Home",i.Home,"Home",36,"VK_HOME",e,e],[1,n.PageUp,"PageUp",i.PageUp,"PageUp",33,"VK_PRIOR",e,e],[1,n.Delete,"Delete",i.Delete,"Delete",46,"VK_DELETE",e,e],[1,n.End,"End",i.End,"End",35,"VK_END",e,e],[1,n.PageDown,"PageDown",i.PageDown,"PageDown",34,"VK_NEXT",e,e],[1,n.ArrowRight,"ArrowRight",i.RightArrow,"RightArrow",39,"VK_RIGHT","Right",e],[1,n.ArrowLeft,"ArrowLeft",i.LeftArrow,"LeftArrow",37,"VK_LEFT","Left",e],[1,n.ArrowDown,"ArrowDown",i.DownArrow,"DownArrow",40,"VK_DOWN","Down",e],[1,n.ArrowUp,"ArrowUp",i.UpArrow,"UpArrow",38,"VK_UP","Up",e],[1,n.NumLock,"NumLock",i.NumLock,"NumLock",144,"VK_NUMLOCK",e,e],[1,n.NumpadDivide,"NumpadDivide",i.NumpadDivide,"NumPad_Divide",111,"VK_DIVIDE",e,e],[1,n.NumpadMultiply,"NumpadMultiply",i.NumpadMultiply,"NumPad_Multiply",106,"VK_MULTIPLY",e,e],[1,n.NumpadSubtract,"NumpadSubtract",i.NumpadSubtract,"NumPad_Subtract",109,"VK_SUBTRACT",e,e],[1,n.NumpadAdd,"NumpadAdd",i.NumpadAdd,"NumPad_Add",107,"VK_ADD",e,e],[1,n.NumpadEnter,"NumpadEnter",i.Enter,e,0,e,e,e],[1,n.Numpad1,"Numpad1",i.Numpad1,"NumPad1",97,"VK_NUMPAD1",e,e],[1,n.Numpad2,"Numpad2",i.Numpad2,"NumPad2",98,"VK_NUMPAD2",e,e],[1,n.Numpad3,"Numpad3",i.Numpad3,"NumPad3",99,"VK_NUMPAD3",e,e],[1,n.Numpad4,"Numpad4",i.Numpad4,"NumPad4",100,"VK_NUMPAD4",e,e],[1,n.Numpad5,"Numpad5",i.Numpad5,"NumPad5",101,"VK_NUMPAD5",e,e],[1,n.Numpad6,"Numpad6",i.Numpad6,"NumPad6",102,"VK_NUMPAD6",e,e],[1,n.Numpad7,"Numpad7",i.Numpad7,"NumPad7",103,"VK_NUMPAD7",e,e],[1,n.Numpad8,"Numpad8",i.Numpad8,"NumPad8",104,"VK_NUMPAD8",e,e],[1,n.Numpad9,"Numpad9",i.Numpad9,"NumPad9",105,"VK_NUMPAD9",e,e],[1,n.Numpad0,"Numpad0",i.Numpad0,"NumPad0",96,"VK_NUMPAD0",e,e],[1,n.NumpadDecimal,"NumpadDecimal",i.NumpadDecimal,"NumPad_Decimal",110,"VK_DECIMAL",e,e],[0,n.IntlBackslash,"IntlBackslash",i.IntlBackslash,"OEM_102",226,"VK_OEM_102",e,e],[1,n.ContextMenu,"ContextMenu",i.ContextMenu,"ContextMenu",93,e,e,e],[1,n.Power,"Power",i.Unknown,e,0,e,e,e],[1,n.NumpadEqual,"NumpadEqual",i.Unknown,e,0,e,e,e],[1,n.F13,"F13",i.F13,"F13",124,"VK_F13",e,e],[1,n.F14,"F14",i.F14,"F14",125,"VK_F14",e,e],[1,n.F15,"F15",i.F15,"F15",126,"VK_F15",e,e],[1,n.F16,"F16",i.F16,"F16",127,"VK_F16",e,e],[1,n.F17,"F17",i.F17,"F17",128,"VK_F17",e,e],[1,n.F18,"F18",i.F18,"F18",129,"VK_F18",e,e],[1,n.F19,"F19",i.F19,"F19",130,"VK_F19",e,e],[1,n.F20,"F20",i.F20,"F20",131,"VK_F20",e,e],[1,n.F21,"F21",i.F21,"F21",132,"VK_F21",e,e],[1,n.F22,"F22",i.F22,"F22",133,"VK_F22",e,e],[1,n.F23,"F23",i.F23,"F23",134,"VK_F23",e,e],[1,n.F24,"F24",i.F24,"F24",135,"VK_F24",e,e],[1,n.Open,"Open",i.Unknown,e,0,e,e,e],[1,n.Help,"Help",i.Unknown,e,0,e,e,e],[1,n.Select,"Select",i.Unknown,e,0,e,e,e],[1,n.Again,"Again",i.Unknown,e,0,e,e,e],[1,n.Undo,"Undo",i.Unknown,e,0,e,e,e],[1,n.Cut,"Cut",i.Unknown,e,0,e,e,e],[1,n.Copy,"Copy",i.Unknown,e,0,e,e,e],[1,n.Paste,"Paste",i.Unknown,e,0,e,e,e],[1,n.Find,"Find",i.Unknown,e,0,e,e,e],[1,n.AudioVolumeMute,"AudioVolumeMute",i.AudioVolumeMute,"AudioVolumeMute",173,"VK_VOLUME_MUTE",e,e],[1,n.AudioVolumeUp,"AudioVolumeUp",i.AudioVolumeUp,"AudioVolumeUp",175,"VK_VOLUME_UP",e,e],[1,n.AudioVolumeDown,"AudioVolumeDown",i.AudioVolumeDown,"AudioVolumeDown",174,"VK_VOLUME_DOWN",e,e],[1,n.NumpadComma,"NumpadComma",i.NUMPAD_SEPARATOR,"NumPad_Separator",108,"VK_SEPARATOR",e,e],[0,n.IntlRo,"IntlRo",i.ABNT_C1,"ABNT_C1",193,"VK_ABNT_C1",e,e],[1,n.KanaMode,"KanaMode",i.Unknown,e,0,e,e,e],[0,n.IntlYen,"IntlYen",i.Unknown,e,0,e,e,e],[1,n.Convert,"Convert",i.Unknown,e,0,e,e,e],[1,n.NonConvert,"NonConvert",i.Unknown,e,0,e,e,e],[1,n.Lang1,"Lang1",i.Unknown,e,0,e,e,e],[1,n.Lang2,"Lang2",i.Unknown,e,0,e,e,e],[1,n.Lang3,"Lang3",i.Unknown,e,0,e,e,e],[1,n.Lang4,"Lang4",i.Unknown,e,0,e,e,e],[1,n.Lang5,"Lang5",i.Unknown,e,0,e,e,e],[1,n.Abort,"Abort",i.Unknown,e,0,e,e,e],[1,n.Props,"Props",i.Unknown,e,0,e,e,e],[1,n.NumpadParenLeft,"NumpadParenLeft",i.Unknown,e,0,e,e,e],[1,n.NumpadParenRight,"NumpadParenRight",i.Unknown,e,0,e,e,e],[1,n.NumpadBackspace,"NumpadBackspace",i.Unknown,e,0,e,e,e],[1,n.NumpadMemoryStore,"NumpadMemoryStore",i.Unknown,e,0,e,e,e],[1,n.NumpadMemoryRecall,"NumpadMemoryRecall",i.Unknown,e,0,e,e,e],[1,n.NumpadMemoryClear,"NumpadMemoryClear",i.Unknown,e,0,e,e,e],[1,n.NumpadMemoryAdd,"NumpadMemoryAdd",i.Unknown,e,0,e,e,e],[1,n.NumpadMemorySubtract,"NumpadMemorySubtract",i.Unknown,e,0,e,e,e],[1,n.NumpadClear,"NumpadClear",i.Clear,"Clear",12,"VK_CLEAR",e,e],[1,n.NumpadClearEntry,"NumpadClearEntry",i.Unknown,e,0,e,e,e],[1,n.None,e,i.Ctrl,"Ctrl",17,"VK_CONTROL",e,e],[1,n.None,e,i.Shift,"Shift",16,"VK_SHIFT",e,e],[1,n.None,e,i.Alt,"Alt",18,"VK_MENU",e,e],[1,n.None,e,i.Meta,"Meta",91,"VK_COMMAND",e,e],[1,n.ControlLeft,"ControlLeft",i.Ctrl,e,0,"VK_LCONTROL",e,e],[1,n.ShiftLeft,"ShiftLeft",i.Shift,e,0,"VK_LSHIFT",e,e],[1,n.AltLeft,"AltLeft",i.Alt,e,0,"VK_LMENU",e,e],[1,n.MetaLeft,"MetaLeft",i.Meta,e,0,"VK_LWIN",e,e],[1,n.ControlRight,"ControlRight",i.Ctrl,e,0,"VK_RCONTROL",e,e],[1,n.ShiftRight,"ShiftRight",i.Shift,e,0,"VK_RSHIFT",e,e],[1,n.AltRight,"AltRight",i.Alt,e,0,"VK_RMENU",e,e],[1,n.MetaRight,"MetaRight",i.Meta,e,0,"VK_RWIN",e,e],[1,n.BrightnessUp,"BrightnessUp",i.Unknown,e,0,e,e,e],[1,n.BrightnessDown,"BrightnessDown",i.Unknown,e,0,e,e,e],[1,n.MediaPlay,"MediaPlay",i.Unknown,e,0,e,e,e],[1,n.MediaRecord,"MediaRecord",i.Unknown,e,0,e,e,e],[1,n.MediaFastForward,"MediaFastForward",i.Unknown,e,0,e,e,e],[1,n.MediaRewind,"MediaRewind",i.Unknown,e,0,e,e,e],[1,n.MediaTrackNext,"MediaTrackNext",i.MediaTrackNext,"MediaTrackNext",176,"VK_MEDIA_NEXT_TRACK",e,e],[1,n.MediaTrackPrevious,"MediaTrackPrevious",i.MediaTrackPrevious,"MediaTrackPrevious",177,"VK_MEDIA_PREV_TRACK",e,e],[1,n.MediaStop,"MediaStop",i.MediaStop,"MediaStop",178,"VK_MEDIA_STOP",e,e],[1,n.Eject,"Eject",i.Unknown,e,0,e,e,e],[1,n.MediaPlayPause,"MediaPlayPause",i.MediaPlayPause,"MediaPlayPause",179,"VK_MEDIA_PLAY_PAUSE",e,e],[1,n.MediaSelect,"MediaSelect",i.LaunchMediaPlayer,"LaunchMediaPlayer",181,"VK_MEDIA_LAUNCH_MEDIA_SELECT",e,e],[1,n.LaunchMail,"LaunchMail",i.LaunchMail,"LaunchMail",180,"VK_MEDIA_LAUNCH_MAIL",e,e],[1,n.LaunchApp2,"LaunchApp2",i.LaunchApp2,"LaunchApp2",183,"VK_MEDIA_LAUNCH_APP2",e,e],[1,n.LaunchApp1,"LaunchApp1",i.Unknown,e,0,"VK_MEDIA_LAUNCH_APP1",e,e],[1,n.SelectTask,"SelectTask",i.Unknown,e,0,e,e,e],[1,n.LaunchScreenSaver,"LaunchScreenSaver",i.Unknown,e,0,e,e,e],[1,n.BrowserSearch,"BrowserSearch",i.BrowserSearch,"BrowserSearch",170,"VK_BROWSER_SEARCH",e,e],[1,n.BrowserHome,"BrowserHome",i.BrowserHome,"BrowserHome",172,"VK_BROWSER_HOME",e,e],[1,n.BrowserBack,"BrowserBack",i.BrowserBack,"BrowserBack",166,"VK_BROWSER_BACK",e,e],[1,n.BrowserForward,"BrowserForward",i.BrowserForward,"BrowserForward",167,"VK_BROWSER_FORWARD",e,e],[1,n.BrowserStop,"BrowserStop",i.Unknown,e,0,"VK_BROWSER_STOP",e,e],[1,n.BrowserRefresh,"BrowserRefresh",i.Unknown,e,0,"VK_BROWSER_REFRESH",e,e],[1,n.BrowserFavorites,"BrowserFavorites",i.Unknown,e,0,"VK_BROWSER_FAVORITES",e,e],[1,n.ZoomToggle,"ZoomToggle",i.Unknown,e,0,e,e,e],[1,n.MailReply,"MailReply",i.Unknown,e,0,e,e,e],[1,n.MailForward,"MailForward",i.Unknown,e,0,e,e,e],[1,n.MailSend,"MailSend",i.Unknown,e,0,e,e,e],[1,n.None,e,i.KEY_IN_COMPOSITION,"KeyInComposition",229,e,e,e],[1,n.None,e,i.ABNT_C2,"ABNT_C2",194,"VK_ABNT_C2",e,e],[1,n.None,e,i.OEM_8,"OEM_8",223,"VK_OEM_8",e,e],[1,n.None,e,i.Unknown,e,0,"VK_KANA",e,e],[1,n.None,e,i.Unknown,e,0,"VK_HANGUL",e,e],[1,n.None,e,i.Unknown,e,0,"VK_JUNJA",e,e],[1,n.None,e,i.Unknown,e,0,"VK_FINAL",e,e],[1,n.None,e,i.Unknown,e,0,"VK_HANJA",e,e],[1,n.None,e,i.Unknown,e,0,"VK_KANJI",e,e],[1,n.None,e,i.Unknown,e,0,"VK_CONVERT",e,e],[1,n.None,e,i.Unknown,e,0,"VK_NONCONVERT",e,e],[1,n.None,e,i.Unknown,e,0,"VK_ACCEPT",e,e],[1,n.None,e,i.Unknown,e,0,"VK_MODECHANGE",e,e],[1,n.None,e,i.Unknown,e,0,"VK_SELECT",e,e],[1,n.None,e,i.Unknown,e,0,"VK_PRINT",e,e],[1,n.None,e,i.Unknown,e,0,"VK_EXECUTE",e,e],[1,n.None,e,i.Unknown,e,0,"VK_SNAPSHOT",e,e],[1,n.None,e,i.Unknown,e,0,"VK_HELP",e,e],[1,n.None,e,i.Unknown,e,0,"VK_APPS",e,e],[1,n.None,e,i.Unknown,e,0,"VK_PROCESSKEY",e,e],[1,n.None,e,i.Unknown,e,0,"VK_PACKET",e,e],[1,n.None,e,i.Unknown,e,0,"VK_DBE_SBCSCHAR",e,e],[1,n.None,e,i.Unknown,e,0,"VK_DBE_DBCSCHAR",e,e],[1,n.None,e,i.Unknown,e,0,"VK_ATTN",e,e],[1,n.None,e,i.Unknown,e,0,"VK_CRSEL",e,e],[1,n.None,e,i.Unknown,e,0,"VK_EXSEL",e,e],[1,n.None,e,i.Unknown,e,0,"VK_EREOF",e,e],[1,n.None,e,i.Unknown,e,0,"VK_PLAY",e,e],[1,n.None,e,i.Unknown,e,0,"VK_ZOOM",e,e],[1,n.None,e,i.Unknown,e,0,"VK_NONAME",e,e],[1,n.None,e,i.Unknown,e,0,"VK_PA1",e,e],[1,n.None,e,i.Unknown,e,0,"VK_OEM_CLEAR",e,e]],r=[],h=[];for(const l of s){const[v,k,A,d,f,b,S,U,_]=l;if(h[k]||(h[k]=!0,D[k]=A,c[A]=k,p[A.toLowerCase()]=k,v&&(t.$Tr[k]=d,d!==i.Unknown&&d!==i.Enter&&d!==i.Ctrl&&d!==i.Shift&&d!==i.Alt&&d!==i.Meta&&(t.$Ur[d]=k))),!r[d]){if(r[d]=!0,!f)throw new Error(`String representation missing for key code ${d} around scan code ${A}`);F.define(d,f),N.define(d,U||f),w.define(d,_||U||f)}b&&(t.$Qr[b]=d),S&&(t.$Rr[S]=d)}t.$Ur[i.Enter]=n.Enter})();var y;(function(e){function s(A){return F.keyCodeToStr(A)}e.toString=s;function r(A){return F.strToKeyCode(A)}e.fromString=r;function h(A){return N.keyCodeToStr(A)}e.toUserSettingsUS=h;function l(A){return w.keyCodeToStr(A)}e.toUserSettingsGeneral=l;function v(A){return N.strToKeyCode(A)||w.strToKeyCode(A)}e.fromUserSettings=v;function k(A){if(A>=i.Numpad0&&A<=i.NumpadDivide)return null;switch(A){case i.UpArrow:return"Up";case i.DownArrow:return"Down";case i.LeftArrow:return"Left";case i.RightArrow:return"Right"}return F.keyCodeToStr(A)}e.toElectronAccelerator=k})(y||(t.KeyCodeUtils=y={}));var $;(function(e){e[e.CtrlCmd=2048]="CtrlCmd",e[e.Shift=1024]="Shift",e[e.Alt=512]="Alt",e[e.WinCtrl=256]="WinCtrl"})($||(t.KeyMod=$={}));function g(e,s){const r=(s&65535)<<16>>>0;return(e|r)>>>0}}),define(we[25],ve([1,0]),function(re,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$T=void 0;class i{constructor(j){this.d=j,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(j){this.c=j}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}t.$T=i}),define(we[14],ve([1,0,25]),function(re,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$vU=w,t.$wU=D,t.$xU=c;let j=()=>({get delay(){return-1},dispose:()=>{},showHover:()=>{}});const F=new i.$T(()=>j("mouse",!1)),N=new i.$T(()=>j("element",!1));function w(p){j=p}function D(p){return p==="element"?N.value:F.value}function c(){return j("element",!0)}}),define(we[59],ve([1,0]),function(re,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$4c=void 0;class i{static{this.Undefined=new i(void 0)}constructor(F){this.element=F,this.next=i.Undefined,this.prev=i.Undefined}}class n{constructor(){this.a=i.Undefined,this.b=i.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===i.Undefined}clear(){let F=this.a;for(;F!==i.Undefined;){const N=F.next;F.prev=i.Undefined,F.next=i.Undefined,F=N}this.a=i.Undefined,this.b=i.Undefined,this.c=0}unshift(F){return this.d(F,!1)}push(F){return this.d(F,!0)}d(F,N){const w=new i(F);if(this.a===i.Undefined)this.a=w,this.b=w;else if(N){const c=this.b;this.b=w,w.prev=c,c.next=w}else{const c=this.a;this.a=w,w.next=c,c.prev=w}this.c+=1;let D=!1;return()=>{D||(D=!0,this.e(w))}}shift(){if(this.a!==i.Undefined){const F=this.a.element;return this.e(this.a),F}}pop(){if(this.b!==i.Undefined){const F=this.b.element;return this.e(this.b),F}}e(F){if(F.prev!==i.Undefined&&F.next!==i.Undefined){const N=F.prev;N.next=F.next,F.next.prev=N}else F.prev===i.Undefined&&F.next===i.Undefined?(this.a=i.Undefined,this.b=i.Undefined):F.next===i.Undefined?(this.b=this.b.prev,this.b.next=i.Undefined):F.prev===i.Undefined&&(this.a=this.a.next,this.a.prev=i.Undefined);this.c-=1}*[Symbol.iterator](){let F=this.a;for(;F!==i.Undefined;)yield F.element,F=F.next}}t.$4c=n}),define(we[43],ve([1,0]),function(re,t){"use strict";var i,n,j;Object.defineProperty(t,"__esModule",{value:!0}),t.$Gc=t.$Fc=t.$Ec=t.$Dc=t.$Cc=t.$Bc=t.Touch=t.$Ac=t.$zc=void 0,t.$wc=F,t.$xc=N,t.$yc=w,t.$Hc=k;function F(A,d,f){let b=A.get(d);return b===void 0&&(b=f,A.set(d,b)),b}function N(A){const d=[];return A.forEach((f,b)=>{d.push(`${b} => ${f}`)}),`Map(${A.size}) {${d.join(", ")}}`}function w(A){const d=[];return A.forEach(f=>{d.push(f)}),`Set(${A.size}) {${d.join(", ")}}`}class D{constructor(d,f){this.uri=d,this.value=f}}function c(A){return Array.isArray(A)}class p{static{this.c=d=>d.toString()}constructor(d,f){if(this[i]="ResourceMap",d instanceof p)this.d=new Map(d.d),this.e=f??p.c;else if(c(d)){this.d=new Map,this.e=f??p.c;for(const[b,S]of d)this.set(b,S)}else this.d=new Map,this.e=d??p.c}set(d,f){return this.d.set(this.e(d),new D(d,f)),this}get(d){return this.d.get(this.e(d))?.value}has(d){return this.d.has(this.e(d))}get size(){return this.d.size}clear(){this.d.clear()}delete(d){return this.d.delete(this.e(d))}forEach(d,f){typeof f<"u"&&(d=d.bind(f));for(const[b,S]of this.d)d(S.value,S.uri,this)}*values(){for(const d of this.d.values())yield d.value}*keys(){for(const d of this.d.values())yield d.uri}*entries(){for(const d of this.d.values())yield[d.uri,d.value]}*[(i=Symbol.toStringTag,Symbol.iterator)](){for(const[,d]of this.d)yield[d.uri,d.value]}}t.$zc=p;class y{constructor(d,f){this[n]="ResourceSet",!d||typeof d=="function"?this.c=new p(d):(this.c=new p(f),d.forEach(this.add,this))}get size(){return this.c.size}add(d){return this.c.set(d,d),this}clear(){this.c.clear()}delete(d){return this.c.delete(d)}forEach(d,f){this.c.forEach((b,S)=>d.call(f,S,S,this))}has(d){return this.c.has(d)}entries(){return this.c.entries()}keys(){return this.c.keys()}values(){return this.c.keys()}[(n=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}t.$Ac=y;var $;(function(A){A[A.None=0]="None",A[A.AsOld=1]="AsOld",A[A.AsNew=2]="AsNew"})($||(t.Touch=$={}));class g{constructor(){this[j]="LinkedMap",this.c=new Map,this.d=void 0,this.e=void 0,this.f=0,this.g=0}clear(){this.c.clear(),this.d=void 0,this.e=void 0,this.f=0,this.g++}isEmpty(){return!this.d&&!this.e}get size(){return this.f}get first(){return this.d?.value}get last(){return this.e?.value}has(d){return this.c.has(d)}get(d,f=$.None){const b=this.c.get(d);if(b)return f!==$.None&&this.m(b,f),b.value}set(d,f,b=$.None){let S=this.c.get(d);if(S)S.value=f,b!==$.None&&this.m(S,b);else{switch(S={key:d,value:f,next:void 0,previous:void 0},b){case $.None:this.k(S);break;case $.AsOld:this.j(S);break;case $.AsNew:this.k(S);break;default:this.k(S);break}this.c.set(d,S),this.f++}return this}delete(d){return!!this.remove(d)}remove(d){const f=this.c.get(d);if(f)return this.c.delete(d),this.l(f),this.f--,f.value}shift(){if(!this.d&&!this.e)return;if(!this.d||!this.e)throw new Error("Invalid list");const d=this.d;return this.c.delete(d.key),this.l(d),this.f--,d.value}forEach(d,f){const b=this.g;let S=this.d;for(;S;){if(f?d.bind(f)(S.value,S.key,this):d(S.value,S.key,this),this.g!==b)throw new Error("LinkedMap got modified during iteration.");S=S.next}}keys(){const d=this,f=this.g;let b=this.d;const S={[Symbol.iterator](){return S},next(){if(d.g!==f)throw new Error("LinkedMap got modified during iteration.");if(b){const U={value:b.key,done:!1};return b=b.next,U}else return{value:void 0,done:!0}}};return S}values(){const d=this,f=this.g;let b=this.d;const S={[Symbol.iterator](){return S},next(){if(d.g!==f)throw new Error("LinkedMap got modified during iteration.");if(b){const U={value:b.value,done:!1};return b=b.next,U}else return{value:void 0,done:!0}}};return S}entries(){const d=this,f=this.g;let b=this.d;const S={[Symbol.iterator](){return S},next(){if(d.g!==f)throw new Error("LinkedMap got modified during iteration.");if(b){const U={value:[b.key,b.value],done:!1};return b=b.next,U}else return{value:void 0,done:!0}}};return S}[(j=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}h(d){if(d>=this.size)return;if(d===0){this.clear();return}let f=this.d,b=this.size;for(;f&&b>d;)this.c.delete(f.key),f=f.next,b--;this.d=f,this.f=b,f&&(f.previous=void 0),this.g++}i(d){if(d>=this.size)return;if(d===0){this.clear();return}let f=this.e,b=this.size;for(;f&&b>d;)this.c.delete(f.key),f=f.previous,b--;this.e=f,this.f=b,f&&(f.next=void 0),this.g++}j(d){if(!this.d&&!this.e)this.e=d;else if(this.d)d.next=this.d,this.d.previous=d;else throw new Error("Invalid list");this.d=d,this.g++}k(d){if(!this.d&&!this.e)this.d=d;else if(this.e)d.previous=this.e,this.e.next=d;else throw new Error("Invalid list");this.e=d,this.g++}l(d){if(d===this.d&&d===this.e)this.d=void 0,this.e=void 0;else if(d===this.d){if(!d.next)throw new Error("Invalid list");d.next.previous=void 0,this.d=d.next}else if(d===this.e){if(!d.previous)throw new Error("Invalid list");d.previous.next=void 0,this.e=d.previous}else{const f=d.next,b=d.previous;if(!f||!b)throw new Error("Invalid list");f.previous=b,b.next=f}d.next=void 0,d.previous=void 0,this.g++}m(d,f){if(!this.d||!this.e)throw new Error("Invalid list");if(!(f!==$.AsOld&&f!==$.AsNew)){if(f===$.AsOld){if(d===this.d)return;const b=d.next,S=d.previous;d===this.e?(S.next=void 0,this.e=S):(b.previous=S,S.next=b),d.previous=void 0,d.next=this.d,this.d.previous=d,this.d=d,this.g++}else if(f===$.AsNew){if(d===this.e)return;const b=d.next,S=d.previous;d===this.d?(b.previous=void 0,this.d=b):(b.previous=S,S.next=b),d.next=void 0,d.previous=this.e,this.e.next=d,this.e=d,this.g++}}}toJSON(){const d=[];return this.forEach((f,b)=>{d.push([b,f])}),d}fromJSON(d){this.clear();for(const[f,b]of d)this.set(f,b)}}t.$Bc=g;class e extends g{constructor(d,f=1){super(),this.n=d,this.o=Math.min(Math.max(0,f),1)}get limit(){return this.n}set limit(d){this.n=d,this.p()}get ratio(){return this.o}set ratio(d){this.o=Math.min(Math.max(0,d),1),this.p()}get(d,f=$.AsNew){return super.get(d,f)}peek(d){return super.get(d,$.None)}set(d,f){return super.set(d,f,$.AsNew),this}p(){this.size>this.n&&this.q(Math.round(this.n*this.o))}}class s extends e{constructor(d,f=1){super(d,f)}q(d){this.h(d)}set(d,f){return super.set(d,f),this.p(),this}}t.$Cc=s;class r extends e{constructor(d,f=1){super(d,f)}q(d){this.i(d)}set(d,f){return this.n<=this.size&&!this.has(d)&&this.q(Math.round(this.n*this.o)-1),super.set(d,f),this}}t.$Dc=r;class h{constructor(){this.c=new Map}add(d){return this.c.set(d,(this.c.get(d)||0)+1),this}delete(d){let f=this.c.get(d)||0;return f===0?!1:(f--,f===0?this.c.delete(d):this.c.set(d,f),!0)}has(d){return this.c.has(d)}}t.$Ec=h;class l{constructor(d){if(this.c=new Map,this.d=new Map,d)for(const[f,b]of d)this.set(f,b)}clear(){this.c.clear(),this.d.clear()}set(d,f){this.c.set(d,f),this.d.set(f,d)}get(d){return this.c.get(d)}getKey(d){return this.d.get(d)}delete(d){const f=this.c.get(d);return f===void 0?!1:(this.c.delete(d),this.d.delete(f),!0)}forEach(d,f){this.c.forEach((b,S)=>{d.call(f,b,S,this)})}keys(){return this.c.keys()}values(){return this.c.values()}}t.$Fc=l;class v{constructor(){this.c=new Map}add(d,f){let b=this.c.get(d);b||(b=new Set,this.c.set(d,b)),b.add(f)}delete(d,f){const b=this.c.get(d);b&&(b.delete(f),b.size===0&&this.c.delete(d))}forEach(d,f){const b=this.c.get(d);b&&b.forEach(f)}get(d){const f=this.c.get(d);return f||new Set}}t.$Gc=v;function k(A,d){if(A===d)return!0;if(A.size!==d.size)return!1;for(const[f,b]of A)if(!d.has(f)||d.get(f)!==b)return!1;for(const[f]of d)if(!A.has(f))return!1;return!0}}),define(we[2],ve([1,0,9,57,43,58,36]),function(re,t,i,n,j,F,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$3c=t.$1c=t.$Zc=t.$Yc=t.$Xc=t.$Wc=t.$Vc=t.$Uc=t.$Tc=t.$Sc=t.$Ic=void 0,t.$Jc=p,t.$Kc=y,t.$Lc=$,t.$Mc=s,t.$Nc=r,t.$Oc=h,t.$Pc=l,t.$Qc=v,t.$Rc=k,t.$2c=I;const w=!1;let D=null;class c{constructor(){this.b=new Map}static{this.a=0}c(C){let x=this.b.get(C);return x||(x={parent:null,source:null,isSingleton:!1,value:C,idx:c.a++},this.b.set(C,x)),x}trackDisposable(C){const x=this.c(C);x.source||(x.source=new Error().stack)}setParent(C,x){const Z=this.c(C);Z.parent=x}markAsDisposed(C){this.b.delete(C)}markAsSingleton(C){this.c(C).isSingleton=!0}f(C,x){const Z=x.get(C);if(Z)return Z;const Y=C.parent?this.f(this.c(C.parent),x):C;return x.set(C,Y),Y}getTrackedDisposables(){const C=new Map;return[...this.b.entries()].filter(([,Z])=>Z.source!==null&&!this.f(Z,C).isSingleton).flatMap(([Z])=>Z)}computeLeakingDisposables(C=10,x){let Z;if(x)Z=x;else{const be=new Map,ke=[...this.b.values()].filter(ue=>ue.source!==null&&!this.f(ue,be).isSingleton);if(ke.length===0)return;const Fe=new Set(ke.map(ue=>ue.value));if(Z=ke.filter(ue=>!(ue.parent&&Fe.has(ue.parent))),Z.length===0)throw new Error("There are cyclic diposable chains!")}if(!Z)return;function Y(be){function ke(ue,Q){for(;ue.length>0&&Q.some(he=>typeof he=="string"?he===ue[0]:ue[0].match(he));)ue.shift()}const Fe=be.source.split(`
`).map(ue=>ue.trim().replace("at ","")).filter(ue=>ue!=="");return ke(Fe,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),Fe.reverse()}const q=new j.$Gc;for(const be of Z){const ke=Y(be);for(let Fe=0;Fe<=ke.length;Fe++)q.add(ke.slice(0,Fe).join(`
`),be)}Z.sort((0,i.$5b)(be=>be.idx,i.$7b));let ee="",ce=0;for(const be of Z.slice(0,C)){ce++;const ke=Y(be),Fe=[];for(let ue=0;ue<ke.length;ue++){let Q=ke[ue];Q=`(shared with ${q.get(ke.slice(0,ue+1).join(`
`)).size}/${Z.length} leaks) at ${Q}`;const le=q.get(ke.slice(0,ue).join(`
`)),Ne=(0,n.$c)([...le].map(te=>Y(te)[ue]),te=>te);delete Ne[ke[ue]];for(const[te,$e]of Object.entries(Ne))Fe.unshift(`    - stacktraces of ${$e.length} other leaks continue with ${te}`);Fe.unshift(Q)}ee+=`


==================== Leaking disposable ${ce}/${Z.length}: ${be.value.constructor.name} ====================
${Fe.join(`
`)}
============================================================

`}return Z.length>C&&(ee+=`


... and ${Z.length-C} more leaking disposables

`),{leaks:Z,details:ee}}}t.$Ic=c;function p(O){D=O}if(w){const O="__is_disposable_tracked__";p(new class{trackDisposable(C){const x=new Error("Potentially leaked disposable").stack;setTimeout(()=>{C[O]||console.log(x)},3e3)}setParent(C,x){if(C&&C!==d.None)try{C[O]=!0}catch{}}markAsDisposed(C){if(C&&C!==d.None)try{C[O]=!0}catch{}}markAsSingleton(C){}})}function y(O){return D?.trackDisposable(O),O}function $(O){D?.markAsDisposed(O)}function g(O,C){D?.setParent(O,C)}function e(O,C){if(D)for(const x of O)D.setParent(x,C)}function s(O){return D?.markAsSingleton(O),O}function r(O){return typeof O=="object"&&O!==null&&typeof O.dispose=="function"&&O.dispose.length===0}function h(O){if(N.Iterable.is(O)){const C=[];for(const x of O)if(x)try{x.dispose()}catch(Z){C.push(Z)}if(C.length===1)throw C[0];if(C.length>1)throw new AggregateError(C,"Encountered errors while disposing of store");return Array.isArray(O)?[]:O}else if(O)return O.dispose(),O}function l(O){for(const C of O)r(C)&&C.dispose();return[]}function v(...O){const C=k(()=>h(O));return e(O,C),C}function k(O){const C=y({dispose:(0,F.$cb)(()=>{$(C),O()})});return C}class A{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,y(this)}dispose(){this.g||($(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{h(this.f)}finally{this.f.clear()}}add(C){if(!C)return C;if(C===this)throw new Error("Cannot register a disposable on itself!");return g(C,this),this.g?A.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(C),C}delete(C){if(C){if(C===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(C),C.dispose()}}deleteAndLeak(C){C&&this.f.has(C)&&(this.f.delete(C),g(C,null))}}t.$Sc=A;class d{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new A,y(this),g(this.q,this)}dispose(){$(this),this.q.dispose()}B(C){if(C===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(C)}}t.$Tc=d;class f{constructor(){this.b=!1,y(this)}get value(){return this.b?void 0:this.a}set value(C){this.b||C===this.a||(this.a?.dispose(),C&&g(C,this),this.a=C)}clear(){this.value=void 0}dispose(){this.b=!0,$(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const C=this.a;return this.a=void 0,C&&g(C,null),C}}t.$Uc=f;class b{constructor(C){this.a=new f,this.b=!1,this.a.value=C}get value(){return this.a.value}set value(C){this.b||C===this.a.value||(this.a.value=C)}dispose(){this.b=!0,this.a.dispose()}}t.$Vc=b;class S{constructor(C){this.b=C,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}t.$Wc=S;class U{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,y(this)}set(C){let x=C;return this.unset=()=>x=void 0,this.isset=()=>x!==void 0,this.dispose=()=>{x&&(x(),x=void 0,$(this))},this}}t.$Xc=U;class _{constructor(){this.a=new Map}acquire(C,...x){let Z=this.a.get(C);Z||(Z={counter:0,object:this.b(C,...x)},this.a.set(C,Z));const{object:Y}=Z,q=(0,F.$cb)(()=>{--Z.counter===0&&(this.c(C,Z.object),this.a.delete(C))});return Z.counter++,{object:Y,dispose:q}}}t.$Yc=_;class B{constructor(C){this.a=C}async acquire(C,...x){const Z=this.a.acquire(C,...x);try{return{object:await Z.object,dispose:()=>Z.dispose()}}catch(Y){throw Z.dispose(),Y}}}t.$Zc=B;class E{constructor(C){this.object=C}dispose(){}}t.$1c=E;function I(O){const C=new A;try{O(C)}finally{C.dispose()}}class z{constructor(){this.a=new Map,this.b=!1,y(this)}dispose(){$(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{h(this.a.values())}finally{this.a.clear()}}has(C){return this.a.has(C)}get size(){return this.a.size}get(C){return this.a.get(C)}set(C,x,Z=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),Z||this.a.get(C)?.dispose(),this.a.set(C,x)}deleteAndDispose(C){this.a.get(C)?.dispose(),this.a.delete(C)}deleteAndLeak(C){const x=this.a.get(C);return this.a.delete(C),x}keys(){return this.a.keys()}values(){return this.a.values()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}t.$3c=z}),function(re,t){typeof define=="function"&&define.amd?define(we[92],ve([0]),t):typeof exports=="object"&&typeof module<"u"?t(exports):(re=typeof globalThis<"u"?globalThis:re||self,t(re.marked={}))}(this,function(re){"use strict";function t(K,W){for(var a=0;a<W.length;a++){var o=W[a];o.enumerable=o.enumerable||!1,o.configurable=!0,"value"in o&&(o.writable=!0),Object.defineProperty(K,o.key,o)}}function i(K,W,a){return W&&t(K.prototype,W),a&&t(K,a),Object.defineProperty(K,"prototype",{writable:!1}),K}function n(K,W){if(K){if(typeof K=="string")return j(K,W);var a=Object.prototype.toString.call(K).slice(8,-1);if(a==="Object"&&K.constructor&&(a=K.constructor.name),a==="Map"||a==="Set")return Array.from(K);if(a==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(a))return j(K,W)}}function j(K,W){(W==null||W>K.length)&&(W=K.length);for(var a=0,o=new Array(W);a<W;a++)o[a]=K[a];return o}function F(K,W){var a=typeof Symbol<"u"&&K[Symbol.iterator]||K["@@iterator"];if(a)return(a=a.call(K)).next.bind(a);if(Array.isArray(K)||(a=n(K))||W&&K&&typeof K.length=="number"){a&&(K=a);var o=0;return function(){return o>=K.length?{done:!0}:{done:!1,value:K[o++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function N(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}re.defaults=N();function w(K){re.defaults=K}var D=/[&<>"']/,c=/[&<>"']/g,p=/[<>"']|&(?!#?\w+;)/,y=/[<>"']|&(?!#?\w+;)/g,$={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},g=function(W){return $[W]};function e(K,W){if(W){if(D.test(K))return K.replace(c,g)}else if(p.test(K))return K.replace(y,g);return K}var s=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function r(K){return K.replace(s,function(W,a){return a=a.toLowerCase(),a==="colon"?":":a.charAt(0)==="#"?a.charAt(1)==="x"?String.fromCharCode(parseInt(a.substring(2),16)):String.fromCharCode(+a.substring(1)):""})}var h=/(^|[^\[])\^/g;function l(K,W){K=typeof K=="string"?K:K.source,W=W||"";var a={replace:function(m,M){return M=M.source||M,M=M.replace(h,"$1"),K=K.replace(m,M),a},getRegex:function(){return new RegExp(K,W)}};return a}var v=/[^\w:]/g,k=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function A(K,W,a){if(K){var o;try{o=decodeURIComponent(r(a)).replace(v,"").toLowerCase()}catch{return null}if(o.indexOf("javascript:")===0||o.indexOf("vbscript:")===0||o.indexOf("data:")===0)return null}W&&!k.test(a)&&(a=U(W,a));try{a=encodeURI(a).replace(/%25/g,"%")}catch{return null}return a}var d={},f=/^[^:]+:\/*[^/]*$/,b=/^([^:]+:)[\s\S]*$/,S=/^([^:]+:\/*[^/]*)[\s\S]*$/;function U(K,W){d[" "+K]||(f.test(K)?d[" "+K]=K+"/":d[" "+K]=I(K,"/",!0)),K=d[" "+K];var a=K.indexOf(":")===-1;return W.substring(0,2)==="//"?a?W:K.replace(b,"$1")+W:W.charAt(0)==="/"?a?W:K.replace(S,"$1")+W:K+W}var _={exec:function(){}};function B(K){for(var W=1,a,o;W<arguments.length;W++){a=arguments[W];for(o in a)Object.prototype.hasOwnProperty.call(a,o)&&(K[o]=a[o])}return K}function E(K,W){var a=K.replace(/\|/g,function(M,R,u){for(var L=!1,T=R;--T>=0&&u[T]==="\\";)L=!L;return L?"|":" |"}),o=a.split(/ \|/),m=0;if(o[0].trim()||o.shift(),o.length>0&&!o[o.length-1].trim()&&o.pop(),o.length>W)o.splice(W);else for(;o.length<W;)o.push("");for(;m<o.length;m++)o[m]=o[m].trim().replace(/\\\|/g,"|");return o}function I(K,W,a){var o=K.length;if(o===0)return"";for(var m=0;m<o;){var M=K.charAt(o-m-1);if(M===W&&!a)m++;else if(M!==W&&a)m++;else break}return K.slice(0,o-m)}function z(K,W){if(K.indexOf(W[1])===-1)return-1;for(var a=K.length,o=0,m=0;m<a;m++)if(K[m]==="\\")m++;else if(K[m]===W[0])o++;else if(K[m]===W[1]&&(o--,o<0))return m;return-1}function O(K){K&&K.sanitize&&!K.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function C(K,W){if(W<1)return"";for(var a="";W>1;)W&1&&(a+=K),W>>=1,K+=K;return a+K}function x(K,W,a,o){var m=W.href,M=W.title?e(W.title):null,R=K[1].replace(/\\([\[\]])/g,"$1");if(K[0].charAt(0)!=="!"){o.state.inLink=!0;var u={type:"link",raw:a,href:m,title:M,text:R,tokens:o.inlineTokens(R)};return o.state.inLink=!1,u}return{type:"image",raw:a,href:m,title:M,text:e(R)}}function Z(K,W){var a=K.match(/^(\s+)(?:```)/);if(a===null)return W;var o=a[1];return W.split(`
`).map(function(m){var M=m.match(/^\s+/);if(M===null)return m;var R=M[0];return R.length>=o.length?m.slice(o.length):m}).join(`
`)}var Y=function(){function K(a){this.options=a||re.defaults}var W=K.prototype;return W.space=function(o){var m=this.rules.block.newline.exec(o);if(m&&m[0].length>0)return{type:"space",raw:m[0]}},W.code=function(o){var m=this.rules.block.code.exec(o);if(m){var M=m[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:m[0],codeBlockStyle:"indented",text:this.options.pedantic?M:I(M,`
`)}}},W.fences=function(o){var m=this.rules.block.fences.exec(o);if(m){var M=m[0],R=Z(M,m[3]||"");return{type:"code",raw:M,lang:m[2]?m[2].trim():m[2],text:R}}},W.heading=function(o){var m=this.rules.block.heading.exec(o);if(m){var M=m[2].trim();if(/#$/.test(M)){var R=I(M,"#");(this.options.pedantic||!R||/ $/.test(R))&&(M=R.trim())}return{type:"heading",raw:m[0],depth:m[1].length,text:M,tokens:this.lexer.inline(M)}}},W.hr=function(o){var m=this.rules.block.hr.exec(o);if(m)return{type:"hr",raw:m[0]}},W.blockquote=function(o){var m=this.rules.block.blockquote.exec(o);if(m){var M=m[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:m[0],tokens:this.lexer.blockTokens(M,[]),text:M}}},W.list=function(o){var m=this.rules.block.list.exec(o);if(m){var M,R,u,L,T,P,H,X,ie,oe,de,ye,De=m[1].trim(),Le=De.length>1,Te={type:"list",raw:"",ordered:Le,start:Le?+De.slice(0,-1):"",loose:!1,items:[]};De=Le?"\\d{1,9}\\"+De.slice(-1):"\\"+De,this.options.pedantic&&(De=Le?De:"[*+-]");for(var fe=new RegExp("^( {0,3}"+De+")((?:[	 ][^\\n]*)?(?:\\n|$))");o&&(ye=!1,!(!(m=fe.exec(o))||this.rules.block.hr.test(o)));){if(M=m[0],o=o.substring(M.length),X=m[2].split(`
`,1)[0],ie=o.split(`
`,1)[0],this.options.pedantic?(L=2,de=X.trimLeft()):(L=m[2].search(/[^ ]/),L=L>4?1:L,de=X.slice(L),L+=m[1].length),P=!1,!X&&/^ *$/.test(ie)&&(M+=ie+`
`,o=o.substring(ie.length+1),ye=!0),!ye)for(var Re=new RegExp("^ {0,"+Math.min(3,L-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),Ke=new RegExp("^ {0,"+Math.min(3,L-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),Ze=new RegExp("^ {0,"+Math.min(3,L-1)+"}(?:```|~~~)"),tt=new RegExp("^ {0,"+Math.min(3,L-1)+"}#");o&&(oe=o.split(`
`,1)[0],X=oe,this.options.pedantic&&(X=X.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(Ze.test(X)||tt.test(X)||Re.test(X)||Ke.test(o)));){if(X.search(/[^ ]/)>=L||!X.trim())de+=`
`+X.slice(L);else if(!P)de+=`
`+X;else break;!P&&!X.trim()&&(P=!0),M+=oe+`
`,o=o.substring(oe.length+1)}Te.loose||(H?Te.loose=!0:/\n *\n *$/.test(M)&&(H=!0)),this.options.gfm&&(R=/^\[[ xX]\] /.exec(de),R&&(u=R[0]!=="[ ] ",de=de.replace(/^\[[ xX]\] +/,""))),Te.items.push({type:"list_item",raw:M,task:!!R,checked:u,loose:!1,text:de}),Te.raw+=M}Te.items[Te.items.length-1].raw=M.trimRight(),Te.items[Te.items.length-1].text=de.trimRight(),Te.raw=Te.raw.trimRight();var at=Te.items.length;for(T=0;T<at;T++){this.lexer.state.top=!1,Te.items[T].tokens=this.lexer.blockTokens(Te.items[T].text,[]);var st=Te.items[T].tokens.filter(function(Qe){return Qe.type==="space"}),Ge=st.every(function(Qe){for(var J=Qe.raw.split(""),ae=0,pe=F(J),Se;!(Se=pe()).done;){var Pe=Se.value;if(Pe===`
`&&(ae+=1),ae>1)return!0}return!1});!Te.loose&&st.length&&Ge&&(Te.loose=!0,Te.items[T].loose=!0)}return Te}},W.html=function(o){var m=this.rules.block.html.exec(o);if(m){var M={type:"html",raw:m[0],pre:!this.options.sanitizer&&(m[1]==="pre"||m[1]==="script"||m[1]==="style"),text:m[0]};if(this.options.sanitize){var R=this.options.sanitizer?this.options.sanitizer(m[0]):e(m[0]);M.type="paragraph",M.text=R,M.tokens=this.lexer.inline(R)}return M}},W.def=function(o){var m=this.rules.block.def.exec(o);if(m){m[3]&&(m[3]=m[3].substring(1,m[3].length-1));var M=m[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:M,raw:m[0],href:m[2],title:m[3]}}},W.table=function(o){var m=this.rules.block.table.exec(o);if(m){var M={type:"table",header:E(m[1]).map(function(H){return{text:H}}),align:m[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:m[3]&&m[3].trim()?m[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(M.header.length===M.align.length){M.raw=m[0];var R=M.align.length,u,L,T,P;for(u=0;u<R;u++)/^ *-+: *$/.test(M.align[u])?M.align[u]="right":/^ *:-+: *$/.test(M.align[u])?M.align[u]="center":/^ *:-+ *$/.test(M.align[u])?M.align[u]="left":M.align[u]=null;for(R=M.rows.length,u=0;u<R;u++)M.rows[u]=E(M.rows[u],M.header.length).map(function(H){return{text:H}});for(R=M.header.length,L=0;L<R;L++)M.header[L].tokens=this.lexer.inline(M.header[L].text);for(R=M.rows.length,L=0;L<R;L++)for(P=M.rows[L],T=0;T<P.length;T++)P[T].tokens=this.lexer.inline(P[T].text);return M}}},W.lheading=function(o){var m=this.rules.block.lheading.exec(o);if(m)return{type:"heading",raw:m[0],depth:m[2].charAt(0)==="="?1:2,text:m[1],tokens:this.lexer.inline(m[1])}},W.paragraph=function(o){var m=this.rules.block.paragraph.exec(o);if(m){var M=m[1].charAt(m[1].length-1)===`
`?m[1].slice(0,-1):m[1];return{type:"paragraph",raw:m[0],text:M,tokens:this.lexer.inline(M)}}},W.text=function(o){var m=this.rules.block.text.exec(o);if(m)return{type:"text",raw:m[0],text:m[0],tokens:this.lexer.inline(m[0])}},W.escape=function(o){var m=this.rules.inline.escape.exec(o);if(m)return{type:"escape",raw:m[0],text:e(m[1])}},W.tag=function(o){var m=this.rules.inline.tag.exec(o);if(m)return!this.lexer.state.inLink&&/^<a /i.test(m[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(m[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(m[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(m[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:m[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(m[0]):e(m[0]):m[0]}},W.link=function(o){var m=this.rules.inline.link.exec(o);if(m){var M=m[2].trim();if(!this.options.pedantic&&/^</.test(M)){if(!/>$/.test(M))return;var R=I(M.slice(0,-1),"\\");if((M.length-R.length)%2===0)return}else{var u=z(m[2],"()");if(u>-1){var L=m[0].indexOf("!")===0?5:4,T=L+m[1].length+u;m[2]=m[2].substring(0,u),m[0]=m[0].substring(0,T).trim(),m[3]=""}}var P=m[2],H="";if(this.options.pedantic){var X=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(P);X&&(P=X[1],H=X[3])}else H=m[3]?m[3].slice(1,-1):"";return P=P.trim(),/^</.test(P)&&(this.options.pedantic&&!/>$/.test(M)?P=P.slice(1):P=P.slice(1,-1)),x(m,{href:P&&P.replace(this.rules.inline._escapes,"$1"),title:H&&H.replace(this.rules.inline._escapes,"$1")},m[0],this.lexer)}},W.reflink=function(o,m){var M;if((M=this.rules.inline.reflink.exec(o))||(M=this.rules.inline.nolink.exec(o))){var R=(M[2]||M[1]).replace(/\s+/g," ");if(R=m[R.toLowerCase()],!R||!R.href){var u=M[0].charAt(0);return{type:"text",raw:u,text:u}}return x(M,R,M[0],this.lexer)}},W.emStrong=function(o,m,M){M===void 0&&(M="");var R=this.rules.inline.emStrong.lDelim.exec(o);if(R&&!(R[3]&&M.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var u=R[1]||R[2]||"";if(!u||u&&(M===""||this.rules.inline.punctuation.exec(M))){var L=R[0].length-1,T,P,H=L,X=0,ie=R[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(ie.lastIndex=0,m=m.slice(-1*o.length+L);(R=ie.exec(m))!=null;)if(T=R[1]||R[2]||R[3]||R[4]||R[5]||R[6],!!T){if(P=T.length,R[3]||R[4]){H+=P;continue}else if((R[5]||R[6])&&L%3&&!((L+P)%3)){X+=P;continue}if(H-=P,!(H>0)){if(P=Math.min(P,P+H+X),Math.min(L,P)%2){var oe=o.slice(1,L+R.index+P);return{type:"em",raw:o.slice(0,L+R.index+P+1),text:oe,tokens:this.lexer.inlineTokens(oe)}}var de=o.slice(2,L+R.index+P-1);return{type:"strong",raw:o.slice(0,L+R.index+P+1),text:de,tokens:this.lexer.inlineTokens(de)}}}}}},W.codespan=function(o){var m=this.rules.inline.code.exec(o);if(m){var M=m[2].replace(/\n/g," "),R=/[^ ]/.test(M),u=/^ /.test(M)&&/ $/.test(M);return R&&u&&(M=M.substring(1,M.length-1)),M=e(M,!0),{type:"codespan",raw:m[0],text:M}}},W.br=function(o){var m=this.rules.inline.br.exec(o);if(m)return{type:"br",raw:m[0]}},W.del=function(o){var m=this.rules.inline.del.exec(o);if(m)return{type:"del",raw:m[0],text:m[2],tokens:this.lexer.inlineTokens(m[2])}},W.autolink=function(o,m){var M=this.rules.inline.autolink.exec(o);if(M){var R,u;return M[2]==="@"?(R=e(this.options.mangle?m(M[1]):M[1]),u="mailto:"+R):(R=e(M[1]),u=R),{type:"link",raw:M[0],text:R,href:u,tokens:[{type:"text",raw:R,text:R}]}}},W.url=function(o,m){var M;if(M=this.rules.inline.url.exec(o)){var R,u;if(M[2]==="@")R=e(this.options.mangle?m(M[0]):M[0]),u="mailto:"+R;else{var L;do L=M[0],M[0]=this.rules.inline._backpedal.exec(M[0])[0];while(L!==M[0]);R=e(M[0]),M[1]==="www."?u="http://"+R:u=R}return{type:"link",raw:M[0],text:R,href:u,tokens:[{type:"text",raw:R,text:R}]}}},W.inlineText=function(o,m){var M=this.rules.inline.text.exec(o);if(M){var R;return this.lexer.state.inRawBlock?R=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(M[0]):e(M[0]):M[0]:R=e(this.options.smartypants?m(M[0]):M[0]),{type:"text",raw:M[0],text:R}}},K}(),q={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:_,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};q._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,q._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,q.def=l(q.def).replace("label",q._label).replace("title",q._title).getRegex(),q.bullet=/(?:[*+-]|\d{1,9}[.)])/,q.listItemStart=l(/^( *)(bull) */).replace("bull",q.bullet).getRegex(),q.list=l(q.list).replace(/bull/g,q.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+q.def.source+")").getRegex(),q._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",q._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,q.html=l(q.html,"i").replace("comment",q._comment).replace("tag",q._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),q.paragraph=l(q._paragraph).replace("hr",q.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",q._tag).getRegex(),q.blockquote=l(q.blockquote).replace("paragraph",q.paragraph).getRegex(),q.normal=B({},q),q.gfm=B({},q.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),q.gfm.table=l(q.gfm.table).replace("hr",q.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",q._tag).getRegex(),q.gfm.paragraph=l(q._paragraph).replace("hr",q.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",q.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",q._tag).getRegex(),q.pedantic=B({},q.normal,{html:l(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",q._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:_,paragraph:l(q.normal._paragraph).replace("hr",q.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",q.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var ee={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:_,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:_,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};ee._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",ee.punctuation=l(ee.punctuation).replace(/punctuation/g,ee._punctuation).getRegex(),ee.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,ee.escapedEmSt=/\\\*|\\_/g,ee._comment=l(q._comment).replace("(?:-->|$)","-->").getRegex(),ee.emStrong.lDelim=l(ee.emStrong.lDelim).replace(/punct/g,ee._punctuation).getRegex(),ee.emStrong.rDelimAst=l(ee.emStrong.rDelimAst,"g").replace(/punct/g,ee._punctuation).getRegex(),ee.emStrong.rDelimUnd=l(ee.emStrong.rDelimUnd,"g").replace(/punct/g,ee._punctuation).getRegex(),ee._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,ee._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,ee._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,ee.autolink=l(ee.autolink).replace("scheme",ee._scheme).replace("email",ee._email).getRegex(),ee._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,ee.tag=l(ee.tag).replace("comment",ee._comment).replace("attribute",ee._attribute).getRegex(),ee._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,ee._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,ee._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,ee.link=l(ee.link).replace("label",ee._label).replace("href",ee._href).replace("title",ee._title).getRegex(),ee.reflink=l(ee.reflink).replace("label",ee._label).replace("ref",q._label).getRegex(),ee.nolink=l(ee.nolink).replace("ref",q._label).getRegex(),ee.reflinkSearch=l(ee.reflinkSearch,"g").replace("reflink",ee.reflink).replace("nolink",ee.nolink).getRegex(),ee.normal=B({},ee),ee.pedantic=B({},ee.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:l(/^!?\[(label)\]\((.*?)\)/).replace("label",ee._label).getRegex(),reflink:l(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",ee._label).getRegex()}),ee.gfm=B({},ee.normal,{escape:l(ee.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),ee.gfm.url=l(ee.gfm.url,"i").replace("email",ee.gfm._extended_email).getRegex(),ee.breaks=B({},ee.gfm,{br:l(ee.br).replace("{2,}","*").getRegex(),text:l(ee.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function ce(K){return K.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function be(K){var W="",a,o,m=K.length;for(a=0;a<m;a++)o=K.charCodeAt(a),Math.random()>.5&&(o="x"+o.toString(16)),W+="&#"+o+";";return W}var ke=function(){function K(a){this.tokens=[],this.tokens.links=Object.create(null),this.options=a||re.defaults,this.options.tokenizer=this.options.tokenizer||new Y,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var o={block:q.normal,inline:ee.normal};this.options.pedantic?(o.block=q.pedantic,o.inline=ee.pedantic):this.options.gfm&&(o.block=q.gfm,this.options.breaks?o.inline=ee.breaks:o.inline=ee.gfm),this.tokenizer.rules=o}K.lex=function(o,m){var M=new K(m);return M.lex(o)},K.lexInline=function(o,m){var M=new K(m);return M.inlineTokens(o)};var W=K.prototype;return W.lex=function(o){o=o.replace(/\r\n|\r/g,`
`),this.blockTokens(o,this.tokens);for(var m;m=this.inlineQueue.shift();)this.inlineTokens(m.src,m.tokens);return this.tokens},W.blockTokens=function(o,m){var M=this;m===void 0&&(m=[]),this.options.pedantic?o=o.replace(/\t/g,"    ").replace(/^ +$/gm,""):o=o.replace(/^( *)(\t+)/gm,function(H,X,ie){return X+"    ".repeat(ie.length)});for(var R,u,L,T;o;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(H){return(R=H.call({lexer:M},o,m))?(o=o.substring(R.raw.length),m.push(R),!0):!1}))){if(R=this.tokenizer.space(o)){o=o.substring(R.raw.length),R.raw.length===1&&m.length>0?m[m.length-1].raw+=`
`:m.push(R);continue}if(R=this.tokenizer.code(o)){o=o.substring(R.raw.length),u=m[m.length-1],u&&(u.type==="paragraph"||u.type==="text")?(u.raw+=`
`+R.raw,u.text+=`
`+R.text,this.inlineQueue[this.inlineQueue.length-1].src=u.text):m.push(R);continue}if(R=this.tokenizer.fences(o)){o=o.substring(R.raw.length),m.push(R);continue}if(R=this.tokenizer.heading(o)){o=o.substring(R.raw.length),m.push(R);continue}if(R=this.tokenizer.hr(o)){o=o.substring(R.raw.length),m.push(R);continue}if(R=this.tokenizer.blockquote(o)){o=o.substring(R.raw.length),m.push(R);continue}if(R=this.tokenizer.list(o)){o=o.substring(R.raw.length),m.push(R);continue}if(R=this.tokenizer.html(o)){o=o.substring(R.raw.length),m.push(R);continue}if(R=this.tokenizer.def(o)){o=o.substring(R.raw.length),u=m[m.length-1],u&&(u.type==="paragraph"||u.type==="text")?(u.raw+=`
`+R.raw,u.text+=`
`+R.raw,this.inlineQueue[this.inlineQueue.length-1].src=u.text):this.tokens.links[R.tag]||(this.tokens.links[R.tag]={href:R.href,title:R.title});continue}if(R=this.tokenizer.table(o)){o=o.substring(R.raw.length),m.push(R);continue}if(R=this.tokenizer.lheading(o)){o=o.substring(R.raw.length),m.push(R);continue}if(L=o,this.options.extensions&&this.options.extensions.startBlock&&function(){var H=1/0,X=o.slice(1),ie=void 0;M.options.extensions.startBlock.forEach(function(oe){ie=oe.call({lexer:this},X),typeof ie=="number"&&ie>=0&&(H=Math.min(H,ie))}),H<1/0&&H>=0&&(L=o.substring(0,H+1))}(),this.state.top&&(R=this.tokenizer.paragraph(L))){u=m[m.length-1],T&&u.type==="paragraph"?(u.raw+=`
`+R.raw,u.text+=`
`+R.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=u.text):m.push(R),T=L.length!==o.length,o=o.substring(R.raw.length);continue}if(R=this.tokenizer.text(o)){o=o.substring(R.raw.length),u=m[m.length-1],u&&u.type==="text"?(u.raw+=`
`+R.raw,u.text+=`
`+R.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=u.text):m.push(R);continue}if(o){var P="Infinite loop on byte: "+o.charCodeAt(0);if(this.options.silent){console.error(P);break}else throw new Error(P)}}return this.state.top=!0,m},W.inline=function(o,m){return m===void 0&&(m=[]),this.inlineQueue.push({src:o,tokens:m}),m},W.inlineTokens=function(o,m){var M=this;m===void 0&&(m=[]);var R,u,L,T=o,P,H,X;if(this.tokens.links){var ie=Object.keys(this.tokens.links);if(ie.length>0)for(;(P=this.tokenizer.rules.inline.reflinkSearch.exec(T))!=null;)ie.includes(P[0].slice(P[0].lastIndexOf("[")+1,-1))&&(T=T.slice(0,P.index)+"["+C("a",P[0].length-2)+"]"+T.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(P=this.tokenizer.rules.inline.blockSkip.exec(T))!=null;)T=T.slice(0,P.index)+"["+C("a",P[0].length-2)+"]"+T.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(P=this.tokenizer.rules.inline.escapedEmSt.exec(T))!=null;)T=T.slice(0,P.index)+"++"+T.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;o;)if(H||(X=""),H=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(de){return(R=de.call({lexer:M},o,m))?(o=o.substring(R.raw.length),m.push(R),!0):!1}))){if(R=this.tokenizer.escape(o)){o=o.substring(R.raw.length),m.push(R);continue}if(R=this.tokenizer.tag(o)){o=o.substring(R.raw.length),u=m[m.length-1],u&&R.type==="text"&&u.type==="text"?(u.raw+=R.raw,u.text+=R.text):m.push(R);continue}if(R=this.tokenizer.link(o)){o=o.substring(R.raw.length),m.push(R);continue}if(R=this.tokenizer.reflink(o,this.tokens.links)){o=o.substring(R.raw.length),u=m[m.length-1],u&&R.type==="text"&&u.type==="text"?(u.raw+=R.raw,u.text+=R.text):m.push(R);continue}if(R=this.tokenizer.emStrong(o,T,X)){o=o.substring(R.raw.length),m.push(R);continue}if(R=this.tokenizer.codespan(o)){o=o.substring(R.raw.length),m.push(R);continue}if(R=this.tokenizer.br(o)){o=o.substring(R.raw.length),m.push(R);continue}if(R=this.tokenizer.del(o)){o=o.substring(R.raw.length),m.push(R);continue}if(R=this.tokenizer.autolink(o,be)){o=o.substring(R.raw.length),m.push(R);continue}if(!this.state.inLink&&(R=this.tokenizer.url(o,be))){o=o.substring(R.raw.length),m.push(R);continue}if(L=o,this.options.extensions&&this.options.extensions.startInline&&function(){var de=1/0,ye=o.slice(1),De=void 0;M.options.extensions.startInline.forEach(function(Le){De=Le.call({lexer:this},ye),typeof De=="number"&&De>=0&&(de=Math.min(de,De))}),de<1/0&&de>=0&&(L=o.substring(0,de+1))}(),R=this.tokenizer.inlineText(L,ce)){o=o.substring(R.raw.length),R.raw.slice(-1)!=="_"&&(X=R.raw.slice(-1)),H=!0,u=m[m.length-1],u&&u.type==="text"?(u.raw+=R.raw,u.text+=R.text):m.push(R);continue}if(o){var oe="Infinite loop on byte: "+o.charCodeAt(0);if(this.options.silent){console.error(oe);break}else throw new Error(oe)}}return m},i(K,null,[{key:"rules",get:function(){return{block:q,inline:ee}}}]),K}(),Fe=function(){function K(a){this.options=a||re.defaults}var W=K.prototype;return W.code=function(o,m,M){var R=(m||"").match(/\S*/)[0];if(this.options.highlight){var u=this.options.highlight(o,R);u!=null&&u!==o&&(M=!0,o=u)}return o=o.replace(/\n$/,"")+`
`,R?'<pre><code class="'+this.options.langPrefix+e(R,!0)+'">'+(M?o:e(o,!0))+`</code></pre>
`:"<pre><code>"+(M?o:e(o,!0))+`</code></pre>
`},W.blockquote=function(o){return`<blockquote>
`+o+`</blockquote>
`},W.html=function(o){return o},W.heading=function(o,m,M,R){if(this.options.headerIds){var u=this.options.headerPrefix+R.slug(M);return"<h"+m+' id="'+u+'">'+o+"</h"+m+`>
`}return"<h"+m+">"+o+"</h"+m+`>
`},W.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},W.list=function(o,m,M){var R=m?"ol":"ul",u=m&&M!==1?' start="'+M+'"':"";return"<"+R+u+`>
`+o+"</"+R+`>
`},W.listitem=function(o){return"<li>"+o+`</li>
`},W.checkbox=function(o){return"<input "+(o?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},W.paragraph=function(o){return"<p>"+o+`</p>
`},W.table=function(o,m){return m&&(m="<tbody>"+m+"</tbody>"),`<table>
<thead>
`+o+`</thead>
`+m+`</table>
`},W.tablerow=function(o){return`<tr>
`+o+`</tr>
`},W.tablecell=function(o,m){var M=m.header?"th":"td",R=m.align?"<"+M+' align="'+m.align+'">':"<"+M+">";return R+o+("</"+M+`>
`)},W.strong=function(o){return"<strong>"+o+"</strong>"},W.em=function(o){return"<em>"+o+"</em>"},W.codespan=function(o){return"<code>"+o+"</code>"},W.br=function(){return this.options.xhtml?"<br/>":"<br>"},W.del=function(o){return"<del>"+o+"</del>"},W.link=function(o,m,M){if(o=A(this.options.sanitize,this.options.baseUrl,o),o===null)return M;var R='<a href="'+e(o)+'"';return m&&(R+=' title="'+m+'"'),R+=">"+M+"</a>",R},W.image=function(o,m,M){if(o=A(this.options.sanitize,this.options.baseUrl,o),o===null)return M;var R='<img src="'+o+'" alt="'+M+'"';return m&&(R+=' title="'+m+'"'),R+=this.options.xhtml?"/>":">",R},W.text=function(o){return o},K}(),ue=function(){function K(){}var W=K.prototype;return W.strong=function(o){return o},W.em=function(o){return o},W.codespan=function(o){return o},W.del=function(o){return o},W.html=function(o){return o},W.text=function(o){return o},W.link=function(o,m,M){return""+M},W.image=function(o,m,M){return""+M},W.br=function(){return""},K}(),Q=function(){function K(){this.seen={}}var W=K.prototype;return W.serialize=function(o){return o.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},W.getNextSafeSlug=function(o,m){var M=o,R=0;if(this.seen.hasOwnProperty(M)){R=this.seen[o];do R++,M=o+"-"+R;while(this.seen.hasOwnProperty(M))}return m||(this.seen[o]=R,this.seen[M]=0),M},W.slug=function(o,m){m===void 0&&(m={});var M=this.serialize(o);return this.getNextSafeSlug(M,m.dryrun)},K}(),he=function(){function K(a){this.options=a||re.defaults,this.options.renderer=this.options.renderer||new Fe,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new ue,this.slugger=new Q}K.parse=function(o,m){var M=new K(m);return M.parse(o)},K.parseInline=function(o,m){var M=new K(m);return M.parseInline(o)};var W=K.prototype;return W.parse=function(o,m){m===void 0&&(m=!0);var M="",R,u,L,T,P,H,X,ie,oe,de,ye,De,Le,Te,fe,Re,Ke,Ze,tt,at=o.length;for(R=0;R<at;R++){if(de=o[R],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[de.type]&&(tt=this.options.extensions.renderers[de.type].call({parser:this},de),tt!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(de.type))){M+=tt||"";continue}switch(de.type){case"space":continue;case"hr":{M+=this.renderer.hr();continue}case"heading":{M+=this.renderer.heading(this.parseInline(de.tokens),de.depth,r(this.parseInline(de.tokens,this.textRenderer)),this.slugger);continue}case"code":{M+=this.renderer.code(de.text,de.lang,de.escaped);continue}case"table":{for(ie="",X="",T=de.header.length,u=0;u<T;u++)X+=this.renderer.tablecell(this.parseInline(de.header[u].tokens),{header:!0,align:de.align[u]});for(ie+=this.renderer.tablerow(X),oe="",T=de.rows.length,u=0;u<T;u++){for(H=de.rows[u],X="",P=H.length,L=0;L<P;L++)X+=this.renderer.tablecell(this.parseInline(H[L].tokens),{header:!1,align:de.align[L]});oe+=this.renderer.tablerow(X)}M+=this.renderer.table(ie,oe);continue}case"blockquote":{oe=this.parse(de.tokens),M+=this.renderer.blockquote(oe);continue}case"list":{for(ye=de.ordered,De=de.start,Le=de.loose,T=de.items.length,oe="",u=0;u<T;u++)fe=de.items[u],Re=fe.checked,Ke=fe.task,Te="",fe.task&&(Ze=this.renderer.checkbox(Re),Le?fe.tokens.length>0&&fe.tokens[0].type==="paragraph"?(fe.tokens[0].text=Ze+" "+fe.tokens[0].text,fe.tokens[0].tokens&&fe.tokens[0].tokens.length>0&&fe.tokens[0].tokens[0].type==="text"&&(fe.tokens[0].tokens[0].text=Ze+" "+fe.tokens[0].tokens[0].text)):fe.tokens.unshift({type:"text",text:Ze}):Te+=Ze),Te+=this.parse(fe.tokens,Le),oe+=this.renderer.listitem(Te,Ke,Re);M+=this.renderer.list(oe,ye,De);continue}case"html":{M+=this.renderer.html(de.text);continue}case"paragraph":{M+=this.renderer.paragraph(this.parseInline(de.tokens));continue}case"text":{for(oe=de.tokens?this.parseInline(de.tokens):de.text;R+1<at&&o[R+1].type==="text";)de=o[++R],oe+=`
`+(de.tokens?this.parseInline(de.tokens):de.text);M+=m?this.renderer.paragraph(oe):oe;continue}default:{var st='Token with "'+de.type+'" type was not found.';if(this.options.silent){console.error(st);return}else throw new Error(st)}}}return M},W.parseInline=function(o,m){m=m||this.renderer;var M="",R,u,L,T=o.length;for(R=0;R<T;R++){if(u=o[R],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[u.type]&&(L=this.options.extensions.renderers[u.type].call({parser:this},u),L!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(u.type))){M+=L||"";continue}switch(u.type){case"escape":{M+=m.text(u.text);break}case"html":{M+=m.html(u.text);break}case"link":{M+=m.link(u.href,u.title,this.parseInline(u.tokens,m));break}case"image":{M+=m.image(u.href,u.title,u.text);break}case"strong":{M+=m.strong(this.parseInline(u.tokens,m));break}case"em":{M+=m.em(this.parseInline(u.tokens,m));break}case"codespan":{M+=m.codespan(u.text);break}case"br":{M+=m.br();break}case"del":{M+=m.del(this.parseInline(u.tokens,m));break}case"text":{M+=m.text(u.text);break}default:{var P='Token with "'+u.type+'" type was not found.';if(this.options.silent){console.error(P);return}else throw new Error(P)}}}return M},K}();function le(K,W,a){if(typeof K>"u"||K===null)throw new Error("marked(): input parameter is undefined or null");if(typeof K!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(K)+", string expected");if(typeof W=="function"&&(a=W,W=null),W=B({},le.defaults,W||{}),O(W),a){var o=W.highlight,m;try{m=ke.lex(K,W)}catch(T){return a(T)}var M=function(P){var H;if(!P)try{W.walkTokens&&le.walkTokens(m,W.walkTokens),H=he.parse(m,W)}catch(X){P=X}return W.highlight=o,P?a(P):a(null,H)};if(!o||o.length<3||(delete W.highlight,!m.length))return M();var R=0;le.walkTokens(m,function(T){T.type==="code"&&(R++,setTimeout(function(){o(T.text,T.lang,function(P,H){if(P)return M(P);H!=null&&H!==T.text&&(T.text=H,T.escaped=!0),R--,R===0&&M()})},0))}),R===0&&M();return}function u(T){if(T.message+=`
Please report this to https://github.com/markedjs/marked.`,W.silent)return"<p>An error occurred:</p><pre>"+e(T.message+"",!0)+"</pre>";throw T}try{var L=ke.lex(K,W);if(W.walkTokens){if(W.async)return Promise.all(le.walkTokens(L,W.walkTokens)).then(function(){return he.parse(L,W)}).catch(u);le.walkTokens(L,W.walkTokens)}return he.parse(L,W)}catch(T){u(T)}}le.options=le.setOptions=function(K){return B(le.defaults,K),w(le.defaults),le},le.getDefaults=N,le.defaults=re.defaults,le.use=function(){for(var K=arguments.length,W=new Array(K),a=0;a<K;a++)W[a]=arguments[a];var o=B.apply(void 0,[{}].concat(W)),m=le.defaults.extensions||{renderers:{},childTokens:{}},M;W.forEach(function(R){if(R.extensions&&(M=!0,R.extensions.forEach(function(L){if(!L.name)throw new Error("extension name required");if(L.renderer){var T=m.renderers?m.renderers[L.name]:null;T?m.renderers[L.name]=function(){for(var P=arguments.length,H=new Array(P),X=0;X<P;X++)H[X]=arguments[X];var ie=L.renderer.apply(this,H);return ie===!1&&(ie=T.apply(this,H)),ie}:m.renderers[L.name]=L.renderer}if(L.tokenizer){if(!L.level||L.level!=="block"&&L.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");m[L.level]?m[L.level].unshift(L.tokenizer):m[L.level]=[L.tokenizer],L.start&&(L.level==="block"?m.startBlock?m.startBlock.push(L.start):m.startBlock=[L.start]:L.level==="inline"&&(m.startInline?m.startInline.push(L.start):m.startInline=[L.start]))}L.childTokens&&(m.childTokens[L.name]=L.childTokens)})),R.renderer&&function(){var L=le.defaults.renderer||new Fe,T=function(X){var ie=L[X];L[X]=function(){for(var oe=arguments.length,de=new Array(oe),ye=0;ye<oe;ye++)de[ye]=arguments[ye];var De=R.renderer[X].apply(L,de);return De===!1&&(De=ie.apply(L,de)),De}};for(var P in R.renderer)T(P);o.renderer=L}(),R.tokenizer&&function(){var L=le.defaults.tokenizer||new Y,T=function(X){var ie=L[X];L[X]=function(){for(var oe=arguments.length,de=new Array(oe),ye=0;ye<oe;ye++)de[ye]=arguments[ye];var De=R.tokenizer[X].apply(L,de);return De===!1&&(De=ie.apply(L,de)),De}};for(var P in R.tokenizer)T(P);o.tokenizer=L}(),R.walkTokens){var u=le.defaults.walkTokens;o.walkTokens=function(L){var T=[];return T.push(R.walkTokens.call(this,L)),u&&(T=T.concat(u.call(this,L))),T}}M&&(o.extensions=m),le.setOptions(o)})},le.walkTokens=function(K,W){for(var a=[],o=function(){var u=M.value;switch(a=a.concat(W.call(le,u)),u.type){case"table":{for(var L=F(u.header),T;!(T=L()).done;){var P=T.value;a=a.concat(le.walkTokens(P.tokens,W))}for(var H=F(u.rows),X;!(X=H()).done;)for(var ie=X.value,oe=F(ie),de;!(de=oe()).done;){var ye=de.value;a=a.concat(le.walkTokens(ye.tokens,W))}break}case"list":{a=a.concat(le.walkTokens(u.items,W));break}default:le.defaults.extensions&&le.defaults.extensions.childTokens&&le.defaults.extensions.childTokens[u.type]?le.defaults.extensions.childTokens[u.type].forEach(function(De){a=a.concat(le.walkTokens(u[De],W))}):u.tokens&&(a=a.concat(le.walkTokens(u.tokens,W)))}},m=F(K),M;!(M=m()).done;)o();return a},le.parseInline=function(K,W){if(typeof K>"u"||K===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof K!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(K)+", string expected");W=B({},le.defaults,W||{}),O(W);try{var a=ke.lexInline(K,W);return W.walkTokens&&le.walkTokens(a,W.walkTokens),he.parseInline(a,W)}catch(o){if(o.message+=`
Please report this to https://github.com/markedjs/marked.`,W.silent)return"<p>An error occurred:</p><pre>"+e(o.message+"",!0)+"</pre>";throw o}},le.Parser=he,le.parser=he.parse,le.Renderer=Fe,le.TextRenderer=ue,le.Lexer=ke,le.lexer=ke.lex,le.Tokenizer=Y,le.Slugger=Q,le.parse=le;var Ne=le.options,te=le.setOptions,$e=le.use,Ae=le.walkTokens,Oe=le.parseInline,Ie=le,Ce=he.parse,se=ke.lex;re.Lexer=ke,re.Parser=he,re.Renderer=Fe,re.Slugger=Q,re.TextRenderer=ue,re.Tokenizer=Y,re.getDefaults=N,re.lexer=se,re.marked=le,re.options=Ne,re.parse=Ie,re.parseInline=Oe,re.parser=Ce,re.setOptions=te,re.use=$e,re.walkTokens=Ae,Object.defineProperty(re,"__esModule",{value:!0})}),define(we[60],ve([1,0]),function(re,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.MarshalledId=void 0;var i;(function(n){n[n.Uri=1]="Uri",n[n.Regexp=2]="Regexp",n[n.ScmResource=3]="ScmResource",n[n.ScmResourceGroup=4]="ScmResourceGroup",n[n.ScmProvider=5]="ScmProvider",n[n.CommentController=6]="CommentController",n[n.CommentThread=7]="CommentThread",n[n.CommentThreadInstance=8]="CommentThreadInstance",n[n.CommentThreadReply=9]="CommentThreadReply",n[n.CommentNode=10]="CommentNode",n[n.CommentThreadNode=11]="CommentThreadNode",n[n.TimelineActionContext=12]="TimelineActionContext",n[n.NotebookCellActionContext=13]="NotebookCellActionContext",n[n.NotebookActionContext=14]="NotebookActionContext",n[n.TerminalContext=15]="TerminalContext",n[n.TestItemContext=16]="TestItemContext",n[n.Date=17]="Date",n[n.TestMessageMenuArgs=18]="TestMessageMenuArgs"})(i||(t.MarshalledId=i={}))}),define(we[93],ve([1,0]),function(re,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Ck=i;function i(s){const r=F(s);if(r&&r.length>0)return new Uint32Array(r)}let n=0;const j=new Uint32Array(10);function F(s){if(n=0,N(s,y,D.InitialConsonant),n>0||(N(s,$,D.Vowel),n>0)||(N(s,g,D.FinalConsonant),n>0)||(N(s,e,D.CompatibilityJamo),n))return j.subarray(0,n);if(s>=44032&&s<=55203){const r=s-44032,h=r%588,l=Math.floor(r/588),v=Math.floor(h/28),k=h%28-1;if(l<y.length?N(l,y,0):D.InitialConsonant+l-D.CompatibilityJamo<e.length&&N(D.InitialConsonant+l,e,D.CompatibilityJamo),v<$.length?N(v,$,0):D.Vowel+v-D.CompatibilityJamo<e.length&&N(D.Vowel+v-D.CompatibilityJamo,e,D.CompatibilityJamo),k>=0&&(k<g.length?N(k,g,0):D.FinalConsonant+k-D.CompatibilityJamo<e.length&&N(D.FinalConsonant+k-D.CompatibilityJamo,e,D.CompatibilityJamo)),n>0)return j.subarray(0,n)}}function N(s,r,h){s>=h&&s<h+r.length&&w(r[s-h])}function w(s){s!==c.NUL&&(j[n++]=s&255,s>>8&&(j[n++]=s>>8&255),s>>16&&(j[n++]=s>>16&255))}var D;(function(s){s[s.InitialConsonant=4352]="InitialConsonant",s[s.Vowel=4449]="Vowel",s[s.FinalConsonant=4520]="FinalConsonant",s[s.CompatibilityJamo=12593]="CompatibilityJamo"})(D||(D={}));var c;(function(s){s[s.NUL=0]="NUL",s[s.A=65]="A",s[s.B=66]="B",s[s.C=67]="C",s[s.D=68]="D",s[s.E=69]="E",s[s.F=70]="F",s[s.G=71]="G",s[s.H=72]="H",s[s.I=73]="I",s[s.J=74]="J",s[s.K=75]="K",s[s.L=76]="L",s[s.M=77]="M",s[s.N=78]="N",s[s.O=79]="O",s[s.P=80]="P",s[s.Q=81]="Q",s[s.R=82]="R",s[s.S=83]="S",s[s.T=84]="T",s[s.U=85]="U",s[s.V=86]="V",s[s.W=87]="W",s[s.X=88]="X",s[s.Y=89]="Y",s[s.Z=90]="Z",s[s.a=97]="a",s[s.b=98]="b",s[s.c=99]="c",s[s.d=100]="d",s[s.e=101]="e",s[s.f=102]="f",s[s.g=103]="g",s[s.h=104]="h",s[s.i=105]="i",s[s.j=106]="j",s[s.k=107]="k",s[s.l=108]="l",s[s.m=109]="m",s[s.n=110]="n",s[s.o=111]="o",s[s.p=112]="p",s[s.q=113]="q",s[s.r=114]="r",s[s.s=115]="s",s[s.t=116]="t",s[s.u=117]="u",s[s.v=118]="v",s[s.w=119]="w",s[s.x=120]="x",s[s.y=121]="y",s[s.z=122]="z"})(c||(c={}));var p;(function(s){s[s.fa=24934]="fa",s[s.fg=26470]="fg",s[s.fq=29030]="fq",s[s.fr=29286]="fr",s[s.ft=29798]="ft",s[s.fv=30310]="fv",s[s.fx=30822]="fx",s[s.hk=27496]="hk",s[s.hl=27752]="hl",s[s.ho=28520]="ho",s[s.ml=27757]="ml",s[s.nj=27246]="nj",s[s.nl=27758]="nl",s[s.np=28782]="np",s[s.qt=29809]="qt",s[s.rt=29810]="rt",s[s.sg=26483]="sg",s[s.sw=30579]="sw"})(p||(p={}));const y=new Uint8Array([c.r,c.R,c.s,c.e,c.E,c.f,c.a,c.q,c.Q,c.t,c.T,c.d,c.w,c.W,c.c,c.z,c.x,c.v,c.g]),$=new Uint16Array([c.k,c.o,c.i,c.O,c.j,c.p,c.u,c.P,c.h,p.hk,p.ho,p.hl,c.y,c.n,p.nj,p.np,p.nl,c.b,c.m,p.ml,c.l]),g=new Uint16Array([c.r,c.R,p.rt,c.s,p.sw,p.sg,c.e,c.f,p.fr,p.fa,p.fq,p.ft,p.fx,p.fv,p.fg,c.a,c.q,p.qt,c.t,c.T,c.d,c.w,c.c,c.z,c.x,c.v,c.g]),e=new Uint16Array([c.r,c.R,p.rt,c.s,p.sw,p.sg,c.e,c.E,c.f,p.fr,p.fa,p.fq,p.ft,p.fx,p.fv,p.fg,c.a,c.q,c.Q,p.qt,c.t,c.T,c.d,c.w,c.W,c.c,c.z,c.x,c.v,c.g,c.k,c.o,c.i,c.O,c.j,c.p,c.u,c.P,c.h,p.hk,p.ho,p.hl,c.y,c.n,p.nj,p.np,p.nl,c.b,c.m,p.ml,c.l])}),define(we[94],ve([1,0]),function(re,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$eW=void 0;class i{constructor(j,F=0,N=j.length,w=F-1){this.a=j,this.b=F,this.c=N,this.d=w}current(){return this.d===this.b-1||this.d===this.c?null:this.a[this.d]}next(){return this.d=Math.min(this.d+1,this.c),this.current()}previous(){return this.d=Math.max(this.d-1,this.b-1),this.current()}first(){return this.d=this.b,this.current()}last(){return this.d=this.c-1,this.current()}}t.$eW=i}),define(we[95],ve([1,0,57,94]),function(re,t,i,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$gW=t.$fW=void 0;class j{constructor(w=[],D=10){this.h(w),this.b=D,this.d()}getHistory(){return this.j}add(w){this.a.delete(w),this.a.add(w),this.d()}next(){return this.c.next()}previous(){return this.g()!==0?this.c.previous():null}current(){return this.c.current()}first(){return this.c.first()}last(){return this.c.last()}isFirst(){return this.g()===0}isLast(){return this.g()>=this.j.length-1}isNowhere(){return this.c.current()===null}has(w){return this.a.has(w)}clear(){this.h([]),this.d()}d(){this.f();const w=this.j;this.c=new n.$eW(w,0,w.length,w.length)}f(){const w=this.j;w.length>this.b&&this.h(w.slice(w.length-this.b))}g(){const w=this.c.current();return w?this.j.indexOf(w):-1}h(w){this.a=new Set;for(const D of w)this.a.add(D)}get j(){const w=[];return this.a.forEach(D=>w.push(D)),w}}t.$fW=j;class F{get size(){return this.f}constructor(w,D=10,c=p=>p){if(this.g=D,this.h=c,w.length<1)throw new Error("not supported");this.f=1,this.b=this.c=this.d={value:w[0],previous:void 0,next:void 0},this.a=new i.$g([w[0]],c);for(let p=1;p<w.length;p++)this.add(w[p])}add(w){const D={value:w,previous:this.c,next:void 0};for(this.c.next=D,this.c=D,this.d=this.c,this.f++,this.a.has(w)?this.j(w):this.a.add(w);this.f>this.g;)this.a.delete(this.b.value),this.b=this.b.next,this.b.previous=void 0,this.f--}replaceLast(w){if(this.h(this.c.value)===this.h(w))return w;const D=this.c.value;return this.a.delete(D),this.c.value=w,this.a.has(w)?this.j(w):this.a.add(w),D}prepend(w){if(this.f===this.g||this.a.has(w))return;const D={value:w,previous:void 0,next:this.b};this.b.previous=D,this.b=D,this.f++,this.a.add(w)}isAtEnd(){return this.d===this.c}current(){return this.d.value}previous(){return this.d.previous&&(this.d=this.d.previous),this.d.value}next(){return this.d.next&&(this.d=this.d.next),this.d.value}has(w){return this.a.has(w)}resetCursor(){return this.d=this.c,this.d.value}*[Symbol.iterator](){let w=this.b;for(;w;)yield w.value,w=w.next}j(w){let D=this.b;const c=this.h(w);for(;D!==this.c;)this.h(D.value)===c&&(D===this.b?(this.b=this.b.next,this.b.previous=void 0):(D.previous.next=D.next,D.next.previous=D.previous),this.f--),D=D.next}}t.$gW=F}),define(we[37],ve([1,0]),function(re,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Mm=t.$Lm=t.$Km=void 0,t.$Im=i,t.rot=n,t.$Nm=w;function i(D,c,p){return Math.min(Math.max(D,c),p)}function n(D,c){return(c+D%c)%c}class j{constructor(){this.a=0}getNext(){return this.a++}}t.$Km=j;class F{constructor(){this.a=1,this.b=0}update(c){return this.b=this.b+(c-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}t.$Lm=F;class N{constructor(c){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(c),this.c.fill(0,0,c)}update(c){const p=this.c[this.d];return this.c[this.d]=c,this.d=(this.d+1)%this.c.length,this.e-=p,this.e+=c,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}t.$Mm=N;function w(D,c,p,y,$,g,e,s){const r=e-p,h=s-y,l=$-p,v=g-y,k=D-p,A=c-y,d=r*r+h*h,f=r*l+h*v,b=r*k+h*A,S=l*l+v*v,U=l*k+v*A,_=1/(d*S-f*f),B=(S*b-f*U)*_,E=(d*U-f*b)*_;return B>=0&&E>=0&&B+E<1}}),define(we[26],ve([1,0]),function(re,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$_c=void 0,t.$ad=F,t.$bd=$;class i{constructor(e,s,r){this.owner=e,this.debugNameSource=s,this.referenceFn=r}getDebugName(e){return F(e,this)}}t.$_c=i;const n=new Map,j=new WeakMap;function F(g,e){const s=j.get(g);if(s)return s;const r=N(g,e);if(r){let h=n.get(r)??0;h++,n.set(r,h);const l=h===1?r:`${r}#${h}`;return j.set(g,l),l}}function N(g,e){const s=j.get(g);if(s)return s;const r=e.owner?p(e.owner)+".":"";let h;const l=e.debugNameSource;if(l!==void 0)if(typeof l=="function"){if(h=l(),h!==void 0)return r+h}else return r+l;const v=e.referenceFn;if(v!==void 0&&(h=$(v),h!==void 0))return r+h;if(e.owner!==void 0){const k=w(e.owner,g);if(k!==void 0)return r+k}}function w(g,e){for(const s in g)if(g[s]===e)return s}const D=new Map,c=new WeakMap;function p(g){const e=c.get(g);if(e)return e;const s=y(g);let r=D.get(s)??0;r++,D.set(s,r);const h=r===1?s:`${s}#${r}`;return c.set(g,h),h}function y(g){const e=g.constructor;return e?e.name:"Object"}function $(g){const e=g.toString(),r=/\/\*\*\s*@description\s*([^*]*)\*\//.exec(e);return(r?r[1]:void 0)?.trim()}}),define(we[31],ve([1,0]),function(re,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Kd=void 0,t.$Id=n,t.$Jd=j;let i;function n(s){i=s}function j(){return i}class F{constructor(){this.a=0,this.d=new WeakMap}b(r){return N([w(g("|  ",this.a)),r])}c(r){return r.hadValue?r.didChange?[w(" "),c(p(r.oldValue,70),{color:"red",strikeThrough:!0}),w(" "),c(p(r.newValue,60),{color:"green"})]:[w(" (unchanged)")]:[w(" "),c(p(r.newValue,60),{color:"green"}),w(" (initial)")]}handleObservableChanged(r,h){console.log(...this.b([D("observable value changed"),c(r.debugName,{color:"BlueViolet"}),...this.c(h)]))}formatChanges(r){if(r.size!==0)return c(" (changed deps: "+[...r].map(h=>h.debugName).join(", ")+")",{color:"gray"})}handleDerivedCreated(r){const h=r.handleChange;this.d.set(r,new Set),r.handleChange=(l,v)=>(this.d.get(r).add(l),h.apply(r,[l,v]))}handleDerivedRecomputed(r,h){const l=this.d.get(r);console.log(...this.b([D("derived recomputed"),c(r.debugName,{color:"BlueViolet"}),...this.c(h),this.formatChanges(l),{data:[{fn:r._debugNameData.referenceFn??r._computeFn}]}])),l.clear()}handleFromEventObservableTriggered(r,h){console.log(...this.b([D("observable from event triggered"),c(r.debugName,{color:"BlueViolet"}),...this.c(h),{data:[{fn:r._getValue}]}]))}handleAutorunCreated(r){const h=r.handleChange;this.d.set(r,new Set),r.handleChange=(l,v)=>(this.d.get(r).add(l),h.apply(r,[l,v]))}handleAutorunTriggered(r){const h=this.d.get(r);console.log(...this.b([D("autorun"),c(r.debugName,{color:"BlueViolet"}),this.formatChanges(h),{data:[{fn:r._debugNameData.referenceFn??r._runFn}]}])),h.clear(),this.a++}handleAutorunFinished(r){this.a--}handleBeginTransaction(r){let h=r.getDebugName();h===void 0&&(h=""),console.log(...this.b([D("transaction"),c(h,{color:"BlueViolet"}),{data:[{fn:r._fn}]}])),this.a++}handleEndTransaction(){this.a--}}t.$Kd=F;function N(s){const r=new Array,h=[];let l="";function v(A){if("length"in A)for(const d of A)d&&v(d);else"text"in A?(l+=`%c${A.text}`,r.push(A.style),A.data&&h.push(...A.data)):"data"in A&&h.push(...A.data)}v(s);const k=[l,...r];return k.push(...h),k}function w(s){return c(s,{color:"black"})}function D(s){return c(e(`${s}: `,10),{color:"black",bold:!0})}function c(s,r={color:"black"}){function h(v){return Object.entries(v).reduce((k,[A,d])=>`${k}${A}:${d};`,"")}const l={color:r.color};return r.strikeThrough&&(l["text-decoration"]="line-through"),r.bold&&(l["font-weight"]="bold"),{text:s,style:h(l)}}function p(s,r){switch(typeof s){case"number":return""+s;case"string":return s.length+2<=r?`"${s}"`:`"${s.substr(0,r-7)}"+...`;case"boolean":return s?"true":"false";case"undefined":return"undefined";case"object":return s===null?"null":Array.isArray(s)?y(s,r):$(s,r);case"symbol":return s.toString();case"function":return`[[Function${s.name?" "+s.name:""}]]`;default:return""+s}}function y(s,r){let h="[ ",l=!0;for(const v of s){if(l||(h+=", "),h.length-5>r){h+="...";break}l=!1,h+=`${p(v,r-h.length)}`}return h+=" ]",h}function $(s,r){let h="{ ",l=!0;for(const[v,k]of Object.entries(s)){if(l||(h+=", "),h.length-5>r){h+="...";break}l=!1,h+=`${v}: ${p(k,r-h.length)}`}return h+=" }",h}function g(s,r){let h="";for(let l=1;l<=r;l++)h+=s;return h}function e(s,r){for(;s.length<r;)s+=" ";return s}}),define(we[44],ve([1,0,42,2,26,31]),function(re,t,i,n,j,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$od=void 0,t.$id=N,t.$jd=w,t.$kd=D,t.$ld=c,t.$md=p,t.$nd=y;function N(e){return new g(new j.$_c(void 0,void 0,e),e,void 0,void 0)}function w(e,s){return new g(new j.$_c(e.owner,e.debugName,e.debugReferenceFn??s),s,void 0,void 0)}function D(e,s){return new g(new j.$_c(e.owner,e.debugName,e.debugReferenceFn??s),s,e.createEmptyChangeSummary,e.handleChange)}function c(e,s){const r=new n.$Sc,h=D({owner:e.owner,debugName:e.debugName,debugReferenceFn:e.debugReferenceFn??s,createEmptyChangeSummary:e.createEmptyChangeSummary,handleChange:e.handleChange},(l,v)=>{r.clear(),s(l,v,r)});return(0,n.$Rc)(()=>{h.dispose(),r.dispose()})}function p(e){const s=new n.$Sc,r=w({owner:void 0,debugName:void 0,debugReferenceFn:e},h=>{s.clear(),e(h,s)});return(0,n.$Rc)(()=>{r.dispose(),s.dispose()})}function y(e,s){let r;return w({debugReferenceFn:s},h=>{const l=e.read(h),v=r;r=l,s({lastValue:v,newValue:l})})}var $;(function(e){e[e.dependenciesMightHaveChanged=1]="dependenciesMightHaveChanged",e[e.stale=2]="stale",e[e.upToDate=3]="upToDate"})($||($={}));class g{get debugName(){return this._debugNameData.getDebugName(this)??"(anonymous)"}constructor(s,r,h,l){this._debugNameData=s,this._runFn=r,this.h=h,this.i=l,this.a=$.stale,this.b=0,this.c=!1,this.e=new Set,this.f=new Set,this.g=this.h?.(),(0,F.$Jd)()?.handleAutorunCreated(this),this.j(),(0,n.$Kc)(this)}dispose(){this.c=!0;for(const s of this.e)s.removeObserver(this);this.e.clear(),(0,n.$Lc)(this)}j(){if(this.a===$.upToDate)return;const s=this.f;this.f=this.e,this.e=s,this.a=$.upToDate;const r=this.c;try{if(!r){(0,F.$Jd)()?.handleAutorunTriggered(this);const h=this.g;this.g=this.h?.(),this._runFn(this,h)}}finally{r||(0,F.$Jd)()?.handleAutorunFinished(this);for(const h of this.f)h.removeObserver(this);this.f.clear()}}toString(){return`Autorun<${this.debugName}>`}beginUpdate(){this.a===$.upToDate&&(this.a=$.dependenciesMightHaveChanged),this.b++}endUpdate(){if(this.b===1)do{if(this.a===$.dependenciesMightHaveChanged){this.a=$.upToDate;for(const s of this.e)if(s.reportChanges(),this.a===$.stale)break}this.j()}while(this.a!==$.upToDate);this.b--,(0,i.$gd)(()=>this.b>=0)}handlePossibleChange(s){this.a===$.upToDate&&this.e.has(s)&&!this.f.has(s)&&(this.a=$.dependenciesMightHaveChanged)}handleChange(s,r){this.e.has(s)&&!this.f.has(s)&&(!this.i||this.i({changedObservable:s,change:r,didChange:l=>l===s},this.g))&&(this.a=$.stale)}readObservable(s){if(this.c)return s.get();s.addObserver(this);const r=s.get();return this.e.add(s),this.f.delete(s),r}}t.$od=g,function(e){e.Observer=g}(N||(t.$id=N={}))}),define(we[27],ve([1,0,30,26,31]),function(re,t,i,n,j){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$7d=t.$5d=t.$3d=t.$Xd=t.$Wd=void 0,t.$Td=N,t.$Ud=D,t.$Vd=p,t.$Yd=g,t.$Zd=s,t.$1d=r,t.$2d=h,t.$4d=v,t.$6d=A;let F;function N(f){F=f}let w;function D(f){w=f}let c;function p(f){c=f}class y{get TChange(){return null}reportChanges(){this.get()}read(b){return b?b.readObservable(this):this.get()}map(b,S){const U=S===void 0?void 0:b,_=S===void 0?b:S;return c({owner:U,debugName:()=>{const B=(0,n.$bd)(_);if(B!==void 0)return B;const I=/^\s*\(?\s*([a-zA-Z_$][a-zA-Z_$0-9]*)\s*\)?\s*=>\s*\1(?:\??)\.([a-zA-Z_$][a-zA-Z_$0-9]*)\s*$/.exec(_.toString());if(I)return`${this.debugName}.${I[2]}`;if(!U)return`${this.debugName} (mapped)`},debugReferenceFn:_},B=>_(this.read(B),B))}recomputeInitiallyAndOnChange(b,S){return b.add(F(this,S)),this}keepObserved(b){return b.add(w(this)),this}get a(){return this.get()}}t.$Wd=y;class $ extends y{constructor(){super(...arguments),this.b=new Set}addObserver(b){const S=this.b.size;this.b.add(b),S===0&&this.c()}removeObserver(b){this.b.delete(b)&&this.b.size===0&&this.f()}c(){}f(){}}t.$Xd=$;function g(f,b){const S=new l(f,b);try{f(S)}finally{S.finish()}}let e;function s(f){if(e)f(e);else{const b=new l(f,void 0);e=b;try{f(b)}finally{b.finish(),e=void 0}}}async function r(f,b){const S=new l(f,b);try{await f(S)}finally{S.finish()}}function h(f,b,S){f?b(f):g(b,S)}class l{constructor(b,S){this._fn=b,this.b=S,this.a=[],(0,j.$Jd)()?.handleBeginTransaction(this)}getDebugName(){return this.b?this.b():(0,n.$bd)(this._fn)}updateObserver(b,S){this.a.push({observer:b,observable:S}),b.beginUpdate(S)}finish(){const b=this.a;for(let S=0;S<b.length;S++){const{observer:U,observable:_}=b[S];U.endUpdate(_)}this.a=null,(0,j.$Jd)()?.handleEndTransaction()}}t.$3d=l;function v(f,b){let S;return typeof f=="string"?S=new n.$_c(void 0,f,void 0):S=new n.$_c(f,void 0,void 0),new k(S,b,i.$5c)}class k extends ${get debugName(){return this.e.getDebugName(this)??"ObservableValue"}constructor(b,S,U){super(),this.e=b,this.g=U,this.d=S}get(){return this.d}set(b,S,U){if(U===void 0&&this.g(this.d,b))return;let _;S||(S=_=new l(()=>{},()=>`Setting ${this.debugName}`));try{const B=this.d;this.h(b),(0,j.$Jd)()?.handleObservableChanged(this,{oldValue:B,newValue:b,change:U,didChange:!0,hadValue:!0});for(const E of this.b)S.updateObserver(E,this),E.handleChange(this,U)}finally{_&&_.finish()}}toString(){return`${this.debugName}: ${this.d}`}h(b){this.d=b}}t.$5d=k;function A(f,b){let S;return typeof f=="string"?S=new n.$_c(void 0,f,void 0):S=new n.$_c(f,void 0,void 0),new d(S,b,i.$5c)}class d extends k{h(b){this.d!==b&&(this.d&&this.d.dispose(),this.d=b)}dispose(){this.d?.dispose()}}t.$7d=d}),define(we[45],ve([1,0,42,30,2,27,26,31]),function(re,t,i,n,j,F,N,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Sd=t.$Rd=void 0,t.$Ld=D,t.$Md=c,t.$Nd=p,t.$Od=y,t.$Pd=$,t.$Qd=g;function D(h,l){return l!==void 0?new s(new N.$_c(h,void 0,l),l,void 0,void 0,void 0,n.$5c):new s(new N.$_c(void 0,void 0,h),h,void 0,void 0,void 0,n.$5c)}function c(h,l,v){return new r(new N.$_c(h,void 0,l),l,void 0,void 0,void 0,n.$5c,v)}function p(h,l){return new s(new N.$_c(h.owner,h.debugName,h.debugReferenceFn),l,void 0,void 0,h.onLastObserverRemoved,h.equalsFn??n.$5c)}(0,F.$Vd)(p);function y(h,l){return new s(new N.$_c(h.owner,h.debugName,void 0),l,h.createEmptyChangeSummary,h.handleChange,void 0,h.equalityComparer??n.$5c)}function $(h,l){let v,k;l===void 0?(v=h,k=void 0):(k=h,v=l);const A=new j.$Sc;return new s(new N.$_c(k,void 0,v),d=>(A.clear(),v(d,A)),void 0,void 0,()=>A.dispose(),n.$5c)}function g(h,l){let v,k;l===void 0?(v=h,k=void 0):(k=h,v=l);let A;return new s(new N.$_c(k,void 0,v),d=>{A?A.clear():A=new j.$Sc;const f=v(d);return f&&A.add(f),f},void 0,void 0,()=>{A&&(A.dispose(),A=void 0)},n.$5c)}var e;(function(h){h[h.initial=0]="initial",h[h.dependenciesMightHaveChanged=1]="dependenciesMightHaveChanged",h[h.stale=2]="stale",h[h.upToDate=3]="upToDate"})(e||(e={}));class s extends F.$Xd{get debugName(){return this._debugNameData.getDebugName(this)??"(anonymous)"}constructor(l,v,k,A,d=void 0,f){super(),this._debugNameData=l,this._computeFn=v,this.m=k,this.n=A,this.p=d,this.q=f,this.e=e.initial,this.g=void 0,this.h=0,this.j=new Set,this.k=new Set,this.l=void 0,this.l=this.m?.(),(0,w.$Jd)()?.handleDerivedCreated(this)}f(){this.e=e.initial,this.g=void 0;for(const l of this.j)l.removeObserver(this);this.j.clear(),this.p?.()}get(){if(this.b.size===0){const l=this._computeFn(this,this.m?.());return this.f(),l}else{do{if(this.e===e.dependenciesMightHaveChanged){for(const l of this.j)if(l.reportChanges(),this.e===e.stale)break}this.e===e.dependenciesMightHaveChanged&&(this.e=e.upToDate),this.t()}while(this.e!==e.upToDate);return this.g}}t(){if(this.e===e.upToDate)return;const l=this.k;this.k=this.j,this.j=l;const v=this.e!==e.initial,k=this.g;this.e=e.upToDate;const A=this.l;this.l=this.m?.();try{this.g=this._computeFn(this,A)}finally{for(const f of this.k)f.removeObserver(this);this.k.clear()}const d=v&&!this.q(k,this.g);if((0,w.$Jd)()?.handleDerivedRecomputed(this,{oldValue:k,newValue:this.g,change:void 0,didChange:d,hadValue:v}),d)for(const f of this.b)f.handleChange(this,void 0)}toString(){return`LazyDerived<${this.debugName}>`}beginUpdate(l){this.h++;const v=this.h===1;if(this.e===e.upToDate&&(this.e=e.dependenciesMightHaveChanged,!v))for(const k of this.b)k.handlePossibleChange(this);if(v)for(const k of this.b)k.beginUpdate(this)}endUpdate(l){if(this.h--,this.h===0){const v=[...this.b];for(const k of v)k.endUpdate(this)}(0,i.$gd)(()=>this.h>=0)}handlePossibleChange(l){if(this.e===e.upToDate&&this.j.has(l)&&!this.k.has(l)){this.e=e.dependenciesMightHaveChanged;for(const v of this.b)v.handlePossibleChange(this)}}handleChange(l,v){if(this.j.has(l)&&!this.k.has(l)){const k=this.n?this.n({changedObservable:l,change:v,didChange:d=>d===l},this.l):!0,A=this.e===e.upToDate;if(k&&(this.e===e.dependenciesMightHaveChanged||A)&&(this.e=e.stale,A))for(const d of this.b)d.handlePossibleChange(this)}}readObservable(l){l.addObserver(this);const v=l.get();return this.j.add(l),this.k.delete(l),v}addObserver(l){const v=!this.b.has(l)&&this.h>0;super.addObserver(l),v&&l.beginUpdate(this)}removeObserver(l){const v=this.b.has(l)&&this.h>0;super.removeObserver(l),v&&l.endUpdate(this)}}t.$Rd=s;class r extends s{constructor(l,v,k,A,d=void 0,f,b){super(l,v,k,A,d,f),this.set=b}}t.$Sd=r}),define(we[96],ve([1,0,27]),function(re,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$be=void 0;class n extends i.$Xd{get debugName(){return this.h.getDebugName(this)??"LazyObservableValue"}constructor(F,N,w){super(),this.h=F,this.j=w,this.e=!0,this.g=[],this.l=0,this.d=N}get(){return this.k(),this.d}k(){if(!this.e)if(this.e=!0,this.g.length>0){for(const F of this.b)for(const N of this.g)F.handleChange(this,N);this.g.length=0}else for(const F of this.b)F.handleChange(this,void 0)}m(){if(this.l++,this.l===1)for(const F of this.b)F.beginUpdate(this)}n(){if(this.l--,this.l===0){this.k();const F=[...this.b];for(const N of F)N.endUpdate(this)}}addObserver(F){const N=!this.b.has(F)&&this.l>0;super.addObserver(F),N&&F.beginUpdate(this)}removeObserver(F){const N=this.b.has(F)&&this.l>0;super.removeObserver(F),N&&F.endUpdate(this)}set(F,N,w){if(w===void 0&&this.j(this.d,F))return;let D;N||(N=D=new i.$3d(()=>{},()=>`Setting ${this.debugName}`));try{if(this.e=!1,this.o(F),w!==void 0&&this.g.push(w),N.updateObserver({beginUpdate:()=>this.m(),endUpdate:()=>this.n(),handleChange:(c,p)=>{},handlePossibleChange:c=>{}},this),this.l>1)for(const c of this.b)c.handlePossibleChange(this)}finally{D&&D.finish()}}toString(){return`${this.debugName}: ${this.d}`}o(F){this.d=F}}t.$be=n}),define(we[97],ve([1,0,30,27,26,96]),function(re,t,i,n,j,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ce=N;function N(w,D){return w.lazy?new F.$be(new j.$_c(w.owner,w.debugName,void 0),D,w.equalsFn??i.$5c):new n.$5d(new j.$_c(w.owner,w.debugName,void 0),D,w.equalsFn??i.$5c)}}),define(we[5],ve([1,0]),function(re,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$J=t.$I=t.$H=t.$G=t.$F=t.OS=t.OperatingSystem=t.$C=t.$B=t.$A=t.$z=t.$y=t.Language=t.$x=t.$w=t.$v=t.$u=t.$t=t.$s=t.$r=t.$q=t.$p=t.$o=t.$n=t.$m=t.$l=t.$k=t.$j=t.Platform=t.$h=void 0,t.$i=d,t.$E=B,t.$K=E,t.$h="en";let i=!1,n=!1,j=!1,F=!1,N=!1,w=!1,D=!1,c=!1,p=!1,y=!1,$,g=t.$h,e=t.$h,s,r;const h=globalThis;let l;typeof h.vscode<"u"&&typeof h.vscode.process<"u"?l=h.vscode.process:typeof process<"u"&&typeof process?.versions?.node=="string"&&(l=process);const v=typeof l?.versions?.electron=="string",k=v&&l?.type==="renderer";if(typeof l=="object"){i=l.platform==="win32",n=l.platform==="darwin",j=l.platform==="linux",F=j&&!!l.env.SNAP&&!!l.env.SNAP_REVISION,D=v,p=!!l.env.CI||!!l.env.BUILD_ARTIFACTSTAGINGDIRECTORY,$=t.$h,g=t.$h;const I=l.env.VSCODE_NLS_CONFIG;if(I)try{const z=JSON.parse(I);$=z.userLocale,e=z.osLocale,g=z.resolvedLanguage||t.$h,s=z.languagePack?.translationsConfigFile}catch{}N=!0}else typeof navigator=="object"&&!k?(r=navigator.userAgent,i=r.indexOf("Windows")>=0,n=r.indexOf("Macintosh")>=0,c=(r.indexOf("Macintosh")>=0||r.indexOf("iPad")>=0||r.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,j=r.indexOf("Linux")>=0,y=r?.indexOf("Mobi")>=0,w=!0,g=globalThis._VSCODE_NLS_LANGUAGE||t.$h,$=navigator.language.toLowerCase(),e=$):console.error("Unable to resolve platform.");var A;(function(I){I[I.Web=0]="Web",I[I.Mac=1]="Mac",I[I.Linux=2]="Linux",I[I.Windows=3]="Windows"})(A||(t.Platform=A={}));function d(I){switch(I){case A.Web:return"Web";case A.Mac:return"Mac";case A.Linux:return"Linux";case A.Windows:return"Windows"}}let f=A.Web;n?f=A.Mac:i?f=A.Windows:j&&(f=A.Linux),t.$j=i,t.$k=n,t.$l=j,t.$m=F,t.$n=N,t.$o=D,t.$p=w,t.$q=w&&typeof h.importScripts=="function",t.$r=t.$q?h.origin:void 0,t.$s=c,t.$t=y,t.$u=p,t.$v=f,t.$w=r,t.$x=g;var b;(function(I){function z(){return t.$x}I.value=z;function O(){return t.$x.length===2?t.$x==="en":t.$x.length>=3?t.$x[0]==="e"&&t.$x[1]==="n"&&t.$x[2]==="-":!1}I.isDefaultVariant=O;function C(){return t.$x==="en"}I.isDefault=C})(b||(t.Language=b={})),t.$y=$,t.$z=e,t.$A=s,t.$B=typeof h.postMessage=="function"&&!h.importScripts,t.$C=(()=>{if(t.$B){const I=[];h.addEventListener("message",O=>{if(O.data&&O.data.vscodeScheduleAsyncWork)for(let C=0,x=I.length;C<x;C++){const Z=I[C];if(Z.id===O.data.vscodeScheduleAsyncWork){I.splice(C,1),Z.callback();return}}});let z=0;return O=>{const C=++z;I.push({id:C,callback:O}),h.postMessage({vscodeScheduleAsyncWork:C},"*")}}return I=>setTimeout(I)})();var S;(function(I){I[I.Windows=1]="Windows",I[I.Macintosh=2]="Macintosh",I[I.Linux=3]="Linux"})(S||(t.OperatingSystem=S={})),t.OS=n||c?S.Macintosh:i?S.Windows:S.Linux;let U=!0,_=!1;function B(){if(!_){_=!0;const I=new Uint8Array(2);I[0]=1,I[1]=2,U=new Uint16Array(I.buffer)[0]===513}return U}t.$F=!!(t.$w&&t.$w.indexOf("Chrome")>=0),t.$G=!!(t.$w&&t.$w.indexOf("Firefox")>=0),t.$H=!!(!t.$F&&t.$w&&t.$w.indexOf("Safari")>=0),t.$I=!!(t.$w&&t.$w.indexOf("Edg/")>=0),t.$J=!!(t.$w&&t.$w.indexOf("Android")>=0);function E(I){return parseFloat(I)>=20}}),define(we[98],ve([1,0,6,8,5]),function(re,t,i,n,j){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$3r=t.$2r=t.$1r=t.$Zr=t.$Yr=void 0,t.$Wr=N,t.$Xr=w;var F;(function(g){g[g.CtrlCmd=2048]="CtrlCmd",g[g.Shift=1024]="Shift",g[g.Alt=512]="Alt",g[g.WinCtrl=256]="WinCtrl",g[g.KeyCode=255]="KeyCode"})(F||(F={}));function N(g,e){if(typeof g=="number"){if(g===0)return null;const s=(g&65535)>>>0,r=(g&4294901760)>>>16;return r!==0?new p([w(s,e),w(r,e)]):new p([w(s,e)])}else{const s=[];for(let r=0;r<g.length;r++)s.push(w(g[r],e));return new p(s)}}function w(g,e){const s=!!(g&F.CtrlCmd),r=!!(g&F.WinCtrl),h=e===j.OperatingSystem.Macintosh?r:s,l=!!(g&F.Shift),v=!!(g&F.Alt),k=e===j.OperatingSystem.Macintosh?s:r,A=g&F.KeyCode;return new D(h,l,v,k,A)}class D{constructor(e,s,r,h,l){this.ctrlKey=e,this.shiftKey=s,this.altKey=r,this.metaKey=h,this.keyCode=l}equals(e){return e instanceof D&&this.ctrlKey===e.ctrlKey&&this.shiftKey===e.shiftKey&&this.altKey===e.altKey&&this.metaKey===e.metaKey&&this.keyCode===e.keyCode}getHashCode(){const e=this.ctrlKey?"1":"0",s=this.shiftKey?"1":"0",r=this.altKey?"1":"0",h=this.metaKey?"1":"0";return`K${e}${s}${r}${h}${this.keyCode}`}isModifierKey(){return this.keyCode===n.KeyCode.Unknown||this.keyCode===n.KeyCode.Ctrl||this.keyCode===n.KeyCode.Meta||this.keyCode===n.KeyCode.Alt||this.keyCode===n.KeyCode.Shift}toKeybinding(){return new p([this])}isDuplicateModifierCase(){return this.ctrlKey&&this.keyCode===n.KeyCode.Ctrl||this.shiftKey&&this.keyCode===n.KeyCode.Shift||this.altKey&&this.keyCode===n.KeyCode.Alt||this.metaKey&&this.keyCode===n.KeyCode.Meta}}t.$Yr=D;class c{constructor(e,s,r,h,l){this.ctrlKey=e,this.shiftKey=s,this.altKey=r,this.metaKey=h,this.scanCode=l}equals(e){return e instanceof c&&this.ctrlKey===e.ctrlKey&&this.shiftKey===e.shiftKey&&this.altKey===e.altKey&&this.metaKey===e.metaKey&&this.scanCode===e.scanCode}getHashCode(){const e=this.ctrlKey?"1":"0",s=this.shiftKey?"1":"0",r=this.altKey?"1":"0",h=this.metaKey?"1":"0";return`S${e}${s}${r}${h}${this.scanCode}`}isDuplicateModifierCase(){return this.ctrlKey&&(this.scanCode===n.ScanCode.ControlLeft||this.scanCode===n.ScanCode.ControlRight)||this.shiftKey&&(this.scanCode===n.ScanCode.ShiftLeft||this.scanCode===n.ScanCode.ShiftRight)||this.altKey&&(this.scanCode===n.ScanCode.AltLeft||this.scanCode===n.ScanCode.AltRight)||this.metaKey&&(this.scanCode===n.ScanCode.MetaLeft||this.scanCode===n.ScanCode.MetaRight)}}t.$Zr=c;class p{constructor(e){if(e.length===0)throw(0,i.$6)("chords");this.chords=e}getHashCode(){let e="";for(let s=0,r=this.chords.length;s<r;s++)s!==0&&(e+=";"),e+=this.chords[s].getHashCode();return e}equals(e){if(e===null||this.chords.length!==e.chords.length)return!1;for(let s=0;s<this.chords.length;s++)if(!this.chords[s].equals(e.chords[s]))return!1;return!0}}t.$1r=p;class y{constructor(e,s,r,h,l,v){this.ctrlKey=e,this.shiftKey=s,this.altKey=r,this.metaKey=h,this.keyLabel=l,this.keyAriaLabel=v}}t.$2r=y;class ${}t.$3r=$}),define(we[99],ve([1,0,5]),function(re,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$dc=t.$cc=t.env=t.cwd=void 0;let n;const j=globalThis.vscode;if(typeof j<"u"&&typeof j.process<"u"){const F=j.process;n={get platform(){return F.platform},get arch(){return F.arch},get env(){return F.env},cwd(){return F.cwd()}}}else typeof process<"u"?n={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:n={get platform(){return i.$j?"win32":i.$k?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};t.cwd=n.cwd,t.env=n.env,t.$cc=n.platform,t.$dc=n.arch}),define(we[28],ve([1,0,99]),function(re,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$sc=t.sep=t.$qc=t.$pc=t.$oc=t.$nc=t.$mc=t.$lc=t.$kc=t.$jc=t.$ic=t.$hc=t.$gc=t.$fc=t.$ec=void 0,i=He(i);const n=65,j=97,F=90,N=122,w=46,D=47,c=92,p=58,y=63;class $ extends Error{constructor(b,S,U){let _;typeof S=="string"&&S.indexOf("not ")===0?(_="must not be",S=S.replace(/^not /,"")):_="must be";const B=b.indexOf(".")!==-1?"property":"argument";let E=`The "${b}" ${B} ${_} of type ${S}`;E+=`. Received type ${typeof U}`,super(E),this.code="ERR_INVALID_ARG_TYPE"}}function g(f,b){if(f===null||typeof f!="object")throw new $(b,"Object",f)}function e(f,b){if(typeof f!="string")throw new $(b,"string",f)}const s=i.$cc==="win32";function r(f){return f===D||f===c}function h(f){return f===D}function l(f){return f>=n&&f<=F||f>=j&&f<=N}function v(f,b,S,U){let _="",B=0,E=-1,I=0,z=0;for(let O=0;O<=f.length;++O){if(O<f.length)z=f.charCodeAt(O);else{if(U(z))break;z=D}if(U(z)){if(!(E===O-1||I===1))if(I===2){if(_.length<2||B!==2||_.charCodeAt(_.length-1)!==w||_.charCodeAt(_.length-2)!==w){if(_.length>2){const C=_.lastIndexOf(S);C===-1?(_="",B=0):(_=_.slice(0,C),B=_.length-1-_.lastIndexOf(S)),E=O,I=0;continue}else if(_.length!==0){_="",B=0,E=O,I=0;continue}}b&&(_+=_.length>0?`${S}..`:"..",B=2)}else _.length>0?_+=`${S}${f.slice(E+1,O)}`:_=f.slice(E+1,O),B=O-E-1;E=O,I=0}else z===w&&I!==-1?++I:I=-1}return _}function k(f){return f?`${f[0]==="."?"":"."}${f}`:""}function A(f,b){g(b,"pathObject");const S=b.dir||b.root,U=b.base||`${b.name||""}${k(b.ext)}`;return S?S===b.root?`${S}${U}`:`${S}${f}${U}`:U}t.$ec={resolve(...f){let b="",S="",U=!1;for(let _=f.length-1;_>=-1;_--){let B;if(_>=0){if(B=f[_],e(B,`paths[${_}]`),B.length===0)continue}else b.length===0?B=i.cwd():(B=i.env[`=${b}`]||i.cwd(),(B===void 0||B.slice(0,2).toLowerCase()!==b.toLowerCase()&&B.charCodeAt(2)===c)&&(B=`${b}\\`));const E=B.length;let I=0,z="",O=!1;const C=B.charCodeAt(0);if(E===1)r(C)&&(I=1,O=!0);else if(r(C))if(O=!0,r(B.charCodeAt(1))){let x=2,Z=x;for(;x<E&&!r(B.charCodeAt(x));)x++;if(x<E&&x!==Z){const Y=B.slice(Z,x);for(Z=x;x<E&&r(B.charCodeAt(x));)x++;if(x<E&&x!==Z){for(Z=x;x<E&&!r(B.charCodeAt(x));)x++;(x===E||x!==Z)&&(z=`\\\\${Y}\\${B.slice(Z,x)}`,I=x)}}}else I=1;else l(C)&&B.charCodeAt(1)===p&&(z=B.slice(0,2),I=2,E>2&&r(B.charCodeAt(2))&&(O=!0,I=3));if(z.length>0)if(b.length>0){if(z.toLowerCase()!==b.toLowerCase())continue}else b=z;if(U){if(b.length>0)break}else if(S=`${B.slice(I)}\\${S}`,U=O,O&&b.length>0)break}return S=v(S,!U,"\\",r),U?`${b}\\${S}`:`${b}${S}`||"."},normalize(f){e(f,"path");const b=f.length;if(b===0)return".";let S=0,U,_=!1;const B=f.charCodeAt(0);if(b===1)return h(B)?"\\":f;if(r(B))if(_=!0,r(f.charCodeAt(1))){let I=2,z=I;for(;I<b&&!r(f.charCodeAt(I));)I++;if(I<b&&I!==z){const O=f.slice(z,I);for(z=I;I<b&&r(f.charCodeAt(I));)I++;if(I<b&&I!==z){for(z=I;I<b&&!r(f.charCodeAt(I));)I++;if(I===b)return`\\\\${O}\\${f.slice(z)}\\`;I!==z&&(U=`\\\\${O}\\${f.slice(z,I)}`,S=I)}}}else S=1;else l(B)&&f.charCodeAt(1)===p&&(U=f.slice(0,2),S=2,b>2&&r(f.charCodeAt(2))&&(_=!0,S=3));let E=S<b?v(f.slice(S),!_,"\\",r):"";return E.length===0&&!_&&(E="."),E.length>0&&r(f.charCodeAt(b-1))&&(E+="\\"),U===void 0?_?`\\${E}`:E:_?`${U}\\${E}`:`${U}${E}`},isAbsolute(f){e(f,"path");const b=f.length;if(b===0)return!1;const S=f.charCodeAt(0);return r(S)||b>2&&l(S)&&f.charCodeAt(1)===p&&r(f.charCodeAt(2))},join(...f){if(f.length===0)return".";let b,S;for(let B=0;B<f.length;++B){const E=f[B];e(E,"path"),E.length>0&&(b===void 0?b=S=E:b+=`\\${E}`)}if(b===void 0)return".";let U=!0,_=0;if(typeof S=="string"&&r(S.charCodeAt(0))){++_;const B=S.length;B>1&&r(S.charCodeAt(1))&&(++_,B>2&&(r(S.charCodeAt(2))?++_:U=!1))}if(U){for(;_<b.length&&r(b.charCodeAt(_));)_++;_>=2&&(b=`\\${b.slice(_)}`)}return t.$ec.normalize(b)},relative(f,b){if(e(f,"from"),e(b,"to"),f===b)return"";const S=t.$ec.resolve(f),U=t.$ec.resolve(b);if(S===U||(f=S.toLowerCase(),b=U.toLowerCase(),f===b))return"";let _=0;for(;_<f.length&&f.charCodeAt(_)===c;)_++;let B=f.length;for(;B-1>_&&f.charCodeAt(B-1)===c;)B--;const E=B-_;let I=0;for(;I<b.length&&b.charCodeAt(I)===c;)I++;let z=b.length;for(;z-1>I&&b.charCodeAt(z-1)===c;)z--;const O=z-I,C=E<O?E:O;let x=-1,Z=0;for(;Z<C;Z++){const q=f.charCodeAt(_+Z);if(q!==b.charCodeAt(I+Z))break;q===c&&(x=Z)}if(Z!==C){if(x===-1)return U}else{if(O>C){if(b.charCodeAt(I+Z)===c)return U.slice(I+Z+1);if(Z===2)return U.slice(I+Z)}E>C&&(f.charCodeAt(_+Z)===c?x=Z:Z===2&&(x=3)),x===-1&&(x=0)}let Y="";for(Z=_+x+1;Z<=B;++Z)(Z===B||f.charCodeAt(Z)===c)&&(Y+=Y.length===0?"..":"\\..");return I+=x,Y.length>0?`${Y}${U.slice(I,z)}`:(U.charCodeAt(I)===c&&++I,U.slice(I,z))},toNamespacedPath(f){if(typeof f!="string"||f.length===0)return f;const b=t.$ec.resolve(f);if(b.length<=2)return f;if(b.charCodeAt(0)===c){if(b.charCodeAt(1)===c){const S=b.charCodeAt(2);if(S!==y&&S!==w)return`\\\\?\\UNC\\${b.slice(2)}`}}else if(l(b.charCodeAt(0))&&b.charCodeAt(1)===p&&b.charCodeAt(2)===c)return`\\\\?\\${b}`;return f},dirname(f){e(f,"path");const b=f.length;if(b===0)return".";let S=-1,U=0;const _=f.charCodeAt(0);if(b===1)return r(_)?f:".";if(r(_)){if(S=U=1,r(f.charCodeAt(1))){let I=2,z=I;for(;I<b&&!r(f.charCodeAt(I));)I++;if(I<b&&I!==z){for(z=I;I<b&&r(f.charCodeAt(I));)I++;if(I<b&&I!==z){for(z=I;I<b&&!r(f.charCodeAt(I));)I++;if(I===b)return f;I!==z&&(S=U=I+1)}}}}else l(_)&&f.charCodeAt(1)===p&&(S=b>2&&r(f.charCodeAt(2))?3:2,U=S);let B=-1,E=!0;for(let I=b-1;I>=U;--I)if(r(f.charCodeAt(I))){if(!E){B=I;break}}else E=!1;if(B===-1){if(S===-1)return".";B=S}return f.slice(0,B)},basename(f,b){b!==void 0&&e(b,"suffix"),e(f,"path");let S=0,U=-1,_=!0,B;if(f.length>=2&&l(f.charCodeAt(0))&&f.charCodeAt(1)===p&&(S=2),b!==void 0&&b.length>0&&b.length<=f.length){if(b===f)return"";let E=b.length-1,I=-1;for(B=f.length-1;B>=S;--B){const z=f.charCodeAt(B);if(r(z)){if(!_){S=B+1;break}}else I===-1&&(_=!1,I=B+1),E>=0&&(z===b.charCodeAt(E)?--E===-1&&(U=B):(E=-1,U=I))}return S===U?U=I:U===-1&&(U=f.length),f.slice(S,U)}for(B=f.length-1;B>=S;--B)if(r(f.charCodeAt(B))){if(!_){S=B+1;break}}else U===-1&&(_=!1,U=B+1);return U===-1?"":f.slice(S,U)},extname(f){e(f,"path");let b=0,S=-1,U=0,_=-1,B=!0,E=0;f.length>=2&&f.charCodeAt(1)===p&&l(f.charCodeAt(0))&&(b=U=2);for(let I=f.length-1;I>=b;--I){const z=f.charCodeAt(I);if(r(z)){if(!B){U=I+1;break}continue}_===-1&&(B=!1,_=I+1),z===w?S===-1?S=I:E!==1&&(E=1):S!==-1&&(E=-1)}return S===-1||_===-1||E===0||E===1&&S===_-1&&S===U+1?"":f.slice(S,_)},format:A.bind(null,"\\"),parse(f){e(f,"path");const b={root:"",dir:"",base:"",ext:"",name:""};if(f.length===0)return b;const S=f.length;let U=0,_=f.charCodeAt(0);if(S===1)return r(_)?(b.root=b.dir=f,b):(b.base=b.name=f,b);if(r(_)){if(U=1,r(f.charCodeAt(1))){let x=2,Z=x;for(;x<S&&!r(f.charCodeAt(x));)x++;if(x<S&&x!==Z){for(Z=x;x<S&&r(f.charCodeAt(x));)x++;if(x<S&&x!==Z){for(Z=x;x<S&&!r(f.charCodeAt(x));)x++;x===S?U=x:x!==Z&&(U=x+1)}}}}else if(l(_)&&f.charCodeAt(1)===p){if(S<=2)return b.root=b.dir=f,b;if(U=2,r(f.charCodeAt(2))){if(S===3)return b.root=b.dir=f,b;U=3}}U>0&&(b.root=f.slice(0,U));let B=-1,E=U,I=-1,z=!0,O=f.length-1,C=0;for(;O>=U;--O){if(_=f.charCodeAt(O),r(_)){if(!z){E=O+1;break}continue}I===-1&&(z=!1,I=O+1),_===w?B===-1?B=O:C!==1&&(C=1):B!==-1&&(C=-1)}return I!==-1&&(B===-1||C===0||C===1&&B===I-1&&B===E+1?b.base=b.name=f.slice(E,I):(b.name=f.slice(E,B),b.base=f.slice(E,I),b.ext=f.slice(B,I))),E>0&&E!==U?b.dir=f.slice(0,E-1):b.dir=b.root,b},sep:"\\",delimiter:";",win32:null,posix:null};const d=(()=>{if(s){const f=/\\/g;return()=>{const b=i.cwd().replace(f,"/");return b.slice(b.indexOf("/"))}}return()=>i.cwd()})();t.$fc={resolve(...f){let b="",S=!1;for(let U=f.length-1;U>=-1&&!S;U--){const _=U>=0?f[U]:d();e(_,`paths[${U}]`),_.length!==0&&(b=`${_}/${b}`,S=_.charCodeAt(0)===D)}return b=v(b,!S,"/",h),S?`/${b}`:b.length>0?b:"."},normalize(f){if(e(f,"path"),f.length===0)return".";const b=f.charCodeAt(0)===D,S=f.charCodeAt(f.length-1)===D;return f=v(f,!b,"/",h),f.length===0?b?"/":S?"./":".":(S&&(f+="/"),b?`/${f}`:f)},isAbsolute(f){return e(f,"path"),f.length>0&&f.charCodeAt(0)===D},join(...f){if(f.length===0)return".";let b;for(let S=0;S<f.length;++S){const U=f[S];e(U,"path"),U.length>0&&(b===void 0?b=U:b+=`/${U}`)}return b===void 0?".":t.$fc.normalize(b)},relative(f,b){if(e(f,"from"),e(b,"to"),f===b||(f=t.$fc.resolve(f),b=t.$fc.resolve(b),f===b))return"";const S=1,U=f.length,_=U-S,B=1,E=b.length-B,I=_<E?_:E;let z=-1,O=0;for(;O<I;O++){const x=f.charCodeAt(S+O);if(x!==b.charCodeAt(B+O))break;x===D&&(z=O)}if(O===I)if(E>I){if(b.charCodeAt(B+O)===D)return b.slice(B+O+1);if(O===0)return b.slice(B+O)}else _>I&&(f.charCodeAt(S+O)===D?z=O:O===0&&(z=0));let C="";for(O=S+z+1;O<=U;++O)(O===U||f.charCodeAt(O)===D)&&(C+=C.length===0?"..":"/..");return`${C}${b.slice(B+z)}`},toNamespacedPath(f){return f},dirname(f){if(e(f,"path"),f.length===0)return".";const b=f.charCodeAt(0)===D;let S=-1,U=!0;for(let _=f.length-1;_>=1;--_)if(f.charCodeAt(_)===D){if(!U){S=_;break}}else U=!1;return S===-1?b?"/":".":b&&S===1?"//":f.slice(0,S)},basename(f,b){b!==void 0&&e(b,"ext"),e(f,"path");let S=0,U=-1,_=!0,B;if(b!==void 0&&b.length>0&&b.length<=f.length){if(b===f)return"";let E=b.length-1,I=-1;for(B=f.length-1;B>=0;--B){const z=f.charCodeAt(B);if(z===D){if(!_){S=B+1;break}}else I===-1&&(_=!1,I=B+1),E>=0&&(z===b.charCodeAt(E)?--E===-1&&(U=B):(E=-1,U=I))}return S===U?U=I:U===-1&&(U=f.length),f.slice(S,U)}for(B=f.length-1;B>=0;--B)if(f.charCodeAt(B)===D){if(!_){S=B+1;break}}else U===-1&&(_=!1,U=B+1);return U===-1?"":f.slice(S,U)},extname(f){e(f,"path");let b=-1,S=0,U=-1,_=!0,B=0;for(let E=f.length-1;E>=0;--E){const I=f.charCodeAt(E);if(I===D){if(!_){S=E+1;break}continue}U===-1&&(_=!1,U=E+1),I===w?b===-1?b=E:B!==1&&(B=1):b!==-1&&(B=-1)}return b===-1||U===-1||B===0||B===1&&b===U-1&&b===S+1?"":f.slice(b,U)},format:A.bind(null,"/"),parse(f){e(f,"path");const b={root:"",dir:"",base:"",ext:"",name:""};if(f.length===0)return b;const S=f.charCodeAt(0)===D;let U;S?(b.root="/",U=1):U=0;let _=-1,B=0,E=-1,I=!0,z=f.length-1,O=0;for(;z>=U;--z){const C=f.charCodeAt(z);if(C===D){if(!I){B=z+1;break}continue}E===-1&&(I=!1,E=z+1),C===w?_===-1?_=z:O!==1&&(O=1):_!==-1&&(O=-1)}if(E!==-1){const C=B===0&&S?1:B;_===-1||O===0||O===1&&_===E-1&&_===B+1?b.base=b.name=f.slice(C,E):(b.name=f.slice(C,_),b.base=f.slice(C,E),b.ext=f.slice(_,E))}return B>0?b.dir=f.slice(0,B-1):S&&(b.dir="/"),b},sep:"/",delimiter:":",win32:null,posix:null},t.$fc.win32=t.$ec.win32=t.$ec,t.$fc.posix=t.$ec.posix=t.$fc,t.$gc=s?t.$ec.normalize:t.$fc.normalize,t.$hc=s?t.$ec.isAbsolute:t.$fc.isAbsolute,t.$ic=s?t.$ec.join:t.$fc.join,t.$jc=s?t.$ec.resolve:t.$fc.resolve,t.$kc=s?t.$ec.relative:t.$fc.relative,t.$lc=s?t.$ec.dirname:t.$fc.dirname,t.$mc=s?t.$ec.basename:t.$fc.basename,t.$nc=s?t.$ec.extname:t.$fc.extname,t.$oc=s?t.$ec.format:t.$fc.format,t.$pc=s?t.$ec.parse:t.$fc.parse,t.$qc=s?t.$ec.toNamespacedPath:t.$fc.toNamespacedPath,t.sep=s?t.$ec.sep:t.$fc.sep,t.$sc=s?t.$ec.delimiter:t.$fc.delimiter}),define(we[100],ve([1,0,28]),function(re,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$8s=void 0,t.$9s=F,t.$0s=N,t.$$s=w,t.$_s=c,t.$8s=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const n={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},j={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function F(p){const y=(0,i.$nc)(p),$=n[y.toLowerCase()];return $!==void 0?$:N(p)}function N(p){const y=(0,i.$nc)(p);return j[y.toLowerCase()]}function w(p){for(const y in j)if(j[y]===p)return y}const D=/^(.+)\/(.+?)(;.+)?$/;function c(p,y){const $=D.exec(p);return $?`${$[1].toLowerCase()}/${$[2].toLowerCase()}${$[3]??""}`:y?void 0:p}}),define(we[46],ve([1,0]),function(re,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Range=void 0;var i;(function(n){function j(D,c){if(D.start>=c.end||c.start>=D.end)return{start:0,end:0};const p=Math.max(D.start,c.start),y=Math.min(D.end,c.end);return y-p<=0?{start:0,end:0}:{start:p,end:y}}n.intersect=j;function F(D){return D.end-D.start<=0}n.isEmpty=F;function N(D,c){return!F(j(D,c))}n.intersects=N;function w(D,c){const p=[],y={start:D.start,end:Math.min(c.start,D.end)},$={start:Math.max(c.end,D.start),end:D.end};return F(y)||p.push(y),F($)||p.push($),p}n.relativeComplement=w})(i||(t.Range=i={}))}),define(we[101],ve([1,0,46]),function(re,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$OU=void 0,t.$LU=n,t.$MU=j,t.$NU=F;function n(D,c){const p=[];for(const y of c){if(D.start>=y.range.end)continue;if(D.end<y.range.start)break;const $=i.Range.intersect(D,y.range);i.Range.isEmpty($)||p.push({range:$,size:y.size})}return p}function j({start:D,end:c},p){return{start:D+p,end:c+p}}function F(D){const c=[];let p=null;for(const y of D){const $=y.range.start,g=y.range.end,e=y.size;if(p&&e===p.size){p.range.end=g;continue}p={range:{start:$,end:g},size:e},c.push(p)}return c}function N(...D){return F(D.reduce((c,p)=>c.concat(p),[]))}class w{get paddingTop(){return this.c}set paddingTop(c){this.b=this.b+c-this.c,this.c=c}constructor(c){this.a=[],this.b=0,this.c=0,this.c=c??0,this.b=this.c}splice(c,p,y=[]){const $=y.length-p,g=n({start:0,end:c},this.a),e=n({start:c+p,end:Number.POSITIVE_INFINITY},this.a).map(r=>({range:j(r.range,$),size:r.size})),s=y.map((r,h)=>({range:{start:c+h,end:c+h+1},size:r.size}));this.a=N(g,s,e),this.b=this.c+this.a.reduce((r,h)=>r+h.size*(h.range.end-h.range.start),0)}get count(){const c=this.a.length;return c?this.a[c-1].range.end:0}get size(){return this.b}indexAt(c){if(c<0)return-1;if(c<this.c)return 0;let p=0,y=this.c;for(const $ of this.a){const g=$.range.end-$.range.start,e=y+g*$.size;if(c<e)return p+Math.floor((c-y)/$.size);p+=g,y=e}return p}indexAfter(c){return Math.min(this.indexAt(c)+1,this.count)}positionAt(c){if(c<0)return-1;let p=0,y=0;for(const $ of this.a){const g=$.range.end-$.range.start,e=y+g;if(c<e)return this.c+p+(c-y)*$.size;p+=g*$.size,y=e}return-1}}t.$OU=w}),define(we[102],ve([1,0]),function(re,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$de=void 0;const i=globalThis.performance&&typeof globalThis.performance.now=="function";class n{static create(F){return new n(F)}constructor(F){this.c=i&&F===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}t.$de=n}),define(we[3],ve([1,0,6,58,2,59,102]),function(re,t,i,n,j,F,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$te=t.$se=t.$re=t.$qe=t.$pe=t.$oe=t.$ne=t.$me=t.$le=t.$ke=t.$je=t.$ie=t.$he=t.$fe=t.Event=void 0,t.$ge=g;const w=!1,D=!1,c=!1;var p;(function(Y){Y.None=()=>j.$Tc.None;function q(T){if(c){const{onDidAddListener:P}=T,H=s.create();let X=0;T.onDidAddListener=()=>{++X===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),H.print()),P?.()}}}function ee(T,P){return te(T,()=>{},0,void 0,!0,void 0,P)}Y.defer=ee;function ce(T){return(P,H=null,X)=>{let ie=!1,oe;return oe=T(de=>{if(!ie)return oe?oe.dispose():ie=!0,P.call(H,de)},null,X),ie&&oe.dispose(),oe}}Y.once=ce;function be(T,P,H){return le((X,ie=null,oe)=>T(de=>X.call(ie,P(de)),null,oe),H)}Y.map=be;function ke(T,P,H){return le((X,ie=null,oe)=>T(de=>{P(de),X.call(ie,de)},null,oe),H)}Y.forEach=ke;function Fe(T,P,H){return le((X,ie=null,oe)=>T(de=>P(de)&&X.call(ie,de),null,oe),H)}Y.filter=Fe;function ue(T){return T}Y.signal=ue;function Q(...T){return(P,H=null,X)=>{const ie=(0,j.$Qc)(...T.map(oe=>oe(de=>P.call(H,de))));return Ne(ie,X)}}Y.any=Q;function he(T,P,H,X){let ie=H;return be(T,oe=>(ie=P(ie,oe),ie),X)}Y.reduce=he;function le(T,P){let H;const X={onWillAddFirstListener(){H=T(ie.fire,ie)},onDidRemoveLastListener(){H?.dispose()}};P||q(X);const ie=new f(X);return P?.add(ie),ie.event}function Ne(T,P){return P instanceof Array?P.push(T):P&&P.add(T),T}function te(T,P,H=100,X=!1,ie=!1,oe,de){let ye,De,Le,Te=0,fe;const Re={leakWarningThreshold:oe,onWillAddFirstListener(){ye=T(Ze=>{Te++,De=P(De,Ze),X&&!Le&&(Ke.fire(De),De=void 0),fe=()=>{const tt=De;De=void 0,Le=void 0,(!X||Te>1)&&Ke.fire(tt),Te=0},typeof H=="number"?(clearTimeout(Le),Le=setTimeout(fe,H)):Le===void 0&&(Le=0,queueMicrotask(fe))})},onWillRemoveListener(){ie&&Te>0&&fe?.()},onDidRemoveLastListener(){fe=void 0,ye.dispose()}};de||q(Re);const Ke=new f(Re);return de?.add(Ke),Ke.event}Y.debounce=te;function $e(T,P=0,H){return Y.debounce(T,(X,ie)=>X?(X.push(ie),X):[ie],P,void 0,!0,void 0,H)}Y.accumulate=$e;function Ae(T,P=(X,ie)=>X===ie,H){let X=!0,ie;return Fe(T,oe=>{const de=X||!P(oe,ie);return X=!1,ie=oe,de},H)}Y.latch=Ae;function Oe(T,P,H){return[Y.filter(T,P,H),Y.filter(T,X=>!P(X),H)]}Y.split=Oe;function Ie(T,P=!1,H=[],X){let ie=H.slice(),oe=T(De=>{ie?ie.push(De):ye.fire(De)});X&&X.add(oe);const de=()=>{ie?.forEach(De=>ye.fire(De)),ie=null},ye=new f({onWillAddFirstListener(){oe||(oe=T(De=>ye.fire(De)),X&&X.add(oe))},onDidAddFirstListener(){ie&&(P?setTimeout(de):de())},onDidRemoveLastListener(){oe&&oe.dispose(),oe=null}});return X&&X.add(ye),ye.event}Y.buffer=Ie;function Ce(T,P){return(X,ie,oe)=>{const de=P(new K);return T(function(ye){const De=de.evaluate(ye);De!==se&&X.call(ie,De)},void 0,oe)}}Y.chain=Ce;const se=Symbol("HaltChainable");class K{constructor(){this.f=[]}map(P){return this.f.push(P),this}forEach(P){return this.f.push(H=>(P(H),H)),this}filter(P){return this.f.push(H=>P(H)?H:se),this}reduce(P,H){let X=H;return this.f.push(ie=>(X=P(X,ie),X)),this}latch(P=(H,X)=>H===X){let H=!0,X;return this.f.push(ie=>{const oe=H||!P(ie,X);return H=!1,X=ie,oe?ie:se}),this}evaluate(P){for(const H of this.f)if(P=H(P),P===se)break;return P}}function W(T,P,H=X=>X){const X=(...ye)=>de.fire(H(...ye)),ie=()=>T.on(P,X),oe=()=>T.removeListener(P,X),de=new f({onWillAddFirstListener:ie,onDidRemoveLastListener:oe});return de.event}Y.fromNodeEventEmitter=W;function a(T,P,H=X=>X){const X=(...ye)=>de.fire(H(...ye)),ie=()=>T.addEventListener(P,X),oe=()=>T.removeEventListener(P,X),de=new f({onWillAddFirstListener:ie,onDidRemoveLastListener:oe});return de.event}Y.fromDOMEventEmitter=a;function o(T){return new Promise(P=>ce(T)(P))}Y.toPromise=o;function m(T){const P=new f;return T.then(H=>{P.fire(H)},()=>{P.fire(void 0)}).finally(()=>{P.dispose()}),P.event}Y.fromPromise=m;function M(T,P,H){return P(H),T(X=>P(X))}Y.runAndSubscribe=M;class R{constructor(P,H){this._observable=P,this.f=0,this.g=!1;const X={onWillAddFirstListener:()=>{P.addObserver(this)},onDidRemoveLastListener:()=>{P.removeObserver(this)}};H||q(X),this.emitter=new f(X),H&&H.add(this.emitter)}beginUpdate(P){this.f++}handlePossibleChange(P){}handleChange(P,H){this.g=!0}endUpdate(P){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function u(T,P){return new R(T,P).emitter.event}Y.fromObservable=u;function L(T){return(P,H,X)=>{let ie=0,oe=!1;const de={beginUpdate(){ie++},endUpdate(){ie--,ie===0&&(T.reportChanges(),oe&&(oe=!1,P.call(H)))},handlePossibleChange(){},handleChange(){oe=!0}};T.addObserver(de),T.reportChanges();const ye={dispose(){T.removeObserver(de)}};return X instanceof j.$Sc?X.add(ye):Array.isArray(X)&&X.push(ye),ye}}Y.fromObservableLight=L})(p||(t.Event=p={}));class y{static{this.all=new Set}static{this.f=0}constructor(q){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${q}_${y.f++}`,y.all.add(this)}start(q){this.g=new N.$de,this.listenerCount=q}stop(){if(this.g){const q=this.g.elapsed();this.durations.push(q),this.elapsedOverall+=q,this.invocationCount+=1,this.g=void 0}}}t.$fe=y;let $=-1;function g(Y){const q=$;return $=Y,{dispose(){$=q}}}class e{static{this.f=1}constructor(q,ee,ce=(e.f++).toString(16).padStart(3,"0")){this.j=q,this.threshold=ee,this.name=ce,this.h=0}dispose(){this.g?.clear()}check(q,ee){const ce=this.threshold;if(ce<=0||ee<ce)return;this.g||(this.g=new Map);const be=this.g.get(q.value)||0;if(this.g.set(q.value,be+1),this.h-=1,this.h<=0){this.h=ce*.5;const[ke,Fe]=this.getMostFrequentStack(),ue=`[${this.name}] potential listener LEAK detected, having ${ee} listeners already. MOST frequent listener (${Fe}):`;console.warn(ue),console.warn(ke);const Q=new r(ue,ke);this.j(Q)}return()=>{const ke=this.g.get(q.value)||0;this.g.set(q.value,ke-1)}}getMostFrequentStack(){if(!this.g)return;let q,ee=0;for(const[ce,be]of this.g)(!q||ee<be)&&(q=[ce,be],ee=be);return q}}class s{static create(){const q=new Error;return new s(q.stack??"")}constructor(q){this.value=q}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class r extends Error{constructor(q,ee){super(q),this.name="ListenerLeakError",this.stack=ee}}t.$he=r;class h extends Error{constructor(q,ee){super(q),this.name="ListenerRefusalError",this.stack=ee}}t.$ie=h;let l=0;class v{constructor(q){this.value=q,this.id=l++}}const k=2,A=(Y,q)=>{if(Y instanceof v)q(Y);else for(let ee=0;ee<Y.length;ee++){const ce=Y[ee];ce&&q(ce)}};let d;if(w){const Y=[];setInterval(()=>{Y.length!==0&&(console.warn("[LEAKING LISTENERS] GC'ed these listeners that were NOT yet disposed:"),console.warn(Y.join(`
`)),Y.length=0)},3e3),d=new FinalizationRegistry(q=>{typeof q=="string"&&Y.push(q)})}class f{constructor(q){this.z=0,this.f=q,this.g=$>0||this.f?.leakWarningThreshold?new e(q?.onListenerError??i.$Y,this.f?.leakWarningThreshold??$):void 0,this.j=this.f?._profName?new y(this.f._profName):void 0,this.w=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.w?.current===this&&this.w.reset(),this.u){if(D){const q=this.u;queueMicrotask(()=>{A(q,ee=>ee.stack?.print())})}this.u=void 0,this.z=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(q,ee,ce)=>{if(this.g&&this.z>this.g.threshold**2){const Q=`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far (${this.z} vs ${this.g.threshold})`;console.warn(Q);const he=this.g.getMostFrequentStack()??["UNKNOWN stack",-1],le=new h(`${Q}. HINT: Stack shows most frequent listener (${he[1]}-times)`,he[0]);return(this.f?.onListenerError||i.$Y)(le),j.$Tc.None}if(this.m)return j.$Tc.None;ee&&(q=q.bind(ee));const be=new v(q);let ke,Fe;this.g&&this.z>=Math.ceil(this.g.threshold*.2)&&(be.stack=s.create(),ke=this.g.check(be.stack,this.z+1)),D&&(be.stack=Fe??s.create()),this.u?this.u instanceof v?(this.w??=new S,this.u=[this.u,be]):this.u.push(be):(this.f?.onWillAddFirstListener?.(this),this.u=be,this.f?.onDidAddFirstListener?.(this)),this.z++;const ue=(0,j.$Rc)(()=>{d?.unregister(ue),ke?.(),this.A(be)});if(ce instanceof j.$Sc?ce.add(ue):Array.isArray(ce)&&ce.push(ue),d){const Q=new Error().stack.split(`
`).slice(2,3).join(`
`).trim(),he=/(file:|vscode-file:\/\/vscode-app)?(\/[^:]*:\d+:\d+)/.exec(Q);d.register(ue,he?.[2]??Q,ue)}return ue},this.q}A(q){if(this.f?.onWillRemoveListener?.(this),!this.u)return;if(this.z===1){this.u=void 0,this.f?.onDidRemoveLastListener?.(this),this.z=0;return}const ee=this.u,ce=ee.indexOf(q);if(ce===-1)throw console.log("disposed?",this.m),console.log("size?",this.z),console.log("arr?",JSON.stringify(this.u)),new Error("Attempted to dispose unknown listener");this.z--,ee[ce]=void 0;const be=this.w.current===this;if(this.z*k<=ee.length){let ke=0;for(let Fe=0;Fe<ee.length;Fe++)ee[Fe]?ee[ke++]=ee[Fe]:be&&(this.w.end--,ke<this.w.i&&this.w.i--);ee.length=ke}}B(q,ee){if(!q)return;const ce=this.f?.onListenerError||i.$Y;if(!ce){q.value(ee);return}try{q.value(ee)}catch(be){ce(be)}}C(q){const ee=q.current.u;for(;q.i<q.end;)this.B(ee[q.i++],q.value);q.reset()}fire(q){if(this.w?.current&&(this.C(this.w),this.j?.stop()),this.j?.start(this.z),this.u)if(this.u instanceof v)this.B(this.u,q);else{const ee=this.w;ee.enqueue(this,q,this.u.length),this.C(ee)}this.j?.stop()}hasListeners(){return this.z>0}}t.$je=f;const b=()=>new S;t.$ke=b;class S{constructor(){this.i=-1,this.end=0}enqueue(q,ee,ce){this.i=0,this.end=ce,this.current=q,this.value=ee}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class U extends f{async fireAsync(q,ee,ce){if(this.u)for(this.h||(this.h=new F.$4c),A(this.u,be=>this.h.push([be.value,q]));this.h.size>0&&!ee.isCancellationRequested;){const[be,ke]=this.h.shift(),Fe=[],ue={...ke,token:ee,waitUntil:Q=>{if(Object.isFrozen(Fe))throw new Error("waitUntil can NOT be called asynchronous");ce&&(Q=ce(Q,be)),Fe.push(Q)}};try{be(ue)}catch(Q){(0,i.$Y)(Q);continue}Object.freeze(Fe),await Promise.allSettled(Fe).then(Q=>{for(const he of Q)he.status==="rejected"&&(0,i.$Y)(he.reason)})}}}t.$le=U;class _ extends f{get isPaused(){return this.h!==0}constructor(q){super(q),this.h=0,this.s=new F.$4c,this.t=q?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.t){if(this.s.size>0){const q=Array.from(this.s);this.s.clear(),super.fire(this.t(q))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(q){this.z&&(this.h!==0?this.s.push(q):super.fire(q))}}t.$me=_;class B extends _{constructor(q){super(q),this.k=q.delay??100}fire(q){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(q)}}t.$ne=B;class E extends f{constructor(q){super(q),this.h=[],this.k=q?.merge}fire(q){this.hasListeners()&&(this.h.push(q),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(ee=>super.fire(ee)),this.h=[]}))}}t.$oe=E;class I{constructor(){this.g=!1,this.h=[],this.f=new f({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(q){const ee={event:q,listener:null};this.h.push(ee),this.g&&this.m(ee);const ce=()=>{this.g&&this.o(ee);const be=this.h.indexOf(ee);this.h.splice(be,1)};return(0,j.$Rc)((0,n.$cb)(ce))}j(){this.g=!0,this.h.forEach(q=>this.m(q))}k(){this.g=!1,this.h.forEach(q=>this.o(q))}m(q){q.listener=q.event(ee=>this.f.fire(ee))}o(q){q.listener?.dispose(),q.listener=null}dispose(){this.f.dispose();for(const q of this.h)q.listener?.dispose();this.h=[]}}t.$pe=I;class z{constructor(q,ee,ce,be){this.f=new j.$Sc;const ke=this.f.add(new I),Fe=this.f.add(new j.$3c);function ue(Q){Fe.set(Q,ke.add(be(Q)))}for(const Q of q)ue(Q);this.f.add(ee(Q=>{ue(Q)})),this.f.add(ce(Q=>{Fe.deleteAndDispose(Q)})),this.event=ke.event}dispose(){this.f.dispose()}}t.$qe=z;class O{constructor(){this.f=[]}wrapEvent(q,ee,ce){return(be,ke,Fe)=>q(ue=>{const Q=this.f[this.f.length-1];if(!ee){Q?Q.buffers.push(()=>be.call(ke,ue)):be.call(ke,ue);return}const he=Q;if(!he){be.call(ke,ee(ce,ue));return}he.items??=[],he.items.push(ue),he.buffers.length===0&&Q.buffers.push(()=>{he.reducedResult??=ce?he.items.reduce(ee,ce):he.items.reduce(ee),be.call(ke,he.reducedResult)})},void 0,Fe)}bufferEvents(q){const ee={buffers:new Array};this.f.push(ee);const ce=q();return this.f.pop(),ee.buffers.forEach(be=>be()),ce}}t.$re=O;class C{constructor(){this.f=!1,this.g=p.None,this.h=j.$Tc.None,this.j=new f({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(q){this.g=q,this.f&&(this.h.dispose(),this.h=q(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}t.$se=C;class x{static const(q){return new Z(q)}constructor(q){this.g=q,this.f=new f,this.onDidChange=this.f.event}get value(){return this.g}set value(q){q!==this.g&&(this.g=q,this.f.fire(void 0))}}t.$te=x;class Z{constructor(q){this.value=q,this.onDidChange=p.None}}}),define(we[18],ve([1,0,24,3]),function(re,t,i,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$cS=t.$bS=t.$aS=t.$_R=t.$$R=t.$0R=t.$9R=t.$8R=t.$3R=void 0,t.$ZR=F,t.$1R=N,t.$2R=w,t.$4R=D,t.$5R=c,t.$6R=p,t.$7R=y,t.$dS=e,t.$eS=s,t.$fS=r;class j{constructor(){this.a=new Map,this.b=new n.$je,this.onDidChangeZoomLevel=this.b.event,this.c=new Map,this.d=new n.$je,this.onDidChangeFullscreen=this.d.event,this.e=new Map}static{this.INSTANCE=new j}getZoomLevel(l){return this.a.get(this.f(l))??0}setZoomLevel(l,v){if(this.getZoomLevel(v)===l)return;const k=this.f(v);this.a.set(k,l),this.b.fire(k)}getZoomFactor(l){return this.c.get(this.f(l))??1}setZoomFactor(l,v){this.c.set(this.f(v),l)}setFullscreen(l,v){if(this.isFullscreen(v)===l)return;const k=this.f(v);this.e.set(k,l),this.d.fire(k)}isFullscreen(l){return!!this.e.get(this.f(l))}f(l){return l.vscodeWindowId}}function F(h,l,v){typeof l=="string"&&(l=h.matchMedia(l)),l.addEventListener("change",v)}function N(h,l){j.INSTANCE.setZoomLevel(h,l)}function w(h){return j.INSTANCE.getZoomLevel(h)}t.$3R=j.INSTANCE.onDidChangeZoomLevel;function D(h){return j.INSTANCE.getZoomFactor(h)}function c(h,l){j.INSTANCE.setZoomFactor(h,l)}function p(h,l){j.INSTANCE.setFullscreen(h,l)}function y(h){return j.INSTANCE.isFullscreen(h)}t.$8R=j.INSTANCE.onDidChangeFullscreen;const $=navigator.userAgent;t.$9R=$.indexOf("Firefox")>=0,t.$0R=$.indexOf("AppleWebKit")>=0,t.$$R=$.indexOf("Chrome")>=0,t.$_R=!t.$$R&&$.indexOf("Safari")>=0,t.$aS=!t.$$R&&!t.$_R&&t.$0R,t.$bS=$.indexOf("Electron/")>=0,t.$cS=$.indexOf("Android")>=0;let g=!1;if(typeof i.$WR.matchMedia=="function"){const h=i.$WR.matchMedia("(display-mode: standalone) or (display-mode: window-controls-overlay)"),l=i.$WR.matchMedia("(display-mode: fullscreen)");g=h.matches,F(i.$WR,h,({matches:v})=>{g&&l.matches||(g=v)})}function e(){return g}function s(){return navigator?.windowControlsOverlay?.visible}function r(){return navigator?.windowControlsOverlay?.getTitlebarAreaRect()}}),define(we[61],ve([1,0,18,24,5]),function(re,t,i,n,j){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$gS=t.KeyboardSupport=void 0,i=He(i),j=He(j);var F;(function(N){N[N.Always=0]="Always",N[N.FullScreen=1]="FullScreen",N[N.None=2]="None"})(F||(t.KeyboardSupport=F={})),t.$gS={clipboard:{writeText:j.$n||document.queryCommandSupported&&document.queryCommandSupported("copy")||!!(navigator&&navigator.clipboard&&navigator.clipboard.writeText),readText:j.$n||!!(navigator&&navigator.clipboard&&navigator.clipboard.readText)},keyboard:j.$n||i.$dS()?F.Always:navigator.keyboard||i.$_R?F.FullScreen:F.None,touch:"ontouchstart"in n.$WR||navigator.maxTouchPoints>0,pointerEvents:n.$WR.PointerEvent&&("ontouchstart"in n.$WR||navigator.maxTouchPoints>0)}}),define(we[29],ve([1,0,3]),function(re,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$GU=void 0;class n{get event(){return this.a.event}constructor(F,N,w){const D=c=>this.a.fire(c);this.a=new i.$je({onWillAddFirstListener:()=>F.addEventListener(N,D,w),onDidRemoveLastListener:()=>F.removeEventListener(N,D,w)})}dispose(){this.a.dispose()}}t.$GU=n}),define(we[15],ve([1,0,18,8,98,5]),function(re,t,i,n,j,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$oS=void 0,t.$mS=y,t.$nS=$,i=He(i),F=He(F);function N(e){if(e.charCode){const r=String.fromCharCode(e.charCode).toUpperCase();return n.KeyCodeUtils.fromString(r)}const s=e.keyCode;if(s===3)return n.KeyCode.PauseBreak;if(i.$9R)switch(s){case 59:return n.KeyCode.Semicolon;case 60:if(F.$l)return n.KeyCode.IntlBackslash;break;case 61:return n.KeyCode.Equal;case 107:return n.KeyCode.NumpadAdd;case 109:return n.KeyCode.NumpadSubtract;case 173:return n.KeyCode.Minus;case 224:if(F.$k)return n.KeyCode.Meta;break}else if(i.$0R){if(F.$k&&s===93)return n.KeyCode.Meta;if(!F.$k&&s===92)return n.KeyCode.Meta}return n.$Qr[s]||n.KeyCode.Unknown}const w=F.$k?n.KeyMod.WinCtrl:n.KeyMod.CtrlCmd,D=n.KeyMod.Alt,c=n.KeyMod.Shift,p=F.$k?n.KeyMod.CtrlCmd:n.KeyMod.WinCtrl;function y(e){const s=[];return e.ctrlKey&&s.push("ctrl"),e.shiftKey&&s.push("shift"),e.altKey&&s.push("alt"),e.metaKey&&s.push("meta"),`modifiers: [${s.join(",")}], code: ${e.code}, keyCode: ${e.keyCode}, key: ${e.key}`}function $(e){const s=[];return e.ctrlKey&&s.push("ctrl"),e.shiftKey&&s.push("shift"),e.altKey&&s.push("alt"),e.metaKey&&s.push("meta"),`modifiers: [${s.join(",")}], code: ${e.code}, keyCode: ${e.keyCode} ('${n.KeyCodeUtils.toString(e.keyCode)}')`}class g{constructor(s){this._standardKeyboardEventBrand=!0;const r=s;this.browserEvent=r,this.target=r.target,this.ctrlKey=r.ctrlKey,this.shiftKey=r.shiftKey,this.altKey=r.altKey,this.metaKey=r.metaKey,this.altGraphKey=r.getModifierState?.("AltGraph"),this.keyCode=N(r),this.code=r.code,this.ctrlKey=this.ctrlKey||this.keyCode===n.KeyCode.Ctrl,this.altKey=this.altKey||this.keyCode===n.KeyCode.Alt,this.shiftKey=this.shiftKey||this.keyCode===n.KeyCode.Shift,this.metaKey=this.metaKey||this.keyCode===n.KeyCode.Meta,this.a=this.c(),this.b=this.d()}preventDefault(){this.browserEvent&&this.browserEvent.preventDefault&&this.browserEvent.preventDefault()}stopPropagation(){this.browserEvent&&this.browserEvent.stopPropagation&&this.browserEvent.stopPropagation()}toKeyCodeChord(){return this.b}equals(s){return this.a===s}c(){let s=n.KeyCode.Unknown;this.keyCode!==n.KeyCode.Ctrl&&this.keyCode!==n.KeyCode.Shift&&this.keyCode!==n.KeyCode.Alt&&this.keyCode!==n.KeyCode.Meta&&(s=this.keyCode);let r=0;return this.ctrlKey&&(r|=w),this.altKey&&(r|=D),this.shiftKey&&(r|=c),this.metaKey&&(r|=p),r|=s,r}d(){let s=n.KeyCode.Unknown;return this.keyCode!==n.KeyCode.Ctrl&&this.keyCode!==n.KeyCode.Shift&&this.keyCode!==n.KeyCode.Alt&&this.keyCode!==n.KeyCode.Meta&&(s=this.keyCode),new j.$Yr(this.ctrlKey,this.shiftKey,this.altKey,this.metaKey,s)}}t.$oS=g}),define(we[19],ve([1,0,18,85,5]),function(re,t,i,n,j){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$lS=t.$kS=t.$jS=void 0,i=He(i),j=He(j);class F{constructor(c,p){this.timestamp=Date.now(),this.browserEvent=p,this.leftButton=p.button===0,this.middleButton=p.button===1,this.rightButton=p.button===2,this.buttons=p.buttons,this.target=p.target,this.detail=p.detail||1,p.type==="dblclick"&&(this.detail=2),this.ctrlKey=p.ctrlKey,this.shiftKey=p.shiftKey,this.altKey=p.altKey,this.metaKey=p.metaKey,typeof p.pageX=="number"?(this.posx=p.pageX,this.posy=p.pageY):(this.posx=p.clientX+this.target.ownerDocument.body.scrollLeft+this.target.ownerDocument.documentElement.scrollLeft,this.posy=p.clientY+this.target.ownerDocument.body.scrollTop+this.target.ownerDocument.documentElement.scrollTop);const y=n.$hS.getPositionOfChildWindowRelativeToAncestorWindow(c,p.view);this.posx-=y.left,this.posy-=y.top}preventDefault(){this.browserEvent.preventDefault()}stopPropagation(){this.browserEvent.stopPropagation()}}t.$jS=F;class N extends F{constructor(c,p){super(c,p),this.dataTransfer=p.dataTransfer}}t.$kS=N;class w{constructor(c,p=0,y=0){this.browserEvent=c||null,this.target=c?c.target||c.targetNode||c.srcElement:null,this.deltaY=y,this.deltaX=p;let $=!1;if(i.$$R){const g=navigator.userAgent.match(/Chrome\/(\d+)/);$=(g?parseInt(g[1]):123)<=122}if(c){const g=c,e=c,s=c.view?.devicePixelRatio||1;if(typeof g.wheelDeltaY<"u")$?this.deltaY=g.wheelDeltaY/(120*s):this.deltaY=g.wheelDeltaY/120;else if(typeof e.VERTICAL_AXIS<"u"&&e.axis===e.VERTICAL_AXIS)this.deltaY=-e.detail/3;else if(c.type==="wheel"){const r=c;r.deltaMode===r.DOM_DELTA_LINE?i.$9R&&!j.$k?this.deltaY=-c.deltaY/3:this.deltaY=-c.deltaY:this.deltaY=-c.deltaY/40}if(typeof g.wheelDeltaX<"u")i.$_R&&j.$j?this.deltaX=-(g.wheelDeltaX/120):$?this.deltaX=g.wheelDeltaX/(120*s):this.deltaX=g.wheelDeltaX/120;else if(typeof e.HORIZONTAL_AXIS<"u"&&e.axis===e.HORIZONTAL_AXIS)this.deltaX=-c.detail/3;else if(c.type==="wheel"){const r=c;r.deltaMode===r.DOM_DELTA_LINE?i.$9R&&!j.$k?this.deltaX=-c.deltaX/3:this.deltaX=-c.deltaX:this.deltaX=-c.deltaX/40}this.deltaY===0&&this.deltaX===0&&c.wheelDelta&&($?this.deltaY=c.wheelDelta/(120*s):this.deltaY=c.wheelDelta/120)}}preventDefault(){this.browserEvent?.preventDefault()}stopPropagation(){this.browserEvent?.stopPropagation()}}t.$lS=w}),define(we[38],ve([1,0,3]),function(re,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ue=t.CancellationToken=void 0,t.$ve=w;const n=Object.freeze(function(D,c){const p=setTimeout(D.bind(c),0);return{dispose(){clearTimeout(p)}}});var j;(function(D){function c(p){return p===D.None||p===D.Cancelled||p instanceof F?!0:!p||typeof p!="object"?!1:typeof p.isCancellationRequested=="boolean"&&typeof p.onCancellationRequested=="function"}D.isCancellationToken=c,D.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:i.Event.None}),D.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:n})})(j||(t.CancellationToken=j={}));class F{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?n:(this.b||(this.b=new i.$je),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class N{constructor(c){this.f=void 0,this.g=void 0,this.g=c&&c.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new F),this.f}cancel(){this.f?this.f instanceof F&&this.f.cancel():this.f=j.Cancelled}dispose(c=!1){c&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof F&&this.f.dispose():this.f=j.None}}t.$ue=N;function w(D){const c=new N;return D.add({dispose(){c.cancel()}}),c.token}}),define(we[103],ve([1,0,38]),function(re,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$0e=t.$9e=t.$7e=void 0,t.$8e=j;class n{constructor(D){this.b=D,this.a=null}get(){if(this.a)return this.a;const D=new i.$ue,c=this.b(D.token);return this.a={promise:c,dispose:()=>{this.a=null,D.cancel(),D.dispose()}},this.a}}t.$7e=n;function j(w){return w}class F{constructor(D,c){this.a=void 0,this.b=void 0,typeof D=="function"?(this.c=D,this.d=j):(this.c=c,this.d=D.getCacheKey)}get(D){const c=this.d(D);return this.b!==c&&(this.b=c,this.a=this.c(D)),this.a}}t.$9e=F;class N{get cachedValues(){return this.a}constructor(D,c){this.a=new Map,this.b=new Map,typeof D=="function"?(this.c=D,this.d=j):(this.c=c,this.d=D.getCacheKey)}get(D){const c=this.d(D);if(this.b.has(c))return this.b.get(c);const p=this.c(D);return this.a.set(D,p),this.b.set(c,p),p}}t.$0e=N}),define(we[104],ve([1,0,44,27,45,38,26,30,6]),function(re,t,i,n,j,F,N,w,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$$d=t.$0d=t.$9d=t.$8d=void 0,t.$_d=g,t.$ae=e;class c{get cachedValue(){return this.a}constructor(r){this.b=r,this.a=(0,n.$4d)(this,void 0)}getValue(){let r=this.a.get();return r||(r=this.b(),this.a.set(r,void 0)),r}}t.$8d=c;class p{static fromFn(r){return new p(r())}constructor(r){this.a=(0,n.$4d)(this,void 0),this.promiseResult=this.a,this.promise=r.then(h=>((0,n.$Yd)(l=>{this.a.set(new y(h,void 0),l)}),h),h=>{throw(0,n.$Yd)(l=>{this.a.set(new y(void 0,h),l)}),h})}}t.$9d=p;class y{constructor(r,h){this.data=r,this.error=h}getDataOrThrow(){if(this.error)throw this.error;return this.data}}t.$0d=y;class ${constructor(r){this.b=r,this.a=new c(()=>new p(this.b())),this.cachedPromiseResult=(0,j.$Ld)(this,h=>this.a.cachedValue.read(h)?.promiseResult.read(h))}getPromise(){return this.a.getValue().promise}}t.$$d=$;function g(s,r,h,l){return r||(r=v=>v!=null),new Promise((v,k)=>{let A=!0,d=!1;const f=s.map(S=>({isFinished:r(S),error:h?h(S):!1,state:S})),b=(0,i.$id)(S=>{const{isFinished:U,error:_,state:B}=f.read(S);(U||_)&&(A?d=!0:b.dispose(),_?k(_===!0?B:_):v(B))});if(l){const S=l.onCancellationRequested(()=>{b.dispose(),S.dispose(),k(new D.$4)});if(l.isCancellationRequested){b.dispose(),S.dispose(),k(new D.$4);return}}A=!1,d&&b.dispose()})}function e(s,r){let h,l;r===void 0?(h=s,l=void 0):(l=s,h=r);let v;return new j.$Rd(new N.$_c(l,void 0,h),k=>(v&&v.dispose(!0),v=new F.$ue,h(k,v.token)),void 0,void 0,()=>v?.dispose(),w.$5c)}}),define(we[105],ve([1,0,3,2,44,27,26,45,31,6,30]),function(re,t,i,n,j,F,N,w,D,c,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Fd=t.$Bd=t.$td=void 0,t.$pd=y,t.$qd=g,t.$rd=e,t.$sd=s,t.$ud=h,t.$vd=v,t.$wd=A,t.$xd=d,t.$yd=f,t.$zd=b,t.$Ad=S,t.$Cd=_,t.$Dd=B,t.$Ed=E,t.$Gd=O,t.$Hd=C;function y(x){return new $(x)}class $ extends F.$Wd{constructor(Z){super(),this.b=Z}get debugName(){return this.toString()}get(){return this.b}addObserver(Z){}removeObserver(Z){}toString(){return`Const: ${this.b}`}}function g(x){const Z=(0,F.$4d)("promiseValue",{});return x.then(Y=>{Z.set({value:Y},void 0)}),Z}function e(...x){let Z,Y,q;return x.length===3?[Z,Y,q]=x:[Y,q]=x,new r(new N.$_c(Z,void 0,q),Y,q,()=>r.globalTransaction,p.$5c)}function s(x,Z,Y){return new r(new N.$_c(x.owner,x.debugName,x.debugReferenceFn??Y),Z,Y,()=>r.globalTransaction,x.equalsFn??p.$5c)}class r extends F.$Xd{constructor(Z,Y,q,ee,ce){super(),this.j=Z,this.k=Y,this._getValue=q,this.l=ee,this.n=ce,this.g=!1,this.r=be=>{const ke=this._getValue(be),Fe=this.e,ue=!this.g||!this.n(Fe,ke);let Q=!1;ue&&(this.e=ke,this.g&&(Q=!0,(0,F.$2d)(this.l(),he=>{(0,D.$Jd)()?.handleFromEventObservableTriggered(this,{oldValue:Fe,newValue:ke,change:void 0,didChange:ue,hadValue:this.g});for(const le of this.b)he.updateObserver(le,this),le.handleChange(this,void 0)},()=>{const he=this.p();return"Event fired"+(he?`: ${he}`:"")})),this.g=!0),Q||(0,D.$Jd)()?.handleFromEventObservableTriggered(this,{oldValue:Fe,newValue:ke,change:void 0,didChange:ue,hadValue:this.g})}}p(){return this.j.getDebugName(this)}get debugName(){const Z=this.p();return"From Event"+(Z?`: ${Z}`:"")}c(){this.h=this.k(this.r)}f(){this.h.dispose(),this.h=void 0,this.g=!1,this.e=void 0}get(){return this.h?(this.g||this.r(void 0),this.e):this._getValue(void 0)}}t.$td=r,function(x){x.Observer=r;function Z(Y,q){let ee=!1;r.globalTransaction===void 0&&(r.globalTransaction=Y,ee=!0);try{q()}finally{ee&&(r.globalTransaction=void 0)}}x.batchEventsGlobally=Z}(e||(t.$rd=e={}));function h(x,Z){return new l(x,Z)}class l extends F.$Xd{constructor(Z,Y){super(),this.debugName=Z,this.g=Y,this.j=()=>{(0,F.$Yd)(q=>{for(const ee of this.b)q.updateObserver(ee,this),ee.handleChange(this,void 0)},()=>this.debugName)}}c(){this.e=this.g(this.j)}f(){this.e.dispose(),this.e=void 0}get(){}}function v(x){return typeof x=="string"?new k(x):new k(void 0,x)}class k extends F.$Xd{get debugName(){return new N.$_c(this.g,this.e,void 0).getDebugName(this)??"Observable Signal"}toString(){return this.debugName}constructor(Z,Y){super(),this.e=Z,this.g=Y}trigger(Z,Y){if(!Z){(0,F.$Yd)(q=>{this.trigger(q,Y)},()=>`Trigger signal ${this.debugName}`);return}for(const q of this.b)Z.updateObserver(q,this),q.handleChange(this,Y)}get(){}}function A(x,Z,Y){const q=(0,F.$4d)("debounced",void 0);let ee;return Y.add((0,j.$id)(ce=>{const be=x.read(ce);ee&&clearTimeout(ee),ee=setTimeout(()=>{(0,F.$Yd)(ke=>{q.set(be,ke)})},Z)})),q}function d(x,Z){let Y=!1,q,ee;return e(ce=>{const be=(0,j.$id)(ke=>{const Fe=x.read(ke);Y?(ee&&clearTimeout(ee),ee=setTimeout(()=>{q=Fe,ce()},Z)):(Y=!0,q=Fe)});return{dispose(){be.dispose(),Y=!1,q=void 0}}},()=>Y?q:x.get())}function f(x,Z,Y){const q=(0,F.$4d)("triggeredRecently",!1);let ee;return Y.add(x(()=>{q.set(!0,void 0),ee&&clearTimeout(ee),ee=setTimeout(()=>{q.set(!1,void 0)},Z)})),q}function b(x){const Z=new U(!1,void 0);return x.addObserver(Z),(0,n.$Rc)(()=>{x.removeObserver(Z)})}(0,F.$Ud)(b);function S(x,Z){const Y=new U(!0,Z);return x.addObserver(Y),Z?Z(x.get()):x.reportChanges(),(0,n.$Rc)(()=>{x.removeObserver(Y)})}(0,F.$Td)(S);class U{constructor(Z,Y){this.b=Z,this.c=Y,this.a=0}beginUpdate(Z){this.a++}endUpdate(Z){this.a--,this.a===0&&this.b&&(this.c?this.c(Z.get()):Z.reportChanges())}handlePossibleChange(Z){}handleChange(Z,Y){}}t.$Bd=U;function _(x,Z){let Y;return(0,w.$Nd)({owner:x,debugReferenceFn:Z},ee=>(Y=Z(ee,Y),Y))}function B(x,Z){let Y;const q=v("derivedObservableWithWritableCache"),ee=(0,w.$Ld)(x,ce=>(q.read(ce),Y=Z(ce,Y),Y));return Object.assign(ee,{clearCache:ce=>{Y=void 0,q.trigger(ce)},setCache:(ce,be)=>{Y=ce,q.trigger(be)}})}function E(x,Z,Y,q){let ee=new I(Y,q);return(0,w.$Nd)({debugReferenceFn:Y,owner:x,onLastObserverRemoved:()=>{ee.dispose(),ee=new I(Y)}},be=>(ee.setItems(Z.read(be)),ee.getItems()))}class I{constructor(Z,Y){this.c=Z,this.e=Y,this.a=new Map,this.b=[]}dispose(){this.a.forEach(Z=>Z.store.dispose()),this.a.clear()}setItems(Z){const Y=[],q=new Set(this.a.keys());for(const ee of Z){const ce=this.e?this.e(ee):ee;let be=this.a.get(ce);if(be)q.delete(ce);else{const ke=new n.$Sc;be={out:this.c(ee,ke),store:ke},this.a.set(ce,be)}Y.push(be.out)}for(const ee of q)this.a.get(ee).store.dispose(),this.a.delete(ee);this.b=Y}getItems(){return this.b}}class z{constructor(Z){this.observable=Z}get onDidChange(){return i.Event.fromObservableLight(this.observable)}get value(){return this.observable.get()}}t.$Fd=z;function O(x,Z){return Z instanceof z?Z.observable:e(x,Z.onDidChange,()=>Z.value)}function C(x,Z){if(Z.length===0)throw new c.$bb;let Y=!1,q;const ee=e(x,ce=>{const be=new n.$Sc;for(const ke of Z)be.add((0,j.$jd)({debugName:()=>(0,N.$ad)(ee,new N.$_c(x,void 0,void 0))+".updateLastChangedValue"},Fe=>{Y=!0,q=ke.read(Fe),ce()}));return be.add({dispose(){Y=!1,q=void 0}}),be},()=>Y?q:Z[Z.length-1].get());return ee}}),define(we[62],ve([1,0,27,45,44,105,104,97,31]),function(re,t,i,n,j,F,N,w,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.observableValueOpts=t.derivedWithCancellationToken=t.waitForState=t.PromiseResult=t.ObservablePromise=t.ObservableLazyPromise=t.ObservableLazy=t.wasEventTriggeredRecently=t.observableSignalFromEvent=t.observableSignal=t.observableFromPromise=t.observableFromEvent=t.recomputeInitiallyAndOnChange=t.keepObserved=t.derivedObservableWithWritableCache=t.derivedObservableWithCache=t.debouncedObservable=t.constObservable=t.autorunWithStoreHandleChanges=t.autorunOpts=t.autorunWithStore=t.autorunHandleChanges=t.autorunDelta=t.autorun=t.derivedWithStore=t.derivedHandleChanges=t.derivedOpts=t.derived=t.subtransaction=t.transaction=t.disposableObservableValue=t.observableValue=void 0,Object.defineProperty(t,"observableValue",{enumerable:!0,get:function(){return i.$4d}}),Object.defineProperty(t,"disposableObservableValue",{enumerable:!0,get:function(){return i.$6d}}),Object.defineProperty(t,"transaction",{enumerable:!0,get:function(){return i.$Yd}}),Object.defineProperty(t,"subtransaction",{enumerable:!0,get:function(){return i.$2d}}),Object.defineProperty(t,"derived",{enumerable:!0,get:function(){return n.$Ld}}),Object.defineProperty(t,"derivedOpts",{enumerable:!0,get:function(){return n.$Nd}}),Object.defineProperty(t,"derivedHandleChanges",{enumerable:!0,get:function(){return n.$Od}}),Object.defineProperty(t,"derivedWithStore",{enumerable:!0,get:function(){return n.$Pd}}),Object.defineProperty(t,"autorun",{enumerable:!0,get:function(){return j.$id}}),Object.defineProperty(t,"autorunDelta",{enumerable:!0,get:function(){return j.$nd}}),Object.defineProperty(t,"autorunHandleChanges",{enumerable:!0,get:function(){return j.$kd}}),Object.defineProperty(t,"autorunWithStore",{enumerable:!0,get:function(){return j.$md}}),Object.defineProperty(t,"autorunOpts",{enumerable:!0,get:function(){return j.$jd}}),Object.defineProperty(t,"autorunWithStoreHandleChanges",{enumerable:!0,get:function(){return j.$ld}}),Object.defineProperty(t,"constObservable",{enumerable:!0,get:function(){return F.$pd}}),Object.defineProperty(t,"debouncedObservable",{enumerable:!0,get:function(){return F.$wd}}),Object.defineProperty(t,"derivedObservableWithCache",{enumerable:!0,get:function(){return F.$Cd}}),Object.defineProperty(t,"derivedObservableWithWritableCache",{enumerable:!0,get:function(){return F.$Dd}}),Object.defineProperty(t,"keepObserved",{enumerable:!0,get:function(){return F.$zd}}),Object.defineProperty(t,"recomputeInitiallyAndOnChange",{enumerable:!0,get:function(){return F.$Ad}}),Object.defineProperty(t,"observableFromEvent",{enumerable:!0,get:function(){return F.$rd}}),Object.defineProperty(t,"observableFromPromise",{enumerable:!0,get:function(){return F.$qd}}),Object.defineProperty(t,"observableSignal",{enumerable:!0,get:function(){return F.$vd}}),Object.defineProperty(t,"observableSignalFromEvent",{enumerable:!0,get:function(){return F.$ud}}),Object.defineProperty(t,"wasEventTriggeredRecently",{enumerable:!0,get:function(){return F.$yd}}),Object.defineProperty(t,"ObservableLazy",{enumerable:!0,get:function(){return N.$8d}}),Object.defineProperty(t,"ObservableLazyPromise",{enumerable:!0,get:function(){return N.$$d}}),Object.defineProperty(t,"ObservablePromise",{enumerable:!0,get:function(){return N.$9d}}),Object.defineProperty(t,"PromiseResult",{enumerable:!0,get:function(){return N.$0d}}),Object.defineProperty(t,"waitForState",{enumerable:!0,get:function(){return N.$_d}}),Object.defineProperty(t,"derivedWithCancellationToken",{enumerable:!0,get:function(){return N.$ae}}),Object.defineProperty(t,"observableValueOpts",{enumerable:!0,get:function(){return w.$ce}}),!1&&(0,D.$Id)(new D.$Kd)}),define(we[20],ve([1,0,3,2]),function(re,t,i,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$dt=t.$ct=t.$bt=t.$at=t.ScrollbarVisibility=void 0;var j;(function(g){g[g.Auto=1]="Auto",g[g.Hidden=2]="Hidden",g[g.Visible=3]="Visible"})(j||(t.ScrollbarVisibility=j={}));class F{constructor(e,s,r,h,l,v,k){this.c=e,this._scrollStateBrand=void 0,this.c&&(s=s|0,r=r|0,h=h|0,l=l|0,v=v|0,k=k|0),this.rawScrollLeft=h,this.rawScrollTop=k,s<0&&(s=0),h+s>r&&(h=r-s),h<0&&(h=0),l<0&&(l=0),k+l>v&&(k=v-l),k<0&&(k=0),this.width=s,this.scrollWidth=r,this.scrollLeft=h,this.height=l,this.scrollHeight=v,this.scrollTop=k}equals(e){return this.rawScrollLeft===e.rawScrollLeft&&this.rawScrollTop===e.rawScrollTop&&this.width===e.width&&this.scrollWidth===e.scrollWidth&&this.scrollLeft===e.scrollLeft&&this.height===e.height&&this.scrollHeight===e.scrollHeight&&this.scrollTop===e.scrollTop}withScrollDimensions(e,s){return new F(this.c,typeof e.width<"u"?e.width:this.width,typeof e.scrollWidth<"u"?e.scrollWidth:this.scrollWidth,s?this.rawScrollLeft:this.scrollLeft,typeof e.height<"u"?e.height:this.height,typeof e.scrollHeight<"u"?e.scrollHeight:this.scrollHeight,s?this.rawScrollTop:this.scrollTop)}withScrollPosition(e){return new F(this.c,this.width,this.scrollWidth,typeof e.scrollLeft<"u"?e.scrollLeft:this.rawScrollLeft,this.height,this.scrollHeight,typeof e.scrollTop<"u"?e.scrollTop:this.rawScrollTop)}createScrollEvent(e,s){const r=this.width!==e.width,h=this.scrollWidth!==e.scrollWidth,l=this.scrollLeft!==e.scrollLeft,v=this.height!==e.height,k=this.scrollHeight!==e.scrollHeight,A=this.scrollTop!==e.scrollTop;return{inSmoothScrolling:s,oldWidth:e.width,oldScrollWidth:e.scrollWidth,oldScrollLeft:e.scrollLeft,width:this.width,scrollWidth:this.scrollWidth,scrollLeft:this.scrollLeft,oldHeight:e.height,oldScrollHeight:e.scrollHeight,oldScrollTop:e.scrollTop,height:this.height,scrollHeight:this.scrollHeight,scrollTop:this.scrollTop,widthChanged:r,scrollWidthChanged:h,scrollLeftChanged:l,heightChanged:v,scrollHeightChanged:k,scrollTopChanged:A}}}t.$at=F;class N extends n.$Tc{constructor(e){super(),this._scrollableBrand=void 0,this.j=this.B(new i.$je),this.onScroll=this.j.event,this.c=e.smoothScrollDuration,this.f=e.scheduleAtNextAnimationFrame,this.g=new F(e.forceIntegerValues,0,0,0,0,0,0),this.h=null}dispose(){this.h&&(this.h.dispose(),this.h=null),super.dispose()}setSmoothScrollDuration(e){this.c=e}validateScrollPosition(e){return this.g.withScrollPosition(e)}getScrollDimensions(){return this.g}setScrollDimensions(e,s){const r=this.g.withScrollDimensions(e,s);this.n(r,!!this.h),this.h?.acceptScrollDimensions(this.g)}getFutureScrollPosition(){return this.h?this.h.to:this.g}getCurrentScrollPosition(){return this.g}setScrollPositionNow(e){const s=this.g.withScrollPosition(e);this.h&&(this.h.dispose(),this.h=null),this.n(s,!1)}setScrollPositionSmooth(e,s){if(this.c===0)return this.setScrollPositionNow(e);if(this.h){e={scrollLeft:typeof e.scrollLeft>"u"?this.h.to.scrollLeft:e.scrollLeft,scrollTop:typeof e.scrollTop>"u"?this.h.to.scrollTop:e.scrollTop};const r=this.g.withScrollPosition(e);if(this.h.to.scrollLeft===r.scrollLeft&&this.h.to.scrollTop===r.scrollTop)return;let h;s?h=new p(this.h.from,r,this.h.startTime,this.h.duration):h=this.h.combine(this.g,r,this.c),this.h.dispose(),this.h=h}else{const r=this.g.withScrollPosition(e);this.h=p.start(this.g,r,this.c)}this.h.animationFrameDisposable=this.f(()=>{this.h&&(this.h.animationFrameDisposable=null,this.m())})}hasPendingScrollAnimation(){return!!this.h}m(){if(!this.h)return;const e=this.h.tick(),s=this.g.withScrollPosition(e);if(this.n(s,!0),!!this.h){if(e.isDone){this.h.dispose(),this.h=null;return}this.h.animationFrameDisposable=this.f(()=>{this.h&&(this.h.animationFrameDisposable=null,this.m())})}}n(e,s){const r=this.g;r.equals(e)||(this.g=e,this.j.fire(this.g.createScrollEvent(r,s)))}}t.$bt=N;class w{constructor(e,s,r){this.scrollLeft=e,this.scrollTop=s,this.isDone=r}}t.$ct=w;function D(g,e){const s=e-g;return function(r){return g+s*$(r)}}function c(g,e,s){return function(r){return r<s?g(r/s):e((r-s)/(1-s))}}class p{constructor(e,s,r,h){this.from=e,this.to=s,this.duration=h,this.startTime=r,this.animationFrameDisposable=null,this.e()}e(){this.c=this.f(this.from.scrollLeft,this.to.scrollLeft,this.to.width),this.d=this.f(this.from.scrollTop,this.to.scrollTop,this.to.height)}f(e,s,r){if(Math.abs(e-s)>2.5*r){let l,v;return e<s?(l=e+.75*r,v=s-.75*r):(l=e-.75*r,v=s+.75*r),c(D(e,l),D(v,s),.33)}return D(e,s)}dispose(){this.animationFrameDisposable!==null&&(this.animationFrameDisposable.dispose(),this.animationFrameDisposable=null)}acceptScrollDimensions(e){this.to=e.withScrollPosition(this.to),this.e()}tick(){return this.g(Date.now())}g(e){const s=(e-this.startTime)/this.duration;if(s<1){const r=this.c(s),h=this.d(s);return new w(r,h,!1)}return new w(this.to.scrollLeft,this.to.scrollTop,!0)}combine(e,s,r){return p.start(e,s,r)}static start(e,s,r){r=r+10;const h=Date.now()-10;return new p(e,s,h,r)}}t.$dt=p;function y(g){return Math.pow(g,3)}function $(g){return 1-y(1-g)}}),define(we[106],ve([1,0,6,2]),function(re,t,i,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$we=j,t.$xe=F,t.$ye=N,t.$ze=w,t.$Ae=c,t.$Be=p,t.$Ce=y,t.$De=$,t.$Ee=g,t.$Fe=e,t.$Ge=s,t.$He=r,t.$Ie=h,t.$Je=l,t.$Ke=v;function j(k){const A=k;return A?typeof A.read=="function":!1}function F(k){const A=k;return A?[A.on,A.pause,A.resume,A.destroy].every(d=>typeof d=="function"):!1}function N(k){const A=k;return A?F(A.stream)&&Array.isArray(A.buffer)&&typeof A.ended=="boolean":!1}function w(k,A){return new D(k,A)}class D{constructor(A,d){this.e=A,this.f=d,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(A){if(!this.a.destroyed){if(this.a.flowing)this.g(A);else if(this.b.data.push(A),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(d=>this.d.push(d))}}error(A){this.a.destroyed||(this.a.flowing?this.h(A):this.b.error.push(A))}end(A){this.a.destroyed||(typeof A<"u"&&this.write(A),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(A){this.c.data.slice(0).forEach(d=>d(A))}h(A){this.c.error.length===0?(0,i.$Y)(A):this.c.error.slice(0).forEach(d=>d(A))}i(){this.c.end.slice(0).forEach(A=>A())}on(A,d){if(!this.a.destroyed)switch(A){case"data":this.c.data.push(d),this.resume();break;case"end":this.c.end.push(d),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(d),this.a.flowing&&this.k();break}}removeListener(A,d){if(this.a.destroyed)return;let f;switch(A){case"data":f=this.c.data;break;case"end":f=this.c.end;break;case"error":f=this.c.error;break}if(f){const b=f.indexOf(d);b>=0&&f.splice(b,1)}}j(){if(this.b.data.length>0){const A=this.e(this.b.data);this.g(A),this.b.data.length=0;const d=[...this.d];this.d.length=0,d.forEach(f=>f())}}k(){if(this.c.error.length>0){for(const A of this.b.error)this.h(A);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function c(k,A){const d=[];let f;for(;(f=k.read())!==null;)d.push(f);return A(d)}function p(k,A,d){const f=[];let b;for(;(b=k.read())!==null&&f.length<d;)f.push(b);return b===null&&f.length>0?A(f):{read:()=>{if(f.length>0)return f.shift();if(typeof b<"u"){const S=b;return b=void 0,S}return k.read()}}}function y(k,A){return new Promise((d,f)=>{const b=[];$(k,{onData:S=>{A&&b.push(S)},onError:S=>{A?f(S):d(void 0)},onEnd:()=>{d(A?A(b):void 0)}})})}function $(k,A,d){k.on("error",f=>{d?.isCancellationRequested||A.onError(f)}),k.on("end",()=>{d?.isCancellationRequested||A.onEnd()}),k.on("data",f=>{d?.isCancellationRequested||A.onData(f)})}function g(k,A){return new Promise((d,f)=>{const b=new n.$Sc,S=[],U=E=>{if(S.push(E),S.length>A)return b.dispose(),k.pause(),d({stream:k,buffer:S,ended:!1})},_=E=>(b.dispose(),f(E)),B=()=>(b.dispose(),d({stream:k,buffer:S,ended:!0}));b.add((0,n.$Rc)(()=>k.removeListener("error",_))),k.on("error",_),b.add((0,n.$Rc)(()=>k.removeListener("end",B))),k.on("end",B),b.add((0,n.$Rc)(()=>k.removeListener("data",U))),k.on("data",U)})}function e(k,A){const d=w(A);return d.end(k),d}function s(){const k=w(()=>{throw new Error("not supported")});return k.end(),k}function r(k){let A=!1;return{read:()=>A?null:(A=!0,k)}}function h(k,A,d){const f=w(d);return $(k,{onData:b=>f.write(A.data(b)),onError:b=>f.error(A.error?A.error(b):b),onEnd:()=>f.end()}),f}function l(k,A,d){let f=!1;return{read:()=>{const b=A.read();return f?b:(f=!0,b!==null?d([k,b]):k)}}}function v(k,A,d){let f=!1;const b=w(d);return $(A,{onData:S=>f?b.write(S):(f=!0,b.write(d([k,S]))),onError:S=>b.error(S),onEnd:()=>{f||(f=!0,b.write(k)),b.end()}}),b}}),define(we[47],ve([1,0,25,106]),function(re,t,i,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Le=void 0,t.$Me=c,t.$Ne=p,t.$Oe=y,t.$Pe=$,t.$Qe=g,t.$Re=e,t.$Se=s,t.$Te=r,t.$Ue=h,t.$Ve=l,t.$We=v,t.$Xe=k,t.$Ye=A,t.$Ze=d,t.$1e=f,t.$2e=b,t.$3e=S,t.$4e=U,t.$5e=_,t.$6e=I,n=He(n);const j=typeof Buffer<"u",F=new i.$T(()=>new Uint8Array(256));let N,w;class D{static alloc(O){return j?new D(Buffer.allocUnsafe(O)):new D(new Uint8Array(O))}static wrap(O){return j&&!Buffer.isBuffer(O)&&(O=Buffer.from(O.buffer,O.byteOffset,O.byteLength)),new D(O)}static fromString(O,C){return!(C?.dontUseNodeBuffer||!1)&&j?new D(Buffer.from(O)):(N||(N=new TextEncoder),new D(N.encode(O)))}static fromByteArray(O){const C=D.alloc(O.length);for(let x=0,Z=O.length;x<Z;x++)C.buffer[x]=O[x];return C}static concat(O,C){if(typeof C>"u"){C=0;for(let Y=0,q=O.length;Y<q;Y++)C+=O[Y].byteLength}const x=D.alloc(C);let Z=0;for(let Y=0,q=O.length;Y<q;Y++){const ee=O[Y];x.set(ee,Z),Z+=ee.byteLength}return x}constructor(O){this.buffer=O,this.byteLength=this.buffer.byteLength}clone(){const O=D.alloc(this.byteLength);return O.set(this),O}toString(){return j?this.buffer.toString():(w||(w=new TextDecoder),w.decode(this.buffer))}slice(O,C){return new D(this.buffer.subarray(O,C))}set(O,C){if(O instanceof D)this.buffer.set(O.buffer,C);else if(O instanceof Uint8Array)this.buffer.set(O,C);else if(O instanceof ArrayBuffer)this.buffer.set(new Uint8Array(O),C);else if(ArrayBuffer.isView(O))this.buffer.set(new Uint8Array(O.buffer,O.byteOffset,O.byteLength),C);else throw new Error("Unknown argument 'array'")}readUInt32BE(O){return $(this.buffer,O)}writeUInt32BE(O,C){g(this.buffer,O,C)}readUInt32LE(O){return e(this.buffer,O)}writeUInt32LE(O,C){s(this.buffer,O,C)}readUInt8(O){return r(this.buffer,O)}writeUInt8(O,C){h(this.buffer,O,C)}indexOf(O,C=0){return c(this.buffer,O instanceof D?O.buffer:O,C)}}t.$Le=D;function c(z,O,C=0){const x=O.byteLength,Z=z.byteLength;if(x===0)return 0;if(x===1)return z.indexOf(O[0]);if(x>Z-C)return-1;const Y=F.value;Y.fill(O.length);for(let be=0;be<O.length;be++)Y[O[be]]=O.length-be-1;let q=C+O.length-1,ee=q,ce=-1;for(;q<Z;)if(z[q]===O[ee]){if(ee===0){ce=q;break}q--,ee--}else q+=Math.max(O.length-ee,Y[z[q]]),ee=O.length-1;return ce}function p(z,O){return z[O+0]<<0>>>0|z[O+1]<<8>>>0}function y(z,O,C){z[C+0]=O&255,O=O>>>8,z[C+1]=O&255}function $(z,O){return z[O]*2**24+z[O+1]*2**16+z[O+2]*2**8+z[O+3]}function g(z,O,C){z[C+3]=O,O=O>>>8,z[C+2]=O,O=O>>>8,z[C+1]=O,O=O>>>8,z[C]=O}function e(z,O){return z[O+0]<<0>>>0|z[O+1]<<8>>>0|z[O+2]<<16>>>0|z[O+3]<<24>>>0}function s(z,O,C){z[C+0]=O&255,O=O>>>8,z[C+1]=O&255,O=O>>>8,z[C+2]=O&255,O=O>>>8,z[C+3]=O&255}function r(z,O){return z[O]}function h(z,O,C){z[C]=O}function l(z){return n.$Ae(z,O=>D.concat(O))}function v(z){return n.$He(z)}function k(z){return n.$Ce(z,O=>D.concat(O))}async function A(z){return z.ended?D.concat(z.buffer):D.concat([...z.buffer,await k(z.stream)])}function d(z){return n.$Fe(z,O=>D.concat(O))}function f(z){return n.$Ie(z,{data:O=>typeof O=="string"?D.fromString(O):D.wrap(O)},O=>D.concat(O))}function b(z){return n.$ze(O=>D.concat(O),z)}function S(z,O){return n.$Je(z,O,C=>D.concat(C))}function U(z,O){return n.$Ke(z,O,C=>D.concat(C))}function _(z){let O=0,C=0,x=0;const Z=new Uint8Array(Math.floor(z.length/4*3)),Y=ee=>{switch(C){case 3:Z[x++]=O|ee,C=0;break;case 2:Z[x++]=O|ee>>>2,O=ee<<6,C=3;break;case 1:Z[x++]=O|ee>>>4,O=ee<<4,C=2;break;default:O=ee<<2,C=1}};for(let ee=0;ee<z.length;ee++){const ce=z.charCodeAt(ee);if(ce>=65&&ce<=90)Y(ce-65);else if(ce>=97&&ce<=122)Y(ce-97+26);else if(ce>=48&&ce<=57)Y(ce-48+52);else if(ce===43||ce===45)Y(62);else if(ce===47||ce===95)Y(63);else{if(ce===61)break;throw new SyntaxError(`Unexpected base64 character ${z[ee]}`)}}const q=x;for(;C>0;)Y(0);return D.wrap(Z).slice(0,q)}const B="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",E="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function I({buffer:z},O=!0,C=!1){const x=C?E:B;let Z="";const Y=z.byteLength%3;let q=0;for(;q<z.byteLength-Y;q+=3){const ee=z[q+0],ce=z[q+1],be=z[q+2];Z+=x[ee>>>2],Z+=x[(ee<<4|ce>>>4)&63],Z+=x[(ce<<2|be>>>6)&63],Z+=x[be&63]}if(Y===1){const ee=z[q+0];Z+=x[ee>>>2],Z+=x[ee<<4&63],O&&(Z+="==")}else if(Y===2){const ee=z[q+0],ce=z[q+1];Z+=x[ee>>>2],Z+=x[(ee<<4|ce>>>4)&63],Z+=x[ce<<2&63],O&&(Z+="=")}return Z}}),define(we[63],ve([1,0]),function(re,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ee=void 0,t.$ee=Symbol("MicrotaskDelay")}),define(we[10],ve([1,0]),function(re,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$cg=i,t.$dg=n,t.$eg=j,t.$fg=F,t.$gg=N,t.$hg=w,t.$ig=D,t.$jg=c,t.$kg=p,t.$lg=y,t.$mg=$,t.$ng=g,t.$og=e,t.$pg=r,t.$qg=h,t.$rg=l,t.$sg=v,t.$tg=k;function i(A){return typeof A=="string"}function n(A){return Array.isArray(A)&&A.every(d=>i(d))}function j(A){return typeof A=="object"&&A!==null&&!Array.isArray(A)&&!(A instanceof RegExp)&&!(A instanceof Date)}function F(A){const d=Object.getPrototypeOf(Uint8Array);return typeof A=="object"&&A instanceof d}function N(A){return typeof A=="number"&&!isNaN(A)}function w(A){return!!A&&typeof A[Symbol.iterator]=="function"}function D(A){return A===!0||A===!1}function c(A){return typeof A>"u"}function p(A){return!y(A)}function y(A){return c(A)||A===null}function $(A,d){if(!A)throw new Error(d?`Unexpected type, expected '${d}'`:"Unexpected type")}function g(A){if(y(A))throw new Error("Assertion Failed: argument is undefined or null");return A}function e(...A){const d=[];for(let f=0;f<A.length;f++){const b=A[f];if(y(b))throw new Error(`Assertion Failed: argument at index ${f} is undefined or null`);d.push(b)}return d}const s=Object.prototype.hasOwnProperty;function r(A){if(!j(A))return!1;for(const d in A)if(s.call(A,d))return!1;return!0}function h(A){return typeof A=="function"}function l(...A){return A.length>0&&A.every(h)}function v(A,d){const f=Math.min(A.length,d.length);for(let b=0;b<f;b++)k(A[b],d[b])}function k(A,d){if(i(d)){if(typeof A!==d)throw new Error(`argument does not match constraint: typeof ${d}`)}else if(h(d)){try{if(A instanceof d)return}catch{}if(!y(A)&&A.constructor===d||d.length===1&&d.call(void 0,A)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}}),define(we[48],ve([1,0,10]),function(re,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Wj=j,t.$Xj=F;const n=Object.create(null);function j(N,w){if((0,i.$cg)(w)){const D=n[w];if(D===void 0)throw new Error(`${N} references an unknown codicon: ${w}`);w=D}return n[N]=w,{id:N}}function F(){return n}}),define(we[107],ve([1,0,48]),function(re,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Yj=void 0,t.$Yj={add:(0,i.$Wj)("add",6e4),plus:(0,i.$Wj)("plus",6e4),gistNew:(0,i.$Wj)("gist-new",6e4),repoCreate:(0,i.$Wj)("repo-create",6e4),lightbulb:(0,i.$Wj)("lightbulb",60001),lightBulb:(0,i.$Wj)("light-bulb",60001),repo:(0,i.$Wj)("repo",60002),repoDelete:(0,i.$Wj)("repo-delete",60002),gistFork:(0,i.$Wj)("gist-fork",60003),repoForked:(0,i.$Wj)("repo-forked",60003),gitPullRequest:(0,i.$Wj)("git-pull-request",60004),gitPullRequestAbandoned:(0,i.$Wj)("git-pull-request-abandoned",60004),recordKeys:(0,i.$Wj)("record-keys",60005),keyboard:(0,i.$Wj)("keyboard",60005),tag:(0,i.$Wj)("tag",60006),gitPullRequestLabel:(0,i.$Wj)("git-pull-request-label",60006),tagAdd:(0,i.$Wj)("tag-add",60006),tagRemove:(0,i.$Wj)("tag-remove",60006),person:(0,i.$Wj)("person",60007),personFollow:(0,i.$Wj)("person-follow",60007),personOutline:(0,i.$Wj)("person-outline",60007),personFilled:(0,i.$Wj)("person-filled",60007),gitBranch:(0,i.$Wj)("git-branch",60008),gitBranchCreate:(0,i.$Wj)("git-branch-create",60008),gitBranchDelete:(0,i.$Wj)("git-branch-delete",60008),sourceControl:(0,i.$Wj)("source-control",60008),mirror:(0,i.$Wj)("mirror",60009),mirrorPublic:(0,i.$Wj)("mirror-public",60009),star:(0,i.$Wj)("star",60010),starAdd:(0,i.$Wj)("star-add",60010),starDelete:(0,i.$Wj)("star-delete",60010),starEmpty:(0,i.$Wj)("star-empty",60010),comment:(0,i.$Wj)("comment",60011),commentAdd:(0,i.$Wj)("comment-add",60011),alert:(0,i.$Wj)("alert",60012),warning:(0,i.$Wj)("warning",60012),search:(0,i.$Wj)("search",60013),searchSave:(0,i.$Wj)("search-save",60013),logOut:(0,i.$Wj)("log-out",60014),signOut:(0,i.$Wj)("sign-out",60014),logIn:(0,i.$Wj)("log-in",60015),signIn:(0,i.$Wj)("sign-in",60015),eye:(0,i.$Wj)("eye",60016),eyeUnwatch:(0,i.$Wj)("eye-unwatch",60016),eyeWatch:(0,i.$Wj)("eye-watch",60016),circleFilled:(0,i.$Wj)("circle-filled",60017),primitiveDot:(0,i.$Wj)("primitive-dot",60017),closeDirty:(0,i.$Wj)("close-dirty",60017),debugBreakpoint:(0,i.$Wj)("debug-breakpoint",60017),debugBreakpointDisabled:(0,i.$Wj)("debug-breakpoint-disabled",60017),debugHint:(0,i.$Wj)("debug-hint",60017),terminalDecorationSuccess:(0,i.$Wj)("terminal-decoration-success",60017),primitiveSquare:(0,i.$Wj)("primitive-square",60018),edit:(0,i.$Wj)("edit",60019),pencil:(0,i.$Wj)("pencil",60019),info:(0,i.$Wj)("info",60020),issueOpened:(0,i.$Wj)("issue-opened",60020),gistPrivate:(0,i.$Wj)("gist-private",60021),gitForkPrivate:(0,i.$Wj)("git-fork-private",60021),lock:(0,i.$Wj)("lock",60021),mirrorPrivate:(0,i.$Wj)("mirror-private",60021),close:(0,i.$Wj)("close",60022),removeClose:(0,i.$Wj)("remove-close",60022),x:(0,i.$Wj)("x",60022),repoSync:(0,i.$Wj)("repo-sync",60023),sync:(0,i.$Wj)("sync",60023),clone:(0,i.$Wj)("clone",60024),desktopDownload:(0,i.$Wj)("desktop-download",60024),beaker:(0,i.$Wj)("beaker",60025),microscope:(0,i.$Wj)("microscope",60025),vm:(0,i.$Wj)("vm",60026),deviceDesktop:(0,i.$Wj)("device-desktop",60026),file:(0,i.$Wj)("file",60027),fileText:(0,i.$Wj)("file-text",60027),more:(0,i.$Wj)("more",60028),ellipsis:(0,i.$Wj)("ellipsis",60028),kebabHorizontal:(0,i.$Wj)("kebab-horizontal",60028),mailReply:(0,i.$Wj)("mail-reply",60029),reply:(0,i.$Wj)("reply",60029),organization:(0,i.$Wj)("organization",60030),organizationFilled:(0,i.$Wj)("organization-filled",60030),organizationOutline:(0,i.$Wj)("organization-outline",60030),newFile:(0,i.$Wj)("new-file",60031),fileAdd:(0,i.$Wj)("file-add",60031),newFolder:(0,i.$Wj)("new-folder",60032),fileDirectoryCreate:(0,i.$Wj)("file-directory-create",60032),trash:(0,i.$Wj)("trash",60033),trashcan:(0,i.$Wj)("trashcan",60033),history:(0,i.$Wj)("history",60034),clock:(0,i.$Wj)("clock",60034),folder:(0,i.$Wj)("folder",60035),fileDirectory:(0,i.$Wj)("file-directory",60035),symbolFolder:(0,i.$Wj)("symbol-folder",60035),logoGithub:(0,i.$Wj)("logo-github",60036),markGithub:(0,i.$Wj)("mark-github",60036),github:(0,i.$Wj)("github",60036),terminal:(0,i.$Wj)("terminal",60037),console:(0,i.$Wj)("console",60037),repl:(0,i.$Wj)("repl",60037),zap:(0,i.$Wj)("zap",60038),symbolEvent:(0,i.$Wj)("symbol-event",60038),error:(0,i.$Wj)("error",60039),stop:(0,i.$Wj)("stop",60039),variable:(0,i.$Wj)("variable",60040),symbolVariable:(0,i.$Wj)("symbol-variable",60040),array:(0,i.$Wj)("array",60042),symbolArray:(0,i.$Wj)("symbol-array",60042),symbolModule:(0,i.$Wj)("symbol-module",60043),symbolPackage:(0,i.$Wj)("symbol-package",60043),symbolNamespace:(0,i.$Wj)("symbol-namespace",60043),symbolObject:(0,i.$Wj)("symbol-object",60043),symbolMethod:(0,i.$Wj)("symbol-method",60044),symbolFunction:(0,i.$Wj)("symbol-function",60044),symbolConstructor:(0,i.$Wj)("symbol-constructor",60044),symbolBoolean:(0,i.$Wj)("symbol-boolean",60047),symbolNull:(0,i.$Wj)("symbol-null",60047),symbolNumeric:(0,i.$Wj)("symbol-numeric",60048),symbolNumber:(0,i.$Wj)("symbol-number",60048),symbolStructure:(0,i.$Wj)("symbol-structure",60049),symbolStruct:(0,i.$Wj)("symbol-struct",60049),symbolParameter:(0,i.$Wj)("symbol-parameter",60050),symbolTypeParameter:(0,i.$Wj)("symbol-type-parameter",60050),symbolKey:(0,i.$Wj)("symbol-key",60051),symbolText:(0,i.$Wj)("symbol-text",60051),symbolReference:(0,i.$Wj)("symbol-reference",60052),goToFile:(0,i.$Wj)("go-to-file",60052),symbolEnum:(0,i.$Wj)("symbol-enum",60053),symbolValue:(0,i.$Wj)("symbol-value",60053),symbolRuler:(0,i.$Wj)("symbol-ruler",60054),symbolUnit:(0,i.$Wj)("symbol-unit",60054),activateBreakpoints:(0,i.$Wj)("activate-breakpoints",60055),archive:(0,i.$Wj)("archive",60056),arrowBoth:(0,i.$Wj)("arrow-both",60057),arrowDown:(0,i.$Wj)("arrow-down",60058),arrowLeft:(0,i.$Wj)("arrow-left",60059),arrowRight:(0,i.$Wj)("arrow-right",60060),arrowSmallDown:(0,i.$Wj)("arrow-small-down",60061),arrowSmallLeft:(0,i.$Wj)("arrow-small-left",60062),arrowSmallRight:(0,i.$Wj)("arrow-small-right",60063),arrowSmallUp:(0,i.$Wj)("arrow-small-up",60064),arrowUp:(0,i.$Wj)("arrow-up",60065),bell:(0,i.$Wj)("bell",60066),bold:(0,i.$Wj)("bold",60067),book:(0,i.$Wj)("book",60068),bookmark:(0,i.$Wj)("bookmark",60069),debugBreakpointConditionalUnverified:(0,i.$Wj)("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:(0,i.$Wj)("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:(0,i.$Wj)("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:(0,i.$Wj)("debug-breakpoint-data-unverified",60072),debugBreakpointData:(0,i.$Wj)("debug-breakpoint-data",60073),debugBreakpointDataDisabled:(0,i.$Wj)("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:(0,i.$Wj)("debug-breakpoint-log-unverified",60074),debugBreakpointLog:(0,i.$Wj)("debug-breakpoint-log",60075),debugBreakpointLogDisabled:(0,i.$Wj)("debug-breakpoint-log-disabled",60075),briefcase:(0,i.$Wj)("briefcase",60076),broadcast:(0,i.$Wj)("broadcast",60077),browser:(0,i.$Wj)("browser",60078),bug:(0,i.$Wj)("bug",60079),calendar:(0,i.$Wj)("calendar",60080),caseSensitive:(0,i.$Wj)("case-sensitive",60081),check:(0,i.$Wj)("check",60082),checklist:(0,i.$Wj)("checklist",60083),chevronDown:(0,i.$Wj)("chevron-down",60084),chevronLeft:(0,i.$Wj)("chevron-left",60085),chevronRight:(0,i.$Wj)("chevron-right",60086),chevronUp:(0,i.$Wj)("chevron-up",60087),chromeClose:(0,i.$Wj)("chrome-close",60088),chromeMaximize:(0,i.$Wj)("chrome-maximize",60089),chromeMinimize:(0,i.$Wj)("chrome-minimize",60090),chromeRestore:(0,i.$Wj)("chrome-restore",60091),circleOutline:(0,i.$Wj)("circle-outline",60092),circle:(0,i.$Wj)("circle",60092),debugBreakpointUnverified:(0,i.$Wj)("debug-breakpoint-unverified",60092),terminalDecorationIncomplete:(0,i.$Wj)("terminal-decoration-incomplete",60092),circleSlash:(0,i.$Wj)("circle-slash",60093),circuitBoard:(0,i.$Wj)("circuit-board",60094),clearAll:(0,i.$Wj)("clear-all",60095),clippy:(0,i.$Wj)("clippy",60096),closeAll:(0,i.$Wj)("close-all",60097),cloudDownload:(0,i.$Wj)("cloud-download",60098),cloudUpload:(0,i.$Wj)("cloud-upload",60099),code:(0,i.$Wj)("code",60100),collapseAll:(0,i.$Wj)("collapse-all",60101),colorMode:(0,i.$Wj)("color-mode",60102),commentDiscussion:(0,i.$Wj)("comment-discussion",60103),creditCard:(0,i.$Wj)("credit-card",60105),dash:(0,i.$Wj)("dash",60108),dashboard:(0,i.$Wj)("dashboard",60109),database:(0,i.$Wj)("database",60110),debugContinue:(0,i.$Wj)("debug-continue",60111),debugDisconnect:(0,i.$Wj)("debug-disconnect",60112),debugPause:(0,i.$Wj)("debug-pause",60113),debugRestart:(0,i.$Wj)("debug-restart",60114),debugStart:(0,i.$Wj)("debug-start",60115),debugStepInto:(0,i.$Wj)("debug-step-into",60116),debugStepOut:(0,i.$Wj)("debug-step-out",60117),debugStepOver:(0,i.$Wj)("debug-step-over",60118),debugStop:(0,i.$Wj)("debug-stop",60119),debug:(0,i.$Wj)("debug",60120),deviceCameraVideo:(0,i.$Wj)("device-camera-video",60121),deviceCamera:(0,i.$Wj)("device-camera",60122),deviceMobile:(0,i.$Wj)("device-mobile",60123),diffAdded:(0,i.$Wj)("diff-added",60124),diffIgnored:(0,i.$Wj)("diff-ignored",60125),diffModified:(0,i.$Wj)("diff-modified",60126),diffRemoved:(0,i.$Wj)("diff-removed",60127),diffRenamed:(0,i.$Wj)("diff-renamed",60128),diff:(0,i.$Wj)("diff",60129),diffSidebyside:(0,i.$Wj)("diff-sidebyside",60129),discard:(0,i.$Wj)("discard",60130),editorLayout:(0,i.$Wj)("editor-layout",60131),emptyWindow:(0,i.$Wj)("empty-window",60132),exclude:(0,i.$Wj)("exclude",60133),extensions:(0,i.$Wj)("extensions",60134),eyeClosed:(0,i.$Wj)("eye-closed",60135),fileBinary:(0,i.$Wj)("file-binary",60136),fileCode:(0,i.$Wj)("file-code",60137),fileMedia:(0,i.$Wj)("file-media",60138),filePdf:(0,i.$Wj)("file-pdf",60139),fileSubmodule:(0,i.$Wj)("file-submodule",60140),fileSymlinkDirectory:(0,i.$Wj)("file-symlink-directory",60141),fileSymlinkFile:(0,i.$Wj)("file-symlink-file",60142),fileZip:(0,i.$Wj)("file-zip",60143),files:(0,i.$Wj)("files",60144),filter:(0,i.$Wj)("filter",60145),flame:(0,i.$Wj)("flame",60146),foldDown:(0,i.$Wj)("fold-down",60147),foldUp:(0,i.$Wj)("fold-up",60148),fold:(0,i.$Wj)("fold",60149),folderActive:(0,i.$Wj)("folder-active",60150),folderOpened:(0,i.$Wj)("folder-opened",60151),gear:(0,i.$Wj)("gear",60152),gift:(0,i.$Wj)("gift",60153),gistSecret:(0,i.$Wj)("gist-secret",60154),gist:(0,i.$Wj)("gist",60155),gitCommit:(0,i.$Wj)("git-commit",60156),gitCompare:(0,i.$Wj)("git-compare",60157),compareChanges:(0,i.$Wj)("compare-changes",60157),gitMerge:(0,i.$Wj)("git-merge",60158),githubAction:(0,i.$Wj)("github-action",60159),githubAlt:(0,i.$Wj)("github-alt",60160),globe:(0,i.$Wj)("globe",60161),grabber:(0,i.$Wj)("grabber",60162),graph:(0,i.$Wj)("graph",60163),gripper:(0,i.$Wj)("gripper",60164),heart:(0,i.$Wj)("heart",60165),home:(0,i.$Wj)("home",60166),horizontalRule:(0,i.$Wj)("horizontal-rule",60167),hubot:(0,i.$Wj)("hubot",60168),inbox:(0,i.$Wj)("inbox",60169),issueReopened:(0,i.$Wj)("issue-reopened",60171),issues:(0,i.$Wj)("issues",60172),italic:(0,i.$Wj)("italic",60173),jersey:(0,i.$Wj)("jersey",60174),json:(0,i.$Wj)("json",60175),kebabVertical:(0,i.$Wj)("kebab-vertical",60176),key:(0,i.$Wj)("key",60177),law:(0,i.$Wj)("law",60178),lightbulbAutofix:(0,i.$Wj)("lightbulb-autofix",60179),linkExternal:(0,i.$Wj)("link-external",60180),link:(0,i.$Wj)("link",60181),listOrdered:(0,i.$Wj)("list-ordered",60182),listUnordered:(0,i.$Wj)("list-unordered",60183),liveShare:(0,i.$Wj)("live-share",60184),loading:(0,i.$Wj)("loading",60185),location:(0,i.$Wj)("location",60186),mailRead:(0,i.$Wj)("mail-read",60187),mail:(0,i.$Wj)("mail",60188),markdown:(0,i.$Wj)("markdown",60189),megaphone:(0,i.$Wj)("megaphone",60190),mention:(0,i.$Wj)("mention",60191),milestone:(0,i.$Wj)("milestone",60192),gitPullRequestMilestone:(0,i.$Wj)("git-pull-request-milestone",60192),mortarBoard:(0,i.$Wj)("mortar-board",60193),move:(0,i.$Wj)("move",60194),multipleWindows:(0,i.$Wj)("multiple-windows",60195),mute:(0,i.$Wj)("mute",60196),noNewline:(0,i.$Wj)("no-newline",60197),note:(0,i.$Wj)("note",60198),octoface:(0,i.$Wj)("octoface",60199),openPreview:(0,i.$Wj)("open-preview",60200),package:(0,i.$Wj)("package",60201),paintcan:(0,i.$Wj)("paintcan",60202),pin:(0,i.$Wj)("pin",60203),play:(0,i.$Wj)("play",60204),run:(0,i.$Wj)("run",60204),plug:(0,i.$Wj)("plug",60205),preserveCase:(0,i.$Wj)("preserve-case",60206),preview:(0,i.$Wj)("preview",60207),project:(0,i.$Wj)("project",60208),pulse:(0,i.$Wj)("pulse",60209),question:(0,i.$Wj)("question",60210),quote:(0,i.$Wj)("quote",60211),radioTower:(0,i.$Wj)("radio-tower",60212),reactions:(0,i.$Wj)("reactions",60213),references:(0,i.$Wj)("references",60214),refresh:(0,i.$Wj)("refresh",60215),regex:(0,i.$Wj)("regex",60216),remoteExplorer:(0,i.$Wj)("remote-explorer",60217),remote:(0,i.$Wj)("remote",60218),remove:(0,i.$Wj)("remove",60219),replaceAll:(0,i.$Wj)("replace-all",60220),replace:(0,i.$Wj)("replace",60221),repoClone:(0,i.$Wj)("repo-clone",60222),repoForcePush:(0,i.$Wj)("repo-force-push",60223),repoPull:(0,i.$Wj)("repo-pull",60224),repoPush:(0,i.$Wj)("repo-push",60225),report:(0,i.$Wj)("report",60226),requestChanges:(0,i.$Wj)("request-changes",60227),rocket:(0,i.$Wj)("rocket",60228),rootFolderOpened:(0,i.$Wj)("root-folder-opened",60229),rootFolder:(0,i.$Wj)("root-folder",60230),rss:(0,i.$Wj)("rss",60231),ruby:(0,i.$Wj)("ruby",60232),saveAll:(0,i.$Wj)("save-all",60233),saveAs:(0,i.$Wj)("save-as",60234),save:(0,i.$Wj)("save",60235),screenFull:(0,i.$Wj)("screen-full",60236),screenNormal:(0,i.$Wj)("screen-normal",60237),searchStop:(0,i.$Wj)("search-stop",60238),server:(0,i.$Wj)("server",60240),settingsGear:(0,i.$Wj)("settings-gear",60241),settings:(0,i.$Wj)("settings",60242),shield:(0,i.$Wj)("shield",60243),smiley:(0,i.$Wj)("smiley",60244),sortPrecedence:(0,i.$Wj)("sort-precedence",60245),splitHorizontal:(0,i.$Wj)("split-horizontal",60246),splitVertical:(0,i.$Wj)("split-vertical",60247),squirrel:(0,i.$Wj)("squirrel",60248),starFull:(0,i.$Wj)("star-full",60249),starHalf:(0,i.$Wj)("star-half",60250),symbolClass:(0,i.$Wj)("symbol-class",60251),symbolColor:(0,i.$Wj)("symbol-color",60252),symbolConstant:(0,i.$Wj)("symbol-constant",60253),symbolEnumMember:(0,i.$Wj)("symbol-enum-member",60254),symbolField:(0,i.$Wj)("symbol-field",60255),symbolFile:(0,i.$Wj)("symbol-file",60256),symbolInterface:(0,i.$Wj)("symbol-interface",60257),symbolKeyword:(0,i.$Wj)("symbol-keyword",60258),symbolMisc:(0,i.$Wj)("symbol-misc",60259),symbolOperator:(0,i.$Wj)("symbol-operator",60260),symbolProperty:(0,i.$Wj)("symbol-property",60261),wrench:(0,i.$Wj)("wrench",60261),wrenchSubaction:(0,i.$Wj)("wrench-subaction",60261),symbolSnippet:(0,i.$Wj)("symbol-snippet",60262),tasklist:(0,i.$Wj)("tasklist",60263),telescope:(0,i.$Wj)("telescope",60264),textSize:(0,i.$Wj)("text-size",60265),threeBars:(0,i.$Wj)("three-bars",60266),thumbsdown:(0,i.$Wj)("thumbsdown",60267),thumbsup:(0,i.$Wj)("thumbsup",60268),tools:(0,i.$Wj)("tools",60269),triangleDown:(0,i.$Wj)("triangle-down",60270),triangleLeft:(0,i.$Wj)("triangle-left",60271),triangleRight:(0,i.$Wj)("triangle-right",60272),triangleUp:(0,i.$Wj)("triangle-up",60273),twitter:(0,i.$Wj)("twitter",60274),unfold:(0,i.$Wj)("unfold",60275),unlock:(0,i.$Wj)("unlock",60276),unmute:(0,i.$Wj)("unmute",60277),unverified:(0,i.$Wj)("unverified",60278),verified:(0,i.$Wj)("verified",60279),versions:(0,i.$Wj)("versions",60280),vmActive:(0,i.$Wj)("vm-active",60281),vmOutline:(0,i.$Wj)("vm-outline",60282),vmRunning:(0,i.$Wj)("vm-running",60283),watch:(0,i.$Wj)("watch",60284),whitespace:(0,i.$Wj)("whitespace",60285),wholeWord:(0,i.$Wj)("whole-word",60286),window:(0,i.$Wj)("window",60287),wordWrap:(0,i.$Wj)("word-wrap",60288),zoomIn:(0,i.$Wj)("zoom-in",60289),zoomOut:(0,i.$Wj)("zoom-out",60290),listFilter:(0,i.$Wj)("list-filter",60291),listFlat:(0,i.$Wj)("list-flat",60292),listSelection:(0,i.$Wj)("list-selection",60293),selection:(0,i.$Wj)("selection",60293),listTree:(0,i.$Wj)("list-tree",60294),debugBreakpointFunctionUnverified:(0,i.$Wj)("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:(0,i.$Wj)("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:(0,i.$Wj)("debug-breakpoint-function-disabled",60296),debugStackframeActive:(0,i.$Wj)("debug-stackframe-active",60297),circleSmallFilled:(0,i.$Wj)("circle-small-filled",60298),debugStackframeDot:(0,i.$Wj)("debug-stackframe-dot",60298),terminalDecorationMark:(0,i.$Wj)("terminal-decoration-mark",60298),debugStackframe:(0,i.$Wj)("debug-stackframe",60299),debugStackframeFocused:(0,i.$Wj)("debug-stackframe-focused",60299),debugBreakpointUnsupported:(0,i.$Wj)("debug-breakpoint-unsupported",60300),symbolString:(0,i.$Wj)("symbol-string",60301),debugReverseContinue:(0,i.$Wj)("debug-reverse-continue",60302),debugStepBack:(0,i.$Wj)("debug-step-back",60303),debugRestartFrame:(0,i.$Wj)("debug-restart-frame",60304),debugAlt:(0,i.$Wj)("debug-alt",60305),callIncoming:(0,i.$Wj)("call-incoming",60306),callOutgoing:(0,i.$Wj)("call-outgoing",60307),menu:(0,i.$Wj)("menu",60308),expandAll:(0,i.$Wj)("expand-all",60309),feedback:(0,i.$Wj)("feedback",60310),gitPullRequestReviewer:(0,i.$Wj)("git-pull-request-reviewer",60310),groupByRefType:(0,i.$Wj)("group-by-ref-type",60311),ungroupByRefType:(0,i.$Wj)("ungroup-by-ref-type",60312),account:(0,i.$Wj)("account",60313),gitPullRequestAssignee:(0,i.$Wj)("git-pull-request-assignee",60313),bellDot:(0,i.$Wj)("bell-dot",60314),debugConsole:(0,i.$Wj)("debug-console",60315),library:(0,i.$Wj)("library",60316),output:(0,i.$Wj)("output",60317),runAll:(0,i.$Wj)("run-all",60318),syncIgnored:(0,i.$Wj)("sync-ignored",60319),pinned:(0,i.$Wj)("pinned",60320),githubInverted:(0,i.$Wj)("github-inverted",60321),serverProcess:(0,i.$Wj)("server-process",60322),serverEnvironment:(0,i.$Wj)("server-environment",60323),pass:(0,i.$Wj)("pass",60324),issueClosed:(0,i.$Wj)("issue-closed",60324),stopCircle:(0,i.$Wj)("stop-circle",60325),playCircle:(0,i.$Wj)("play-circle",60326),record:(0,i.$Wj)("record",60327),debugAltSmall:(0,i.$Wj)("debug-alt-small",60328),vmConnect:(0,i.$Wj)("vm-connect",60329),cloud:(0,i.$Wj)("cloud",60330),merge:(0,i.$Wj)("merge",60331),export:(0,i.$Wj)("export",60332),graphLeft:(0,i.$Wj)("graph-left",60333),magnet:(0,i.$Wj)("magnet",60334),notebook:(0,i.$Wj)("notebook",60335),redo:(0,i.$Wj)("redo",60336),checkAll:(0,i.$Wj)("check-all",60337),pinnedDirty:(0,i.$Wj)("pinned-dirty",60338),passFilled:(0,i.$Wj)("pass-filled",60339),circleLargeFilled:(0,i.$Wj)("circle-large-filled",60340),circleLarge:(0,i.$Wj)("circle-large",60341),circleLargeOutline:(0,i.$Wj)("circle-large-outline",60341),combine:(0,i.$Wj)("combine",60342),gather:(0,i.$Wj)("gather",60342),table:(0,i.$Wj)("table",60343),variableGroup:(0,i.$Wj)("variable-group",60344),typeHierarchy:(0,i.$Wj)("type-hierarchy",60345),typeHierarchySub:(0,i.$Wj)("type-hierarchy-sub",60346),typeHierarchySuper:(0,i.$Wj)("type-hierarchy-super",60347),gitPullRequestCreate:(0,i.$Wj)("git-pull-request-create",60348),runAbove:(0,i.$Wj)("run-above",60349),runBelow:(0,i.$Wj)("run-below",60350),notebookTemplate:(0,i.$Wj)("notebook-template",60351),debugRerun:(0,i.$Wj)("debug-rerun",60352),workspaceTrusted:(0,i.$Wj)("workspace-trusted",60353),workspaceUntrusted:(0,i.$Wj)("workspace-untrusted",60354),workspaceUnknown:(0,i.$Wj)("workspace-unknown",60355),terminalCmd:(0,i.$Wj)("terminal-cmd",60356),terminalDebian:(0,i.$Wj)("terminal-debian",60357),terminalLinux:(0,i.$Wj)("terminal-linux",60358),terminalPowershell:(0,i.$Wj)("terminal-powershell",60359),terminalTmux:(0,i.$Wj)("terminal-tmux",60360),terminalUbuntu:(0,i.$Wj)("terminal-ubuntu",60361),terminalBash:(0,i.$Wj)("terminal-bash",60362),arrowSwap:(0,i.$Wj)("arrow-swap",60363),copy:(0,i.$Wj)("copy",60364),personAdd:(0,i.$Wj)("person-add",60365),filterFilled:(0,i.$Wj)("filter-filled",60366),wand:(0,i.$Wj)("wand",60367),debugLineByLine:(0,i.$Wj)("debug-line-by-line",60368),inspect:(0,i.$Wj)("inspect",60369),layers:(0,i.$Wj)("layers",60370),layersDot:(0,i.$Wj)("layers-dot",60371),layersActive:(0,i.$Wj)("layers-active",60372),compass:(0,i.$Wj)("compass",60373),compassDot:(0,i.$Wj)("compass-dot",60374),compassActive:(0,i.$Wj)("compass-active",60375),azure:(0,i.$Wj)("azure",60376),issueDraft:(0,i.$Wj)("issue-draft",60377),gitPullRequestClosed:(0,i.$Wj)("git-pull-request-closed",60378),gitPullRequestDraft:(0,i.$Wj)("git-pull-request-draft",60379),debugAll:(0,i.$Wj)("debug-all",60380),debugCoverage:(0,i.$Wj)("debug-coverage",60381),runErrors:(0,i.$Wj)("run-errors",60382),folderLibrary:(0,i.$Wj)("folder-library",60383),debugContinueSmall:(0,i.$Wj)("debug-continue-small",60384),beakerStop:(0,i.$Wj)("beaker-stop",60385),graphLine:(0,i.$Wj)("graph-line",60386),graphScatter:(0,i.$Wj)("graph-scatter",60387),pieChart:(0,i.$Wj)("pie-chart",60388),bracket:(0,i.$Wj)("bracket",60175),bracketDot:(0,i.$Wj)("bracket-dot",60389),bracketError:(0,i.$Wj)("bracket-error",60390),lockSmall:(0,i.$Wj)("lock-small",60391),azureDevops:(0,i.$Wj)("azure-devops",60392),verifiedFilled:(0,i.$Wj)("verified-filled",60393),newline:(0,i.$Wj)("newline",60394),layout:(0,i.$Wj)("layout",60395),layoutActivitybarLeft:(0,i.$Wj)("layout-activitybar-left",60396),layoutActivitybarRight:(0,i.$Wj)("layout-activitybar-right",60397),layoutPanelLeft:(0,i.$Wj)("layout-panel-left",60398),layoutPanelCenter:(0,i.$Wj)("layout-panel-center",60399),layoutPanelJustify:(0,i.$Wj)("layout-panel-justify",60400),layoutPanelRight:(0,i.$Wj)("layout-panel-right",60401),layoutPanel:(0,i.$Wj)("layout-panel",60402),layoutSidebarLeft:(0,i.$Wj)("layout-sidebar-left",60403),layoutSidebarRight:(0,i.$Wj)("layout-sidebar-right",60404),layoutStatusbar:(0,i.$Wj)("layout-statusbar",60405),layoutMenubar:(0,i.$Wj)("layout-menubar",60406),layoutCentered:(0,i.$Wj)("layout-centered",60407),target:(0,i.$Wj)("target",60408),indent:(0,i.$Wj)("indent",60409),recordSmall:(0,i.$Wj)("record-small",60410),errorSmall:(0,i.$Wj)("error-small",60411),terminalDecorationError:(0,i.$Wj)("terminal-decoration-error",60411),arrowCircleDown:(0,i.$Wj)("arrow-circle-down",60412),arrowCircleLeft:(0,i.$Wj)("arrow-circle-left",60413),arrowCircleRight:(0,i.$Wj)("arrow-circle-right",60414),arrowCircleUp:(0,i.$Wj)("arrow-circle-up",60415),layoutSidebarRightOff:(0,i.$Wj)("layout-sidebar-right-off",60416),layoutPanelOff:(0,i.$Wj)("layout-panel-off",60417),layoutSidebarLeftOff:(0,i.$Wj)("layout-sidebar-left-off",60418),blank:(0,i.$Wj)("blank",60419),heartFilled:(0,i.$Wj)("heart-filled",60420),map:(0,i.$Wj)("map",60421),mapHorizontal:(0,i.$Wj)("map-horizontal",60421),foldHorizontal:(0,i.$Wj)("fold-horizontal",60421),mapFilled:(0,i.$Wj)("map-filled",60422),mapHorizontalFilled:(0,i.$Wj)("map-horizontal-filled",60422),foldHorizontalFilled:(0,i.$Wj)("fold-horizontal-filled",60422),circleSmall:(0,i.$Wj)("circle-small",60423),bellSlash:(0,i.$Wj)("bell-slash",60424),bellSlashDot:(0,i.$Wj)("bell-slash-dot",60425),commentUnresolved:(0,i.$Wj)("comment-unresolved",60426),gitPullRequestGoToChanges:(0,i.$Wj)("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:(0,i.$Wj)("git-pull-request-new-changes",60428),searchFuzzy:(0,i.$Wj)("search-fuzzy",60429),commentDraft:(0,i.$Wj)("comment-draft",60430),send:(0,i.$Wj)("send",60431),sparkle:(0,i.$Wj)("sparkle",60432),insert:(0,i.$Wj)("insert",60433),mic:(0,i.$Wj)("mic",60434),thumbsdownFilled:(0,i.$Wj)("thumbsdown-filled",60435),thumbsupFilled:(0,i.$Wj)("thumbsup-filled",60436),coffee:(0,i.$Wj)("coffee",60437),snake:(0,i.$Wj)("snake",60438),game:(0,i.$Wj)("game",60439),vr:(0,i.$Wj)("vr",60440),chip:(0,i.$Wj)("chip",60441),piano:(0,i.$Wj)("piano",60442),music:(0,i.$Wj)("music",60443),micFilled:(0,i.$Wj)("mic-filled",60444),repoFetch:(0,i.$Wj)("repo-fetch",60445),copilot:(0,i.$Wj)("copilot",60446),lightbulbSparkle:(0,i.$Wj)("lightbulb-sparkle",60447),robot:(0,i.$Wj)("robot",60448),sparkleFilled:(0,i.$Wj)("sparkle-filled",60449),diffSingle:(0,i.$Wj)("diff-single",60450),diffMultiple:(0,i.$Wj)("diff-multiple",60451),surroundWith:(0,i.$Wj)("surround-with",60452),share:(0,i.$Wj)("share",60453),gitStash:(0,i.$Wj)("git-stash",60454),gitStashApply:(0,i.$Wj)("git-stash-apply",60455),gitStashPop:(0,i.$Wj)("git-stash-pop",60456),vscode:(0,i.$Wj)("vscode",60457),vscodeInsiders:(0,i.$Wj)("vscode-insiders",60458),codeOss:(0,i.$Wj)("code-oss",60459),runCoverage:(0,i.$Wj)("run-coverage",60460),runAllCoverage:(0,i.$Wj)("run-all-coverage",60461),coverage:(0,i.$Wj)("coverage",60462),githubProject:(0,i.$Wj)("github-project",60463),mapVertical:(0,i.$Wj)("map-vertical",60464),foldVertical:(0,i.$Wj)("fold-vertical",60464),mapVerticalFilled:(0,i.$Wj)("map-vertical-filled",60465),foldVerticalFilled:(0,i.$Wj)("fold-vertical-filled",60465),goToSearch:(0,i.$Wj)("go-to-search",60466),percentage:(0,i.$Wj)("percentage",60467),sortPercentage:(0,i.$Wj)("sort-percentage",60467),attach:(0,i.$Wj)("attach",60468)}}),define(we[21],ve([1,0,48,107]),function(re,t,i,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$2j=t.$1j=void 0,t.$Zj=j;function j(){return Object.values(t.$2j)}t.$1j={dialogError:(0,i.$Wj)("dialog-error","error"),dialogWarning:(0,i.$Wj)("dialog-warning","warning"),dialogInfo:(0,i.$Wj)("dialog-info","info"),dialogClose:(0,i.$Wj)("dialog-close","close"),treeItemExpanded:(0,i.$Wj)("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:(0,i.$Wj)("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:(0,i.$Wj)("tree-filter-on-type-off","list-selection"),treeFilterClear:(0,i.$Wj)("tree-filter-clear","close"),treeItemLoading:(0,i.$Wj)("tree-item-loading","loading"),menuSelection:(0,i.$Wj)("menu-selection","check"),menuSubmenu:(0,i.$Wj)("menu-submenu","chevron-right"),menuBarMore:(0,i.$Wj)("menubar-more","more"),scrollbarButtonLeft:(0,i.$Wj)("scrollbar-button-left","triangle-left"),scrollbarButtonRight:(0,i.$Wj)("scrollbar-button-right","triangle-right"),scrollbarButtonUp:(0,i.$Wj)("scrollbar-button-up","triangle-up"),scrollbarButtonDown:(0,i.$Wj)("scrollbar-button-down","triangle-down"),toolBarMore:(0,i.$Wj)("toolbar-more","more"),quickInputBack:(0,i.$Wj)("quick-input-back","arrow-left"),dropDownButton:(0,i.$Wj)("drop-down-button",60084),symbolCustomColor:(0,i.$Wj)("symbol-customcolor",60252),exportIcon:(0,i.$Wj)("export",60332),workspaceUnspecified:(0,i.$Wj)("workspace-unspecified",60355),newLine:(0,i.$Wj)("newline",60394),thumbsDownFilled:(0,i.$Wj)("thumbsdown-filled",60435),thumbsUpFilled:(0,i.$Wj)("thumbsup-filled",60436),gitFetch:(0,i.$Wj)("git-fetch",60445),lightbulbSparkleAutofix:(0,i.$Wj)("lightbulb-sparkle-autofix",60447),debugBreakpointPending:(0,i.$Wj)("debug-breakpoint-pending",60377)},t.$2j={...n.$Yj,...t.$1j}}),define(we[64],ve([1,0,10]),function(re,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$bo=n,t.$co=j,t.$do=N,t.$eo=D,t.$fo=c,t.$go=p,t.$ho=y,t.$io=$,t.$jo=g,t.$ko=e,t.$lo=s,t.$mo=r,t.$no=h;function n(l){if(!l||typeof l!="object"||l instanceof RegExp)return l;const v=Array.isArray(l)?[]:{};return Object.entries(l).forEach(([k,A])=>{v[k]=A&&typeof A=="object"?n(A):A}),v}function j(l){if(!l||typeof l!="object")return l;const v=[l];for(;v.length>0;){const k=v.shift();Object.freeze(k);for(const A in k)if(F.call(k,A)){const d=k[A];typeof d=="object"&&!Object.isFrozen(d)&&!(0,i.$fg)(d)&&v.push(d)}}return l}const F=Object.prototype.hasOwnProperty;function N(l,v){return w(l,v,new Set)}function w(l,v,k){if((0,i.$lg)(l))return l;const A=v(l);if(typeof A<"u")return A;if(Array.isArray(l)){const d=[];for(const f of l)d.push(w(f,v,k));return d}if((0,i.$eg)(l)){if(k.has(l))throw new Error("Cannot clone recursive data-structure");k.add(l);const d={};for(const f in l)F.call(l,f)&&(d[f]=w(l[f],v,k));return k.delete(l),d}return l}function D(l,v,k=!0){return(0,i.$eg)(l)?((0,i.$eg)(v)&&Object.keys(v).forEach(A=>{A in l?k&&((0,i.$eg)(l[A])&&(0,i.$eg)(v[A])?D(l[A],v[A],k):l[A]=v[A]):l[A]=v[A]}),l):v}function c(l,v){if(l===v)return!0;if(l==null||v===null||v===void 0||typeof l!=typeof v||typeof l!="object"||Array.isArray(l)!==Array.isArray(v))return!1;let k,A;if(Array.isArray(l)){if(l.length!==v.length)return!1;for(k=0;k<l.length;k++)if(!c(l[k],v[k]))return!1}else{const d=[];for(A in l)d.push(A);d.sort();const f=[];for(A in v)f.push(A);if(f.sort(),!c(d,f))return!1;for(k=0;k<d.length;k++)if(!c(l[d[k]],v[d[k]]))return!1}return!0}function p(l){const v=new Set;return JSON.stringify(l,(k,A)=>{if((0,i.$eg)(A)||Array.isArray(A)){if(v.has(A))return"[Circular]";v.add(A)}return typeof A=="bigint"?`[BigInt ${A.toString()}]`:A})}function y(l,v){const k=Object.create(null);return!l||!v||Object.keys(v).forEach(d=>{const f=l[d],b=v[d];c(f,b)||(k[d]=b)}),k}function $(l,v){const k=v.toLowerCase(),A=Object.keys(l).find(d=>d.toLowerCase()===k);return A?l[A]:l[v]}function g(l,v){const k=Object.create(null);for(const[A,d]of Object.entries(l))v(A,d)&&(k[A]=d);return k}function e(l){let v=[];for(;Object.prototype!==l;)v=v.concat(Object.getOwnPropertyNames(l)),l=Object.getPrototypeOf(l);return v}function s(l){const v=[];for(const k of e(l))typeof l[k]=="function"&&v.push(k);return v}function r(l,v){const k=d=>function(){const f=Array.prototype.slice.call(arguments,0);return v(d,f)},A={};for(const d of l)A[d]=k(d);return A}function h(l,v){const k={};for(const[A,d]of Object.entries(l))k[A]=v(d,A);return k}}),define(we[22],ve([1,0,21]),function(re,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ThemeIcon=t.ThemeColor=void 0,t.$3j=j;var n;(function(N){function w(D){return D&&typeof D=="object"&&typeof D.id=="string"}N.isThemeColor=w})(n||(t.ThemeColor=n={}));function j(N){return{id:N}}var F;(function(N){N.iconNameSegment="[A-Za-z0-9]+",N.iconNameExpression="[A-Za-z0-9-]+",N.iconModifierExpression="~[A-Za-z]+",N.iconNameCharacter="[A-Za-z0-9~-]";const w=new RegExp(`^(${N.iconNameExpression})(${N.iconModifierExpression})?$`);function D(l){const v=w.exec(l.id);if(!v)return D(i.$2j.error);const[,k,A]=v,d=["codicon","codicon-"+k];return A&&d.push("codicon-modifier-"+A.substring(1)),d}N.asClassNameArray=D;function c(l){return D(l).join(" ")}N.asClassName=c;function p(l){return"."+D(l).join(".")}N.asCSSSelector=p;function y(l){return l&&typeof l=="object"&&typeof l.id=="string"&&(typeof l.color>"u"||n.isThemeColor(l.color))}N.isThemeIcon=y;const $=new RegExp(`^\\$\\((${N.iconNameExpression}(?:${N.iconModifierExpression})?)\\)$`);function g(l){const v=$.exec(l);if(!v)return;const[,k]=v;return{id:k}}N.fromString=g;function e(l){return{id:l}}N.fromId=e;function s(l,v){let k=l.id;const A=k.lastIndexOf("~");return A!==-1&&(k=k.substring(0,A)),v&&(k=`${k}~${v}`),{id:k}}N.modify=s;function r(l){const v=l.id.lastIndexOf("~");if(v!==-1)return l.id.substring(v+1)}N.getModifier=r;function h(l,v){return l.id===v.id&&l.color?.id===v.color?.id}N.isEqual=h})(F||(t.ThemeIcon=F={}))}),define(we[65],ve([1,0]),function(re,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Constants=void 0,t.$$e=n,t.$_e=j;var i;(function(F){F[F.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",F[F.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",F[F.MAX_UINT_8=255]="MAX_UINT_8",F[F.MAX_UINT_16=65535]="MAX_UINT_16",F[F.MAX_UINT_32=4294967295]="MAX_UINT_32",F[F.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(i||(t.Constants=i={}));function n(F){return F<0?0:F>i.MAX_UINT_8?i.MAX_UINT_8:F|0}function j(F){return F<0?0:F>i.MAX_UINT_32?i.MAX_UINT_32:F|0}}),define(we[11],ve([1,0,103,17,25,65]),function(re,t,i,n,j,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$bg=t.$ag=t.$_f=t.GraphemeBreakType=t.$2f=t.$Tf=t.$Mf=t.$Lf=void 0,t.$af=N,t.$bf=D,t.$cf=p,t.$df=y,t.$ef=$,t.$ff=g,t.$gf=e,t.$hf=s,t.$if=r,t.$jf=h,t.$kf=l,t.$lf=v,t.$mf=k,t.$nf=A,t.$of=d,t.$pf=f,t.$qf=b,t.$rf=S,t.$sf=U,t.$tf=_,t.$uf=B,t.$vf=E,t.$wf=I,t.$xf=z,t.$yf=O,t.$zf=C,t.$Af=x,t.$Bf=Z,t.$Cf=Y,t.$Df=q,t.$Ef=ee,t.$Ff=ce,t.$Gf=be,t.$Hf=ke,t.$If=Fe,t.$Jf=ue,t.$Kf=Q,t.$Nf=te,t.$Of=$e,t.$Pf=Ae,t.$Qf=Oe,t.$Rf=se,t.$Sf=W,t.$Uf=a,t.$Vf=o,t.$Wf=m,t.$Xf=M,t.$Yf=u,t.$Zf=L,t.$1f=P,t.$3f=H,t.$4f=X,t.$5f=ie,t.$6f=oe,t.$7f=de,t.$8f=ye,t.$9f=De,t.$0f=Le,t.$$f=Ze;function N(J){return!J||typeof J!="string"?!0:J.trim().length===0}const w=/{(\d+)}/g;function D(J,...ae){return ae.length===0?J:J.replace(w,function(pe,Se){const Pe=parseInt(Se,10);return isNaN(Pe)||Pe<0||Pe>=ae.length?pe:ae[Pe]})}const c=/{([^}]+)}/g;function p(J,ae){return Object.keys(ae).length===0?J:J.replace(c,(pe,Se)=>ae[Se]??pe)}function y(J){return J.replace(/[<>"'&]/g,ae=>{switch(ae){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return ae})}function $(J){return J.replace(/[<>&]/g,function(ae){switch(ae){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return ae}})}function g(J){return J.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}function e(J,ae){let pe=0,Se=J.indexOf(ae);for(;Se!==-1;)pe++,Se=J.indexOf(ae,Se+ae.length);return pe}function s(J,ae,pe="\u2026"){return J.length<=ae?J:`${J.substr(0,ae)}${pe}`}function r(J,ae,pe="\u2026"){if(J.length<=ae)return J;const Se=Math.ceil(ae/2)-pe.length/2,Pe=Math.floor(ae/2)-pe.length/2;return`${J.substr(0,Se)}${pe}${J.substr(J.length-Pe)}`}function h(J,ae=" "){const pe=l(J,ae);return v(pe,ae)}function l(J,ae){if(!J||!ae)return J;const pe=ae.length;if(pe===0||J.length===0)return J;let Se=0;for(;J.indexOf(ae,Se)===Se;)Se=Se+pe;return J.substring(Se)}function v(J,ae){if(!J||!ae)return J;const pe=ae.length,Se=J.length;if(pe===0||Se===0)return J;let Pe=Se,ze=-1;for(;ze=J.lastIndexOf(ae,Pe-1),!(ze===-1||ze+pe!==Pe);){if(ze===0)return"";Pe=ze}return J.substring(0,Pe)}function k(J){return J.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}function A(J){return J.replace(/\*/g,"")}function d(J,ae,pe={}){if(!J)throw new Error("Cannot create regex from empty string");ae||(J=g(J)),pe.wholeWord&&(/\B/.test(J.charAt(0))||(J="\\b"+J),/\B/.test(J.charAt(J.length-1))||(J=J+"\\b"));let Se="";return pe.global&&(Se+="g"),pe.matchCase||(Se+="i"),pe.multiline&&(Se+="m"),pe.unicode&&(Se+="u"),new RegExp(J,Se)}function f(J){return J.source==="^"||J.source==="^$"||J.source==="$"||J.source==="^\\s*$"?!1:!!(J.exec("")&&J.lastIndex===0)}function b(J){return J.split(/\r\n|\r|\n/)}function S(J){const ae=[],pe=J.split(/(\r\n|\r|\n)/);for(let Se=0;Se<Math.ceil(pe.length/2);Se++)ae.push(pe[2*Se]+(pe[2*Se+1]??""));return ae}function U(J){for(let ae=0,pe=J.length;ae<pe;ae++){const Se=J.charCodeAt(ae);if(Se!==n.CharCode.Space&&Se!==n.CharCode.Tab)return ae}return-1}function _(J,ae=0,pe=J.length){for(let Se=ae;Se<pe;Se++){const Pe=J.charCodeAt(Se);if(Pe!==n.CharCode.Space&&Pe!==n.CharCode.Tab)return J.substring(ae,Se)}return J.substring(ae,pe)}function B(J,ae=J.length-1){for(let pe=ae;pe>=0;pe--){const Se=J.charCodeAt(pe);if(Se!==n.CharCode.Space&&Se!==n.CharCode.Tab)return pe}return-1}function E(J,ae,pe){const Se=[];let Pe=0;for(const ze of J.matchAll(ae)){if(Se.push(J.slice(Pe,ze.index)),ze.index===void 0)throw new Error("match.index should be defined");Pe=ze.index+ze[0].length,Se.push(pe(ze[0],...ze.slice(1),ze.index,J,ze.groups))}return Se.push(J.slice(Pe)),Promise.all(Se).then(ze=>ze.join(""))}function I(J,ae){return J<ae?-1:J>ae?1:0}function z(J,ae,pe=0,Se=J.length,Pe=0,ze=ae.length){for(;pe<Se&&Pe<ze;pe++,Pe++){const it=J.charCodeAt(pe),ht=ae.charCodeAt(Pe);if(it<ht)return-1;if(it>ht)return 1}const Xe=Se-pe,rt=ze-Pe;return Xe<rt?-1:Xe>rt?1:0}function O(J,ae){return C(J,ae,0,J.length,0,ae.length)}function C(J,ae,pe=0,Se=J.length,Pe=0,ze=ae.length){for(;pe<Se&&Pe<ze;pe++,Pe++){let it=J.charCodeAt(pe),ht=ae.charCodeAt(Pe);if(it===ht)continue;if(it>=128||ht>=128)return z(J.toLowerCase(),ae.toLowerCase(),pe,Se,Pe,ze);Z(it)&&(it-=32),Z(ht)&&(ht-=32);const nt=it-ht;if(nt!==0)return nt}const Xe=Se-pe,rt=ze-Pe;return Xe<rt?-1:Xe>rt?1:0}function x(J){return J>=n.CharCode.Digit0&&J<=n.CharCode.Digit9}function Z(J){return J>=n.CharCode.a&&J<=n.CharCode.z}function Y(J){return J>=n.CharCode.A&&J<=n.CharCode.Z}function q(J,ae){return J.length===ae.length&&C(J,ae)===0}function ee(J,ae){const pe=ae.length;return ae.length>J.length?!1:C(J,ae,0,pe)===0}function ce(J,ae){const pe=Math.min(J.length,ae.length);let Se;for(Se=0;Se<pe;Se++)if(J.charCodeAt(Se)!==ae.charCodeAt(Se))return Se;return pe}function be(J,ae){const pe=Math.min(J.length,ae.length);let Se;const Pe=J.length-1,ze=ae.length-1;for(Se=0;Se<pe;Se++)if(J.charCodeAt(Pe-Se)!==ae.charCodeAt(ze-Se))return Se;return pe}function ke(J){return 55296<=J&&J<=56319}function Fe(J){return 56320<=J&&J<=57343}function ue(J,ae){return(J-55296<<10)+(ae-56320)+65536}function Q(J,ae,pe){const Se=J.charCodeAt(pe);if(ke(Se)&&pe+1<ae){const Pe=J.charCodeAt(pe+1);if(Fe(Pe))return ue(Se,Pe)}return Se}function he(J,ae){const pe=J.charCodeAt(ae-1);if(Fe(pe)&&ae>1){const Se=J.charCodeAt(ae-2);if(ke(Se))return ue(Se,pe)}return pe}class le{get offset(){return this.e}constructor(ae,pe=0){this.c=ae,this.d=ae.length,this.e=pe}setOffset(ae){this.e=ae}prevCodePoint(){const ae=he(this.c,this.e);return this.e-=ae>=F.Constants.UNICODE_SUPPLEMENTARY_PLANE_BEGIN?2:1,ae}nextCodePoint(){const ae=Q(this.c,this.d,this.e);return this.e+=ae>=F.Constants.UNICODE_SUPPLEMENTARY_PLANE_BEGIN?2:1,ae}eol(){return this.e>=this.d}}t.$Lf=le;class Ne{get offset(){return this.c.offset}constructor(ae,pe=0){this.c=new le(ae,pe)}nextGraphemeLength(){const ae=Re.getInstance(),pe=this.c,Se=pe.offset;let Pe=ae.getGraphemeBreakType(pe.nextCodePoint());for(;!pe.eol();){const ze=pe.offset,Xe=ae.getGraphemeBreakType(pe.nextCodePoint());if(Te(Pe,Xe)){pe.setOffset(ze);break}Pe=Xe}return pe.offset-Se}prevGraphemeLength(){const ae=Re.getInstance(),pe=this.c,Se=pe.offset;let Pe=ae.getGraphemeBreakType(pe.prevCodePoint());for(;pe.offset>0;){const ze=pe.offset,Xe=ae.getGraphemeBreakType(pe.prevCodePoint());if(Te(Xe,Pe)){pe.setOffset(ze);break}Pe=Xe}return Se-pe.offset}eol(){return this.c.eol()}}t.$Mf=Ne;function te(J,ae){return new Ne(J,ae).nextGraphemeLength()}function $e(J,ae){return new Ne(J,ae).prevGraphemeLength()}function Ae(J,ae){ae>0&&Fe(J.charCodeAt(ae))&&ae--;const pe=ae+te(J,ae);return[pe-$e(J,pe),pe]}function Oe(J){const ae=new Ne(J);let pe=0;for(;!ae.eol();)pe++,ae.nextGraphemeLength();return pe}let Ie;function Ce(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function se(J){return Ie||(Ie=Ce()),Ie.test(J)}const K=/^[\t\n\r\x20-\x7E]*$/;function W(J){return K.test(J)}t.$Tf=/[\u2028\u2029]/;function a(J){return t.$Tf.test(J)}function o(J){return J>=11904&&J<=55215||J>=63744&&J<=64255||J>=65281&&J<=65374}function m(J){return J>=127462&&J<=127487||J===8986||J===8987||J===9200||J===9203||J>=9728&&J<=10175||J===11088||J===11093||J>=127744&&J<=128591||J>=128640&&J<=128764||J>=128992&&J<=129008||J>=129280&&J<=129535||J>=129648&&J<=129782}function M(J,ae,pe=""){const Se=J.trimStart();if(Se.length<ae)return Se;const Pe=/\b/g;let ze=0;for(;Pe.test(Se)&&!(Se.length-Pe.lastIndex<ae);)ze=Pe.lastIndex,Pe.lastIndex+=1;return ze===0?Se:pe+Se.substring(ze).trimStart()}const R=/(?:(?:\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~])|(:?\x1b\].*?\x07)/g;function*u(J){let ae=0;for(const pe of J.matchAll(R))ae!==pe.index&&(yield{isCode:!1,str:J.substring(ae,pe.index)}),yield{isCode:!0,str:pe[0]},ae=pe.index+pe[0].length;ae!==J.length&&(yield{isCode:!1,str:J.substring(ae)})}function L(J){return J&&(J=J.replace(R,"")),J}const T=/\\\[.*?\\\]/g;function P(J){return L(J).replace(T,"")}t.$2f=String.fromCharCode(n.CharCode.UTF8_BOM);function H(J){return!!(J&&J.length>0&&J.charCodeAt(0)===n.CharCode.UTF8_BOM)}function X(J){return H(J)?J.substr(1):J}function ie(J,ae){if(!J||!ae||J.length<ae.length)return!1;const pe=ae.length,Se=J.toLowerCase();let Pe=0,ze=-1;for(;Pe<pe;){const Xe=Se.indexOf(ae[Pe],ze+1);if(Xe<0)return!1;ze=Xe,Pe++}return!0}function oe(J,ae=!1){return J?(ae&&(J=J.replace(/\\./g,"")),J.toLowerCase()!==J):!1}function de(J){return J.charAt(0).toUpperCase()+J.slice(1)}function ye(J,ae=1){if(ae===0)return"";let pe=-1;do pe=J.indexOf(`
`,pe+1),ae--;while(ae>0&&pe>=0);return pe===-1?J:(J[pe-1]==="\r"&&pe--,J.substr(0,pe))}function De(J){const ae=n.CharCode.Z-n.CharCode.A+1;return J=J%(2*ae),J<ae?String.fromCharCode(n.CharCode.a+J):String.fromCharCode(n.CharCode.A+J-ae)}function Le(J){return Re.getInstance().getGraphemeBreakType(J)}function Te(J,ae){return J===fe.Other?ae!==fe.Extend&&ae!==fe.SpacingMark:J===fe.CR&&ae===fe.LF?!1:J===fe.Control||J===fe.CR||J===fe.LF||ae===fe.Control||ae===fe.CR||ae===fe.LF?!0:!(J===fe.L&&(ae===fe.L||ae===fe.V||ae===fe.LV||ae===fe.LVT)||(J===fe.LV||J===fe.V)&&(ae===fe.V||ae===fe.T)||(J===fe.LVT||J===fe.T)&&ae===fe.T||ae===fe.Extend||ae===fe.ZWJ||ae===fe.SpacingMark||J===fe.Prepend||J===fe.ZWJ&&ae===fe.Extended_Pictographic||J===fe.Regional_Indicator&&ae===fe.Regional_Indicator)}var fe;(function(J){J[J.Other=0]="Other",J[J.Prepend=1]="Prepend",J[J.CR=2]="CR",J[J.LF=3]="LF",J[J.Control=4]="Control",J[J.Extend=5]="Extend",J[J.Regional_Indicator=6]="Regional_Indicator",J[J.SpacingMark=7]="SpacingMark",J[J.L=8]="L",J[J.V=9]="V",J[J.T=10]="T",J[J.LV=11]="LV",J[J.LVT=12]="LVT",J[J.ZWJ=13]="ZWJ",J[J.Extended_Pictographic=14]="Extended_Pictographic"})(fe||(t.GraphemeBreakType=fe={}));class Re{static{this.c=null}static getInstance(){return Re.c||(Re.c=new Re),Re.c}constructor(){this.d=Ke()}getGraphemeBreakType(ae){if(ae<32)return ae===n.CharCode.LineFeed?fe.LF:ae===n.CharCode.CarriageReturn?fe.CR:fe.Control;if(ae<127)return fe.Other;const pe=this.d,Se=pe.length/3;let Pe=1;for(;Pe<=Se;)if(ae<pe[3*Pe])Pe=2*Pe;else if(ae>pe[3*Pe+1])Pe=2*Pe+1;else return pe[3*Pe+2];return fe.Other}}function Ke(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Ze(J,ae){if(J===0)return 0;const pe=tt(J,ae);if(pe!==void 0)return pe;const Se=new le(ae,J);return Se.prevCodePoint(),Se.offset}function tt(J,ae){const pe=new le(ae,J);let Se=pe.prevCodePoint();for(;at(Se)||Se===st.emojiVariantSelector||Se===st.enclosingKeyCap;){if(pe.offset===0)return;Se=pe.prevCodePoint()}if(!m(Se))return;let Pe=pe.offset;return Pe>0&&pe.prevCodePoint()===st.zwj&&(Pe=pe.offset),Pe}function at(J){return 127995<=J&&J<=127999}var st;(function(J){J[J.zwj=8205]="zwj",J[J.emojiVariantSelector=65039]="emojiVariantSelector",J[J.enclosingKeyCap=8419]="enclosingKeyCap"})(st||(st={})),t.$_f="\xA0";class Ge{static{this.c=new j.$T(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new i.$9e({getCacheKey:JSON.stringify},ae=>{function pe(nt){const ft=new Map;for(let ct=0;ct<nt.length;ct+=2)ft.set(nt[ct],nt[ct+1]);return ft}function Se(nt,ft){const ct=new Map(nt);for(const[wt,Ue]of ft)ct.set(wt,Ue);return ct}function Pe(nt,ft){if(!nt)return ft;const ct=new Map;for(const[wt,Ue]of nt)ft.has(wt)&&ct.set(wt,Ue);return ct}const ze=this.c.value;let Xe=ae.filter(nt=>!nt.startsWith("_")&&nt in ze);Xe.length===0&&(Xe=["_default"]);let rt;for(const nt of Xe){const ft=pe(ze[nt]);rt=Pe(rt,ft)}const it=pe(ze._common),ht=Se(it,rt);return new Ge(ht)})}static getInstance(ae){return Ge.d.get(Array.from(ae))}static{this.e=new j.$T(()=>Object.keys(Ge.c.value).filter(ae=>!ae.startsWith("_")))}static getLocales(){return Ge.e.value}constructor(ae){this.f=ae}isAmbiguous(ae){return this.f.has(ae)}containsAmbiguousCharacter(ae){for(let pe=0;pe<ae.length;pe++){const Se=ae.codePointAt(pe);if(typeof Se=="number"&&this.isAmbiguous(Se))return!0}return!1}getPrimaryConfusable(ae){return this.f.get(ae)}getConfusableCodePoints(){return new Set(this.f.keys())}}t.$ag=Ge;class Qe{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(Qe.c())),this.d}static isInvisibleCharacter(ae){return Qe.e().has(ae)}static containsInvisibleCharacter(ae){for(let pe=0;pe<ae.length;pe++){const Se=ae.codePointAt(pe);if(typeof Se=="number"&&Qe.isInvisibleCharacter(Se))return!0}return!1}static get codePoints(){return Qe.e()}}t.$bg=Qe}),define(we[108],ve([1,0,17,28,5,11,10]),function(re,t,i,n,j,F,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ug=w,t.$vg=D,t.$wg=c,t.$xg=p,t.$yg=y,t.$zg=s,t.$Ag=r,t.$Bg=h,t.$Cg=l,t.$Dg=v,t.$Eg=k,t.$Fg=A,t.$Gg=d,t.$Hg=f,t.$Ig=b,t.$Jg=S,t.$Kg=B;function w(E){return E===i.CharCode.Slash||E===i.CharCode.Backslash}function D(E){return E.replace(/[\\/]/g,n.$fc.sep)}function c(E){return E.indexOf("/")===-1&&(E=D(E)),/^[a-zA-Z]:(\/|$)/.test(E)&&(E="/"+E),E}function p(E,I=n.$fc.sep){if(!E)return"";const z=E.length,O=E.charCodeAt(0);if(w(O)){if(w(E.charCodeAt(1))&&!w(E.charCodeAt(2))){let x=3;const Z=x;for(;x<z&&!w(E.charCodeAt(x));x++);if(Z!==x&&!w(E.charCodeAt(x+1))){for(x+=1;x<z;x++)if(w(E.charCodeAt(x)))return E.slice(0,x+1).replace(/[\\/]/g,I)}}return I}else if(l(O)&&E.charCodeAt(1)===i.CharCode.Colon)return w(E.charCodeAt(2))?E.slice(0,2)+I:E.slice(0,2);let C=E.indexOf("://");if(C!==-1){for(C+=3;C<z;C++)if(w(E.charCodeAt(C)))return E.slice(0,C+1)}return""}function y(E){if(!j.$j||!E||E.length<5)return!1;let I=E.charCodeAt(0);if(I!==i.CharCode.Backslash||(I=E.charCodeAt(1),I!==i.CharCode.Backslash))return!1;let z=2;const O=z;for(;z<E.length&&(I=E.charCodeAt(z),I!==i.CharCode.Backslash);z++);return!(O===z||(I=E.charCodeAt(z+1),isNaN(I)||I===i.CharCode.Backslash))}const $=/[\\/:\*\?"<>\|]/g,g=/[/]/g,e=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function s(E,I=j.$j){const z=I?$:g;return!(!E||E.length===0||/^\s+$/.test(E)||(z.lastIndex=0,z.test(E))||I&&e.test(E)||E==="."||E===".."||I&&E[E.length-1]==="."||I&&E.length!==E.trim().length||E.length>255)}function r(E,I,z){const O=E===I;return!z||O?O:!E||!I?!1:(0,F.$Df)(E,I)}function h(E,I,z,O=n.sep){if(E===I)return!0;if(!E||!I||I.length>E.length)return!1;if(z){if(!(0,F.$Ef)(E,I))return!1;if(I.length===E.length)return!0;let x=I.length;return I.charAt(I.length-1)===O&&x--,E.charAt(x)===O}return I.charAt(I.length-1)!==O&&(I+=O),E.indexOf(I)===0}function l(E){return E>=i.CharCode.A&&E<=i.CharCode.Z||E>=i.CharCode.a&&E<=i.CharCode.z}function v(E,I){return j.$j&&E.endsWith(":")&&(E+=n.sep),(0,n.$hc)(E)||(E=(0,n.$ic)(I,E)),E=(0,n.$gc)(E),k(E)}function k(E){return j.$j?(E=(0,F.$lf)(E,n.sep),E.endsWith(":")&&(E+=n.sep)):(E=(0,F.$lf)(E,n.sep),E||(E=n.sep)),E}function A(E){const I=(0,n.$gc)(E);return j.$j?E.length>3?!1:d(I)&&(E.length===2||I.charCodeAt(2)===i.CharCode.Backslash):I===n.$fc.sep}function d(E,I=j.$j){return I?l(E.charCodeAt(0))&&E.charCodeAt(1)===i.CharCode.Colon:!1}function f(E,I=j.$j){return d(E,I)?E[0]:void 0}function b(E,I,z){return I.length>E.length?-1:E===I?0:(z&&(E=E.toLowerCase(),I=I.toLowerCase()),E.indexOf(I))}function S(E){const I=E.split(":");let z,O,C;for(const x of I){const Z=Number(x);(0,N.$gg)(Z)?O===void 0?O=Z:C===void 0&&(C=Z):z=z?[z,x].join(":"):x}if(!z)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:z,line:O!==void 0?O:void 0,column:C!==void 0?C:O!==void 0?1:void 0}}const U="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",_="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function B(E,I,z=8){let O="";for(let x=0;x<z;x++){let Z;x===0&&j.$j&&!I&&(z===3||z===4)?Z=_:Z=U,O+=Z.charAt(Math.floor(Math.random()*Z.length))}let C;return I?C=`${I}-${O}`:C=O,E?(0,n.$ic)(E,C):C}}),define(we[49],ve([1,0,17,43,93,11]),function(re,t,i,n,j,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Qk=t.FuzzyScore=t.$Fk=t.$Ek=void 0,t.or=N,t.$Gk=D,t.$Hk=c,t.$Ik=$,t.$Jk=B,t.$Kk=E,t.$Lk=Z,t.$Mk=Y,t.$Nk=q,t.$Ok=ee,t.$Pk=Ce,t.$Rk=a,t.$Sk=M,t.$Tk=R,F=He(F);function N(...T){return function(P,H){for(let X=0,ie=T.length;X<ie;X++){const oe=T[X](P,H);if(oe)return oe}return null}}t.$Ek=w.bind(void 0,!1),t.$Fk=w.bind(void 0,!0);function w(T,P,H){if(!H||H.length<P.length)return null;let X;return T?X=F.$Ef(H,P):X=H.indexOf(P)===0,X?P.length>0?[{start:0,end:P.length}]:[]:null}function D(T,P){const H=P.toLowerCase().indexOf(T.toLowerCase());return H===-1?null:[{start:H,end:H+T.length}]}function c(T,P){return p(T.toLowerCase(),P.toLowerCase(),0,0)}function p(T,P,H,X){if(H===T.length)return[];if(X===P.length)return null;if(T[H]===P[X]){let ie=null;return(ie=p(T,P,H+1,X+1))?A({start:X,end:X+1},ie):null}return p(T,P,H,X+1)}function y(T){return i.CharCode.a<=T&&T<=i.CharCode.z}function $(T){return i.CharCode.A<=T&&T<=i.CharCode.Z}function g(T){return i.CharCode.Digit0<=T&&T<=i.CharCode.Digit9}function e(T){return T===i.CharCode.Space||T===i.CharCode.Tab||T===i.CharCode.LineFeed||T===i.CharCode.CarriageReturn}const s=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(T=>s.add(T.charCodeAt(0)));function r(T){return e(T)||s.has(T)}function h(T,P){return T===P||r(T)&&r(P)}const l=new Map;function v(T){if(l.has(T))return l.get(T);let P;const H=(0,j.$Ck)(T);return H&&(P=H),l.set(T,P),P}function k(T){return y(T)||$(T)||g(T)}function A(T,P){return P.length===0?P=[T]:T.end===P[0].start?P[0].start=T.start:P.unshift(T),P}function d(T,P){for(let H=P;H<T.length;H++){const X=T.charCodeAt(H);if($(X)||g(X)||H>0&&!k(T.charCodeAt(H-1)))return H}return T.length}function f(T,P,H,X){if(H===T.length)return[];if(X===P.length)return null;if(T[H]!==P[X].toLowerCase())return null;{let ie=null,oe=X+1;for(ie=f(T,P,H+1,X+1);!ie&&(oe=d(P,oe))<P.length;)ie=f(T,P,H+1,oe),oe++;return ie===null?null:A({start:X,end:X+1},ie)}}function b(T){let P=0,H=0,X=0,ie=0,oe=0;for(let Te=0;Te<T.length;Te++)oe=T.charCodeAt(Te),$(oe)&&P++,y(oe)&&H++,k(oe)&&X++,g(oe)&&ie++;const de=P/T.length,ye=H/T.length,De=X/T.length,Le=ie/T.length;return{upperPercent:de,lowerPercent:ye,alphaPercent:De,numericPercent:Le}}function S(T){const{upperPercent:P,lowerPercent:H}=T;return H===0&&P>.6}function U(T){const{upperPercent:P,lowerPercent:H,alphaPercent:X,numericPercent:ie}=T;return H>.2&&P<.8&&X>.6&&ie<.2}function _(T){let P=0,H=0,X=0,ie=0;for(let oe=0;oe<T.length;oe++)X=T.charCodeAt(oe),$(X)&&P++,y(X)&&H++,e(X)&&ie++;return(P===0||H===0)&&ie===0?T.length<=30:P<=5}function B(T,P){if(!P||(P=P.trim(),P.length===0)||!_(T))return null;P.length>60&&(P=P.substring(0,60));const H=b(P);if(!U(H)){if(!S(H))return null;P=P.toLowerCase()}let X=null,ie=0;for(T=T.toLowerCase();ie<P.length&&(X=f(T,P,0,ie))===null;)ie=d(P,ie+1);return X}function E(T,P,H=!1){if(!P||P.length===0)return null;let X=null,ie=0;for(T=T.toLowerCase(),P=P.toLowerCase();ie<P.length&&(X=I(T,P,0,ie,H),X===null);)ie=z(P,ie+1);return X}function I(T,P,H,X,ie){let oe=0;if(H===T.length)return[];if(X===P.length)return null;if(!h(T.charCodeAt(H),P.charCodeAt(X))){const De=v(T.charCodeAt(H));if(!De)return null;for(let Le=0;Le<De.length;Le++)if(!h(De[Le],P.charCodeAt(X+Le)))return null;oe+=De.length-1}let de=null,ye=X+oe+1;if(de=I(T,P,H+1,ye,ie),!ie)for(;!de&&(ye=z(P,ye))<P.length;)de=I(T,P,H+1,ye,ie),ye++;if(!de)return null;if(T.charCodeAt(H)!==P.charCodeAt(X)){const De=v(T.charCodeAt(H));if(!De)return de;for(let Le=0;Le<De.length;Le++)if(De[Le]!==P.charCodeAt(X+Le))return de}return A({start:X,end:X+oe+1},de)}function z(T,P){for(let H=P;H<T.length;H++)if(r(T.charCodeAt(H))||H>0&&r(T.charCodeAt(H-1)))return H;return T.length}const O=N(t.$Fk,B,D),C=N(t.$Fk,B,c),x=new n.$Cc(1e4);function Z(T,P,H=!1){if(typeof T!="string"||typeof P!="string")return null;let X=x.get(T);X||(X=new RegExp(F.$mf(T),"i"),x.set(T,X));const ie=X.exec(P);return ie?[{start:ie.index,end:ie.index+ie[0].length}]:H?C(T,P):O(T,P)}function Y(T,P){const H=a(T,T.toLowerCase(),0,P,P.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return H?ee(H):null}function q(T,P,H,X,ie,oe){const de=Math.min(13,T.length);for(;H<de;H++){const ye=a(T,P,H,X,ie,oe,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(ye)return ye}return[0,oe]}function ee(T){if(typeof T>"u")return[];const P=[],H=T[1];for(let X=T.length-1;X>1;X--){const ie=T[X]+H,oe=P[P.length-1];oe&&oe.end===ie?oe.end=ie+1:P.push({start:ie,end:ie+1})}return P}const ce=128;function be(){const T=[],P=[];for(let H=0;H<=ce;H++)P[H]=0;for(let H=0;H<=ce;H++)T.push(P.slice(0));return T}function ke(T){const P=[];for(let H=0;H<=T;H++)P[H]=0;return P}const Fe=ke(2*ce),ue=ke(2*ce),Q=be(),he=be(),le=be(),Ne=!1;function te(T,P,H,X,ie){function oe(ye,De,Le=" "){for(;ye.length<De;)ye=Le+ye;return ye}let de=` |   |${X.split("").map(ye=>oe(ye,3)).join("|")}
`;for(let ye=0;ye<=H;ye++)ye===0?de+=" |":de+=`${P[ye-1]}|`,de+=T[ye].slice(0,ie+1).map(De=>oe(De.toString(),3)).join("|")+`
`;return de}function $e(T,P,H,X){T=T.substr(P),H=H.substr(X),console.log(te(he,T,T.length,H,H.length)),console.log(te(le,T,T.length,H,H.length)),console.log(te(Q,T,T.length,H,H.length))}function Ae(T,P){if(P<0||P>=T.length)return!1;const H=T.codePointAt(P);switch(H){case i.CharCode.Underline:case i.CharCode.Dash:case i.CharCode.Period:case i.CharCode.Space:case i.CharCode.Slash:case i.CharCode.Backslash:case i.CharCode.SingleQuote:case i.CharCode.DoubleQuote:case i.CharCode.Colon:case i.CharCode.DollarSign:case i.CharCode.LessThan:case i.CharCode.GreaterThan:case i.CharCode.OpenParen:case i.CharCode.CloseParen:case i.CharCode.OpenSquareBracket:case i.CharCode.CloseSquareBracket:case i.CharCode.OpenCurlyBrace:case i.CharCode.CloseCurlyBrace:return!0;case void 0:return!1;default:return!!F.$Wf(H)}}function Oe(T,P){if(P<0||P>=T.length)return!1;switch(T.charCodeAt(P)){case i.CharCode.Space:case i.CharCode.Tab:return!0;default:return!1}}function Ie(T,P,H){return P[T]!==H[T]}function Ce(T,P,H,X,ie,oe,de=!1){for(;P<H&&ie<oe;)T[P]===X[ie]&&(de&&(Fe[P]=ie),P+=1),ie+=1;return P===H}var se;(function(T){T[T.Diag=1]="Diag",T[T.Left=2]="Left",T[T.LeftLeft=3]="LeftLeft"})(se||(se={}));var K;(function(T){T.Default=[-100,0];function P(H){return!H||H.length===2&&H[0]===-100&&H[1]===0}T.isDefault=P})(K||(t.FuzzyScore=K={}));class W{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(P,H){this.firstMatchCanBeWeak=P,this.boostFullMatch=H}}t.$Qk=W;function a(T,P,H,X,ie,oe,de=W.default){const ye=T.length>ce?ce:T.length,De=X.length>ce?ce:X.length;if(H>=ye||oe>=De||ye-H>De-oe||!Ce(P,H,ye,ie,oe,De,!0))return;o(ye,De,H,oe,P,ie);let Le=1,Te=1,fe=H,Re=oe;const Ke=[!1];for(Le=1,fe=H;fe<ye;Le++,fe++){const Ge=Fe[fe],Qe=ue[fe],J=fe+1<ye?ue[fe+1]:De;for(Te=Ge-oe+1,Re=Ge;Re<J;Te++,Re++){let ae=Number.MIN_SAFE_INTEGER,pe=!1;Re<=Qe&&(ae=m(T,P,fe,H,X,ie,Re,De,oe,Q[Le-1][Te-1]===0,Ke));let Se=0;ae!==Number.MAX_SAFE_INTEGER&&(pe=!0,Se=ae+he[Le-1][Te-1]);const Pe=Re>Ge,ze=Pe?he[Le][Te-1]+(Q[Le][Te-1]>0?-5:0):0,Xe=Re>Ge+1&&Q[Le][Te-1]>0,rt=Xe?he[Le][Te-2]+(Q[Le][Te-2]>0?-5:0):0;if(Xe&&(!Pe||rt>=ze)&&(!pe||rt>=Se))he[Le][Te]=rt,le[Le][Te]=se.LeftLeft,Q[Le][Te]=0;else if(Pe&&(!pe||ze>=Se))he[Le][Te]=ze,le[Le][Te]=se.Left,Q[Le][Te]=0;else if(pe)he[Le][Te]=Se,le[Le][Te]=se.Diag,Q[Le][Te]=Q[Le-1][Te-1]+1;else throw new Error("not possible")}}if(Ne&&$e(T,H,X,oe),!Ke[0]&&!de.firstMatchCanBeWeak)return;Le--,Te--;const Ze=[he[Le][Te],oe];let tt=0,at=0;for(;Le>=1;){let Ge=Te;do{const Qe=le[Le][Ge];if(Qe===se.LeftLeft)Ge=Ge-2;else if(Qe===se.Left)Ge=Ge-1;else break}while(Ge>=1);tt>1&&P[H+Le-1]===ie[oe+Te-1]&&!Ie(Ge+oe-1,X,ie)&&tt+1>Q[Le][Ge]&&(Ge=Te),Ge===Te?tt++:tt=1,at||(at=Ge),Le--,Te=Ge-1,Ze.push(Te)}De-oe===ye&&de.boostFullMatch&&(Ze[0]+=2);const st=at-ye;return Ze[0]-=st,Ze}function o(T,P,H,X,ie,oe){let de=T-1,ye=P-1;for(;de>=H&&ye>=X;)ie[de]===oe[ye]&&(ue[de]=ye,de--),ye--}function m(T,P,H,X,ie,oe,de,ye,De,Le,Te){if(P[H]!==oe[de])return Number.MIN_SAFE_INTEGER;let fe=1,Re=!1;return de===H-X?fe=T[H]===ie[de]?7:5:Ie(de,ie,oe)&&(de===0||!Ie(de-1,ie,oe))?(fe=T[H]===ie[de]?7:5,Re=!0):Ae(oe,de)&&(de===0||!Ae(oe,de-1))?fe=5:(Ae(oe,de-1)||Oe(oe,de-1))&&(fe=5,Re=!0),fe>1&&H===X&&(Te[0]=!0),Re||(Re=Ie(de,ie,oe)||Ae(oe,de-1)||Oe(oe,de-1)),H===X?de>De&&(fe-=Re?3:5):Le?fe+=Re?2:0:fe+=Re?0:1,de+1===ye&&(fe-=Re?3:5),fe}function M(T,P,H,X,ie,oe,de){return u(T,P,H,X,ie,oe,!0,de)}function R(T,P,H,X,ie,oe,de){return u(T,P,H,X,ie,oe,!1,de)}function u(T,P,H,X,ie,oe,de,ye){let De=a(T,P,H,X,ie,oe,ye);if(De&&!de)return De;if(T.length>=3){const Le=Math.min(7,T.length-1);for(let Te=H+1;Te<Le;Te++){const fe=L(T,Te);if(fe){const Re=a(fe,fe.toLowerCase(),H,X,ie,oe,ye);Re&&(Re[0]-=3,(!De||Re[0]>De[0])&&(De=Re))}}}return De}function L(T,P){if(P+1>=T.length)return;const H=T[P],X=T[P+1];if(H!==X)return T.slice(0,P)+X+H+T.slice(P+2)}}),define(we[66],ve([1,0,11]),function(re,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$wj=t.$uj=void 0,t.$qj=n,t.$rj=j,t.$sj=F,t.$tj=w,t.$vj=s,i=He(i);function n(h){return j(h,0)}function j(h,l){switch(typeof h){case"object":return h===null?F(349,l):Array.isArray(h)?D(h,l):c(h,l);case"string":return w(h,l);case"boolean":return N(h,l);case"number":return F(h,l);case"undefined":return F(937,l);default:return F(617,l)}}function F(h,l){return(l<<5)-l+h|0}function N(h,l){return F(h?433:863,l)}function w(h,l){l=F(149417,l);for(let v=0,k=h.length;v<k;v++)l=F(h.charCodeAt(v),l);return l}function D(h,l){return l=F(104579,l),h.reduce((v,k)=>j(k,v),l)}function c(h,l){return l=F(181387,l),Object.keys(h).sort().reduce((v,k)=>(v=w(k,v),j(h[k],v)),l)}class p{constructor(){this.g=0}get value(){return this.g}hash(l){return this.g=j(l,this.g),this.g}}t.$uj=p;var y;(function(h){h[h.BLOCK_SIZE=64]="BLOCK_SIZE",h[h.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(y||(y={}));function $(h,l,v=32){const k=v-l,A=~((1<<k)-1);return(h<<l|(A&h)>>>k)>>>0}function g(h,l=0,v=h.byteLength,k=0){for(let A=0;A<v;A++)h[l+A]=k}function e(h,l,v="0"){for(;h.length<l;)h=v+h;return h}function s(h,l=32){return h instanceof ArrayBuffer?Array.from(new Uint8Array(h)).map(v=>v.toString(16).padStart(2,"0")).join(""):e((h>>>0).toString(16),l/4)}class r{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(y.BLOCK_SIZE+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(l){const v=l.length;if(v===0)return;const k=this.p;let A=this.r,d=this.u,f,b;for(d!==0?(f=d,b=-1,d=0):(f=l.charCodeAt(0),b=0);;){let S=f;if(i.$Hf(f))if(b+1<v){const U=l.charCodeAt(b+1);i.$If(U)?(b++,S=i.$Jf(f,U)):S=y.UNICODE_REPLACEMENT}else{d=f;break}else i.$If(f)&&(S=y.UNICODE_REPLACEMENT);if(A=this.w(k,A,S),b++,b<v)f=l.charCodeAt(b);else break}this.r=A,this.u=d}w(l,v,k){return k<128?l[v++]=k:k<2048?(l[v++]=192|(k&1984)>>>6,l[v++]=128|(k&63)>>>0):k<65536?(l[v++]=224|(k&61440)>>>12,l[v++]=128|(k&4032)>>>6,l[v++]=128|(k&63)>>>0):(l[v++]=240|(k&1835008)>>>18,l[v++]=128|(k&258048)>>>12,l[v++]=128|(k&4032)>>>6,l[v++]=128|(k&63)>>>0),v>=y.BLOCK_SIZE&&(this.y(),v-=y.BLOCK_SIZE,this.t+=y.BLOCK_SIZE,l[0]=l[y.BLOCK_SIZE+0],l[1]=l[y.BLOCK_SIZE+1],l[2]=l[y.BLOCK_SIZE+2]),v}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,y.UNICODE_REPLACEMENT)),this.t+=this.r,this.x()),s(this.h)+s(this.l)+s(this.m)+s(this.n)+s(this.o)}x(){this.p[this.r++]=128,g(this.p,this.r),this.r>56&&(this.y(),g(this.p));const l=8*this.t;this.q.setUint32(56,Math.floor(l/4294967296),!1),this.q.setUint32(60,l%4294967296,!1),this.y()}y(){const l=r.g,v=this.q;for(let B=0;B<64;B+=4)l.setUint32(B,v.getUint32(B,!1),!1);for(let B=64;B<320;B+=4)l.setUint32(B,$(l.getUint32(B-12,!1)^l.getUint32(B-32,!1)^l.getUint32(B-56,!1)^l.getUint32(B-64,!1),1),!1);let k=this.h,A=this.l,d=this.m,f=this.n,b=this.o,S,U,_;for(let B=0;B<80;B++)B<20?(S=A&d|~A&f,U=1518500249):B<40?(S=A^d^f,U=1859775393):B<60?(S=A&d|A&f|d&f,U=2400959708):(S=A^d^f,U=3395469782),_=$(k,5)+S+b+U+l.getUint32(B*4,!1)&4294967295,b=f,f=d,d=$(A,30),A=k,k=_;this.h=this.h+k&4294967295,this.l=this.l+A&4294967295,this.m=this.m+d&4294967295,this.n=this.n+f&4294967295,this.o=this.o+b&4294967295}}t.$wj=r}),define(we[109],ve([1,0,89,66,65]),function(re,t,i,n,j){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Rt=t.$Pt=void 0,t.$Qt=N;class F{constructor(g){this.a=g}getElements(){const g=this.a,e=new Int32Array(g.length);for(let s=0,r=g.length;s<r;s++)e[s]=g.charCodeAt(s);return e}}t.$Pt=F;function N($,g,e){return new y(new F($),new F(g)).ComputeDiff(e).changes}class w{static Assert(g,e){if(!g)throw new Error(e)}}class D{static Copy(g,e,s,r,h){for(let l=0;l<h;l++)s[r+l]=g[e+l]}static Copy2(g,e,s,r,h){for(let l=0;l<h;l++)s[r+l]=g[e+l]}}var c;(function($){$[$.MaxDifferencesHistory=1447]="MaxDifferencesHistory"})(c||(c={}));class p{constructor(){this.a=[],this.b=j.Constants.MAX_SAFE_SMALL_INTEGER,this.c=j.Constants.MAX_SAFE_SMALL_INTEGER,this.d=0,this.e=0}MarkNextChange(){(this.d>0||this.e>0)&&this.a.push(new i.$Ot(this.b,this.d,this.c,this.e)),this.d=0,this.e=0,this.b=j.Constants.MAX_SAFE_SMALL_INTEGER,this.c=j.Constants.MAX_SAFE_SMALL_INTEGER}AddOriginalElement(g,e){this.b=Math.min(this.b,g),this.c=Math.min(this.c,e),this.d++}AddModifiedElement(g,e){this.b=Math.min(this.b,g),this.c=Math.min(this.c,e),this.e++}getChanges(){return(this.d>0||this.e>0)&&this.MarkNextChange(),this.a}getReverseChanges(){return(this.d>0||this.e>0)&&this.MarkNextChange(),this.a.reverse(),this.a}}class y{constructor(g,e,s=null){this.a=s,this.b=g,this.c=e;const[r,h,l]=y.o(g),[v,k,A]=y.o(e);this.d=l&&A,this.e=r,this.f=h,this.g=v,this.h=k,this.k=[],this.m=[]}static n(g){return g.length>0&&typeof g[0]=="string"}static o(g){const e=g.getElements();if(y.n(e)){const s=new Int32Array(e.length);for(let r=0,h=e.length;r<h;r++)s[r]=(0,n.$tj)(e[r],0);return[e,s,!0]}return e instanceof Int32Array?[[],e,!1]:[[],new Int32Array(e),!1]}p(g,e){return this.f[g]!==this.h[e]?!1:this.d?this.e[g]===this.g[e]:!0}q(g,e){if(!this.p(g,e))return!1;const s=y.r(this.b,g),r=y.r(this.c,e);return s===r}static r(g,e){return typeof g.getStrictElement=="function"?g.getStrictElement(e):null}s(g,e){return this.f[g]!==this.f[e]?!1:this.d?this.e[g]===this.e[e]:!0}u(g,e){return this.h[g]!==this.h[e]?!1:this.d?this.g[g]===this.g[e]:!0}ComputeDiff(g){return this.v(0,this.f.length-1,0,this.h.length-1,g)}v(g,e,s,r,h){const l=[!1];let v=this.w(g,e,s,r,l);return h&&(v=this.z(v)),{quitEarly:l[0],changes:v}}w(g,e,s,r,h){for(h[0]=!1;g<=e&&s<=r&&this.p(g,s);)g++,s++;for(;e>=g&&r>=s&&this.p(e,r);)e--,r--;if(g>e||s>r){let f;return s<=r?(w.Assert(g===e+1,"originalStart should only be one more than originalEnd"),f=[new i.$Ot(g,0,s,r-s+1)]):g<=e?(w.Assert(s===r+1,"modifiedStart should only be one more than modifiedEnd"),f=[new i.$Ot(g,e-g+1,s,0)]):(w.Assert(g===e+1,"originalStart should only be one more than originalEnd"),w.Assert(s===r+1,"modifiedStart should only be one more than modifiedEnd"),f=[]),f}const l=[0],v=[0],k=this.y(g,e,s,r,l,v,h),A=l[0],d=v[0];if(k!==null)return k;if(!h[0]){const f=this.w(g,A,s,d,h);let b=[];return h[0]?b=[new i.$Ot(A+1,e-(A+1)+1,d+1,r-(d+1)+1)]:b=this.w(A+1,e,d+1,r,h),this.H(f,b)}return[new i.$Ot(g,e-g+1,s,r-s+1)]}x(g,e,s,r,h,l,v,k,A,d,f,b,S,U,_,B,E,I){let z=null,O=null,C=new p,x=e,Z=s,Y=S[0]-B[0]-r,q=j.Constants.MIN_SAFE_SMALL_INTEGER,ee=this.k.length-1;do{const ce=Y+g;ce===x||ce<Z&&A[ce-1]<A[ce+1]?(f=A[ce+1],U=f-Y-r,f<q&&C.MarkNextChange(),q=f,C.AddModifiedElement(f+1,U),Y=ce+1-g):(f=A[ce-1]+1,U=f-Y-r,f<q&&C.MarkNextChange(),q=f-1,C.AddOriginalElement(f,U+1),Y=ce-1-g),ee>=0&&(A=this.k[ee],g=A[0],x=1,Z=A.length-1)}while(--ee>=-1);if(z=C.getReverseChanges(),I[0]){let ce=S[0]+1,be=B[0]+1;if(z!==null&&z.length>0){const ke=z[z.length-1];ce=Math.max(ce,ke.getOriginalEnd()),be=Math.max(be,ke.getModifiedEnd())}O=[new i.$Ot(ce,b-ce+1,be,_-be+1)]}else{C=new p,x=l,Z=v,Y=S[0]-B[0]-k,q=j.Constants.MAX_SAFE_SMALL_INTEGER,ee=E?this.m.length-1:this.m.length-2;do{const ce=Y+h;ce===x||ce<Z&&d[ce-1]>=d[ce+1]?(f=d[ce+1]-1,U=f-Y-k,f>q&&C.MarkNextChange(),q=f+1,C.AddOriginalElement(f+1,U+1),Y=ce+1-h):(f=d[ce-1],U=f-Y-k,f>q&&C.MarkNextChange(),q=f,C.AddModifiedElement(f+1,U+1),Y=ce-1-h),ee>=0&&(d=this.m[ee],h=d[0],x=1,Z=d.length-1)}while(--ee>=-1);O=C.getChanges()}return this.H(z,O)}y(g,e,s,r,h,l,v){let k=0,A=0,d=0,f=0,b=0,S=0;g--,s--,h[0]=0,l[0]=0,this.k=[],this.m=[];const U=e-g+(r-s),_=U+1,B=new Int32Array(_),E=new Int32Array(_),I=r-s,z=e-g,O=g-s,C=e-r,Z=(z-I)%2===0;B[I]=g,E[z]=e,v[0]=!1;for(let Y=1;Y<=U/2+1;Y++){let q=0,ee=0;d=this.J(I-Y,Y,I,_),f=this.J(I+Y,Y,I,_);for(let be=d;be<=f;be+=2){be===d||be<f&&B[be-1]<B[be+1]?k=B[be+1]:k=B[be-1]+1,A=k-(be-I)-O;const ke=k;for(;k<e&&A<r&&this.p(k+1,A+1);)k++,A++;if(B[be]=k,k+A>q+ee&&(q=k,ee=A),!Z&&Math.abs(be-z)<=Y-1&&k>=E[be])return h[0]=k,l[0]=A,ke<=E[be]&&c.MaxDifferencesHistory>0&&Y<=c.MaxDifferencesHistory+1?this.x(I,d,f,O,z,b,S,C,B,E,k,e,h,A,r,l,Z,v):null}const ce=(q-g+(ee-s)-Y)/2;if(this.a!==null&&!this.a(q,ce))return v[0]=!0,h[0]=q,l[0]=ee,ce>0&&c.MaxDifferencesHistory>0&&Y<=c.MaxDifferencesHistory+1?this.x(I,d,f,O,z,b,S,C,B,E,k,e,h,A,r,l,Z,v):(g++,s++,[new i.$Ot(g,e-g+1,s,r-s+1)]);b=this.J(z-Y,Y,z,_),S=this.J(z+Y,Y,z,_);for(let be=b;be<=S;be+=2){be===b||be<S&&E[be-1]>=E[be+1]?k=E[be+1]-1:k=E[be-1],A=k-(be-z)-C;const ke=k;for(;k>g&&A>s&&this.p(k,A);)k--,A--;if(E[be]=k,Z&&Math.abs(be-I)<=Y&&k<=B[be])return h[0]=k,l[0]=A,ke>=B[be]&&c.MaxDifferencesHistory>0&&Y<=c.MaxDifferencesHistory+1?this.x(I,d,f,O,z,b,S,C,B,E,k,e,h,A,r,l,Z,v):null}if(Y<=c.MaxDifferencesHistory){let be=new Int32Array(f-d+2);be[0]=I-d+1,D.Copy2(B,d,be,1,f-d+1),this.k.push(be),be=new Int32Array(S-b+2),be[0]=z-b+1,D.Copy2(E,b,be,1,S-b+1),this.m.push(be)}}return this.x(I,d,f,O,z,b,S,C,B,E,k,e,h,A,r,l,Z,v)}z(g){for(let e=0;e<g.length;e++){const s=g[e],r=e<g.length-1?g[e+1].originalStart:this.f.length,h=e<g.length-1?g[e+1].modifiedStart:this.h.length,l=s.originalLength>0,v=s.modifiedLength>0;for(;s.originalStart+s.originalLength<r&&s.modifiedStart+s.modifiedLength<h&&(!l||this.s(s.originalStart,s.originalStart+s.originalLength))&&(!v||this.u(s.modifiedStart,s.modifiedStart+s.modifiedLength));){const A=this.q(s.originalStart,s.modifiedStart);if(this.q(s.originalStart+s.originalLength,s.modifiedStart+s.modifiedLength)&&!A)break;s.originalStart++,s.modifiedStart++}const k=[null];if(e<g.length-1&&this.I(g[e],g[e+1],k)){g[e]=k[0],g.splice(e+1,1),e--;continue}}for(let e=g.length-1;e>=0;e--){const s=g[e];let r=0,h=0;if(e>0){const f=g[e-1];r=f.originalStart+f.originalLength,h=f.modifiedStart+f.modifiedLength}const l=s.originalLength>0,v=s.modifiedLength>0;let k=0,A=this.G(s.originalStart,s.originalLength,s.modifiedStart,s.modifiedLength);for(let f=1;;f++){const b=s.originalStart-f,S=s.modifiedStart-f;if(b<r||S<h||l&&!this.s(b,b+s.originalLength)||v&&!this.u(S,S+s.modifiedLength))break;const _=(b===r&&S===h?5:0)+this.G(b,s.originalLength,S,s.modifiedLength);_>A&&(A=_,k=f)}s.originalStart-=k,s.modifiedStart-=k;const d=[null];if(e>0&&this.I(g[e-1],g[e],d)){g[e-1]=d[0],g.splice(e,1),e++;continue}}if(this.d)for(let e=1,s=g.length;e<s;e++){const r=g[e-1],h=g[e],l=h.originalStart-r.originalStart-r.originalLength,v=r.originalStart,k=h.originalStart+h.originalLength,A=k-v,d=r.modifiedStart,f=h.modifiedStart+h.modifiedLength,b=f-d;if(l<5&&A<20&&b<20){const S=this.A(v,A,d,b,l);if(S){const[U,_]=S;(U!==r.originalStart+r.originalLength||_!==r.modifiedStart+r.modifiedLength)&&(r.originalLength=U-r.originalStart,r.modifiedLength=_-r.modifiedStart,h.originalStart=U+l,h.modifiedStart=_+l,h.originalLength=k-h.originalStart,h.modifiedLength=f-h.modifiedStart)}}}return g}A(g,e,s,r,h){if(e<h||r<h)return null;const l=g+e-h+1,v=s+r-h+1;let k=0,A=0,d=0;for(let f=g;f<l;f++)for(let b=s;b<v;b++){const S=this.B(f,b,h);S>0&&S>k&&(k=S,A=f,d=b)}return k>0?[A,d]:null}B(g,e,s){let r=0;for(let h=0;h<s;h++){if(!this.p(g+h,e+h))return 0;r+=this.e[g+h].length}return r}C(g){return g<=0||g>=this.f.length-1?!0:this.d&&/^\s*$/.test(this.e[g])}D(g,e){if(this.C(g)||this.C(g-1))return!0;if(e>0){const s=g+e;if(this.C(s-1)||this.C(s))return!0}return!1}E(g){return g<=0||g>=this.h.length-1?!0:this.d&&/^\s*$/.test(this.g[g])}F(g,e){if(this.E(g)||this.E(g-1))return!0;if(e>0){const s=g+e;if(this.E(s-1)||this.E(s))return!0}return!1}G(g,e,s,r){const h=this.D(g,e)?1:0,l=this.F(s,r)?1:0;return h+l}H(g,e){const s=[];if(g.length===0||e.length===0)return e.length>0?e:g;if(this.I(g[g.length-1],e[0],s)){const r=new Array(g.length+e.length-1);return D.Copy(g,0,r,0,g.length-1),r[g.length-1]=s[0],D.Copy(e,1,r,g.length,e.length-1),r}else{const r=new Array(g.length+e.length);return D.Copy(g,0,r,0,g.length),D.Copy(e,0,r,g.length,e.length),r}}I(g,e,s){if(w.Assert(g.originalStart<=e.originalStart,"Left change is not less than or equal to right change"),w.Assert(g.modifiedStart<=e.modifiedStart,"Left change is not less than or equal to right change"),g.originalStart+g.originalLength>=e.originalStart||g.modifiedStart+g.modifiedLength>=e.modifiedStart){const r=g.originalStart;let h=g.originalLength;const l=g.modifiedStart;let v=g.modifiedLength;return g.originalStart+g.originalLength>=e.originalStart&&(h=e.originalStart+e.originalLength-g.originalStart),g.modifiedStart+g.modifiedLength>=e.modifiedStart&&(v=e.modifiedStart+e.modifiedLength-g.modifiedStart),s[0]=new i.$Ot(r,h,l,v),!0}else return s[0]=null,!1}J(g,e,s,r){if(g>=0&&g<r)return g;const h=s,l=r-s-1,v=e%2===0;if(g<0){const k=h%2===0;return v===k?0:1}else{const k=l%2===0;return v===k?r-1:r-2}}}t.$Rt=y}),define(we[67],ve([1,0,49,11,22]),function(re,t,i,n,j){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Uk=D,t.$Vk=p,t.$Wk=$,t.$Xk=g,t.$Yk=s,t.$Zk=r;const F="$(",N=new RegExp(`\\$\\(${j.ThemeIcon.iconNameExpression}(?:${j.ThemeIcon.iconModifierExpression})?\\)`,"g"),w=new RegExp(`(\\\\)?${N.source}`,"g");function D(h){return h.replace(w,(l,v)=>v?l:`\\${l}`)}const c=new RegExp(`\\\\${N.source}`,"g");function p(h){return h.replace(c,l=>`\\${l}`)}const y=new RegExp(`(\\s)?(\\\\)?${N.source}(\\s)?`,"g");function $(h){return h.indexOf(F)===-1?h:h.replace(y,(l,v,k,A)=>k?l:v||A||"")}function g(h){return h?h.replace(/\$\((.*?)\)/g,(l,v)=>` ${v} `).trim():""}const e=new RegExp(`\\$\\(${j.ThemeIcon.iconNameCharacter}+\\)`,"g");function s(h){e.lastIndex=0;let l="";const v=[];let k=0;for(;;){const A=e.lastIndex,d=e.exec(h),f=h.substring(A,d?.index);if(f.length>0){l+=f;for(let b=0;b<f.length;b++)v.push(k)}if(!d)break;k+=d[0].length}return{text:l,iconOffsets:v}}function r(h,l,v=!1){const{text:k,iconOffsets:A}=l;if(!A||A.length===0)return(0,i.$Lk)(h,k,v);const d=(0,n.$kf)(k," "),f=k.length-d.length,b=(0,i.$Lk)(h,d,v);if(b)for(const S of b){const U=A[S.start+f]+f;S.start+=U,S.end+=U}return b}}),define(we[110],ve([1,0,9,17,11]),function(re,t,i,n,j){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Ii=t.$Hi=t.$Gi=t.$Fi=t.$Ei=void 0;class F{constructor(){this.b="",this.c=0}reset(e){return this.b=e,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(e){const s=e.charCodeAt(0),r=this.b.charCodeAt(this.c);return s-r}value(){return this.b[this.c]}}t.$Ei=F;class N{constructor(e=!0){this.e=e}reset(e){return this.b=e,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let e=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===n.CharCode.Period)if(e)this.c++;else break;else e=!1;return this}cmp(e){return this.e?(0,j.$xf)(e,this.b,0,e.length,this.c,this.d):(0,j.$zf)(e,this.b,0,e.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}t.$Fi=N;class w{constructor(e=!0,s=!0){this.f=e,this.g=s}reset(e){this.d=0,this.e=0,this.b=e,this.c=e.length;for(let s=e.length-1;s>=0;s--,this.c--){const r=this.b.charCodeAt(s);if(!(r===n.CharCode.Slash||this.f&&r===n.CharCode.Backslash))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let e=!0;for(;this.e<this.c;this.e++){const s=this.b.charCodeAt(this.e);if(s===n.CharCode.Slash||this.f&&s===n.CharCode.Backslash)if(e)this.d++;else break;else e=!1}return this}cmp(e){return this.g?(0,j.$xf)(e,this.b,0,e.length,this.d,this.e):(0,j.$zf)(e,this.b,0,e.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}t.$Gi=w;var D;(function(g){g[g.Scheme=1]="Scheme",g[g.Authority=2]="Authority",g[g.Path=3]="Path",g[g.Query=4]="Query",g[g.Fragment=5]="Fragment"})(D||(D={}));class c{constructor(e,s){this.f=e,this.g=s,this.d=[],this.e=0}reset(e){return this.c=e,this.d=[],this.c.scheme&&this.d.push(D.Scheme),this.c.authority&&this.d.push(D.Authority),this.c.path&&(this.b=new w(!1,!this.f(e)),this.b.reset(e.path),this.b.value()&&this.d.push(D.Path)),this.g(e)||(this.c.query&&this.d.push(D.Query),this.c.fragment&&this.d.push(D.Fragment)),this.e=0,this}next(){return this.d[this.e]===D.Path&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===D.Path&&this.b.hasNext()||this.e<this.d.length-1}cmp(e){if(this.d[this.e]===D.Scheme)return(0,j.$yf)(e,this.c.scheme);if(this.d[this.e]===D.Authority)return(0,j.$yf)(e,this.c.authority);if(this.d[this.e]===D.Path)return this.b.cmp(e);if(this.d[this.e]===D.Query)return(0,j.$wf)(e,this.c.query);if(this.d[this.e]===D.Fragment)return(0,j.$wf)(e,this.c.fragment);throw new Error}value(){if(this.d[this.e]===D.Scheme)return this.c.scheme;if(this.d[this.e]===D.Authority)return this.c.authority;if(this.d[this.e]===D.Path)return this.b.value();if(this.d[this.e]===D.Query)return this.c.query;if(this.d[this.e]===D.Fragment)return this.c.fragment;throw new Error}}t.$Hi=c;class p{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const e=this.right;return this.right=e.left,e.left=this,this.updateHeight(),e.updateHeight(),e}rotateRight(){const e=this.left;return this.left=e.right,e.right=this,this.updateHeight(),e.updateHeight(),e}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var y;(function(g){g[g.Left=-1]="Left",g[g.Mid=0]="Mid",g[g.Right=1]="Right"})(y||(y={}));class ${static forUris(e=()=>!1,s=()=>!1){return new $(new c(e,s))}static forPaths(e=!1){return new $(new w(void 0,!e))}static forStrings(){return new $(new F)}static forConfigKeys(){return new $(new N)}constructor(e){this.b=e}clear(){this.c=void 0}fill(e,s){if(s){const r=s.slice(0);(0,i.$Vb)(r);for(const h of r)this.set(h,e)}else{const r=e.slice(0);(0,i.$Vb)(r);for(const h of r)this.set(h[0],h[1])}}set(e,s){const r=this.b.reset(e);let h;this.c||(this.c=new p,this.c.segment=r.value());const l=[];for(h=this.c;;){const k=r.cmp(h.segment);if(k>0)h.left||(h.left=new p,h.left.segment=r.value()),l.push([y.Left,h]),h=h.left;else if(k<0)h.right||(h.right=new p,h.right.segment=r.value()),l.push([y.Right,h]),h=h.right;else if(r.hasNext())r.next(),h.mid||(h.mid=new p,h.mid.segment=r.value()),l.push([y.Mid,h]),h=h.mid;else break}const v=h.value;h.value=s,h.key=e;for(let k=l.length-1;k>=0;k--){const A=l[k][1];A.updateHeight();const d=A.balanceFactor();if(d<-1||d>1){const f=l[k][0],b=l[k+1][0];if(f===y.Right&&b===y.Right)l[k][1]=A.rotateLeft();else if(f===y.Left&&b===y.Left)l[k][1]=A.rotateRight();else if(f===y.Right&&b===y.Left)A.right=l[k+1][1]=l[k+1][1].rotateRight(),l[k][1]=A.rotateLeft();else if(f===y.Left&&b===y.Right)A.left=l[k+1][1]=l[k+1][1].rotateLeft(),l[k][1]=A.rotateRight();else throw new Error;if(k>0)switch(l[k-1][0]){case y.Left:l[k-1][1].left=l[k][1];break;case y.Right:l[k-1][1].right=l[k][1];break;case y.Mid:l[k-1][1].mid=l[k][1];break}else this.c=l[0][1]}}return v}get(e){return this.d(e)?.value}d(e){const s=this.b.reset(e);let r=this.c;for(;r;){const h=s.cmp(r.segment);if(h>0)r=r.left;else if(h<0)r=r.right;else if(s.hasNext())s.next(),r=r.mid;else break}return r}has(e){const s=this.d(e);return!(s?.value===void 0&&s?.mid===void 0)}delete(e){return this.e(e,!1)}deleteSuperstr(e){return this.e(e,!0)}e(e,s){const r=this.b.reset(e),h=[];let l=this.c;for(;l;){const v=r.cmp(l.segment);if(v>0)h.push([y.Left,l]),l=l.left;else if(v<0)h.push([y.Right,l]),l=l.right;else if(r.hasNext())r.next(),h.push([y.Mid,l]),l=l.mid;else break}if(l){if(s?(l.left=void 0,l.mid=void 0,l.right=void 0,l.height=1):(l.key=void 0,l.value=void 0),!l.mid&&!l.value)if(l.left&&l.right){const v=this.f(l.right);if(v.key){const{key:k,value:A,segment:d}=v;this.e(v.key,!1),l.key=k,l.value=A,l.segment=d}}else{const v=l.left??l.right;if(h.length>0){const[k,A]=h[h.length-1];switch(k){case y.Left:A.left=v;break;case y.Mid:A.mid=v;break;case y.Right:A.right=v;break}}else this.c=v}for(let v=h.length-1;v>=0;v--){const k=h[v][1];k.updateHeight();const A=k.balanceFactor();if(A>1?(k.right.balanceFactor()>=0||(k.right=k.right.rotateRight()),h[v][1]=k.rotateLeft()):A<-1&&(k.left.balanceFactor()<=0||(k.left=k.left.rotateLeft()),h[v][1]=k.rotateRight()),v>0)switch(h[v-1][0]){case y.Left:h[v-1][1].left=h[v][1];break;case y.Right:h[v-1][1].right=h[v][1];break;case y.Mid:h[v-1][1].mid=h[v][1];break}else this.c=h[0][1]}}}f(e){for(;e.left;)e=e.left;return e}findSubstr(e){const s=this.b.reset(e);let r=this.c,h;for(;r;){const l=s.cmp(r.segment);if(l>0)r=r.left;else if(l<0)r=r.right;else if(s.hasNext())s.next(),h=r.value||h,r=r.mid;else break}return r&&r.value||h}findSuperstr(e){return this.g(e,!1)}g(e,s){const r=this.b.reset(e);let h=this.c;for(;h;){const l=r.cmp(h.segment);if(l>0)h=h.left;else if(l<0)h=h.right;else if(r.hasNext())r.next(),h=h.mid;else return h.mid?this.h(h.mid):s?h.value:void 0}}hasElementOrSubtree(e){return this.g(e,!0)!==void 0}forEach(e){for(const[s,r]of this)e(r,s)}*[Symbol.iterator](){yield*this.h(this.c)}h(e){const s=[];return this.j(e,s),s[Symbol.iterator]()}j(e,s){e&&(e.left&&this.j(e.left,s),e.value&&s.push([e.key,e.value]),e.mid&&this.j(e.mid,s),e.right&&this.j(e.right,s))}_isBalanced(){const e=s=>{if(!s)return!0;const r=s.balanceFactor();return r<-1||r>1?!1:e(s.left)&&e(s.right)};return e(this.c)}}t.$Ii=$}),define(we[16],ve([1,0,17,60,28,5]),function(re,t,i,n,j,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.URI=void 0,t.$uc=r,t.$vc=d,j=He(j);const N=/^\w[\w\d+.-]*$/,w=/^\//,D=/^\/\//;function c(_,B){if(!_.scheme&&B)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${_.authority}", path: "${_.path}", query: "${_.query}", fragment: "${_.fragment}"}`);if(_.scheme&&!N.test(_.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(_.path){if(_.authority){if(!w.test(_.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(D.test(_.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function p(_,B){return!_&&!B?"file":_}function y(_,B){switch(_){case"https":case"http":case"file":B?B[0]!==g&&(B=g+B):B=g;break}return B}const $="",g="/",e=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class s{static isUri(B){return B instanceof s?!0:B?typeof B.authority=="string"&&typeof B.fragment=="string"&&typeof B.path=="string"&&typeof B.query=="string"&&typeof B.scheme=="string"&&typeof B.fsPath=="string"&&typeof B.with=="function"&&typeof B.toString=="function":!1}constructor(B,E,I,z,O,C=!1){typeof B=="object"?(this.scheme=B.scheme||$,this.authority=B.authority||$,this.path=B.path||$,this.query=B.query||$,this.fragment=B.fragment||$):(this.scheme=p(B,C),this.authority=E||$,this.path=y(this.scheme,I||$),this.query=z||$,this.fragment=O||$,c(this,C))}get fsPath(){return d(this,!1)}with(B){if(!B)return this;let{scheme:E,authority:I,path:z,query:O,fragment:C}=B;return E===void 0?E=this.scheme:E===null&&(E=$),I===void 0?I=this.authority:I===null&&(I=$),z===void 0?z=this.path:z===null&&(z=$),O===void 0?O=this.query:O===null&&(O=$),C===void 0?C=this.fragment:C===null&&(C=$),E===this.scheme&&I===this.authority&&z===this.path&&O===this.query&&C===this.fragment?this:new l(E,I,z,O,C)}static parse(B,E=!1){const I=e.exec(B);return I?new l(I[2]||$,U(I[4]||$),U(I[5]||$),U(I[7]||$),U(I[9]||$),E):new l($,$,$,$,$)}static file(B){let E=$;if(F.$j&&(B=B.replace(/\\/g,g)),B[0]===g&&B[1]===g){const I=B.indexOf(g,2);I===-1?(E=B.substring(2),B=g):(E=B.substring(2,I),B=B.substring(I)||g)}return new l("file",E,B,$,$)}static from(B,E){return new l(B.scheme,B.authority,B.path,B.query,B.fragment,E)}static joinPath(B,...E){if(!B.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let I;return F.$j&&B.scheme==="file"?I=s.file(j.$ec.join(d(B,!0),...E)).path:I=j.$fc.join(B.path,...E),B.with({path:I})}toString(B=!1){return f(this,B)}toJSON(){return this}static revive(B){if(B){if(B instanceof s)return B;{const E=new l(B);return E._formatted=B.external??null,E._fsPath=B._sep===h?B.fsPath??null:null,E}}else return B}[Symbol.for("debug.description")](){return`URI(${this.toString()})`}}t.URI=s;function r(_){return!_||typeof _!="object"?!1:typeof _.scheme=="string"&&(typeof _.authority=="string"||typeof _.authority>"u")&&(typeof _.path=="string"||typeof _.path>"u")&&(typeof _.query=="string"||typeof _.query>"u")&&(typeof _.fragment=="string"||typeof _.fragment>"u")}const h=F.$j?1:void 0;class l extends s{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=d(this,!1)),this._fsPath}toString(B=!1){return B?f(this,!0):(this._formatted||(this._formatted=f(this,!1)),this._formatted)}toJSON(){const B={$mid:n.MarshalledId.Uri};return this._fsPath&&(B.fsPath=this._fsPath,B._sep=h),this._formatted&&(B.external=this._formatted),this.path&&(B.path=this.path),this.scheme&&(B.scheme=this.scheme),this.authority&&(B.authority=this.authority),this.query&&(B.query=this.query),this.fragment&&(B.fragment=this.fragment),B}}const v={[i.CharCode.Colon]:"%3A",[i.CharCode.Slash]:"%2F",[i.CharCode.QuestionMark]:"%3F",[i.CharCode.Hash]:"%23",[i.CharCode.OpenSquareBracket]:"%5B",[i.CharCode.CloseSquareBracket]:"%5D",[i.CharCode.AtSign]:"%40",[i.CharCode.ExclamationMark]:"%21",[i.CharCode.DollarSign]:"%24",[i.CharCode.Ampersand]:"%26",[i.CharCode.SingleQuote]:"%27",[i.CharCode.OpenParen]:"%28",[i.CharCode.CloseParen]:"%29",[i.CharCode.Asterisk]:"%2A",[i.CharCode.Plus]:"%2B",[i.CharCode.Comma]:"%2C",[i.CharCode.Semicolon]:"%3B",[i.CharCode.Equals]:"%3D",[i.CharCode.Space]:"%20"};function k(_,B,E){let I,z=-1;for(let O=0;O<_.length;O++){const C=_.charCodeAt(O);if(C>=i.CharCode.a&&C<=i.CharCode.z||C>=i.CharCode.A&&C<=i.CharCode.Z||C>=i.CharCode.Digit0&&C<=i.CharCode.Digit9||C===i.CharCode.Dash||C===i.CharCode.Period||C===i.CharCode.Underline||C===i.CharCode.Tilde||B&&C===i.CharCode.Slash||E&&C===i.CharCode.OpenSquareBracket||E&&C===i.CharCode.CloseSquareBracket||E&&C===i.CharCode.Colon)z!==-1&&(I+=encodeURIComponent(_.substring(z,O)),z=-1),I!==void 0&&(I+=_.charAt(O));else{I===void 0&&(I=_.substr(0,O));const x=v[C];x!==void 0?(z!==-1&&(I+=encodeURIComponent(_.substring(z,O)),z=-1),I+=x):z===-1&&(z=O)}}return z!==-1&&(I+=encodeURIComponent(_.substring(z))),I!==void 0?I:_}function A(_){let B;for(let E=0;E<_.length;E++){const I=_.charCodeAt(E);I===i.CharCode.Hash||I===i.CharCode.QuestionMark?(B===void 0&&(B=_.substr(0,E)),B+=v[I]):B!==void 0&&(B+=_[E])}return B!==void 0?B:_}function d(_,B){let E;return _.authority&&_.path.length>1&&_.scheme==="file"?E=`//${_.authority}${_.path}`:_.path.charCodeAt(0)===i.CharCode.Slash&&(_.path.charCodeAt(1)>=i.CharCode.A&&_.path.charCodeAt(1)<=i.CharCode.Z||_.path.charCodeAt(1)>=i.CharCode.a&&_.path.charCodeAt(1)<=i.CharCode.z)&&_.path.charCodeAt(2)===i.CharCode.Colon?B?E=_.path.substr(1):E=_.path[1].toLowerCase()+_.path.substr(2):E=_.path,F.$j&&(E=E.replace(/\//g,"\\")),E}function f(_,B){const E=B?A:k;let I="",{scheme:z,authority:O,path:C,query:x,fragment:Z}=_;if(z&&(I+=z,I+=":"),(O||z==="file")&&(I+=g,I+=g),O){let Y=O.indexOf("@");if(Y!==-1){const q=O.substr(0,Y);O=O.substr(Y+1),Y=q.lastIndexOf(":"),Y===-1?I+=E(q,!1,!1):(I+=E(q.substr(0,Y),!1,!1),I+=":",I+=E(q.substr(Y+1),!1,!0)),I+="@"}O=O.toLowerCase(),Y=O.lastIndexOf(":"),Y===-1?I+=E(O,!1,!0):(I+=E(O.substr(0,Y),!1,!0),I+=O.substr(Y))}if(C){if(C.length>=3&&C.charCodeAt(0)===i.CharCode.Slash&&C.charCodeAt(2)===i.CharCode.Colon){const Y=C.charCodeAt(1);Y>=i.CharCode.A&&Y<=i.CharCode.Z&&(C=`/${String.fromCharCode(Y+32)}:${C.substr(3)}`)}else if(C.length>=2&&C.charCodeAt(1)===i.CharCode.Colon){const Y=C.charCodeAt(0);Y>=i.CharCode.A&&Y<=i.CharCode.Z&&(C=`${String.fromCharCode(Y+32)}:${C.substr(2)}`)}I+=E(C,!0,!1)}return x&&(I+="?",I+=E(x,!1,!1)),Z&&(I+="#",I+=B?Z:k(Z,!1,!1)),I}function b(_){try{return decodeURIComponent(_)}catch{return _.length>3?_.substr(0,3)+b(_.substr(3)):_}}const S=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function U(_){return _.match(S)?_.replace(S,B=>b(B)):_}}),define(we[68],ve([1,0,47,16,60]),function(re,t,i,n,j){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$0h=F,t.$$h=N,t.$_h=D;function F(c){return JSON.stringify(c,w)}function N(c){let p=JSON.parse(c);return p=D(p),p}function w(c,p){return p instanceof RegExp?{$mid:j.MarshalledId.Regexp,source:p.source,flags:p.flags}:p}function D(c,p=0){if(!c||p>200)return c;if(typeof c=="object"){switch(c.$mid){case j.MarshalledId.Uri:return n.URI.revive(c);case j.MarshalledId.Regexp:return new RegExp(c.source,c.flags);case j.MarshalledId.Date:return new Date(c.source)}if(c instanceof i.$Le||c instanceof Uint8Array)return c;if(Array.isArray(c))for(let y=0;y<c.length;++y)c[y]=D(c[y],p+1);else for(const y in c)Object.hasOwnProperty.call(c,y)&&(c[y]=D(c[y],p+1))}return c}}),define(we[39],ve([1,0,6,5,11,16,28]),function(re,t,i,n,j,F,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.COI=t.$Wg=t.$Vg=t.$Ug=t.$Tg=t.$Sg=t.$Rg=t.$Pg=t.$Og=t.$Ng=t.Schemas=void 0,t.$Lg=D,t.$Mg=c,t.$Qg=y,i=He(i),n=He(n),N=He(N);var w;(function(e){e.inMemory="inmemory",e.vscode="vscode",e.internal="private",e.walkThrough="walkThrough",e.walkThroughSnippet="walkThroughSnippet",e.http="http",e.https="https",e.file="file",e.mailto="mailto",e.untitled="untitled",e.data="data",e.command="command",e.vscodeRemote="vscode-remote",e.vscodeRemoteResource="vscode-remote-resource",e.vscodeManagedRemoteResource="vscode-managed-remote-resource",e.vscodeUserData="vscode-userdata",e.vscodeCustomEditor="vscode-custom-editor",e.vscodeNotebookCell="vscode-notebook-cell",e.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",e.vscodeNotebookCellOutput="vscode-notebook-cell-output",e.vscodeInteractiveInput="vscode-interactive-input",e.vscodeSettings="vscode-settings",e.vscodeWorkspaceTrust="vscode-workspace-trust",e.vscodeTerminal="vscode-terminal",e.vscodeChatCodeBlock="vscode-chat-code-block",e.vscodeCopilotBackingChatCodeBlock="vscode-copilot-chat-code-block",e.vscodeChatCodeCompareBlock="vscode-chat-code-compare-block",e.vscodeChatSesssion="vscode-chat-editor",e.webviewPanel="webview-panel",e.vscodeWebview="vscode-webview",e.extension="extension",e.vscodeFileResource="vscode-file",e.tmp="tmp",e.vsls="vsls",e.vscodeSourceControl="vscode-scm",e.commentsInput="comment",e.codeSetting="code-setting"})(w||(t.Schemas=w={}));function D(e,s){return F.URI.isUri(e)?(0,j.$Df)(e.scheme,s):(0,j.$Ef)(e,s+":")}function c(e,...s){return s.some(r=>D(e,r))}t.$Ng="vscode-tkn",t.$Og="tkn";class p{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f="/"}setPreferredWebSchema(s){this.d=s}setDelegate(s){this.e=s}setServerRootPath(s,r){this.f=y(s,r)}getServerRootPath(){return this.f}get g(){return N.$fc.join(this.f,w.vscodeRemoteResource)}set(s,r,h){this.a[s]=r,this.b[s]=h}setConnectionToken(s,r){this.c[s]=r}getPreferredWebSchema(){return this.d}rewrite(s){if(this.e)try{return this.e(s)}catch(A){return i.$Y(A),s}const r=s.authority;let h=this.a[r];h&&h.indexOf(":")!==-1&&h.indexOf("[")===-1&&(h=`[${h}]`);const l=this.b[r],v=this.c[r];let k=`path=${encodeURIComponent(s.path)}`;return typeof v=="string"&&(k+=`&${t.$Og}=${encodeURIComponent(v)}`),F.URI.from({scheme:n.$p?this.d:w.vscodeRemoteResource,authority:`${h}:${l}`,path:this.g,query:k})}}t.$Pg=new p;function y(e,s){return N.$fc.join(s??"/",`${e.quality??"oss"}-${e.commit??"dev"}`)}t.$Rg="vs/../../extensions",t.$Sg="vs/../../node_modules",t.$Tg="vs/../../node_modules.asar",t.$Ug="vs/../../node_modules.asar.unpacked",t.$Vg="vscode-app";class ${static{this.a=t.$Vg}asBrowserUri(s){const r=this.b(s,re);return this.uriToBrowserUri(r)}uriToBrowserUri(s){return s.scheme===w.vscodeRemote?t.$Pg.rewrite(s):s.scheme===w.file&&(n.$n||n.$r===`${w.vscodeFileResource}://${$.a}`)?s.with({scheme:w.vscodeFileResource,authority:s.authority||$.a,query:null,fragment:null}):s}asFileUri(s){const r=this.b(s,re);return this.uriToFileUri(r)}uriToFileUri(s){return s.scheme===w.vscodeFileResource?s.with({scheme:w.file,authority:s.authority!==$.a?s.authority:null,query:null,fragment:null}):s}b(s,r){return F.URI.isUri(s)?s:F.URI.parse(r.toUrl(s))}}t.$Wg=new $;var g;(function(e){const s=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);e.CoopAndCoep=Object.freeze(s.get("3"));const r="vscode-coi";function h(v){let k;typeof v=="string"?k=new URL(v).searchParams:v instanceof URL?k=v.searchParams:F.URI.isUri(v)&&(k=new URL(v.toString(!0)).searchParams);const A=k?.get(r);if(A)return s.get(A)}e.getHeadersFromQuery=h;function l(v,k,A){if(!globalThis.crossOriginIsolated)return;const d=k&&A?"3":A?"2":"1";v instanceof URLSearchParams?v.set(r,d):v[r]=d}e.addSearchParam=l})(g||(t.COI=g={}))}),define(we[50],ve([1,0,17,108,39,28,5,11,16]),function(re,t,i,n,j,F,N,w,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DataUri=t.$lh=t.$kh=t.$jh=t.$ih=t.$hh=t.$gh=t.$fh=t.$eh=t.$dh=t.$ch=t.$bh=t.$ah=t.$_g=t.$$g=t.$0g=t.$9g=t.$8g=t.$7g=t.$6g=t.$5g=void 0,t.$4g=c,t.$mh=y,t.$nh=g,n=He(n),F=He(F);function c(e){return(0,D.$vc)(e,!0)}class p{constructor(s){this.a=s}compare(s,r,h=!1){return s===r?0:(0,w.$wf)(this.getComparisonKey(s,h),this.getComparisonKey(r,h))}isEqual(s,r,h=!1){return s===r?!0:!s||!r?!1:this.getComparisonKey(s,h)===this.getComparisonKey(r,h)}getComparisonKey(s,r=!1){return s.with({path:this.a(s)?s.path.toLowerCase():void 0,fragment:r?null:void 0}).toString()}ignorePathCasing(s){return this.a(s)}isEqualOrParent(s,r,h=!1){if(s.scheme===r.scheme){if(s.scheme===j.Schemas.file)return n.$Bg(c(s),c(r),this.a(s))&&s.query===r.query&&(h||s.fragment===r.fragment);if((0,t.$ih)(s.authority,r.authority))return n.$Bg(s.path,r.path,this.a(s),"/")&&s.query===r.query&&(h||s.fragment===r.fragment)}return!1}joinPath(s,...r){return D.URI.joinPath(s,...r)}basenameOrAuthority(s){return(0,t.$ah)(s)||s.authority}basename(s){return F.$fc.basename(s.path)}extname(s){return F.$fc.extname(s.path)}dirname(s){if(s.path.length===0)return s;let r;return s.scheme===j.Schemas.file?r=D.URI.file(F.$lc(c(s))).path:(r=F.$fc.dirname(s.path),s.authority&&r.length&&r.charCodeAt(0)!==i.CharCode.Slash&&(console.error(`dirname("${s.toString})) resulted in a relative path`),r="/")),s.with({path:r})}normalizePath(s){if(!s.path.length)return s;let r;return s.scheme===j.Schemas.file?r=D.URI.file(F.$gc(c(s))).path:r=F.$fc.normalize(s.path),s.with({path:r})}relativePath(s,r){if(s.scheme!==r.scheme||!(0,t.$ih)(s.authority,r.authority))return;if(s.scheme===j.Schemas.file){const v=F.$kc(c(s),c(r));return N.$j?n.$vg(v):v}let h=s.path||"/";const l=r.path||"/";if(this.a(s)){let v=0;for(const k=Math.min(h.length,l.length);v<k&&!(h.charCodeAt(v)!==l.charCodeAt(v)&&h.charAt(v).toLowerCase()!==l.charAt(v).toLowerCase());v++);h=l.substr(0,v)+h.substr(v)}return F.$fc.relative(h,l)}resolvePath(s,r){if(s.scheme===j.Schemas.file){const h=D.URI.file(F.$jc(c(s),r));return s.with({authority:h.authority,path:h.path})}return r=n.$wg(r),s.with({path:F.$fc.resolve(s.path,r)})}isAbsolutePath(s){return!!s.path&&s.path[0]==="/"}isEqualAuthority(s,r){return s===r||s!==void 0&&r!==void 0&&(0,w.$Df)(s,r)}hasTrailingPathSeparator(s,r=F.sep){if(s.scheme===j.Schemas.file){const h=c(s);return h.length>n.$xg(h).length&&h[h.length-1]===r}else{const h=s.path;return h.length>1&&h.charCodeAt(h.length-1)===i.CharCode.Slash&&!/^[a-zA-Z]:(\/$|\\$)/.test(s.fsPath)}}removeTrailingPathSeparator(s,r=F.sep){return(0,t.$jh)(s,r)?s.with({path:s.path.substr(0,s.path.length-1)}):s}addTrailingPathSeparator(s,r=F.sep){let h=!1;if(s.scheme===j.Schemas.file){const l=c(s);h=l!==void 0&&l.length===n.$xg(l).length&&l[l.length-1]===r}else{r="/";const l=s.path;h=l.length===1&&l.charCodeAt(l.length-1)===i.CharCode.Slash}return!h&&!(0,t.$jh)(s,r)?s.with({path:s.path+"/"}):s}}t.$5g=p,t.$6g=new p(()=>!1),t.$7g=new p(e=>e.scheme===j.Schemas.file?!N.$l:!0),t.$8g=new p(e=>!0),t.$9g=t.$6g.isEqual.bind(t.$6g),t.$0g=t.$6g.isEqualOrParent.bind(t.$6g),t.$$g=t.$6g.getComparisonKey.bind(t.$6g),t.$_g=t.$6g.basenameOrAuthority.bind(t.$6g),t.$ah=t.$6g.basename.bind(t.$6g),t.$bh=t.$6g.extname.bind(t.$6g),t.$ch=t.$6g.dirname.bind(t.$6g),t.$dh=t.$6g.joinPath.bind(t.$6g),t.$eh=t.$6g.normalizePath.bind(t.$6g),t.$fh=t.$6g.relativePath.bind(t.$6g),t.$gh=t.$6g.resolvePath.bind(t.$6g),t.$hh=t.$6g.isAbsolutePath.bind(t.$6g),t.$ih=t.$6g.isEqualAuthority.bind(t.$6g),t.$jh=t.$6g.hasTrailingPathSeparator.bind(t.$6g),t.$kh=t.$6g.removeTrailingPathSeparator.bind(t.$6g),t.$lh=t.$6g.addTrailingPathSeparator.bind(t.$6g);function y(e,s){const r=[];for(let h=0;h<e.length;h++){const l=s(e[h]);e.some((v,k)=>k===h?!1:(0,t.$0g)(l,s(v)))||r.push(e[h])}return r}var $;(function(e){e.META_DATA_LABEL="label",e.META_DATA_DESCRIPTION="description",e.META_DATA_SIZE="size",e.META_DATA_MIME="mime";function s(r){const h=new Map;r.path.substring(r.path.indexOf(";")+1,r.path.lastIndexOf(";")).split(";").forEach(k=>{const[A,d]=k.split(":");A&&d&&h.set(A,d)});const v=r.path.substring(0,r.path.indexOf(";"));return v&&h.set(e.META_DATA_MIME,v),h}e.parseMetaData=s})($||(t.DataUri=$={}));function g(e,s,r){if(s){let h=e.path;return h&&h[0]!==F.$fc.sep&&(h=F.$fc.sep+h),e.with({scheme:r,authority:s,path:h})}return e.with({scheme:r})}}),define(we[12],ve([1,0,38,6,3,2,50,5,63,25]),function(re,t,i,n,j,F,N,w,D,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$6h=t.$4h=t.$3h=t.$2h=t.$1h=t.Promises=t.$Zh=t.$Yh=t.$Xh=t.$Vh=t.$Uh=t.$Th=t.$Sh=t.$Rh=t.$Qh=t.$Ph=t.$Oh=t.$Nh=t.$Mh=t.$Lh=t.$Kh=t.$Jh=t.$Ih=t.$Ch=t.$Bh=t.$Ah=t.$zh=t.$yh=t.$xh=t.$wh=void 0,t.$oh=p,t.$ph=y,t.$qh=$,t.$rh=g,t.$sh=e,t.$th=s,t.$uh=r,t.$vh=h,t.$Dh=_,t.$Eh=B,t.$Fh=E,t.$Gh=I,t.$Hh=z,t.$Wh=Q,t.$5h=K;function p(a){return!!a&&typeof a.then=="function"}function y(a){const o=new i.$ue,m=a(o.token),M=new Promise((R,u)=>{const L=o.token.onCancellationRequested(()=>{L.dispose(),u(new n.$4)});Promise.resolve(m).then(T=>{L.dispose(),o.dispose(),R(T)},T=>{L.dispose(),o.dispose(),u(T)})});return new class{cancel(){o.cancel(),o.dispose()}then(R,u){return M.then(R,u)}catch(R){return this.then(void 0,R)}finally(R){return M.finally(R)}}}function $(a,o,m){return new Promise((M,R)=>{const u=o.onCancellationRequested(()=>{u.dispose(),M(m)});a.then(M,R).finally(()=>u.dispose())})}function g(a,o){return new Promise((m,M)=>{const R=o.onCancellationRequested(()=>{R.dispose(),M(new n.$4)});a.then(m,M).finally(()=>R.dispose())})}async function e(a){let o=-1;const m=a.map((M,R)=>M.then(u=>(o=R,u)));try{return await Promise.race(m)}finally{a.forEach((M,R)=>{R!==o&&M.cancel()})}}function s(a,o,m){let M;const R=setTimeout(()=>{M?.(void 0),m?.()},o);return Promise.race([a.finally(()=>clearTimeout(R)),new Promise(u=>M=u)])}function r(a){return new Promise((o,m)=>{const M=a();p(M)?M.then(o,m):o(M)})}function h(){let a,o;return{promise:new Promise((M,R)=>{a=M,o=R}),resolve:a,reject:o}}class l{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(o){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=o,!this.b){const m=()=>{if(this.b=null,this.f)return;const M=this.queue(this.d);return this.d=null,M};this.b=new Promise(M=>{this.a.then(m,m).then(M)})}return new Promise((m,M)=>{this.b.then(m,M)})}return this.a=o(),new Promise((m,M)=>{this.a.then(R=>{this.a=null,m(R)},R=>{this.a=null,M(R)})})}dispose(){this.f=!0}}t.$wh=l;class v{constructor(){this.a=Promise.resolve(null)}queue(o){return this.a=this.a.then(()=>o(),()=>o())}}t.$xh=v;class k{constructor(){this.a=new Map}queue(o,m){const R=(this.a.get(o)??Promise.resolve()).catch(()=>{}).then(m).finally(()=>{this.a.get(o)===R&&this.a.delete(o)});return this.a.set(o,R),R}}t.$yh=k;const A=(a,o)=>{let m=!0;const M=setTimeout(()=>{m=!1,o()},a);return{isTriggered:()=>m,dispose:()=>{clearTimeout(M),m=!1}}},d=a=>{let o=!0;return queueMicrotask(()=>{o&&(o=!1,a())}),{isTriggered:()=>o,dispose:()=>{o=!1}}};class f{constructor(o){this.defaultDelay=o,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(o,m=this.defaultDelay){this.g=o,this.h(),this.b||(this.b=new Promise((R,u)=>{this.d=R,this.f=u}).then(()=>{if(this.b=null,this.d=null,this.g){const R=this.g;return this.g=null,R()}}));const M=()=>{this.a=null,this.d?.(null)};return this.a=m===D.$ee?d(M):A(m,M),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new n.$4),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}t.$zh=f;class b{constructor(o){this.a=new f(o),this.b=new l}trigger(o,m){return this.a.trigger(()=>this.b.queue(o),m)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}t.$Ah=b;class S{constructor(){this.a=!1,this.b=new Promise((o,m)=>{this.d=o})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}t.$Bh=S;class U extends S{constructor(o){super(),this.f=setTimeout(()=>this.open(),o)}open(){clearTimeout(this.f),super.open()}}t.$Ch=U;function _(a,o){return o?new Promise((m,M)=>{const R=setTimeout(()=>{u.dispose(),m()},a),u=o.onCancellationRequested(()=>{clearTimeout(R),u.dispose(),M(new n.$4)})}):y(m=>_(a,m))}function B(a,o=0,m){const M=setTimeout(()=>{a(),m&&R.dispose()},o),R=(0,F.$Rc)(()=>{clearTimeout(M),m?.deleteAndLeak(R)});return m?.add(R),R}function E(a){const o=[];let m=0;const M=a.length;function R(){return m<M?a[m++]():null}function u(L){L!=null&&o.push(L);const T=R();return T?T.then(u):Promise.resolve(o)}return Promise.resolve(null).then(u)}function I(a,o=M=>!!M,m=null){let M=0;const R=a.length,u=()=>{if(M>=R)return Promise.resolve(m);const L=a[M++];return Promise.resolve(L()).then(P=>o(P)?Promise.resolve(P):u())};return u()}function z(a,o=M=>!!M,m=null){if(a.length===0)return Promise.resolve(m);let M=a.length;const R=()=>{M=-1;for(const u of a)u.cancel?.()};return new Promise((u,L)=>{for(const T of a)T.then(P=>{--M>=0&&o(P)?(R(),u(P)):M===0&&u(m)}).catch(P=>{--M>=0&&(R(),L(P))})})}class O{constructor(o){this.a=0,this.b=!1,this.f=o,this.g=[],this.d=0,this.h=new j.$je}whenIdle(){return this.size>0?j.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(o){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((m,M)=>{this.g.push({factory:o,c:m,e:M}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const o=this.g.shift();this.d++;const m=o.factory();m.then(o.c,o.e),m.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}t.$Ih=O;class C extends O{constructor(){super(1)}}t.$Jh=C;class x{constructor(){this.a=new he,this.b=0}queue(o){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,o())):this.a.run(this.b++,o())}}t.$Kh=x;class Z{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const o=new te;return this.b.add(o),o.p}g(){for(const[,o]of this.a)if(o.size>0)return!1;return!0}queueSize(o,m=N.$6g){const M=m.getComparisonKey(o);return this.a.get(M)?.size??0}queueFor(o,m,M=N.$6g){const R=M.getComparisonKey(o);let u=this.a.get(R);if(!u){u=new C;const L=this.f++,T=j.Event.once(u.onDrained)(()=>{u?.dispose(),this.a.delete(R),this.h(),this.d?.deleteAndDispose(L),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new F.$3c),this.d.set(L,T),this.a.set(R,u)}return u.queue(m)}h(){this.g()&&this.j()}j(){for(const o of this.b)o.complete();this.b.clear()}dispose(){for(const[,o]of this.a)o.dispose();this.a.clear(),this.j(),this.d?.dispose()}}t.$Lh=Z;class Y{constructor(o,m){this.b=!1,this.a=-1,typeof o=="function"&&typeof m=="number"&&this.setIfNotSet(o,m)}dispose(){this.cancel(),this.b=!0}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(o,m){if(this.b)throw new n.$bb("Calling 'cancelAndSet' on a disposed TimeoutTimer");this.cancel(),this.a=setTimeout(()=>{this.a=-1,o()},m)}setIfNotSet(o,m){if(this.b)throw new n.$bb("Calling 'setIfNotSet' on a disposed TimeoutTimer");this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,o()},m))}}t.$Mh=Y;class q{constructor(){this.d=void 0,this.f=!1}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(o,m,M=globalThis){if(this.f)throw new n.$bb("Calling 'cancelAndSet' on a disposed IntervalTimer");this.cancel();const R=M.setInterval(()=>{o()},m);this.d=(0,F.$Rc)(()=>{M.clearInterval(R),this.d=void 0})}dispose(){this.cancel(),this.f=!0}}t.$Nh=q;class ee{constructor(o,m){this.b=-1,this.a=o,this.d=m,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(o=this.d){this.cancel(),this.b=setTimeout(this.f,o)}get delay(){return this.d}set delay(o){this.d=o}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}t.$Oh=ee;class ce{constructor(o,m){m%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${m}ms is not a multiple of 1000ms.`),this.a=o,this.b=m,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(o=this.b){o%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${o}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(o/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}t.$Ph=ce;class be extends ee{constructor(o,m){super(o,m),this.j=[]}work(o){this.j.push(o),this.isScheduled()||this.schedule()}h(){const o=this.j;this.j=[],this.a?.(o)}dispose(){this.j=[],super.dispose()}}t.$Qh=be;class ke extends F.$Tc{constructor(o,m){super(),this.g=o,this.h=m,this.a=[],this.b=this.B(new F.$Uc),this.f=!1}get pending(){return this.a.length}work(o){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+o.length>this.g.maxBufferedWork)return!1}else if(this.pending+o.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const m of o)this.a.push(m);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new ee(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}t.$Rh=ke,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?t.$Th=(a,o)=>{(0,w.$C)(()=>{if(m)return;const M=Date.now()+15;o(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,M-Date.now())}}))});let m=!1;return{dispose(){m||(m=!0)}}}:t.$Th=(a,o,m)=>{const M=a.requestIdleCallback(o,typeof m=="number"?{timeout:m}:void 0);let R=!1;return{dispose(){R||(R=!0,a.cancelIdleCallback(M))}}},t.$Sh=a=>(0,t.$Th)(globalThis,a)}();class Fe{constructor(o,m){this.g=!1,this.d=()=>{try{this.j=m()}catch(M){this.l=M}finally{this.g=!0}},this.f=(0,t.$Th)(o,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}t.$Uh=Fe;class ue extends Fe{constructor(o){super(globalThis,o)}}t.$Vh=ue;async function Q(a,o,m){let M;for(let R=0;R<m;R++)try{return await a()}catch(u){M=u,await _(o)}throw M}class he{isRunning(o){return typeof o=="number"?this.a?.taskId===o:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(o,m,M){return this.a={taskId:o,cancel:()=>M?.(),promise:m},m.then(()=>this.d(o),()=>this.d(o)),m}d(o){this.a&&o===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const o=this.b;this.b=void 0,o.run().then(o.promiseResolve,o.promiseReject)}}queue(o){if(this.b)this.b.run=o;else{const{promise:m,resolve:M,reject:R}=h();this.b={run:o,promise:m,promiseResolve:M,promiseReject:R}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}t.$Xh=he;class le{constructor(o,m=()=>Date.now()){this.d=o,this.f=m,this.a=0,this.b=0}increment(){const o=this.f();return o-this.a>this.d&&(this.a=o,this.b=0),this.b++,this.b}}t.$Yh=le;var Ne;(function(a){a[a.Resolved=0]="Resolved",a[a.Rejected=1]="Rejected"})(Ne||(Ne={}));class te{get isRejected(){return this.d?.outcome===Ne.Rejected}get isResolved(){return this.d?.outcome===Ne.Resolved}get isSettled(){return!!this.d}get value(){return this.d?.outcome===Ne.Resolved?this.d?.value:void 0}constructor(){this.p=new Promise((o,m)=>{this.a=o,this.b=m})}complete(o){return new Promise(m=>{this.a(o),this.d={outcome:Ne.Resolved,value:o},m()})}error(o){return new Promise(m=>{this.b(o),this.d={outcome:Ne.Rejected,value:o},m()})}cancel(){return this.error(new n.$4)}}t.$Zh=te;var $e;(function(a){async function o(M){let R;const u=await Promise.all(M.map(L=>L.then(T=>T,T=>{R||(R=T)})));if(typeof R<"u")throw R;return u}a.settled=o;function m(M){return new Promise(async(R,u)=>{try{await M(R,u)}catch(L){u(L)}})}a.withAsyncBody=m})($e||(t.Promises=$e={}));class Ae{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(o){this.a=void 0,this.b=void 0,this.d=!1,this.promise=o.then(m=>(this.a=m,this.d=!0,m),m=>{throw this.b=m,this.d=!0,m})}requireValue(){if(!this.d)throw new n.$bb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}t.$1h=Ae;class Oe{constructor(o){this.b=o,this.a=new c.$T(()=>new Ae(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}t.$2h=Oe;var Ie;(function(a){a[a.Initial=0]="Initial",a[a.DoneOK=1]="DoneOK",a[a.DoneError=2]="DoneError"})(Ie||(Ie={}));class Ce{static fromArray(o){return new Ce(m=>{m.emitMany(o)})}static fromPromise(o){return new Ce(async m=>{m.emitMany(await o)})}static fromPromises(o){return new Ce(async m=>{await Promise.all(o.map(async M=>m.emitOne(await M)))})}static merge(o){return new Ce(async m=>{await Promise.all(o.map(async M=>{for await(const R of M)m.emitOne(R)}))})}static{this.EMPTY=Ce.fromArray([])}constructor(o,m){this.a=Ie.Initial,this.b=[],this.d=null,this.f=m,this.g=new j.$je,queueMicrotask(async()=>{const M={emitOne:R=>this.h(R),emitMany:R=>this.j(R),reject:R=>this.l(R)};try{await Promise.resolve(o(M)),this.k()}catch(R){this.l(R)}finally{M.emitOne=void 0,M.emitMany=void 0,M.reject=void 0}})}[Symbol.asyncIterator](){let o=0;return{next:async()=>{do{if(this.a===Ie.DoneError)throw this.d;if(o<this.b.length)return{done:!1,value:this.b[o++]};if(this.a===Ie.DoneOK)return{done:!0,value:void 0};await j.Event.toPromise(this.g.event)}while(!0)},return:async()=>(this.f?.(),{done:!0,value:void 0})}}static map(o,m){return new Ce(async M=>{for await(const R of o)M.emitOne(m(R))})}map(o){return Ce.map(this,o)}static filter(o,m){return new Ce(async M=>{for await(const R of o)m(R)&&M.emitOne(R)})}filter(o){return Ce.filter(this,o)}static coalesce(o){return Ce.filter(o,m=>!!m)}coalesce(){return Ce.coalesce(this)}static async toPromise(o){const m=[];for await(const M of o)m.push(M);return m}toPromise(){return Ce.toPromise(this)}h(o){this.a===Ie.Initial&&(this.b.push(o),this.g.fire())}j(o){this.a===Ie.Initial&&(this.b=this.b.concat(o),this.g.fire())}k(){this.a===Ie.Initial&&(this.a=Ie.DoneOK,this.g.fire())}l(o){this.a===Ie.Initial&&(this.a=Ie.DoneError,this.d=o,this.g.fire())}}t.$3h=Ce;class se extends Ce{constructor(o,m){super(m),this.m=o}cancel(){this.m.cancel()}}t.$4h=se;function K(a){const o=new i.$ue,m=a(o.token);return new se(o,async M=>{const R=o.token.onCancellationRequested(()=>{R.dispose(),o.dispose(),M.reject(new n.$4)});try{for await(const u of m){if(o.token.isCancellationRequested)return;M.emitOne(u)}R.dispose(),o.dispose()}catch(u){R.dispose(),o.dispose(),M.reject(u)}})}class W{constructor(o){this.a=new te,this.b=new Ce(R=>{if(m){R.reject(m);return}return M&&R.emitMany(M),this.d=u=>R.reject(u),this.f=u=>R.emitOne(u),this.a.p},o);let m,M;this.f=R=>{M||(M=[]),M.push(R)},this.d=R=>{m||(m=R)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(o){this.d(o),this.a.complete()}emitOne(o){this.f(o)}}t.$6h=W}),define(we[4],ve([1,0,18,61,15,19,12,6,3,111,8,2,39,5,16,66,24,37]),function(re,t,i,n,j,F,N,w,D,c,p,y,$,g,e,s,r,h){"use strict";var l;Object.defineProperty(t,"__esModule",{value:!0}),t.$8T=t.$3T=t.$1T=t.$XT=t.DetectedFullscreenMode=t.Namespace=t.$vT=t.$tT=t.$cT=t.$KS=t.$ES=t.$CS=t.$BS=t.$AS=t.$vS=t.$uS=t.$tS=t.onDidUnregisterWindow=t.onWillUnregisterWindow=t.onDidRegisterWindow=t.hasWindow=t.getWindowById=t.getWindowId=t.getWindowsCount=t.getWindows=t.getDocument=t.getWindow=t.registerWindow=void 0,t.$qS=v,t.$rS=k,t.$sS=d,t.$wS=B,t.$xS=E,t.$yS=I,t.$zS=z,t.$DS=C,t.$FS=Y,t.$GS=q,t.$HS=ke,t.$IS=Fe,t.$JS=ue,t.$LS=le,t.$MS=Ne,t.$NS=te,t.$OS=$e,t.$PS=Ae,t.$QS=Oe,t.$RS=Ie,t.$SS=Ce,t.$TS=se,t.$US=K,t.$VS=a,t.$WS=o,t.$XS=M,t.$YS=u,t.$ZS=L,t.$1S=T,t.$2S=P,t.$3S=H,t.$4S=X,t.$5S=ie,t.$6S=oe,t.$7S=de,t.$8S=ye,t.$9S=De,t.$0S=Le,t.$$S=fe,t.$_S=Re,t.$aT=Ze,t.$bT=tt,t.$dT=st,t.$eT=Ge,t.$fT=Se,t.$gT=Pe,t.$hT=Xe,t.$iT=rt,t.$jT=it,t.$kT=ht,t.$lT=nt,t.$mT=ft,t.$nT=ct,t.$oT=wt,t.$pT=Ue,t.$qT=ge,t.$rT=Me,t.$sT=We,t.$uT=Ye,t.$wT=ot,t.$xT=dt,t.$yT=bt,t.$zT=Tt,t.$AT=kt,t.$BT=Jt,t.$CT=Oi,t.$=ei,t.$ET=ji,t.$FT=Pi,t.$GT=ti,t.$HT=ii,t.$IT=Bi,t.$JT=Ci,t.$KT=_i,t.$LT=Ui,t.$MT=Hi,t.$NT=xi,t.$OT=zi,t.$PT=Vi,t.$QT=Ki,t.$RT=qi,t.$ST=ri,t.$TT=Gi,t.$UT=Xi,t.$VT=Yi,t.$WT=oi,t.$YT=Qi,t.$ZT=tn,t.$2T=nn,t.h=rn,t.$5T=on,t.$6T=ai,t.$7T=an,i=He(i),D=He(D),c=He(c),g=He(g),l=function(){const V=new Map;(0,r.$VR)(r.$WR,1);const G={window:r.$WR,disposables:new y.$Sc};V.set(r.$WR.vscodeWindowId,G);const ne=new D.$je,me=new D.$je,Ee=new D.$je;function Be(je,Ve){return(typeof je=="number"?V.get(je):void 0)??(Ve?G:void 0)}return{onDidRegisterWindow:ne.event,onWillUnregisterWindow:Ee.event,onDidUnregisterWindow:me.event,registerWindow(je){if(V.has(je.vscodeWindowId))return y.$Tc.None;const Ve=new y.$Sc,xe={window:je,disposables:Ve.add(new y.$Sc)};return V.set(je.vscodeWindowId,xe),Ve.add((0,y.$Rc)(()=>{V.delete(je.vscodeWindowId),me.fire(je)})),Ve.add(d(je,t.$tT.BEFORE_UNLOAD,()=>{Ee.fire(je)})),ne.fire(xe),Ve},getWindows(){return V.values()},getWindowsCount(){return V.size},getWindowId(je){return je.vscodeWindowId},hasWindow(je){return V.has(je)},getWindowById:Be,getWindow(je){const Ve=je;if(Ve?.ownerDocument?.defaultView)return Ve.ownerDocument.defaultView.window;const xe=je;return xe?.view?xe.view.window:r.$WR},getDocument(je){const Ve=je;return(0,t.getWindow)(Ve).document}}}(),t.registerWindow=l.registerWindow,t.getWindow=l.getWindow,t.getDocument=l.getDocument,t.getWindows=l.getWindows,t.getWindowsCount=l.getWindowsCount,t.getWindowId=l.getWindowId,t.getWindowById=l.getWindowById,t.hasWindow=l.hasWindow,t.onDidRegisterWindow=l.onDidRegisterWindow,t.onWillUnregisterWindow=l.onWillUnregisterWindow,t.onDidUnregisterWindow=l.onDidUnregisterWindow;function v(V){for(;V.firstChild;)V.firstChild.remove()}function k(V){for(;V.firstChild;){const G=V.firstChild;G.remove(),k(G)}}class A{constructor(G,ne,me,Ee){this.f=G,this.g=ne,this.d=me,this.j=Ee||!1,this.f.addEventListener(this.g,this.d,this.j)}dispose(){this.d&&(this.f.removeEventListener(this.g,this.d,this.j),this.f=null,this.d=null)}}function d(V,G,ne,me){return new A(V,G,ne,me)}function f(V,G){return function(ne){return G(new F.$jS(V,ne))}}function b(V){return function(G){return V(new j.$oS(G))}}const S=function(G,ne,me,Ee){let Be=me;return ne==="click"||ne==="mousedown"||ne==="contextmenu"?Be=f((0,t.getWindow)(G),me):(ne==="keydown"||ne==="keypress"||ne==="keyup")&&(Be=b(me)),d(G,ne,Be,Ee)};t.$tS=S;const U=function(G,ne,me){const Ee=f((0,t.getWindow)(G),ne);return B(G,Ee,me)};t.$uS=U;const _=function(G,ne,me){const Ee=f((0,t.getWindow)(G),ne);return I(G,Ee,me)};t.$vS=_;function B(V,G,ne){return d(V,g.$s&&n.$gS.pointerEvents?t.$tT.POINTER_DOWN:t.$tT.MOUSE_DOWN,G,ne)}function E(V,G,ne){return d(V,g.$s&&n.$gS.pointerEvents?t.$tT.POINTER_MOVE:t.$tT.MOUSE_MOVE,G,ne)}function I(V,G,ne){return d(V,g.$s&&n.$gS.pointerEvents?t.$tT.POINTER_UP:t.$tT.MOUSE_UP,G,ne)}function z(V,G,ne){return(0,N.$Th)(V,G,ne)}class O extends N.$Uh{constructor(G,ne){super(G,ne)}}t.$AS=O;function C(V,G,ne,me){let Ee=0;const Be=V.setInterval(()=>{Ee++,(typeof me=="number"&&Ee>=me||G()===!0)&&je.dispose()},ne),je=(0,y.$Rc)(()=>{V.clearInterval(Be)});return je}class x extends N.$Nh{constructor(G){super(),this.g=G&&(0,t.getWindow)(G)}cancelAndSet(G,ne,me){return super.cancelAndSet(G,ne,me??this.g)}}t.$ES=x;class Z{constructor(G,ne=0){this.d=G,this.priority=ne,this.f=!1}dispose(){this.f=!0}execute(){if(!this.f)try{this.d()}catch(G){(0,w.$Y)(G)}}static sort(G,ne){return ne.priority-G.priority}}(function(){const V=new Map,G=new Map,ne=new Map,me=new Map,Ee=Be=>{ne.set(Be,!1);const je=V.get(Be)??[];for(G.set(Be,je),V.set(Be,[]),me.set(Be,!0);je.length>0;)je.sort(Z.sort),je.shift().execute();me.set(Be,!1)};t.$CS=(Be,je,Ve=0)=>{const xe=(0,t.getWindowId)(Be),_e=new Z(je,Ve);let lt=V.get(xe);return lt||(lt=[],V.set(xe,lt)),lt.push(_e),ne.get(xe)||(ne.set(xe,!0),Be.requestAnimationFrame(()=>Ee(xe))),_e},t.$BS=(Be,je,Ve)=>{const xe=(0,t.getWindowId)(Be);if(me.get(xe)){const _e=new Z(je,Ve);let lt=G.get(xe);return lt||(lt=[],G.set(xe,lt)),lt.push(_e),_e}else return(0,t.$CS)(Be,je,Ve)}})();function Y(V,G){return(0,t.$CS)(V,G,1e4)}function q(V,G){return(0,t.$CS)(V,G,-1e4)}const ee=8,ce=function(V,G){return G};class be extends y.$Tc{constructor(G,ne,me,Ee=ce,Be=ee){super();let je=null,Ve=0;const xe=this.B(new N.$Mh),_e=()=>{Ve=new Date().getTime(),me(je),je=null};this.B(d(G,ne,lt=>{je=Ee(je,lt);const yt=new Date().getTime()-Ve;yt>=Be?(xe.cancel(),_e()):xe.setIfNotSet(_e,Be-yt)}))}}function ke(V,G,ne,me,Ee){return new be(V,G,ne,me,Ee)}function Fe(V){return(0,t.getWindow)(V).getComputedStyle(V,null)}function ue(V,G){const ne=(0,t.getWindow)(V),me=ne.document;if(V!==me.body)return new he(V.clientWidth,V.clientHeight);if(g.$s&&ne?.visualViewport)return new he(ne.visualViewport.width,ne.visualViewport.height);if(ne?.innerWidth&&ne.innerHeight)return new he(ne.innerWidth,ne.innerHeight);if(me.body&&me.body.clientWidth&&me.body.clientHeight)return new he(me.body.clientWidth,me.body.clientHeight);if(me.documentElement&&me.documentElement.clientWidth&&me.documentElement.clientHeight)return new he(me.documentElement.clientWidth,me.documentElement.clientHeight);if(G)return ue(G);throw new Error("Unable to figure out browser width and height")}class Q{static d(G,ne){return parseFloat(ne)||0}static f(G,ne,me){const Ee=Fe(G),Be=Ee?Ee.getPropertyValue(ne):"0";return Q.d(G,Be)}static getBorderLeftWidth(G){return Q.f(G,"border-left-width","borderLeftWidth")}static getBorderRightWidth(G){return Q.f(G,"border-right-width","borderRightWidth")}static getBorderTopWidth(G){return Q.f(G,"border-top-width","borderTopWidth")}static getBorderBottomWidth(G){return Q.f(G,"border-bottom-width","borderBottomWidth")}static getPaddingLeft(G){return Q.f(G,"padding-left","paddingLeft")}static getPaddingRight(G){return Q.f(G,"padding-right","paddingRight")}static getPaddingTop(G){return Q.f(G,"padding-top","paddingTop")}static getPaddingBottom(G){return Q.f(G,"padding-bottom","paddingBottom")}static getMarginLeft(G){return Q.f(G,"margin-left","marginLeft")}static getMarginTop(G){return Q.f(G,"margin-top","marginTop")}static getMarginRight(G){return Q.f(G,"margin-right","marginRight")}static getMarginBottom(G){return Q.f(G,"margin-bottom","marginBottom")}}class he{static{this.None=new he(0,0)}constructor(G,ne){this.width=G,this.height=ne}with(G=this.width,ne=this.height){return G!==this.width||ne!==this.height?new he(G,ne):this}static is(G){return typeof G=="object"&&typeof G.height=="number"&&typeof G.width=="number"}static lift(G){return G instanceof he?G:new he(G.width,G.height)}static equals(G,ne){return G===ne?!0:!G||!ne?!1:G.width===ne.width&&G.height===ne.height}}t.$KS=he;function le(V){let G=V.offsetParent,ne=V.offsetTop,me=V.offsetLeft;for(;(V=V.parentNode)!==null&&V!==V.ownerDocument.body&&V!==V.ownerDocument.documentElement;){ne-=V.scrollTop;const Ee=P(V)?null:Fe(V);Ee&&(me-=Ee.direction!=="rtl"?V.scrollLeft:-V.scrollLeft),V===G&&(me+=Q.getBorderLeftWidth(V),ne+=Q.getBorderTopWidth(V),ne+=V.offsetTop,me+=V.offsetLeft,G=V.offsetParent)}return{left:me,top:ne}}function Ne(V,G,ne){typeof G=="number"&&(V.style.width=`${G}px`),typeof ne=="number"&&(V.style.height=`${ne}px`)}function te(V,G,ne,me,Ee,Be="absolute"){typeof G=="number"&&(V.style.top=`${G}px`),typeof ne=="number"&&(V.style.right=`${ne}px`),typeof me=="number"&&(V.style.bottom=`${me}px`),typeof Ee=="number"&&(V.style.left=`${Ee}px`),V.style.position=Be}function $e(V){const G=V.getBoundingClientRect(),ne=(0,t.getWindow)(V);return{left:G.left+ne.scrollX,top:G.top+ne.scrollY,width:G.width,height:G.height}}function Ae(V){let G=V,ne=1;do{const me=Fe(G).zoom;me!=null&&me!=="1"&&(ne*=me),G=G.parentElement}while(G!==null&&G!==G.ownerDocument.documentElement);return ne}function Oe(V){const G=Q.getMarginLeft(V)+Q.getMarginRight(V);return V.offsetWidth+G}function Ie(V){const G=Q.getBorderLeftWidth(V)+Q.getBorderRightWidth(V),ne=Q.getPaddingLeft(V)+Q.getPaddingRight(V);return V.offsetWidth-G-ne}function Ce(V){const G=Q.getMarginLeft(V)+Q.getMarginRight(V);return V.scrollWidth+G}function se(V){const G=Q.getBorderTopWidth(V)+Q.getBorderBottomWidth(V),ne=Q.getPaddingTop(V)+Q.getPaddingBottom(V);return V.offsetHeight-G-ne}function K(V){const G=Q.getMarginTop(V)+Q.getMarginBottom(V);return V.offsetHeight+G}function W(V,G){if(V===null)return 0;const ne=le(V),me=le(G);return ne.left-me.left}function a(V,G){const ne=G.map(Ee=>Math.max(Ce(Ee),Oe(Ee))+W(Ee,V)||0);return Math.max(...ne)}function o(V,G){return!!G?.contains(V)}const m="parentFlowToElementId";function M(V,G){V.dataset[m]=G.id}function R(V){const G=V.dataset[m];return typeof G=="string"?V.ownerDocument.getElementById(G):null}function u(V,G){let ne=V;for(;ne;){if(ne===G)return!0;if(Xe(ne)){const me=R(ne);if(me){ne=me;continue}}ne=ne.parentNode}return!1}function L(V,G,ne){for(;V&&V.nodeType===V.ELEMENT_NODE;){if(V.classList.contains(G))return V;if(ne){if(typeof ne=="string"){if(V.classList.contains(ne))return null}else if(V===ne)return null}V=V.parentNode}return null}function T(V,G,ne){return!!L(V,G,ne)}function P(V){return V&&!!V.host&&!!V.mode}function H(V){return!!X(V)}function X(V){for(;V.parentNode;){if(V===V.ownerDocument?.body)return null;V=V.parentNode}return P(V)?V:null}function ie(){let V=De().activeElement;for(;V?.shadowRoot;)V=V.shadowRoot.activeElement;return V}function oe(V){return ie()===V}function de(V){return o(ie(),V)}function ye(V){return V.ownerDocument===De()}function De(){return(0,t.getWindowsCount)()<=1?r.$WR.document:Array.from((0,t.getWindows)()).map(({window:G})=>G.document).find(G=>G.hasFocus())??r.$WR.document}function Le(){return De().defaultView?.window??r.$WR}const Te=new Map;function fe(V){return Te.has(V)}function Re(){return new Ke}class Ke{constructor(){this.d="",this.f=void 0}setStyle(G){G!==this.d&&(this.d=G,this.f?this.f.innerText=G:this.f=Ze(r.$WR.document.head,ne=>ne.innerText=G))}dispose(){this.f&&(this.f.remove(),this.f=void 0)}}function Ze(V=r.$WR.document.head,G,ne){const me=document.createElement("style");if(me.type="text/css",me.media="screen",G?.(me),V.appendChild(me),ne&&ne.add((0,y.$Rc)(()=>me.remove())),V===r.$WR.document.head){const Ee=new Set;Te.set(me,Ee);for(const{window:Be,disposables:je}of(0,t.getWindows)()){if(Be===r.$WR)continue;const Ve=je.add(at(me,Ee,Be));ne?.add(Ve)}}return me}function tt(V){const G=new y.$Sc;for(const[ne,me]of Te)G.add(at(ne,me,V));return G}function at(V,G,ne){const me=new y.$Sc,Ee=V.cloneNode(!0);ne.document.head.appendChild(Ee),me.add((0,y.$Rc)(()=>Ee.remove()));for(const Be of pe(V))Ee.sheet?.insertRule(Be.cssText,Ee.sheet?.cssRules.length);return me.add(t.$cT.observe(V,me,{childList:!0})(()=>{Ee.textContent=V.textContent})),G.add(Ee),me.add((0,y.$Rc)(()=>G.delete(Ee))),me}t.$cT=new class{constructor(){this.mutationObservers=new Map}observe(V,G,ne){let me=this.mutationObservers.get(V);me||(me=new Map,this.mutationObservers.set(V,me));const Ee=(0,s.$qj)(ne);let Be=me.get(Ee);if(Be)Be.users+=1;else{const je=new D.$je,Ve=new MutationObserver(_e=>je.fire(_e));Ve.observe(V,ne);const xe=Be={users:1,observer:Ve,onDidMutate:je.event};G.add((0,y.$Rc)(()=>{xe.users-=1,xe.users===0&&(je.dispose(),Ve.disconnect(),me?.delete(Ee),me?.size===0&&this.mutationObservers.delete(V))})),me.set(Ee,Be)}return Be.onDidMutate}};function st(V=r.$WR.document.head){return Qe("meta",V)}function Ge(V=r.$WR.document.head){return Qe("link",V)}function Qe(V,G=r.$WR.document.head){const ne=document.createElement(V);return G.appendChild(ne),ne}let J=null;function ae(){return J||(J=Ze()),J}function pe(V){return V?.sheet?.rules?V.sheet.rules:V?.sheet?.cssRules?V.sheet.cssRules:[]}function Se(V,G,ne=ae()){if(!(!ne||!G)){ne.sheet?.insertRule(`${V} {${G}}`,0);for(const me of Te.get(ne)??[])Se(V,G,me)}}function Pe(V,G=ae()){if(!G)return;const ne=pe(G),me=[];for(let Ee=0;Ee<ne.length;Ee++){const Be=ne[Ee];ze(Be)&&Be.selectorText.indexOf(V)!==-1&&me.push(Ee)}for(let Ee=me.length-1;Ee>=0;Ee--)G.sheet?.deleteRule(me[Ee]);for(const Ee of Te.get(G)??[])Pe(V,Ee)}function ze(V){return typeof V.selectorText=="string"}function Xe(V){return V instanceof HTMLElement||V instanceof(0,t.getWindow)(V).HTMLElement}function rt(V){return V instanceof HTMLAnchorElement||V instanceof(0,t.getWindow)(V).HTMLAnchorElement}function it(V){return V instanceof HTMLSpanElement||V instanceof(0,t.getWindow)(V).HTMLSpanElement}function ht(V){return V instanceof HTMLTextAreaElement||V instanceof(0,t.getWindow)(V).HTMLTextAreaElement}function nt(V){return V instanceof HTMLInputElement||V instanceof(0,t.getWindow)(V).HTMLInputElement}function ft(V){return V instanceof HTMLButtonElement||V instanceof(0,t.getWindow)(V).HTMLButtonElement}function ct(V){return V instanceof HTMLDivElement||V instanceof(0,t.getWindow)(V).HTMLDivElement}function wt(V){return V instanceof SVGElement||V instanceof(0,t.getWindow)(V).SVGElement}function Ue(V){return V instanceof MouseEvent||V instanceof(0,t.getWindow)(V).MouseEvent}function ge(V){return V instanceof KeyboardEvent||V instanceof(0,t.getWindow)(V).KeyboardEvent}function Me(V){return V instanceof PointerEvent||V instanceof(0,t.getWindow)(V).PointerEvent}function We(V){return V instanceof DragEvent||V instanceof(0,t.getWindow)(V).DragEvent}t.$tT={CLICK:"click",AUXCLICK:"auxclick",DBLCLICK:"dblclick",MOUSE_UP:"mouseup",MOUSE_DOWN:"mousedown",MOUSE_OVER:"mouseover",MOUSE_MOVE:"mousemove",MOUSE_OUT:"mouseout",MOUSE_ENTER:"mouseenter",MOUSE_LEAVE:"mouseleave",MOUSE_WHEEL:"wheel",POINTER_UP:"pointerup",POINTER_DOWN:"pointerdown",POINTER_MOVE:"pointermove",POINTER_LEAVE:"pointerleave",CONTEXT_MENU:"contextmenu",WHEEL:"wheel",KEY_DOWN:"keydown",KEY_PRESS:"keypress",KEY_UP:"keyup",LOAD:"load",BEFORE_UNLOAD:"beforeunload",UNLOAD:"unload",PAGE_SHOW:"pageshow",PAGE_HIDE:"pagehide",PASTE:"paste",ABORT:"abort",ERROR:"error",RESIZE:"resize",SCROLL:"scroll",FULLSCREEN_CHANGE:"fullscreenchange",WK_FULLSCREEN_CHANGE:"webkitfullscreenchange",SELECT:"select",CHANGE:"change",SUBMIT:"submit",RESET:"reset",FOCUS:"focus",FOCUS_IN:"focusin",FOCUS_OUT:"focusout",BLUR:"blur",INPUT:"input",STORAGE:"storage",DRAG_START:"dragstart",DRAG:"drag",DRAG_ENTER:"dragenter",DRAG_LEAVE:"dragleave",DRAG_OVER:"dragover",DROP:"drop",DRAG_END:"dragend",ANIMATION_START:i.$0R?"webkitAnimationStart":"animationstart",ANIMATION_END:i.$0R?"webkitAnimationEnd":"animationend",ANIMATION_ITERATION:i.$0R?"webkitAnimationIteration":"animationiteration"};function Ye(V){const G=V;return!!(G&&typeof G.preventDefault=="function"&&typeof G.stopPropagation=="function")}t.$vT={stop:(V,G)=>(V.preventDefault(),G&&V.stopPropagation(),V)};function ot(V){const G=[];for(let ne=0;V&&V.nodeType===V.ELEMENT_NODE;ne++)G[ne]=V.scrollTop,V=V.parentNode;return G}function dt(V,G){for(let ne=0;V&&V.nodeType===V.ELEMENT_NODE;ne++)V.scrollTop!==G[ne]&&(V.scrollTop=G[ne]),V=V.parentNode}class Je extends y.$Tc{static m(G){if(Xe(G)){const ne=X(G),me=ne?ne.activeElement:G.ownerDocument.activeElement;return o(me,G)}else{const ne=G;return o(ne.document.activeElement,ne.document)}}constructor(G){super(),this.f=this.B(new D.$je),this.onDidFocus=this.f.event,this.g=this.B(new D.$je),this.onDidBlur=this.g.event;let ne=Je.m(G),me=!1;const Ee=()=>{me=!1,ne||(ne=!0,this.f.fire())},Be=()=>{ne&&(me=!0,(Xe(G)?(0,t.getWindow)(G):G).setTimeout(()=>{me&&(me=!1,ne=!1,this.g.fire())},0))};this.j=()=>{Je.m(G)!==ne&&(ne?Be():Ee())},this.B(d(G,t.$tT.FOCUS,Ee,!0)),this.B(d(G,t.$tT.BLUR,Be,!0)),Xe(G)&&(this.B(d(G,t.$tT.FOCUS_IN,()=>this.j())),this.B(d(G,t.$tT.FOCUS_OUT,()=>this.j())))}refreshState(){this.j()}}function bt(V){return new Je(V)}function Tt(V,G){return V.after(G),G}function kt(V,...G){if(V.append(...G),G.length===1&&typeof G[0]!="string")return G[0]}function Jt(V,G){return V.insertBefore(G,V.firstChild),G}function Oi(V,...G){V.innerText="",kt(V,...G)}const Mi=/([\w\-]+)?(#([\w\-]+))?((\.([\w\-]+))*)/;var Nt;(function(V){V.HTML="http://www.w3.org/1999/xhtml",V.SVG="http://www.w3.org/2000/svg"})(Nt||(t.Namespace=Nt={}));function Qt(V,G,ne,...me){const Ee=Mi.exec(G);if(!Ee)throw new Error("Bad use of emmet");const Be=Ee[1]||"div";let je;return V!==Nt.HTML?je=document.createElementNS(V,Be):je=document.createElement(Be),Ee[3]&&(je.id=Ee[3]),Ee[4]&&(je.className=Ee[4].replace(/\./g," ").trim()),ne&&Object.entries(ne).forEach(([Ve,xe])=>{typeof xe>"u"||(/^on\w+$/.test(Ve)?je[Ve]=xe:Ve==="selected"?xe&&je.setAttribute(Ve,"true"):je.setAttribute(Ve,xe))}),je.append(...me),je}function ei(V,G,...ne){return Qt(Nt.HTML,V,G,...ne)}ei.SVG=function(V,G,...ne){return Qt(Nt.SVG,V,G,...ne)};function ji(V,G){const ne=[];return V.forEach((me,Ee)=>{Ee>0&&(G instanceof Node?ne.push(G.cloneNode()):ne.push(document.createTextNode(G))),ne.push(me)}),ne}function Pi(V,...G){V?ti(...G):ii(...G)}function ti(...V){for(const G of V)G.style.display="",G.removeAttribute("aria-hidden")}function ii(...V){for(const G of V)G.style.display="none",G.setAttribute("aria-hidden","true")}function Wi(V,G){for(;V&&V.nodeType===V.ELEMENT_NODE;){if(Xe(V)&&V.hasAttribute(G))return V;V=V.parentNode}return null}function Bi(V){!V||!V.hasAttribute("tabIndex")||(V.ownerDocument.activeElement===V&&Wi(V.parentElement,"tabIndex")?.focus(),V.removeAttribute("tabindex"))}function Ci(V){return G=>{G.preventDefault(),G.stopPropagation(),V(G)}}function _i(V){return new Promise(G=>{if(V.document.readyState==="complete"||V.document&&V.document.body!==null)G(void 0);else{const me=()=>{V.window.removeEventListener("DOMContentLoaded",me,!1),G()};V.window.addEventListener("DOMContentLoaded",me,!1)}})}function Ui(V,G){const ne=V.devicePixelRatio*G;return Math.max(1,Math.floor(ne))/V.devicePixelRatio}function Hi(V){r.$WR.open(V,"_blank","noopener")}const ni=780,si=640;function xi(V){const G=Math.floor(r.$WR.screenLeft+r.$WR.innerWidth/2-ni/2),ne=Math.floor(r.$WR.screenTop+r.$WR.innerHeight/2-si/2);r.$WR.open(V,"_blank",`width=${ni},height=${si},top=${ne},left=${G}`)}function zi(V,G=!0){const ne=r.$WR.open();return ne?(G&&(ne.opener=null),ne.location.href=V,!0):!1}function Vi(V,G){const ne=()=>{G(),me=(0,t.$CS)(V,ne)};let me=(0,t.$CS)(V,ne);return(0,y.$Rc)(()=>me.dispose())}$.$Pg.setPreferredWebSchema(/^https:/.test(r.$WR.location.href)?"https":"http");function Ki(V){return V?`url('${$.$Wg.uriToBrowserUri(V).toString(!0).replace(/'/g,"%27")}')`:"url('')"}function qi(V){return`'${V.replace(/'/g,"%27")}'`}function ri(V,G){if(V!==void 0){const ne=V.match(/^\s*var\((.+)\)$/);if(ne){const me=ne[1].split(",",2);return me.length===2&&(G=ri(me[1].trim(),G)),`var(${me[0]}, ${G})`}return V}return G}function Gi(V,G){let ne;if(e.URI.isUri(V))ne=V.toString(!0);else{const Be=new Blob([V]);ne=URL.createObjectURL(Be),setTimeout(()=>URL.revokeObjectURL(ne))}const me=Le(),Ee=document.createElement("a");me.document.body.appendChild(Ee),Ee.download=G,Ee.href=ne,Ee.click(),setTimeout(()=>Ee.remove())}function Xi(){return new Promise(V=>{const G=Le(),ne=document.createElement("input");G.document.body.appendChild(ne),ne.type="file",ne.multiple=!0,D.Event.once(D.Event.fromDOMEventEmitter(ne,"input"))(()=>{V(ne.files??void 0)}),ne.click(),setTimeout(()=>ne.remove())})}var Lt;(function(V){V[V.DOCUMENT=1]="DOCUMENT",V[V.BROWSER=2]="BROWSER"})(Lt||(t.DetectedFullscreenMode=Lt={}));function Yi(V){return V.document.fullscreenElement||V.document.webkitFullscreenElement||V.document.webkitIsFullScreen?{mode:Lt.DOCUMENT,guess:!1}:V.innerHeight===V.screen.height?{mode:Lt.BROWSER,guess:!1}:(g.$k||g.$l)&&V.outerHeight===V.screen.height&&V.outerWidth===V.screen.width?{mode:Lt.BROWSER,guess:!0}:null}function oi(V,G=!1){const ne=document.createElement("a");return c.addHook("afterSanitizeAttributes",me=>{for(const Ee of["href","src"])if(me.hasAttribute(Ee)){const Be=me.getAttribute(Ee);if(Ee==="href"&&Be.startsWith("#"))continue;if(ne.href=Be,!V.includes(ne.protocol.replace(/:$/,""))){if(G&&Ee==="src"&&ne.href.startsWith("data:"))continue;me.removeAttribute(Ee)}}}),(0,y.$Rc)(()=>{c.removeHook("afterSanitizeAttributes")})}const Zi=[$.Schemas.http,$.Schemas.https,$.Schemas.command];t.$XT=Object.freeze(["a","abbr","b","bdo","blockquote","br","caption","cite","code","col","colgroup","dd","del","details","dfn","div","dl","dt","em","figcaption","figure","h1","h2","h3","h4","h5","h6","hr","i","img","input","ins","kbd","label","li","mark","ol","p","pre","q","rp","rt","ruby","samp","small","small","source","span","strike","strong","sub","summary","sup","table","tbody","td","tfoot","th","thead","time","tr","tt","u","ul","var","video","wbr"]);const Ji=Object.freeze({ALLOWED_TAGS:["a","button","blockquote","code","div","h1","h2","h3","h4","h5","h6","hr","input","label","li","p","pre","select","small","span","strong","textarea","ul","ol"],ALLOWED_ATTR:["href","data-href","data-command","target","title","name","src","alt","class","id","role","tabindex","style","data-code","width","height","align","x-dispatch","required","checked","placeholder","type","start"],RETURN_DOM:!1,RETURN_DOM_FRAGMENT:!1,RETURN_TRUSTED_TYPE:!0});function Qi(V,G){const ne=oi(Zi);try{const me=c.sanitize(G,Ji);V.innerHTML=me}finally{ne.dispose()}}function en(V){const G=new Uint16Array(V.length);for(let Ee=0;Ee<G.length;Ee++)G[Ee]=V.charCodeAt(Ee);let ne="";const me=new Uint8Array(G.buffer);for(let Ee=0;Ee<me.length;Ee++)ne+=String.fromCharCode(me[Ee]);return ne}function tn(V){return btoa(en(V))}class Et extends D.$je{constructor(){super(),this.o=new y.$Sc,this.D={altKey:!1,shiftKey:!1,ctrlKey:!1,metaKey:!1},this.o.add(D.Event.runAndSubscribe(t.onDidRegisterWindow,({window:G,disposables:ne})=>this.G(G,ne),{window:r.$WR,disposables:this.o}))}G(G,ne){ne.add(d(G,"keydown",me=>{if(me.defaultPrevented)return;const Ee=new j.$oS(me);if(!(Ee.keyCode===p.KeyCode.Alt&&me.repeat)){if(me.altKey&&!this.D.altKey)this.D.lastKeyPressed="alt";else if(me.ctrlKey&&!this.D.ctrlKey)this.D.lastKeyPressed="ctrl";else if(me.metaKey&&!this.D.metaKey)this.D.lastKeyPressed="meta";else if(me.shiftKey&&!this.D.shiftKey)this.D.lastKeyPressed="shift";else if(Ee.keyCode!==p.KeyCode.Alt)this.D.lastKeyPressed=void 0;else return;this.D.altKey=me.altKey,this.D.ctrlKey=me.ctrlKey,this.D.metaKey=me.metaKey,this.D.shiftKey=me.shiftKey,this.D.lastKeyPressed&&(this.D.event=me,this.fire(this.D))}},!0)),ne.add(d(G,"keyup",me=>{me.defaultPrevented||(!me.altKey&&this.D.altKey?this.D.lastKeyReleased="alt":!me.ctrlKey&&this.D.ctrlKey?this.D.lastKeyReleased="ctrl":!me.metaKey&&this.D.metaKey?this.D.lastKeyReleased="meta":!me.shiftKey&&this.D.shiftKey?this.D.lastKeyReleased="shift":this.D.lastKeyReleased=void 0,this.D.lastKeyPressed!==this.D.lastKeyReleased&&(this.D.lastKeyPressed=void 0),this.D.altKey=me.altKey,this.D.ctrlKey=me.ctrlKey,this.D.metaKey=me.metaKey,this.D.shiftKey=me.shiftKey,this.D.lastKeyReleased&&(this.D.event=me,this.fire(this.D)))},!0)),ne.add(d(G.document.body,"mousedown",()=>{this.D.lastKeyPressed=void 0},!0)),ne.add(d(G.document.body,"mouseup",()=>{this.D.lastKeyPressed=void 0},!0)),ne.add(d(G.document.body,"mousemove",me=>{me.buttons&&(this.D.lastKeyPressed=void 0)},!0)),ne.add(d(G,"blur",()=>{this.resetKeyStatus()}))}get keyStatus(){return this.D}get isModifierPressed(){return this.D.altKey||this.D.ctrlKey||this.D.metaKey||this.D.shiftKey}resetKeyStatus(){this.H(),this.fire(this.D)}H(){this.D={altKey:!1,shiftKey:!1,ctrlKey:!1,metaKey:!1}}static getInstance(){return Et.F||(Et.F=new Et),Et.F}dispose(){super.dispose(),this.o.dispose()}}t.$1T=Et;function nn(V){const G=document.cookie.match("(^|[^;]+)\\s*"+V+"\\s*=\\s*([^;]+)");return G?G.pop():void 0}class sn extends y.$Tc{constructor(G,ne){super(),this.j=G,this.m=ne,this.f=0,this.g=0,this.n()}n(){this.m.onDragStart&&this.B(d(this.j,t.$tT.DRAG_START,G=>{this.m.onDragStart?.(G)})),this.m.onDrag&&this.B(d(this.j,t.$tT.DRAG,G=>{this.m.onDrag?.(G)})),this.B(d(this.j,t.$tT.DRAG_ENTER,G=>{this.f++,this.g=G.timeStamp,this.m.onDragEnter?.(G)})),this.B(d(this.j,t.$tT.DRAG_OVER,G=>{G.preventDefault(),this.m.onDragOver?.(G,G.timeStamp-this.g)})),this.B(d(this.j,t.$tT.DRAG_LEAVE,G=>{this.f--,this.f===0&&(this.g=0,this.m.onDragLeave?.(G))})),this.B(d(this.j,t.$tT.DRAG_END,G=>{this.f=0,this.g=0,this.m.onDragEnd?.(G)})),this.B(d(this.j,t.$tT.DROP,G=>{this.f=0,this.g=0,this.m.onDrop?.(G)}))}}t.$3T=sn;const li=/(?<tag>[\w\-]+)?(?:#(?<id>[\w\-]+))?(?<class>(?:\.(?:[\w\-]+))*)(?:@(?<name>(?:[\w\_])+))?/;function rn(V,...G){let ne,me;Array.isArray(G[0])?(ne={},me=G[0]):(ne=G[0]||{},me=G[1]);const Ee=li.exec(V);if(!Ee||!Ee.groups)throw new Error("Bad use of h");const Be=Ee.groups.tag||"div",je=document.createElement(Be);Ee.groups.id&&(je.id=Ee.groups.id);const Ve=[];if(Ee.groups.class)for(const _e of Ee.groups.class.split("."))_e!==""&&Ve.push(_e);if(ne.className!==void 0)for(const _e of ne.className.split("."))_e!==""&&Ve.push(_e);Ve.length>0&&(je.className=Ve.join(" "));const xe={};if(Ee.groups.name&&(xe[Ee.groups.name]=je),me)for(const _e of me)Xe(_e)?je.appendChild(_e):typeof _e=="string"?je.append(_e):"root"in _e&&(Object.assign(xe,_e),je.appendChild(_e.root));for(const[_e,lt]of Object.entries(ne))if(_e!=="className")if(_e==="style")for(const[yt,vt]of Object.entries(lt))je.style.setProperty(Ot(yt),typeof vt=="number"?vt+"px":""+vt);else _e==="tabIndex"?je.tabIndex=lt:je.setAttribute(Ot(_e),lt.toString());return xe.root=je,xe}function on(V,...G){let ne,me;Array.isArray(G[0])?(ne={},me=G[0]):(ne=G[0]||{},me=G[1]);const Ee=li.exec(V);if(!Ee||!Ee.groups)throw new Error("Bad use of h");const Be=Ee.groups.tag||"div",je=document.createElementNS("http://www.w3.org/2000/svg",Be);Ee.groups.id&&(je.id=Ee.groups.id);const Ve=[];if(Ee.groups.class)for(const _e of Ee.groups.class.split("."))_e!==""&&Ve.push(_e);if(ne.className!==void 0)for(const _e of ne.className.split("."))_e!==""&&Ve.push(_e);Ve.length>0&&(je.className=Ve.join(" "));const xe={};if(Ee.groups.name&&(xe[Ee.groups.name]=je),me)for(const _e of me)Xe(_e)?je.appendChild(_e):typeof _e=="string"?je.append(_e):"root"in _e&&(Object.assign(xe,_e),je.appendChild(_e.root));for(const[_e,lt]of Object.entries(ne))if(_e!=="className")if(_e==="style")for(const[yt,vt]of Object.entries(lt))je.style.setProperty(Ot(yt),typeof vt=="number"?vt+"px":""+vt);else _e==="tabIndex"?je.tabIndex=lt:je.setAttribute(Ot(_e),lt.toString());return xe.root=je,xe}function Ot(V){return V.replace(/([a-z])([A-Z])/g,"$1-$2").toLowerCase()}function ai(V,G,ne){for(const{name:me,value:Ee}of V.attributes)(!ne||ne.includes(me))&&G.setAttribute(me,Ee)}function ln(V,G,ne){const me=V.getAttribute(ne);me?G.setAttribute(ne,me):G.removeAttribute(ne)}function an(V,G,ne){ai(V,G,ne);const me=new y.$Sc;return me.add(t.$cT.observe(V,me,{attributes:!0,attributeFilter:ne})(Ee=>{for(const Be of Ee)Be.type==="attributes"&&Be.attributeName&&ln(V,G,Be.attributeName)})),me}class un{constructor(G,ne,me){this.f=G,this.g=ne,this.d=[];const{top:Ee,left:Be,right:je,bottom:Ve}=me.getBoundingClientRect(),xe=this.d;let _e=0;xe[_e++]=Be,xe[_e++]=Ee,xe[_e++]=je,xe[_e++]=Ee,xe[_e++]=Be,xe[_e++]=Ee,xe[_e++]=Be,xe[_e++]=Ve,xe[_e++]=je,xe[_e++]=Ee,xe[_e++]=je,xe[_e++]=Ve,xe[_e++]=Be,xe[_e++]=Ve,xe[_e++]=je,xe[_e++]=Ve}contains(G,ne){const{d:me,f:Ee,g:Be}=this;for(let je=0;je<4;je++)if((0,h.$Nm)(G,ne,Ee,Be,me[2*je],me[2*je+1],me[2*je+2],me[2*je+3]))return!0;return!1}}t.$8T=un}),define(we[69],ve([1,0,4,2,100]),function(re,t,i,n,j){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$0T=t.$9T=void 0,t.$$T=N;class F extends n.$Tc{constructor(D,c){super(),this.B((0,i.$sS)(D,"dragover",p=>{p.preventDefault(),this.a||(this.a=setTimeout(()=>{c(),this.a=null},800))})),["dragleave","drop","dragend"].forEach(p=>{this.B((0,i.$sS)(D,p,()=>{this.b()}))})}b(){this.a&&(clearTimeout(this.a),this.a=null)}dispose(){super.dispose(),this.b()}}t.$9T=F,t.$0T={RESOURCES:"ResourceURLs",DOWNLOAD_URL:"DownloadURL",FILES:"Files",TEXT:j.$8s.text,INTERNAL_URI_LIST:"application/vnd.code.uri-list"};function N(w,D,c,p,y){const $=document.createElement("div");$.className=c,$.textContent=D,y&&($.style.color=y),p&&($.style.background=p),w.dataTransfer&&((0,i.getWindow)(w).document.body.appendChild($),w.dataTransfer.setDragImage($,-10,-10),setTimeout(()=>$.remove(),0))}}),define(we[70],ve([1,0,4]),function(re,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$DU=n,t.$EU=j,t.$FU=F,i=He(i);function n($,g={}){const e=F(g);return e.textContent=$,e}function j($,g={}){const e=F(g);return D(e,c($,!!g.renderCodeSegments),g.actionHandler,g.renderCodeSegments),e}function F($){const g=$.inline?"span":"div",e=document.createElement(g);return $.className&&(e.className=$.className),e}class N{constructor(g){this.b=g,this.c=0}eos(){return this.c>=this.b.length}next(){const g=this.peek();return this.advance(),g}peek(){return this.b[this.c]}advance(){this.c++}}var w;(function($){$[$.Invalid=0]="Invalid",$[$.Root=1]="Root",$[$.Text=2]="Text",$[$.Bold=3]="Bold",$[$.Italics=4]="Italics",$[$.Action=5]="Action",$[$.ActionClose=6]="ActionClose",$[$.Code=7]="Code",$[$.NewLine=8]="NewLine"})(w||(w={}));function D($,g,e,s){let r;if(g.type===w.Text)r=document.createTextNode(g.content||"");else if(g.type===w.Bold)r=document.createElement("b");else if(g.type===w.Italics)r=document.createElement("i");else if(g.type===w.Code&&s)r=document.createElement("code");else if(g.type===w.Action&&e){const h=document.createElement("a");e.disposables.add(i.$tS(h,"click",l=>{e.callback(String(g.index),l)})),r=h}else g.type===w.NewLine?r=document.createElement("br"):g.type===w.Root&&(r=$);r&&$!==r&&$.appendChild(r),r&&Array.isArray(g.children)&&g.children.forEach(h=>{D(r,h,e,s)})}function c($,g){const e={type:w.Root,children:[]};let s=0,r=e;const h=[],l=new N($);for(;!l.eos();){let v=l.next();const k=v==="\\"&&y(l.peek(),g)!==w.Invalid;if(k&&(v=l.next()),!k&&p(v,g)&&v===l.peek()){l.advance(),r.type===w.Text&&(r=h.pop());const A=y(v,g);if(r.type===A||r.type===w.Action&&A===w.ActionClose)r=h.pop();else{const d={type:A,children:[]};A===w.Action&&(d.index=s,s++),r.children.push(d),h.push(r),r=d}}else if(v===`
`)r.type===w.Text&&(r=h.pop()),r.children.push({type:w.NewLine});else if(r.type!==w.Text){const A={type:w.Text,content:v};r.children.push(A),h.push(r),r=A}else r.content+=v}return r.type===w.Text&&(r=h.pop()),h.length,e}function p($,g){return y($,g)!==w.Invalid}function y($,g){switch($){case"*":return w.Bold;case"_":return w.Italics;case"[":return w.Action;case"]":return w.ActionClose;case"`":return g?w.Code:w.Invalid;default:return w.Invalid}}}),define(we[71],ve([1,0,4,2]),function(re,t,i,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$cU=void 0,i=He(i);class j{constructor(){this.a=new n.$Sc,this.b=null,this.c=null}dispose(){this.stopMonitoring(!1),this.a.dispose()}stopMonitoring(N,w){if(!this.isMonitoring())return;this.a.clear(),this.b=null;const D=this.c;this.c=null,N&&D&&D(w)}isMonitoring(){return!!this.b}startMonitoring(N,w,D,c,p){this.isMonitoring()&&this.stopMonitoring(!1),this.b=c,this.c=p;let y=N;try{N.setPointerCapture(w),this.a.add((0,n.$Rc)(()=>{try{N.releasePointerCapture(w)}catch{}}))}catch{y=i.getWindow(N)}this.a.add(i.$sS(y,i.$tT.POINTER_MOVE,$=>{if($.buttons!==D){this.stopMonitoring(!0);return}$.preventDefault(),this.b($)})),this.a.add(i.$sS(y,i.$tT.POINTER_UP,$=>this.stopMonitoring(!0)))}}t.$cU=j});var et=this&&this.__decorate||function(re,t,i,n){var j=arguments.length,F=j<3?t:n===null?n=Object.getOwnPropertyDescriptor(t,i):n,N;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")F=Reflect.decorate(re,t,i,n);else for(var w=re.length-1;w>=0;w--)(N=re[w])&&(F=(j<3?N(F):j>3?N(t,i,F):N(t,i))||F);return j>3&&F&&Object.defineProperty(t,i,F),F};define(we[32],ve([1,0,4,24,9,35,3,2,59]),function(re,t,i,n,j,F,N,w,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$_T=t.EventType=void 0,i=He(i),j=He(j);var c;(function(y){y.Tap="-monaco-gesturetap",y.Change="-monaco-gesturechange",y.Start="-monaco-gesturestart",y.End="-monaco-gesturesend",y.Contextmenu="-monaco-gesturecontextmenu"})(c||(t.EventType=c={}));class p extends w.$Tc{static{this.c=-.005}static{this.g=700}static{this.u=400}constructor(){super(),this.h=!1,this.j=new D.$4c,this.m=new D.$4c,this.r={},this.n=null,this.s=0,this.B(N.Event.runAndSubscribe(i.onDidRegisterWindow,({window:$,disposables:g})=>{g.add(i.$sS($.document,"touchstart",e=>this.w(e),{passive:!1})),g.add(i.$sS($.document,"touchend",e=>this.z($,e))),g.add(i.$sS($.document,"touchmove",e=>this.G(e),{passive:!1}))},{window:n.$WR,disposables:this.q}))}static addTarget($){if(!p.isTouchDevice())return w.$Tc.None;p.f||(p.f=(0,w.$Mc)(new p));const g=p.f.j.push($);return(0,w.$Rc)(g)}static ignoreTarget($){if(!p.isTouchDevice())return w.$Tc.None;p.f||(p.f=(0,w.$Mc)(new p));const g=p.f.m.push($);return(0,w.$Rc)(g)}static isTouchDevice(){return"ontouchstart"in n.$WR||navigator.maxTouchPoints>0}dispose(){this.n&&(this.n.dispose(),this.n=null),super.dispose()}w($){const g=Date.now();this.n&&(this.n.dispose(),this.n=null);for(let e=0,s=$.targetTouches.length;e<s;e++){const r=$.targetTouches.item(e);this.r[r.identifier]={id:r.identifier,initialTarget:r.target,initialTimeStamp:g,initialPageX:r.pageX,initialPageY:r.pageY,rollingTimestamps:[g],rollingPageX:[r.pageX],rollingPageY:[r.pageY]};const h=this.C(c.Start,r.target);h.pageX=r.pageX,h.pageY=r.pageY,this.D(h)}this.h&&($.preventDefault(),$.stopPropagation(),this.h=!1)}z($,g){const e=Date.now(),s=Object.keys(this.r).length;for(let r=0,h=g.changedTouches.length;r<h;r++){const l=g.changedTouches.item(r);if(!this.r.hasOwnProperty(String(l.identifier))){console.warn("move of an UNKNOWN touch",l);continue}const v=this.r[l.identifier],k=Date.now()-v.initialTimeStamp;if(k<p.g&&Math.abs(v.initialPageX-j.$rb(v.rollingPageX))<30&&Math.abs(v.initialPageY-j.$rb(v.rollingPageY))<30){const A=this.C(c.Tap,v.initialTarget);A.pageX=j.$rb(v.rollingPageX),A.pageY=j.$rb(v.rollingPageY),this.D(A)}else if(k>=p.g&&Math.abs(v.initialPageX-j.$rb(v.rollingPageX))<30&&Math.abs(v.initialPageY-j.$rb(v.rollingPageY))<30){const A=this.C(c.Contextmenu,v.initialTarget);A.pageX=j.$rb(v.rollingPageX),A.pageY=j.$rb(v.rollingPageY),this.D(A)}else if(s===1){const A=j.$rb(v.rollingPageX),d=j.$rb(v.rollingPageY),f=j.$rb(v.rollingTimestamps)-v.rollingTimestamps[0],b=A-v.rollingPageX[0],S=d-v.rollingPageY[0],U=[...this.j].filter(_=>v.initialTarget instanceof Node&&_.contains(v.initialTarget));this.F($,U,e,Math.abs(b)/f,b>0?1:-1,A,Math.abs(S)/f,S>0?1:-1,d)}this.D(this.C(c.End,v.initialTarget)),delete this.r[l.identifier]}this.h&&(g.preventDefault(),g.stopPropagation(),this.h=!1)}C($,g){const e=document.createEvent("CustomEvent");return e.initEvent($,!1,!0),e.initialTarget=g,e.tapCount=0,e}D($){if($.type===c.Tap){const g=new Date().getTime();let e=0;g-this.s>p.u?e=1:e=2,this.s=g,$.tapCount=e}else($.type===c.Change||$.type===c.Contextmenu)&&(this.s=0);if($.initialTarget instanceof Node){for(const e of this.m)if(e.contains($.initialTarget))return;const g=[];for(const e of this.j)if(e.contains($.initialTarget)){let s=0,r=$.initialTarget;for(;r&&r!==e;)s++,r=r.parentElement;g.push([s,e])}g.sort((e,s)=>e[0]-s[0]);for(const[e,s]of g)s.dispatchEvent($),this.h=!0}}F($,g,e,s,r,h,l,v,k){this.n=i.$CS($,()=>{const A=Date.now(),d=A-e;let f=0,b=0,S=!0;s+=p.c*d,l+=p.c*d,s>0&&(S=!1,f=r*s*d),l>0&&(S=!1,b=v*l*d);const U=this.C(c.Change);U.translationX=f,U.translationY=b,g.forEach(_=>_.dispatchEvent(U)),S||this.F($,g,A,s,r,h+f,l,v,k+b)})}G($){const g=Date.now();for(let e=0,s=$.changedTouches.length;e<s;e++){const r=$.changedTouches.item(e);if(!this.r.hasOwnProperty(String(r.identifier))){console.warn("end of an UNKNOWN touch",r);continue}const h=this.r[r.identifier],l=this.C(c.Change,h.initialTarget);l.translationX=r.pageX-j.$rb(h.rollingPageX),l.translationY=r.pageY-j.$rb(h.rollingPageY),l.pageX=r.pageX,l.pageY=r.pageY,this.D(l),h.rollingPageX.length>3&&(h.rollingPageX.shift(),h.rollingPageY.shift(),h.rollingTimestamps.shift()),h.rollingPageX.push(r.pageX),h.rollingPageY.push(r.pageY),h.rollingTimestamps.push(g)}this.h&&($.preventDefault(),$.stopPropagation(),this.h=!1)}}t.$_T=p,et([F.$7h],p,"isTouchDevice",null)}),define(we[112],ve([1,0,4,22]),function(re,t,i,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$aV=F,t.$bV=N,i=He(i);const j=new RegExp(`(\\\\)?\\$\\((${n.ThemeIcon.iconNameExpression}(?:${n.ThemeIcon.iconModifierExpression})?)\\)`,"g");function F(w){const D=new Array;let c,p=0,y=0;for(;(c=j.exec(w))!==null;){y=c.index||0,p<y&&D.push(w.substring(p,y)),p=(c.index||0)+c[0].length;const[,$,g]=c;D.push($?`$(${g})`:N({id:g}))}return p<w.length&&D.push(w.substring(p)),D}function N(w){const D=i.$("span");return D.classList.add(...n.ThemeIcon.asClassNameArray(w)),D}}),define(we[113],ve([1,0,4]),function(re,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$PU=void 0;class n{constructor(F){this.d=F,this.a=new Map,this.b=new Set,this.c=!1}alloc(F){let N=this.g(F).pop(),w=!1;if(N)w=this.b.has(N.domNode),w&&this.b.delete(N.domNode);else{const D=(0,i.$)(".monaco-list-row"),p=this.h(F).renderTemplate(D);N={domNode:D,templateId:F,templateData:p}}return{row:N,isReusingConnectedDomNode:w}}release(F){F&&this.e(F)}transact(F){if(this.c)throw new Error("Already in transaction");this.c=!0;try{F()}finally{for(const N of this.b)this.f(N);this.b.clear(),this.c=!1}}e(F){const{domNode:N,templateId:w}=F;N&&(this.c?this.b.add(N):this.f(N)),this.g(w).push(F)}f(F){F.classList.remove("scrolling"),F.remove()}g(F){let N=this.a.get(F);return N||(N=[],this.a.set(F,N)),N}dispose(){this.a.forEach((F,N)=>{for(const w of F)this.h(N).disposeTemplate(w.templateData),w.templateData=null}),this.a.clear(),this.b.clear()}h(F){const N=this.d.get(F);if(!N)throw new Error(`No renderer found for ${F}`);return N}}t.$PU=n}),define(we[114],ve([1,0,12,2,20]),function(re,t,i,n,j){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$hU=void 0;class F extends n.$Tc{constructor(w,D,c){super(),this.a=w,this.b=D,this.c=c,this.f=null,this.m=!1,this.j=!1,this.g=!1,this.h=!1,this.n=this.B(new i.$Mh)}setVisibility(w){this.a!==w&&(this.a=w,this.s())}setShouldBeVisible(w){this.g=w,this.s()}r(){return this.a===j.ScrollbarVisibility.Hidden?!1:this.a===j.ScrollbarVisibility.Visible?!0:this.g}s(){const w=this.r();this.h!==w&&(this.h=w,this.ensureVisibility())}setIsNeeded(w){this.j!==w&&(this.j=w,this.ensureVisibility())}setDomNode(w){this.f=w,this.f.setClassName(this.c),this.setShouldBeVisible(!1)}ensureVisibility(){if(!this.j){this.u(!1);return}this.h?this.t():this.u(!0)}t(){this.m||(this.m=!0,this.n.setIfNotSet(()=>{this.f?.setClassName(this.b)},0))}u(w){this.n.cancel(),this.m&&(this.m=!1,this.f?.setClassName(this.c+(w?" fade":"")))}}t.$hU=F}),define(we[115],ve([1,0,4,32,9,3,8,2,5]),function(re,t,i,n,j,F,N,w,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$kV=void 0,i=He(i),j=He(j);class c extends w.$Tc{constructor(y,$,g,e){super(),this.f=0,this.b=e||Object.create(null),this.c=[],this.a=document.createElement("select"),this.a.className="monaco-select-box",typeof this.b.ariaLabel=="string"&&this.a.setAttribute("aria-label",this.b.ariaLabel),typeof this.b.ariaDescription=="string"&&this.a.setAttribute("aria-description",this.b.ariaDescription),this.g=this.B(new F.$je),this.h=g,this.j(),this.setOptions(y,$)}j(){this.B(n.$_T.addTarget(this.a)),[n.EventType.Tap].forEach(y=>{this.B(i.$sS(this.a,y,$=>{this.a.focus()}))}),this.B(i.$tS(this.a,"click",y=>{i.$vT.stop(y,!0)})),this.B(i.$tS(this.a,"change",y=>{this.a.title=y.target.value,this.g.fire({index:y.target.selectedIndex,selected:y.target.value})})),this.B(i.$tS(this.a,"keydown",y=>{let $=!1;D.$k?(y.keyCode===N.KeyCode.DownArrow||y.keyCode===N.KeyCode.UpArrow||y.keyCode===N.KeyCode.Space)&&($=!0):(y.keyCode===N.KeyCode.DownArrow&&y.altKey||y.keyCode===N.KeyCode.Space||y.keyCode===N.KeyCode.Enter)&&($=!0),$&&y.stopPropagation()}))}get onDidSelect(){return this.g.event}setOptions(y,$){(!this.c||!j.$tb(this.c,y))&&(this.c=y,this.a.options.length=0,this.c.forEach((g,e)=>{this.a.add(this.m(g.text,e,g.isDisabled))})),$!==void 0&&this.select($)}select(y){this.c.length===0?this.f=0:y>=0&&y<this.c.length?this.f=y:y>this.c.length-1?this.select(this.c.length-1):this.f<0&&(this.f=0),this.a.selectedIndex=this.f,this.f<this.c.length&&typeof this.c[this.f].text=="string"?this.a.title=this.c[this.f].text:this.a.title=""}setAriaLabel(y){this.b.ariaLabel=y,this.a.setAttribute("aria-label",y)}focus(){this.a&&(this.a.tabIndex=0,this.a.focus())}blur(){this.a&&(this.a.tabIndex=-1,this.a.blur())}setEnabled(y){this.a.disabled=!y}setFocusable(y){this.a.tabIndex=y?0:-1}render(y){y.classList.add("select-container"),y.appendChild(this.a),this.setOptions(this.c,this.f),this.applyStyles()}style(y){this.h=y,this.applyStyles()}applyStyles(){this.a&&(this.a.style.backgroundColor=this.h.selectBackground??"",this.a.style.color=this.h.selectForeground??"",this.a.style.borderColor=this.h.selectBorder??"")}m(y,$,g){const e=document.createElement("option");return e.value=y,e.text=y,e.disabled=!!g,e}}t.$kV=c}),define(we[72],ve([1,0,34,9,12,63,109,3,36]),function(re,t,i,n,j,F,N,w,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$XW=void 0,t.$VW=c,t.$WW=p;function c(g){return typeof g=="object"&&"visibility"in g&&"data"in g}function p(g){switch(g){case!0:return i.TreeVisibility.Visible;case!1:return i.TreeVisibility.Hidden;default:return g}}function y(g){return typeof g.collapsible=="boolean"}class ${constructor(e,s,r,h={}){this.p=e,this.q=s,this.rootRef=[],this.d=new w.$re,this.f=new w.$je,this.onDidChangeCollapseState=this.d.wrapEvent(this.f.event),this.g=new w.$je,this.onDidChangeRenderNodeCount=this.d.wrapEvent(this.g.event),this.m=new w.$je,this.onDidSplice=this.m.event,this.o=new j.$zh(F.$ee),this.h=typeof h.collapseByDefault>"u"?!1:h.collapseByDefault,this.j=h.allowNonCollapsibleParents??!1,this.k=h.filter,this.l=typeof h.autoExpandSingleChildren>"u"?!1:h.autoExpandSingleChildren,this.c={parent:void 0,element:r,children:[],depth:0,visibleChildrenCount:0,visibleChildIndex:-1,collapsible:!1,collapsed:!1,renderNodeCount:0,visibility:i.TreeVisibility.Visible,visible:!0,filterData:void 0}}splice(e,s,r=D.Iterable.empty(),h={}){if(e.length===0)throw new i.$TW(this.p,"Invalid tree location");h.diffIdentityProvider?this.s(h.diffIdentityProvider,e,s,r,h):this.t(e,s,r,h)}s(e,s,r,h=D.Iterable.empty(),l,v=l.diffDepth??0){const{parentNode:k}=this.H(s);if(!k.lastDiffIds)return this.t(s,r,h,l);const A=[...h],d=s[s.length-1],f=new N.$Rt({getElements:()=>k.lastDiffIds},{getElements:()=>[...k.children.slice(0,d),...A,...k.children.slice(d+r)].map(B=>e.getId(B.element).toString())}).ComputeDiff(!1);if(f.quitEarly)return k.lastDiffIds=void 0,this.t(s,r,A,l);const b=s.slice(0,-1),S=(B,E,I)=>{if(v>0)for(let z=0;z<I;z++)B--,E--,this.s(e,[...b,B,0],Number.MAX_SAFE_INTEGER,A[E].children,l,v-1)};let U=Math.min(k.children.length,d+r),_=A.length;for(const B of f.changes.sort((E,I)=>I.originalStart-E.originalStart))S(U,_,U-(B.originalStart+B.originalLength)),U=B.originalStart,_=B.modifiedStart-d,this.t([...b,U],B.originalLength,D.Iterable.slice(A,_,_+B.modifiedLength),l);S(U,_,U)}t(e,s,r=D.Iterable.empty(),{onDidCreateNode:h,onDidDeleteNode:l,diffIdentityProvider:v}){const{parentNode:k,listIndex:A,revealed:d,visible:f}=this.H(e),b=[],S=D.Iterable.map(r,x=>this.x(x,k,k.visible?i.TreeVisibility.Visible:i.TreeVisibility.Hidden,d,b,h)),U=e[e.length-1];let _=0;for(let x=U;x>=0&&x<k.children.length;x--){const Z=k.children[x];if(Z.visible){_=Z.visibleChildIndex;break}}const B=[];let E=0,I=0;for(const x of S)B.push(x),I+=x.renderNodeCount,x.visible&&(x.visibleChildIndex=_+E++);const z=(0,n.$4b)(k.children,U,s,B);v?k.lastDiffIds?(0,n.$4b)(k.lastDiffIds,U,s,B.map(x=>v.getId(x.element).toString())):k.lastDiffIds=k.children.map(x=>v.getId(x.element).toString()):k.lastDiffIds=void 0;let O=0;for(const x of z)x.visible&&O++;if(O!==0)for(let x=U+B.length;x<k.children.length;x++){const Z=k.children[x];Z.visible&&(Z.visibleChildIndex-=O)}if(k.visibleChildrenCount+=E-O,d&&f){const x=z.reduce((Z,Y)=>Z+(Y.visible?Y.renderNodeCount:0),0);this.C(k,I-x),this.q.splice(A,x,b)}if(z.length>0&&l){const x=Z=>{l(Z),Z.children.forEach(x)};z.forEach(x)}this.m.fire({insertedNodes:B,deletedNodes:z});let C=k;for(;C;){if(C.visibility===i.TreeVisibility.Recurse){this.o.trigger(()=>this.refilter());break}C=C.parent}}rerender(e){if(e.length===0)throw new i.$TW(this.p,"Invalid tree location");const{node:s,listIndex:r,revealed:h}=this.G(e);s.visible&&h&&this.q.splice(r,1,[s])}updateElementHeight(e,s){if(e.length===0)throw new i.$TW(this.p,"Invalid tree location");const{listIndex:r}=this.G(e);this.q.updateElementHeight(r,s)}has(e){return this.E(e)}getListIndex(e){const{listIndex:s,visible:r,revealed:h}=this.G(e);return r&&h?s:-1}getListRenderCount(e){return this.F(e).renderNodeCount}isCollapsible(e){return this.F(e).collapsible}setCollapsible(e,s){const r=this.F(e);typeof s>"u"&&(s=!r.collapsible);const h={collapsible:s};return this.d.bufferEvents(()=>this.u(e,h))}isCollapsed(e){return this.F(e).collapsed}setCollapsed(e,s,r){const h=this.F(e);typeof s>"u"&&(s=!h.collapsed);const l={collapsed:s,recursive:r||!1};return this.d.bufferEvents(()=>this.u(e,l))}u(e,s){const{node:r,listIndex:h,revealed:l}=this.G(e),v=this.v(r,h,l,s);if(r!==this.c&&this.l&&v&&!y(s)&&r.collapsible&&!r.collapsed&&!s.recursive){let k=-1;for(let A=0;A<r.children.length;A++)if(r.children[A].visible)if(k>-1){k=-1;break}else k=A;k>-1&&this.u([...e,k],s)}return v}v(e,s,r,h){const l=this.w(e,h,!1);if(!r||!e.visible||!l)return l;const v=e.renderNodeCount,k=this.y(e),A=v-(s===-1?0:1);return this.q.splice(s+1,A,k.slice(1)),l}w(e,s,r){let h;if(e===this.c?h=!1:(y(s)?(h=e.collapsible!==s.collapsible,e.collapsible=s.collapsible):e.collapsible?(h=e.collapsed!==s.collapsed,e.collapsed=s.collapsed):h=!1,h&&this.f.fire({node:e,deep:r})),!y(s)&&s.recursive)for(const l of e.children)h=this.w(l,s,!0)||h;return h}expandTo(e){this.d.bufferEvents(()=>{let s=this.F(e);for(;s.parent;)s=s.parent,e=e.slice(0,e.length-1),s.collapsed&&this.u(e,{collapsed:!1,recursive:!1})})}refilter(){const e=this.c.renderNodeCount,s=this.A(this.c);this.q.splice(0,e,s),this.o.cancel()}x(e,s,r,h,l,v){const k={parent:s,element:e.element,children:[],depth:s.depth+1,visibleChildrenCount:0,visibleChildIndex:-1,collapsible:typeof e.collapsible=="boolean"?e.collapsible:typeof e.collapsed<"u",collapsed:typeof e.collapsed>"u"?this.h:e.collapsed,renderNodeCount:1,visibility:i.TreeVisibility.Visible,visible:!0,filterData:void 0},A=this.D(k,r);k.visibility=A,h&&l.push(k);const d=e.children||D.Iterable.empty(),f=h&&A!==i.TreeVisibility.Hidden&&!k.collapsed;let b=0,S=1;for(const U of d){const _=this.x(U,k,A,f,l,v);k.children.push(_),S+=_.renderNodeCount,_.visible&&(_.visibleChildIndex=b++)}return this.j||(k.collapsible=k.collapsible||k.children.length>0),k.visibleChildrenCount=b,k.visible=A===i.TreeVisibility.Recurse?b>0:A===i.TreeVisibility.Visible,k.visible?k.collapsed||(k.renderNodeCount=S):(k.renderNodeCount=0,h&&l.pop()),v?.(k),k}y(e){const s=e.renderNodeCount,r=[];return this.z(e,r),this.C(e.parent,r.length-s),r}z(e,s){if(e.visible===!1)return 0;if(s.push(e),e.renderNodeCount=1,!e.collapsed)for(const r of e.children)e.renderNodeCount+=this.z(r,s);return this.g.fire(e),e.renderNodeCount}A(e){const s=e.renderNodeCount,r=[];return this.B(e,e.visible?i.TreeVisibility.Visible:i.TreeVisibility.Hidden,r),this.C(e.parent,r.length-s),r}B(e,s,r,h=!0){let l;if(e!==this.c){if(l=this.D(e,s),l===i.TreeVisibility.Hidden)return e.visible=!1,e.renderNodeCount=0,!1;h&&r.push(e)}const v=r.length;e.renderNodeCount=e===this.c?0:1;let k=!1;if(!e.collapsed||l!==i.TreeVisibility.Hidden){let A=0;for(const d of e.children)k=this.B(d,l,r,h&&!e.collapsed)||k,d.visible&&(d.visibleChildIndex=A++);e.visibleChildrenCount=A}else e.visibleChildrenCount=0;return e!==this.c&&(e.visible=l===i.TreeVisibility.Recurse?k:l===i.TreeVisibility.Visible,e.visibility=l),e.visible?e.collapsed||(e.renderNodeCount+=r.length-v):(e.renderNodeCount=0,h&&r.pop()),this.g.fire(e),e.visible}C(e,s){if(s!==0)for(;e;)e.renderNodeCount+=s,this.g.fire(e),e=e.parent}D(e,s){const r=this.k?this.k.filter(e.element,s):i.TreeVisibility.Visible;return typeof r=="boolean"?(e.filterData=void 0,r?i.TreeVisibility.Visible:i.TreeVisibility.Hidden):c(r)?(e.filterData=r.data,p(r.visibility)):(e.filterData=void 0,p(r))}E(e,s=this.c){if(!e||e.length===0)return!0;const[r,...h]=e;return r<0||r>s.children.length?!1:this.E(h,s.children[r])}F(e,s=this.c){if(!e||e.length===0)return s;const[r,...h]=e;if(r<0||r>s.children.length)throw new i.$TW(this.p,"Invalid tree location");return this.F(h,s.children[r])}G(e){if(e.length===0)return{node:this.c,listIndex:-1,revealed:!0,visible:!1};const{parentNode:s,listIndex:r,revealed:h,visible:l}=this.H(e),v=e[e.length-1];if(v<0||v>s.children.length)throw new i.$TW(this.p,"Invalid tree location");const k=s.children[v];return{node:k,listIndex:r,revealed:h,visible:l&&k.visible}}H(e,s=this.c,r=0,h=!0,l=!0){const[v,...k]=e;if(v<0||v>s.children.length)throw new i.$TW(this.p,"Invalid tree location");for(let A=0;A<v;A++)r+=s.children[A].renderNodeCount;return h=h&&!s.collapsed,l=l&&s.visible,k.length===0?{parentNode:s,listIndex:r,revealed:h,visible:l}:this.H(k,s.children[v],r+1,h,l)}getNode(e=[]){return this.F(e)}getNodeLocation(e){const s=[];let r=e;for(;r.parent;)s.push(r.parent.children.indexOf(r)),r=r.parent;return s.reverse()}getParentNodeLocation(e){if(e.length!==0)return e.length===1?[]:(0,n.$sb)(e)[0]}getFirstElementChild(e){const s=this.F(e);if(s.children.length!==0)return s.children[0].element}getLastElementAncestor(e=[]){const s=this.F(e);if(s.children.length!==0)return this.I(s)}I(e){return e.children.length===0?e.element:this.I(e.children[e.children.length-1])}}t.$XW=$}),define(we[116],ve([1,0,72,34,36]),function(re,t,i,n,j){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$5W=void 0;class F{get size(){return this.d.size}constructor(w,D,c={}){this.k=w,this.rootRef=null,this.d=new Map,this.f=new Map,this.c=new i.$XW(w,D,null,c),this.onDidSplice=this.c.onDidSplice,this.onDidChangeCollapseState=this.c.onDidChangeCollapseState,this.onDidChangeRenderNodeCount=this.c.onDidChangeRenderNodeCount,c.sorter&&(this.j={compare(p,y){return c.sorter.compare(p.element,y.element)}}),this.h=c.identityProvider}setChildren(w,D=j.Iterable.empty(),c={}){const p=this.o(w);this.l(p,this.m(D),c)}l(w,D=j.Iterable.empty(),c){const p=new Set,y=new Set,$=e=>{if(e.element===null)return;const s=e;if(p.add(s.element),this.d.set(s.element,s),this.h){const r=this.h.getId(s.element).toString();y.add(r),this.f.set(r,s)}c.onDidCreateNode?.(s)},g=e=>{if(e.element===null)return;const s=e;if(p.has(s.element)||this.d.delete(s.element),this.h){const r=this.h.getId(s.element).toString();y.has(r)||this.f.delete(r)}c.onDidDeleteNode?.(s)};this.c.splice([...w,0],Number.MAX_VALUE,D,{...c,onDidCreateNode:$,onDidDeleteNode:g})}m(w=j.Iterable.empty()){return this.j&&(w=[...w].sort(this.j.compare.bind(this.j))),j.Iterable.map(w,D=>{let c=this.d.get(D.element);if(!c&&this.h){const $=this.h.getId(D.element).toString();c=this.f.get($)}if(!c){let $;return typeof D.collapsed>"u"?$=void 0:D.collapsed===n.ObjectTreeElementCollapseState.Collapsed||D.collapsed===n.ObjectTreeElementCollapseState.PreserveOrCollapsed?$=!0:D.collapsed===n.ObjectTreeElementCollapseState.Expanded||D.collapsed===n.ObjectTreeElementCollapseState.PreserveOrExpanded?$=!1:$=!!D.collapsed,{...D,children:this.m(D.children),collapsed:$}}const p=typeof D.collapsible=="boolean"?D.collapsible:c.collapsible;let y;return typeof D.collapsed>"u"||D.collapsed===n.ObjectTreeElementCollapseState.PreserveOrCollapsed||D.collapsed===n.ObjectTreeElementCollapseState.PreserveOrExpanded?y=c.collapsed:D.collapsed===n.ObjectTreeElementCollapseState.Collapsed?y=!0:D.collapsed===n.ObjectTreeElementCollapseState.Expanded?y=!1:y=!!D.collapsed,{...D,collapsible:p,collapsed:y,children:this.m(D.children)}})}rerender(w){const D=this.o(w);this.c.rerender(D)}updateElementHeight(w,D){const c=this.o(w);this.c.updateElementHeight(c,D)}resort(w=null,D=!0){if(!this.j)return;const c=this.o(w),p=this.c.getNode(c);this.l(c,this.n(p,D),{})}n(w,D,c=!0){let p=[...w.children];return(D||c)&&(p=p.sort(this.j.compare.bind(this.j))),j.Iterable.map(p,y=>({element:y.element,collapsible:y.collapsible,collapsed:y.collapsed,children:this.n(y,D,!1)}))}getFirstElementChild(w=null){const D=this.o(w);return this.c.getFirstElementChild(D)}getLastElementAncestor(w=null){const D=this.o(w);return this.c.getLastElementAncestor(D)}has(w){return this.d.has(w)}getListIndex(w){const D=this.o(w);return this.c.getListIndex(D)}getListRenderCount(w){const D=this.o(w);return this.c.getListRenderCount(D)}isCollapsible(w){const D=this.o(w);return this.c.isCollapsible(D)}setCollapsible(w,D){const c=this.o(w);return this.c.setCollapsible(c,D)}isCollapsed(w){const D=this.o(w);return this.c.isCollapsed(D)}setCollapsed(w,D,c){const p=this.o(w);return this.c.setCollapsed(p,D,c)}expandTo(w){const D=this.o(w);this.c.expandTo(D)}refilter(){this.c.refilter()}getNode(w=null){if(w===null)return this.c.getNode(this.c.rootRef);const D=this.d.get(w);if(!D)throw new n.$TW(this.k,`Tree element not found: ${w}`);return D}getNodeLocation(w){return w.element}getParentNodeLocation(w){if(w===null)throw new n.$TW(this.k,"Invalid getParentNodeLocation call");const D=this.d.get(w);if(!D)throw new n.$TW(this.k,`Tree element not found: ${w}`);const c=this.c.getNodeLocation(D),p=this.c.getParentNodeLocation(c);return this.c.getNode(p).element}o(w){if(w===null)return[];const D=this.d.get(w);if(!D)throw new n.$TW(this.k,`Tree element not found: ${w}`);return this.c.getNodeLocation(D)}}t.$5W=F}),define(we[23],ve([1,0,4,15,19,32,2]),function(re,t,i,n,j,F,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$dU=void 0,i=He(i);class w extends N.$Tc{f(c,p){this.B(i.$sS(c,i.$tT.CLICK,y=>p(new j.$jS(i.getWindow(c),y))))}j(c,p){this.B(i.$sS(c,i.$tT.MOUSE_DOWN,y=>p(new j.$jS(i.getWindow(c),y))))}m(c,p){this.B(i.$sS(c,i.$tT.MOUSE_OVER,y=>p(new j.$jS(i.getWindow(c),y))))}u(c,p){this.B(i.$sS(c,i.$tT.MOUSE_LEAVE,y=>p(new j.$jS(i.getWindow(c),y))))}z(c,p){this.B(i.$sS(c,i.$tT.KEY_DOWN,y=>p(new n.$oS(y))))}C(c,p){this.B(i.$sS(c,i.$tT.KEY_UP,y=>p(new n.$oS(y))))}D(c,p){this.B(i.$sS(c,i.$tT.INPUT,p))}F(c,p){this.B(i.$sS(c,i.$tT.BLUR,p))}G(c,p){this.B(i.$sS(c,i.$tT.FOCUS,p))}H(c,p){this.B(i.$sS(c,i.$tT.CHANGE,p))}I(c){return F.$_T.ignoreTarget(c)}}t.$dU=w}),define(we[51],ve([1,0,71,23,12,22,4]),function(re,t,i,n,j,F,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$fU=t.$eU=void 0,N=He(N),t.$eU=11;class w extends n.$dU{constructor(c){super(),this.a=c.onActivate,this.bgDomNode=document.createElement("div"),this.bgDomNode.className="arrow-background",this.bgDomNode.style.position="absolute",this.bgDomNode.style.width=c.bgWidth+"px",this.bgDomNode.style.height=c.bgHeight+"px",typeof c.top<"u"&&(this.bgDomNode.style.top="0px"),typeof c.left<"u"&&(this.bgDomNode.style.left="0px"),typeof c.bottom<"u"&&(this.bgDomNode.style.bottom="0px"),typeof c.right<"u"&&(this.bgDomNode.style.right="0px"),this.domNode=document.createElement("div"),this.domNode.className=c.className,this.domNode.classList.add(...F.ThemeIcon.asClassNameArray(c.icon)),this.domNode.style.position="absolute",this.domNode.style.width=t.$eU+"px",this.domNode.style.height=t.$eU+"px",typeof c.top<"u"&&(this.domNode.style.top=c.top+"px"),typeof c.left<"u"&&(this.domNode.style.left=c.left+"px"),typeof c.bottom<"u"&&(this.domNode.style.bottom=c.bottom+"px"),typeof c.right<"u"&&(this.domNode.style.right=c.right+"px"),this.g=this.B(new i.$cU),this.B(N.$tS(this.bgDomNode,N.$tT.POINTER_DOWN,p=>this.h(p))),this.B(N.$tS(this.domNode,N.$tT.POINTER_DOWN,p=>this.h(p))),this.b=this.B(new N.$ES),this.c=this.B(new j.$Mh)}h(c){if(!c.target||!(c.target instanceof Element))return;const p=()=>{this.b.cancelAndSet(()=>this.a(),1e3/24,N.getWindow(c))};this.a(),this.b.cancel(),this.c.cancelAndSet(p,200),this.g.startMonitoring(c.target,c.pointerId,c.buttons,y=>{},()=>{this.b.cancel(),this.c.cancel()}),c.preventDefault()}}t.$fU=w}),define(we[73],ve([1,0,4,55,71,51,114,23,5]),function(re,t,i,n,j,F,N,w,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$iU=void 0,i=He(i),D=He(D);const c=140;class p extends w.$dU{constructor($){super(),this.g=$.lazyRender,this.a=$.host,this.b=$.scrollable,this.c=$.scrollByPage,this.h=$.scrollbarState,this.n=this.B(new N.$hU($.visibility,"visible scrollbar "+$.extraScrollbarClassName,"invisible scrollbar "+$.extraScrollbarClassName)),this.n.setIsNeeded(this.h.isNeeded()),this.r=this.B(new j.$cU),this.s=!0,this.domNode=(0,n.$bU)(document.createElement("div")),this.domNode.setAttribute("role","presentation"),this.domNode.setAttribute("aria-hidden","true"),this.n.setDomNode(this.domNode),this.domNode.setPosition("absolute"),this.B(i.$sS(this.domNode.domNode,i.$tT.POINTER_DOWN,g=>this.M(g)))}t($){const g=this.B(new F.$fU($));this.domNode.domNode.appendChild(g.bgDomNode),this.domNode.domNode.appendChild(g.domNode)}w($,g,e,s){this.slider=(0,n.$bU)(document.createElement("div")),this.slider.setClassName("slider"),this.slider.setPosition("absolute"),this.slider.setTop($),this.slider.setLeft(g),typeof e=="number"&&this.slider.setWidth(e),typeof s=="number"&&this.slider.setHeight(s),this.slider.setLayerHinting(!0),this.slider.setContain("strict"),this.domNode.domNode.appendChild(this.slider.domNode),this.B(i.$sS(this.slider.domNode,i.$tT.POINTER_DOWN,r=>{r.button===0&&(r.preventDefault(),this.O(r))})),this.f(this.slider.domNode,r=>{r.leftButton&&r.stopPropagation()})}y($){return this.h.setVisibleSize($)&&(this.n.setIsNeeded(this.h.isNeeded()),this.s=!0,this.g||this.render()),this.s}J($){return this.h.setScrollSize($)&&(this.n.setIsNeeded(this.h.isNeeded()),this.s=!0,this.g||this.render()),this.s}L($){return this.h.setScrollPosition($)&&(this.n.setIsNeeded(this.h.isNeeded()),this.s=!0,this.g||this.render()),this.s}beginReveal(){this.n.setShouldBeVisible(!0)}beginHide(){this.n.setShouldBeVisible(!1)}render(){this.s&&(this.s=!1,this.Q(this.h.getRectangleLargeSize(),this.h.getRectangleSmallSize()),this.R(this.h.getSliderSize(),this.h.getArrowSize()+this.h.getSliderPosition()))}M($){$.target===this.domNode.domNode&&this.N($)}delegatePointerDown($){const g=this.domNode.domNode.getClientRects()[0].top,e=g+this.h.getSliderPosition(),s=g+this.h.getSliderPosition()+this.h.getSliderSize(),r=this.U($);e<=r&&r<=s?$.button===0&&($.preventDefault(),this.O($)):this.N($)}N($){let g,e;if($.target===this.domNode.domNode&&typeof $.offsetX=="number"&&typeof $.offsetY=="number")g=$.offsetX,e=$.offsetY;else{const r=i.$OS(this.domNode.domNode);g=$.pageX-r.left,e=$.pageY-r.top}const s=this.S(g,e);this.P(this.c?this.h.getDesiredScrollPositionFromOffsetPaged(s):this.h.getDesiredScrollPositionFromOffset(s)),$.button===0&&($.preventDefault(),this.O($))}O($){if(!$.target||!($.target instanceof Element))return;const g=this.U($),e=this.W($),s=this.h.clone();this.slider.toggleClassName("active",!0),this.r.startMonitoring($.target,$.pointerId,$.buttons,r=>{const h=this.W(r),l=Math.abs(h-e);if(D.$j&&l>c){this.P(s.getScrollPosition());return}const k=this.U(r)-g;this.P(s.getDesiredScrollPositionFromDelta(k))},()=>{this.slider.toggleClassName("active",!1),this.a.onDragEnd()}),this.a.onDragStart()}P($){const g={};this.writeScrollPosition(g,$),this.b.setScrollPositionNow(g)}updateScrollbarSize($){this.X($),this.h.setScrollbarSize($),this.s=!0,this.g||this.render()}isNeeded(){return this.h.isNeeded()}}t.$iU=p}),define(we[117],ve([1,0,19,73,51,56,21,20]),function(re,t,i,n,j,F,N,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$jU=void 0;class D extends n.$iU{constructor(p,y,$){const g=p.getScrollDimensions(),e=p.getCurrentScrollPosition();if(super({lazyRender:y.lazyRender,host:$,scrollbarState:new F.$gU(y.horizontalHasArrows?y.arrowSize:0,y.horizontal===w.ScrollbarVisibility.Hidden?0:y.horizontalScrollbarSize,y.vertical===w.ScrollbarVisibility.Hidden?0:y.verticalScrollbarSize,g.width,g.scrollWidth,e.scrollLeft),visibility:y.horizontal,extraScrollbarClassName:"horizontal",scrollable:p,scrollByPage:y.scrollByPage}),y.horizontalHasArrows){const s=(y.arrowSize-j.$eU)/2,r=(y.horizontalScrollbarSize-j.$eU)/2;this.t({className:"scra",icon:N.$2j.scrollbarButtonLeft,top:r,left:s,bottom:void 0,right:void 0,bgWidth:y.arrowSize,bgHeight:y.horizontalScrollbarSize,onActivate:()=>this.a.onMouseWheel(new i.$lS(null,1,0))}),this.t({className:"scra",icon:N.$2j.scrollbarButtonRight,top:r,left:void 0,bottom:void 0,right:s,bgWidth:y.arrowSize,bgHeight:y.horizontalScrollbarSize,onActivate:()=>this.a.onMouseWheel(new i.$lS(null,-1,0))})}this.w(Math.floor((y.horizontalScrollbarSize-y.horizontalSliderSize)/2),0,void 0,y.horizontalSliderSize)}R(p,y){this.slider.setWidth(p),this.slider.setLeft(y)}Q(p,y){this.domNode.setWidth(p),this.domNode.setHeight(y),this.domNode.setLeft(0),this.domNode.setBottom(0)}onDidScroll(p){return this.s=this.J(p.scrollWidth)||this.s,this.s=this.L(p.scrollLeft)||this.s,this.s=this.y(p.width)||this.s,this.s}S(p,y){return p}U(p){return p.pageX}W(p){return p.pageY}X(p){this.slider.setHeight(p)}writeScrollPosition(p,y){p.scrollLeft=y}updateOptions(p){this.updateScrollbarSize(p.horizontal===w.ScrollbarVisibility.Hidden?0:p.horizontalScrollbarSize),this.h.setOppositeScrollbarSize(p.vertical===w.ScrollbarVisibility.Hidden?0:p.verticalScrollbarSize),this.n.setVisibility(p.horizontal),this.c=p.scrollByPage}}t.$jU=D}),define(we[118],ve([1,0,19,73,51,56,21,20]),function(re,t,i,n,j,F,N,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$kU=void 0;class D extends n.$iU{constructor(p,y,$){const g=p.getScrollDimensions(),e=p.getCurrentScrollPosition();if(super({lazyRender:y.lazyRender,host:$,scrollbarState:new F.$gU(y.verticalHasArrows?y.arrowSize:0,y.vertical===w.ScrollbarVisibility.Hidden?0:y.verticalScrollbarSize,0,g.height,g.scrollHeight,e.scrollTop),visibility:y.vertical,extraScrollbarClassName:"vertical",scrollable:p,scrollByPage:y.scrollByPage}),y.verticalHasArrows){const s=(y.arrowSize-j.$eU)/2,r=(y.verticalScrollbarSize-j.$eU)/2;this.t({className:"scra",icon:N.$2j.scrollbarButtonUp,top:s,left:r,bottom:void 0,right:void 0,bgWidth:y.verticalScrollbarSize,bgHeight:y.arrowSize,onActivate:()=>this.a.onMouseWheel(new i.$lS(null,0,1))}),this.t({className:"scra",icon:N.$2j.scrollbarButtonDown,top:void 0,left:r,bottom:s,right:void 0,bgWidth:y.verticalScrollbarSize,bgHeight:y.arrowSize,onActivate:()=>this.a.onMouseWheel(new i.$lS(null,0,-1))})}this.w(0,Math.floor((y.verticalScrollbarSize-y.verticalSliderSize)/2),y.verticalSliderSize,void 0)}R(p,y){this.slider.setHeight(p),this.slider.setTop(y)}Q(p,y){this.domNode.setWidth(y),this.domNode.setHeight(p),this.domNode.setRight(0),this.domNode.setTop(0)}onDidScroll(p){return this.s=this.J(p.scrollHeight)||this.s,this.s=this.L(p.scrollTop)||this.s,this.s=this.y(p.height)||this.s,this.s}S(p,y){return y}U(p){return p.pageY}W(p){return p.pageX}X(p){this.slider.setWidth(p)}writeScrollPosition(p,y){p.scrollTop=y}updateOptions(p){this.updateScrollbarSize(p.vertical===w.ScrollbarVisibility.Hidden?0:p.verticalScrollbarSize),this.h.setOppositeScrollbarSize(0),this.n.setVisibility(p.vertical),this.c=p.scrollByPage}}t.$kU=D}),define(we[119],ve([1,0,6,67,50,11,16]),function(re,t,i,n,j,F,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$1k=t.MarkdownStringTextNewlineStyle=void 0,t.$2k=c,t.$3k=p,t.$4k=y,t.$5k=$,t.$6k=g,t.$7k=e,t.$8k=s,t.$9k=r;var w;(function(h){h[h.Paragraph=0]="Paragraph",h[h.Break=1]="Break"})(w||(t.MarkdownStringTextNewlineStyle=w={}));class D{constructor(l="",v=!1){if(this.value=l,typeof this.value!="string")throw(0,i.$6)("value");typeof v=="boolean"?(this.isTrusted=v,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=v.isTrusted??void 0,this.supportThemeIcons=v.supportThemeIcons??!1,this.supportHtml=v.supportHtml??!1)}appendText(l,v=w.Paragraph){return this.value+=$(this.supportThemeIcons?(0,n.$Uk)(l):l).replace(/([ \t]+)/g,(k,A)=>"&nbsp;".repeat(A.length)).replace(/\>/gm,"\\>").replace(/\n/g,v===w.Break?`\\
`:`

`),this}appendMarkdown(l){return this.value+=l,this}appendCodeblock(l,v){return this.value+=`
${g(v,l)}
`,this}appendLink(l,v,k){return this.value+="[",this.value+=this.c(v,"]"),this.value+="](",this.value+=this.c(String(l),")"),k&&(this.value+=` "${this.c(this.c(k,'"'),")")}"`),this.value+=")",this}c(l,v){const k=new RegExp((0,F.$ff)(v),"g");return l.replace(k,(A,d)=>l.charAt(d-1)!=="\\"?`\\${A}`:A)}}t.$1k=D;function c(h){return p(h)?!h.value:Array.isArray(h)?h.every(c):!0}function p(h){return h instanceof D?!0:h&&typeof h=="object"?typeof h.value=="string"&&(typeof h.isTrusted=="boolean"||typeof h.isTrusted=="object"||h.isTrusted===void 0)&&(typeof h.supportThemeIcons=="boolean"||h.supportThemeIcons===void 0):!1}function y(h,l){return h===l?!0:!h||!l?!1:h.value===l.value&&h.isTrusted===l.isTrusted&&h.supportThemeIcons===l.supportThemeIcons&&h.supportHtml===l.supportHtml&&(h.baseUri===l.baseUri||!!h.baseUri&&!!l.baseUri&&(0,j.$9g)(N.URI.from(h.baseUri),N.URI.from(l.baseUri)))}function $(h){return h.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}function g(h,l){const v=h.match(/^`+/gm)?.reduce((A,d)=>A.length>d.length?A:d).length??0,k=v>=3?v+1:3;return[`${"`".repeat(k)}${l}`,h,`${"`".repeat(k)}`].join(`
`)}function e(h){return h.replace(/"/g,"&quot;")}function s(h){return h&&h.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}function r(h){const l=[],v=h.split("|").map(A=>A.trim());h=v[0];const k=v[1];if(k){const A=/height=(\d+)/.exec(k),d=/width=(\d+)/.exec(k),f=A?A[1]:"",b=d?d[1]:"",S=isFinite(parseInt(b)),U=isFinite(parseInt(f));S&&l.push(`width="${b}"`),U&&l.push(`height="${f}"`)}return{href:h,dimensions:l}}}),define(we[120],ve([1,0,4,111,29,70,15,19,112,6,3,119,67,90,8,25,2,92,68,39,64,50,11,16]),function(re,t,i,n,j,F,N,w,D,c,p,y,$,g,e,s,r,h,l,v,k,A,d,f){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$dV=void 0,t.$cV=S,t.$eV=z,t.$fV=O,t.$gV=ue,i=He(i),n=He(n);const b=Object.freeze({image:(a,o,m)=>{let M=[],R=[];return a&&({href:a,dimensions:M}=(0,y.$9k)(a),R.push(`src="${(0,y.$7k)(a)}"`)),m&&R.push(`alt="${(0,y.$7k)(m)}"`),o&&R.push(`title="${(0,y.$7k)(o)}"`),M.length&&(R=R.concat(M)),"<img "+R.join(" ")+">"},paragraph:a=>`<p>${a}</p>`,link:(a,o,m)=>typeof a!="string"?"":(a===m&&(m=(0,y.$8k)(m)),o=typeof o=="string"?(0,y.$7k)((0,y.$8k)(o)):"",a=(0,y.$8k)(a),a=a.replace(/&/g,"&amp;").replace(/</g,"&lt;").replace(/>/g,"&gt;").replace(/"/g,"&quot;").replace(/'/g,"&#39;"),`<a href="${a}" title="${o||a}" draggable="false">${m}</a>`)});function S(a,o={},m={}){const M=new r.$Sc;let R=!1;const u=(0,F.$FU)(o),L=function(De){let Le;try{Le=(0,l.$$h)(decodeURIComponent(De))}catch{}return Le?(Le=(0,k.$do)(Le,Te=>{if(a.uris&&a.uris[Te])return f.URI.revive(a.uris[Te])}),encodeURIComponent(JSON.stringify(Le))):De},T=function(De,Le){const Te=a.uris&&a.uris[De];let fe=f.URI.revive(Te);return Le?De.startsWith(v.Schemas.data+":")?De:(fe||(fe=f.URI.parse(De)),v.$Wg.uriToBrowserUri(fe).toString(!0)):!fe||f.URI.parse(De).toString()===fe.toString()?De:(fe.query&&(fe=fe.with({query:L(fe.query)})),fe.toString())},P=new h.marked.Renderer;P.image=b.image,P.link=b.link,P.paragraph=b.paragraph;const H=[],X=[];if(o.codeBlockRendererSync?P.code=(De,Le)=>{const Te=g.$bQ.nextId(),fe=o.codeBlockRendererSync(U(Le),De);return X.push([Te,fe]),`<div class="code" data-code="${Te}">${(0,d.$ef)(De)}</div>`}:o.codeBlockRenderer&&(P.code=(De,Le)=>{const Te=g.$bQ.nextId(),fe=o.codeBlockRenderer(U(Le),De);return H.push(fe.then(Re=>[Te,Re])),`<div class="code" data-code="${Te}">${(0,d.$ef)(De)}</div>`}),o.actionHandler){const De=function(fe){let Re=fe.target;if(!(Re.tagName!=="A"&&(Re=Re.parentElement,!Re||Re.tagName!=="A")))try{let Ke=Re.dataset.href;Ke&&(a.baseUri&&(Ke=_(f.URI.from(a.baseUri),Ke)),o.actionHandler.callback(Ke,fe))}catch(Ke){(0,c.$Y)(Ke)}finally{fe.preventDefault()}},Le=o.actionHandler.disposables.add(new j.$GU(u,"click")),Te=o.actionHandler.disposables.add(new j.$GU(u,"auxclick"));o.actionHandler.disposables.add(p.Event.any(Le.event,Te.event)(fe=>{const Re=new w.$jS(i.getWindow(u),fe);!Re.leftButton&&!Re.middleButton||De(Re)})),o.actionHandler.disposables.add(i.$sS(u,"keydown",fe=>{const Re=new N.$oS(fe);!Re.equals(e.KeyCode.Space)&&!Re.equals(e.KeyCode.Enter)||De(Re)}))}a.supportHtml||(m.sanitizer=De=>o.sanitizerOptions?.replaceWithPlaintext?(0,d.$ef)(De):(a.isTrusted?De.match(/^(<span[^>]+>)|(<\/\s*span>)$/):void 0)?De:"",m.sanitize=!0,m.silent=!0),m.renderer=P;let ie=a.value??"";ie.length>1e5&&(ie=`${ie.substr(0,1e5)}\u2026`),a.supportThemeIcons&&(ie=(0,$.$Vk)(ie));let oe;if(o.fillInIncompleteTokens){const De={...h.marked.defaults,...m},Le=h.marked.lexer(ie,De),Te=ue(Le);oe=h.marked.parser(Te,De)}else oe=h.marked.parse(ie,m);a.supportThemeIcons&&(oe=(0,D.$aV)(oe).map(Le=>typeof Le=="string"?Le:Le.outerHTML).join(""));const ye=new DOMParser().parseFromString(E({isTrusted:a.isTrusted,...o.sanitizerOptions},oe),"text/html");if(ye.body.querySelectorAll("img, audio, video, source").forEach(De=>{const Le=De.getAttribute("src");if(Le){let Te=Le;try{a.baseUri&&(Te=_(f.URI.from(a.baseUri),Te))}catch{}if(De.setAttribute("src",T(Te,!0)),o.remoteImageIsAllowed){const fe=f.URI.parse(Te);fe.scheme!==v.Schemas.file&&fe.scheme!==v.Schemas.data&&!o.remoteImageIsAllowed(fe)&&De.replaceWith(i.$("",void 0,De.outerHTML))}}}),ye.body.querySelectorAll("a").forEach(De=>{const Le=De.getAttribute("href");if(De.setAttribute("href",""),!Le||/^data:|javascript:/i.test(Le)||/^command:/i.test(Le)&&!a.isTrusted||/^command:(\/\/\/)?_workbench\.downloadResource/i.test(Le))De.replaceWith(...De.childNodes);else{let Te=T(Le,!1);a.baseUri&&(Te=_(f.URI.from(a.baseUri),Le)),De.dataset.href=Te}}),u.innerHTML=E({isTrusted:a.isTrusted,...o.sanitizerOptions},ye.body.innerHTML),H.length>0)Promise.all(H).then(De=>{if(R)return;const Le=new Map(De),Te=u.querySelectorAll("div[data-code]");for(const fe of Te){const Re=Le.get(fe.dataset.code??"");Re&&i.$CT(fe,Re)}o.asyncRenderCallback?.()});else if(X.length>0){const De=new Map(X),Le=u.querySelectorAll("div[data-code]");for(const Te of Le){const fe=De.get(Te.dataset.code??"");fe&&i.$CT(Te,fe)}}if(o.asyncRenderCallback)for(const De of u.getElementsByTagName("img")){const Le=M.add(i.$sS(De,"load",()=>{Le.dispose(),o.asyncRenderCallback()}))}return{element:u,dispose:()=>{R=!0,M.dispose()}}}function U(a){if(!a)return"";const o=a.split(/[\s+|:|,|\{|\?]/,1);return o.length?o[0]:a}function _(a,o){return/^\w[\w\d+.-]*:/.test(o)?o:a.path.endsWith("/")?(0,A.$gh)(a,o).toString():(0,A.$gh)((0,A.$ch)(a),o).toString()}const B=["area","base","br","col","command","embed","hr","img","input","keygen","link","meta","param","source","track","wbr"];function E(a,o){const{config:m,allowedSchemes:M}=I(a),R=new r.$Sc;R.add(W("uponSanitizeAttribute",(u,L)=>{if(L.attrName==="style"||L.attrName==="class"){if(u.tagName==="SPAN"){if(L.attrName==="style"){L.keepAttr=/^(color\:(#[0-9a-fA-F]+|var\(--vscode(-[a-zA-Z]+)+\));)?(background-color\:(#[0-9a-fA-F]+|var\(--vscode(-[a-zA-Z]+)+\));)?$/.test(L.attrValue);return}else if(L.attrName==="class"){L.keepAttr=/^codicon codicon-[a-z\-]+( codicon-modifier-[a-z\-]+)?$/.test(L.attrValue);return}}L.keepAttr=!1;return}else if(u.tagName==="INPUT"&&u.attributes.getNamedItem("type")?.value==="checkbox"){if(L.attrName==="type"&&L.attrValue==="checkbox"||L.attrName==="disabled"||L.attrName==="checked"){L.keepAttr=!0;return}L.keepAttr=!1}})),R.add(W("uponSanitizeElement",(u,L)=>{if(L.tagName==="input"&&(u.attributes.getNamedItem("type")?.value==="checkbox"?u.setAttribute("disabled",""):a.replaceWithPlaintext||u.remove()),a.replaceWithPlaintext&&!L.allowedTags[L.tagName]&&L.tagName!=="body"&&u.parentElement){let T,P;if(L.tagName==="#comment")T=`<!--${u.textContent}-->`;else{const oe=B.includes(L.tagName),de=u.attributes.length?" "+Array.from(u.attributes).map(ye=>`${ye.name}="${ye.value}"`).join(" "):"";T=`<${L.tagName}${de}>`,oe||(P=`</${L.tagName}>`)}const H=document.createDocumentFragment(),X=u.parentElement.ownerDocument.createTextNode(T);H.appendChild(X);const ie=P?u.parentElement.ownerDocument.createTextNode(P):void 0;for(;u.firstChild;)H.appendChild(u.firstChild);ie&&H.appendChild(ie),u.parentElement.replaceChild(H,u)}})),R.add(i.$WT(M));try{return n.sanitize(o,{...m,RETURN_TRUSTED_TYPE:!0})}finally{R.dispose()}}t.$dV=["align","autoplay","alt","checked","class","colspan","controls","data-code","data-href","disabled","draggable","height","href","loop","muted","playsinline","poster","rowspan","src","style","target","title","type","width","start"];function I(a){const o=[v.Schemas.http,v.Schemas.https,v.Schemas.mailto,v.Schemas.data,v.Schemas.file,v.Schemas.vscodeFileResource,v.Schemas.vscodeRemote,v.Schemas.vscodeRemoteResource];return a.isTrusted&&o.push(v.Schemas.command),{config:{ALLOWED_TAGS:a.allowedTags??[...i.$XT],ALLOWED_ATTR:t.$dV,ALLOW_UNKNOWN_PROTOCOLS:!0},allowedSchemes:o}}function z(a){return typeof a=="string"?a:O(a)}function O(a,o){let m=a.value??"";m.length>1e5&&(m=`${m.substr(0,1e5)}\u2026`);const M=h.marked.parse(m,{renderer:o?Y.value:Z.value}).replace(/&(#\d+|[a-zA-Z]+);/g,R=>C.get(R)??R);return E({isTrusted:!1},M).toString()}const C=new Map([["&quot;",'"'],["&nbsp;"," "],["&amp;","&"],["&#39;","'"],["&lt;","<"],["&gt;",">"]]);function x(){const a=new h.marked.Renderer;return a.code=o=>o,a.blockquote=o=>o,a.html=o=>"",a.heading=(o,m,M)=>o+`
`,a.hr=()=>"",a.list=(o,m)=>o,a.listitem=o=>o+`
`,a.paragraph=o=>o+`
`,a.table=(o,m)=>o+m+`
`,a.tablerow=o=>o,a.tablecell=(o,m)=>o+" ",a.strong=o=>o,a.em=o=>o,a.codespan=o=>o,a.br=()=>`
`,a.del=o=>o,a.image=(o,m,M)=>"",a.text=o=>o,a.link=(o,m,M)=>M,a}const Z=new s.$T(a=>x()),Y=new s.$T(()=>{const a=x();return a.code=o=>`
\`\`\`
${o}
\`\`\`
`,a});function q(a){let o="";return a.forEach(m=>{o+=m.raw}),o}function ee(a){if(a.tokens)for(let o=a.tokens.length-1;o>=0;o--){const m=a.tokens[o];if(m.type==="text"){const M=m.raw.split(`
`),R=M[M.length-1];if(R.includes("`"))return le(a);if(R.includes("**"))return Ie(a);if(R.match(/\*\w/))return Ne(a);if(R.match(/(^|\s)__\w/))return Ce(a);if(R.match(/(^|\s)_\w/))return te(a);if(ce(R)||be(R)&&a.tokens.slice(0,o).some(u=>u.type==="text"&&u.raw.match(/\[[^\]]*$/))){const u=a.tokens.slice(o+1);return u[0]?.type==="link"&&u[1]?.type==="text"&&u[1].raw.match(/^ *"[^"]*$/)||R.match(/^[^"]* +"[^"]*$/)?Ae(a):$e(a)}else if(R.match(/(^|\s)\[\w*/))return Oe(a)}}}function ce(a){return!!a.match(/(^|\s)\[.*\]\(\w*/)}function be(a){return!!a.match(/^[^\[]*\]\([^\)]*$/)}function ke(a){const o=a.items[a.items.length-1],m=o.tokens?o.tokens[o.tokens.length-1]:void 0;let M;if(m?.type==="text"&&!("inRawBlock"in o)&&(M=ee(m)),!M||M.type!=="paragraph")return;const R=q(a.items.slice(0,-1)),u=o.raw.match(/^(\s*(-|\d+\.|\*) +)/)?.[0];if(!u)return;const L=u+q(o.tokens.slice(0,-1))+M.raw,T=h.marked.lexer(R+L)[0];if(T.type==="list")return T}const Fe=3;function ue(a){for(let o=0;o<Fe;o++){const m=Q(a);if(m)a=m;else break}return a}function Q(a){let o,m;for(o=0;o<a.length;o++){const M=a[o];let R;if(M.type==="paragraph"&&(R=M.raw.match(/(\n|^)(````*)/))){const u=R[2];m=he(a.slice(o),u);break}if(M.type==="paragraph"&&M.raw.match(/(\n|^)\|/)){m=K(a.slice(o));break}if(o===a.length-1&&M.type==="list"){const u=ke(M);if(u){m=[u];break}}if(o===a.length-1&&M.type==="paragraph"){const u=ee(M);if(u){m=[u];break}}}if(m){const M=[...a.slice(0,o),...m];return M.links=a.links,M}return null}function he(a,o){const m=q(a);return h.marked.lexer(m+`
${o}`)}function le(a){return se(a,"`")}function Ne(a){return se(a,"*")}function te(a){return se(a,"_")}function $e(a){return se(a,")")}function Ae(a){return se(a,'")')}function Oe(a){return se(a,"](https://microsoft.com)")}function Ie(a){return se(a,"**")}function Ce(a){return se(a,"__")}function se(a,o){const m=q(Array.isArray(a)?a:[a]);return h.marked.lexer(m+o)[0]}function K(a){const o=q(a),m=o.split(`
`);let M,R=!1;for(let u=0;u<m.length;u++){const L=m[u].trim();if(typeof M>"u"&&L.match(/^\s*\|/)){const T=L.match(/(\|[^\|]+)(?=\||$)/g);T&&(M=T.length)}else if(typeof M=="number")if(L.match(/^\s*\|/)){if(u!==m.length-1)return;R=!0}else return}if(typeof M=="number"&&M>0){const u=R?m.slice(0,-1).join(`
`):o,L=!!u.match(/\|\s*$/),T=u+(L?"":"|")+`
|${" --- |".repeat(M)}`;return h.marked.lexer(T)}}function W(a,o){return n.addHook(a,o),(0,r.$Rc)(()=>n.removeHook(a))}}),define(we[121],ve([1,0]),function(re,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$GX=t.$FX=void 0,t.$FX="vscode:contextmenu",t.$GX="vscode:onCloseContextMenu"}),define(we[74],ve([1,0,9,12,47,38,35,6,3,2,68,11,10]),function(re,t,i,n,j,F,N,w,D,c,p,y,$){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$li=t.ProxyChannel=t.$ki=t.$hi=t.$gi=t.$fi=t.RequestInitiator=t.$ei=t.$bi=t.$ai=void 0,t.$ci=_,t.$di=B,t.$ii=x,t.$ji=Z,y=He(y);var g;(function(ue){ue[ue.Promise=100]="Promise",ue[ue.PromiseCancel=101]="PromiseCancel",ue[ue.EventListen=102]="EventListen",ue[ue.EventDispose=103]="EventDispose"})(g||(g={}));function e(ue){switch(ue){case g.Promise:return"req";case g.PromiseCancel:return"cancel";case g.EventListen:return"subscribe";case g.EventDispose:return"unsubscribe"}}var s;(function(ue){ue[ue.Initialize=200]="Initialize",ue[ue.PromiseSuccess=201]="PromiseSuccess",ue[ue.PromiseError=202]="PromiseError",ue[ue.PromiseErrorObj=203]="PromiseErrorObj",ue[ue.EventFire=204]="EventFire"})(s||(s={}));function r(ue){switch(ue){case s.Initialize:return"init";case s.PromiseSuccess:return"reply:";case s.PromiseError:case s.PromiseErrorObj:return"replyErr:";case s.EventFire:return"event:"}}var h;(function(ue){ue[ue.Uninitialized=0]="Uninitialized",ue[ue.Idle=1]="Idle"})(h||(h={}));function l(ue){let Q=0;for(let he=0;;he+=7){const le=ue.read(1);if(Q|=(le.buffer[0]&127)<<he,!(le.buffer[0]&128))return Q}}const v=b(0);function k(ue,Q){if(Q===0){ue.write(v);return}let he=0;for(let Ne=Q;Ne!==0;Ne=Ne>>>7)he++;const le=j.$Le.alloc(he);for(let Ne=0;Q!==0;Ne++)le.buffer[Ne]=Q&127,Q=Q>>>7,Q>0&&(le.buffer[Ne]|=128);ue.write(le)}class A{constructor(Q){this.b=Q,this.a=0}read(Q){const he=this.b.slice(this.a,this.a+Q);return this.a+=he.byteLength,he}}t.$ai=A;class d{constructor(){this.a=[]}get buffer(){return j.$Le.concat(this.a)}write(Q){this.a.push(Q)}}t.$bi=d;var f;(function(ue){ue[ue.Undefined=0]="Undefined",ue[ue.String=1]="String",ue[ue.Buffer=2]="Buffer",ue[ue.VSBuffer=3]="VSBuffer",ue[ue.Array=4]="Array",ue[ue.Object=5]="Object",ue[ue.Int=6]="Int"})(f||(f={}));function b(ue){const Q=j.$Le.alloc(1);return Q.writeUInt8(ue,0),Q}const S={Undefined:b(f.Undefined),String:b(f.String),Buffer:b(f.Buffer),VSBuffer:b(f.VSBuffer),Array:b(f.Array),Object:b(f.Object),Uint:b(f.Int)},U=typeof Buffer<"u";function _(ue,Q){if(typeof Q>"u")ue.write(S.Undefined);else if(typeof Q=="string"){const he=j.$Le.fromString(Q);ue.write(S.String),k(ue,he.byteLength),ue.write(he)}else if(U&&Buffer.isBuffer(Q)){const he=j.$Le.wrap(Q);ue.write(S.Buffer),k(ue,he.byteLength),ue.write(he)}else if(Q instanceof j.$Le)ue.write(S.VSBuffer),k(ue,Q.byteLength),ue.write(Q);else if(Array.isArray(Q)){ue.write(S.Array),k(ue,Q.length);for(const he of Q)_(ue,he)}else if(typeof Q=="number"&&(Q|0)===Q)ue.write(S.Uint),k(ue,Q);else{const he=j.$Le.fromString(JSON.stringify(Q));ue.write(S.Object),k(ue,he.byteLength),ue.write(he)}}function B(ue){switch(ue.read(1).readUInt8(0)){case f.Undefined:return;case f.String:return ue.read(l(ue)).toString();case f.Buffer:return ue.read(l(ue)).buffer;case f.VSBuffer:return ue.read(l(ue));case f.Array:{const he=l(ue),le=[];for(let Ne=0;Ne<he;Ne++)le.push(B(ue));return le}case f.Object:return JSON.parse(ue.read(l(ue)).toString());case f.Int:return l(ue)}}class E{constructor(Q,he,le=null,Ne=1e3){this.h=Q,this.j=he,this.k=le,this.l=Ne,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(te=>this.q(te)),this.m({type:s.Initialize})}registerChannel(Q,he){this.b.set(Q,he),setTimeout(()=>this.w(Q),0)}m(Q){switch(Q.type){case s.Initialize:{const he=this.o([Q.type]);this.k?.logOutgoing(he,0,I.OtherSide,r(Q.type));return}case s.PromiseSuccess:case s.PromiseError:case s.EventFire:case s.PromiseErrorObj:{const he=this.o([Q.type,Q.id],Q.data);this.k?.logOutgoing(he,Q.id,I.OtherSide,r(Q.type),Q.data);return}}}o(Q,he=void 0){const le=new d;return _(le,Q),_(le,he),this.p(le.buffer)}p(Q){try{return this.h.send(Q),Q.byteLength}catch{return 0}}q(Q){const he=new A(Q),le=B(he),Ne=B(he),te=le[0];switch(te){case g.Promise:return this.k?.logIncoming(Q.byteLength,le[1],I.OtherSide,`${e(te)}: ${le[2]}.${le[3]}`,Ne),this.s({type:te,id:le[1],channelName:le[2],name:le[3],arg:Ne});case g.EventListen:return this.k?.logIncoming(Q.byteLength,le[1],I.OtherSide,`${e(te)}: ${le[2]}.${le[3]}`,Ne),this.t({type:te,id:le[1],channelName:le[2],name:le[3],arg:Ne});case g.PromiseCancel:return this.k?.logIncoming(Q.byteLength,le[1],I.OtherSide,`${e(te)}`),this.u({type:te,id:le[1]});case g.EventDispose:return this.k?.logIncoming(Q.byteLength,le[1],I.OtherSide,`${e(te)}`),this.u({type:te,id:le[1]})}}s(Q){const he=this.b.get(Q.channelName);if(!he){this.v(Q);return}const le=new F.$ue;let Ne;try{Ne=he.call(this.j,Q.name,Q.arg,le.token)}catch(Ae){Ne=Promise.reject(Ae)}const te=Q.id;Ne.then(Ae=>{this.m({id:te,data:Ae,type:s.PromiseSuccess})},Ae=>{Ae instanceof Error?this.m({id:te,data:{message:Ae.message,name:Ae.name,stack:Ae.stack?Ae.stack.split(`
`):void 0},type:s.PromiseError}):this.m({id:te,data:Ae,type:s.PromiseErrorObj})}).finally(()=>{$e.dispose(),this.d.delete(Q.id)});const $e=(0,c.$Rc)(()=>le.cancel());this.d.set(Q.id,$e)}t(Q){const he=this.b.get(Q.channelName);if(!he){this.v(Q);return}const le=Q.id,te=he.listen(this.j,Q.name,Q.arg)($e=>this.m({id:le,data:$e,type:s.EventFire}));this.d.set(Q.id,te)}u(Q){const he=this.d.get(Q.id);he&&(he.dispose(),this.d.delete(Q.id))}v(Q){let he=this.g.get(Q.channelName);he||(he=[],this.g.set(Q.channelName,he));const le=setTimeout(()=>{console.error(`Unknown channel: ${Q.channelName}`),Q.type===g.Promise&&this.m({id:Q.id,data:{name:"Unknown channel",message:`Channel name '${Q.channelName}' timed out after ${this.l}ms`,stack:void 0},type:s.PromiseError})},this.l);he.push({request:Q,timeoutTimer:le})}w(Q){const he=this.g.get(Q);if(he){for(const le of he)switch(clearTimeout(le.timeoutTimer),le.request.type){case g.Promise:this.s(le.request);break;case g.EventListen:this.t(le.request);break}this.g.delete(Q)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,c.$Oc)(this.d.values()),this.d.clear()}}t.$ei=E;var I;(function(ue){ue[ue.LocalSide=0]="LocalSide",ue[ue.OtherSide=1]="OtherSide"})(I||(t.RequestInitiator=I={}));class z{constructor(Q,he=null){this.l=Q,this.a=!1,this.b=h.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new D.$je,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(le=>this.s(le)),this.j=he}getChannel(Q){const he=this;return{call(le,Ne,te){return he.a?Promise.reject(new w.$4):he.m(Q,le,Ne,te)},listen(le,Ne){return he.a?D.Event.None:he.o(Q,le,Ne)}}}m(Q,he,le,Ne=F.CancellationToken.None){const te=this.g++,$e=g.Promise,Ae={id:te,type:$e,channelName:Q,name:he,arg:le};if(Ne.isCancellationRequested)return Promise.reject(new w.$4);let Oe;return new Promise((Ce,se)=>{if(Ne.isCancellationRequested)return se(new w.$4);const K=()=>{const m=M=>{switch(M.type){case s.PromiseSuccess:this.f.delete(te),Ce(M.data);break;case s.PromiseError:{this.f.delete(te);const R=new Error(M.data.message);R.stack=Array.isArray(M.data.stack)?M.data.stack.join(`
`):M.data.stack,R.name=M.data.name,se(R);break}case s.PromiseErrorObj:this.f.delete(te),se(M.data);break}};this.f.set(te,m),this.p(Ae)};let W=null;this.b===h.Idle?K():(W=(0,n.$ph)(m=>this.u()),W.then(()=>{W=null,K()}));const a=()=>{W?(W.cancel(),W=null):this.p({id:te,type:g.PromiseCancel}),se(new w.$4)},o=Ne.onCancellationRequested(a);Oe=(0,c.$Qc)((0,c.$Rc)(a),o),this.d.add(Oe)}).finally(()=>{Oe.dispose(),this.d.delete(Oe)})}o(Q,he,le){const Ne=this.g++,te=g.EventListen,$e={id:Ne,type:te,channelName:Q,name:he,arg:le};let Ae=null;const Oe=new D.$je({onWillAddFirstListener:()=>{Ae=(0,n.$ph)(Ce=>this.u()),Ae.then(()=>{Ae=null,this.d.add(Oe),this.p($e)})},onDidRemoveLastListener:()=>{Ae?(Ae.cancel(),Ae=null):(this.d.delete(Oe),this.p({id:Ne,type:g.EventDispose}))}}),Ie=Ce=>Oe.fire(Ce.data);return this.f.set(Ne,Ie),Oe.event}p(Q){switch(Q.type){case g.Promise:case g.EventListen:{const he=this.q([Q.type,Q.id,Q.channelName,Q.name],Q.arg);this.j?.logOutgoing(he,Q.id,I.LocalSide,`${e(Q.type)}: ${Q.channelName}.${Q.name}`,Q.arg);return}case g.PromiseCancel:case g.EventDispose:{const he=this.q([Q.type,Q.id]);this.j?.logOutgoing(he,Q.id,I.LocalSide,e(Q.type));return}}}q(Q,he=void 0){const le=new d;return _(le,Q),_(le,he),this.r(le.buffer)}r(Q){try{return this.l.send(Q),Q.byteLength}catch{return 0}}s(Q){const he=new A(Q),le=B(he),Ne=B(he),te=le[0];switch(te){case s.Initialize:return this.j?.logIncoming(Q.byteLength,0,I.LocalSide,r(te)),this.t({type:le[0]});case s.PromiseSuccess:case s.PromiseError:case s.EventFire:case s.PromiseErrorObj:return this.j?.logIncoming(Q.byteLength,le[1],I.LocalSide,r(te),Ne),this.t({type:le[0],id:le[1],data:Ne})}}t(Q){if(Q.type===s.Initialize){this.b=h.Idle,this.k.fire();return}this.f.get(Q.id)?.(Q)}get onDidInitializePromise(){return D.Event.toPromise(this.onDidInitialize)}u(){return this.b===h.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,c.$Oc)(this.d.values()),this.d.clear()}}t.$fi=z,et([N.$7h],z.prototype,"onDidInitializePromise",null);class O{get connections(){const Q=[];return this.f.forEach(he=>Q.push(he)),Q}constructor(Q,he,le){this.a=new Map,this.f=new Set,this.g=new D.$je,this.onDidAddConnection=this.g.event,this.h=new D.$je,this.onDidRemoveConnection=this.h.event,this.j=new c.$Sc,this.j.add(Q(({protocol:Ne,onDidClientDisconnect:te})=>{const $e=D.Event.once(Ne.onMessage);this.j.add($e(Ae=>{const Oe=new A(Ae),Ie=B(Oe),Ce=new E(Ne,Ie,he,le),se=new z(Ne,he);this.a.forEach((W,a)=>Ce.registerChannel(a,W));const K={channelServer:Ce,channelClient:se,ctx:Ie};this.f.add(K),this.g.fire(K),this.j.add(te(()=>{Ce.dispose(),se.dispose(),this.f.delete(K),this.h.fire(K)}))}))}))}getChannel(Q,he){const le=this;return{call(Ne,te,$e){let Ae;if((0,$.$qg)(he)){const Ie=(0,i.$2b)(le.connections.filter(he));Ae=Ie?Promise.resolve(Ie):D.Event.toPromise(D.Event.filter(le.onDidAddConnection,he))}else Ae=he.routeCall(le,Ne,te);const Oe=Ae.then(Ie=>Ie.channelClient.getChannel(Q));return x(Oe).call(Ne,te,$e)},listen(Ne,te){if((0,$.$qg)(he))return le.k(Q,he,Ne,te);const $e=he.routeEvent(le,Ne,te).then(Ae=>Ae.channelClient.getChannel(Q));return x($e).listen(Ne,te)}}}k(Q,he,le,Ne){const te=this;let $e;const Ae=new D.$je({onWillAddFirstListener:()=>{$e=new c.$Sc;const Oe=new D.$pe,Ie=new Map,Ce=K=>{const a=K.channelClient.getChannel(Q).listen(le,Ne),o=Oe.add(a);Ie.set(K,o)},se=K=>{const W=Ie.get(K);W&&(W.dispose(),Ie.delete(K))};te.connections.filter(he).forEach(Ce),D.Event.filter(te.onDidAddConnection,he)(Ce,void 0,$e),te.onDidRemoveConnection(se,void 0,$e),Oe.event(Ae.fire,Ae,$e),$e.add(Oe)},onDidRemoveLastListener:()=>{$e?.dispose(),$e=void 0}});return Ae.event}registerChannel(Q,he){this.a.set(Q,he);for(const le of this.f)le.channelServer.registerChannel(Q,he)}dispose(){this.j.dispose();for(const Q of this.f)Q.channelClient.dispose(),Q.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}t.$gi=O;class C{constructor(Q,he,le=null){const Ne=new d;_(Ne,he),Q.send(Ne.buffer),this.a=new z(Q,le),this.d=new E(Q,he,le)}getChannel(Q){return this.a.getChannel(Q)}registerChannel(Q,he){this.d.registerChannel(Q,he)}dispose(){this.a.dispose(),this.d.dispose()}}t.$hi=C;function x(ue){return{call(Q,he,le){return ue.then(Ne=>Ne.call(Q,he,le))},listen(Q,he){const le=new D.$se;return ue.then(Ne=>le.input=Ne.listen(Q,he)),le.event}}}function Z(ue){let Q=!1;return{call(he,le,Ne){return Q?ue.call(he,le,Ne):(0,n.$Dh)(0).then(()=>Q=!0).then(()=>ue.call(he,le,Ne))},listen(he,le){if(Q)return ue.listen(he,le);const Ne=new D.$se;return(0,n.$Dh)(0).then(()=>Q=!0).then(()=>Ne.input=ue.listen(he,le)),Ne.event}}}class Y{constructor(Q){this.a=Q}routeCall(Q){return this.b(Q)}routeEvent(Q){return this.b(Q)}async b(Q){for(const he of Q.connections)if(await Promise.resolve(this.a(he.ctx)))return Promise.resolve(he);return await D.Event.toPromise(Q.onDidAddConnection),await this.b(Q)}}t.$ki=Y;var q;(function(ue){function Q(te,$e,Ae){const Oe=te,Ie=Ae&&Ae.disableMarshalling,Ce=new Map;for(const se in Oe)le(se)&&Ce.set(se,D.Event.buffer(Oe[se],!0,void 0,$e));return new class{listen(se,K,W){const a=Ce.get(K);if(a)return a;const o=Oe[K];if(typeof o=="function"){if(Ne(K))return o.call(Oe,W);if(le(K))return Ce.set(K,D.Event.buffer(Oe[K],!0,void 0,$e)),Ce.get(K)}throw new w.$ab(`Event not found: ${K}`)}call(se,K,W){const a=Oe[K];if(typeof a=="function"){if(!Ie&&Array.isArray(W))for(let m=0;m<W.length;m++)W[m]=(0,p.$_h)(W[m]);let o=a.apply(Oe,W);return o instanceof Promise||(o=Promise.resolve(o)),o}throw new w.$ab(`Method not found: ${K}`)}}}ue.fromService=Q;function he(te,$e){const Ae=$e&&$e.disableMarshalling;return new Proxy({},{get(Oe,Ie){if(typeof Ie=="string")return $e?.properties?.has(Ie)?$e.properties.get(Ie):Ne(Ie)?function(Ce){return te.listen(Ie,Ce)}:le(Ie)?te.listen(Ie):async function(...Ce){let se;$e&&!(0,$.$lg)($e.context)?se=[$e.context,...Ce]:se=Ce;const K=await te.call(Ie,se);return Ae?K:(0,p.$_h)(K)};throw new w.$ab(`Property not found: ${String(Ie)}`)}})}ue.toService=he;function le(te){return te[0]==="o"&&te[1]==="n"&&y.$Cf(te.charCodeAt(2))}function Ne(te){return/^onDynamic/.test(te)&&y.$Cf(te.charCodeAt(9))}})(q||(t.ProxyChannel=q={}));const ee=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function ce(ue){if(Array.isArray(ue))return ue;if(ue&&typeof ue=="object"&&typeof ue.toString=="function"){const Q=ue.toString();if(Q!=="[object Object]")return Q}return ue}function be(ue){return Array.isArray(ue)?ue.map(ce):ce(ue)}function ke(ue,Q,he,le,Ne,te,$e){$e=be($e);const Ae=ee[Ne],Oe=Ae[le%Ae.length];let Ie=[`%c[${ue}]%c[${String(Q).padStart(7," ")}]%c[len: ${String(he).padStart(5," ")}]%c${String(le).padStart(5," ")} - ${te}`,"color: darkgreen","color: grey","color: grey",`color: ${Oe}`];/\($/.test(te)?(Ie=Ie.concat($e),Ie.push(")")):Ie.push($e),console.log.apply(console,Ie)}class Fe{constructor(Q,he){this.d=Q,this.f=he,this.a=0,this.b=0}logOutgoing(Q,he,le,Ne,te){this.b+=Q,ke(this.d,this.b,Q,he,le,Ne,te)}logIncoming(Q,he,le,Ne,te){this.a+=Q,ke(this.f,this.a,Q,he,le,Ne,te)}}t.$li=Fe}),define(we[122],ve([1,0]),function(re,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$NX=void 0;class i{constructor(j,F){this.a=j,this.onMessage=F}send(j){try{this.a.send("vscode:message",j.buffer)}catch{}}disconnect(){this.a.send("vscode:disconnect",null)}}t.$NX=i}),define(we[40],ve([1,0]),function(re,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Q=t.$P=t.$O=t.$N=t.$M=t.$L=void 0;const i=globalThis.vscode;t.$L=i.ipcRenderer,t.$M=i.ipcMessagePort,t.$N=i.webFrame,t.$O=i.process,t.$P=i.context,t.$Q=i.webUtils}),define(we[123],ve([1,0,121,40]),function(re,t,i,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$JX=F;let j=0;function F(w,D,c){const p=[],y=j++,$=`vscode:onContextMenu${y}`,g=(e,s,r)=>{p[s].click?.(r)};n.$L.once($,g),n.$L.once(i.$GX,(e,s)=>{s===y&&(n.$L.removeListener($,g),c?.())}),n.$L.send(i.$FX,y,w.map(e=>N(e,p)),$,D)}function N(w,D){const c={id:D.length,label:w.label,type:w.type,accelerator:w.accelerator,checked:w.checked,enabled:typeof w.enabled=="boolean"?w.enabled:!0,visible:typeof w.visible=="boolean"?w.visible:!0};return D.push(w),Array.isArray(w.submenu)&&(c.submenu=w.submenu.map(p=>N(p,D))),c}}),define(we[124],ve([1,0,47,3,74,122,40]),function(re,t,i,n,j,F,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$RX=void 0;class w extends j.$hi{static f(){const c=n.Event.fromNodeEventEmitter(N.$L,"vscode:message",(p,y)=>i.$Le.wrap(y));return N.$L.send("vscode:hello"),new F.$NX(N.$L,c)}constructor(c){const p=w.f();super(p,c),this.b=p}dispose(){this.b.disconnect(),super.dispose()}}t.$RX=w}),define(we[75],ve([7]),{}),define(we[125],ve([7]),{}),define(we[76],ve([1,0,4,125]),function(re,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$HU=c,t.$IU=p,t.$JU=y,i=He(i);const n=2e4;let j,F,N,w,D;function c(g){j=document.createElement("div"),j.className="monaco-aria-container";const e=()=>{const r=document.createElement("div");return r.className="monaco-alert",r.setAttribute("role","alert"),r.setAttribute("aria-atomic","true"),j.appendChild(r),r};F=e(),N=e();const s=()=>{const r=document.createElement("div");return r.className="monaco-status",r.setAttribute("aria-live","polite"),r.setAttribute("aria-atomic","true"),j.appendChild(r),r};w=s(),D=s(),g.appendChild(j)}function p(g){j&&(F.textContent!==g?(i.$qS(N),$(F,g)):(i.$qS(F),$(N,g)))}function y(g){j&&(w.textContent!==g?(i.$qS(D),$(w,g)):(i.$qS(w),$(D,g)))}function $(g,e){i.$qS(g),e.length>n&&(e=e.substr(0,n)),g.textContent=e,g.style.visibility="hidden",g.style.visibility="visible"}}),define(we[126],ve([7]),{}),define(we[127],ve([7]),{}),define(we[128],ve([1,0,126,127]),function(re,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0})}),define(we[129],ve([7]),{}),define(we[77],ve([1,0,61,4,2,5,46,129]),function(re,t,i,n,j,F,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$CU=t.LayoutAnchorMode=t.LayoutAnchorPosition=t.AnchorAxisAlignment=t.AnchorPosition=t.AnchorAlignment=t.ContextViewDOMPosition=void 0,t.$AU=D,t.$BU=e,n=He(n),F=He(F);var w;(function(h){h[h.ABSOLUTE=1]="ABSOLUTE",h[h.FIXED=2]="FIXED",h[h.FIXED_SHADOW=3]="FIXED_SHADOW"})(w||(t.ContextViewDOMPosition=w={}));function D(h){const l=h;return!!l&&typeof l.x=="number"&&typeof l.y=="number"}var c;(function(h){h[h.LEFT=0]="LEFT",h[h.RIGHT=1]="RIGHT"})(c||(t.AnchorAlignment=c={}));var p;(function(h){h[h.BELOW=0]="BELOW",h[h.ABOVE=1]="ABOVE"})(p||(t.AnchorPosition=p={}));var y;(function(h){h[h.VERTICAL=0]="VERTICAL",h[h.HORIZONTAL=1]="HORIZONTAL"})(y||(t.AnchorAxisAlignment=y={}));var $;(function(h){h[h.Before=0]="Before",h[h.After=1]="After"})($||(t.LayoutAnchorPosition=$={}));var g;(function(h){h[h.AVOID=0]="AVOID",h[h.ALIGN=1]="ALIGN"})(g||(t.LayoutAnchorMode=g={}));function e(h,l,v){const k=v.mode===g.ALIGN?v.offset:v.offset+v.size,A=v.mode===g.ALIGN?v.offset+v.size:v.offset;return v.position===$.Before?l<=h-k?k:l<=A?A-l:Math.max(h-l,0):l<=A?A-l:l<=h-k?k:0}class s extends j.$Tc{static{this.a=["click","keydown","focus","blur"]}static{this.b=["click"]}constructor(l,v){super(),this.c=null,this.g=!1,this.h=!1,this.j=null,this.m=j.$Tc.None,this.n=j.$Tc.None,this.r=null,this.s=null,this.f=n.$(".context-view"),n.$HT(this.f),this.setContainer(l,v),this.B((0,j.$Rc)(()=>this.setContainer(null,w.ABSOLUTE)))}setContainer(l,v){this.g=v!==w.ABSOLUTE;const k=this.h;if(this.h=v===w.FIXED_SHADOW,!(l===this.c&&k===this.h)&&(this.c&&(this.n.dispose(),this.f.remove(),this.r&&(this.r=null,this.s?.remove(),this.s=null),this.c=null),l)){if(this.c=l,this.h){this.s=n.$(".shadow-root-host"),this.c.appendChild(this.s),this.r=this.s.attachShadow({mode:"open"});const d=document.createElement("style");d.textContent=r,this.r.appendChild(d),this.r.appendChild(this.f),this.r.appendChild(n.$("slot"))}else this.c.appendChild(this.f);const A=new j.$Sc;s.a.forEach(d=>{A.add(n.$tS(this.c,d,f=>{this.w(f,!1)}))}),s.b.forEach(d=>{A.add(n.$tS(this.c,d,f=>{this.w(f,!0)},!0))}),this.n=A}}show(l){this.u()&&this.hide(),n.$qS(this.f),this.f.className="context-view monaco-component",this.f.style.top="0px",this.f.style.left="0px",this.f.style.zIndex=`${2575+(l.layer??0)}`,this.f.style.position=this.g?"fixed":"absolute",n.$GT(this.f),this.m=l.render(this.f)||j.$Tc.None,this.j=l,this.t(),this.j.focus?.()}getViewElement(){return this.f}layout(){if(this.u()){if(this.j.canRelayout===!1&&!(F.$s&&i.$gS.pointerEvents)){this.hide();return}this.j?.layout?.(),this.t()}}t(){if(!this.u())return;const l=this.j.getAnchor();let v;if(n.$hT(l)){const E=n.$OS(l),I=n.$PS(l);v={top:E.top*I,left:E.left*I,width:E.width*I,height:E.height*I}}else D(l)?v={top:l.y,left:l.x,width:l.width||1,height:l.height||2}:v={top:l.posy,left:l.posx,width:2,height:2};const k=n.$QS(this.f),A=n.$US(this.f),d=this.j.anchorPosition||p.BELOW,f=this.j.anchorAlignment||c.LEFT,b=this.j.anchorAxisAlignment||y.VERTICAL;let S,U;const _=n.$0S();if(b===y.VERTICAL){const E={offset:v.top-_.pageYOffset,size:v.height,position:d===p.BELOW?$.Before:$.After},I={offset:v.left,size:v.width,position:f===c.LEFT?$.Before:$.After,mode:g.ALIGN};S=e(_.innerHeight,A,E)+_.pageYOffset,N.Range.intersects({start:S,end:S+A},{start:E.offset,end:E.offset+E.size})&&(I.mode=g.AVOID),U=e(_.innerWidth,k,I)}else{const E={offset:v.left,size:v.width,position:f===c.LEFT?$.Before:$.After},I={offset:v.top,size:v.height,position:d===p.BELOW?$.Before:$.After,mode:g.ALIGN};U=e(_.innerWidth,k,E),N.Range.intersects({start:U,end:U+k},{start:E.offset,end:E.offset+E.size})&&(I.mode=g.AVOID),S=e(_.innerHeight,A,I)+_.pageYOffset}this.f.classList.remove("top","bottom","left","right"),this.f.classList.add(d===p.BELOW?"bottom":"top"),this.f.classList.add(f===c.LEFT?"left":"right"),this.f.classList.toggle("fixed",this.g);const B=n.$OS(this.c);this.f.style.top=`${S-(this.g?n.$OS(this.f).top:B.top)}px`,this.f.style.left=`${U-(this.g?n.$OS(this.f).left:B.left)}px`,this.f.style.width="initial"}hide(l){const v=this.j;this.j=null,v?.onHide&&v.onHide(l),this.m.dispose(),n.$HT(this.f)}u(){return!!this.j}w(l,v){this.j&&(this.j.onDOMEvent?this.j.onDOMEvent(l,n.getWindow(l).document.activeElement):v&&!n.$WS(l.target,this.c)&&this.hide())}dispose(){this.hide(),super.dispose()}}t.$CU=s;const r=`
	:host {
		all: initial; /* 1st rule so subsequent properties are reset. */
	}

	.codicon[class*='codicon-'] {
		font: normal normal normal 16px/1 codicon;
		display: inline-block;
		text-decoration: none;
		text-rendering: auto;
		text-align: center;
		-webkit-font-smoothing: antialiased;
		-moz-osx-font-smoothing: grayscale;
		user-select: none;
		-webkit-user-select: none;
		-ms-user-select: none;
	}

	:host {
		font-family: -apple-system, BlinkMacSystemFont, "Segoe WPC", "Segoe UI", "HelveticaNeue-Light", system-ui, "Ubuntu", "Droid Sans", sans-serif;
	}

	:host-context(.mac) { font-family: -apple-system, BlinkMacSystemFont, sans-serif; }
	:host-context(.mac:lang(zh-Hans)) { font-family: -apple-system, BlinkMacSystemFont, "PingFang SC", "Hiragino Sans GB", sans-serif; }
	:host-context(.mac:lang(zh-Hant)) { font-family: -apple-system, BlinkMacSystemFont, "PingFang TC", sans-serif; }
	:host-context(.mac:lang(ja)) { font-family: -apple-system, BlinkMacSystemFont, "Hiragino Kaku Gothic Pro", sans-serif; }
	:host-context(.mac:lang(ko)) { font-family: -apple-system, BlinkMacSystemFont, "Nanum Gothic", "Apple SD Gothic Neo", "AppleGothic", sans-serif; }

	:host-context(.windows) { font-family: "Segoe WPC", "Segoe UI", sans-serif; }
	:host-context(.windows:lang(zh-Hans)) { font-family: "Segoe WPC", "Segoe UI", "Microsoft YaHei", sans-serif; }
	:host-context(.windows:lang(zh-Hant)) { font-family: "Segoe WPC", "Segoe UI", "Microsoft Jhenghei", sans-serif; }
	:host-context(.windows:lang(ja)) { font-family: "Segoe WPC", "Segoe UI", "Yu Gothic UI", "Meiryo UI", sans-serif; }
	:host-context(.windows:lang(ko)) { font-family: "Segoe WPC", "Segoe UI", "Malgun Gothic", "Dotom", sans-serif; }

	:host-context(.linux) { font-family: system-ui, "Ubuntu", "Droid Sans", sans-serif; }
	:host-context(.linux:lang(zh-Hans)) { font-family: system-ui, "Ubuntu", "Droid Sans", "Source Han Sans SC", "Source Han Sans CN", "Source Han Sans", sans-serif; }
	:host-context(.linux:lang(zh-Hant)) { font-family: system-ui, "Ubuntu", "Droid Sans", "Source Han Sans TC", "Source Han Sans TW", "Source Han Sans", sans-serif; }
	:host-context(.linux:lang(ja)) { font-family: system-ui, "Ubuntu", "Droid Sans", "Source Han Sans J", "Source Han Sans JP", "Source Han Sans", sans-serif; }
	:host-context(.linux:lang(ko)) { font-family: system-ui, "Ubuntu", "Droid Sans", "Source Han Sans K", "Source Han Sans JR", "Source Han Sans", "UnDotum", "FBaekmuk Gulim", sans-serif; }
`}),define(we[130],ve([7]),{}),define(we[131],ve([7]),{}),define(we[132],ve([7]),{}),define(we[133],ve([7]),{}),define(we[78],ve([1,0,18,4,55,19,117,118,23,12,3,2,5,20,133]),function(re,t,i,n,j,F,N,w,D,c,p,y,$,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$pU=t.$oU=t.$nU=t.$mU=t.$lU=void 0,n=He(n),$=He($);const e=500,s=50,r=!0;class h{constructor(S,U,_){this.timestamp=S,this.deltaX=U,this.deltaY=_,this.score=0}}class l{static{this.INSTANCE=new l}constructor(){this.a=5,this.b=[],this.c=-1,this.d=-1}isPhysicalMouseWheel(){if(this.c===-1&&this.d===-1)return!1;let S=1,U=0,_=1,B=this.d;do{const E=B===this.c?S:Math.pow(2,-_);if(S-=E,U+=this.b[B].score*E,B===this.c)break;B=(this.a+B-1)%this.a,_++}while(!0);return U<=.5}acceptStandardWheelEvent(S){if(i.$$R){const U=n.getWindow(S.browserEvent),_=(0,i.$4R)(U);this.accept(Date.now(),S.deltaX*_,S.deltaY*_)}else this.accept(Date.now(),S.deltaX,S.deltaY)}accept(S,U,_){let B=null;const E=new h(S,U,_);this.c===-1&&this.d===-1?(this.b[0]=E,this.c=0,this.d=0):(B=this.b[this.d],this.d=(this.d+1)%this.a,this.d===this.c&&(this.c=(this.c+1)%this.a),this.b[this.d]=E),E.score=this.f(E,B)}f(S,U){if(Math.abs(S.deltaX)>0&&Math.abs(S.deltaY)>0)return 1;let _=.5;if((!this.g(S.deltaX)||!this.g(S.deltaY))&&(_+=.25),U){const B=Math.abs(S.deltaX),E=Math.abs(S.deltaY),I=Math.abs(U.deltaX),z=Math.abs(U.deltaY),O=Math.max(Math.min(B,I),1),C=Math.max(Math.min(E,z),1),x=Math.max(B,I),Z=Math.max(E,z);x%O===0&&Z%C===0&&(_-=.5)}return Math.min(Math.max(_,0),1)}g(S){return Math.abs(Math.round(S)-S)<.01}}t.$lU=l;class v extends D.$dU{get options(){return this.a}constructor(S,U,_){super(),this.O=this.B(new p.$je),this.onScroll=this.O.event,this.P=this.B(new p.$je),this.onWillScroll=this.P.event,S.style.overflow="hidden",this.a=f(U),this.b=_,this.B(this.b.onScroll(E=>{this.P.fire(E),this.S(E),this.O.fire(E)}));const B={onMouseWheel:E=>this.R(E),onDragStart:()=>this.W(),onDragEnd:()=>this.X()};this.c=this.B(new w.$kU(this.b,this.a,B)),this.g=this.B(new N.$jU(this.b,this.a,B)),this.h=document.createElement("div"),this.h.className="monaco-scrollable-element "+this.a.className,this.h.setAttribute("role","presentation"),this.h.style.position="relative",this.h.style.overflow="hidden",this.h.appendChild(S),this.h.appendChild(this.g.domNode.domNode),this.h.appendChild(this.c.domNode.domNode),this.a.useShadows?(this.n=(0,j.$bU)(document.createElement("div")),this.n.setClassName("shadow"),this.h.appendChild(this.n.domNode),this.r=(0,j.$bU)(document.createElement("div")),this.r.setClassName("shadow"),this.h.appendChild(this.r.domNode),this.s=(0,j.$bU)(document.createElement("div")),this.s.setClassName("shadow"),this.h.appendChild(this.s.domNode)):(this.n=null,this.r=null,this.s=null),this.t=this.a.listenOnDomNode||this.h,this.w=[],this.Q(this.a.handleMouseWheel),this.m(this.t,E=>this.Z(E)),this.u(this.t,E=>this.Y(E)),this.L=this.B(new c.$Mh),this.y=!1,this.J=!1,this.M=!0,this.N=!0}dispose(){this.w=(0,y.$Oc)(this.w),super.dispose()}getDomNode(){return this.h}getOverviewRulerLayoutInfo(){return{parent:this.h,insertBefore:this.c.domNode.domNode}}delegateVerticalScrollbarPointerDown(S){this.c.delegatePointerDown(S)}getScrollDimensions(){return this.b.getScrollDimensions()}setScrollDimensions(S){this.b.setScrollDimensions(S,!1)}updateClassName(S){this.a.className=S,$.$k&&(this.a.className+=" mac"),this.h.className="monaco-scrollable-element "+this.a.className}updateOptions(S){typeof S.handleMouseWheel<"u"&&(this.a.handleMouseWheel=S.handleMouseWheel,this.Q(this.a.handleMouseWheel)),typeof S.mouseWheelScrollSensitivity<"u"&&(this.a.mouseWheelScrollSensitivity=S.mouseWheelScrollSensitivity),typeof S.fastScrollSensitivity<"u"&&(this.a.fastScrollSensitivity=S.fastScrollSensitivity),typeof S.scrollPredominantAxis<"u"&&(this.a.scrollPredominantAxis=S.scrollPredominantAxis),typeof S.horizontal<"u"&&(this.a.horizontal=S.horizontal),typeof S.vertical<"u"&&(this.a.vertical=S.vertical),typeof S.horizontalScrollbarSize<"u"&&(this.a.horizontalScrollbarSize=S.horizontalScrollbarSize),typeof S.verticalScrollbarSize<"u"&&(this.a.verticalScrollbarSize=S.verticalScrollbarSize),typeof S.scrollByPage<"u"&&(this.a.scrollByPage=S.scrollByPage),this.g.updateOptions(this.a),this.c.updateOptions(this.a),this.a.lazyRender||this.U()}setRevealOnScroll(S){this.N=S}delegateScrollFromMouseWheelEvent(S){this.R(new F.$lS(S))}Q(S){if(this.w.length>0!==S&&(this.w=(0,y.$Oc)(this.w),S)){const _=B=>{this.R(new F.$lS(B))};this.w.push(n.$sS(this.t,n.$tT.MOUSE_WHEEL,_,{passive:!1}))}}R(S){if(S.browserEvent?.defaultPrevented)return;const U=l.INSTANCE;r&&U.acceptStandardWheelEvent(S);let _=!1;if(S.deltaY||S.deltaX){let E=S.deltaY*this.a.mouseWheelScrollSensitivity,I=S.deltaX*this.a.mouseWheelScrollSensitivity;this.a.scrollPredominantAxis&&(this.a.scrollYToX&&I+E===0?I=E=0:Math.abs(E)>=Math.abs(I)?I=0:E=0),this.a.flipAxes&&([E,I]=[I,E]);const z=!$.$k&&S.browserEvent&&S.browserEvent.shiftKey;(this.a.scrollYToX||z)&&!I&&(I=E,E=0),S.browserEvent&&S.browserEvent.altKey&&(I=I*this.a.fastScrollSensitivity,E=E*this.a.fastScrollSensitivity);const O=this.b.getFutureScrollPosition();let C={};if(E){const x=s*E,Z=O.scrollTop-(x<0?Math.floor(x):Math.ceil(x));this.c.writeScrollPosition(C,Z)}if(I){const x=s*I,Z=O.scrollLeft-(x<0?Math.floor(x):Math.ceil(x));this.g.writeScrollPosition(C,Z)}C=this.b.validateScrollPosition(C),(O.scrollLeft!==C.scrollLeft||O.scrollTop!==C.scrollTop)&&(r&&this.a.mouseWheelSmoothScroll&&U.isPhysicalMouseWheel()?this.b.setScrollPositionSmooth(C):this.b.setScrollPositionNow(C),_=!0)}let B=_;!B&&this.a.alwaysConsumeMouseWheel&&(B=!0),!B&&this.a.consumeMouseWheelIfScrollbarIsNeeded&&(this.c.isNeeded()||this.g.isNeeded())&&(B=!0),B&&(S.preventDefault(),S.stopPropagation())}S(S){this.M=this.g.onDidScroll(S)||this.M,this.M=this.c.onDidScroll(S)||this.M,this.a.useShadows&&(this.M=!0),this.N&&this.$(),this.a.lazyRender||this.U()}renderNow(){if(!this.a.lazyRender)throw new Error("Please use `lazyRender` together with `renderNow`!");this.U()}U(){if(this.M&&(this.M=!1,this.g.render(),this.c.render(),this.a.useShadows)){const S=this.b.getCurrentScrollPosition(),U=S.scrollTop>0,_=S.scrollLeft>0,B=_?" left":"",E=U?" top":"",I=_||U?" top-left-corner":"";this.n.setClassName(`shadow${B}`),this.r.setClassName(`shadow${E}`),this.s.setClassName(`shadow${I}${E}${B}`)}}W(){this.y=!0,this.$()}X(){this.y=!1,this.ab()}Y(S){this.J=!1,this.ab()}Z(S){this.J=!0,this.$()}$(){this.c.beginReveal(),this.g.beginReveal(),this.bb()}ab(){!this.J&&!this.y&&(this.c.beginHide(),this.g.beginHide())}bb(){!this.J&&!this.y&&this.L.cancelAndSet(()=>this.ab(),e)}}t.$mU=v;class k extends v{constructor(S,U){U=U||{},U.mouseWheelSmoothScroll=!1;const _=new g.$bt({forceIntegerValues:!0,smoothScrollDuration:0,scheduleAtNextAnimationFrame:B=>n.$CS(n.getWindow(S),B)});super(S,U,_),this.B(_)}setScrollPosition(S){this.b.setScrollPositionNow(S)}getScrollPosition(){return this.b.getCurrentScrollPosition()}}t.$nU=k;class A extends v{constructor(S,U,_){super(S,U,_)}setScrollPosition(S){S.reuseAnimation?this.b.setScrollPositionSmooth(S,S.reuseAnimation):this.b.setScrollPositionNow(S)}getScrollPosition(){return this.b.getCurrentScrollPosition()}}t.$oU=A;class d extends v{constructor(S,U){U=U||{},U.mouseWheelSmoothScroll=!1;const _=new g.$bt({forceIntegerValues:!1,smoothScrollDuration:0,scheduleAtNextAnimationFrame:B=>n.$CS(n.getWindow(S),B)});super(S,U,_),this.B(_),this.cb=S,this.B(this.onScroll(B=>{B.scrollTopChanged&&(this.cb.scrollTop=B.scrollTop),B.scrollLeftChanged&&(this.cb.scrollLeft=B.scrollLeft)})),this.scanDomNode()}setScrollPosition(S){this.b.setScrollPositionNow(S)}getScrollPosition(){return this.b.getCurrentScrollPosition()}scanDomNode(){this.setScrollDimensions({width:this.cb.clientWidth,scrollWidth:this.cb.scrollWidth,height:this.cb.clientHeight,scrollHeight:this.cb.scrollHeight}),this.setScrollPosition({scrollLeft:this.cb.scrollLeft,scrollTop:this.cb.scrollTop})}}t.$pU=d;function f(b){const S={lazyRender:typeof b.lazyRender<"u"?b.lazyRender:!1,className:typeof b.className<"u"?b.className:"",useShadows:typeof b.useShadows<"u"?b.useShadows:!0,handleMouseWheel:typeof b.handleMouseWheel<"u"?b.handleMouseWheel:!0,flipAxes:typeof b.flipAxes<"u"?b.flipAxes:!1,consumeMouseWheelIfScrollbarIsNeeded:typeof b.consumeMouseWheelIfScrollbarIsNeeded<"u"?b.consumeMouseWheelIfScrollbarIsNeeded:!1,alwaysConsumeMouseWheel:typeof b.alwaysConsumeMouseWheel<"u"?b.alwaysConsumeMouseWheel:!1,scrollYToX:typeof b.scrollYToX<"u"?b.scrollYToX:!1,mouseWheelScrollSensitivity:typeof b.mouseWheelScrollSensitivity<"u"?b.mouseWheelScrollSensitivity:1,fastScrollSensitivity:typeof b.fastScrollSensitivity<"u"?b.fastScrollSensitivity:5,scrollPredominantAxis:typeof b.scrollPredominantAxis<"u"?b.scrollPredominantAxis:!0,mouseWheelSmoothScroll:typeof b.mouseWheelSmoothScroll<"u"?b.mouseWheelSmoothScroll:!0,arrowSize:typeof b.arrowSize<"u"?b.arrowSize:11,listenOnDomNode:typeof b.listenOnDomNode<"u"?b.listenOnDomNode:null,horizontal:typeof b.horizontal<"u"?b.horizontal:g.ScrollbarVisibility.Auto,horizontalScrollbarSize:typeof b.horizontalScrollbarSize<"u"?b.horizontalScrollbarSize:10,horizontalSliderSize:typeof b.horizontalSliderSize<"u"?b.horizontalSliderSize:0,horizontalHasArrows:typeof b.horizontalHasArrows<"u"?b.horizontalHasArrows:!1,vertical:typeof b.vertical<"u"?b.vertical:g.ScrollbarVisibility.Auto,verticalScrollbarSize:typeof b.verticalScrollbarSize<"u"?b.verticalScrollbarSize:10,verticalHasArrows:typeof b.verticalHasArrows<"u"?b.verticalHasArrows:!1,verticalSliderSize:typeof b.verticalSliderSize<"u"?b.verticalSliderSize:0,scrollByPage:typeof b.scrollByPage<"u"?b.scrollByPage:!1};return S.horizontalSliderSize=typeof b.horizontalSliderSize<"u"?b.horizontalSliderSize:S.horizontalScrollbarSize,S.verticalSliderSize=typeof b.verticalSliderSize<"u"?b.verticalSliderSize:S.verticalScrollbarSize,$.$k&&(S.className+=" mac"),S}}),define(we[79],ve([1,0,69,4,29,32,78,9,12,35,3,2,46,20,41,101,113,6,37]),function(re,t,i,n,j,F,N,w,D,c,p,y,$,g,e,s,r,h,l){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$TU=t.$SU=t.$RU=t.$QU=t.ListViewTargetSector=void 0;const v={CurrentDragAndDropData:void 0};var k;(function(B){B[B.TOP=0]="TOP",B[B.CENTER_TOP=1]="CENTER_TOP",B[B.CENTER_BOTTOM=2]="CENTER_BOTTOM",B[B.BOTTOM=3]="BOTTOM"})(k||(t.ListViewTargetSector=k={}));const A={useShadows:!0,verticalScrollMode:g.ScrollbarVisibility.Auto,setRowLineHeight:!0,setRowHeight:!0,supportDynamicHeights:!1,dnd:{getDragElements(B){return[B]},getDragURI(){return null},onDragStart(){},onDragOver(){return!1},drop(){},dispose(){}},horizontalScrolling:!1,transformOptimization:!0,alwaysConsumeMouseWheel:!0};class d{get context(){return this.d}set context(E){this.d=E}constructor(E){this.elements=E}update(){}getData(){return this.elements}}t.$QU=d;class f{constructor(E){this.elements=E}update(){}getData(){return this.elements}}t.$RU=f;class b{constructor(){this.types=[],this.files=[]}update(E){if(E.types&&this.types.splice(0,this.types.length,...E.types),E.files){this.files.splice(0,this.files.length);for(let I=0;I<E.files.length;I++){const z=E.files.item(I);z&&(z.size||z.type)&&this.files.push(z)}}}getData(){return{types:this.types,files:this.files}}}t.$SU=b;function S(B,E){return Array.isArray(B)&&Array.isArray(E)?(0,w.$tb)(B,E):B===E}class U{constructor(E){E?.getSetSize?this.getSetSize=E.getSetSize.bind(E):this.getSetSize=(I,z,O)=>O,E?.getPosInSet?this.getPosInSet=E.getPosInSet.bind(E):this.getPosInSet=(I,z)=>z+1,E?.getRole?this.getRole=E.getRole.bind(E):this.getRole=I=>"listitem",E?.isChecked?this.isChecked=E.isChecked.bind(E):this.isChecked=I=>{}}}class _{static{this.c=0}get contentHeight(){return this.g.size}get contentWidth(){return this.E??0}get onDidScroll(){return this.q.onScroll}get onWillScroll(){return this.q.onWillScroll}get containerDomNode(){return this.o}get scrollableElementDomNode(){return this.q.getDomNode()}get Q(){return this.P}set Q(E){if(E!==this.P){if(E&&this.B)throw new Error("Horizontal scrolling and dynamic heights not supported simultaneously");if(this.P=E,this.domNode.classList.toggle("horizontal-scrolling",this.P),this.P){for(const I of this.d)this.ab(I);this.X(),this.q.setScrollDimensions({width:(0,n.$RS)(this.domNode)}),this.o.style.width=`${Math.max(this.E||0,this.n)}px`}else this.u.cancel(),this.q.setScrollDimensions({width:this.n,scrollWidth:this.n}),this.o.style.width=""}}constructor(E,I,z,O=A){if(this.R=I,this.domId=`list_id_${++_.c}`,this.j=new Map,this.n=0,this.s=0,this.t=null,this.u=new D.$zh(50),this.v=!1,this.x=y.$Tc.None,this.y=0,this.G=!1,this.K=y.$Tc.None,this.L=y.$Tc.None,this.M=new y.$Sc,this.N=new p.$je,this.O=new p.$je,this.onDidChangeContentHeight=p.Event.latch(this.N.event,void 0,this.M),this.onDidChangeContentWidth=p.Event.latch(this.O.event,void 0,this.M),this.P=!1,O.horizontalScrolling&&O.supportDynamicHeights)throw new Error("Horizontal scrolling and dynamic heights not supported simultaneously");this.d=[],this.f=0,this.g=this.S(O.paddingTop??0);for(const x of z)this.j.set(x.templateId,x);this.h=this.M.add(new r.$PU(this.j)),this.k=0,this.m=0,this.domNode=document.createElement("div"),this.domNode.className="monaco-list",this.domNode.classList.add(this.domId),this.domNode.tabIndex=0,this.domNode.classList.toggle("mouse-support",typeof O.mouseSupport=="boolean"?O.mouseSupport:!0),this.P=O.horizontalScrolling??A.horizontalScrolling,this.domNode.classList.toggle("horizontal-scrolling",this.P),this.C=typeof O.paddingBottom>"u"?0:O.paddingBottom,this.D=new U(O.accessibilityProvider),this.o=document.createElement("div"),this.o.className="monaco-list-rows",(O.transformOptimization??A.transformOptimization)&&(this.o.style.transform="translate3d(0px, 0px, 0px)",this.o.style.overflow="hidden",this.o.style.contain="strict"),this.M.add(F.$_T.addTarget(this.o)),this.p=this.M.add(new g.$bt({forceIntegerValues:!0,smoothScrollDuration:O.smoothScrolling??!1?125:0,scheduleAtNextAnimationFrame:x=>(0,n.$CS)((0,n.getWindow)(this.domNode),x)})),this.q=this.M.add(new N.$oU(this.o,{alwaysConsumeMouseWheel:O.alwaysConsumeMouseWheel??A.alwaysConsumeMouseWheel,horizontal:g.ScrollbarVisibility.Auto,vertical:O.verticalScrollMode??A.verticalScrollMode,useShadows:O.useShadows??A.useShadows,mouseWheelScrollSensitivity:O.mouseWheelScrollSensitivity,fastScrollSensitivity:O.fastScrollSensitivity,scrollByPage:O.scrollByPage},this.p)),this.domNode.appendChild(this.q.getDomNode()),E.appendChild(this.domNode),this.q.onScroll(this.ib,this,this.M),this.M.add((0,n.$sS)(this.o,F.EventType.Change,x=>this.jb(x))),this.M.add((0,n.$sS)(this.q.getDomNode(),"scroll",x=>x.target.scrollTop=0)),this.M.add((0,n.$sS)(this.domNode,"dragover",x=>this.lb(this.hb(x)))),this.M.add((0,n.$sS)(this.domNode,"drop",x=>this.nb(this.hb(x)))),this.M.add((0,n.$sS)(this.domNode,"dragleave",x=>this.mb(this.hb(x)))),this.M.add((0,n.$sS)(this.domNode,"dragend",x=>this.ob(x))),this.z=O.setRowLineHeight??A.setRowLineHeight,this.A=O.setRowHeight??A.setRowHeight,this.B=O.supportDynamicHeights??A.supportDynamicHeights,this.F=O.dnd??this.M.add(A.dnd),this.layout(O.initialSize?.height,O.initialSize?.width)}updateOptions(E){E.paddingBottom!==void 0&&(this.C=E.paddingBottom,this.q.setScrollDimensions({scrollHeight:this.scrollHeight})),E.smoothScrolling!==void 0&&this.p.setSmoothScrollDuration(E.smoothScrolling?125:0),E.horizontalScrolling!==void 0&&(this.Q=E.horizontalScrolling);let I;if(E.scrollByPage!==void 0&&(I={...I??{},scrollByPage:E.scrollByPage}),E.mouseWheelScrollSensitivity!==void 0&&(I={...I??{},mouseWheelScrollSensitivity:E.mouseWheelScrollSensitivity}),E.fastScrollSensitivity!==void 0&&(I={...I??{},fastScrollSensitivity:E.fastScrollSensitivity}),I&&this.q.updateOptions(I),E.paddingTop!==void 0&&E.paddingTop!==this.g.paddingTop){const z=this.vb(this.k,this.m),O=E.paddingTop-this.g.paddingTop;this.g.paddingTop=E.paddingTop,this.Y(z,Math.max(0,this.k+O),this.m,void 0,void 0,!0),this.setScrollTop(this.k),this.V(),this.B&&this.wb(this.k,this.m)}}delegateScrollFromMouseWheelEvent(E){this.q.delegateScrollFromMouseWheelEvent(E)}delegateVerticalScrollbarPointerDown(E){this.q.delegateVerticalScrollbarPointerDown(E)}updateElementHeight(E,I,z){if(E<0||E>=this.d.length)return;const O=this.d[E].size;if(typeof I>"u"){if(!this.B){console.warn("Dynamic heights not supported");return}this.d[E].lastDynamicHeightWidth=void 0,I=O+this.xb(E)}if(O===I)return;const C=this.vb(this.k,this.m);let x=0;E<C.start||z!==null&&z>E&&z<C.end?x=I-O:x=0,this.g.splice(E,1,[{size:I}]),this.d[E].size=I,this.Y(C,Math.max(0,this.k+x),this.m,void 0,void 0,!0),this.setScrollTop(this.k),this.V(),this.B&&this.wb(this.k,this.m)}S(E){return new s.$OU(E)}splice(E,I,z=[]){if(this.v)throw new Error("Can't run recursive splices.");this.v=!0;try{return this.U(E,I,z)}finally{this.v=!1,this.N.fire(this.contentHeight)}}U(E,I,z=[]){const O=this.vb(this.k,this.m),C={start:E,end:E+I},x=$.Range.intersect(O,C),Z=new Map;for(let $e=x.end-1;$e>=x.start;$e--){const Ae=this.d[$e];if(Ae.dragStartDisposable.dispose(),Ae.checkedDisposable.dispose(),Ae.row){let Oe=Z.get(Ae.templateId);Oe||(Oe=[],Z.set(Ae.templateId,Oe));const Ie=this.j.get(Ae.templateId);Ie&&Ie.disposeElement&&Ie.disposeElement(Ae.element,$e,Ae.row.templateData,Ae.size),Oe.unshift(Ae.row)}Ae.row=null,Ae.stale=!0}const Y={start:E+I,end:this.d.length},q=$.Range.intersect(Y,O),ee=$.Range.relativeComplement(Y,O),ce=z.map($e=>({id:String(this.f++),element:$e,templateId:this.R.getTemplateId($e),size:this.R.getHeight($e),width:void 0,hasDynamicHeight:!!this.R.hasDynamicHeight&&this.R.hasDynamicHeight($e),lastDynamicHeightWidth:void 0,row:null,uri:void 0,dropTarget:!1,dragStartDisposable:y.$Tc.None,checkedDisposable:y.$Tc.None,stale:!1}));let be;E===0&&I>=this.d.length?(this.g=this.S(this.g.paddingTop),this.g.splice(0,0,ce),be=this.d,this.d=ce):(this.g.splice(E,I,ce),be=this.d.splice(E,I,...ce));const ke=z.length-I,Fe=this.vb(this.k,this.m),ue=(0,s.$MU)(q,ke),Q=$.Range.intersect(Fe,ue);for(let $e=Q.start;$e<Q.end;$e++)this.bb(this.d[$e],$e);const he=$.Range.relativeComplement(ue,Fe);for(const $e of he)for(let Ae=$e.start;Ae<$e.end;Ae++)this.db(Ae);const le=ee.map($e=>(0,s.$MU)($e,ke)),te=[{start:E,end:E+z.length},...le].map($e=>$.Range.intersect(Fe,$e)).reverse();for(const $e of te)for(let Ae=$e.end-1;Ae>=$e.start;Ae--){const Oe=this.d[Ae],Ce=Z.get(Oe.templateId)?.pop();this.Z(Ae,Ce)}for(const $e of Z.values())for(const Ae of $e)this.h.release(Ae);return this.V(),this.B&&this.wb(this.scrollTop,this.renderHeight),be.map($e=>$e.element)}V(){this.s=this.contentHeight,this.o.style.height=`${this.s}px`,this.t||(this.t=(0,n.$CS)((0,n.getWindow)(this.domNode),()=>{this.q.setScrollDimensions({scrollHeight:this.scrollHeight}),this.X(),this.t=null}))}W(){if(!this.Q){this.u.cancel();return}this.u.trigger(()=>this.X())}X(){if(!this.Q)return;let E=0;for(const I of this.d)typeof I.width<"u"&&(E=Math.max(E,I.width));this.E=E,this.q.setScrollDimensions({scrollWidth:E===0?0:E+10}),this.O.fire(this.E)}updateWidth(E){if(!this.Q||typeof this.E>"u")return;const I=this.d[E];this.ab(I),typeof I.width<"u"&&I.width>this.E&&(this.E=I.width,this.q.setScrollDimensions({scrollWidth:this.E+10}),this.O.fire(this.E))}rerender(){if(this.B){for(const E of this.d)E.lastDynamicHeightWidth=void 0;this.wb(this.k,this.m)}}get length(){return this.d.length}get renderHeight(){return this.q.getScrollDimensions().height}get firstVisibleIndex(){return this.vb(this.k,this.m).start}get firstMostlyVisibleIndex(){const E=this.firstVisibleIndex,I=this.g.positionAt(E),z=this.g.positionAt(E+1);return z!==-1&&(z-I)/2+I<this.scrollTop?E+1:E}get lastVisibleIndex(){return this.vb(this.k,this.m).end-1}element(E){return this.d[E].element}indexOf(E){return this.d.findIndex(I=>I.element===E)}domElement(E){const I=this.d[E].row;return I&&I.domNode}elementHeight(E){return this.d[E].size}elementTop(E){return this.g.positionAt(E)}indexAt(E){return this.g.indexAt(E)}indexAfter(E){return this.g.indexAfter(E)}layout(E,I){const z={height:typeof E=="number"?E:(0,n.$TS)(this.domNode)};this.t&&(this.t.dispose(),this.t=null,z.scrollHeight=this.scrollHeight),this.q.setScrollDimensions(z),typeof I<"u"&&(this.n=I,this.B&&this.wb(this.scrollTop,this.renderHeight)),this.Q&&this.q.setScrollDimensions({width:typeof I=="number"?I:(0,n.$RS)(this.domNode)})}Y(E,I,z,O,C,x=!1){const Z=this.vb(I,z),Y=$.Range.relativeComplement(Z,E).reverse(),q=$.Range.relativeComplement(E,Z);if(x){const ee=$.Range.intersect(E,Z);for(let ce=ee.start;ce<ee.end;ce++)this.bb(this.d[ce],ce)}this.h.transact(()=>{for(const ee of q)for(let ce=ee.start;ce<ee.end;ce++)this.db(ce);for(const ee of Y)for(let ce=ee.end-1;ce>=ee.start;ce--)this.Z(ce)}),O!==void 0&&(this.o.style.left=`-${O}px`),this.o.style.top=`-${I}px`,this.Q&&C!==void 0&&(this.o.style.width=`${Math.max(C,this.n)}px`),this.k=I,this.m=z}Z(E,I){const z=this.d[E];if(!z.row)if(I)z.row=I,z.stale=!0;else{const Y=this.h.alloc(z.templateId);z.row=Y.row,z.stale||=Y.isReusingConnectedDomNode}const O=this.D.getRole(z.element)||"listitem";z.row.domNode.setAttribute("role",O);const C=this.D.isChecked(z.element);if(typeof C=="boolean")z.row.domNode.setAttribute("aria-checked",String(!!C));else if(C){const Y=q=>z.row.domNode.setAttribute("aria-checked",String(!!q));Y(C.value),z.checkedDisposable=C.onDidChange(()=>Y(C.value))}if(z.stale||!z.row.domNode.parentElement){const Y=this.d.at(E+1)?.row?.domNode??null;(z.row.domNode.parentElement!==this.o||z.row.domNode.nextElementSibling!==Y)&&this.o.insertBefore(z.row.domNode,Y),z.stale=!1}this.bb(z,E);const x=this.j.get(z.templateId);if(!x)throw new Error(`No renderer found for template id ${z.templateId}`);x?.renderElement(z.element,E,z.row.templateData,z.size);const Z=this.F.getDragURI(z.element);z.dragStartDisposable.dispose(),z.row.domNode.draggable=!!Z,Z&&(z.dragStartDisposable=(0,n.$sS)(z.row.domNode,"dragstart",Y=>this.kb(z.element,Z,Y))),this.Q&&(this.ab(z),this.W())}ab(E){if(!E.row||!E.row.domNode)return;E.row.domNode.style.width="fit-content",E.width=(0,n.$RS)(E.row.domNode);const I=(0,n.getWindow)(E.row.domNode).getComputedStyle(E.row.domNode);I.paddingLeft&&(E.width+=parseFloat(I.paddingLeft)),I.paddingRight&&(E.width+=parseFloat(I.paddingRight)),E.row.domNode.style.width=""}bb(E,I){E.row.domNode.style.top=`${this.elementTop(I)}px`,this.A&&(E.row.domNode.style.height=`${E.size}px`),this.z&&(E.row.domNode.style.lineHeight=`${E.size}px`),E.row.domNode.setAttribute("data-index",`${I}`),E.row.domNode.setAttribute("data-last-element",I===this.length-1?"true":"false"),E.row.domNode.setAttribute("data-parity",I%2===0?"even":"odd"),E.row.domNode.setAttribute("aria-setsize",String(this.D.getSetSize(E.element,I,this.length))),E.row.domNode.setAttribute("aria-posinset",String(this.D.getPosInSet(E.element,I))),E.row.domNode.setAttribute("id",this.getElementDomId(I)),E.row.domNode.classList.toggle("drop-target",E.dropTarget)}db(E){const I=this.d[E];if(I.dragStartDisposable.dispose(),I.checkedDisposable.dispose(),I.row){const z=this.j.get(I.templateId);z&&z.disposeElement&&z.disposeElement(I.element,E,I.row.templateData,I.size),this.h.release(I.row),I.row=null}this.Q&&this.W()}getScrollTop(){return this.q.getScrollPosition().scrollTop}setScrollTop(E,I){this.t&&(this.t.dispose(),this.t=null,this.q.setScrollDimensions({scrollHeight:this.scrollHeight})),this.q.setScrollPosition({scrollTop:E,reuseAnimation:I})}getScrollLeft(){return this.q.getScrollPosition().scrollLeft}setScrollLeft(E){this.t&&(this.t.dispose(),this.t=null,this.q.setScrollDimensions({scrollWidth:this.E})),this.q.setScrollPosition({scrollLeft:E})}get scrollTop(){return this.getScrollTop()}set scrollTop(E){this.setScrollTop(E)}get scrollHeight(){return this.s+(this.Q?10:0)+this.C}get onMouseClick(){return p.Event.map(this.M.add(new j.$GU(this.domNode,"click")).event,E=>this.eb(E),this.M)}get onMouseDblClick(){return p.Event.map(this.M.add(new j.$GU(this.domNode,"dblclick")).event,E=>this.eb(E),this.M)}get onMouseMiddleClick(){return p.Event.filter(p.Event.map(this.M.add(new j.$GU(this.domNode,"auxclick")).event,E=>this.eb(E),this.M),E=>E.browserEvent.button===1,this.M)}get onMouseUp(){return p.Event.map(this.M.add(new j.$GU(this.domNode,"mouseup")).event,E=>this.eb(E),this.M)}get onMouseDown(){return p.Event.map(this.M.add(new j.$GU(this.domNode,"mousedown")).event,E=>this.eb(E),this.M)}get onMouseOver(){return p.Event.map(this.M.add(new j.$GU(this.domNode,"mouseover")).event,E=>this.eb(E),this.M)}get onMouseMove(){return p.Event.map(this.M.add(new j.$GU(this.domNode,"mousemove")).event,E=>this.eb(E),this.M)}get onMouseOut(){return p.Event.map(this.M.add(new j.$GU(this.domNode,"mouseout")).event,E=>this.eb(E),this.M)}get onContextMenu(){return p.Event.any(p.Event.map(this.M.add(new j.$GU(this.domNode,"contextmenu")).event,E=>this.eb(E),this.M),p.Event.map(this.M.add(new j.$GU(this.domNode,F.EventType.Contextmenu)).event,E=>this.gb(E),this.M))}get onTouchStart(){return p.Event.map(this.M.add(new j.$GU(this.domNode,"touchstart")).event,E=>this.fb(E),this.M)}get onTap(){return p.Event.map(this.M.add(new j.$GU(this.o,F.EventType.Tap)).event,E=>this.gb(E),this.M)}eb(E){const I=this.ub(E.target||null),z=typeof I>"u"?void 0:this.d[I],O=z&&z.element;return{browserEvent:E,index:I,element:O}}fb(E){const I=this.ub(E.target||null),z=typeof I>"u"?void 0:this.d[I],O=z&&z.element;return{browserEvent:E,index:I,element:O}}gb(E){const I=this.ub(E.initialTarget||null),z=typeof I>"u"?void 0:this.d[I],O=z&&z.element;return{browserEvent:E,index:I,element:O}}hb(E){const I=this.ub(E.target||null),z=typeof I>"u"?void 0:this.d[I],O=z&&z.element,C=this.tb(E,I);return{browserEvent:E,index:I,element:O,sector:C}}ib(E){try{const I=this.vb(this.k,this.m);this.Y(I,E.scrollTop,E.height,E.scrollLeft,E.scrollWidth),this.B&&this.wb(E.scrollTop,E.height,E.inSmoothScrolling)}catch(I){throw console.error("Got bad scroll event:",E),I}}jb(E){E.preventDefault(),E.stopPropagation(),this.scrollTop-=E.translationY}kb(E,I,z){if(!z.dataTransfer)return;const O=this.F.getDragElements(E);if(z.dataTransfer.effectAllowed="copyMove",z.dataTransfer.setData(i.$0T.TEXT,I),z.dataTransfer.setDragImage){let C;this.F.getDragLabel&&(C=this.F.getDragLabel(O,z)),typeof C>"u"&&(C=String(O.length));const x=(0,n.$)(".monaco-drag-image");x.textContent=C,(q=>{for(;q&&!q.classList.contains("monaco-workbench");)q=q.parentElement;return q||this.domNode.ownerDocument})(this.domNode).appendChild(x),z.dataTransfer.setDragImage(x,-10,-10),setTimeout(()=>x.remove(),0)}this.domNode.classList.add("dragging"),this.H=new d(O),v.CurrentDragAndDropData=new f(O),this.F.onDragStart?.(this.H,z)}lb(E){if(E.browserEvent.preventDefault(),this.L.dispose(),v.CurrentDragAndDropData&&v.CurrentDragAndDropData.getData()==="vscode-ui"||(this.qb(E.browserEvent),!E.browserEvent.dataTransfer))return!1;if(!this.H)if(v.CurrentDragAndDropData)this.H=v.CurrentDragAndDropData;else{if(!E.browserEvent.dataTransfer.types)return!1;this.H=new b}const I=this.F.onDragOver(this.H,E.element,E.index,E.sector,E.browserEvent);if(this.G=typeof I=="boolean"?I:I.accept,!this.G)return this.I=void 0,this.K.dispose(),!1;E.browserEvent.dataTransfer.dropEffect=typeof I!="boolean"&&I.effect?.type===e.ListDragOverEffectType.Copy?"copy":"move";let z;typeof I!="boolean"&&I.feedback?z=I.feedback:typeof E.index>"u"?z=[-1]:z=[E.index],z=(0,w.$Lb)(z).filter(C=>C>=-1&&C<this.length).sort((C,x)=>C-x),z=z[0]===-1?[-1]:z;let O=typeof I!="boolean"&&I.effect&&I.effect.position?I.effect.position:e.ListDragOverEffectPosition.Over;if(S(this.I,z)&&this.J===O)return!0;if(this.I=z,this.J=O,this.K.dispose(),z[0]===-1)this.domNode.classList.add(O),this.o.classList.add(O),this.K=(0,y.$Rc)(()=>{this.domNode.classList.remove(O),this.o.classList.remove(O)});else{if(z.length>1&&O!==e.ListDragOverEffectPosition.Over)throw new Error("Can't use multiple feedbacks with position different than 'over'");O===e.ListDragOverEffectPosition.After&&z[0]<this.length-1&&(z[0]+=1,O=e.ListDragOverEffectPosition.Before);for(const C of z){const x=this.d[C];x.dropTarget=!0,x.row?.domNode.classList.add(O)}this.K=(0,y.$Rc)(()=>{for(const C of z){const x=this.d[C];x.dropTarget=!1,x.row?.domNode.classList.remove(O)}})}return!0}mb(E){this.L.dispose(),this.L=(0,D.$Eh)(()=>this.pb(),100,this.M),this.H&&this.F.onDragLeave?.(this.H,E.element,E.index,E.browserEvent)}nb(E){if(!this.G)return;const I=this.H;this.sb(),this.pb(),this.domNode.classList.remove("dragging"),this.H=void 0,v.CurrentDragAndDropData=void 0,!(!I||!E.browserEvent.dataTransfer)&&(E.browserEvent.preventDefault(),I.update(E.browserEvent.dataTransfer),this.F.drop(I,E.element,E.index,E.sector,E.browserEvent))}ob(E){this.G=!1,this.sb(),this.pb(),this.domNode.classList.remove("dragging"),this.H=void 0,v.CurrentDragAndDropData=void 0,this.F.onDragEnd?.(E)}pb(){this.I=void 0,this.J=void 0,this.K.dispose(),this.K=y.$Tc.None}qb(E){if(!this.w){const I=(0,n.$LS)(this.domNode).top;this.w=(0,n.$PT)((0,n.getWindow)(this.domNode),this.rb.bind(this,I))}this.x.dispose(),this.x=(0,D.$Eh)(()=>{this.w&&(this.w.dispose(),this.w=void 0)},1e3,this.M),this.y=E.pageY}rb(E){if(this.y===void 0)return;const I=this.y-E,z=this.renderHeight-35;I<35?this.scrollTop+=Math.max(-14,Math.floor(.3*(I-35))):I>z&&(this.scrollTop+=Math.min(14,Math.floor(.3*(I-z))))}sb(){this.x.dispose(),this.w&&(this.w.dispose(),this.w=void 0)}tb(E,I){if(I===void 0)return;const z=E.offsetY/this.d[I].size,O=Math.floor(z/.25);return(0,l.$Im)(O,0,3)}ub(E){const I=this.q.getDomNode();let z=E;for(;((0,n.$hT)(z)||(0,n.$oT)(z))&&z!==this.o&&I.contains(z);){const O=z.getAttribute("data-index");if(O){const C=Number(O);if(!isNaN(C))return C}z=z.parentElement}}vb(E,I){return{start:this.g.indexAt(E),end:this.g.indexAfter(E+I-1)}}wb(E,I,z){const O=this.vb(E,I);let C,x;E===this.elementTop(O.start)?(C=O.start,x=0):O.end-O.start>1&&(C=O.start+1,x=this.elementTop(C)-E);let Z=0;for(;;){const Y=this.vb(E,I);let q=!1;for(let ee=Y.start;ee<Y.end;ee++){const ce=this.xb(ee);ce!==0&&this.g.splice(ee,1,[this.d[ee]]),Z+=ce,q=q||ce!==0}if(!q){Z!==0&&this.V();const ee=$.Range.relativeComplement(O,Y);for(const be of ee)for(let ke=be.start;ke<be.end;ke++)this.d[ke].row&&this.db(ke);const ce=$.Range.relativeComplement(Y,O).reverse();for(const be of ce)for(let ke=be.end-1;ke>=be.start;ke--)this.Z(ke);for(let be=Y.start;be<Y.end;be++)this.d[be].row&&this.bb(this.d[be],be);if(typeof C=="number"){const be=this.p.getFutureScrollPosition().scrollTop-E,ke=this.elementTop(C)-x+be;this.setScrollTop(ke,z)}this.N.fire(this.contentHeight);return}}}xb(E){const I=this.d[E];if(this.R.getDynamicHeight){const x=this.R.getDynamicHeight(I.element);if(x!==null){const Z=I.size;return I.size=x,I.lastDynamicHeightWidth=this.n,x-Z}}if(!I.hasDynamicHeight||I.lastDynamicHeightWidth===this.n||this.R.hasDynamicHeight&&!this.R.hasDynamicHeight(I.element))return 0;const z=I.size;if(I.row)return I.row.domNode.style.height="",I.size=I.row.domNode.offsetHeight,I.size===0&&!(0,n.$WS)(I.row.domNode,(0,n.getWindow)(I.row.domNode).document.body)&&console.warn("Measuring item node that is not in DOM! Add ListView to the DOM before measuring row height!"),I.lastDynamicHeightWidth=this.n,I.size-z;const{row:O}=this.h.alloc(I.templateId);O.domNode.style.height="",this.o.appendChild(O.domNode);const C=this.j.get(I.templateId);if(!C)throw new h.$bb("Missing renderer for templateId: "+I.templateId);return C.renderElement(I.element,E,O.templateData,void 0),I.size=O.domNode.offsetHeight,C.disposeElement?.(I.element,E,O.templateData,void 0),this.R.setDynamicHeight?.(I.element,I.size),I.lastDynamicHeightWidth=this.n,O.domNode.remove(),this.h.release(O),I.size-z}getElementDomId(E){return`${this.domId}_${E}`}dispose(){for(const E of this.d)if(E.dragStartDisposable.dispose(),E.checkedDisposable.dispose(),E.row){const I=this.j.get(E.row.templateId);I&&(I.disposeElement?.(E.element,-1,E.row.templateData,void 0),I.disposeTemplate(E.row.templateData))}this.d=[],this.domNode?.remove(),this.w?.dispose(),this.M.dispose()}}t.$TU=_,et([c.$7h],_.prototype,"onMouseClick",null),et([c.$7h],_.prototype,"onMouseDblClick",null),et([c.$7h],_.prototype,"onMouseMiddleClick",null),et([c.$7h],_.prototype,"onMouseUp",null),et([c.$7h],_.prototype,"onMouseDown",null),et([c.$7h],_.prototype,"onMouseOver",null),et([c.$7h],_.prototype,"onMouseMove",null),et([c.$7h],_.prototype,"onMouseOut",null),et([c.$7h],_.prototype,"onContextMenu",null),et([c.$7h],_.prototype,"onTouchStart",null),et([c.$7h],_.prototype,"onTap",null)}),define(we[52],ve([1,0,4,29,15,32,76,86,9,12,88,35,3,49,8,2,37,5,10,41,79,19,62,132]),function(re,t,i,n,j,F,N,w,D,c,p,y,$,g,e,s,r,h,l,v,k,A,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$_U=t.$$U=t.$0U=t.$9U=t.$6U=t.TypeNavigationMode=void 0,t.$XU=_,t.$YU=E,t.$ZU=I,t.$1U=z,t.$2U=O,t.$3U=C,t.$4U=x,t.$5U=Z,t.$7U=ke,t.$8U=Fe,h=He(h);class f{constructor(a){this.d=a,this.c=[]}get templateId(){return`template:${this.d.name}`}renderTemplate(a){return a}renderElement(a,o,m){const M=this.c.findIndex(R=>R.templateData===m);if(M>=0){const R=this.c[M];this.d.unrender(m),R.index=o}else{const R={index:o,templateData:m};this.c.push(R)}this.d.renderIndex(o,m)}splice(a,o,m){const M=[];for(const R of this.c)R.index<a?M.push(R):R.index>=a+o&&M.push({index:R.index+m-o,templateData:R.templateData});this.c=M}renderIndexes(a){for(const{index:o,templateData:m}of this.c)a.indexOf(o)>-1&&this.d.renderIndex(o,m)}disposeTemplate(a){const o=this.c.findIndex(m=>m.templateData===a);o<0||this.c.splice(o,1)}}class b{get name(){return this.g}get renderer(){return new f(this)}constructor(a){this.g=a,this.c=[],this.d=[],this.f=new $.$je,this.onChange=this.f.event}splice(a,o,m){const M=m.length-o,R=a+o,u=[];let L=0;for(;L<this.d.length&&this.d[L]<a;)u.push(this.d[L++]);for(let T=0;T<m.length;T++)m[T]&&u.push(T+a);for(;L<this.d.length&&this.d[L]>=R;)u.push(this.d[L++]+M);this.renderer.splice(a,o,m.length),this.h(u,u)}renderIndex(a,o){o.classList.toggle(this.g,this.contains(a))}unrender(a){a.classList.remove(this.g)}set(a,o){return this.h(a,[...a].sort(Oe),o)}h(a,o,m){const M=this.c,R=this.d;this.c=a,this.d=o;const u=$e(R,a);return this.renderer.renderIndexes(u),this.f.fire({indexes:a,browserEvent:m}),M}get(){return this.c}contains(a){return(0,D.$vb)(this.d,a,Oe)>=0}dispose(){(0,s.$Oc)(this.f)}}et([y.$7h],b.prototype,"renderer",null);class S extends b{constructor(a){super("selected"),this.k=a}renderIndex(a,o){super.renderIndex(a,o),this.k&&(this.contains(a)?o.setAttribute("aria-selected","true"):o.setAttribute("aria-selected","false"))}}class U{constructor(a,o,m){this.c=a,this.d=o,this.f=m}splice(a,o,m){if(!this.f)return this.c.splice(a,o,new Array(m.length).fill(!1));const M=this.c.get().map(L=>this.f.getId(this.d.element(L)).toString());if(M.length===0)return this.c.splice(a,o,new Array(m.length).fill(!1));const R=new Set(M),u=m.map(L=>R.has(this.f.getId(L).toString()));this.c.splice(a,o,u)}}function _(W){return W.tagName==="INPUT"||W.tagName==="TEXTAREA"}function B(W,a){return W.classList.contains(a)?!0:W.classList.contains("monaco-list")||!W.parentElement?!1:B(W.parentElement,a)}function E(W){return B(W,"monaco-editor")}function I(W){return B(W,"monaco-custom-toggle")}function z(W){return B(W,"action-item")}function O(W){return B(W,"monaco-tl-twistie")}function C(W){return B(W,"monaco-tree-sticky-row")}function x(W){return W.classList.contains("monaco-tree-sticky-container")}function Z(W){return W.tagName==="A"&&W.classList.contains("monaco-button")||W.tagName==="DIV"&&W.classList.contains("monaco-button-dropdown")?!0:W.classList.contains("monaco-list")||!W.parentElement?!1:Z(W.parentElement)}class Y{get g(){return $.Event.chain(this.c.add(new n.$GU(this.k.domNode,"keydown")).event,a=>a.filter(o=>!_(o.target)).map(o=>new j.$oS(o)))}constructor(a,o,m){this.h=a,this.k=o,this.c=new s.$Sc,this.d=new s.$Sc,this.f=m.multipleSelectionSupport,this.c.add(this.g(M=>{switch(M.keyCode){case e.KeyCode.Enter:return this.l(M);case e.KeyCode.UpArrow:return this.o(M);case e.KeyCode.DownArrow:return this.p(M);case e.KeyCode.PageUp:return this.q(M);case e.KeyCode.PageDown:return this.s(M);case e.KeyCode.Escape:return this.u(M);case e.KeyCode.KeyA:this.f&&(h.$k?M.metaKey:M.ctrlKey)&&this.t(M)}}))}updateOptions(a){a.multipleSelectionSupport!==void 0&&(this.f=a.multipleSelectionSupport)}l(a){a.preventDefault(),a.stopPropagation(),this.h.setSelection(this.h.getFocus(),a.browserEvent)}o(a){a.preventDefault(),a.stopPropagation(),this.h.focusPrevious(1,!1,a.browserEvent);const o=this.h.getFocus()[0];this.h.setAnchor(o),this.h.reveal(o),this.k.domNode.focus()}p(a){a.preventDefault(),a.stopPropagation(),this.h.focusNext(1,!1,a.browserEvent);const o=this.h.getFocus()[0];this.h.setAnchor(o),this.h.reveal(o),this.k.domNode.focus()}q(a){a.preventDefault(),a.stopPropagation(),this.h.focusPreviousPage(a.browserEvent);const o=this.h.getFocus()[0];this.h.setAnchor(o),this.h.reveal(o),this.k.domNode.focus()}s(a){a.preventDefault(),a.stopPropagation(),this.h.focusNextPage(a.browserEvent);const o=this.h.getFocus()[0];this.h.setAnchor(o),this.h.reveal(o),this.k.domNode.focus()}t(a){a.preventDefault(),a.stopPropagation(),this.h.setSelection((0,D.$Qb)(this.h.length),a.browserEvent),this.h.setAnchor(void 0),this.k.domNode.focus()}u(a){this.h.getSelection().length&&(a.preventDefault(),a.stopPropagation(),this.h.setSelection([],a.browserEvent),this.h.setAnchor(void 0),this.k.domNode.focus())}dispose(){this.c.dispose(),this.d.dispose()}}et([y.$7h],Y.prototype,"g",null);var q;(function(W){W[W.Automatic=0]="Automatic",W[W.Trigger=1]="Trigger"})(q||(t.TypeNavigationMode=q={}));var ee;(function(W){W[W.Idle=0]="Idle",W[W.Typing=1]="Typing"})(ee||(ee={})),t.$6U=new class{mightProducePrintableCharacter(W){return W.ctrlKey||W.metaKey||W.altKey?!1:W.keyCode>=e.KeyCode.KeyA&&W.keyCode<=e.KeyCode.KeyZ||W.keyCode>=e.KeyCode.Digit0&&W.keyCode<=e.KeyCode.Digit9||W.keyCode>=e.KeyCode.Numpad0&&W.keyCode<=e.KeyCode.Numpad9||W.keyCode>=e.KeyCode.Semicolon&&W.keyCode<=e.KeyCode.Quote}};class ce{constructor(a,o,m,M,R){this.o=a,this.p=o,this.q=m,this.s=M,this.t=R,this.c=!1,this.d=ee.Idle,this.f=q.Automatic,this.g=!1,this.h=-1,this.k=new s.$Sc,this.l=new s.$Sc,this.updateOptions(a.options)}updateOptions(a){a.typeNavigationEnabled??!0?this.u():this.v(),this.f=a.typeNavigationMode??q.Automatic}trigger(){this.g=!this.g}u(){if(this.c)return;let a=!1;const o=$.Event.chain(this.k.add(new n.$GU(this.p.domNode,"keydown")).event,R=>R.filter(u=>!_(u.target)).filter(()=>this.f===q.Automatic||this.g).map(u=>new j.$oS(u)).filter(u=>a||this.s(u)).filter(u=>this.t.mightProducePrintableCharacter(u)).forEach(u=>i.$vT.stop(u,!0)).map(u=>u.browserEvent.key)),m=$.Event.debounce(o,()=>null,800,void 0,void 0,void 0,this.k);$.Event.reduce($.Event.any(o,m),(R,u)=>u===null?null:(R||"")+u,void 0,this.k)(this.x,this,this.k),m(this.w,this,this.k),o(()=>a=!0,void 0,this.k),m(()=>a=!1,void 0,this.k),this.c=!0,this.g=!1}v(){this.c&&(this.k.clear(),this.c=!1,this.g=!1)}w(){const a=this.o.getFocus();if(a.length>0&&a[0]===this.h){const o=this.o.options.accessibilityProvider?.getAriaLabel(this.o.element(a[0]));typeof o=="string"?(0,N.$IU)(o):o&&(0,N.$IU)(o.get())}this.h=-1}x(a){if(!a){this.d=ee.Idle,this.g=!1;return}const o=this.o.getFocus(),m=o.length>0?o[0]:0,M=this.d===ee.Idle?1:0;this.d=ee.Typing;for(let R=0;R<this.o.length;R++){const u=(m+R+M)%this.o.length,L=this.q.getKeyboardNavigationLabel(this.p.element(u)),T=L&&L.toString();if(this.o.options.typeNavigationEnabled){if(typeof T<"u"){if((0,g.$Fk)(a,T)){this.h=m,this.o.setFocus([u]),this.o.reveal(u);return}const P=(0,g.$Mk)(a,T);if(P&&P[0].end-P[0].start>1&&P.length===1){this.h=m,this.o.setFocus([u]),this.o.reveal(u);return}}}else if(typeof T>"u"||(0,g.$Fk)(a,T)){this.h=m,this.o.setFocus([u]),this.o.reveal(u);return}}}dispose(){this.v(),this.k.dispose(),this.l.dispose()}}class be{constructor(a,o){this.d=a,this.f=o,this.c=new s.$Sc;const m=$.Event.chain(this.c.add(new n.$GU(o.domNode,"keydown")).event,R=>R.filter(u=>!_(u.target)).map(u=>new j.$oS(u)));$.Event.chain(m,R=>R.filter(u=>u.keyCode===e.KeyCode.Tab&&!u.ctrlKey&&!u.metaKey&&!u.shiftKey&&!u.altKey))(this.g,this,this.c)}g(a){if(a.target!==this.f.domNode)return;const o=this.d.getFocus();if(o.length===0)return;const m=this.f.domElement(o[0]);if(!m)return;const M=m.querySelector("[tabIndex]");if(!M||!(0,i.$hT)(M)||M.tabIndex===-1)return;const R=(0,i.getWindow)(M).getComputedStyle(M);R.visibility==="hidden"||R.display==="none"||(a.preventDefault(),a.stopPropagation(),M.focus())}dispose(){this.c.dispose()}}function ke(W){return h.$k?W.browserEvent.metaKey:W.browserEvent.ctrlKey}function Fe(W){return W.browserEvent.shiftKey}function ue(W){return(0,i.$pT)(W)&&W.button===2}const Q={isSelectionSingleChangeEvent:ke,isSelectionRangeChangeEvent:Fe};class he{constructor(a){this.k=a,this.f=new s.$Sc,this.g=new $.$je,this.onPointer=this.g.event,a.options.multipleSelectionSupport!==!1&&(this.c=this.k.options.multipleSelectionController||Q),this.d=typeof a.options.mouseSupport>"u"||!!a.options.mouseSupport,this.d&&(a.onMouseDown(this.s,this,this.f),a.onContextMenu(this.t,this,this.f),a.onMouseDblClick(this.v,this,this.f),a.onTouchStart(this.s,this,this.f),this.f.add(F.$_T.addTarget(a.getHTMLElement()))),$.Event.any(a.onMouseClick,a.onMouseMiddleClick,a.onTap)(this.u,this,this.f)}updateOptions(a){a.multipleSelectionSupport!==void 0&&(this.c=void 0,a.multipleSelectionSupport&&(this.c=this.k.options.multipleSelectionController||Q))}o(a){return this.c?this.c.isSelectionSingleChangeEvent(a):!1}p(a){return this.c?this.c.isSelectionRangeChangeEvent(a):!1}q(a){return this.o(a)||this.p(a)}s(a){E(a.browserEvent.target)||(0,i.$5S)()!==a.browserEvent.target&&this.k.domFocus()}t(a){if(_(a.browserEvent.target)||E(a.browserEvent.target))return;const o=typeof a.index>"u"?[]:[a.index];this.k.setFocus(o,a.browserEvent)}u(a){if(!this.d||_(a.browserEvent.target)||E(a.browserEvent.target)||a.browserEvent.isHandledByList)return;a.browserEvent.isHandledByList=!0;const o=a.index;if(typeof o>"u"){this.k.setFocus([],a.browserEvent),this.k.setSelection([],a.browserEvent),this.k.setAnchor(void 0);return}if(this.q(a))return this.w(a);this.k.setFocus([o],a.browserEvent),this.k.setAnchor(o),ue(a.browserEvent)||this.k.setSelection([o],a.browserEvent),this.g.fire(a)}v(a){if(_(a.browserEvent.target)||E(a.browserEvent.target)||this.q(a)||a.browserEvent.isHandledByList)return;a.browserEvent.isHandledByList=!0;const o=this.k.getFocus();this.k.setSelection(o,a.browserEvent)}w(a){const o=a.index;let m=this.k.getAnchor();if(this.p(a)){typeof m>"u"&&(m=this.k.getFocus()[0]??o,this.k.setAnchor(m));const M=Math.min(m,o),R=Math.max(m,o),u=(0,D.$Qb)(M,R+1),L=this.k.getSelection(),T=te($e(L,[m]),m);if(T.length===0)return;const P=$e(u,Ae(L,T));this.k.setSelection(P,a.browserEvent),this.k.setFocus([o],a.browserEvent)}else if(this.o(a)){const M=this.k.getSelection(),R=M.filter(u=>u!==o);this.k.setFocus([o]),this.k.setAnchor(o),M.length===R.length?this.k.setSelection([...R,o],a.browserEvent):this.k.setSelection(R,a.browserEvent)}}dispose(){this.f.dispose()}}t.$9U=he;class le{constructor(a,o){this.c=a,this.d=o}style(a){const o=this.d&&`.${this.d}`,m=[];a.listBackground&&m.push(`.monaco-list${o} .monaco-list-rows { background: ${a.listBackground}; }`),a.listFocusBackground&&(m.push(`.monaco-list${o}:focus .monaco-list-row.focused { background-color: ${a.listFocusBackground}; }`),m.push(`.monaco-list${o}:focus .monaco-list-row.focused:hover { background-color: ${a.listFocusBackground}; }`)),a.listFocusForeground&&m.push(`.monaco-list${o}:focus .monaco-list-row.focused { color: ${a.listFocusForeground}; }`),a.listActiveSelectionBackground&&(m.push(`.monaco-list${o}:focus .monaco-list-row.selected { background-color: ${a.listActiveSelectionBackground}; }`),m.push(`.monaco-list${o}:focus .monaco-list-row.selected:hover { background-color: ${a.listActiveSelectionBackground}; }`)),a.listActiveSelectionForeground&&m.push(`.monaco-list${o}:focus .monaco-list-row.selected { color: ${a.listActiveSelectionForeground}; }`),a.listActiveSelectionIconForeground&&m.push(`.monaco-list${o}:focus .monaco-list-row.selected .codicon { color: ${a.listActiveSelectionIconForeground}; }`),a.listFocusAndSelectionBackground&&m.push(`
				.monaco-drag-image,
				.monaco-list${o}:focus .monaco-list-row.selected.focused { background-color: ${a.listFocusAndSelectionBackground}; }
			`),a.listFocusAndSelectionForeground&&m.push(`
				.monaco-drag-image,
				.monaco-list${o}:focus .monaco-list-row.selected.focused { color: ${a.listFocusAndSelectionForeground}; }
			`),a.listInactiveFocusForeground&&(m.push(`.monaco-list${o} .monaco-list-row.focused { color:  ${a.listInactiveFocusForeground}; }`),m.push(`.monaco-list${o} .monaco-list-row.focused:hover { color:  ${a.listInactiveFocusForeground}; }`)),a.listInactiveSelectionIconForeground&&m.push(`.monaco-list${o} .monaco-list-row.focused .codicon { color:  ${a.listInactiveSelectionIconForeground}; }`),a.listInactiveFocusBackground&&(m.push(`.monaco-list${o} .monaco-list-row.focused { background-color:  ${a.listInactiveFocusBackground}; }`),m.push(`.monaco-list${o} .monaco-list-row.focused:hover { background-color:  ${a.listInactiveFocusBackground}; }`)),a.listInactiveSelectionBackground&&(m.push(`.monaco-list${o} .monaco-list-row.selected { background-color:  ${a.listInactiveSelectionBackground}; }`),m.push(`.monaco-list${o} .monaco-list-row.selected:hover { background-color:  ${a.listInactiveSelectionBackground}; }`)),a.listInactiveSelectionForeground&&m.push(`.monaco-list${o} .monaco-list-row.selected { color: ${a.listInactiveSelectionForeground}; }`),a.listHoverBackground&&m.push(`.monaco-list${o}:not(.drop-target):not(.dragging) .monaco-list-row:hover:not(.selected):not(.focused) { background-color: ${a.listHoverBackground}; }`),a.listHoverForeground&&m.push(`.monaco-list${o}:not(.drop-target):not(.dragging) .monaco-list-row:hover:not(.selected):not(.focused) { color:  ${a.listHoverForeground}; }`);const M=(0,i.$ST)(a.listFocusAndSelectionOutline,(0,i.$ST)(a.listSelectionOutline,a.listFocusOutline??""));M&&m.push(`.monaco-list${o}:focus .monaco-list-row.focused.selected { outline: 1px solid ${M}; outline-offset: -1px;}`),a.listFocusOutline&&m.push(`
				.monaco-drag-image,
				.monaco-list${o}:focus .monaco-list-row.focused { outline: 1px solid ${a.listFocusOutline}; outline-offset: -1px; }
				.monaco-workbench.context-menu-visible .monaco-list${o}.last-focused .monaco-list-row.focused { outline: 1px solid ${a.listFocusOutline}; outline-offset: -1px; }
			`);const R=(0,i.$ST)(a.listSelectionOutline,a.listInactiveFocusOutline??"");R&&m.push(`.monaco-list${o} .monaco-list-row.focused.selected { outline: 1px dotted ${R}; outline-offset: -1px; }`),a.listSelectionOutline&&m.push(`.monaco-list${o} .monaco-list-row.selected { outline: 1px dotted ${a.listSelectionOutline}; outline-offset: -1px; }`),a.listInactiveFocusOutline&&m.push(`.monaco-list${o} .monaco-list-row.focused { outline: 1px dotted ${a.listInactiveFocusOutline}; outline-offset: -1px; }`),a.listHoverOutline&&m.push(`.monaco-list${o} .monaco-list-row:hover { outline: 1px dashed ${a.listHoverOutline}; outline-offset: -1px; }`),a.listDropOverBackground&&m.push(`
				.monaco-list${o}.drop-target,
				.monaco-list${o} .monaco-list-rows.drop-target,
				.monaco-list${o} .monaco-list-row.drop-target { background-color: ${a.listDropOverBackground} !important; color: inherit !important; }
			`),a.listDropBetweenBackground&&(m.push(`
			.monaco-list${o} .monaco-list-rows.drop-target-before .monaco-list-row:first-child::before,
			.monaco-list${o} .monaco-list-row.drop-target-before::before {
				content: ""; position: absolute; top: 0px; left: 0px; width: 100%; height: 1px;
				background-color: ${a.listDropBetweenBackground};
			}`),m.push(`
			.monaco-list${o} .monaco-list-rows.drop-target-after .monaco-list-row:last-child::after,
			.monaco-list${o} .monaco-list-row.drop-target-after::after {
				content: ""; position: absolute; bottom: 0px; left: 0px; width: 100%; height: 1px;
				background-color: ${a.listDropBetweenBackground};
			}`)),a.tableColumnsBorder&&m.push(`
				.monaco-table > .monaco-split-view2,
				.monaco-table > .monaco-split-view2 .monaco-sash.vertical::before,
				.monaco-workbench:not(.reduce-motion) .monaco-table:hover > .monaco-split-view2,
				.monaco-workbench:not(.reduce-motion) .monaco-table:hover > .monaco-split-view2 .monaco-sash.vertical::before {
					border-color: ${a.tableColumnsBorder};
				}

				.monaco-workbench:not(.reduce-motion) .monaco-table > .monaco-split-view2,
				.monaco-workbench:not(.reduce-motion) .monaco-table > .monaco-split-view2 .monaco-sash.vertical::before {
					border-color: transparent;
				}
			`),a.tableOddRowsBackgroundColor&&m.push(`
				.monaco-table .monaco-list-row[data-parity=odd]:not(.focused):not(.selected):not(:hover) .monaco-table-tr,
				.monaco-table .monaco-list:not(:focus) .monaco-list-row[data-parity=odd].focused:not(.selected):not(:hover) .monaco-table-tr,
				.monaco-table .monaco-list:not(.focused) .monaco-list-row[data-parity=odd].focused:not(.selected):not(:hover) .monaco-table-tr {
					background-color: ${a.tableOddRowsBackgroundColor};
				}
			`),this.c.textContent=m.join(`
`)}}t.$0U=le,t.$$U={listFocusBackground:"#7FB0D0",listActiveSelectionBackground:"#0E639C",listActiveSelectionForeground:"#FFFFFF",listActiveSelectionIconForeground:"#FFFFFF",listFocusAndSelectionOutline:"#90C2F9",listFocusAndSelectionBackground:"#094771",listFocusAndSelectionForeground:"#FFFFFF",listInactiveSelectionBackground:"#3F3F46",listInactiveSelectionIconForeground:"#FFFFFF",listHoverBackground:"#2A2D2E",listDropOverBackground:"#383B3D",listDropBetweenBackground:"#EEEEEE",treeIndentGuidesStroke:"#a9a9a9",treeInactiveIndentGuidesStroke:p.$lu.fromHex("#a9a9a9").transparent(.4).toString(),tableColumnsBorder:p.$lu.fromHex("#cccccc").transparent(.2).toString(),tableOddRowsBackgroundColor:p.$lu.fromHex("#cccccc").transparent(.04).toString(),listBackground:void 0,listFocusForeground:void 0,listInactiveSelectionForeground:void 0,listInactiveFocusForeground:void 0,listInactiveFocusBackground:void 0,listHoverForeground:void 0,listFocusOutline:void 0,listInactiveFocusOutline:void 0,listSelectionOutline:void 0,listHoverOutline:void 0,treeStickyScrollBackground:void 0,treeStickyScrollBorder:void 0,treeStickyScrollShadow:void 0};const Ne={keyboardSupport:!0,mouseSupport:!0,multipleSelectionSupport:!0,dnd:{getDragURI(){return null},onDragStart(){},onDragOver(){return!1},drop(){},dispose(){}}};function te(W,a){const o=W.indexOf(a);if(o===-1)return[];const m=[];let M=o-1;for(;M>=0&&W[M]===a-(o-M);)m.push(W[M--]);for(m.reverse(),M=o;M<W.length&&W[M]===a+(M-o);)m.push(W[M++]);return m}function $e(W,a){const o=[];let m=0,M=0;for(;m<W.length||M<a.length;)if(m>=W.length)o.push(a[M++]);else if(M>=a.length)o.push(W[m++]);else if(W[m]===a[M]){o.push(W[m]),m++,M++;continue}else W[m]<a[M]?o.push(W[m++]):o.push(a[M++]);return o}function Ae(W,a){const o=[];let m=0,M=0;for(;m<W.length||M<a.length;)if(m>=W.length)o.push(a[M++]);else if(M>=a.length)o.push(W[m++]);else if(W[m]===a[M]){m++,M++;continue}else W[m]<a[M]?o.push(W[m++]):M++;return o}const Oe=(W,a)=>W-a;class Ie{constructor(a,o){this.c=a,this.d=o}get templateId(){return this.c}renderTemplate(a){return this.d.map(o=>o.renderTemplate(a))}renderElement(a,o,m,M){let R=0;for(const u of this.d)u.renderElement(a,o,m[R++],M)}disposeElement(a,o,m,M){let R=0;for(const u of this.d)u.disposeElement?.(a,o,m[R],M),R+=1}disposeTemplate(a){let o=0;for(const m of this.d)m.disposeTemplate(a[o++])}}class Ce{constructor(a){this.c=a,this.templateId="a18n"}renderTemplate(a){return{container:a,disposables:new s.$Sc}}renderElement(a,o,m){const M=this.c.getAriaLabel(a),R=M&&typeof M!="string"?M:(0,d.constObservable)(M);m.disposables.add((0,d.autorun)(L=>{this.d(L.readObservable(R),m.container)}));const u=this.c.getAriaLevel&&this.c.getAriaLevel(a);typeof u=="number"?m.container.setAttribute("aria-level",`${u}`):m.container.removeAttribute("aria-level")}d(a,o){a?o.setAttribute("aria-label",a):o.removeAttribute("aria-label")}disposeElement(a,o,m,M){m.disposables.clear()}disposeTemplate(a){a.disposables.dispose()}}class se{constructor(a,o){this.c=a,this.d=o}getDragElements(a){const o=this.c.getSelectedElements();return o.indexOf(a)>-1?o:[a]}getDragURI(a){return this.d.getDragURI(a)}getDragLabel(a,o){if(this.d.getDragLabel)return this.d.getDragLabel(a,o)}onDragStart(a,o){this.d.onDragStart?.(a,o)}onDragOver(a,o,m,M,R){return this.d.onDragOver(a,o,m,M,R)}onDragLeave(a,o,m,M){this.d.onDragLeave?.(a,o,m,M)}onDragEnd(a){this.d.onDragEnd?.(a)}drop(a,o,m,M,R){this.d.drop(a,o,m,M,R)}dispose(){this.d.dispose()}}class K{get onDidChangeFocus(){return $.Event.map(this.g.wrapEvent(this.c.onChange),a=>this.G(a),this.y)}get onDidChangeSelection(){return $.Event.map(this.g.wrapEvent(this.d.onChange),a=>this.G(a),this.y)}get domId(){return this.k.domId}get onDidScroll(){return this.k.onDidScroll}get onMouseClick(){return this.k.onMouseClick}get onMouseDblClick(){return this.k.onMouseDblClick}get onMouseMiddleClick(){return this.k.onMouseMiddleClick}get onPointer(){return this.w.onPointer}get onMouseUp(){return this.k.onMouseUp}get onMouseDown(){return this.k.onMouseDown}get onMouseOver(){return this.k.onMouseOver}get onMouseMove(){return this.k.onMouseMove}get onMouseOut(){return this.k.onMouseOut}get onTouchStart(){return this.k.onTouchStart}get onTap(){return this.k.onTap}get onContextMenu(){let a=!1;const o=$.Event.chain(this.y.add(new n.$GU(this.k.domNode,"keydown")).event,R=>R.map(u=>new j.$oS(u)).filter(u=>a=u.keyCode===e.KeyCode.ContextMenu||u.shiftKey&&u.keyCode===e.KeyCode.F10).map(u=>i.$vT.stop(u,!0)).filter(()=>!1)),m=$.Event.chain(this.y.add(new n.$GU(this.k.domNode,"keyup")).event,R=>R.forEach(()=>a=!1).map(u=>new j.$oS(u)).filter(u=>u.keyCode===e.KeyCode.ContextMenu||u.shiftKey&&u.keyCode===e.KeyCode.F10).map(u=>i.$vT.stop(u,!0)).map(({browserEvent:u})=>{const L=this.getFocus(),T=L.length?L[0]:void 0,P=typeof T<"u"?this.k.element(T):void 0,H=typeof T<"u"?this.k.domElement(T):this.k.domNode;return{index:T,element:P,anchor:H,browserEvent:u}})),M=$.Event.chain(this.k.onContextMenu,R=>R.filter(u=>!a).map(({element:u,index:L,browserEvent:T})=>({element:u,index:L,anchor:new A.$jS((0,i.getWindow)(this.k.domNode),T),browserEvent:T})));return $.Event.any(o,m,M)}get onKeyDown(){return this.y.add(new n.$GU(this.k.domNode,"keydown")).event}get onKeyUp(){return this.y.add(new n.$GU(this.k.domNode,"keyup")).event}get onKeyPress(){return this.y.add(new n.$GU(this.k.domNode,"keypress")).event}get onDidFocus(){return $.Event.signal(this.y.add(new n.$GU(this.k.domNode,"focus",!0)).event)}get onDidBlur(){return $.Event.signal(this.y.add(new n.$GU(this.k.domNode,"blur",!0)).event)}constructor(a,o,m,M,R=Ne){this.A=a,this.B=R,this.c=new b("focused"),this.f=new b("anchor"),this.g=new $.$re,this.x="",this.y=new s.$Sc,this.z=new $.$je,this.onDidDispose=this.z.event;const u=this.B.accessibilityProvider&&this.B.accessibilityProvider.getWidgetRole?this.B.accessibilityProvider?.getWidgetRole():"list";this.d=new S(u!=="listbox");const L=[this.c.renderer,this.d.renderer];this.u=R.accessibilityProvider,this.u&&(L.push(new Ce(this.u)),this.u.onDidChangeActiveDescendant?.(this.I,this,this.y)),M=M.map(P=>new Ie(P.templateId,[...L,P]));const T={...R,dnd:R.dnd&&new se(this,R.dnd)};if(this.k=this.C(o,m,M,T),this.k.domNode.setAttribute("role",u),R.styleController)this.q=R.styleController(this.k.domId);else{const P=(0,i.$aT)(this.k.domNode);this.q=new le(P,this.k.domId)}if(this.o=new w.$KU([new U(this.c,this.k,R.identityProvider),new U(this.d,this.k,R.identityProvider),new U(this.f,this.k,R.identityProvider),this.k]),this.y.add(this.c),this.y.add(this.d),this.y.add(this.f),this.y.add(this.k),this.y.add(this.z),this.y.add(new be(this,this.k)),(typeof R.keyboardSupport!="boolean"||R.keyboardSupport)&&(this.v=new Y(this,this.k,R),this.y.add(this.v)),R.keyboardNavigationLabelProvider){const P=R.keyboardNavigationDelegate||t.$6U;this.t=new ce(this,this.k,R.keyboardNavigationLabelProvider,R.keyboardNavigationEventFilter??(()=>!0),P),this.y.add(this.t)}this.w=this.D(R),this.y.add(this.w),this.onDidChangeFocus(this.H,this,this.y),this.onDidChangeSelection(this.J,this,this.y),this.u&&(this.ariaLabel=this.u.getWidgetAriaLabel()),this.B.multipleSelectionSupport!==!1&&this.k.domNode.setAttribute("aria-multiselectable","true")}C(a,o,m,M){return new k.$TU(a,o,m,M)}D(a){return new he(this)}updateOptions(a={}){this.B={...this.B,...a},this.t?.updateOptions(this.B),this.B.multipleSelectionController!==void 0&&(this.B.multipleSelectionSupport?this.k.domNode.setAttribute("aria-multiselectable","true"):this.k.domNode.removeAttribute("aria-multiselectable")),this.w.updateOptions(a),this.v?.updateOptions(a),this.k.updateOptions(a)}get options(){return this.B}splice(a,o,m=[]){if(a<0||a>this.k.length)throw new v.$VU(this.A,`Invalid start index: ${a}`);if(o<0)throw new v.$VU(this.A,`Invalid delete count: ${o}`);o===0&&m.length===0||this.g.bufferEvents(()=>this.o.splice(a,o,m))}updateWidth(a){this.k.updateWidth(a)}updateElementHeight(a,o){this.k.updateElementHeight(a,o,null)}rerender(){this.k.rerender()}element(a){return this.k.element(a)}indexOf(a){return this.k.indexOf(a)}indexAt(a){return this.k.indexAt(a)}get length(){return this.k.length}get contentHeight(){return this.k.contentHeight}get contentWidth(){return this.k.contentWidth}get onDidChangeContentHeight(){return this.k.onDidChangeContentHeight}get onDidChangeContentWidth(){return this.k.onDidChangeContentWidth}get scrollTop(){return this.k.getScrollTop()}set scrollTop(a){this.k.setScrollTop(a)}get scrollLeft(){return this.k.getScrollLeft()}set scrollLeft(a){this.k.setScrollLeft(a)}get scrollHeight(){return this.k.scrollHeight}get renderHeight(){return this.k.renderHeight}get firstVisibleIndex(){return this.k.firstVisibleIndex}get firstMostlyVisibleIndex(){return this.k.firstMostlyVisibleIndex}get lastVisibleIndex(){return this.k.lastVisibleIndex}get ariaLabel(){return this.x}set ariaLabel(a){this.x=a,this.k.domNode.setAttribute("aria-label",a)}domFocus(){this.k.domNode.focus({preventScroll:!0})}layout(a,o){this.k.layout(a,o)}triggerTypeNavigation(){this.t?.trigger()}setSelection(a,o){for(const m of a)if(m<0||m>=this.length)throw new v.$VU(this.A,`Invalid index ${m}`);this.d.set(a,o)}getSelection(){return this.d.get()}getSelectedElements(){return this.getSelection().map(a=>this.k.element(a))}setAnchor(a){if(typeof a>"u"){this.f.set([]);return}if(a<0||a>=this.length)throw new v.$VU(this.A,`Invalid index ${a}`);this.f.set([a])}getAnchor(){return(0,D.$Nb)(this.f.get(),void 0)}getAnchorElement(){const a=this.getAnchor();return typeof a>"u"?void 0:this.element(a)}setFocus(a,o){for(const m of a)if(m<0||m>=this.length)throw new v.$VU(this.A,`Invalid index ${m}`);this.c.set(a,o)}focusNext(a=1,o=!1,m,M){if(this.length===0)return;const R=this.c.get(),u=this.E(R.length>0?R[0]+a:0,o,M);u>-1&&this.setFocus([u],m)}focusPrevious(a=1,o=!1,m,M){if(this.length===0)return;const R=this.c.get(),u=this.F(R.length>0?R[0]-a:0,o,M);u>-1&&this.setFocus([u],m)}async focusNextPage(a,o){let m=this.k.indexAt(this.k.getScrollTop()+this.k.renderHeight);m=m===0?0:m-1;const M=this.getFocus()[0];if(M!==m&&(M===void 0||m>M)){const R=this.F(m,!1,o);R>-1&&M!==R?this.setFocus([R],a):this.setFocus([m],a)}else{const R=this.k.getScrollTop();let u=R+this.k.renderHeight;m>M&&(u-=this.k.elementHeight(m)),this.k.setScrollTop(u),this.k.getScrollTop()!==R&&(this.setFocus([]),await(0,c.$Dh)(0),await this.focusNextPage(a,o))}}async focusPreviousPage(a,o,m=()=>0){let M;const R=m(),u=this.k.getScrollTop()+R;u===0?M=this.k.indexAt(u):M=this.k.indexAfter(u-1);const L=this.getFocus()[0];if(L!==M&&(L===void 0||L>=M)){const T=this.E(M,!1,o);T>-1&&L!==T?this.setFocus([T],a):this.setFocus([M],a)}else{const T=u;this.k.setScrollTop(u-this.k.renderHeight-R),this.k.getScrollTop()+m()!==T&&(this.setFocus([]),await(0,c.$Dh)(0),await this.focusPreviousPage(a,o,m))}}focusLast(a,o){if(this.length===0)return;const m=this.F(this.length-1,!1,o);m>-1&&this.setFocus([m],a)}focusFirst(a,o){this.focusNth(0,a,o)}focusNth(a,o,m){if(this.length===0)return;const M=this.E(a,!1,m);M>-1&&this.setFocus([M],o)}E(a,o=!1,m){for(let M=0;M<this.length;M++){if(a>=this.length&&!o)return-1;if(a=a%this.length,!m||m(this.element(a)))return a;a++}return-1}F(a,o=!1,m){for(let M=0;M<this.length;M++){if(a<0&&!o)return-1;if(a=(this.length+a%this.length)%this.length,!m||m(this.element(a)))return a;a--}return-1}getFocus(){return this.c.get()}getFocusedElements(){return this.getFocus().map(a=>this.k.element(a))}reveal(a,o,m=0){if(a<0||a>=this.length)throw new v.$VU(this.A,`Invalid index ${a}`);const M=this.k.getScrollTop(),R=this.k.elementTop(a),u=this.k.elementHeight(a);if((0,l.$gg)(o)){const L=u-this.k.renderHeight+m;this.k.setScrollTop(L*(0,r.$Im)(o,0,1)+R-m)}else{const L=R+u,T=M+this.k.renderHeight;R<M+m&&L>=T||(R<M+m||L>=T&&u>=this.k.renderHeight?this.k.setScrollTop(R-m):L>=T&&this.k.setScrollTop(L-this.k.renderHeight))}}getRelativeTop(a,o=0){if(a<0||a>=this.length)throw new v.$VU(this.A,`Invalid index ${a}`);const m=this.k.getScrollTop(),M=this.k.elementTop(a),R=this.k.elementHeight(a);if(M<m+o||M+R>m+this.k.renderHeight)return null;const u=R-this.k.renderHeight+o;return Math.abs((m+o-M)/u)}isDOMFocused(){return(0,i.$6S)(this.k.domNode)}getHTMLElement(){return this.k.domNode}getScrollableElement(){return this.k.scrollableElementDomNode}getElementID(a){return this.k.getElementDomId(a)}getElementTop(a){return this.k.elementTop(a)}style(a){this.q.style(a)}G({indexes:a,browserEvent:o}){return{indexes:a,elements:a.map(m=>this.k.element(m)),browserEvent:o}}H(){const a=this.c.get();this.k.domNode.classList.toggle("element-focused",a.length>0),this.I()}I(){const a=this.c.get();if(a.length>0){let o;this.u?.getActiveDescendantId&&(o=this.u.getActiveDescendantId(this.k.element(a[0]))),this.k.domNode.setAttribute("aria-activedescendant",o||this.k.getElementDomId(a[0]))}else this.k.domNode.removeAttribute("aria-activedescendant")}J(){const a=this.d.get();this.k.domNode.classList.toggle("selection-none",a.length===0),this.k.domNode.classList.toggle("selection-single",a.length===1),this.k.domNode.classList.toggle("selection-multiple",a.length>1)}dispose(){this.z.fire(),this.y.dispose(),this.z.dispose()}}t.$_U=K,et([y.$7h],K.prototype,"onDidChangeFocus",null),et([y.$7h],K.prototype,"onDidChangeSelection",null),et([y.$7h],K.prototype,"onContextMenu",null),et([y.$7h],K.prototype,"onKeyDown",null),et([y.$7h],K.prototype,"onKeyUp",null),et([y.$7h],K.prototype,"onKeyPress",null),et([y.$7h],K.prototype,"onDidFocus",null),et([y.$7h],K.prototype,"onDidBlur",null)}),define(we[134],ve([7]),{}),define(we[135],ve([7]),{}),define(we[136],ve([7]),{}),define(we[137],ve([7]),{}),define(we[138],ve([7]),{}),define(we[13],ve([1,0]),function(re,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.localize=j,t.localize2=N;const i=globalThis._VSCODE_NLS_LANGUAGE==="pseudo"||typeof document<"u"&&document.location&&document.location.hash.indexOf("pseudo=true")>=0;function n(w,D){let c;return D.length===0?c=w:c=w.replace(/\{(\d+)\}/g,(p,y)=>{const $=y[0],g=D[$];let e=p;return typeof g=="string"?e=g:(typeof g=="number"||typeof g=="boolean"||g===void 0||g===null)&&(e=String(g)),e}),i&&(c="\uFF3B"+c.replace(/[aouei]/g,"$&$&")+"\uFF3D"),c}function j(w,D,...c){return n(typeof w=="number"?F(w,D):D,c)}function F(w,D){const c=globalThis._VSCODE_NLS_MESSAGES?.[w];if(typeof c!="string"){if(typeof D=="string")return D;throw new Error(`!!! NLS MISSING: ${w} !!!`)}return c}function N(w,D,...c){let p;typeof w=="number"?p=F(w,D):p=D;const y=n(p,c);return{value:y,original:D===p?y:n(D,c)}}}),define(we[139],ve([1,0,4,29,15,120,77,33,14,52,9,3,8,2,5,20,13,135]),function(re,t,i,n,j,F,N,w,D,c,p,y,$,g,e,s,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$jV=void 0,i=He(i),p=He(p);const h=i.$,l="selectOption.entry.template";class v{get templateId(){return l}renderTemplate(d){const f=Object.create(null);return f.root=d,f.text=i.$AT(d,h(".option-text")),f.detail=i.$AT(d,h(".option-detail")),f.decoratorRight=i.$AT(d,h(".option-decorator-right")),f}renderElement(d,f,b){const S=b,U=d.text,_=d.detail,B=d.decoratorRight,E=d.isDisabled;S.text.textContent=U,S.detail.textContent=_||"",S.decoratorRight.innerText=B||"",E?S.root.classList.add("option-disabled"):S.root.classList.remove("option-disabled")}disposeTemplate(d){}}class k extends g.$Tc{static{this.a=32}static{this.b=2}static{this.c=3}constructor(d,f,b,S,U){super(),this.m=[],this.F=0,this.H=!1,this.J=!1,this.N=!1,this.f=!1,this.s=S,this.g=U||Object.create(null),typeof this.g.minBottomMargin!="number"?this.g.minBottomMargin=k.a:this.g.minBottomMargin<0&&(this.g.minBottomMargin=0),this.h=document.createElement("select"),this.h.className="monaco-select-box monaco-select-box-dropdown-padding",typeof this.g.ariaLabel=="string"&&this.h.setAttribute("aria-label",this.g.ariaLabel),typeof this.g.ariaDescription=="string"&&this.h.setAttribute("aria-description",this.g.ariaDescription),this.r=new y.$je,this.B(this.r),this.Q(),this.P(b),this.n=f||0,d&&this.setOptions(d,f),this.S()}O(d){!this.M&&d?this.M=this.B((0,w.$iV)().setupManagedHover((0,D.$wU)("mouse"),this.h,d)):this.M&&this.M.update(d)}getHeight(){return 22}getTemplateId(){return l}P(d){this.u=d,this.w=i.$(".monaco-select-box-dropdown-container"),this.w.classList.add("monaco-select-box-dropdown-padding"),this.I=i.$AT(this.w,h(".select-box-details-pane"));const f=i.$AT(this.w,h(".select-box-dropdown-container-width-control")),b=i.$AT(f,h(".width-control-div"));this.D=document.createElement("span"),this.D.className="option-text-width-control",i.$AT(b,this.D),this.G=N.AnchorPosition.BELOW,this.y=i.$aT(this.w),this.w.setAttribute("draggable","true"),this.B(i.$sS(this.w,i.$tT.DRAG_START,S=>{i.$vT.stop(S,!0)}))}Q(){this.B(i.$tS(this.h,"change",f=>{this.n=f.target.selectedIndex,this.r.fire({index:f.target.selectedIndex,selected:f.target.value}),this.m[this.n]&&this.m[this.n].text&&this.O(this.m[this.n].text)})),this.B(i.$sS(this.h,i.$tT.CLICK,f=>{i.$vT.stop(f),this.f?this.Z(!0):this.Y()})),this.B(i.$sS(this.h,i.$tT.MOUSE_DOWN,f=>{i.$vT.stop(f)}));let d;this.B(i.$sS(this.h,"touchstart",f=>{d=this.f})),this.B(i.$sS(this.h,"touchend",f=>{i.$vT.stop(f),d?this.Z(!0):this.Y()})),this.B(i.$sS(this.h,i.$tT.KEY_DOWN,f=>{const b=new j.$oS(f);let S=!1;e.$k?(b.keyCode===$.KeyCode.DownArrow||b.keyCode===$.KeyCode.UpArrow||b.keyCode===$.KeyCode.Space||b.keyCode===$.KeyCode.Enter)&&(S=!0):(b.keyCode===$.KeyCode.DownArrow&&b.altKey||b.keyCode===$.KeyCode.UpArrow&&b.altKey||b.keyCode===$.KeyCode.Space||b.keyCode===$.KeyCode.Enter)&&(S=!0),S&&(this.Y(),i.$vT.stop(f,!0))}))}get onDidSelect(){return this.r.event}setOptions(d,f){p.$tb(this.m,d)||(this.m=d,this.h.options.length=0,this.H=!1,this.L=void 0,this.m.forEach((b,S)=>{this.h.add(this.X(b.text,S,b.isDisabled)),typeof b.description=="string"&&(this.H=!0)})),f!==void 0&&(this.select(f),this.F=this.n)}setEnabled(d){this.h.disabled=!d}R(){this.z?.splice(0,this.z.length,this.m)}select(d){d>=0&&d<this.m.length?this.n=d:d>this.m.length-1?this.select(this.m.length-1):this.n<0&&(this.n=0),this.h.selectedIndex=this.n,this.m[this.n]&&this.m[this.n].text&&this.O(this.m[this.n].text)}setAriaLabel(d){this.g.ariaLabel=d,this.h.setAttribute("aria-label",this.g.ariaLabel)}focus(){this.h&&(this.h.tabIndex=0,this.h.focus())}blur(){this.h&&(this.h.tabIndex=-1,this.h.blur())}setFocusable(d){this.h.tabIndex=d?0:-1}render(d){this.j=d,d.classList.add("select-container"),d.appendChild(this.h),this.U()}S(){const d=[];this.s.listFocusBackground&&d.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.focused { background-color: ${this.s.listFocusBackground} !important; }`),this.s.listFocusForeground&&d.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.focused { color: ${this.s.listFocusForeground} !important; }`),this.s.decoratorRightForeground&&d.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.focused) .option-decorator-right { color: ${this.s.decoratorRightForeground}; }`),this.s.selectBackground&&this.s.selectBorder&&this.s.selectBorder!==this.s.selectBackground?(d.push(`.monaco-select-box-dropdown-container { border: 1px solid ${this.s.selectBorder} } `),d.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-top { border-top: 1px solid ${this.s.selectBorder} } `),d.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-bottom { border-bottom: 1px solid ${this.s.selectBorder} } `)):this.s.selectListBorder&&(d.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-top { border-top: 1px solid ${this.s.selectListBorder} } `),d.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-bottom { border-bottom: 1px solid ${this.s.selectListBorder} } `)),this.s.listHoverForeground&&d.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.option-disabled):not(.focused):hover { color: ${this.s.listHoverForeground} !important; }`),this.s.listHoverBackground&&d.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.option-disabled):not(.focused):hover { background-color: ${this.s.listHoverBackground} !important; }`),this.s.listFocusOutline&&d.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.focused { outline: 1.6px dotted ${this.s.listFocusOutline} !important; outline-offset: -1.6px !important; }`),this.s.listHoverOutline&&d.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.option-disabled):not(.focused):hover { outline: 1.6px dashed ${this.s.listHoverOutline} !important; outline-offset: -1.6px !important; }`),d.push(".monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.option-disabled.focused { background-color: transparent !important; color: inherit !important; outline: none !important; }"),d.push(".monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.option-disabled:hover { background-color: transparent !important; color: inherit !important; outline: none !important; }"),this.y.textContent=d.join(`
`)}U(){const d=this.s.selectBackground??"",f=this.s.selectForeground??"",b=this.s.selectBorder??"";this.h.style.backgroundColor=d,this.h.style.color=f,this.h.style.borderColor=b}W(){const d=this.s.selectBackground??"",f=i.$ST(this.s.selectListBackground,d);this.C.style.backgroundColor=f,this.I.style.backgroundColor=f;const b=this.s.focusBorder??"";this.w.style.outlineColor=b,this.w.style.outlineOffset="-1px",this.z.style(this.s)}X(d,f,b){const S=document.createElement("option");return S.value=d,S.text=d,S.disabled=!!b,S}Y(){this.I.innerText="",!(!this.u||this.f)&&(this.eb(this.w),this.R(),this.u.showContextView({getAnchor:()=>this.h,render:d=>this.ab(d,!0),layout:()=>{this.cb()},onHide:()=>{this.w.classList.remove("visible"),this.h.classList.remove("synthetic-focus")},anchorPosition:this.G},this.g.optionsAsChildren?this.j:void 0),this.f=!0,this.Z(!1),this.u.showContextView({getAnchor:()=>this.h,render:d=>this.ab(d),layout:()=>this.cb(),onHide:()=>{this.w.classList.remove("visible"),this.h.classList.remove("synthetic-focus")},anchorPosition:this.G},this.g.optionsAsChildren?this.j:void 0),this.F=this.n,this.f=!0,this.h.setAttribute("aria-expanded","true"))}Z(d){!this.u||!this.f||(this.f=!1,this.h.setAttribute("aria-expanded","false"),d&&this.h.focus(),this.u.hideContextView())}ab(d,f){return d.appendChild(this.w),this.cb(f),{dispose:()=>{this.w.remove()}}}bb(){let d=0;return this.m.forEach((f,b)=>{this.jb(b),this.I.offsetHeight>d&&(d=this.I.offsetHeight)}),d}cb(d){if(this.J)return!1;if(this.z){this.w.classList.add("visible");const f=i.getWindow(this.h),b=i.$OS(this.h),S=i.getWindow(this.h).getComputedStyle(this.h),U=parseFloat(S.getPropertyValue("--dropdown-padding-top"))+parseFloat(S.getPropertyValue("--dropdown-padding-bottom")),_=f.innerHeight-b.top-b.height-(this.g.minBottomMargin||0),B=b.top-k.b,E=this.h.offsetWidth,I=this.db(this.D),z=Math.max(I,Math.round(E)).toString()+"px";this.w.style.width=z,this.z.getHTMLElement().style.height="",this.z.layout();let O=this.z.contentHeight;this.H&&this.L===void 0&&(this.L=this.bb());const C=this.H?this.L:0,x=O+U+C,Z=Math.floor((_-U-C)/this.getHeight()),Y=Math.floor((B-U-C)/this.getHeight());if(d)return b.top+b.height>f.innerHeight-22||b.top<k.b||Z<1&&Y<1?!1:(Z<k.c&&Y>Z&&this.m.length>Z?(this.G=N.AnchorPosition.ABOVE,this.C.remove(),this.I.remove(),this.w.appendChild(this.I),this.w.appendChild(this.C),this.I.classList.remove("border-top"),this.I.classList.add("border-bottom")):(this.G=N.AnchorPosition.BELOW,this.C.remove(),this.I.remove(),this.w.appendChild(this.C),this.w.appendChild(this.I),this.I.classList.remove("border-bottom"),this.I.classList.add("border-top")),!0);if(b.top+b.height>f.innerHeight-22||b.top<k.b||this.G===N.AnchorPosition.BELOW&&Z<1||this.G===N.AnchorPosition.ABOVE&&Y<1)return this.Z(!0),!1;if(this.G===N.AnchorPosition.BELOW){if(this.f&&Z+Y<1)return this.Z(!0),!1;x>_&&(O=Z*this.getHeight())}else x>B&&(O=Y*this.getHeight());return this.z.layout(O),this.z.domFocus(),this.z.length>0&&(this.z.setFocus([this.n||0]),this.z.reveal(this.z.getFocus()[0]||0)),this.H?(this.z.getHTMLElement().style.height=O+U+"px",this.w.style.height=""):this.w.style.height=O+U+"px",this.jb(this.n),this.w.style.width=z,this.C.setAttribute("tabindex","0"),this.h.classList.add("synthetic-focus"),this.w.classList.add("synthetic-focus"),!0}else return!1}db(d){let f=0;if(d){let b=0,S=0;this.m.forEach((U,_)=>{const B=U.detail?U.detail.length:0,E=U.decoratorRight?U.decoratorRight.length:0,I=U.text.length+B+E;I>S&&(b=_,S=I)}),d.textContent=this.m[b].text+(this.m[b].decoratorRight?this.m[b].decoratorRight+" ":""),f=i.$QS(d)}return f}eb(d){if(this.z)return;this.C=i.$AT(d,h(".select-box-dropdown-list-container")),this.t=new v,this.z=new c.$_U("SelectBoxCustom",this.C,this,[this.t],{useShadows:!1,verticalScrollMode:s.ScrollbarVisibility.Visible,keyboardSupport:!1,mouseSupport:!1,accessibilityProvider:{getAriaLabel:S=>{let U=S.text;return S.detail&&(U+=`. ${S.detail}`),S.decoratorRight&&(U+=`. ${S.decoratorRight}`),S.description&&(U+=`. ${S.description}`),U},getWidgetAriaLabel:()=>(0,r.localize)(10308,null),getRole:()=>e.$k?"":"option",getWidgetRole:()=>"listbox"}}),this.g.ariaLabel&&(this.z.ariaLabel=this.g.ariaLabel);const f=this.B(new n.$GU(this.C,"keydown")),b=y.Event.chain(f.event,S=>S.filter(()=>this.z.length>0).map(U=>new j.$oS(U)));this.B(y.Event.chain(b,S=>S.filter(U=>U.keyCode===$.KeyCode.Enter))(this.lb,this)),this.B(y.Event.chain(b,S=>S.filter(U=>U.keyCode===$.KeyCode.Tab))(this.lb,this)),this.B(y.Event.chain(b,S=>S.filter(U=>U.keyCode===$.KeyCode.Escape))(this.kb,this)),this.B(y.Event.chain(b,S=>S.filter(U=>U.keyCode===$.KeyCode.UpArrow))(this.nb,this)),this.B(y.Event.chain(b,S=>S.filter(U=>U.keyCode===$.KeyCode.DownArrow))(this.mb,this)),this.B(y.Event.chain(b,S=>S.filter(U=>U.keyCode===$.KeyCode.PageDown))(this.pb,this)),this.B(y.Event.chain(b,S=>S.filter(U=>U.keyCode===$.KeyCode.PageUp))(this.ob,this)),this.B(y.Event.chain(b,S=>S.filter(U=>U.keyCode===$.KeyCode.Home))(this.qb,this)),this.B(y.Event.chain(b,S=>S.filter(U=>U.keyCode===$.KeyCode.End))(this.rb,this)),this.B(y.Event.chain(b,S=>S.filter(U=>U.keyCode>=$.KeyCode.Digit0&&U.keyCode<=$.KeyCode.KeyZ||U.keyCode>=$.KeyCode.Semicolon&&U.keyCode<=$.KeyCode.NumpadDivide))(this.sb,this)),this.B(i.$sS(this.z.getHTMLElement(),i.$tT.POINTER_UP,S=>this.fb(S))),this.B(this.z.onMouseOver(S=>typeof S.index<"u"&&this.z.setFocus([S.index]))),this.B(this.z.onDidChangeFocus(S=>this.ib(S))),this.B(i.$sS(this.w,i.$tT.FOCUS_OUT,S=>{!this.f||i.$WS(S.relatedTarget,this.w)||this.gb()})),this.z.getHTMLElement().setAttribute("aria-label",this.g.ariaLabel||""),this.z.getHTMLElement().setAttribute("aria-expanded","true"),this.W()}fb(d){if(!this.z.length)return;i.$vT.stop(d);const f=d.target;if(!f||f.classList.contains("slider"))return;const b=f.closest(".monaco-list-row");if(!b)return;const S=Number(b.getAttribute("data-index")),U=b.classList.contains("option-disabled");S>=0&&S<this.m.length&&!U&&(this.n=S,this.select(this.n),this.z.setFocus([this.n]),this.z.reveal(this.z.getFocus()[0]),this.n!==this.F&&(this.F=this.n,this.r.fire({index:this.h.selectedIndex,selected:this.m[this.n].text}),this.m[this.n]&&this.m[this.n].text&&this.O(this.m[this.n].text)),this.Z(!0))}gb(){this.N||(this.n!==this.F&&this.select(this.F),this.Z(!1))}hb(d,f){const b=U=>{for(let _=0;_<U.childNodes.length;_++){const B=U.childNodes.item(_);(B.tagName&&B.tagName.toLowerCase())==="img"?B.remove():b(B)}},S=(0,F.$cV)({value:d,supportThemeIcons:!0},{actionHandler:f});return S.element.classList.add("select-box-description-markdown"),b(S.element),S.element}ib(d){!this.f||!this.H||this.jb(d.indexes[0])}jb(d){this.I.innerText="";const f=this.m[d],b=f?.description??"",S=f?.descriptionIsMarkdown??!1;if(b){if(S){const U=f.descriptionMarkdownActionHandler;this.I.appendChild(this.hb(b,U))}else this.I.innerText=b;this.I.style.display="block"}else this.I.style.display="none";this.J=!0,this.u.layout(),this.J=!1}kb(d){i.$vT.stop(d),this.select(this.F),this.Z(!0)}lb(d){i.$vT.stop(d),this.n!==this.F&&(this.F=this.n,this.r.fire({index:this.h.selectedIndex,selected:this.m[this.n].text}),this.m[this.n]&&this.m[this.n].text&&this.O(this.m[this.n].text)),this.Z(!0)}mb(d){if(this.n<this.m.length-1){i.$vT.stop(d,!0);const f=this.m[this.n+1].isDisabled;if(f&&this.m.length>this.n+2)this.n+=2;else{if(f)return;this.n++}this.select(this.n),this.z.setFocus([this.n]),this.z.reveal(this.z.getFocus()[0])}}nb(d){this.n>0&&(i.$vT.stop(d,!0),this.m[this.n-1].isDisabled&&this.n>1?this.n-=2:this.n--,this.select(this.n),this.z.setFocus([this.n]),this.z.reveal(this.z.getFocus()[0]))}ob(d){i.$vT.stop(d),this.z.focusPreviousPage(),setTimeout(()=>{this.n=this.z.getFocus()[0],this.m[this.n].isDisabled&&this.n<this.m.length-1&&(this.n++,this.z.setFocus([this.n])),this.z.reveal(this.n),this.select(this.n)},1)}pb(d){i.$vT.stop(d),this.z.focusNextPage(),setTimeout(()=>{this.n=this.z.getFocus()[0],this.m[this.n].isDisabled&&this.n>0&&(this.n--,this.z.setFocus([this.n])),this.z.reveal(this.n),this.select(this.n)},1)}qb(d){i.$vT.stop(d),!(this.m.length<2)&&(this.n=0,this.m[this.n].isDisabled&&this.n>1&&this.n++,this.z.setFocus([this.n]),this.z.reveal(this.n),this.select(this.n))}rb(d){i.$vT.stop(d),!(this.m.length<2)&&(this.n=this.m.length-1,this.m[this.n].isDisabled&&this.n>1&&this.n--,this.z.setFocus([this.n]),this.z.reveal(this.n),this.select(this.n))}sb(d){const f=$.KeyCodeUtils.toString(d.keyCode);let b=-1;for(let S=0;S<this.m.length-1;S++)if(b=(S+this.n+1)%this.m.length,this.m[b].text.charAt(0).toUpperCase()===f&&!this.m[b].isDisabled){this.select(b),this.z.setFocus([b]),this.z.reveal(this.z.getFocus()[0]),i.$vT.stop(d);break}}dispose(){this.Z(!1),super.dispose()}}t.$jV=k}),define(we[140],ve([1,0,52,139,115,23,5,134]),function(re,t,i,n,j,F,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$mV=t.$lV=void 0,t.$lV={...i.$$U,selectBackground:"#3C3C3C",selectForeground:"#F0F0F0",selectBorder:"#3C3C3C",decoratorRightForeground:void 0,selectListBackground:void 0,selectListBorder:void 0,focusBorder:void 0};class w extends F.$dU{constructor(c,p,y,$,g){super(),N.$k&&!g?.useCustomDrawn?this.a=new j.$kV(c,p,$,g):this.a=new n.$jV(c,p,y,$,g),this.B(this.a)}get onDidSelect(){return this.a.onDidSelect}setOptions(c,p){this.a.setOptions(c,p)}select(c){this.a.select(c)}setAriaLabel(c){this.a.setAriaLabel(c)}focus(){this.a.focus()}blur(){this.a.blur()}setFocusable(c){this.a.setFocusable(c)}setEnabled(c){this.a.setEnabled(c)}render(c){this.a.render(c)}}t.$mV=w}),define(we[53],ve([1,0,3,2,13]),function(re,t,i,n,j){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$lj=t.$kj=t.$jj=t.$ij=t.$hj=void 0,t.$mj=p,j=He(j);class F extends n.$Tc{constructor($,g="",e="",s=!0,r){super(),this.j=this.B(new i.$je),this.onDidChange=this.j.event,this.z=!0,this.m=$,this.n=g,this.w=e,this.z=s,this.D=r}get id(){return this.m}get label(){return this.n}set label($){this.F($)}F($){this.n!==$&&(this.n=$,this.j.fire({label:$}))}get tooltip(){return this.u||""}set tooltip($){this.G($)}G($){this.u!==$&&(this.u=$,this.j.fire({tooltip:$}))}get class(){return this.w}set class($){this.H($)}H($){this.w!==$&&(this.w=$,this.j.fire({class:$}))}get enabled(){return this.z}set enabled($){this.I($)}I($){this.z!==$&&(this.z=$,this.j.fire({enabled:$}))}get checked(){return this.C}set checked($){this.J($)}J($){this.C!==$&&(this.C=$,this.j.fire({checked:$}))}async run($,g){this.D&&await this.D($)}}t.$hj=F;class N extends n.$Tc{constructor(){super(...arguments),this.f=this.B(new i.$je),this.onWillRun=this.f.event,this.m=this.B(new i.$je),this.onDidRun=this.m.event}async run($,g){if(!$.enabled)return;this.f.fire({action:$});let e;try{await this.u($,g)}catch(s){e=s}this.m.fire({action:$,error:e})}async u($,g){await $.run(g)}}t.$ij=N;class w{constructor(){this.id=w.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...$){let g=[];for(const e of $)e.length&&(g.length?g=[...g,new w,...e]:g=e);return g}static{this.ID="vs.actions.separator"}async run(){}}t.$jj=w;class D{get actions(){return this.a}constructor($,g,e,s){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=$,this.label=g,this.class=s,this.a=e}async run(){}}t.$kj=D;class c extends F{static{this.ID="vs.actions.empty"}constructor(){super(c.ID,j.localize(12894,null),void 0,!1)}}t.$lj=c;function p(y){return{id:y.id,label:y.label,tooltip:y.tooltip??y.label,class:y.class,enabled:y.enabled??!0,checked:y.checked,run:async(...$)=>y.run(...$)}}}),define(we[80],ve([1,0,18,69,4,32,14,140,53,2,5,10,13,33,75]),function(re,t,i,n,j,F,N,w,D,c,p,y,$,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$uV=t.$tV=t.$sV=void 0,p=He(p),y=He(y),$=He($);class e extends c.$Tc{get action(){return this._action}constructor(l,v,k={}){super(),this.m=k,this._context=l||this,this._action=v,v instanceof D.$hj&&this.B(v.onDidChange(A=>{this.element&&this.t(A)}))}t(l){l.enabled!==void 0&&this.u(),l.checked!==void 0&&this.H(),l.class!==void 0&&this.G(),l.label!==void 0&&(this.w(),this.D()),l.tooltip!==void 0&&this.D()}get actionRunner(){return this.j||(this.j=this.B(new D.$ij)),this.j}set actionRunner(l){this.j=l}isEnabled(){return this._action.enabled}setActionContext(l){this._context=l}render(l){const v=this.element=l;this.B(F.$_T.addTarget(l));const k=this.m&&this.m.draggable;k&&(l.draggable=!0,i.$9R&&this.B((0,j.$sS)(l,j.$tT.DRAG_START,A=>A.dataTransfer?.setData(n.$0T.TEXT,this._action.label)))),this.B((0,j.$sS)(v,F.EventType.Tap,A=>this.onClick(A,!0))),this.B((0,j.$sS)(v,j.$tT.MOUSE_DOWN,A=>{k||j.$vT.stop(A,!0),this._action.enabled&&A.button===0&&v.classList.add("active")})),p.$k&&this.B((0,j.$sS)(v,j.$tT.CONTEXT_MENU,A=>{A.button===0&&A.ctrlKey===!0&&this.onClick(A)})),this.B((0,j.$sS)(v,j.$tT.CLICK,A=>{j.$vT.stop(A,!0),this.m&&this.m.isMenu||this.onClick(A)})),this.B((0,j.$sS)(v,j.$tT.DBLCLICK,A=>{j.$vT.stop(A,!0)})),[j.$tT.MOUSE_UP,j.$tT.MOUSE_OUT].forEach(A=>{this.B((0,j.$sS)(v,A,d=>{j.$vT.stop(d),v.classList.remove("active")}))})}onClick(l,v=!1){j.$vT.stop(l,!0);const k=y.$lg(this._context)?this.m?.useEventAsContext?l:{preserveFocus:v}:this._context;this.actionRunner.run(this._action,k)}focus(){this.element&&(this.element.tabIndex=0,this.element.focus(),this.element.classList.add("focused"))}isFocused(){return!!this.element?.classList.contains("focused")}blur(){this.element&&(this.element.blur(),this.element.tabIndex=-1,this.element.classList.remove("focused"))}setFocusable(l){this.element&&(this.element.tabIndex=l?0:-1)}get trapsArrowNavigation(){return!1}u(){}w(){}z(){return this.action.class}C(){return this.action.tooltip}D(){if(!this.element)return;const l=this.C()??"";if(this.F(),this.m.hoverDelegate?.showNativeHover)this.element.title=l;else if(!this.f&&l!==""){const v=this.m.hoverDelegate??(0,N.$wU)("element");this.f=this.q.add((0,g.$iV)().setupManagedHover(v,this.element,l))}else this.f&&this.f.update(l)}F(){if(this.element){const l=this.C()??"";this.element.setAttribute("aria-label",l)}}G(){}H(){}dispose(){this.element&&(this.element.remove(),this.element=void 0),this._context=void 0,super.dispose()}}t.$sV=e;class s extends e{constructor(l,v,k){super(l,v,k),this.m=k,this.m.icon=k.icon!==void 0?k.icon:!1,this.m.label=k.label!==void 0?k.label:!0,this.L=""}render(l){super.render(l),y.$mg(this.element);const v=document.createElement("a");if(v.classList.add("action-label"),v.setAttribute("role",this.M()),this.I=v,this.element.appendChild(v),this.m.label&&this.m.keybinding){const k=document.createElement("span");k.classList.add("keybinding"),k.textContent=this.m.keybinding,this.element.appendChild(k)}this.G(),this.w(),this.D(),this.u(),this.H()}M(){return this._action.id===D.$jj.ID?"presentation":this.m.isMenu?"menuitem":"button"}focus(){this.I&&(this.I.tabIndex=0,this.I.focus())}isFocused(){return!!this.I&&this.I?.tabIndex===0}blur(){this.I&&(this.I.tabIndex=-1)}setFocusable(l){this.I&&(this.I.tabIndex=l?0:-1)}w(){this.m.label&&this.I&&(this.I.textContent=this.action.label)}C(){let l=null;return this.action.tooltip?l=this.action.tooltip:!this.m.label&&this.action.label&&this.m.icon&&(l=this.action.label,this.m.keybinding&&(l=$.localize(10336,null,l,this.m.keybinding))),l??void 0}G(){this.L&&this.I&&this.I.classList.remove(...this.L.split(" ")),this.m.icon?(this.L=this.z(),this.I&&(this.I.classList.add("codicon"),this.L&&this.I.classList.add(...this.L.split(" "))),this.u()):this.I?.classList.remove("codicon")}u(){this.action.enabled?(this.I&&(this.I.removeAttribute("aria-disabled"),this.I.classList.remove("disabled")),this.element?.classList.remove("disabled")):(this.I&&(this.I.setAttribute("aria-disabled","true"),this.I.classList.add("disabled")),this.element?.classList.add("disabled"))}F(){if(this.I){const l=this.C()??"";this.I.setAttribute("aria-label",l)}}H(){this.I&&(this.action.checked!==void 0?(this.I.classList.toggle("checked",this.action.checked),this.I.setAttribute("aria-checked",this.action.checked?"true":"false"),this.I.setAttribute("role","checkbox")):(this.I.classList.remove("checked"),this.I.removeAttribute("aria-checked"),this.I.setAttribute("role",this.M())))}}t.$tV=s;class r extends e{constructor(l,v,k,A,d,f,b){super(l,v),this.b=new w.$mV(k,A,d,f,b),this.b.setFocusable(!1),this.B(this.b),this.g()}setOptions(l,v){this.b.setOptions(l,v)}select(l){this.b.select(l)}g(){this.B(this.b.onDidSelect(l=>this.n(l.selected,l.index)))}n(l,v){this.actionRunner.run(this._action,this.r(l,v))}r(l,v){return l}setFocusable(l){this.b.setFocusable(l)}focus(){this.b?.focus()}blur(){this.b?.blur()}render(l){this.b.render(l)}}t.$uV=r}),define(we[81],ve([1,0,4,15,80,14,53,3,8,2,10,75]),function(re,t,i,n,j,F,N,w,D,c,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$yU=t.ActionsOrientation=void 0,t.$zU=g,i=He(i),p=He(p);var y;(function(e){e[e.HORIZONTAL=0]="HORIZONTAL",e[e.VERTICAL=1]="VERTICAL"})(y||(t.ActionsOrientation=y={}));class $ extends c.$Tc{constructor(s,r={}){super(),this.j=this.B(new c.$Sc),this.s=this.B(new c.$3c),this.y=!1,this.z=!0,this.D=this.B(new w.$je),this.onDidBlur=this.D.event,this.F=this.B(new w.$je({onWillAddFirstListener:()=>this.G=!0})),this.onDidCancel=this.F.event,this.G=!1,this.H=this.B(new w.$je),this.onDidRun=this.H.event,this.I=this.B(new w.$je),this.onWillRun=this.I.event,this.b=r,this.m=r.context??null,this.n=this.b.orientation??y.HORIZONTAL,this.r={keyDown:this.b.triggerKeys?.keyDown??!1,keys:this.b.triggerKeys?.keys??[D.KeyCode.Enter,D.KeyCode.Space]},this.f=r.hoverDelegate??this.B((0,F.$xU)()),this.b.actionRunner?this.g=this.b.actionRunner:(this.g=new N.$ij,this.j.add(this.g)),this.j.add(this.g.onDidRun(v=>this.H.fire(v))),this.j.add(this.g.onWillRun(v=>this.I.fire(v))),this.viewItems=[],this.u=void 0,this.domNode=document.createElement("div"),this.domNode.className="monaco-action-bar";let h,l;switch(this.n){case y.HORIZONTAL:h=[D.KeyCode.LeftArrow],l=[D.KeyCode.RightArrow];break;case y.VERTICAL:h=[D.KeyCode.UpArrow],l=[D.KeyCode.DownArrow],this.domNode.className+=" vertical";break}this.B(i.$sS(this.domNode,i.$tT.KEY_DOWN,v=>{const k=new n.$oS(v);let A=!0;const d=typeof this.u=="number"?this.viewItems[this.u]:void 0;h&&(k.equals(h[0])||k.equals(h[1]))?A=this.Q():l&&(k.equals(l[0])||k.equals(l[1]))?A=this.P():k.equals(D.KeyCode.Escape)&&this.G?this.F.fire():k.equals(D.KeyCode.Home)?A=this.N():k.equals(D.KeyCode.End)?A=this.O():k.equals(D.KeyCode.Tab)&&d instanceof j.$sV&&d.trapsArrowNavigation?A=this.P():this.L(k)?this.r.keyDown?this.S(k):this.y=!0:A=!1,A&&(k.preventDefault(),k.stopPropagation())})),this.B(i.$sS(this.domNode,i.$tT.KEY_UP,v=>{const k=new n.$oS(v);this.L(k)?(!this.r.keyDown&&this.y&&(this.y=!1,this.S(k)),k.preventDefault(),k.stopPropagation()):(k.equals(D.KeyCode.Tab)||k.equals(D.KeyMod.Shift|D.KeyCode.Tab)||k.equals(D.KeyCode.UpArrow)||k.equals(D.KeyCode.DownArrow)||k.equals(D.KeyCode.LeftArrow)||k.equals(D.KeyCode.RightArrow))&&this.M()})),this.w=this.B(i.$yT(this.domNode)),this.B(this.w.onDidBlur(()=>{(i.$5S()===this.domNode||!i.$WS(i.$5S(),this.domNode))&&(this.D.fire(),this.t=this.u,this.u=void 0,this.y=!1)})),this.B(this.w.onDidFocus(()=>this.M())),this.C=document.createElement("ul"),this.C.className="actions-container",this.b.highlightToggledItems&&this.C.classList.add("highlight-toggled"),this.C.setAttribute("role",this.b.ariaRole||"toolbar"),this.b.ariaLabel&&this.C.setAttribute("aria-label",this.b.ariaLabel),this.domNode.appendChild(this.C),s.appendChild(this.domNode)}J(){this.length()>=1?this.C.setAttribute("role",this.b.ariaRole||"toolbar"):this.C.setAttribute("role","presentation")}setAriaLabel(s){s?this.C.setAttribute("aria-label",s):this.C.removeAttribute("aria-label")}setFocusable(s){if(this.z=s,this.z){const r=this.viewItems.find(h=>h instanceof j.$sV&&h.isEnabled());r instanceof j.$sV&&r.setFocusable(!0)}else this.viewItems.forEach(r=>{r instanceof j.$sV&&r.setFocusable(!1)})}L(s){let r=!1;return this.r.keys.forEach(h=>{r=r||s.equals(h)}),r}M(){for(let s=0;s<this.C.children.length;s++){const r=this.C.children[s];if(i.$WS(i.$5S(),r)){this.u=s,this.viewItems[this.u]?.showHover?.();break}}}get context(){return this.m}set context(s){this.m=s,this.viewItems.forEach(r=>r.setActionContext(s))}get actionRunner(){return this.g}set actionRunner(s){this.g=s,this.j.clear(),this.j.add(this.g.onDidRun(r=>this.H.fire(r))),this.j.add(this.g.onWillRun(r=>this.I.fire(r))),this.viewItems.forEach(r=>r.actionRunner=s)}getContainer(){return this.domNode}hasAction(s){return this.viewItems.findIndex(r=>r.action.id===s.id)!==-1}getAction(s){if(typeof s=="number")return this.viewItems[s]?.action;if(i.$hT(s)){for(;s.parentElement!==this.C;){if(!s.parentElement)return;s=s.parentElement}for(let r=0;r<this.C.childNodes.length;r++)if(this.C.childNodes[r]===s)return this.viewItems[r].action}}push(s,r={}){const h=Array.isArray(s)?s:[s];let l=p.$gg(r.index)?r.index:null;h.forEach(v=>{const k=document.createElement("li");k.className="action-item",k.setAttribute("role","presentation");let A;const d={hoverDelegate:this.f,...r};this.b.actionViewItemProvider&&(A=this.b.actionViewItemProvider(v,d)),A||(A=new j.$tV(this.context,v,d)),this.b.allowContextMenu||this.s.set(A,i.$sS(k,i.$tT.CONTEXT_MENU,f=>{i.$vT.stop(f,!0)})),A.actionRunner=this.g,A.setActionContext(this.context),A.render(k),this.z&&A instanceof j.$sV&&this.viewItems.length===0&&A.setFocusable(!0),l===null||l<0||l>=this.C.children.length?(this.C.appendChild(k),this.viewItems.push(A)):(this.C.insertBefore(k,this.C.children[l]),this.viewItems.splice(l,0,A),l++)}),typeof this.u=="number"&&this.focus(this.u),this.J()}getWidth(s){if(s>=0&&s<this.C.children.length){const r=this.C.children.item(s);if(r)return r.clientWidth}return 0}getHeight(s){if(s>=0&&s<this.C.children.length){const r=this.C.children.item(s);if(r)return r.clientHeight}return 0}pull(s){s>=0&&s<this.viewItems.length&&(this.C.childNodes[s].remove(),this.s.deleteAndDispose(this.viewItems[s]),(0,c.$Oc)(this.viewItems.splice(s,1)),this.J())}clear(){this.isEmpty()||(this.viewItems=(0,c.$Oc)(this.viewItems),this.s.clearAndDisposeAll(),i.$qS(this.C),this.J())}length(){return this.viewItems.length}isEmpty(){return this.viewItems.length===0}focus(s){let r=!1,h;if(s===void 0?r=!0:typeof s=="number"?h=s:typeof s=="boolean"&&(r=s),r&&typeof this.u>"u"){const l=this.viewItems.findIndex(v=>v.isEnabled());this.u=l===-1?void 0:l,this.R(void 0,void 0,!0)}else h!==void 0&&(this.u=h),this.R(void 0,void 0,!0)}N(){return this.u=this.length()-1,this.P(!0)}O(){return this.u=0,this.Q(!0)}P(s){if(typeof this.u>"u")this.u=this.viewItems.length-1;else if(this.viewItems.length<=1)return!1;const r=this.u;let h;do{if(!s&&this.b.preventLoopNavigation&&this.u+1>=this.viewItems.length)return this.u=r,!1;this.u=(this.u+1)%this.viewItems.length,h=this.viewItems[this.u]}while(this.u!==r&&(this.b.focusOnlyEnabledItems&&!h.isEnabled()||h.action.id===N.$jj.ID));return this.R(),!0}Q(s){if(typeof this.u>"u")this.u=0;else if(this.viewItems.length<=1)return!1;const r=this.u;let h;do{if(this.u=this.u-1,this.u<0){if(!s&&this.b.preventLoopNavigation)return this.u=r,!1;this.u=this.viewItems.length-1}h=this.viewItems[this.u]}while(this.u!==r&&(this.b.focusOnlyEnabledItems&&!h.isEnabled()||h.action.id===N.$jj.ID));return this.R(!0),!0}R(s,r,h=!1){typeof this.u>"u"&&this.C.focus({preventScroll:r}),this.t!==void 0&&this.t!==this.u&&this.viewItems[this.t]?.blur();const l=this.u!==void 0?this.viewItems[this.u]:void 0;if(l){let v=!0;p.$qg(l.focus)||(v=!1),this.b.focusOnlyEnabledItems&&p.$qg(l.isEnabled)&&!l.isEnabled()&&(v=!1),l.action.id===N.$jj.ID&&(v=!1),v?(h||this.t!==this.u)&&(l.focus(s),this.t=this.u):(this.C.focus({preventScroll:r}),this.t=void 0),v&&l.showHover?.()}}S(s){if(typeof this.u>"u")return;const r=this.viewItems[this.u];if(r instanceof j.$sV){const h=r._context===null||r._context===void 0?s:r._context;this.run(r._action,h)}}async run(s,r){await this.g.run(s,r)}dispose(){this.m=void 0,this.viewItems=(0,c.$Oc)(this.viewItems),this.getContainer().remove(),super.dispose()}}t.$yU=$;function g(e){if(!e.length)return e;let s=-1;for(let h=0;h<e.length;h++)if(e[h].id!==N.$jj.ID){s=h;break}if(s===-1)return[];e=e.slice(s);for(let h=e.length-1;h>=0&&e[h].id===N.$jj.ID;h--)e.splice(h,1);let r=!1;for(let h=e.length-1;h>=0;h--){const l=e[h].id===N.$jj.ID;l&&!r?e.splice(h,1):l?l&&(r=!1):r=!0}return e}}),define(we[82],ve([1,0,4,29,70,81,76,77,33,14,78,23,3,95,64,20,13,131]),function(re,t,i,n,j,F,N,w,D,c,p,y,$,g,e,s,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$jW=t.$iW=t.$hW=t.MessageType=void 0,i=He(i),N=He(N),r=He(r);const h=i.$;var l;(function(A){A[A.INFO=1]="INFO",A[A.WARNING=2]="WARNING",A[A.ERROR=3]="ERROR"})(l||(t.MessageType=l={})),t.$hW={inputBackground:"#3C3C3C",inputForeground:"#CCCCCC",inputValidationInfoBorder:"#55AAFF",inputValidationInfoBackground:"#063B49",inputValidationWarningBorder:"#B89500",inputValidationWarningBackground:"#352A05",inputValidationErrorBorder:"#BE1100",inputValidationErrorBackground:"#5A1D1D",inputBorder:void 0,inputValidationErrorForeground:void 0,inputValidationInfoForeground:void 0,inputValidationWarningForeground:void 0};class v extends y.$dU{constructor(d,f,b){super(),this.w="idle",this.M=Number.POSITIVE_INFINITY,this.P=this.B(new $.$je),this.onDidChange=this.P.event,this.Q=this.B(new $.$je),this.onDidHeightChange=this.Q.event,this.a=f,this.g=b,this.h=null,this.n=this.g.placeholder||"",this.r=this.g.tooltip??(this.n||""),this.s=this.g.ariaLabel||"",this.g.validationOptions&&(this.t=this.g.validationOptions.validation),this.element=i.$AT(d,h(".monaco-inputbox.idle"));const S=this.g.flexibleHeight?"textarea":"input",U=i.$AT(this.element,h(".ibwrapper"));if(this.b=i.$AT(U,h(S+".input.empty")),this.b.setAttribute("autocorrect","off"),this.b.setAttribute("autocapitalize","off"),this.b.setAttribute("spellcheck","false"),this.G(this.b,()=>this.element.classList.add("synthetic-focus")),this.F(this.b,()=>this.element.classList.remove("synthetic-focus")),this.g.flexibleHeight){this.M=typeof this.g.flexibleMaxHeight=="number"?this.g.flexibleMaxHeight:Number.POSITIVE_INFINITY,this.y=i.$AT(U,h("div.mirror")),this.y.innerText="\xA0",this.N=new p.$nU(this.element,{vertical:s.ScrollbarVisibility.Auto}),this.g.flexibleWidth&&(this.b.setAttribute("wrap","off"),this.y.style.whiteSpace="pre",this.y.style.wordWrap="initial"),i.$AT(d,this.N.getDomNode()),this.B(this.N),this.B(this.N.onScroll(E=>this.b.scrollTop=E.scrollTop));const _=this.B(new n.$GU(d.ownerDocument,"selectionchange")),B=$.Event.filter(_.event,()=>d.ownerDocument.getSelection()?.anchorNode===U);this.B(B(this.U,this)),this.B(this.onDidHeightChange(this.U,this))}else this.b.type=this.g.type||"text",this.b.setAttribute("wrap","off");this.s&&this.b.setAttribute("aria-label",this.s),this.n&&!this.g.showPlaceholderOnFocus&&this.setPlaceHolder(this.n),this.r&&this.setTooltip(this.r),this.D(this.b,()=>this.Z()),this.F(this.b,()=>this.R()),this.G(this.b,()=>this.S()),this.B(this.I(this.b)),setTimeout(()=>this.ab(),0),this.g.actions&&(this.c=this.B(new F.$yU(this.element)),this.c.push(this.g.actions,{icon:!0,label:!1})),this.bb()}R(){this.Y(),this.g.showPlaceholderOnFocus&&this.b.setAttribute("placeholder","")}S(){this.X(),this.g.showPlaceholderOnFocus&&this.b.setAttribute("placeholder",this.n||"")}setPlaceHolder(d){this.n=d,this.b.setAttribute("placeholder",d)}setTooltip(d){this.r=d,this.O?this.O.update(d):this.O=this.B((0,D.$iV)().setupManagedHover((0,c.$wU)("mouse"),this.b,d))}setAriaLabel(d){this.s=d,d?this.b.setAttribute("aria-label",this.s):this.b.removeAttribute("aria-label")}getAriaLabel(){return this.s}get mirrorElement(){return this.y}get inputElement(){return this.b}get value(){return this.b.value}set value(d){this.b.value!==d&&(this.b.value=d,this.Z())}get step(){return this.b.step}set step(d){this.b.step=d}get height(){return typeof this.J=="number"?this.J:i.$US(this.element)}focus(){this.b.focus()}blur(){this.b.blur()}hasFocus(){return i.$6S(this.b)}select(d=null){this.b.select(),d&&(this.b.setSelectionRange(d.start,d.end),d.end===this.b.value.length&&(this.b.scrollLeft=this.b.scrollWidth))}isSelectionAtEnd(){return this.b.selectionEnd===this.b.value.length&&this.b.selectionStart===this.b.selectionEnd}getSelection(){const d=this.b.selectionStart;if(d===null)return null;const f=this.b.selectionEnd??d;return{start:d,end:f}}enable(){this.b.removeAttribute("disabled")}disable(){this.blur(),this.b.disabled=!0,this.Y()}setEnabled(d){d?this.enable():this.disable()}get width(){return i.$QS(this.b)}set width(d){if(this.g.flexibleHeight&&this.g.flexibleWidth){let f=0;if(this.y){const b=parseFloat(this.y.style.paddingLeft||"")||0,S=parseFloat(this.y.style.paddingRight||"")||0;f=b+S}this.b.style.width=d-f+"px"}else this.b.style.width=d+"px";this.y&&(this.y.style.width=d+"px")}set paddingRight(d){this.b.style.width=`calc(100% - ${d}px)`,this.y&&(this.y.style.paddingRight=d+"px")}U(){if(typeof this.L!="number"||typeof this.J!="number"||!this.N)return;const d=this.L,f=this.J,b=this.b.scrollTop;this.N.setScrollDimensions({scrollHeight:d,height:f}),this.N.setScrollPosition({scrollTop:b})}showMessage(d,f){if(this.w==="open"&&(0,e.$fo)(this.h,d))return;this.h=d,this.element.classList.remove("idle"),this.element.classList.remove("info"),this.element.classList.remove("warning"),this.element.classList.remove("error"),this.element.classList.add(this.W(d.type));const b=this.stylesForType(this.h.type);this.element.style.border=`1px solid ${i.$ST(b.border,"transparent")}`,this.h.content&&(this.hasFocus()||f)&&this.X()}hideMessage(){this.h=null,this.element.classList.remove("info"),this.element.classList.remove("warning"),this.element.classList.remove("error"),this.element.classList.add("idle"),this.Y(),this.bb()}isInputValid(){return!!this.t&&!this.t(this.value)}validate(){let d=null;return this.t&&(d=this.t(this.value),d?(this.inputElement.setAttribute("aria-invalid","true"),this.showMessage(d)):this.inputElement.hasAttribute("aria-invalid")&&(this.inputElement.removeAttribute("aria-invalid"),this.hideMessage())),d?.type}stylesForType(d){const f=this.g.inputBoxStyles;switch(d){case l.INFO:return{border:f.inputValidationInfoBorder,background:f.inputValidationInfoBackground,foreground:f.inputValidationInfoForeground};case l.WARNING:return{border:f.inputValidationWarningBorder,background:f.inputValidationWarningBackground,foreground:f.inputValidationWarningForeground};default:return{border:f.inputValidationErrorBorder,background:f.inputValidationErrorBackground,foreground:f.inputValidationErrorForeground}}}W(d){switch(d){case l.INFO:return"info";case l.WARNING:return"warning";default:return"error"}}X(){if(!this.a||!this.h)return;let d;const f=()=>d.style.width=i.$QS(this.element)+"px";this.a.showContextView({getAnchor:()=>this.element,anchorAlignment:w.AnchorAlignment.RIGHT,render:S=>{if(!this.h)return null;d=i.$AT(S,h(".monaco-inputbox-container")),f();const U={inline:!0,className:"monaco-inputbox-message"},_=this.h.formatContent?(0,j.$EU)(this.h.content,U):(0,j.$DU)(this.h.content,U);_.classList.add(this.W(this.h.type));const B=this.stylesForType(this.h.type);return _.style.backgroundColor=B.background??"",_.style.color=B.foreground??"",_.style.border=B.border?`1px solid ${B.border}`:"",i.$AT(d,_),null},onHide:()=>{this.w="closed"},layout:f});let b;this.h.type===l.ERROR?b=r.localize(10312,null,this.h.content):this.h.type===l.WARNING?b=r.localize(10313,null,this.h.content):b=r.localize(10314,null,this.h.content),N.$IU(b),this.w="open"}Y(){this.a&&(this.w==="open"&&this.a.hideContextView(),this.w="idle")}Z(){this.P.fire(this.value),this.validate(),this.ab(),this.b.classList.toggle("empty",!this.value),this.w==="open"&&this.a&&this.a.layout()}ab(){if(!this.y)return;const d=this.value,b=d.charCodeAt(d.length-1)===10?" ":"";(d+b).replace(/\u000c/g,"")?this.y.textContent=d+b:this.y.innerText="\xA0",this.layout()}bb(){const d=this.g.inputBoxStyles,f=d.inputBackground??"",b=d.inputForeground??"",S=d.inputBorder??"";this.element.style.backgroundColor=f,this.element.style.color=b,this.b.style.backgroundColor="inherit",this.b.style.color=b,this.element.style.border=`1px solid ${i.$ST(S,"transparent")}`}layout(){if(!this.y)return;const d=this.L;this.L=i.$US(this.y),d!==this.L&&(this.J=Math.min(this.L,this.M),this.b.style.height=this.J+"px",this.Q.fire(this.L))}insertAtCursor(d){const f=this.inputElement,b=f.selectionStart,S=f.selectionEnd,U=f.value;b!==null&&S!==null&&(this.value=U.substr(0,b)+d+U.substr(S),f.setSelectionRange(b+1,b+1),this.layout())}dispose(){this.Y(),this.h=null,this.c?.dispose(),super.dispose()}}t.$iW=v;class k extends v{constructor(d,f,b){const S=r.localize(10315,null,"\u21C5"),U=r.localize(10316,null,"\u21C5");super(d,f,b),this.eb=this.B(new $.$je),this.onDidFocus=this.eb.event,this.fb=this.B(new $.$je),this.onDidBlur=this.fb.event,this.cb=new g.$fW(b.history,100);const _=()=>{if(b.showHistoryHint&&b.showHistoryHint()&&!this.n.endsWith(S)&&!this.n.endsWith(U)&&this.cb.getHistory().length){const B=this.n.endsWith(")")?S:U,E=this.n+B;b.showPlaceholderOnFocus&&!i.$6S(this.b)?this.n=E:this.setPlaceHolder(E)}};this.db=new MutationObserver((B,E)=>{B.forEach(I=>{I.target.textContent||_()})}),this.db.observe(this.b,{attributeFilter:["class"]}),this.G(this.b,()=>_()),this.F(this.b,()=>{const B=E=>{if(this.n.endsWith(E)){const I=this.n.slice(0,this.n.length-E.length);return b.showPlaceholderOnFocus?this.n=I:this.setPlaceHolder(I),!0}else return!1};B(U)||B(S)})}dispose(){super.dispose(),this.db&&(this.db.disconnect(),this.db=void 0)}addToHistory(d){this.value&&(d||this.value!==this.ib())&&this.cb.add(this.value)}prependHistory(d){const f=this.getHistory();this.clearHistory(),d.forEach(b=>{this.cb.add(b)}),f.forEach(b=>{this.cb.add(b)})}getHistory(){return this.cb.getHistory()}isAtFirstInHistory(){return this.cb.isFirst()}isAtLastInHistory(){return this.cb.isLast()}isNowhereInHistory(){return this.cb.isNowhere()}showNextValue(){this.cb.has(this.value)||this.addToHistory();let d=this.kb();d&&(d=d===this.value?this.kb():d),this.value=d??"",N.$JU(this.value?this.value:r.localize(10317,null))}showPreviousValue(){this.cb.has(this.value)||this.addToHistory();let d=this.jb();d&&(d=d===this.value?this.jb():d),d&&(this.value=d,N.$JU(this.value))}clearHistory(){this.cb.clear()}setPlaceHolder(d){super.setPlaceHolder(d),this.setTooltip(d)}R(){super.R(),this.fb.fire()}S(){super.S(),this.eb.fire()}ib(){let d=this.cb.current();return d||(d=this.cb.last(),this.cb.next()),d}jb(){return this.cb.previous()||this.cb.first()}kb(){return this.cb.next()}}t.$jW=k}),define(we[83],ve([1,0,80,23,21,22,3,8,4,14,33,136]),function(re,t,i,n,j,F,N,w,D,c,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$rV=t.$qV=t.$pV=t.$oV=t.$nV=void 0,t.$nV={inputActiveOptionBorder:"#007ACC00",inputActiveOptionForeground:"#FFFFFF",inputActiveOptionBackground:"#0E639C50"};class y extends i.$sV{constructor(r,h,l){super(r,h,l),this.a=this.B(new $({actionClassName:this._action.class,isChecked:!!this._action.checked,title:this.m.keybinding?`${this._action.label} (${this.m.keybinding})`:this._action.label,notFocusable:!0,inputActiveOptionBackground:l.toggleStyles?.inputActiveOptionBackground,inputActiveOptionBorder:l.toggleStyles?.inputActiveOptionBorder,inputActiveOptionForeground:l.toggleStyles?.inputActiveOptionForeground,hoverDelegate:l.hoverDelegate})),this.B(this.a.onChange(()=>this._action.checked=!!this.a&&this.a.checked))}render(r){this.element=r,this.element.appendChild(this.a.domNode)}u(){this.a&&(this.isEnabled()?this.a.enable():this.a.disable())}H(){this.a.checked=!!this._action.checked}focus(){this.a.domNode.tabIndex=0,this.a.focus()}blur(){this.a.domNode.tabIndex=-1,this.a.domNode.blur()}setFocusable(r){this.a.domNode.tabIndex=r?0:-1}}t.$oV=y;class $ extends n.$dU{constructor(r){super(),this.a=this.B(new N.$je),this.onChange=this.a.event,this.b=this.B(new N.$je),this.onKeyDown=this.b.event,this.c=r,this.s=this.c.isChecked;const h=["monaco-custom-toggle"];this.c.icon&&(this.g=this.c.icon,h.push(...F.ThemeIcon.asClassNameArray(this.g))),this.c.actionClassName&&h.push(...this.c.actionClassName.split(" ")),this.s&&h.push("checked"),this.domNode=document.createElement("div"),this.t=this.B((0,p.$iV)().setupManagedHover(r.hoverDelegate??(0,c.$wU)("mouse"),this.domNode,this.c.title)),this.domNode.classList.add(...h),this.c.notFocusable||(this.domNode.tabIndex=0),this.domNode.setAttribute("role","checkbox"),this.domNode.setAttribute("aria-checked",String(this.s)),this.domNode.setAttribute("aria-label",this.c.title),this.w(),this.f(this.domNode,l=>{this.enabled&&(this.checked=!this.s,this.a.fire(!1),l.preventDefault())}),this.B(this.I(this.domNode)),this.z(this.domNode,l=>{if(l.keyCode===w.KeyCode.Space||l.keyCode===w.KeyCode.Enter){this.checked=!this.s,this.a.fire(!0),l.preventDefault(),l.stopPropagation();return}this.b.fire(l)})}get enabled(){return this.domNode.getAttribute("aria-disabled")!=="true"}focus(){this.domNode.focus()}get checked(){return this.s}set checked(r){this.s=r,this.domNode.setAttribute("aria-checked",String(this.s)),this.domNode.classList.toggle("checked",this.s),this.w()}setIcon(r){this.g&&this.domNode.classList.remove(...F.ThemeIcon.asClassNameArray(this.g)),this.g=r,this.g&&this.domNode.classList.add(...F.ThemeIcon.asClassNameArray(this.g))}width(){return 22}w(){this.domNode&&(this.domNode.style.borderColor=this.s&&this.c.inputActiveOptionBorder||"",this.domNode.style.color=this.s&&this.c.inputActiveOptionForeground||"inherit",this.domNode.style.backgroundColor=this.s&&this.c.inputActiveOptionBackground||"")}enable(){this.domNode.setAttribute("aria-disabled",String(!1))}disable(){this.domNode.setAttribute("aria-disabled",String(!0))}setTitle(r){this.t.update(r),this.domNode.setAttribute("aria-label",r)}set visible(r){this.domNode.style.display=r?"":"none"}get visible(){return this.domNode.style.display!=="none"}}t.$pV=$;class g extends n.$dU{static{this.CLASS_NAME="monaco-checkbox"}constructor(r,h,l){super(),this.g=r,this.h=h,this.a=this.B(new N.$je),this.onChange=this.a.event,this.b=this.B(new $({title:this.g,isChecked:this.h,icon:j.$2j.check,actionClassName:g.CLASS_NAME,...t.$nV})),this.domNode=this.b.domNode,this.c=l,this.n(),this.B(this.b.onChange(v=>{this.n(),this.a.fire(v)}))}get checked(){return this.b.checked}set checked(r){this.b.checked=r,this.n()}focus(){this.domNode.focus()}hasFocus(){return(0,D.$6S)(this.domNode)}enable(){this.b.enable()}disable(){this.b.disable()}n(){this.domNode.style.color=this.c.checkboxForeground||"",this.domNode.style.backgroundColor=this.c.checkboxBackground||"",this.domNode.style.borderColor=this.c.checkboxBorder||""}}t.$qV=g;class e extends i.$sV{constructor(r,h,l){super(r,h,l),this.a=this.B(new g(this._action.label,!!this._action.checked,l.checkboxStyles)),this.B(this.a.onChange(()=>this.c()))}render(r){if(this.element=r,this.element.classList.add("checkbox-action-item"),this.element.appendChild(this.a.domNode),this.m.label&&this._action.label){const h=this.element.appendChild((0,D.$)("span.checkbox-label",void 0,this._action.label));this.B((0,D.$sS)(h,D.$tT.CLICK,l=>{this.a.checked=!this.a.checked,l.stopPropagation(),l.preventDefault(),this.c()}))}this.u(),this.G(),this.H()}c(){this._action.checked=!!this.a&&this.a.checked,this.actionRunner.run(this._action,this._context)}u(){this.isEnabled()?this.a.enable():this.a.disable(),this.action.enabled?this.element?.classList.remove("disabled"):this.element?.classList.add("disabled")}H(){this.a.checked=!!this._action.checked}G(){this.b&&this.a.domNode.classList.remove(...this.b.split(" ")),this.b=this.z(),this.b&&this.a.domNode.classList.add(...this.b.split(" "))}focus(){this.a.domNode.tabIndex=0,this.a.focus()}blur(){this.a.domNode.tabIndex=-1,this.a.domNode.blur()}setFocusable(r){this.a.domNode.tabIndex=r?0:-1}}t.$rV=e}),define(we[141],ve([1,0,14,83,21,13]),function(re,t,i,n,j,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$pW=t.$oW=t.$nW=void 0,F=He(F);const N=F.localize(10324,null),w=F.localize(10325,null),D=F.localize(10326,null);class c extends n.$pV{constructor(g){super({icon:j.$2j.caseSensitive,title:N+g.appendTitle,isChecked:g.isChecked,hoverDelegate:g.hoverDelegate??(0,i.$wU)("element"),inputActiveOptionBorder:g.inputActiveOptionBorder,inputActiveOptionForeground:g.inputActiveOptionForeground,inputActiveOptionBackground:g.inputActiveOptionBackground})}}t.$nW=c;class p extends n.$pV{constructor(g){super({icon:j.$2j.wholeWord,title:w+g.appendTitle,isChecked:g.isChecked,hoverDelegate:g.hoverDelegate??(0,i.$wU)("element"),inputActiveOptionBorder:g.inputActiveOptionBorder,inputActiveOptionForeground:g.inputActiveOptionForeground,inputActiveOptionBackground:g.inputActiveOptionBackground})}}t.$oW=p;class y extends n.$pV{constructor(g){super({icon:j.$2j.regex,title:D+g.appendTitle,isChecked:g.isChecked,hoverDelegate:g.hoverDelegate??(0,i.$wU)("element"),inputActiveOptionBorder:g.inputActiveOptionBorder,inputActiveOptionForeground:g.inputActiveOptionForeground,inputActiveOptionBackground:g.inputActiveOptionBackground})}}t.$pW=y}),define(we[142],ve([1,0,4,141,82,23,3,8,13,2,14,130]),function(re,t,i,n,j,F,N,w,D,c,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$qW=void 0,i=He(i),D=He(D);const y=D.localize(10327,null);class $ extends F.$dU{static{this.OPTION_CHANGE="optionChange"}constructor(e,s,r){super(),this.n=!0,this.s=!1,this.w=this.B(new c.$Uc),this.N=[],this.O=this.B(new N.$je),this.onDidOptionChange=this.O.event,this.P=this.B(new N.$je),this.onKeyDown=this.P.event,this.Q=this.B(new N.$je),this.onMouseDown=this.Q.event,this.R=this.B(new N.$je),this.onInput=this.R.event,this.S=this.B(new N.$je),this.onKeyUp=this.S.event,this.U=this.B(new N.$je),this.onCaseSensitiveKeyDown=this.U.event,this.W=this.B(new N.$je),this.onRegexKeyDown=this.W.event,this.Y=0,this.a=r.placeholder||"",this.b=r.validation,this.c=r.label||y,this.h=!!r.showCommonFindToggles;const h=r.appendCaseSensitiveLabel||"",l=r.appendWholeWordsLabel||"",v=r.appendRegexLabel||"",k=r.history||[],A=!!r.flexibleHeight,d=!!r.flexibleWidth,f=r.flexibleMaxHeight;this.domNode=document.createElement("div"),this.domNode.classList.add("monaco-findInput"),this.inputBox=this.B(new j.$jW(this.domNode,s,{placeholder:this.a||"",ariaLabel:this.c||"",validationOptions:{validation:this.b},history:k,showHistoryHint:r.showHistoryHint,flexibleHeight:A,flexibleWidth:d,flexibleMaxHeight:f,inputBoxStyles:r.inputBoxStyles}));const b=this.B((0,p.$xU)());if(this.h){this.J=this.B(new n.$pW({appendTitle:v,isChecked:!1,hoverDelegate:b,...r.toggleStyles})),this.B(this.J.onChange(U=>{this.O.fire(U),!U&&this.n&&this.inputBox.focus(),this.validate()})),this.B(this.J.onKeyDown(U=>{this.W.fire(U)})),this.L=this.B(new n.$oW({appendTitle:l,isChecked:!1,hoverDelegate:b,...r.toggleStyles})),this.B(this.L.onChange(U=>{this.O.fire(U),!U&&this.n&&this.inputBox.focus(),this.validate()})),this.M=this.B(new n.$nW({appendTitle:h,isChecked:!1,hoverDelegate:b,...r.toggleStyles})),this.B(this.M.onChange(U=>{this.O.fire(U),!U&&this.n&&this.inputBox.focus(),this.validate()})),this.B(this.M.onKeyDown(U=>{this.U.fire(U)}));const S=[this.M.domNode,this.L.domNode,this.J.domNode];this.z(this.domNode,U=>{if(U.equals(w.KeyCode.LeftArrow)||U.equals(w.KeyCode.RightArrow)||U.equals(w.KeyCode.Escape)){const _=S.indexOf(this.domNode.ownerDocument.activeElement);if(_>=0){let B=-1;U.equals(w.KeyCode.RightArrow)?B=(_+1)%S.length:U.equals(w.KeyCode.LeftArrow)&&(_===0?B=S.length-1:B=_-1),U.equals(w.KeyCode.Escape)?(S[_].blur(),this.inputBox.focus()):B>=0&&S[B].focus(),i.$vT.stop(U,!0)}}})}this.y=document.createElement("div"),this.y.className="controls",this.y.style.display=this.h?"":"none",this.M&&this.y.append(this.M.domNode),this.L&&this.y.appendChild(this.L.domNode),this.J&&this.y.appendChild(this.J.domNode),this.setAdditionalToggles(r?.additionalToggles),this.y&&this.domNode.appendChild(this.y),e?.appendChild(this.domNode),this.B(i.$sS(this.inputBox.inputElement,"compositionstart",S=>{this.s=!0})),this.B(i.$sS(this.inputBox.inputElement,"compositionend",S=>{this.s=!1,this.R.fire()})),this.z(this.inputBox.inputElement,S=>this.P.fire(S)),this.C(this.inputBox.inputElement,S=>this.S.fire(S)),this.D(this.inputBox.inputElement,S=>this.R.fire()),this.j(this.inputBox.inputElement,S=>this.Q.fire(S))}get isImeSessionInProgress(){return this.s}get onDidChange(){return this.inputBox.onDidChange}layout(e){this.inputBox.layout(),this.X(e.collapsedFindWidget)}enable(){this.domNode.classList.remove("disabled"),this.inputBox.enable(),this.J?.enable(),this.L?.enable(),this.M?.enable();for(const e of this.N)e.enable()}disable(){this.domNode.classList.add("disabled"),this.inputBox.disable(),this.J?.disable(),this.L?.disable(),this.M?.disable();for(const e of this.N)e.disable()}setFocusInputOnOptionClick(e){this.n=e}setEnabled(e){e?this.enable():this.disable()}setAdditionalToggles(e){for(const s of this.N)s.domNode.remove();this.N=[],this.w.value=new c.$Sc;for(const s of e??[])this.w.value.add(s),this.y.appendChild(s.domNode),this.w.value.add(s.onChange(r=>{this.O.fire(r),!r&&this.n&&this.inputBox.focus()})),this.N.push(s);this.N.length>0&&(this.y.style.display=""),this.X()}X(e=!1){e?this.inputBox.paddingRight=0:this.inputBox.paddingRight=(this.M?.width()??0)+(this.L?.width()??0)+(this.J?.width()??0)+this.N.reduce((s,r)=>s+r.width(),0)}clear(){this.Z(),this.setValue(""),this.focus()}getValue(){return this.inputBox.value}setValue(e){this.inputBox.value!==e&&(this.inputBox.value=e)}onSearchSubmit(){this.inputBox.addToHistory()}select(){this.inputBox.select()}focus(){this.inputBox.focus()}getCaseSensitive(){return this.M?.checked??!1}setCaseSensitive(e){this.M&&(this.M.checked=e)}getWholeWords(){return this.L?.checked??!1}setWholeWords(e){this.L&&(this.L.checked=e)}getRegex(){return this.J?.checked??!1}setRegex(e){this.J&&(this.J.checked=e,this.validate())}focusOnCaseSensitive(){this.M?.focus()}focusOnRegex(){this.J?.focus()}highlightFindOptions(){this.domNode.classList.remove("highlight-"+this.Y),this.Y=1-this.Y,this.domNode.classList.add("highlight-"+this.Y)}validate(){this.inputBox.validate()}showMessage(e){this.inputBox.showMessage(e)}clearMessage(){this.inputBox.hideMessage()}Z(){this.inputBox.hideMessage()}}t.$qW=$}),define(we[143],ve([1,0,4,29,15,81,142,82,79,52,83,72,34,53,9,12,21,22,43,3,49,8,2,37,10,13,14,62,137]),function(re,t,i,n,j,F,N,w,D,c,p,y,$,g,e,s,r,h,l,v,k,A,d,f,b,S,U,_){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$4W=t.AbstractTreePart=t.TreeFindMatchType=t.TreeFindMode=t.$3W=t.$2W=t.$1W=t.RenderIndentGuides=t.$ZW=t.$YW=void 0;class B extends D.$QU{set context(u){this.c.context=u}get context(){return this.c.context}constructor(u){super(u.elements.map(L=>L.element)),this.c=u}}function E(R){return R instanceof D.$QU?new B(R):R}class I{constructor(u,L){this.d=u,this.f=L,this.b=d.$Tc.None,this.c=new d.$Sc}getDragURI(u){return this.f.getDragURI(u.element)}getDragLabel(u,L){if(this.f.getDragLabel)return this.f.getDragLabel(u.map(T=>T.element),L)}onDragStart(u,L){this.f.onDragStart?.(E(u),L)}onDragOver(u,L,T,P,H,X=!0){const ie=this.f.onDragOver(E(u),L&&L.element,T,P,H),oe=this.a!==L;if(oe&&(this.b.dispose(),this.a=L),typeof L>"u")return ie;if(oe&&typeof ie!="boolean"&&ie.autoExpand&&(this.b=(0,s.$Eh)(()=>{const Te=this.d(),fe=Te.getNodeLocation(L);Te.isCollapsed(fe)&&Te.setCollapsed(fe,!1),this.a=void 0},500,this.c)),typeof ie=="boolean"||!ie.accept||typeof ie.bubble>"u"||ie.feedback){if(!X){const Te=typeof ie=="boolean"?ie:ie.accept,fe=typeof ie=="boolean"?void 0:ie.effect;return{accept:Te,effect:fe,feedback:[T]}}return ie}if(ie.bubble===$.TreeDragOverBubble.Up){const Te=this.d(),fe=Te.getNodeLocation(L),Re=Te.getParentNodeLocation(fe),Ke=Te.getNode(Re),Ze=Re&&Te.getListIndex(Re);return this.onDragOver(u,Ke,Ze,P,H,!1)}const de=this.d(),ye=de.getNodeLocation(L),De=de.getListIndex(ye),Le=de.getListRenderCount(ye);return{...ie,feedback:(0,e.$Qb)(De,De+Le)}}drop(u,L,T,P,H){this.b.dispose(),this.a=void 0,this.f.drop(E(u),L&&L.element,T,P,H)}onDragEnd(u){this.f.onDragEnd?.(u)}dispose(){this.c.dispose(),this.f.dispose()}}function z(R,u){return u&&{...u,identityProvider:u.identityProvider&&{getId(L){return u.identityProvider.getId(L.element)}},dnd:u.dnd&&new I(R,u.dnd),multipleSelectionController:u.multipleSelectionController&&{isSelectionSingleChangeEvent(L){return u.multipleSelectionController.isSelectionSingleChangeEvent({...L,element:L.element})},isSelectionRangeChangeEvent(L){return u.multipleSelectionController.isSelectionRangeChangeEvent({...L,element:L.element})}},accessibilityProvider:u.accessibilityProvider&&{...u.accessibilityProvider,getSetSize(L){const T=R(),P=T.getNodeLocation(L),H=T.getParentNodeLocation(P);return T.getNode(H).visibleChildrenCount},getPosInSet(L){return L.visibleChildIndex+1},isChecked:u.accessibilityProvider&&u.accessibilityProvider.isChecked?L=>u.accessibilityProvider.isChecked(L.element):void 0,getRole:u.accessibilityProvider&&u.accessibilityProvider.getRole?L=>u.accessibilityProvider.getRole(L.element):()=>"treeitem",getAriaLabel(L){return u.accessibilityProvider.getAriaLabel(L.element)},getWidgetAriaLabel(){return u.accessibilityProvider.getWidgetAriaLabel()},getWidgetRole:u.accessibilityProvider&&u.accessibilityProvider.getWidgetRole?()=>u.accessibilityProvider.getWidgetRole():()=>"tree",getAriaLevel:u.accessibilityProvider&&u.accessibilityProvider.getAriaLevel?L=>u.accessibilityProvider.getAriaLevel(L.element):L=>L.depth,getActiveDescendantId:u.accessibilityProvider.getActiveDescendantId&&(L=>u.accessibilityProvider.getActiveDescendantId(L.element))},keyboardNavigationLabelProvider:u.keyboardNavigationLabelProvider&&{...u.keyboardNavigationLabelProvider,getKeyboardNavigationLabel(L){return u.keyboardNavigationLabelProvider.getKeyboardNavigationLabel(L.element)}}}}class O{constructor(u){this.a=u}getHeight(u){return this.a.getHeight(u.element)}getTemplateId(u){return this.a.getTemplateId(u.element)}hasDynamicHeight(u){return!!this.a.hasDynamicHeight&&this.a.hasDynamicHeight(u.element)}setDynamicHeight(u,L){this.a.setDynamicHeight?.(u.element,L)}}t.$YW=O;class C{static lift(u){return u instanceof C?u:new C(u)}static empty(u=0){return new C({focus:[],selection:[],expanded:Object.create(null),scrollTop:u})}constructor(u){if(this.focus=new Set(u.focus),this.selection=new Set(u.selection),u.expanded instanceof Array){this.expanded=Object.create(null);for(const L of u.expanded)this.expanded[L]=1}else this.expanded=u.expanded;this.expanded=u.expanded,this.scrollTop=u.scrollTop}toJSON(){return{focus:Array.from(this.focus),selection:Array.from(this.selection),expanded:this.expanded,scrollTop:this.scrollTop}}}t.$ZW=C;var x;(function(R){R.None="none",R.OnHover="onHover",R.Always="always"})(x||(t.RenderIndentGuides=x={}));class Z{get elements(){return this.b}constructor(u,L=[]){this.b=L,this.a=new d.$Sc,this.onDidChange=v.Event.forEach(u,T=>this.b=T,this.a)}dispose(){this.a.dispose()}}class Y{static{this.a=8}constructor(u,L,T,P,H,X={}){this.o=u,this.p=L,this.q=P,this.s=H,this.b=new Map,this.c=new Map,this.d=Y.a,this.f=!1,this.g=!1,this.j=new Set,this.k=d.$Tc.None,this.m=new d.$Sc,this.templateId=u.templateId,this.updateOptions(X),v.Event.map(T,ie=>ie.node)(this.u,this,this.m),u.onDidChangeTwistieState?.(this.t,this,this.m)}updateOptions(u={}){if(typeof u.indent<"u"){const L=(0,f.$Im)(u.indent,0,40);if(L!==this.d){this.d=L;for(const[T,P]of this.c)this.v(T,P)}}if(typeof u.renderIndentGuides<"u"){const L=u.renderIndentGuides!==x.None;if(L!==this.g){this.g=L;for(const[T,P]of this.c)this.w(T,P);if(this.k.dispose(),L){const T=new d.$Sc;this.q.onDidChange(this.x,this,T),this.k=T,this.x(this.q.elements)}}}typeof u.hideTwistiesOfChildlessElements<"u"&&(this.f=u.hideTwistiesOfChildlessElements)}renderTemplate(u){const L=(0,i.$AT)(u,(0,i.$)(".monaco-tl-row")),T=(0,i.$AT)(L,(0,i.$)(".monaco-tl-indent")),P=(0,i.$AT)(L,(0,i.$)(".monaco-tl-twistie")),H=(0,i.$AT)(L,(0,i.$)(".monaco-tl-contents")),X=this.o.renderTemplate(H);return{container:u,indent:T,twistie:P,indentGuidesDisposable:d.$Tc.None,templateData:X}}renderElement(u,L,T,P){this.c.set(u,T),this.b.set(u.element,u),this.v(u,T),this.o.renderElement(u,L,T.templateData,P)}disposeElement(u,L,T,P){T.indentGuidesDisposable.dispose(),this.o.disposeElement?.(u,L,T.templateData,P),typeof P=="number"&&(this.c.delete(u),this.b.delete(u.element))}disposeTemplate(u){this.o.disposeTemplate(u.templateData)}t(u){const L=this.b.get(u);L&&this.u(L)}u(u){const L=this.c.get(u);L&&(this.x(this.q.elements),this.v(u,L))}v(u,L){const T=Y.a+(u.depth-1)*this.d;L.twistie.style.paddingLeft=`${T}px`,L.indent.style.width=`${T+this.d-16}px`,u.collapsible?L.container.setAttribute("aria-expanded",String(!u.collapsed)):L.container.removeAttribute("aria-expanded"),L.twistie.classList.remove(...h.ThemeIcon.asClassNameArray(r.$2j.treeItemExpanded));let P=!1;this.o.renderTwistie&&(P=this.o.renderTwistie(u.element,L.twistie)),u.collapsible&&(!this.f||u.visibleChildrenCount>0)?(P||L.twistie.classList.add(...h.ThemeIcon.asClassNameArray(r.$2j.treeItemExpanded)),L.twistie.classList.add("collapsible"),L.twistie.classList.toggle("collapsed",u.collapsed)):L.twistie.classList.remove("collapsible","collapsed"),this.w(u,L)}w(u,L){if((0,i.$qS)(L.indent),L.indentGuidesDisposable.dispose(),!this.g)return;const T=new d.$Sc,P=this.p();for(;;){const H=P.getNodeLocation(u),X=P.getParentNodeLocation(H);if(!X)break;const ie=P.getNode(X),oe=(0,i.$)(".indent-guide",{style:`width: ${this.d}px`});this.j.has(ie)&&oe.classList.add("active"),L.indent.childElementCount===0?L.indent.appendChild(oe):L.indent.insertBefore(oe,L.indent.firstElementChild),this.s.add(ie,oe),T.add((0,d.$Rc)(()=>this.s.delete(ie,oe))),u=ie}L.indentGuidesDisposable=T}x(u){if(!this.g)return;const L=new Set,T=this.p();u.forEach(P=>{const H=T.getNodeLocation(P);try{const X=T.getParentNodeLocation(H);P.collapsible&&P.children.length>0&&!P.collapsed?L.add(P):X&&L.add(T.getNode(X))}catch{}}),this.j.forEach(P=>{L.has(P)||this.s.forEach(P,H=>H.classList.remove("active"))}),L.forEach(P=>{this.j.has(P)||this.s.forEach(P,H=>H.classList.add("active"))}),this.j=L}dispose(){this.c.clear(),this.b.clear(),this.k.dispose(),(0,d.$Oc)(this.m)}}t.$1W=Y;class q{get totalCount(){return this.a}get matchCount(){return this.b}set pattern(u){this.c=u,this.d=u.toLowerCase()}constructor(u,L,T){this.g=u,this.j=L,this.k=T,this.a=0,this.b=0,this.c="",this.d="",this.f=new d.$Sc,u.onWillRefilter(this.m,this,this.f)}filter(u,L){let T=$.TreeVisibility.Visible;if(this.k){const X=this.k.filter(u,L);if(typeof X=="boolean"?T=X?$.TreeVisibility.Visible:$.TreeVisibility.Hidden:(0,y.$VW)(X)?T=(0,y.$WW)(X.visibility):T=X,T===$.TreeVisibility.Hidden)return!1}if(this.a++,!this.c)return this.b++,{data:k.FuzzyScore.Default,visibility:T};const P=this.j.getKeyboardNavigationLabel(u),H=Array.isArray(P)?P:[P];for(const X of H){const ie=X&&X.toString();if(typeof ie>"u")return{data:k.FuzzyScore.Default,visibility:T};let oe;if(this.g.findMatchType===Fe.Contiguous){const de=ie.toLowerCase().indexOf(this.d);if(de>-1){oe=[Number.MAX_SAFE_INTEGER,0];for(let ye=this.d.length;ye>0;ye--)oe.push(de+ye-1)}}else oe=(0,k.$Rk)(this.c,this.d,0,ie,ie.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(oe)return this.b++,H.length===1?{data:oe,visibility:T}:{data:{label:ie,score:oe},visibility:T}}return this.g.findMode===ke.Filter?typeof this.g.options.defaultFindVisibility=="number"?this.g.options.defaultFindVisibility:this.g.options.defaultFindVisibility?this.g.options.defaultFindVisibility(u):$.TreeVisibility.Recurse:{data:k.FuzzyScore.Default,visibility:T}}m(){this.a=0,this.b=0}dispose(){(0,d.$Oc)(this.f)}}class ee extends p.$pV{constructor(u){super({icon:r.$2j.listFilter,title:(0,S.localize)(10299,null),isChecked:u.isChecked??!1,hoverDelegate:u.hoverDelegate??(0,U.$wU)("element"),inputActiveOptionBorder:u.inputActiveOptionBorder,inputActiveOptionForeground:u.inputActiveOptionForeground,inputActiveOptionBackground:u.inputActiveOptionBackground})}}t.$2W=ee;class ce extends p.$pV{constructor(u){super({icon:r.$2j.searchFuzzy,title:(0,S.localize)(10300,null),isChecked:u.isChecked??!1,hoverDelegate:u.hoverDelegate??(0,U.$wU)("element"),inputActiveOptionBorder:u.inputActiveOptionBorder,inputActiveOptionForeground:u.inputActiveOptionForeground,inputActiveOptionBackground:u.inputActiveOptionBackground})}}t.$3W=ce;const be={inputBoxStyles:w.$hW,toggleStyles:p.$nV,listFilterWidgetBackground:void 0,listFilterWidgetNoMatchesOutline:void 0,listFilterWidgetOutline:void 0,listFilterWidgetShadow:void 0};var ke;(function(R){R[R.Highlight=0]="Highlight",R[R.Filter=1]="Filter"})(ke||(t.TreeFindMode=ke={}));var Fe;(function(R){R[R.Fuzzy=0]="Fuzzy",R[R.Contiguous=1]="Contiguous"})(Fe||(t.TreeFindMatchType=Fe={}));class ue extends d.$Tc{set mode(u){this.b.checked=u===ke.Filter,this.f.inputBox.setPlaceHolder(u===ke.Filter?(0,S.localize)(10301,null):(0,S.localize)(10302,null))}set matchType(u){this.c.checked=u===Fe.Fuzzy}get value(){return this.f.inputBox.value}set value(u){this.f.inputBox.value=u}constructor(u,L,T,P,H,X){super(),this.t=L,this.a=(0,i.h)(".monaco-tree-type-filter",[(0,i.h)(".monaco-tree-type-filter-grab.codicon.codicon-debug-gripper@grab",{tabIndex:0}),(0,i.h)(".monaco-tree-type-filter-input@findInput"),(0,i.h)(".monaco-tree-type-filter-actionbar@actionbar")]),this.j=0,this.m=0,this.s=0,this._onDidDisable=new v.$je,this.onDidDisable=this._onDidDisable.event,u.appendChild(this.a.root),this.B((0,d.$Rc)(()=>this.a.root.remove()));const ie=X?.styles??be;ie.listFilterWidgetBackground&&(this.a.root.style.backgroundColor=ie.listFilterWidgetBackground),ie.listFilterWidgetShadow&&(this.a.root.style.boxShadow=`0 0 8px 2px ${ie.listFilterWidgetShadow}`);const oe=this.B((0,U.$xU)());this.b=this.B(new ee({...ie.toggleStyles,isChecked:P===ke.Filter,hoverDelegate:oe})),this.c=this.B(new ce({...ie.toggleStyles,isChecked:H===Fe.Fuzzy,hoverDelegate:oe})),this.onDidChangeMode=v.Event.map(this.b.onChange,()=>this.b.checked?ke.Filter:ke.Highlight,this.q),this.onDidChangeMatchType=v.Event.map(this.c.onChange,()=>this.c.checked?Fe.Fuzzy:Fe.Contiguous,this.q),this.f=this.B(new N.$qW(this.a.findInput,T,{label:(0,S.localize)(10303,null),additionalToggles:[this.b,this.c],showCommonFindToggles:!1,inputBoxStyles:ie.inputBoxStyles,toggleStyles:ie.toggleStyles,history:X?.history})),this.g=this.B(new F.$yU(this.a.actionbar)),this.mode=P;const de=this.B(new n.$GU(this.f.inputBox.inputElement,"keydown")),ye=v.Event.chain(de.event,fe=>fe.map(Re=>new j.$oS(Re)));this.B(ye(fe=>{if(fe.equals(A.KeyCode.Enter)){fe.preventDefault(),fe.stopPropagation(),this.f.inputBox.addToHistory(),this.t.domFocus();return}if(fe.equals(A.KeyCode.DownArrow)){fe.preventDefault(),fe.stopPropagation(),this.f.inputBox.isAtLastInHistory()||this.f.inputBox.isNowhereInHistory()?(this.f.inputBox.addToHistory(),this.t.domFocus()):this.f.inputBox.showNextValue();return}if(fe.equals(A.KeyCode.UpArrow)){fe.preventDefault(),fe.stopPropagation(),this.f.inputBox.showPreviousValue();return}}));const De=this.B(new g.$hj("close",(0,S.localize)(10304,null),"codicon codicon-close",!0,()=>this.dispose()));this.g.push(De,{icon:!0,label:!1});const Le=this.B(new n.$GU(this.a.grab,"mousedown"));this.B(Le.event(fe=>{const Re=new d.$Sc,Ke=Re.add(new n.$GU((0,i.getWindow)(fe),"mousemove")),Ze=Re.add(new n.$GU((0,i.getWindow)(fe),"mouseup")),tt=this.m,at=fe.pageX,st=this.s,Ge=fe.pageY;this.a.grab.classList.add("grabbing");const Qe=this.a.root.style.transition;this.a.root.style.transition="unset";const J=ae=>{const pe=ae.pageX-at;this.m=tt-pe;const Se=ae.pageY-Ge;this.s=st+Se,this.layout()};Re.add(Ke.event(J)),Re.add(Ze.event(ae=>{J(ae),this.a.grab.classList.remove("grabbing"),this.a.root.style.transition=Qe,Re.dispose()}))}));const Te=v.Event.chain(this.B(new n.$GU(this.a.grab,"keydown")).event,fe=>fe.map(Re=>new j.$oS(Re)));this.B(Te(fe=>{let Re,Ke;if(fe.keyCode===A.KeyCode.LeftArrow?Re=Number.POSITIVE_INFINITY:fe.keyCode===A.KeyCode.RightArrow?Re=0:fe.keyCode===A.KeyCode.Space&&(Re=this.m===0?Number.POSITIVE_INFINITY:0),fe.keyCode===A.KeyCode.UpArrow?Ke=0:fe.keyCode===A.KeyCode.DownArrow&&(Ke=Number.POSITIVE_INFINITY),Re!==void 0&&(fe.preventDefault(),fe.stopPropagation(),this.m=Re,this.layout()),Ke!==void 0){fe.preventDefault(),fe.stopPropagation(),this.s=Ke;const Ze=this.a.root.style.transition;this.a.root.style.transition="unset",this.layout(),setTimeout(()=>{this.a.root.style.transition=Ze},0)}})),this.onDidChangeValue=this.f.onDidChange}getHistory(){return this.f.inputBox.getHistory()}focus(){this.f.focus()}select(){this.f.select(),this.f.inputBox.addToHistory(!0)}layout(u=this.j){this.j=u,this.m=(0,f.$Im)(this.m,0,Math.max(0,u-212)),this.a.root.style.right=`${this.m}px`,this.s=(0,f.$Im)(this.s,0,24),this.a.root.style.top=`${this.s}px`}showMessage(u){this.f.showMessage(u)}clearMessage(){this.f.clearMessage()}async dispose(){this._onDidDisable.fire(),this.a.root.classList.add("disabled"),await(0,s.$Dh)(300),super.dispose()}}class Q{get pattern(){return this.b}get mode(){return this.d}set mode(u){u!==this.d&&(this.d=u,this.g&&(this.g.mode=this.d),this.t.refilter(),this.A(),this.k.fire(u))}get matchType(){return this.f}set matchType(u){u!==this.f&&(this.f=u,this.g&&(this.g.matchType=this.f),this.t.refilter(),this.A(),this.m.fire(u))}constructor(u,L,T,P,H,X={}){this.t=u,this.u=T,this.v=P,this.w=H,this.x=X,this.b="",this.c="",this.j=0,this.k=new v.$je,this.onDidChangeMode=this.k.event,this.m=new v.$je,this.onDidChangeMatchType=this.m.event,this.o=new v.$je,this.onDidChangePattern=this.o.event,this.p=new v.$je,this.onDidChangeOpenState=this.p.event,this.q=new d.$Sc,this.s=new d.$Sc,this.d=u.options.defaultFindMode??ke.Highlight,this.f=u.options.defaultFindMatchType??Fe.Fuzzy,L.onDidSplice(this.z,this,this.s)}updateOptions(u={}){u.defaultFindMode!==void 0&&(this.mode=u.defaultFindMode),u.defaultFindMatchType!==void 0&&(this.matchType=u.defaultFindMatchType)}open(){if(this.g){this.g.focus(),this.g.select();return}this.g=new ue(this.u.getHTMLElement(),this.t,this.w,this.mode,this.matchType,{...this.x,history:this.a}),this.q.add(this.g),this.g.onDidChangeValue(this.y,this,this.q),this.g.onDidChangeMode(u=>this.mode=u,void 0,this.q),this.g.onDidChangeMatchType(u=>this.matchType=u,void 0,this.q),this.g.onDidDisable(this.close,this,this.q),this.g.layout(this.j),this.g.focus(),this.g.value=this.c,this.g.select(),this.p.fire(!0)}close(){this.g&&(this.a=this.g.getHistory(),this.g=void 0,this.q.clear(),this.c=this.pattern,this.y(""),this.t.domFocus(),this.p.fire(!1))}y(u){this.b=u,this.o.fire(u),this.v.pattern=u,this.t.refilter(),u&&this.t.focusNext(0,!0,void 0,T=>!k.FuzzyScore.isDefault(T.filterData));const L=this.t.getFocus();if(L.length>0){const T=L[0];this.t.getRelativeTop(T)===null&&this.t.reveal(T,.5)}this.A()}z(){!this.g||this.pattern.length===0||(this.t.refilter(),this.A())}A(){const u=this.v.totalCount>0&&this.v.matchCount===0;this.pattern&&u?this.t.options.showNotFoundMessage??!0?this.g?.showMessage({type:w.MessageType.WARNING,content:(0,S.localize)(10305,null)}):this.g?.showMessage({type:w.MessageType.WARNING}):this.g?.clearMessage()}shouldAllowFocus(u){return!this.g||!this.pattern||this.v.totalCount>0&&this.v.matchCount<=1?!0:!k.FuzzyScore.isDefault(u.filterData)}layout(u){this.j=u,this.g?.layout(u)}dispose(){this.a=void 0,this.o.dispose(),this.q.dispose(),this.s.dispose()}}function he(R,u){return R.position===u.position&&le(R,u)}function le(R,u){return R.node.element===u.node.element&&R.startIndex===u.startIndex&&R.height===u.height&&R.endIndex===u.endIndex}class Ne{constructor(u=[]){this.stickyNodes=u}get count(){return this.stickyNodes.length}equal(u){return(0,e.$tb)(this.stickyNodes,u.stickyNodes,he)}lastNodePartiallyVisible(){if(this.count===0)return!1;const u=this.stickyNodes[this.count-1];if(this.count===1)return u.position!==0;const L=this.stickyNodes[this.count-2];return L.position+L.height!==u.position}animationStateChanged(u){if(!(0,e.$tb)(this.stickyNodes,u.stickyNodes,le)||this.count===0)return!1;const L=this.stickyNodes[this.count-1],T=u.stickyNodes[u.count-1];return L.position!==T.position}}class te{constrainStickyScrollNodes(u,L,T){for(let P=0;P<u.length;P++){const H=u[P];if(H.position+H.height>T||P>=L)return u.slice(0,P)}return u}}class $e extends d.$Tc{constructor(u,L,T,P,H,X={}){super(),this.g=u,this.j=L,this.m=T,this.s=H,this.c=.4;const ie=this.validateStickySettings(X);this.b=ie.stickyScrollMaxItemCount,this.a=X.stickyScrollDelegate??new te,this.f=this.B(new Ae(T.getScrollableElement(),T,u,P,H,X.accessibilityProvider)),this.onDidChangeHasFocus=this.f.onDidChangeHasFocus,this.onContextMenu=this.f.onContextMenu,this.B(T.onDidScroll(()=>this.u())),this.B(T.onDidChangeContentHeight(()=>this.u())),this.B(u.onDidChangeCollapseState(()=>this.u())),this.u()}get height(){return this.f.height}get count(){return this.f.count}getNode(u){return this.f.getNode(u)}t(u){let L;if(u===0?L=this.m.firstVisibleIndex:L=this.m.indexAt(u+this.m.scrollTop),!(L<0||L>=this.m.length))return this.m.element(L)}u(){const u=this.t(0);if(!u||this.g.scrollTop===0){this.f.setState(void 0);return}const L=this.w(u);this.f.setState(L)}w(u){const L=[];let T=u,P=0,H=this.z(T,void 0,P);for(;H&&(L.push(H),P+=H.height,!(L.length<=this.b&&(T=this.y(H),!T)));)H=this.z(T,H.node,P);const X=this.H(L);return X.length?new Ne(X):void 0}y(u){return this.t(u.position+u.height)}z(u,L,T){const P=this.F(u,L);if(P&&!(P===u&&(!this.J(u)||this.C(u,T))))return this.D(P,T)}C(u,L){const T=this.L(u),P=this.m.getElementTop(T),H=L;return this.m.scrollTop===P-H}D(u,L){const T=this.s.getHeight(u),{startIndex:P,endIndex:H}=this.M(u),X=this.G(H,L,T);return{node:u,position:X,height:T,startIndex:P,endIndex:H}}F(u,L=void 0){let T=u,P=this.I(T);for(;P;){if(P===L)return T;T=P,P=this.I(T)}if(L===void 0)return T}G(u,L,T){let P=this.m.getRelativeTop(u);if(P===null&&this.m.firstVisibleIndex===u&&u+1<this.m.length){const de=this.s.getHeight(this.m.element(u)),ye=this.m.getRelativeTop(u+1);P=ye?ye-de/this.m.renderHeight:null}if(P===null)return L;const H=this.m.element(u),X=this.s.getHeight(H),oe=P*this.m.renderHeight+X;return L+T>oe&&L<=oe?oe-T:L}H(u){if(u.length===0)return[];const L=this.m.renderHeight*this.c,T=u[u.length-1];if(u.length<=this.b&&T.position+T.height<=L)return u;const P=this.a.constrainStickyScrollNodes(u,this.b,L);if(!P.length)return[];const H=P[P.length-1];if(P.length>this.b||H.position+H.height>L)throw new Error("stickyScrollDelegate violates constraints");return P}I(u){const L=this.j.getNodeLocation(u),T=this.j.getParentNodeLocation(L);return T?this.j.getNode(T):void 0}J(u){const L=this.j.getNodeLocation(u);return this.j.getListRenderCount(L)>1}L(u){const L=this.j.getNodeLocation(u);return this.j.getListIndex(L)}M(u){const L=this.j.getNodeLocation(u),T=this.j.getListIndex(L);if(T<0)throw new Error("Node not found in tree");const P=this.j.getListRenderCount(L),H=T+P-1;return{startIndex:T,endIndex:H}}nodePositionTopBelowWidget(u){const L=[];let T=this.I(u);for(;T;)L.push(T),T=this.I(T);let P=0;for(let H=0;H<L.length&&H<this.b;H++)P+=this.s.getHeight(L[H]);return P}getFocus(){return this.f.getFocus()}domFocus(){this.f.domFocus()}focusedLast(){return this.f.focusedLast()}updateOptions(u={}){if(!u.stickyScrollMaxItemCount)return;const L=this.validateStickySettings(u);this.b!==L.stickyScrollMaxItemCount&&(this.b=L.stickyScrollMaxItemCount,this.u())}validateStickySettings(u){let L=7;return typeof u.stickyScrollMaxItemCount=="number"&&(L=Math.max(u.stickyScrollMaxItemCount,1)),{stickyScrollMaxItemCount:L}}}class Ae{constructor(u,L,T,P,H,X){this.g=L,this.j=T,this.k=P,this.m=H,this.o=X,this.c=[],this.d=new d.$Sc,this.a=(0,i.$)(".monaco-tree-sticky-container.empty"),u.appendChild(this.a);const ie=(0,i.$)(".monaco-tree-sticky-container-shadow");this.a.appendChild(ie),this.f=new Oe(this.a,L),this.onDidChangeHasFocus=this.f.onDidChangeHasFocus,this.onContextMenu=this.f.onContextMenu}get height(){if(!this.b)return 0;const u=this.b.stickyNodes[this.b.count-1];return u.position+u.height}get count(){return this.b?.count??0}getNode(u){return this.b?.stickyNodes.find(L=>L.node===u)}setState(u){const L=!!this.b&&this.b.count>0,T=!!u&&u.count>0;if(!L&&!T||L&&T&&this.b.equal(u))return;if(L!==T&&this.s(T),!T){this.b=void 0,this.c=[],this.d.clear();return}const P=u.stickyNodes[u.count-1];if(this.b&&u.animationStateChanged(this.b))this.c[this.b.count-1].style.top=`${P.position}px`;else{this.d.clear();const H=Array(u.count);for(let X=u.count-1;X>=0;X--){const ie=u.stickyNodes[X],{element:oe,disposable:de}=this.p(ie,X,u.count);H[X]=oe,this.a.appendChild(oe),this.d.add(de)}this.f.updateElements(H,u),this.c=H}this.b=u,this.a.style.height=`${P.position+P.height}px`}p(u,L,T){const P=u.startIndex,H=document.createElement("div");H.style.top=`${u.position}px`,this.j.options.setRowHeight!==!1&&(H.style.height=`${u.height}px`),this.j.options.setRowLineHeight!==!1&&(H.style.lineHeight=`${u.height}px`),H.classList.add("monaco-tree-sticky-row"),H.classList.add("monaco-list-row"),H.setAttribute("data-index",`${P}`),H.setAttribute("data-parity",P%2===0?"even":"odd"),H.setAttribute("id",this.g.getElementID(P));const X=this.q(H,u.node.element,L,T),ie=this.m.getTemplateId(u.node),oe=this.k.find(Le=>Le.templateId===ie);if(!oe)throw new Error(`No renderer found for template id ${ie}`);let de=u.node;de===this.j.getNode(this.j.getNodeLocation(u.node))&&(de=new Proxy(u.node,{}));const ye=oe.renderTemplate(H);oe.renderElement(de,u.startIndex,ye,u.height);const De=(0,d.$Rc)(()=>{X.dispose(),oe.disposeElement(de,u.startIndex,ye,u.height),oe.disposeTemplate(ye),H.remove()});return{element:H,disposable:De}}q(u,L,T,P){if(!this.o)return d.$Tc.None;this.o.getSetSize&&u.setAttribute("aria-setsize",String(this.o.getSetSize(L,T,P))),this.o.getPosInSet&&u.setAttribute("aria-posinset",String(this.o.getPosInSet(L,T))),this.o.getRole&&u.setAttribute("role",this.o.getRole(L)??"treeitem");const H=this.o.getAriaLabel(L),X=H&&typeof H!="string"?H:(0,_.constObservable)(H),ie=(0,_.autorun)(de=>{const ye=de.readObservable(X);ye?u.setAttribute("aria-label",ye):u.removeAttribute("aria-label")});typeof H=="string"||H&&u.setAttribute("aria-label",H.get());const oe=this.o.getAriaLevel&&this.o.getAriaLevel(L);return typeof oe=="number"&&u.setAttribute("aria-level",`${oe}`),u.setAttribute("aria-selected",String(!1)),ie}s(u){this.a.classList.toggle("empty",!u),u||this.f.updateElements([],void 0)}getFocus(){return this.f.getFocus()}domFocus(){this.f.domFocus()}focusedLast(){return this.f.focusedLast()}dispose(){this.f.dispose(),this.d.dispose(),this.a.remove()}}class Oe extends d.$Tc{get m(){return this.j}set m(u){u!==this.j&&(this.f.fire(u),this.j=u)}constructor(u,L){super(),this.s=u,this.t=L,this.a=-1,this.b=[],this.f=new v.$je,this.onDidChangeHasFocus=this.f.event,this.g=new v.$je,this.onContextMenu=this.g.event,this.j=!1,this.s.addEventListener("focus",()=>this.M()),this.s.addEventListener("blur",()=>this.O()),this.B(this.t.onDidFocus(()=>this.L(!1))),this.B(this.t.onKeyDown(T=>this.w(T))),this.B(this.t.onMouseDown(T=>this.y(T))),this.B(this.t.onContextMenu(T=>this.u(T)))}u(u){const L=u.browserEvent.target;if(!(0,c.$4U)(L)&&!(0,c.$3U)(L)){this.focusedLast()&&this.t.domFocus();return}if(!(0,i.$qT)(u.browserEvent)){if(!this.c)throw new Error("Context menu should not be triggered when state is undefined");const X=this.c.stickyNodes.findIndex(ie=>ie.node.element===u.element?.element);if(X===-1)throw new Error("Context menu should not be triggered when element is not in sticky scroll widget");this.s.focus(),this.F(X);return}if(!this.c||this.a<0)throw new Error("Context menu key should not be triggered when focus is not in sticky scroll widget");const P=this.c.stickyNodes[this.a].node.element,H=this.b[this.a];this.g.fire({element:P,anchor:H,browserEvent:u.browserEvent,isStickyScroll:!0})}w(u){if(this.m&&this.c){if(u.key==="ArrowUp")this.z(Math.max(0,this.a-1)),u.preventDefault(),u.stopPropagation();else if(u.key==="ArrowDown"||u.key==="ArrowRight"){if(this.a>=this.c.count-1){const L=this.c.stickyNodes[this.c.count-1].startIndex+1;this.t.domFocus(),this.t.setFocus([L]),this.C(L,this.c)}else this.z(this.a+1);u.preventDefault(),u.stopPropagation()}}}y(u){const L=u.browserEvent.target;!(0,c.$4U)(L)&&!(0,c.$3U)(L)||(u.browserEvent.preventDefault(),u.browserEvent.stopPropagation())}updateElements(u,L){if(L&&L.count===0)throw new Error("Sticky scroll state must be undefined when there are no sticky nodes");if(L&&L.count!==u.length)throw new Error("Sticky scroll focus received illigel state");const T=this.a;if(this.D(),this.b=u,this.c=L,L){const P=(0,f.$Im)(T,0,L.count-1);this.F(P)}else this.m&&this.t.domFocus();this.s.tabIndex=L?0:-1}z(u){const L=this.c;if(!L)throw new Error("Cannot set focus when state is undefined");if(this.F(u),!(u<L.count-1)&&L.lastNodePartiallyVisible()){const T=L.stickyNodes[u];this.C(T.endIndex+1,L)}}C(u,L){const T=L.stickyNodes[L.count-1],P=L.count>1?L.stickyNodes[L.count-2]:void 0,H=this.t.getElementTop(u),X=P?P.position+P.height+T.height:T.height;this.t.scrollTop=H-X}getFocus(){if(!(!this.c||this.a===-1))return this.c.stickyNodes[this.a].node.element}domFocus(){if(!this.c)throw new Error("Cannot focus when state is undefined");this.s.focus()}focusedLast(){return this.c?this.t.getHTMLElement().classList.contains("sticky-scroll-focused"):!1}D(){this.a!==-1&&(this.G(this.b[this.a],!1),this.a=-1)}F(u){if(0>u)throw new Error("addFocus() can not remove focus");if(!this.c&&u>=0)throw new Error("Cannot set focus index when state is undefined");if(this.c&&u>=this.c.count)throw new Error("Cannot set focus index to an index that does not exist");const L=this.a;L>=0&&this.G(this.b[L],!1),u>=0&&this.G(this.b[u],!0),this.a=u}G(u,L){this.I(u,L&&this.m),this.J(u,L)}H(u){this.a!==-1&&this.I(this.b[this.a],u)}I(u,L){u.classList.toggle("focused",L)}J(u,L){u.classList.toggle("passive-focused",L)}L(u){this.t.getHTMLElement().classList.toggle("sticky-scroll-focused",u)}M(){if(!this.c||this.b.length===0)throw new Error("Cannot focus when state is undefined or elements are empty");this.m=!0,this.L(!0),this.H(!0),this.a===-1&&this.F(0)}O(){this.m=!1,this.H(!1)}dispose(){this.L(!1),this.f.fire(!1),super.dispose()}}function Ie(R){let u=$.TreeMouseEventTarget.Unknown;return(0,i.$1S)(R.browserEvent.target,"monaco-tl-twistie","monaco-tl-row")?u=$.TreeMouseEventTarget.Twistie:(0,i.$1S)(R.browserEvent.target,"monaco-tl-contents","monaco-tl-row")?u=$.TreeMouseEventTarget.Element:(0,i.$1S)(R.browserEvent.target,"monaco-tree-type-filter","monaco-list")&&(u=$.TreeMouseEventTarget.Filter),{browserEvent:R.browserEvent,element:R.element?R.element.element:null,target:u}}function Ce(R){const u=(0,c.$4U)(R.browserEvent.target);return{element:R.element?R.element.element:null,browserEvent:R.browserEvent,anchor:R.anchor,isStickyScroll:u}}function se(R,u){u(R),R.children.forEach(L=>se(L,u))}class K{get f(){return this.d||(this.d=this.m()),this.d}constructor(u,L){this.g=u,this.j=L,this.a=[],this.c=new v.$je,this.onDidChange=this.c.event}set(u,L){!L?.__forceEvent&&(0,e.$tb)(this.a,u)||this.k(u,!1,L)}k(u,L,T){if(this.a=[...u],this.b=void 0,this.d=void 0,!L){const P=this;this.c.fire({get elements(){return P.get()},browserEvent:T})}}get(){return this.b||(this.b=this.a.map(u=>u.element)),[...this.b]}getNodes(){return this.a}has(u){return this.f.has(u)}onDidModelSplice({insertedNodes:u,deletedNodes:L}){if(!this.j){const oe=this.m(),de=ye=>oe.delete(ye);L.forEach(ye=>se(ye,de)),this.set([...oe.values()]);return}const T=new Set,P=oe=>T.add(this.j.getId(oe.element).toString());L.forEach(oe=>se(oe,P));const H=new Map,X=oe=>H.set(this.j.getId(oe.element).toString(),oe);u.forEach(oe=>se(oe,X));const ie=[];for(const oe of this.a){const de=this.j.getId(oe.element).toString();if(!T.has(de))ie.push(oe);else{const De=H.get(de);De&&De.visible&&ie.push(De)}}if(this.a.length>0&&ie.length===0){const oe=this.g();oe&&ie.push(oe)}this.k(ie,!0)}m(){const u=new Set;for(const L of this.a)u.add(L);return u}}class W extends c.$9U{constructor(u,L,T){super(u),this.x=L,this.y=T}u(u){if((0,c.$5U)(u.browserEvent.target)||(0,c.$XU)(u.browserEvent.target)||(0,c.$YU)(u.browserEvent.target)||u.browserEvent.isHandledByList)return;const L=u.element;if(!L)return super.u(u);if(this.p(u)||this.o(u))return super.u(u);const T=u.browserEvent.target,P=T.classList.contains("monaco-tl-twistie")||T.classList.contains("monaco-icon-label")&&T.classList.contains("folder-icon")&&u.browserEvent.offsetX<16,H=(0,c.$3U)(u.browserEvent.target);let X=!1;if(H?X=!0:typeof this.x.expandOnlyOnTwistieClick=="function"?X=this.x.expandOnlyOnTwistieClick(L.element):X=!!this.x.expandOnlyOnTwistieClick,H)this.A(u,L);else{if(X&&!P&&u.browserEvent.detail!==2)return super.u(u);if(!this.x.expandOnDoubleClick&&u.browserEvent.detail===2)return super.u(u)}if(L.collapsible&&(!H||P)){const ie=this.x.getNodeLocation(L),oe=u.browserEvent.altKey;if(this.x.setFocus([ie]),this.x.toggleCollapsed(ie,oe),P){u.browserEvent.isHandledByList=!0;return}}H||super.u(u)}A(u,L){if((0,c.$ZU)(u.browserEvent.target)||(0,c.$1U)(u.browserEvent.target))return;const T=this.y();if(!T)throw new Error("Sticky scroll controller not found");const P=this.k.indexOf(L),H=this.k.getElementTop(P),X=T.nodePositionTopBelowWidget(L);this.x.scrollTop=H-X,this.k.domFocus(),this.k.setFocus([P]),this.k.setSelection([P])}v(u){u.browserEvent.target.classList.contains("monaco-tl-twistie")||!this.x.expandOnDoubleClick||u.browserEvent.isHandledByList||super.v(u)}s(u){const L=u.browserEvent.target;if(!(0,c.$4U)(L)&&!(0,c.$3U)(L)){super.s(u);return}}t(u){const L=u.browserEvent.target;if(!(0,c.$4U)(L)&&!(0,c.$3U)(L)){super.t(u);return}}}class a extends c.$_U{constructor(u,L,T,P,H,X,ie,oe){super(u,L,T,P,oe),this.p=H,this.s=X,this.K=ie}D(u){return new W(this,u.tree,u.stickyScrollProvider)}splice(u,L,T=[]){if(super.splice(u,L,T),T.length===0)return;const P=[],H=[];let X;T.forEach((ie,oe)=>{this.p.has(ie)&&P.push(u+oe),this.s.has(ie)&&H.push(u+oe),this.K.has(ie)&&(X=u+oe)}),P.length>0&&super.setFocus((0,e.$Lb)([...super.getFocus(),...P])),H.length>0&&super.setSelection((0,e.$Lb)([...super.getSelection(),...H])),typeof X=="number"&&super.setAnchor(X)}setFocus(u,L,T=!1){super.setFocus(u,L),T||this.p.set(u.map(P=>this.element(P)),L)}setSelection(u,L,T=!1){super.setSelection(u,L),T||this.s.set(u.map(P=>this.element(P)),L)}setAnchor(u,L=!1){super.setAnchor(u),L||(typeof u>"u"?this.K.set([]):this.K.set([this.element(u)]))}}var o;(function(R){R[R.Tree=0]="Tree",R[R.StickyScroll=1]="StickyScroll"})(o||(t.AbstractTreePart=o={}));class m{get onDidScroll(){return this.j.onDidScroll}get onDidChangeFocus(){return this.y.wrapEvent(this.q.onDidChange)}get onDidChangeSelection(){return this.y.wrapEvent(this.w.onDidChange)}get onMouseClick(){return v.Event.map(this.j.onMouseClick,Ie)}get onMouseDblClick(){return v.Event.filter(v.Event.map(this.j.onMouseDblClick,Ie),u=>u.target!==$.TreeMouseEventTarget.Filter)}get onMouseOver(){return v.Event.map(this.j.onMouseOver,Ie)}get onMouseOut(){return v.Event.map(this.j.onMouseOut,Ie)}get onContextMenu(){return v.Event.any(v.Event.filter(v.Event.map(this.j.onContextMenu,Ce),u=>!u.isStickyScroll),this.B?.onContextMenu??v.Event.None)}get onTap(){return v.Event.map(this.j.onTap,Ie)}get onPointer(){return v.Event.map(this.j.onPointer,Ie)}get onKeyDown(){return this.j.onKeyDown}get onKeyUp(){return this.j.onKeyUp}get onKeyPress(){return this.j.onKeyPress}get onDidFocus(){return this.j.onDidFocus}get onDidBlur(){return this.j.onDidBlur}get onDidChangeModel(){return v.Event.signal(this.o.onDidSplice)}get onDidChangeCollapseState(){return this.o.onDidChangeCollapseState}get onDidChangeRenderNodeCount(){return this.o.onDidChangeRenderNodeCount}get findMode(){return this.z?.mode??ke.Highlight}set findMode(u){this.z&&(this.z.mode=u)}get findMatchType(){return this.z?.matchType??Fe.Fuzzy}set findMatchType(u){this.z&&(this.z.matchType=u)}get onDidChangeFindPattern(){return this.z?this.z.onDidChangePattern:v.Event.None}get expandOnDoubleClick(){return typeof this.H.expandOnDoubleClick>"u"?!0:this.H.expandOnDoubleClick}get expandOnlyOnTwistieClick(){return typeof this.H.expandOnlyOnTwistieClick>"u"?!0:this.H.expandOnlyOnTwistieClick}get onDidDispose(){return this.j.onDidDispose}constructor(u,L,T,P,H={}){this.G=u,this.H=H,this.y=new v.$re,this.onDidChangeFindOpenState=v.Event.None,this.onDidChangeStickyScrollFocused=v.Event.None,this.D=new d.$Sc,this.E=new v.$je,this.onWillRefilter=this.E.event,this.F=new v.$je,this.onDidUpdateOptions=this.F.event,this.p=new O(T);const X=new v.$se,ie=new v.$se,oe=this.D.add(new Z(ie.event)),de=new l.$Gc;this.k=P.map(fe=>new Y(fe,()=>this.o,X.event,oe,de,H));for(const fe of this.k)this.D.add(fe);let ye;H.keyboardNavigationLabelProvider&&(ye=new q(this,H.keyboardNavigationLabelProvider,H.filter),H={...H,filter:ye},this.D.add(ye)),this.q=new K(()=>this.j.getFocusedElements()[0],H.identityProvider),this.w=new K(()=>this.j.getSelectedElements()[0],H.identityProvider),this.x=new K(()=>this.j.getAnchorElement(),H.identityProvider),this.j=new a(u,L,this.p,this.k,this.q,this.w,this.x,{...z(()=>this.o,H),tree:this,stickyScrollProvider:()=>this.B}),this.o=this.M(u,this.j,H),X.input=this.o.onDidChangeCollapseState;const De=v.Event.forEach(this.o.onDidSplice,fe=>{this.y.bufferEvents(()=>{this.q.onDidModelSplice(fe),this.w.onDidModelSplice(fe)})},this.D);De(()=>null,null,this.D);const Le=this.D.add(new v.$je),Te=this.D.add(new s.$zh(0));if(this.D.add(v.Event.any(De,this.q.onDidChange,this.w.onDidChange)(()=>{Te.trigger(()=>{const fe=new Set;for(const Re of this.q.getNodes())fe.add(Re);for(const Re of this.w.getNodes())fe.add(Re);Le.fire([...fe.values()])})})),ie.input=Le.event,H.keyboardSupport!==!1){const fe=v.Event.chain(this.j.onKeyDown,Re=>Re.filter(Ke=>!(0,c.$XU)(Ke.target)).map(Ke=>new j.$oS(Ke)));v.Event.chain(fe,Re=>Re.filter(Ke=>Ke.keyCode===A.KeyCode.LeftArrow))(this.J,this,this.D),v.Event.chain(fe,Re=>Re.filter(Ke=>Ke.keyCode===A.KeyCode.RightArrow))(this.K,this,this.D),v.Event.chain(fe,Re=>Re.filter(Ke=>Ke.keyCode===A.KeyCode.Space))(this.L,this,this.D)}if((H.findWidgetEnabled??!0)&&H.keyboardNavigationLabelProvider&&H.contextViewProvider){const fe=this.options.findWidgetStyles?{styles:this.options.findWidgetStyles}:void 0;this.z=new Q(this,this.o,this.j,ye,H.contextViewProvider,fe),this.A=Re=>this.z.shouldAllowFocus(Re),this.onDidChangeFindOpenState=this.z.onDidChangeOpenState,this.D.add(this.z),this.onDidChangeFindMode=this.z.onDidChangeMode,this.onDidChangeFindMatchType=this.z.onDidChangeMatchType}else this.onDidChangeFindMode=v.Event.None,this.onDidChangeFindMatchType=v.Event.None;H.enableStickyScroll&&(this.B=new $e(this,this.o,this.j,this.k,this.p,H),this.onDidChangeStickyScrollFocused=this.B.onDidChangeHasFocus),this.C=(0,i.$aT)(this.j.getHTMLElement()),this.getHTMLElement().classList.toggle("always",this.H.renderIndentGuides===x.Always)}updateOptions(u={}){this.H={...this.H,...u};for(const L of this.k)L.updateOptions(u);this.j.updateOptions(this.H),this.z?.updateOptions(u),this.I(u),this.F.fire(this.H),this.getHTMLElement().classList.toggle("always",this.H.renderIndentGuides===x.Always)}get options(){return this.H}I(u){!this.B&&this.H.enableStickyScroll?(this.B=new $e(this,this.o,this.j,this.k,this.p,this.H),this.onDidChangeStickyScrollFocused=this.B.onDidChangeHasFocus):this.B&&!this.H.enableStickyScroll&&(this.onDidChangeStickyScrollFocused=v.Event.None,this.B.dispose(),this.B=void 0),this.B?.updateOptions(u)}updateWidth(u){const L=this.o.getListIndex(u);L!==-1&&this.j.updateWidth(L)}getHTMLElement(){return this.j.getHTMLElement()}get contentHeight(){return this.j.contentHeight}get contentWidth(){return this.j.contentWidth}get onDidChangeContentHeight(){return this.j.onDidChangeContentHeight}get onDidChangeContentWidth(){return this.j.onDidChangeContentWidth}get scrollTop(){return this.j.scrollTop}set scrollTop(u){this.j.scrollTop=u}get scrollLeft(){return this.j.scrollLeft}set scrollLeft(u){this.j.scrollLeft=u}get scrollHeight(){return this.j.scrollHeight}get renderHeight(){return this.j.renderHeight}get firstVisibleElement(){let u=this.j.firstVisibleIndex;return this.B&&(u+=this.B.count),u<0||u>=this.j.length?void 0:this.j.element(u).element}get lastVisibleElement(){const u=this.j.lastVisibleIndex;return this.j.element(u).element}get ariaLabel(){return this.j.ariaLabel}set ariaLabel(u){this.j.ariaLabel=u}get selectionSize(){return this.w.getNodes().length}domFocus(){this.B?.focusedLast()?this.B.domFocus():this.j.domFocus()}isDOMFocused(){return(0,i.$6S)(this.getHTMLElement())}layout(u,L){this.j.layout(u,L),(0,b.$gg)(L)&&this.z?.layout(L)}style(u){const L=`.${this.j.domId}`,T=[];u.treeIndentGuidesStroke&&(T.push(`.monaco-list${L}:hover .monaco-tl-indent > .indent-guide, .monaco-list${L}.always .monaco-tl-indent > .indent-guide  { border-color: ${u.treeInactiveIndentGuidesStroke}; }`),T.push(`.monaco-list${L} .monaco-tl-indent > .indent-guide.active { border-color: ${u.treeIndentGuidesStroke}; }`));const P=u.treeStickyScrollBackground??u.listBackground;P&&(T.push(`.monaco-list${L} .monaco-scrollable-element .monaco-tree-sticky-container { background-color: ${P}; }`),T.push(`.monaco-list${L} .monaco-scrollable-element .monaco-tree-sticky-container .monaco-tree-sticky-row { background-color: ${P}; }`)),u.treeStickyScrollBorder&&T.push(`.monaco-list${L} .monaco-scrollable-element .monaco-tree-sticky-container { border-bottom: 1px solid ${u.treeStickyScrollBorder}; }`),u.treeStickyScrollShadow&&T.push(`.monaco-list${L} .monaco-scrollable-element .monaco-tree-sticky-container .monaco-tree-sticky-container-shadow { box-shadow: ${u.treeStickyScrollShadow} 0 6px 6px -6px inset; height: 3px; }`),u.listFocusForeground&&(T.push(`.monaco-list${L}.sticky-scroll-focused .monaco-scrollable-element .monaco-tree-sticky-container:focus .monaco-list-row.focused { color: ${u.listFocusForeground}; }`),T.push(`.monaco-list${L}:not(.sticky-scroll-focused) .monaco-scrollable-element .monaco-tree-sticky-container .monaco-list-row.focused { color: inherit; }`));const H=(0,i.$ST)(u.listFocusAndSelectionOutline,(0,i.$ST)(u.listSelectionOutline,u.listFocusOutline??""));H&&(T.push(`.monaco-list${L}.sticky-scroll-focused .monaco-scrollable-element .monaco-tree-sticky-container:focus .monaco-list-row.focused.selected { outline: 1px solid ${H}; outline-offset: -1px;}`),T.push(`.monaco-list${L}:not(.sticky-scroll-focused) .monaco-scrollable-element .monaco-tree-sticky-container .monaco-list-row.focused.selected { outline: inherit;}`)),u.listFocusOutline&&(T.push(`.monaco-list${L}.sticky-scroll-focused .monaco-scrollable-element .monaco-tree-sticky-container:focus .monaco-list-row.focused { outline: 1px solid ${u.listFocusOutline}; outline-offset: -1px; }`),T.push(`.monaco-list${L}:not(.sticky-scroll-focused) .monaco-scrollable-element .monaco-tree-sticky-container .monaco-list-row.focused { outline: inherit; }`),T.push(`.monaco-workbench.context-menu-visible .monaco-list${L}.last-focused.sticky-scroll-focused .monaco-scrollable-element .monaco-tree-sticky-container .monaco-list-row.passive-focused { outline: 1px solid ${u.listFocusOutline}; outline-offset: -1px; }`),T.push(`.monaco-workbench.context-menu-visible .monaco-list${L}.last-focused.sticky-scroll-focused .monaco-list-rows .monaco-list-row.focused { outline: inherit; }`),T.push(`.monaco-workbench.context-menu-visible .monaco-list${L}.last-focused:not(.sticky-scroll-focused) .monaco-tree-sticky-container .monaco-list-rows .monaco-list-row.focused { outline: inherit; }`)),this.C.textContent=T.join(`
`),this.j.style(u)}getParentElement(u){const L=this.o.getParentNodeLocation(u);return this.o.getNode(L).element}getFirstElementChild(u){return this.o.getFirstElementChild(u)}getNode(u){return this.o.getNode(u)}getNodeLocation(u){return this.o.getNodeLocation(u)}collapse(u,L=!1){return this.o.setCollapsed(u,!0,L)}expand(u,L=!1){return this.o.setCollapsed(u,!1,L)}toggleCollapsed(u,L=!1){return this.o.setCollapsed(u,void 0,L)}expandAll(){this.o.setCollapsed(this.o.rootRef,!1,!0)}collapseAll(){this.o.setCollapsed(this.o.rootRef,!0,!0)}isCollapsible(u){return this.o.isCollapsible(u)}setCollapsible(u,L){return this.o.setCollapsible(u,L)}isCollapsed(u){return this.o.isCollapsed(u)}expandTo(u){this.o.expandTo(u)}triggerTypeNavigation(){this.j.triggerTypeNavigation()}openFind(){this.z?.open()}closeFind(){this.z?.close()}refilter(){this.E.fire(void 0),this.o.refilter()}setAnchor(u){if(typeof u>"u")return this.j.setAnchor(void 0);this.y.bufferEvents(()=>{const L=this.o.getNode(u);this.x.set([L]);const T=this.o.getListIndex(u);T>-1&&this.j.setAnchor(T,!0)})}getAnchor(){return(0,e.$Nb)(this.x.get(),void 0)}setSelection(u,L){this.y.bufferEvents(()=>{const T=u.map(H=>this.o.getNode(H));this.w.set(T,L);const P=u.map(H=>this.o.getListIndex(H)).filter(H=>H>-1);this.j.setSelection(P,L,!0)})}getSelection(){return this.w.get()}setFocus(u,L){this.y.bufferEvents(()=>{const T=u.map(H=>this.o.getNode(H));this.q.set(T,L);const P=u.map(H=>this.o.getListIndex(H)).filter(H=>H>-1);this.j.setFocus(P,L,!0)})}focusNext(u=1,L=!1,T,P=(0,i.$qT)(T)&&T.altKey?void 0:this.A){this.j.focusNext(u,L,T,P)}focusPrevious(u=1,L=!1,T,P=(0,i.$qT)(T)&&T.altKey?void 0:this.A){this.j.focusPrevious(u,L,T,P)}focusNextPage(u,L=(0,i.$qT)(u)&&u.altKey?void 0:this.A){return this.j.focusNextPage(u,L)}focusPreviousPage(u,L=(0,i.$qT)(u)&&u.altKey?void 0:this.A){return this.j.focusPreviousPage(u,L,()=>this.B?.height??0)}focusLast(u,L=(0,i.$qT)(u)&&u.altKey?void 0:this.A){this.j.focusLast(u,L)}focusFirst(u,L=(0,i.$qT)(u)&&u.altKey?void 0:this.A){this.j.focusFirst(u,L)}getFocus(){return this.q.get()}getStickyScrollFocus(){const u=this.B?.getFocus();return u!==void 0?[u]:[]}getFocusedPart(){return this.B?.focusedLast()?o.StickyScroll:o.Tree}reveal(u,L){this.o.expandTo(u);const T=this.o.getListIndex(u);if(T!==-1)if(!this.B)this.j.reveal(T,L);else{const P=this.B.nodePositionTopBelowWidget(this.getNode(u));this.j.reveal(T,L,P)}}getRelativeTop(u){const L=this.o.getListIndex(u);if(L===-1)return null;const T=this.B?.getNode(this.getNode(u));return this.j.getRelativeTop(L,T?.position??this.B?.height)}getViewState(u=this.options.identityProvider){if(!u)throw new $.$TW(this.G,"Can't get tree view state without an identity provider");const L=X=>u.getId(X).toString(),T=C.empty(this.scrollTop);for(const X of this.getFocus())T.focus.add(L(X));for(const X of this.getSelection())T.selection.add(L(X));const P=this.o.getNode(),H=[P];for(;H.length>0;){const X=H.shift();X!==P&&X.collapsible&&(T.expanded[L(X.element)]=X.collapsed?0:1),H.push(...X.children)}return T}J(u){u.preventDefault(),u.stopPropagation();const L=this.j.getFocusedElements();if(L.length===0)return;const T=L[0],P=this.o.getNodeLocation(T);if(!this.o.setCollapsed(P,!0)){const X=this.o.getParentNodeLocation(P);if(!X)return;const ie=this.o.getListIndex(X);this.j.reveal(ie),this.j.setFocus([ie])}}K(u){u.preventDefault(),u.stopPropagation();const L=this.j.getFocusedElements();if(L.length===0)return;const T=L[0],P=this.o.getNodeLocation(T);if(!this.o.setCollapsed(P,!1)){if(!T.children.some(oe=>oe.visible))return;const[X]=this.j.getFocus(),ie=X+1;this.j.reveal(ie),this.j.setFocus([ie])}}L(u){u.preventDefault(),u.stopPropagation();const L=this.j.getFocusedElements();if(L.length===0)return;const T=L[0],P=this.o.getNodeLocation(T),H=u.browserEvent.altKey;this.o.setCollapsed(P,void 0,H)}navigate(u){return new M(this.j,this.o,u)}dispose(){(0,d.$Oc)(this.D),this.B?.dispose(),this.j.dispose()}}t.$4W=m;class M{constructor(u,L,T){this.b=u,this.c=L,T?this.a=this.c.getListIndex(T):this.a=-1}current(){return this.a<0||this.a>=this.b.length?null:this.b.element(this.a).element}previous(){return this.a--,this.current()}next(){return this.a++,this.current()}first(){return this.a=0,this.current()}last(){return this.a=this.b.length-1,this.current()}}}),define(we[144],ve([1,0,143,116,34,36]),function(re,t,i,n,j,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$cX=void 0;class N extends i.$4W{constructor(D,c,p,y,$,g={}){super(D,c,p,y,g),this.f=D,this.g=$,this.d=new Map,this.c=g.identityProvider}getInput(){return this.b}setInput(D,c){if(c&&!this.c)throw new j.$TW(this.f,"Can't restore tree view state without an identity provider");if(this.b=D,!D){this.d.clear(),this.o.setChildren(null,F.Iterable.empty());return}if(!c){this.m(D);return}const p=[],y=[],$=e=>{const s=this.c.getId(e).toString();return!c.expanded[s]},g=e=>{const s=this.c.getId(e.element).toString();c.focus.has(s)&&p.push(e.element),c.selection.has(s)&&y.push(e.element)};this.m(D,$,g),this.setFocus(p),this.setSelection(y),c&&typeof c.scrollTop=="number"&&(this.scrollTop=c.scrollTop)}updateChildren(D=this.b){if(typeof this.b>"u")throw new j.$TW(this.f,"Tree input not set");let c;this.c&&(c=p=>{const y=this.c.getId(p).toString(),$=this.d.get(y);if($)return $.collapsed}),this.m(D,c)}resort(D=this.b,c=!0){this.o.resort(D===this.b?null:D,c)}refresh(D){if(D===void 0){this.j.rerender();return}this.o.rerender(D)}m(D,c,p){let y;if(this.c){const $=new Set,g=p;p=e=>{const s=this.c.getId(e.element).toString();$.add(s),this.d.set(s,e),g?.(e)},y=e=>{const s=this.c.getId(e.element).toString();$.has(s)||this.d.delete(s)}}this.o.setChildren(D===this.b?null:D,this.s(D,c).elements,{onDidCreateNode:p,onDidDeleteNode:y})}s(D,c){const p=[...this.g.getChildren(D)];return{elements:F.Iterable.map(p,$=>{const{elements:g,size:e}=this.s($,c),s=this.g.hasChildren?this.g.hasChildren($):void 0,r=e===0?void 0:c&&c($);return{element:$,children:g,collapsible:s,collapsed:r}}),size:p.length}}M(D,c,p){return new n.$5W(D,c,p)}}t.$cX=N}),define(we[54],ve([1,0]),function(re,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Bi=t._util=void 0,t.$Ci=j,t.$Di=F;var i;(function(N){N.serviceIds=new Map,N.DI_TARGET="$di$target",N.DI_DEPENDENCIES="$di$dependencies";function w(D){return D[N.DI_DEPENDENCIES]||[]}N.getServiceDependencies=w})(i||(t._util=i={})),t.$Bi=j("instantiationService");function n(N,w,D){w[i.DI_TARGET]===w?w[i.DI_DEPENDENCIES].push({id:N,index:D}):(w[i.DI_DEPENDENCIES]=[{id:N,index:D}],w[i.DI_TARGET]=w)}function j(N){if(i.serviceIds.has(N))return i.serviceIds.get(N);const w=function(D,c,p){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");n(w,D,p)};return w.toString=()=>N,i.serviceIds.set(N,w),w}function F(N){return N}}),define(we[145],ve([1,0,54]),function(re,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Sm=t.$Qm=t.ID=void 0,t.$Rm=n,t.ID="diagnosticsService",t.$Qm=(0,i.$Ci)(t.ID);function n(F){return!!F.hostName&&!!F.errorMessage}class j{async getPerformanceInfo(N,w){return{}}async getSystemInfo(N,w){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(N,w){return""}async getWorkspaceFileExtensions(N){return{extensions:[]}}async reportWorkspaceStats(N){}}t.$Sm=j}),define(we[146],ve([1,0,110,28,11,10,16,13,54,5,39,25]),function(re,t,i,n,j,F,N,w,D,c,p,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Fl=t.$Cl=t.FileKind=t.$Bl=t.$Al=t.$zl=t.$yl=t.$xl=t.$wl=t.$vl=t.FileOperationResult=t.$ul=t.$tl=t.$sl=t.$ql=t.FileChangeType=t.$pl=t.FileOperation=t.$jl=t.FileSystemProviderErrorCode=t.FileSystemProviderCapabilities=t.FileChangeFilter=t.FilePermission=t.FileType=t.$0k=void 0,t.$$k=$,t.$_k=r,t.$al=l,t.$bl=v,t.$cl=k,t.$dl=A,t.$el=d,t.$fl=f,t.$gl=b,t.$hl=S,t.$il=U,t.$kl=E,t.$ll=I,t.$ml=z,t.$nl=O,t.$ol=C,t.$rl=ee,t.$Dl=Q,t.$El=he,t.$Gl=Ne,t.$0k=(0,D.$Ci)("fileService");function $(te){return te.create===!0}var g;(function(te){te[te.Unknown=0]="Unknown",te[te.File=1]="File",te[te.Directory=2]="Directory",te[te.SymbolicLink=64]="SymbolicLink"})(g||(t.FileType=g={}));var e;(function(te){te[te.Readonly=1]="Readonly",te[te.Locked=2]="Locked"})(e||(t.FilePermission=e={}));var s;(function(te){te[te.UPDATED=2]="UPDATED",te[te.ADDED=4]="ADDED",te[te.DELETED=8]="DELETED"})(s||(t.FileChangeFilter=s={}));function r(te){const $e=te;return!!$e&&typeof $e.onDidChange=="function"}var h;(function(te){te[te.None=0]="None",te[te.FileReadWrite=2]="FileReadWrite",te[te.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",te[te.FileReadStream=16]="FileReadStream",te[te.FileFolderCopy=8]="FileFolderCopy",te[te.PathCaseSensitive=1024]="PathCaseSensitive",te[te.Readonly=2048]="Readonly",te[te.Trash=4096]="Trash",te[te.FileWriteUnlock=8192]="FileWriteUnlock",te[te.FileAtomicRead=16384]="FileAtomicRead",te[te.FileAtomicWrite=32768]="FileAtomicWrite",te[te.FileAtomicDelete=65536]="FileAtomicDelete",te[te.FileClone=131072]="FileClone"})(h||(t.FileSystemProviderCapabilities=h={}));function l(te){return!!(te.capabilities&h.FileReadWrite)}function v(te){return!!(te.capabilities&h.FileFolderCopy)}function k(te){return!!(te.capabilities&h.FileClone)}function A(te){return!!(te.capabilities&h.FileOpenReadWriteClose)}function d(te){return!!(te.capabilities&h.FileReadStream)}function f(te){return l(te)?!!(te.capabilities&h.FileAtomicRead):!1}function b(te){return l(te)?!!(te.capabilities&h.FileAtomicWrite):!1}function S(te){return!!(te.capabilities&h.FileAtomicDelete)}function U(te){return!!(te.capabilities&h.Readonly)}var _;(function(te){te.FileExists="EntryExists",te.FileNotFound="EntryNotFound",te.FileNotADirectory="EntryNotADirectory",te.FileIsADirectory="EntryIsADirectory",te.FileExceedsStorageQuota="EntryExceedsStorageQuota",te.FileTooLarge="EntryTooLarge",te.FileWriteLocked="EntryWriteLocked",te.NoPermissions="NoPermissions",te.Unavailable="Unavailable",te.Unknown="Unknown"})(_||(t.FileSystemProviderErrorCode=_={}));class B extends Error{static create($e,Ae){const Oe=new B($e.toString(),Ae);return z(Oe,Ae),Oe}constructor($e,Ae){super($e),this.code=Ae}}t.$jl=B;function E(te,$e){return B.create(te,$e)}function I(te){return te||E((0,w.localize)(11233,null),_.Unknown)}function z(te,$e){return te.name=$e?`${$e} (FileSystemError)`:"FileSystemError",te}function O(te){if(!te)return _.Unknown;if(te instanceof B)return te.code;const $e=/^(.+) \(FileSystemError\)$/.exec(te.name);if(!$e)return _.Unknown;switch($e[1]){case _.FileExists:return _.FileExists;case _.FileIsADirectory:return _.FileIsADirectory;case _.FileNotADirectory:return _.FileNotADirectory;case _.FileNotFound:return _.FileNotFound;case _.FileTooLarge:return _.FileTooLarge;case _.FileWriteLocked:return _.FileWriteLocked;case _.NoPermissions:return _.NoPermissions;case _.Unavailable:return _.Unavailable}return _.Unknown}function C(te){if(te instanceof ce)return te.fileOperationResult;switch(O(te)){case _.FileNotFound:return Fe.FILE_NOT_FOUND;case _.FileIsADirectory:return Fe.FILE_IS_DIRECTORY;case _.FileNotADirectory:return Fe.FILE_NOT_DIRECTORY;case _.FileWriteLocked:return Fe.FILE_WRITE_LOCKED;case _.NoPermissions:return Fe.FILE_PERMISSION_DENIED;case _.FileExists:return Fe.FILE_MOVE_CONFLICT;case _.FileTooLarge:return Fe.FILE_TOO_LARGE;default:return Fe.FILE_OTHER_ERROR}}var x;(function(te){te[te.CREATE=0]="CREATE",te[te.DELETE=1]="DELETE",te[te.MOVE=2]="MOVE",te[te.COPY=3]="COPY",te[te.WRITE=4]="WRITE"})(x||(t.FileOperation=x={}));class Z{constructor($e,Ae,Oe){this.resource=$e,this.operation=Ae,this.target=Oe}isOperation($e){return this.operation===$e}}t.$pl=Z;var Y;(function(te){te[te.UPDATED=0]="UPDATED",te[te.ADDED=1]="ADDED",te[te.DELETED=2]="DELETED"})(Y||(t.FileChangeType=Y={}));class q{static{this.a=null}constructor($e,Ae){this.c=Ae,this.b=void 0,this.d=new y.$T(()=>{const Oe=i.$Ii.forUris(()=>this.c);return Oe.fill(this.rawAdded.map(Ie=>[Ie,!0])),Oe}),this.f=new y.$T(()=>{const Oe=i.$Ii.forUris(()=>this.c);return Oe.fill(this.rawUpdated.map(Ie=>[Ie,!0])),Oe}),this.g=new y.$T(()=>{const Oe=i.$Ii.forUris(()=>this.c);return Oe.fill(this.rawDeleted.map(Ie=>[Ie,!0])),Oe}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const Oe of $e){switch(Oe.type){case Y.ADDED:this.rawAdded.push(Oe.resource);break;case Y.UPDATED:this.rawUpdated.push(Oe.resource);break;case Y.DELETED:this.rawDeleted.push(Oe.resource);break}this.b!==q.a&&(typeof Oe.cId=="number"?this.b===void 0?this.b=Oe.cId:this.b!==Oe.cId&&(this.b=q.a):this.b!==void 0&&(this.b=q.a))}}contains($e,...Ae){return this.h($e,{includeChildren:!1},...Ae)}affects($e,...Ae){return this.h($e,{includeChildren:!0},...Ae)}h($e,Ae,...Oe){if(!$e)return!1;const Ie=Oe.length>0;return!!((!Ie||Oe.includes(Y.ADDED))&&(this.d.value.get($e)||Ae.includeChildren&&this.d.value.findSuperstr($e))||(!Ie||Oe.includes(Y.UPDATED))&&(this.f.value.get($e)||Ae.includeChildren&&this.f.value.findSuperstr($e))||(!Ie||Oe.includes(Y.DELETED))&&(this.g.value.findSubstr($e)||Ae.includeChildren&&this.g.value.findSuperstr($e)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates($e){return this.b===$e}hasCorrelation(){return typeof this.b=="number"}}t.$ql=q;function ee(te,$e,Ae){return!te||!$e||te===$e||$e.length>te.length?!1:($e.charAt($e.length-1)!==n.sep&&($e+=n.sep),Ae?(0,j.$Ef)(te,$e):te.indexOf($e)===0)}class ce extends Error{constructor($e,Ae,Oe){super($e),this.fileOperationResult=Ae,this.options=Oe}}t.$sl=ce;class be extends ce{constructor($e,Ae,Oe,Ie){super($e,Ae,Ie),this.fileOperationResult=Ae,this.size=Oe}}t.$tl=be;class ke extends ce{constructor($e,Ae,Oe){super($e,Fe.FILE_NOT_MODIFIED_SINCE,Oe),this.stat=Ae}}t.$ul=ke;var Fe;(function(te){te[te.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",te[te.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",te[te.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",te[te.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",te[te.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",te[te.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",te[te.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",te[te.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",te[te.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",te[te.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",te[te.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(Fe||(t.FileOperationResult=Fe={})),t.$vl={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},t.$wl={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},t.$xl="files.associations",t.$yl="files.exclude",t.$zl="files.readonlyInclude",t.$Al="files.readonlyExclude",t.$Bl="files.readonlyFromPermissions";var ue;(function(te){te[te.FILE=0]="FILE",te[te.FOLDER=1]="FOLDER",te[te.ROOT_FOLDER=2]="ROOT_FOLDER"})(ue||(t.FileKind=ue={})),t.$Cl="";function Q(te){if(!(typeof te.size!="number"||typeof te.mtime!="number"))return te.mtime.toString(29)+te.size.toString(31)}async function he(te,$e){if(!$e.hasProvider(N.URI.from({scheme:te.scheme})))return new Promise(Ae=>{const Oe=$e.onDidChangeFileSystemProviderRegistrations(Ie=>{Ie.scheme===te.scheme&&Ie.added&&(Oe.dispose(),Ae())})})}class le{static{this.KB=1024}static{this.MB=le.KB*le.KB}static{this.GB=le.MB*le.KB}static{this.TB=le.GB*le.KB}static formatSize($e){return(0,F.$gg)($e)||($e=0),$e<le.KB?(0,w.localize)(11234,null,$e.toFixed(0)):$e<le.MB?(0,w.localize)(11235,null,($e/le.KB).toFixed(2)):$e<le.GB?(0,w.localize)(11236,null,($e/le.MB).toFixed(2)):$e<le.TB?(0,w.localize)(11237,null,($e/le.GB).toFixed(2)):(0,w.localize)(11238,null,($e/le.TB).toFixed(2))}}t.$Fl=le;function Ne(te){const $e=typeof te=="string"||te?.scheme===p.Schemas.vscodeRemote;return typeof te!="string"&&te?.scheme===p.Schemas.file?1024*le.MB:$e?10*le.MB:c.$p?50*le.MB:1024*le.MB}}),define(we[147],ve([1,0,54]),function(re,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$jhc=t.$ihc=void 0,t.$ihc=(0,i.$Ci)("mainProcessService");class n{constructor(F,N){this.a=F,this.b=N}getChannel(F){return this.a.getChannel(F,this.b)}registerChannel(F,N){this.a.registerChannel(F,N)}}t.$jhc=n}),define(we[148],ve([1,0,2,124]),function(re,t,i,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$khc=void 0;class j extends i.$Tc{constructor(N){super(),this.a=this.B(new n.$RX(`window:${N}`))}getChannel(N){return this.a.getChannel(N)}registerChannel(N,w){this.a.registerChannel(N,w)}}t.$khc=j});var Ii=this&&this.__param||function(re,t){return function(i,n){t(i,n,re)}};define(we[149],ve([1,0,74,147]),function(re,t,i,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$lhc=void 0;let j=class{constructor(N,w){return this.windowId=N,i.ProxyChannel.toService(w.getChannel("nativeHost"),{context:N,properties:(()=>{const D=new Map;return D.set("windowId",N),D})()})}};t.$lhc=j,t.$lhc=j=et([Ii(1,n.$ihc)],j)}),define(we[84],ve([1,0,42,10]),function(re,t,i,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$oo=void 0,i=He(i),n=He(n);class j{constructor(){this.a=new Map}add(N,w){i.ok(n.$cg(N)),i.ok(n.$eg(w)),i.ok(!this.a.has(N),"There is already an extension with this id"),this.a.set(N,w)}knows(N){return this.a.has(N)}as(N){return this.a.get(N)||null}}t.$oo=new j}),define(we[150],ve([1,0,3,91,84]),function(re,t,i,n,j){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$po=void 0,j=He(j),t.$po={JSONContribution:"base.contributions.json"};function F(D){return D.length>0&&D.charAt(D.length-1)==="#"?D.substring(0,D.length-1):D}class N{constructor(){this.b=new i.$je,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(c,p){this.a[F(c)]=p,this.b.fire(c)}notifySchemaChanged(c){this.b.fire(c)}getSchemaContributions(){return{schemas:this.a}}getSchemaContent(c){const p=this.a[c];return p?(0,n.$5j)(p):void 0}hasSchemaContent(c){return!!this.a[c]}}const w=new N;j.$oo.add(t.$po.JSONContribution,w)}),define(we[151],ve([1,0,12,21,48,22,3,10,16,13,150,84]),function(re,t,i,n,j,F,N,w,D,c,p,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Fx=t.$Ex=t.$Dx=t.$Cx=t.$Bx=t.$Ax=t.IconFontDefinition=t.IconContribution=t.$xx=void 0,t.$yx=r,t.$zx=h,y=He(y),t.$xx={IconContribution:"base.contributions.icons"};var $;(function(A){function d(f,b){let S=f.defaults;for(;F.ThemeIcon.isThemeIcon(S);){const U=s.getIcon(S.id);if(!U)return;S=U.defaults}return S}A.getDefinition=d})($||(t.IconContribution=$={}));var g;(function(A){function d(b){return{weight:b.weight,style:b.style,src:b.src.map(S=>({format:S.format,location:S.location.toString()}))}}A.toJSONObject=d;function f(b){const S=U=>(0,w.$cg)(U)?U:void 0;if(b&&Array.isArray(b.src)&&b.src.every(U=>(0,w.$cg)(U.format)&&(0,w.$cg)(U.location)))return{weight:S(b.weight),style:S(b.style),src:b.src.map(U=>({format:U.format,location:D.URI.parse(U.location)}))}}A.fromJSONObject=f})(g||(t.IconFontDefinition=g={}));class e{constructor(){this.a=new N.$je,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,c.localize)(10999,null)},fontCharacter:{type:"string",description:(0,c.localize)(11e3,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${F.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(d,f,b,S){const U=this.b[d];if(U){if(b&&!U.description){U.description=b,this.d.properties[d].markdownDescription=`${b} $(${d})`;const E=this.e.enum.indexOf(d);E!==-1&&(this.e.enumDescriptions[E]=b),this.a.fire()}return U}const _={id:d,description:b,defaults:f,deprecationMessage:S};this.b[d]=_;const B={$ref:"#/definitions/icons"};return S&&(B.deprecationMessage=S),b&&(B.markdownDescription=`${b}: $(${d})`),this.d.properties[d]=B,this.e.enum.push(d),this.e.enumDescriptions.push(b||""),this.a.fire(),{id:d}}deregisterIcon(d){delete this.b[d],delete this.d.properties[d];const f=this.e.enum.indexOf(d);f!==-1&&(this.e.enum.splice(f,1),this.e.enumDescriptions.splice(f,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(d=>this.b[d])}getIcon(d){return this.b[d]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(d,f){const b=this.f[d];return b||(this.f[d]=f,this.a.fire(),f)}deregisterIconFont(d){delete this.f[d]}getIconFont(d){return this.f[d]}toString(){const d=(U,_)=>U.id.localeCompare(_.id),f=U=>{for(;F.ThemeIcon.isThemeIcon(U.defaults);)U=this.b[U.defaults.id];return`codicon codicon-${U?U.id:""}`},b=[];b.push("| preview     | identifier                        | default codicon ID                | description"),b.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const S=Object.keys(this.b).map(U=>this.b[U]);for(const U of S.filter(_=>!!_.description).sort(d))b.push(`|<i class="${f(U)}"></i>|${U.id}|${F.ThemeIcon.isThemeIcon(U.defaults)?U.defaults.id:U.id}|${U.description||""}|`);b.push("| preview     | identifier                        "),b.push("| ----------- | --------------------------------- |");for(const U of S.filter(_=>!F.ThemeIcon.isThemeIcon(_.defaults)).sort(d))b.push(`|<i class="${f(U)}"></i>|${U.id}|`);return b.join(`
`)}}const s=new e;y.$oo.add(t.$xx.IconContribution,s);function r(A,d,f,b){return s.registerIcon(A,d,f,b)}function h(){return s}function l(){const A=(0,j.$Xj)();for(const d in A){const f="\\"+A[d].toString(16);s.registerIcon(d,{fontCharacter:f})}}l(),t.$Ax="vscode://schemas/icons";const v=y.$oo.as(p.$po.JSONContribution);v.registerSchema(t.$Ax,s.getIconSchema());const k=new i.$Oh(()=>v.notifySchemaChanged(t.$Ax),200);s.onDidChange(()=>{k.isScheduled()||k.schedule()}),t.$Bx=r("widget-close",n.$2j.close,(0,c.localize)(11001,null)),t.$Cx=r("goto-previous-location",n.$2j.arrowUp,(0,c.localize)(11002,null)),t.$Dx=r("goto-next-location",n.$2j.arrowDown,(0,c.localize)(11003,null)),t.$Ex=F.ThemeIcon.modify(n.$2j.sync,"spin"),t.$Fx=F.ThemeIcon.modify(n.$2j.loading,"spin")}),define(we[152],ve([1,0,4,3,2,22,151]),function(re,t,i,n,j,F,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$aMb=void 0,t.$_Lb=w;function w(c){const p=new j.$Sc,y=p.add(new n.$je),$=(0,N.$zx)();return p.add($.onDidChange(()=>y.fire())),c&&p.add(c.onDidProductIconThemeChange(()=>y.fire())),{dispose:()=>p.dispose(),onDidChange:y.event,getCSS(){const g=c?c.getProductIconTheme():new D,e={},s=[],r=[];for(const h of $.getIcons()){const l=g.getIcon(h);if(!l)continue;const v=l.font,k=`--vscode-icon-${h.id}-font-family`,A=`--vscode-icon-${h.id}-content`;v?(e[v.id]=v.definition,r.push(`${k}: ${(0,i.$RT)(v.id)};`,`${A}: '${l.fontCharacter}';`),s.push(`.codicon-${h.id}:before { content: '${l.fontCharacter}'; font-family: ${(0,i.$RT)(v.id)}; }`)):(r.push(`${A}: '${l.fontCharacter}'; ${k}: 'codicon';`),s.push(`.codicon-${h.id}:before { content: '${l.fontCharacter}'; }`))}for(const h in e){const l=e[h],v=l.weight?`font-weight: ${l.weight};`:"",k=l.style?`font-style: ${l.style};`:"",A=l.src.map(d=>`${(0,i.$QT)(d.location)} format('${d.format}')`).join(", ");s.push(`@font-face { src: ${A}; font-family: ${(0,i.$RT)(h)};${v}${k} font-display: block; }`)}return s.push(`:root { ${r.join(" ")} }`),s.join(`
`)}}}class D{getIcon(p){const y=(0,N.$zx)();let $=p.defaults;for(;F.ThemeIcon.isThemeIcon($);){const g=y.getIcon($.id);if(!g)return;$=g.defaults}return $}}t.$aMb=D}),define(we[153],ve([1,0,5]),function(re,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$7D=t.CustomTitleBarVisibility=t.TitlebarStyle=t.TitleBarSetting=t.$XD=void 0,t.$YD=n,t.$ZD=j,t.$1D=F,t.$2D=N,t.$3D=w,t.$4D=y,t.$5D=$,t.$6D=g,t.$8D=e,t.$9D=s,t.$0D=r,t.$XD={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function n(h){return typeof h.parentId=="number"}function j(h){return!!h.workspaceUri}function F(h){return!!h.folderUri}function N(h){return!!h.fileUri}function w(h){const l=$(h),v=h.getValue("window.menuBarVisibility");return v==="default"||l&&v==="compact"||i.$k&&i.$n?"classic":v}var D;(function(h){h.TITLE_BAR_STYLE="window.titleBarStyle",h.CUSTOM_TITLE_BAR_VISIBILITY="window.customTitleBarVisibility"})(D||(t.TitleBarSetting=D={}));var c;(function(h){h.NATIVE="native",h.CUSTOM="custom"})(c||(t.TitlebarStyle=c={}));var p;(function(h){h.AUTO="auto",h.WINDOWED="windowed",h.NEVER="never"})(p||(t.CustomTitleBarVisibility=p={}));function y(h,l){return!0}function $(h,l){return l||(l=g(h)),l===c.NATIVE}function g(h){if(i.$p)return c.CUSTOM;const l=h.getValue("window");if(l){if(i.$k&&l.nativeTabs===!0||i.$k&&l.nativeFullScreen===!1)return c.NATIVE;const A=l.titleBarStyle;if(A===c.NATIVE||A===c.CUSTOM)return A}return i.$l?c.NATIVE:c.CUSTOM}t.$7D=35;function e(h){return!(!i.$j||i.$p||$(h))}function s(h){const l=h.getValue("window");return!l||typeof l.nativeFullScreen!="boolean"||l.nativeTabs?!0:l.nativeFullScreen!==!1}function r(h=0){return Math.pow(1.2,h)}}),define(we[154],ve([1,0,18,4,24,40,153]),function(re,t,i,n,j,F,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$nhc=t.$mhc=t.ApplyZoomTarget=void 0,t.$ohc=D,t.$phc=p,t.$qhc=y;var w;(function($){$[$.ACTIVE_WINDOW=1]="ACTIVE_WINDOW",$[$.ALL_WINDOWS=2]="ALL_WINDOWS"})(w||(t.ApplyZoomTarget=w={})),t.$mhc=8,t.$nhc=-8;function D($,g){$=Math.min(Math.max($,t.$nhc),t.$mhc);const e=[];g===w.ACTIVE_WINDOW?e.push((0,n.$0S)()):g===w.ALL_WINDOWS?e.push(...Array.from((0,n.getWindows)()).map(({window:s})=>s)):e.push(g);for(const s of e)c(s)?.webFrame?.setZoomLevel($),(0,i.$5R)((0,N.$0D)($),s),(0,i.$1R)($,s)}function c($){if($===j.$WR)return{ipcRenderer:F.$L,webFrame:F.$N};{const g=$;if(g?.vscode?.ipcRenderer&&g?.vscode?.webFrame)return g.vscode}}function p($){D((0,i.$2R)(typeof $=="number"?(0,n.$0S)():$)+1,$)}function y($){D((0,i.$2R)(typeof $=="number"?(0,n.$0S)():$)-1,$)}}),define(we[155],ve([1,0,13,4,144,12,123,40,145,146,148,149,152,154,15,8,24,138,128]),function(re,t,i,n,j,F,N,w,D,c,p,y,$,g,e,s,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.startup=I;const h=/\s--inspect(?:-brk|port)?=(?<port>\d+)?/,l=/\s--inspect-port=(?<port>\d+)/;class v{getHeight(O){return 22}getTemplateId(O){return _(O)?"process":S(O)?"machine":(0,D.$Rm)(O)?"error":U(O)?"header":""}}class k{hasChildren(O){return(0,D.$Rm)(O)?!1:_(O)?!!O.children?.length:!0}getChildren(O){return _(O)?O.children?O.children:[]:(0,D.$Rm)(O)?[]:U(O)?O.processRoots.length>1?O.processRoots:[O.processRoots[0].rootProcess]:S(O)?[O.rootProcess]:[O.processes]}}class A{constructor(){this.templateId="header"}renderTemplate(O){const C=(0,n.$AT)(O,(0,n.$)(".row")),x=(0,n.$AT)(C,(0,n.$)(".nameLabel")),Z=(0,n.$AT)(C,(0,n.$)(".cpu")),Y=(0,n.$AT)(C,(0,n.$)(".memory")),q=(0,n.$AT)(C,(0,n.$)(".pid"));return{name:x,CPU:Z,memory:Y,PID:q}}renderElement(O,C,x,Z){x.name.textContent=(0,i.localize)(12044,null),x.CPU.textContent=(0,i.localize)(12045,null),x.PID.textContent=(0,i.localize)(12046,null),x.memory.textContent=(0,i.localize)(12047,null)}disposeTemplate(O){}}class d{constructor(){this.templateId="machine"}renderTemplate(O){const C=Object.create(null),x=(0,n.$AT)(O,(0,n.$)(".row"));return C.name=(0,n.$AT)(x,(0,n.$)(".nameLabel")),C}renderElement(O,C,x,Z){x.name.textContent=O.element.name}disposeTemplate(O){}}class f{constructor(){this.templateId="error"}renderTemplate(O){const C=Object.create(null),x=(0,n.$AT)(O,(0,n.$)(".row"));return C.name=(0,n.$AT)(x,(0,n.$)(".nameLabel")),C}renderElement(O,C,x,Z){x.name.textContent=O.element.errorMessage}disposeTemplate(O){}}class b{constructor(O,C,x){this.a=O,this.b=C,this.c=x,this.templateId="process"}renderTemplate(O){const C=(0,n.$AT)(O,(0,n.$)(".row")),x=(0,n.$AT)(C,(0,n.$)(".nameLabel")),Z=(0,n.$AT)(C,(0,n.$)(".cpu")),Y=(0,n.$AT)(C,(0,n.$)(".memory")),q=(0,n.$AT)(C,(0,n.$)(".pid"));return{name:x,CPU:Z,PID:q,memory:Y}}renderElement(O,C,x,Z){const{element:Y}=O,q=Y.pid.toFixed(0);let ee=Y.name;this.c.has(Y.pid)&&(ee=this.c.get(Y.pid)),x.name.textContent=ee,x.name.title=Y.cmd,x.CPU.textContent=Y.load.toFixed(0),x.PID.textContent=q,x.PID.parentElement.id=`pid-${q}`;const ce=this.a==="win32"?Y.mem:this.b*(Y.mem/100);x.memory.textContent=(ce/c.$Fl.MB).toFixed(0)}disposeTemplate(O){}}function S(z){return!!z.name&&!!z.rootProcess}function U(z){return!!z.processRoots}function _(z){return!!z.pid}class B{constructor(O,C){this.f=C,this.b=new Map;const x=new p.$khc(O);this.c=new y.$lhc(O,x),this.k(C.styles),this.g(C),w.$L.on("vscode:pidToNameResponse",(Z,Y)=>{this.b.clear();for(const[q,ee]of Y)this.b.set(q,ee)}),w.$L.on("vscode:listProcessesResponse",async(Z,Y)=>{Y.forEach((q,ee)=>{_(q.rootProcess)&&(q.rootProcess.name=ee===0?`${this.f.applicationName} main`:"remote agent")}),this.d?(this.d.setInput({processes:{processRoots:Y}}),this.d.layout(r.$WR.innerHeight,r.$WR.innerWidth)):await this.h(Y),this.m(0)}),this.a=Date.now(),w.$L.send("vscode:pidToNameRequest"),w.$L.send("vscode:listProcesses")}g(O){r.$WR.document.onkeydown=C=>{const x=O.platform==="darwin"?C.metaKey:C.ctrlKey;x&&C.keyCode===87&&(C.stopPropagation(),C.preventDefault(),w.$L.send("vscode:closeProcessExplorer")),x&&C.keyCode===187&&(0,g.$phc)(r.$WR),x&&C.keyCode===189&&(0,g.$qhc)(r.$WR)}}async h(O){const C=r.$WR.document.getElementById("process-list");if(!C)return;const{totalmem:x}=await this.c.getOSStatistics(),Z=[new b(this.f.platform,x,this.b),new A,new d,new f];this.d=new j.$cX("processExplorer",C,new v,Z,new k,{identityProvider:{getId:Y=>_(Y)?Y.pid.toString():(0,D.$Rm)(Y)?Y.hostName:U(Y)?"processes":S(Y)?Y.name:"header"}}),this.d.setInput({processes:{processRoots:O}}),this.d.layout(r.$WR.innerHeight,r.$WR.innerWidth),this.d.onKeyDown(Y=>{const q=new e.$oS(Y);if(q.keyCode===s.KeyCode.KeyE&&q.altKey){const ee=this.n();Promise.all(ee.map(ce=>this.c.killProcess(ce,"SIGTERM"))).then(()=>this.d?.refresh())}}),this.d.onContextMenu(Y=>{_(Y.element)&&this.l(Y.element,!0)}),C.style.height=`${r.$WR.innerHeight}px`,r.$WR.addEventListener("resize",()=>{C.style.height=`${r.$WR.innerHeight}px`,this.d?.layout(r.$WR.innerHeight,r.$WR.innerWidth)})}i(O){const C=h.exec(O);return C&&C.groups.port!=="0"||O.indexOf("node ")>=0||O.indexOf("node.exe")>=0}j(O){const C={type:"node",request:"attach",name:`process ${O.pid}`};let x=h.exec(O.cmd);x?C.port=Number(x.groups.port):C.processId=String(O.pid),x=l.exec(O.cmd),x&&(C.port=Number(x.groups.port)),w.$L.send("vscode:workbenchCommand",{id:"debug.startFromConfig",from:"processExplorer",args:[C]})}k(O){const C=(0,n.$aT)(),x=[];O.listFocusBackground&&(x.push(`.monaco-list:focus .monaco-list-row.focused { background-color: ${O.listFocusBackground}; }`),x.push(`.monaco-list:focus .monaco-list-row.focused:hover { background-color: ${O.listFocusBackground}; }`)),O.listFocusForeground&&x.push(`.monaco-list:focus .monaco-list-row.focused { color: ${O.listFocusForeground}; }`),O.listActiveSelectionBackground&&(x.push(`.monaco-list:focus .monaco-list-row.selected { background-color: ${O.listActiveSelectionBackground}; }`),x.push(`.monaco-list:focus .monaco-list-row.selected:hover { background-color: ${O.listActiveSelectionBackground}; }`)),O.listActiveSelectionForeground&&x.push(`.monaco-list:focus .monaco-list-row.selected { color: ${O.listActiveSelectionForeground}; }`),O.listHoverBackground&&x.push(`.monaco-list-row:hover:not(.selected):not(.focused) { background-color: ${O.listHoverBackground}; }`),O.listHoverForeground&&x.push(`.monaco-list-row:hover:not(.selected):not(.focused) { color: ${O.listHoverForeground}; }`),O.listFocusOutline&&x.push(`.monaco-list:focus .monaco-list-row.focused { outline: 1px solid ${O.listFocusOutline}; outline-offset: -1px; }`),O.listHoverOutline&&x.push(`.monaco-list-row:hover { outline: 1px dashed ${O.listHoverOutline}; outline-offset: -1px; }`),O.scrollbarShadowColor&&x.push(`
				.monaco-scrollable-element > .shadow.top {
					box-shadow: ${O.scrollbarShadowColor} 0 6px 6px -6px inset;
				}

				.monaco-scrollable-element > .shadow.left {
					box-shadow: ${O.scrollbarShadowColor} 6px 0 6px -6px inset;
				}

				.monaco-scrollable-element > .shadow.top.left {
					box-shadow: ${O.scrollbarShadowColor} 6px 6px 6px -6px inset;
				}
			`),O.scrollbarSliderBackgroundColor&&x.push(`
				.monaco-scrollable-element > .scrollbar > .slider {
					background: ${O.scrollbarSliderBackgroundColor};
				}
			`),O.scrollbarSliderHoverBackgroundColor&&x.push(`
				.monaco-scrollable-element > .scrollbar > .slider:hover {
					background: ${O.scrollbarSliderHoverBackgroundColor};
				}
			`),O.scrollbarSliderActiveBackgroundColor&&x.push(`
				.monaco-scrollable-element > .scrollbar > .slider.active {
					background: ${O.scrollbarSliderActiveBackgroundColor};
				}
			`),C.textContent=x.join(`
`),O.color&&(r.$WR.document.body.style.color=O.color)}l(O,C){const x=[],Z=Number(O.pid);C&&(x.push({accelerator:"Alt+E",label:(0,i.localize)(12048,null),click:()=>{this.c.killProcess(Z,"SIGTERM")}}),x.push({label:(0,i.localize)(12049,null),click:()=>{this.c.killProcess(Z,"SIGKILL")}}),x.push({type:"separator"})),x.push({label:(0,i.localize)(12050,null),click:()=>{const Y=this.n();Y?.includes(Z)||(Y.length=0,Y.push(Z));const q=Y?.map(ee=>r.$WR.document.getElementById(`pid-${ee}`)).filter(ee=>!!ee);if(q){const ee=q.map(ce=>ce.innerText).filter(ce=>!!ce);this.c.writeClipboardText(ee.join(`
`))}}}),x.push({label:(0,i.localize)(12051,null),click:()=>{const Y=r.$WR.document.getElementById("process-list");Y&&this.c.writeClipboardText(Y.innerText)}}),O&&C&&this.i(O.cmd)&&(x.push({type:"separator"}),x.push({label:(0,i.localize)(12052,null),click:()=>{this.j(O)}})),(0,N.$JX)(x)}m(O){setTimeout(()=>{const C=Date.now(),x=O+C-this.a;this.a=C,x>1e3?(w.$L.send("vscode:pidToNameRequest"),w.$L.send("vscode:listProcesses")):this.m(x)},200)}n(){return this.d?.getSelection()?.map(O=>{if(!(!O||!("pid"in O)))return O.pid}).filter(O=>!!O)}}function E(){const z=(0,n.$aT)();z.id="codiconStyles";const O=(0,$.$_Lb)(void 0);function C(){z.textContent=O.getCSS()}const x=new F.$Oh(C,0);O.onDidChange(()=>x.schedule()),x.schedule()}function I(z){const O=z.data.platform==="win32"?"windows":z.data.platform==="linux"?"linux":"mac";r.$WR.document.body.classList.add(O),E(),(0,g.$ohc)(z.data.zoomLevel,r.$WR),new B(z.windowId,z.data)}})}).call(this);

//# sourceMappingURL=https://main.vscode-cdn.net/sourcemaps/8703a11164db333db471576d38ddc143d6ad7ead/core/vs/code/electron-sandbox/processExplorer/processExplorerMain.js.map
