/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ce=["require","exports","vs/base/common/lifecycle","vs/base/common/types","vs/base/common/event","vs/nls","vs/platform/log/common/log","vs/base/common/errors","vs/base/common/async","vs/platform/files/common/files","vs/platform/instantiation/common/instantiation","vs/base/common/uri","vs/base/common/platform","vs/base/common/buffer","vs/base/common/network","vs/base/common/path","vs/base/common/resources","vs/platform/environment/common/environment","vs/platform/telemetry/common/telemetry","vs/base/common/arrays","vs/platform/extensionManagement/common/extensionManagement","vs/base/common/cancellation","vs/platform/extensions/common/extensions","vs/platform/uriIdentity/common/uriIdentity","vs/platform/userDataProfile/common/userDataProfile","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/common/objects","vs/base/common/uuid","vs/base/node/pfs","vs/platform/configuration/common/configuration","vs/base/common/map","vs/base/common/strings","fs","vs/platform/product/common/productService","vs/base/common/json","os","vs/base/common/process","vs/platform/registry/common/platform","vs/base/common/errorMessage","vs/platform/policy/common/policy","vs/platform/configuration/common/configurationRegistry","vs/platform/telemetry/common/telemetryUtils","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/base/common/hash","vs/platform/extensions/common/extensionValidator","vs/base/common/semver/semver","vs/platform/request/common/request","vs/base/common/stream","vs/base/common/marshalling","vs/base/common/ternarySearchTree","vs/base/node/zip","vs/platform/instantiation/common/descriptors","vs/platform/files/common/watcher","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/common/extensionsScannerService","vs/base/common/decorators","vs/base/common/processes","vs/base/common/severity","vs/base/node/processes","vs/base/parts/ipc/common/ipc","child_process","vs/platform/download/common/download","vs/platform/files/common/io","vs/base/common/extpath","vs/platform/instantiation/common/serviceCollection","vs/base/common/iterator","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/remoteHosts","vs/platform/languagePacks/common/languagePacks","vs/platform/state/node/stateService","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/node/extensionSignatureVerificationService","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/storage/common/storage","vs/base/common/amd","vs/base/common/assert","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/jsonSchema","vs/base/common/numbers","vs/base/common/skipList","vs/base/common/console","vs/amdX","vs/base/node/macAddress","vs/base/node/id","vs/base/node/powershell","vs/base/node/shell","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/common/storage","vs/base/common/date","vs/base/common/jsonErrorMessages","vs/platform/contextkey/common/scanner","vs/base/common/charCode","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensions/common/extensionsApiProposals","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/contextkey/common/contextkey","vs/platform/files/node/watcher/baseWatcher","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/base/common/performance","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/logService","vs/platform/log/node/spdlogLog","vs/platform/log/node/loggerService","vs/platform/policy/common/filePolicyService","vs/platform/policy/node/nativePolicyService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/download/common/downloadService","vs/platform/request/node/proxy","url","vs/platform/shell/node/shellEnv","vs/platform/state/node/state","vs/platform/extensionManagement/common/extensionManagementCLI","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/languagePacks/node/languagePacks","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/common/telemetryService","vs/platform/product/common/product","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/telemetry","vs/platform/telemetry/node/telemetryUtils","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/userData/common/fileUserDataProvider","vs/platform/workspace/common/workspace","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/externalServices/common/serviceMachineId","vs/platform/externalServices/common/marketplace","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/userDataProfile/node/userDataProfile","vs/platform/request/node/requestService","vs/base/common/lazy","vs/base/common/marshallingIds","path","vs/base/common/glob","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/base/common/linkedList","vs/platform/environment/node/argvHelper","crypto","https","vs/base/common/stopwatch","zlib","vs/code/node/cliProcessMain","vs/base/node/unc"],le=function(Q){for(var e=[],S=0,P=Q.length;S<P;S++)e[S]=ce[Q[S]];return e};define(ce[74],le([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$S=e.LoaderEventType=e.$R=void 0,e.$R=!1;var S;(function(y){y[y.LoaderAvailable=1]="LoaderAvailable",y[y.BeginLoadingScript=10]="BeginLoadingScript",y[y.EndLoadingScriptOK=11]="EndLoadingScriptOK",y[y.EndLoadingScriptError=12]="EndLoadingScriptError",y[y.BeginInvokeFactory=21]="BeginInvokeFactory",y[y.EndInvokeFactory=22]="EndInvokeFactory",y[y.NodeBeginEvaluatingScript=31]="NodeBeginEvaluatingScript",y[y.NodeEndEvaluatingScript=32]="NodeEndEvaluatingScript",y[y.NodeBeginNativeRequire=33]="NodeBeginNativeRequire",y[y.NodeEndNativeRequire=34]="NodeEndNativeRequire",y[y.CachedDataFound=60]="CachedDataFound",y[y.CachedDataMissed=61]="CachedDataMissed",y[y.CachedDataRejected=62]="CachedDataRejected",y[y.CachedDataCreated=63]="CachedDataCreated"})(S||(e.LoaderEventType=S={}));class P{static get(){const k=new Map,L=new Map,O=new Map,g=new Map;function a($,I){$.has(I.detail)||$.set(I.detail,-I.timestamp)}function d($,I){const b=$.get(I.detail);b&&(b>=0||$.set(I.detail,b+I.timestamp))}let c=[];typeof Q=="function"&&typeof Q.getStats=="function"&&(c=Q.getStats().slice(0).sort(($,I)=>$.timestamp-I.timestamp));for(const $ of c)switch($.type){case S.BeginLoadingScript:a(k,$);break;case S.EndLoadingScriptOK:case S.EndLoadingScriptError:d(k,$);break;case S.BeginInvokeFactory:a(L,$);break;case S.EndInvokeFactory:d(L,$);break;case S.NodeBeginNativeRequire:a(O,$);break;case S.NodeEndNativeRequire:d(O,$);break;case S.NodeBeginEvaluatingScript:a(g,$);break;case S.NodeEndEvaluatingScript:d(g,$);break}let f=0;O.forEach($=>f+=$);function m($){const I=[];return $.forEach((b,h)=>I.push([h,b])),I}return{amdLoad:m(k),amdInvoke:m(L),nodeRequire:m(O),nodeEval:m(g),nodeRequireTotal:f}}static toMarkdownTable(k,L){let O="";const g=[];return k.forEach((a,d)=>{g[d]=a.length}),L.forEach(a=>{a.forEach((d,c)=>{typeof d>"u"&&(d=a[c]="-");const f=d.toString().length;g[c]=Math.max(f,g[c])})}),k.forEach((a,d)=>{O+=`| ${a+" ".repeat(g[d]-a.toString().length)} `}),O+=`|
`,k.forEach((a,d)=>{O+=`| ${"-".repeat(g[d])} `}),O+=`|
`,L.forEach(a=>{a.forEach((d,c)=>{typeof d<"u"&&(O+=`| ${d+" ".repeat(g[c]-d.toString().length)} `)}),O+=`|
`}),O}}e.$S=P}),define(ce[55],le([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7h=P,e.$8h=y,e.$9h=k;function S(L){return(O,g,a)=>{let d=null,c=null;if(typeof a.value=="function"?(d="value",c=a.value):typeof a.get=="function"&&(d="get",c=a.get),!c)throw new Error("not supported");a[d]=L(c,g)}}function P(L,O,g){let a=null,d=null;if(typeof g.value=="function"?(a="value",d=g.value,d.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof g.get=="function"&&(a="get",d=g.get),!d)throw new Error("not supported");const c=`$memoize$${O}`;g[a]=function(...f){return this.hasOwnProperty(c)||Object.defineProperty(this,c,{configurable:!1,enumerable:!1,writable:!1,value:d.apply(this,f)}),this[c]}}function y(L,O,g){return S((a,d)=>{const c=`$debounce$${d}`,f=`$debounce$result$${d}`;return function(...m){this[f]||(this[f]=g?g():void 0),clearTimeout(this[c]),O&&(this[f]=O(this[f],...m),m=[this[f]]),this[c]=setTimeout(()=>{a.apply(this,m),this[f]=g?g():void 0},L)}})}function k(L,O,g){return S((a,d)=>{const c=`$throttle$timer$${d}`,f=`$throttle$result$${d}`,m=`$throttle$lastRun$${d}`,$=`$throttle$pending$${d}`;return function(...I){if(this[f]||(this[f]=g?g():void 0),(this[m]===null||this[m]===void 0)&&(this[m]=-Number.MAX_VALUE),O&&(this[f]=O(this[f],...I)),this[$])return;const b=this[m]+L;b<=Date.now()?(this[m]=Date.now(),a.apply(this,[this[f]]),this[f]=g?g():void 0):(this[$]=!0,this[c]=setTimeout(()=>{this[$]=!1,this[m]=Date.now(),a.apply(this,[this[f]]),this[f]=g?g():void 0},b-Date.now()))}})}}),define(ce[75],le([0,1,7]),function(Q,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=P,e.$dd=y,e.$ed=k,e.$fd=L,e.$gd=O,e.$hd=g;function P(a,d){if(!a)throw new Error(d?`Assertion failed (${d})`:"Assertion Failed")}function y(a,d="Unreachable"){throw new Error(d)}function k(a,d="unexpected state"){if(!a)throw new S.$bb(`Assertion Failed: ${d}`)}function L(a){a||(0,S.$Y)(new S.$bb("Soft Assertion Failed"))}function O(a){if(!a()){debugger;a(),(0,S.$Y)(new S.$bb("Assertion Failed"))}}function g(a,d){let c=0;for(;c<a.length-1;){const f=a[c],m=a[c+1];if(!d(f,m))return!1;c++}return!0}}),define(ce[34],le([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0,e.$Tn=L,e.$Un=c,e.$Vn=f,e.$Wn=m,e.$Xn=$,e.$Yn=I,e.$Zn=b,e.$1n=h,e.$2n=p,e.$3n=R,e.$4n=v;var S;(function(i){i[i.None=0]="None",i[i.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=2]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",i[i.InvalidUnicode=4]="InvalidUnicode",i[i.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",i[i.InvalidCharacter=6]="InvalidCharacter"})(S||(e.ScanError=S={}));var P;(function(i){i[i.OpenBraceToken=1]="OpenBraceToken",i[i.CloseBraceToken=2]="CloseBraceToken",i[i.OpenBracketToken=3]="OpenBracketToken",i[i.CloseBracketToken=4]="CloseBracketToken",i[i.CommaToken=5]="CommaToken",i[i.ColonToken=6]="ColonToken",i[i.NullKeyword=7]="NullKeyword",i[i.TrueKeyword=8]="TrueKeyword",i[i.FalseKeyword=9]="FalseKeyword",i[i.StringLiteral=10]="StringLiteral",i[i.NumericLiteral=11]="NumericLiteral",i[i.LineCommentTrivia=12]="LineCommentTrivia",i[i.BlockCommentTrivia=13]="BlockCommentTrivia",i[i.LineBreakTrivia=14]="LineBreakTrivia",i[i.Trivia=15]="Trivia",i[i.Unknown=16]="Unknown",i[i.EOF=17]="EOF"})(P||(e.SyntaxKind=P={}));var y;(function(i){i[i.InvalidSymbol=1]="InvalidSymbol",i[i.InvalidNumberFormat=2]="InvalidNumberFormat",i[i.PropertyNameExpected=3]="PropertyNameExpected",i[i.ValueExpected=4]="ValueExpected",i[i.ColonExpected=5]="ColonExpected",i[i.CommaExpected=6]="CommaExpected",i[i.CloseBraceExpected=7]="CloseBraceExpected",i[i.CloseBracketExpected=8]="CloseBracketExpected",i[i.EndOfFileExpected=9]="EndOfFileExpected",i[i.InvalidCommentToken=10]="InvalidCommentToken",i[i.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=12]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",i[i.InvalidUnicode=14]="InvalidUnicode",i[i.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",i[i.InvalidCharacter=16]="InvalidCharacter"})(y||(e.ParseErrorCode=y={}));var k;(function(i){i.DEFAULT={allowTrailingComma:!0}})(k||(e.ParseOptions=k={}));function L(i,l=!1){let n=0;const r=i.length;let t="",s=0,o=P.Unknown,u=S.None;function w(K){let re=0,ae=0;for(;re<K;){const ue=i.charCodeAt(n);if(ue>=d._0&&ue<=d._9)ae=ae*16+ue-d._0;else if(ue>=d.A&&ue<=d.F)ae=ae*16+ue-d.A+10;else if(ue>=d.a&&ue<=d.f)ae=ae*16+ue-d.a+10;else break;n++,re++}return re<K&&(ae=-1),ae}function A(K){n=K,t="",s=0,o=P.Unknown,u=S.None}function T(){const K=n;if(i.charCodeAt(n)===d._0)n++;else for(n++;n<i.length&&a(i.charCodeAt(n));)n++;if(n<i.length&&i.charCodeAt(n)===d.dot)if(n++,n<i.length&&a(i.charCodeAt(n)))for(n++;n<i.length&&a(i.charCodeAt(n));)n++;else return u=S.UnexpectedEndOfNumber,i.substring(K,n);let re=n;if(n<i.length&&(i.charCodeAt(n)===d.E||i.charCodeAt(n)===d.e))if(n++,(n<i.length&&i.charCodeAt(n)===d.plus||i.charCodeAt(n)===d.minus)&&n++,n<i.length&&a(i.charCodeAt(n))){for(n++;n<i.length&&a(i.charCodeAt(n));)n++;re=n}else u=S.UnexpectedEndOfNumber;return i.substring(K,re)}function D(){let K="",re=n;for(;;){if(n>=r){K+=i.substring(re,n),u=S.UnexpectedEndOfString;break}const ae=i.charCodeAt(n);if(ae===d.doubleQuote){K+=i.substring(re,n),n++;break}if(ae===d.backslash){if(K+=i.substring(re,n),n++,n>=r){u=S.UnexpectedEndOfString;break}switch(i.charCodeAt(n++)){case d.doubleQuote:K+='"';break;case d.backslash:K+="\\";break;case d.slash:K+="/";break;case d.b:K+="\b";break;case d.f:K+="\f";break;case d.n:K+=`
`;break;case d.r:K+="\r";break;case d.t:K+="	";break;case d.u:{const de=w(4);de>=0?K+=String.fromCharCode(de):u=S.InvalidUnicode;break}default:u=S.InvalidEscapeCharacter}re=n;continue}if(ae>=0&&ae<=31)if(g(ae)){K+=i.substring(re,n),u=S.UnexpectedEndOfString;break}else u=S.InvalidCharacter;n++}return K}function N(){if(t="",u=S.None,s=n,n>=r)return s=r,o=P.EOF;let K=i.charCodeAt(n);if(O(K)){do n++,t+=String.fromCharCode(K),K=i.charCodeAt(n);while(O(K));return o=P.Trivia}if(g(K))return n++,t+=String.fromCharCode(K),K===d.carriageReturn&&i.charCodeAt(n)===d.lineFeed&&(n++,t+=`
`),o=P.LineBreakTrivia;switch(K){case d.openBrace:return n++,o=P.OpenBraceToken;case d.closeBrace:return n++,o=P.CloseBraceToken;case d.openBracket:return n++,o=P.OpenBracketToken;case d.closeBracket:return n++,o=P.CloseBracketToken;case d.colon:return n++,o=P.ColonToken;case d.comma:return n++,o=P.CommaToken;case d.doubleQuote:return n++,t=D(),o=P.StringLiteral;case d.slash:{const re=n-1;if(i.charCodeAt(n+1)===d.slash){for(n+=2;n<r&&!g(i.charCodeAt(n));)n++;return t=i.substring(re,n),o=P.LineCommentTrivia}if(i.charCodeAt(n+1)===d.asterisk){n+=2;const ae=r-1;let ue=!1;for(;n<ae;){if(i.charCodeAt(n)===d.asterisk&&i.charCodeAt(n+1)===d.slash){n+=2,ue=!0;break}n++}return ue||(n++,u=S.UnexpectedEndOfComment),t=i.substring(re,n),o=P.BlockCommentTrivia}return t+=String.fromCharCode(K),n++,o=P.Unknown}case d.minus:if(t+=String.fromCharCode(K),n++,n===r||!a(i.charCodeAt(n)))return o=P.Unknown;case d._0:case d._1:case d._2:case d._3:case d._4:case d._5:case d._6:case d._7:case d._8:case d._9:return t+=T(),o=P.NumericLiteral;default:for(;n<r&&M(K);)n++,K=i.charCodeAt(n);if(s!==n){switch(t=i.substring(s,n),t){case"true":return o=P.TrueKeyword;case"false":return o=P.FalseKeyword;case"null":return o=P.NullKeyword}return o=P.Unknown}return t+=String.fromCharCode(K),n++,o=P.Unknown}}function M(K){if(O(K)||g(K))return!1;switch(K){case d.closeBrace:case d.closeBracket:case d.openBrace:case d.openBracket:case d.doubleQuote:case d.colon:case d.comma:case d.slash:return!1}return!0}function Y(){let K;do K=N();while(K>=P.LineCommentTrivia&&K<=P.Trivia);return K}return{setPosition:A,getPosition:()=>n,scan:l?Y:N,getToken:()=>o,getTokenValue:()=>t,getTokenOffset:()=>s,getTokenLength:()=>n-s,getTokenError:()=>u}}function O(i){return i===d.space||i===d.tab||i===d.verticalTab||i===d.formFeed||i===d.nonBreakingSpace||i===d.ogham||i>=d.enQuad&&i<=d.zeroWidthSpace||i===d.narrowNoBreakSpace||i===d.mathematicalSpace||i===d.ideographicSpace||i===d.byteOrderMark}function g(i){return i===d.lineFeed||i===d.carriageReturn||i===d.lineSeparator||i===d.paragraphSeparator}function a(i){return i>=d._0&&i<=d._9}var d;(function(i){i[i.nullCharacter=0]="nullCharacter",i[i.maxAsciiCharacter=127]="maxAsciiCharacter",i[i.lineFeed=10]="lineFeed",i[i.carriageReturn=13]="carriageReturn",i[i.lineSeparator=8232]="lineSeparator",i[i.paragraphSeparator=8233]="paragraphSeparator",i[i.nextLine=133]="nextLine",i[i.space=32]="space",i[i.nonBreakingSpace=160]="nonBreakingSpace",i[i.enQuad=8192]="enQuad",i[i.emQuad=8193]="emQuad",i[i.enSpace=8194]="enSpace",i[i.emSpace=8195]="emSpace",i[i.threePerEmSpace=8196]="threePerEmSpace",i[i.fourPerEmSpace=8197]="fourPerEmSpace",i[i.sixPerEmSpace=8198]="sixPerEmSpace",i[i.figureSpace=8199]="figureSpace",i[i.punctuationSpace=8200]="punctuationSpace",i[i.thinSpace=8201]="thinSpace",i[i.hairSpace=8202]="hairSpace",i[i.zeroWidthSpace=8203]="zeroWidthSpace",i[i.narrowNoBreakSpace=8239]="narrowNoBreakSpace",i[i.ideographicSpace=12288]="ideographicSpace",i[i.mathematicalSpace=8287]="mathematicalSpace",i[i.ogham=5760]="ogham",i[i._=95]="_",i[i.$=36]="$",i[i._0=48]="_0",i[i._1=49]="_1",i[i._2=50]="_2",i[i._3=51]="_3",i[i._4=52]="_4",i[i._5=53]="_5",i[i._6=54]="_6",i[i._7=55]="_7",i[i._8=56]="_8",i[i._9=57]="_9",i[i.a=97]="a",i[i.b=98]="b",i[i.c=99]="c",i[i.d=100]="d",i[i.e=101]="e",i[i.f=102]="f",i[i.g=103]="g",i[i.h=104]="h",i[i.i=105]="i",i[i.j=106]="j",i[i.k=107]="k",i[i.l=108]="l",i[i.m=109]="m",i[i.n=110]="n",i[i.o=111]="o",i[i.p=112]="p",i[i.q=113]="q",i[i.r=114]="r",i[i.s=115]="s",i[i.t=116]="t",i[i.u=117]="u",i[i.v=118]="v",i[i.w=119]="w",i[i.x=120]="x",i[i.y=121]="y",i[i.z=122]="z",i[i.A=65]="A",i[i.B=66]="B",i[i.C=67]="C",i[i.D=68]="D",i[i.E=69]="E",i[i.F=70]="F",i[i.G=71]="G",i[i.H=72]="H",i[i.I=73]="I",i[i.J=74]="J",i[i.K=75]="K",i[i.L=76]="L",i[i.M=77]="M",i[i.N=78]="N",i[i.O=79]="O",i[i.P=80]="P",i[i.Q=81]="Q",i[i.R=82]="R",i[i.S=83]="S",i[i.T=84]="T",i[i.U=85]="U",i[i.V=86]="V",i[i.W=87]="W",i[i.X=88]="X",i[i.Y=89]="Y",i[i.Z=90]="Z",i[i.ampersand=38]="ampersand",i[i.asterisk=42]="asterisk",i[i.at=64]="at",i[i.backslash=92]="backslash",i[i.bar=124]="bar",i[i.caret=94]="caret",i[i.closeBrace=125]="closeBrace",i[i.closeBracket=93]="closeBracket",i[i.closeParen=41]="closeParen",i[i.colon=58]="colon",i[i.comma=44]="comma",i[i.dot=46]="dot",i[i.doubleQuote=34]="doubleQuote",i[i.equals=61]="equals",i[i.exclamation=33]="exclamation",i[i.greaterThan=62]="greaterThan",i[i.lessThan=60]="lessThan",i[i.minus=45]="minus",i[i.openBrace=123]="openBrace",i[i.openBracket=91]="openBracket",i[i.openParen=40]="openParen",i[i.percent=37]="percent",i[i.plus=43]="plus",i[i.question=63]="question",i[i.semicolon=59]="semicolon",i[i.singleQuote=39]="singleQuote",i[i.slash=47]="slash",i[i.tilde=126]="tilde",i[i.backspace=8]="backspace",i[i.formFeed=12]="formFeed",i[i.byteOrderMark=65279]="byteOrderMark",i[i.tab=9]="tab",i[i.verticalTab=11]="verticalTab"})(d||(d={}));function c(i,l){const n=[],r=new Object;let t;const s={value:{},offset:0,length:0,type:"object",parent:void 0};let o=!1;function u(w,A,T,D){s.value=w,s.offset=A,s.length=T,s.type=D,s.colonOffset=void 0,t=s}try{R(i,{onObjectBegin:(w,A)=>{if(l<=w)throw r;t=void 0,o=l>w,n.push("")},onObjectProperty:(w,A,T)=>{if(l<A||(u(w,A,T,"property"),n[n.length-1]=w,l<=A+T))throw r},onObjectEnd:(w,A)=>{if(l<=w)throw r;t=void 0,n.pop()},onArrayBegin:(w,A)=>{if(l<=w)throw r;t=void 0,n.push(0)},onArrayEnd:(w,A)=>{if(l<=w)throw r;t=void 0,n.pop()},onLiteralValue:(w,A,T)=>{if(l<A||(u(w,A,T,v(w)),l<=A+T))throw r},onSeparator:(w,A,T)=>{if(l<=A)throw r;if(w===":"&&t&&t.type==="property")t.colonOffset=A,o=!1,t=void 0;else if(w===","){const D=n[n.length-1];typeof D=="number"?n[n.length-1]=D+1:(o=!0,n[n.length-1]=""),t=void 0}}})}catch(w){if(w!==r)throw w}return{path:n,previousNode:t,isAtPropertyKey:o,matches:w=>{let A=0;for(let T=0;A<w.length&&T<n.length;T++)if(w[A]===n[T]||w[A]==="*")A++;else if(w[A]!=="**")return!1;return A===w.length}}}function f(i,l=[],n=k.DEFAULT){let r=null,t=[];const s=[];function o(w){Array.isArray(t)?t.push(w):r!==null&&(t[r]=w)}return R(i,{onObjectBegin:()=>{const w={};o(w),s.push(t),t=w,r=null},onObjectProperty:w=>{r=w},onObjectEnd:()=>{t=s.pop()},onArrayBegin:()=>{const w=[];o(w),s.push(t),t=w,r=null},onArrayEnd:()=>{t=s.pop()},onLiteralValue:o,onError:(w,A,T)=>{l.push({error:w,offset:A,length:T})}},n),t[0]}function m(i,l=[],n=k.DEFAULT){let r={type:"array",offset:-1,length:-1,children:[],parent:void 0};function t(w){r.type==="property"&&(r.length=w-r.offset,r=r.parent)}function s(w){return r.children.push(w),w}R(i,{onObjectBegin:w=>{r=s({type:"object",offset:w,length:-1,parent:r,children:[]})},onObjectProperty:(w,A,T)=>{r=s({type:"property",offset:A,length:-1,parent:r,children:[]}),r.children.push({type:"string",value:w,offset:A,length:T,parent:r})},onObjectEnd:(w,A)=>{r.length=w+A-r.offset,r=r.parent,t(w+A)},onArrayBegin:(w,A)=>{r=s({type:"array",offset:w,length:-1,parent:r,children:[]})},onArrayEnd:(w,A)=>{r.length=w+A-r.offset,r=r.parent,t(w+A)},onLiteralValue:(w,A,T)=>{s({type:v(w),offset:A,length:T,parent:r,value:w}),t(A+T)},onSeparator:(w,A,T)=>{r.type==="property"&&(w===":"?r.colonOffset=A:w===","&&t(A))},onError:(w,A,T)=>{l.push({error:w,offset:A,length:T})}},n);const u=r.children[0];return u&&delete u.parent,u}function $(i,l){if(!i)return;let n=i;for(const r of l)if(typeof r=="string"){if(n.type!=="object"||!Array.isArray(n.children))return;let t=!1;for(const s of n.children)if(Array.isArray(s.children)&&s.children[0].value===r){n=s.children[1],t=!0;break}if(!t)return}else{const t=r;if(n.type!=="array"||t<0||!Array.isArray(n.children)||t>=n.children.length)return;n=n.children[t]}return n}function I(i){if(!i.parent||!i.parent.children)return[];const l=I(i.parent);if(i.parent.type==="property"){const n=i.parent.children[0].value;l.push(n)}else if(i.parent.type==="array"){const n=i.parent.children.indexOf(i);n!==-1&&l.push(n)}return l}function b(i){switch(i.type){case"array":return i.children.map(b);case"object":{const l=Object.create(null);for(const n of i.children){const r=n.children[1];r&&(l[n.children[0].value]=b(r))}return l}case"null":case"string":case"number":case"boolean":return i.value;default:return}}function h(i,l,n=!1){return l>=i.offset&&l<i.offset+i.length||n&&l===i.offset+i.length}function p(i,l,n=!1){if(h(i,l,n)){const r=i.children;if(Array.isArray(r))for(let t=0;t<r.length&&r[t].offset<=l;t++){const s=p(r[t],l,n);if(s)return s}return i}}function R(i,l,n=k.DEFAULT){const r=L(i,!1);function t(X){return X?()=>X(r.getTokenOffset(),r.getTokenLength()):()=>!0}function s(X){return X?ee=>X(ee,r.getTokenOffset(),r.getTokenLength()):()=>!0}const o=t(l.onObjectBegin),u=s(l.onObjectProperty),w=t(l.onObjectEnd),A=t(l.onArrayBegin),T=t(l.onArrayEnd),D=s(l.onLiteralValue),N=s(l.onSeparator),M=t(l.onComment),Y=s(l.onError),K=n&&n.disallowComments,re=n&&n.allowTrailingComma;function ae(){for(;;){const X=r.scan();switch(r.getTokenError()){case S.InvalidUnicode:ue(y.InvalidUnicode);break;case S.InvalidEscapeCharacter:ue(y.InvalidEscapeCharacter);break;case S.UnexpectedEndOfNumber:ue(y.UnexpectedEndOfNumber);break;case S.UnexpectedEndOfComment:K||ue(y.UnexpectedEndOfComment);break;case S.UnexpectedEndOfString:ue(y.UnexpectedEndOfString);break;case S.InvalidCharacter:ue(y.InvalidCharacter);break}switch(X){case P.LineCommentTrivia:case P.BlockCommentTrivia:K?ue(y.InvalidCommentToken):M();break;case P.Unknown:ue(y.InvalidSymbol);break;case P.Trivia:case P.LineBreakTrivia:break;default:return X}}}function ue(X,ee=[],ie=[]){if(Y(X),ee.length+ie.length>0){let j=r.getToken();for(;j!==P.EOF;){if(ee.indexOf(j)!==-1){ae();break}else if(ie.indexOf(j)!==-1)break;j=ae()}}}function de(X){const ee=r.getTokenValue();return X?D(ee):u(ee),ae(),!0}function H(){switch(r.getToken()){case P.NumericLiteral:{let X=0;try{X=JSON.parse(r.getTokenValue()),typeof X!="number"&&(ue(y.InvalidNumberFormat),X=0)}catch{ue(y.InvalidNumberFormat)}D(X);break}case P.NullKeyword:D(null);break;case P.TrueKeyword:D(!0);break;case P.FalseKeyword:D(!1);break;default:return!1}return ae(),!0}function Z(){return r.getToken()!==P.StringLiteral?(ue(y.PropertyNameExpected,[],[P.CloseBraceToken,P.CommaToken]),!1):(de(!1),r.getToken()===P.ColonToken?(N(":"),ae(),x()||ue(y.ValueExpected,[],[P.CloseBraceToken,P.CommaToken])):ue(y.ColonExpected,[],[P.CloseBraceToken,P.CommaToken]),!0)}function B(){o(),ae();let X=!1;for(;r.getToken()!==P.CloseBraceToken&&r.getToken()!==P.EOF;){if(r.getToken()===P.CommaToken){if(X||ue(y.ValueExpected,[],[]),N(","),ae(),r.getToken()===P.CloseBraceToken&&re)break}else X&&ue(y.CommaExpected,[],[]);Z()||ue(y.ValueExpected,[],[P.CloseBraceToken,P.CommaToken]),X=!0}return w(),r.getToken()!==P.CloseBraceToken?ue(y.CloseBraceExpected,[P.CloseBraceToken],[]):ae(),!0}function z(){A(),ae();let X=!1;for(;r.getToken()!==P.CloseBracketToken&&r.getToken()!==P.EOF;){if(r.getToken()===P.CommaToken){if(X||ue(y.ValueExpected,[],[]),N(","),ae(),r.getToken()===P.CloseBracketToken&&re)break}else X&&ue(y.CommaExpected,[],[]);x()||ue(y.ValueExpected,[],[P.CloseBracketToken,P.CommaToken]),X=!0}return T(),r.getToken()!==P.CloseBracketToken?ue(y.CloseBracketExpected,[P.CloseBracketToken],[]):ae(),!0}function x(){switch(r.getToken()){case P.OpenBracketToken:return z();case P.OpenBraceToken:return B();case P.StringLiteral:return de(!0);default:return H()}}return ae(),r.getToken()===P.EOF?n.allowEmptyContent?!0:(ue(y.ValueExpected,[],[]),!1):x()?(r.getToken()!==P.EOF&&ue(y.EndOfFileExpected,[],[]),!0):(ue(y.ValueExpected,[],[]),!1)}function v(i){switch(typeof i){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(i){if(Array.isArray(i))return"array"}else return"null";return"object"}default:return"null"}}}),define(ce[76],le([0,1,34]),function(Q,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5n=P,e.$6n=y,e.$7n=O,e.$8n=g;function P(a,d,c){let f,m,$,I,b;if(d){for(I=d.offset,b=I+d.length,$=I;$>0&&!g(a,$-1);)$--;let u=b;for(;u<a.length&&!g(a,u);)u++;m=a.substring($,u),f=L(m,c)}else m=a,f=0,$=0,I=0,b=a.length;const h=O(c,a);let p=!1,R=0,v;c.insertSpaces?v=k(" ",c.tabSize||4):v="	";const i=(0,S.$Tn)(m,!1);let l=!1;function n(){return h+k(v,f+R)}function r(){let u=i.scan();for(p=!1;u===S.SyntaxKind.Trivia||u===S.SyntaxKind.LineBreakTrivia;)p=p||u===S.SyntaxKind.LineBreakTrivia,u=i.scan();return l=u===S.SyntaxKind.Unknown||i.getTokenError()!==S.ScanError.None,u}const t=[];function s(u,w,A){!l&&w<b&&A>I&&a.substring(w,A)!==u&&t.push({offset:w,length:A-w,content:u})}let o=r();if(o!==S.SyntaxKind.EOF){const u=i.getTokenOffset()+$,w=k(v,f);s(w,$,u)}for(;o!==S.SyntaxKind.EOF;){let u=i.getTokenOffset()+i.getTokenLength()+$,w=r(),A="";for(;!p&&(w===S.SyntaxKind.LineCommentTrivia||w===S.SyntaxKind.BlockCommentTrivia);){const D=i.getTokenOffset()+$;s(" ",u,D),u=i.getTokenOffset()+i.getTokenLength()+$,A=w===S.SyntaxKind.LineCommentTrivia?n():"",w=r()}if(w===S.SyntaxKind.CloseBraceToken)o!==S.SyntaxKind.OpenBraceToken&&(R--,A=n());else if(w===S.SyntaxKind.CloseBracketToken)o!==S.SyntaxKind.OpenBracketToken&&(R--,A=n());else{switch(o){case S.SyntaxKind.OpenBracketToken:case S.SyntaxKind.OpenBraceToken:R++,A=n();break;case S.SyntaxKind.CommaToken:case S.SyntaxKind.LineCommentTrivia:A=n();break;case S.SyntaxKind.BlockCommentTrivia:p?A=n():A=" ";break;case S.SyntaxKind.ColonToken:A=" ";break;case S.SyntaxKind.StringLiteral:if(w===S.SyntaxKind.ColonToken){A="";break}case S.SyntaxKind.NullKeyword:case S.SyntaxKind.TrueKeyword:case S.SyntaxKind.FalseKeyword:case S.SyntaxKind.NumericLiteral:case S.SyntaxKind.CloseBraceToken:case S.SyntaxKind.CloseBracketToken:w===S.SyntaxKind.LineCommentTrivia||w===S.SyntaxKind.BlockCommentTrivia?A=" ":w!==S.SyntaxKind.CommaToken&&w!==S.SyntaxKind.EOF&&(l=!0);break;case S.SyntaxKind.Unknown:l=!0;break}p&&(w===S.SyntaxKind.LineCommentTrivia||w===S.SyntaxKind.BlockCommentTrivia)&&(A=n())}const T=i.getTokenOffset()+$;s(A,u,T),o=w}return t}function y(a,d){const c=JSON.stringify(a,void 0,d.insertSpaces?d.tabSize||4:"	");return d.eol!==void 0?c.replace(/\r\n|\r|\n/g,d.eol):c}function k(a,d){let c="";for(let f=0;f<d;f++)c+=a;return c}function L(a,d){let c=0,f=0;const m=d.tabSize||4;for(;c<a.length;){const $=a.charAt(c);if($===" ")f++;else if($==="	")f+=m;else break;c++}return Math.floor(f/m)}function O(a,d){for(let c=0;c<d.length;c++){const f=d.charAt(c);if(f==="\r")return c+1<d.length&&d.charAt(c+1)===`
`?`\r
`:"\r";if(f===`
`)return`
`}return a&&a.eol||`
`}function g(a,d){return`\r
`.indexOf(a.charAt(d))!==-1}}),define(ce[77],le([0,1,34,76]),function(Q,e,S,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9n=y,e.$0n=k,e.$$n=L,e.$_n=O,e.$ao=g;function y(a,d,c){return k(a,d,void 0,c)}function k(a,d,c,f,m){const $=d.slice(),I=[],b=(0,S.$Wn)(a,I);let h,p;for(;$.length>0&&(p=$.pop(),h=(0,S.$Xn)(b,$),h===void 0&&c!==void 0);)typeof p=="string"?c={[p]:c}:c=[c];if(h)if(h.type==="object"&&typeof p=="string"&&Array.isArray(h.children)){const R=(0,S.$Xn)(h,[p]);if(R!==void 0)if(c===void 0){if(!R.parent)throw new Error("Malformed AST");const v=h.children.indexOf(R.parent);let i,l=R.parent.offset+R.parent.length;if(v>0){const n=h.children[v-1];i=n.offset+n.length}else i=h.offset+1,h.children.length>1&&(l=h.children[1].offset);return L(a,{offset:i,length:l-i,content:""},f)}else return L(a,{offset:R.offset,length:R.length,content:JSON.stringify(c)},f);else{if(c===void 0)return[];const v=`${JSON.stringify(p)}: ${JSON.stringify(c)}`,i=m?m(h.children.map(n=>n.children[0].value)):h.children.length;let l;if(i>0){const n=h.children[i-1];l={offset:n.offset+n.length,length:0,content:","+v}}else h.children.length===0?l={offset:h.offset+1,length:0,content:v}:l={offset:h.offset+1,length:0,content:v+","};return L(a,l,f)}}else if(h.type==="array"&&typeof p=="number"&&Array.isArray(h.children))if(c!==void 0){const R=`${JSON.stringify(c)}`;let v;if(h.children.length===0||p===0)v={offset:h.offset+1,length:0,content:h.children.length===0?R:R+","};else{const i=p===-1||p>h.children.length?h.children.length:p,l=h.children[i-1];v={offset:l.offset+l.length,length:0,content:","+R}}return L(a,v,f)}else{const R=p,v=h.children[R];let i;if(h.children.length===1)i={offset:h.offset+1,length:h.length-2,content:""};else if(h.children.length-1===R){const l=h.children[R-1],n=l.offset+l.length,r=h.offset+h.length;i={offset:n,length:r-2-n,content:""}}else i={offset:v.offset,length:h.children[R+1].offset-v.offset,content:""};return L(a,i,f)}else throw new Error(`Can not add ${typeof p!="number"?"index":"property"} to parent of type ${h.type}`);else return c===void 0?[]:L(a,{offset:b?b.offset:0,length:b?b.length:0,content:JSON.stringify(c)},f)}function L(a,d,c){let f=O(a,d),m=d.offset,$=d.offset+d.content.length;if(d.length===0||d.content.length===0){for(;m>0&&!(0,P.$8n)(f,m-1);)m--;for(;$<f.length&&!(0,P.$8n)(f,$);)$++}const I=(0,P.$5n)(f,{offset:m,length:$-m},c);for(let h=I.length-1;h>=0;h--){const p=I[h];f=O(f,p),m=Math.min(m,p.offset),$=Math.max($,p.offset+p.length),$+=p.content.length-p.length}const b=a.length-(f.length-$)-m;return[{offset:m,length:b,content:f.substring(m,$)}]}function O(a,d){return a.substring(0,d.offset)+d.content+a.substring(d.offset+d.length)}function g(a,d){const c=d.slice(0).sort((m,$)=>{const I=m.offset-$.offset;return I===0?m.length-$.length:I});let f=a.length;for(let m=c.length-1;m>=0;m--){const $=c[m];if($.offset+$.length<=f)a=O(a,$);else throw new Error("Overlapping edit");f=$.offset}return a}}),define(ce[78],le([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5j=S;function S(k){let L=!1;const O=new Map,g=new Map;if(y(k,I=>{if(k===I)return!0;const b=JSON.stringify(I);if(b.length<30)return!0;const h=O.get(b);if(!h){const p={schemas:[I]};return O.set(b,p),g.set(I,p),!0}return h.schemas.push(I),g.set(I,h),L=!0,!1}),O.clear(),!L)return JSON.stringify(k);let d="$defs";for(;k.hasOwnProperty(d);)d+="_";const c=[];function f(I){return JSON.stringify(I,(b,h)=>{if(h!==I){const p=g.get(h);if(p&&p.schemas.length>1)return p.id||(p.id=`_${c.length}`,c.push(p.schemas[0])),{$ref:`#/${d}/${p.id}`}}return h})}const m=f(k),$=[];for(let I=0;I<c.length;I++)$.push(`"_${I}":${f(c[I])}`);return $.length?`${m.substring(0,m.length-1)},"${d}":{${$.join(",")}}}`:m}function P(k){return typeof k=="object"&&k!==null}function y(k,L){if(!k||typeof k!="object")return;const O=(...m)=>{for(const $ of m)P($)&&c.push($)},g=(...m)=>{for(const $ of m)if(P($))for(const I in $){const b=$[I];P(b)&&c.push(b)}},a=(...m)=>{for(const $ of m)if(Array.isArray($))for(const I of $)P(I)&&c.push(I)},d=m=>{if(Array.isArray(m))for(const $ of m)P($)&&c.push($);else P(m)&&c.push(m)},c=[k];let f=c.pop();for(;f;)L(f)&&(O(f.additionalItems,f.additionalProperties,f.not,f.contains,f.propertyNames,f.if,f.then,f.else,f.unevaluatedItems,f.unevaluatedProperties),g(f.definitions,f.$defs,f.properties,f.patternProperties,f.dependencies,f.dependentSchemas),a(f.anyOf,f.allOf,f.oneOf,f.prefixItems),d(f.items)),f=c.pop()}}),define(ce[79],le([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mm=e.$Lm=e.$Km=void 0,e.$Im=S,e.rot=P,e.$Nm=O;function S(g,a,d){return Math.min(Math.max(g,a),d)}function P(g,a){return(a+g%a)%a}class y{constructor(){this.a=0}getNext(){return this.a++}}e.$Km=y;class k{constructor(){this.a=1,this.b=0}update(a){return this.b=this.b+(a-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$Lm=k;class L{constructor(a){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(a),this.c.fill(0,0,a)}update(a){const d=this.c[this.d];return this.c[this.d]=a,this.d=(this.d+1)%this.c.length,this.e-=d,this.e+=a,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$Mm=L;function O(g,a,d,c,f,m,$,I){const b=$-d,h=I-c,p=f-d,R=m-c,v=g-d,i=a-c,l=b*b+h*h,n=b*p+h*R,r=b*v+h*i,t=p*p+R*R,s=p*v+R*i,o=1/(l*t-n*n),u=(t*r-n*s)*o,w=(l*s-n*r)*o;return u>=0&&w>=0&&u+w<1}}),function(){function Q(y){const k=[];typeof y=="number"&&k.push("code/timeOrigin",y);function L(g){k.push(g,Date.now())}function O(){const g=[];for(let a=0;a<k.length;a+=2)g.push({name:k[a],startTime:k[a+1]});return g}return{mark:L,getMarks:O}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?Q():{mark(y){performance.mark(y)},getMarks(){let y=performance.timeOrigin;typeof y!="number"&&(y=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const k=[{name:"code/timeOrigin",startTime:Math.round(y)}];for(const L of performance.getEntriesByType("mark"))k.push({name:L.name,startTime:Math.round(y+L.startTime)});return k}};if(typeof process=="object"){const y=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return Q(y)}else return console.trace("perf-util loaded in UNKNOWN environment"),Q()}function S(y){return y.MonacoPerformanceMarks||(y.MonacoPerformanceMarks=e()),y.MonacoPerformanceMarks}var P;typeof global=="object"?P=global:typeof self=="object"?P=self:P={},typeof define=="function"?define("vs/base/common/performance",[],function(){return S(P)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=S(P):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),P.perf=S(P))}(),define(ce[56],le([0,1,12]),function(Q,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminateResponseCode=e.Source=void 0,e.$im=k,e.$jm=L;var P;(function(O){O[O.stdout=0]="stdout",O[O.stderr=1]="stderr"})(P||(e.Source=P={}));var y;(function(O){O[O.Success=0]="Success",O[O.Unknown=1]="Unknown",O[O.AccessDenied=2]="AccessDenied",O[O.ProcessNotFound=3]="ProcessNotFound"})(y||(e.TerminateResponseCode=y={}));function k(O,...g){const a=g.reduce((f,m)=>(f[m]=!0,f),{}),d=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(O).filter(f=>!a[f]).forEach(f=>{for(let m=0;m<d.length;m++)if(f.search(d[m])!==-1){delete O[f];break}})}function L(O){O&&(delete O.DEBUG,S.$l&&delete O.LD_PRELOAD)}}),function(Q,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var S=e();for(var P in S)(typeof exports=="object"?exports:Q)[P]=S[P]}}(typeof self<"u"?self:this,function(){return function(Q){var e={};function S(P){if(e[P])return e[P].exports;var y=e[P]={i:P,l:!1,exports:{}};return Q[P].call(y.exports,y,y.exports,S),y.l=!0,y.exports}return S.m=Q,S.c=e,S.d=function(P,y,k){S.o(P,y)||Object.defineProperty(P,y,{enumerable:!0,get:k})},S.r=function(P){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(P,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(P,"__esModule",{value:!0})},S.t=function(P,y){if(1&y&&(P=S(P)),8&y||4&y&&typeof P=="object"&&P&&P.__esModule)return P;var k=Object.create(null);if(S.r(k),Object.defineProperty(k,"default",{enumerable:!0,value:P}),2&y&&typeof P!="string")for(var L in P)S.d(k,L,function(O){return P[O]}.bind(null,L));return k},S.n=function(P){var y=P&&P.__esModule?function(){return P.default}:function(){return P};return S.d(y,"a",y),y},S.o=function(P,y){return Object.prototype.hasOwnProperty.call(P,y)},S.p="",S(S.s=0)}([function(Q,e,S){(function(P){var y;e=Q.exports=j,y=typeof P=="object"&&P.env&&P.env.NODE_DEBUG&&/\bsemver\b/i.test(P.env.NODE_DEBUG)?function(){var V=Array.prototype.slice.call(arguments,0);V.unshift("SEMVER"),console.log.apply(console,V)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var k=256,L=Number.MAX_SAFE_INTEGER||9007199254740991,O=e.re=[],g=e.src=[],a=0,d=a++;g[d]="0|[1-9]\\d*";var c=a++;g[c]="[0-9]+";var f=a++;g[f]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var m=a++;g[m]="("+g[d]+")\\.("+g[d]+")\\.("+g[d]+")";var $=a++;g[$]="("+g[c]+")\\.("+g[c]+")\\.("+g[c]+")";var I=a++;g[I]="(?:"+g[d]+"|"+g[f]+")";var b=a++;g[b]="(?:"+g[c]+"|"+g[f]+")";var h=a++;g[h]="(?:-("+g[I]+"(?:\\."+g[I]+")*))";var p=a++;g[p]="(?:-?("+g[b]+"(?:\\."+g[b]+")*))";var R=a++;g[R]="[0-9A-Za-z-]+";var v=a++;g[v]="(?:\\+("+g[R]+"(?:\\."+g[R]+")*))";var i=a++,l="v?"+g[m]+g[h]+"?"+g[v]+"?";g[i]="^"+l+"$";var n="[v=\\s]*"+g[$]+g[p]+"?"+g[v]+"?",r=a++;g[r]="^"+n+"$";var t=a++;g[t]="((?:<|>)?=?)";var s=a++;g[s]=g[c]+"|x|X|\\*";var o=a++;g[o]=g[d]+"|x|X|\\*";var u=a++;g[u]="[v=\\s]*("+g[o]+")(?:\\.("+g[o]+")(?:\\.("+g[o]+")(?:"+g[h]+")?"+g[v]+"?)?)?";var w=a++;g[w]="[v=\\s]*("+g[s]+")(?:\\.("+g[s]+")(?:\\.("+g[s]+")(?:"+g[p]+")?"+g[v]+"?)?)?";var A=a++;g[A]="^"+g[t]+"\\s*"+g[u]+"$";var T=a++;g[T]="^"+g[t]+"\\s*"+g[w]+"$";var D=a++;g[D]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var N=a++;g[N]="(?:~>?)";var M=a++;g[M]="(\\s*)"+g[N]+"\\s+",O[M]=new RegExp(g[M],"g");var Y=a++;g[Y]="^"+g[N]+g[u]+"$";var K=a++;g[K]="^"+g[N]+g[w]+"$";var re=a++;g[re]="(?:\\^)";var ae=a++;g[ae]="(\\s*)"+g[re]+"\\s+",O[ae]=new RegExp(g[ae],"g");var ue=a++;g[ue]="^"+g[re]+g[u]+"$";var de=a++;g[de]="^"+g[re]+g[w]+"$";var H=a++;g[H]="^"+g[t]+"\\s*("+n+")$|^$";var Z=a++;g[Z]="^"+g[t]+"\\s*("+l+")$|^$";var B=a++;g[B]="(\\s*)"+g[t]+"\\s*("+n+"|"+g[u]+")",O[B]=new RegExp(g[B],"g");var z=a++;g[z]="^\\s*("+g[u]+")\\s+-\\s+("+g[u]+")\\s*$";var x=a++;g[x]="^\\s*("+g[w]+")\\s+-\\s+("+g[w]+")\\s*$";var X=a++;g[X]="(<|>)?=?\\s*\\*";for(var ee=0;ee<35;ee++)y(ee,g[ee]),O[ee]||(O[ee]=new RegExp(g[ee]));function ie(V,_){if(V instanceof j)return V;if(typeof V!="string"||V.length>k||!(_?O[r]:O[i]).test(V))return null;try{return new j(V,_)}catch{return null}}function j(V,_){if(V instanceof j){if(V.loose===_)return V;V=V.version}else if(typeof V!="string")throw new TypeError("Invalid Version: "+V);if(V.length>k)throw new TypeError("version is longer than "+k+" characters");if(!(this instanceof j))return new j(V,_);y("SemVer",V,_),this.loose=_;var te=V.trim().match(_?O[r]:O[i]);if(!te)throw new TypeError("Invalid Version: "+V);if(this.raw=V,this.major=+te[1],this.minor=+te[2],this.patch=+te[3],this.major>L||this.major<0)throw new TypeError("Invalid major version");if(this.minor>L||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>L||this.patch<0)throw new TypeError("Invalid patch version");te[4]?this.prerelease=te[4].split(".").map(function($e){if(/^[0-9]+$/.test($e)){var Ee=+$e;if(Ee>=0&&Ee<L)return Ee}return $e}):this.prerelease=[],this.build=te[5]?te[5].split("."):[],this.format()}e.parse=ie,e.valid=function(V,_){var te=ie(V,_);return te?te.version:null},e.clean=function(V,_){var te=ie(V.trim().replace(/^[=v]+/,""),_);return te?te.version:null},e.SemVer=j,j.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},j.prototype.toString=function(){return this.version},j.prototype.compare=function(V){return y("SemVer.compare",this.version,this.loose,V),V instanceof j||(V=new j(V,this.loose)),this.compareMain(V)||this.comparePre(V)},j.prototype.compareMain=function(V){return V instanceof j||(V=new j(V,this.loose)),q(this.major,V.major)||q(this.minor,V.minor)||q(this.patch,V.patch)},j.prototype.comparePre=function(V){if(V instanceof j||(V=new j(V,this.loose)),this.prerelease.length&&!V.prerelease.length)return-1;if(!this.prerelease.length&&V.prerelease.length)return 1;if(!this.prerelease.length&&!V.prerelease.length)return 0;var _=0;do{var te=this.prerelease[_],$e=V.prerelease[_];if(y("prerelease compare",_,te,$e),te===void 0&&$e===void 0)return 0;if($e===void 0)return 1;if(te===void 0)return-1;if(te!==$e)return q(te,$e)}while(++_)},j.prototype.inc=function(V,_){switch(V){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",_);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",_);break;case"prepatch":this.prerelease.length=0,this.inc("patch",_),this.inc("pre",_);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",_),this.inc("pre",_);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var te=this.prerelease.length;--te>=0;)typeof this.prerelease[te]=="number"&&(this.prerelease[te]++,te=-2);te===-1&&this.prerelease.push(0)}_&&(this.prerelease[0]===_?isNaN(this.prerelease[1])&&(this.prerelease=[_,0]):this.prerelease=[_,0]);break;default:throw new Error("invalid increment argument: "+V)}return this.format(),this.raw=this.version,this},e.inc=function(V,_,te,$e){typeof te=="string"&&($e=te,te=void 0);try{return new j(V,te).inc(_,$e).version}catch{return null}},e.diff=function(V,_){if(C(V,_))return null;var te=ie(V),$e=ie(_);if(te.prerelease.length||$e.prerelease.length){for(var Ee in te)if((Ee==="major"||Ee==="minor"||Ee==="patch")&&te[Ee]!==$e[Ee])return"pre"+Ee;return"prerelease"}for(var Ee in te)if((Ee==="major"||Ee==="minor"||Ee==="patch")&&te[Ee]!==$e[Ee])return Ee},e.compareIdentifiers=q;var W=/^[0-9]+$/;function q(V,_){var te=W.test(V),$e=W.test(_);return te&&$e&&(V=+V,_=+_),te&&!$e?-1:$e&&!te?1:V<_?-1:V>_?1:0}function E(V,_,te){return new j(V,te).compare(new j(_,te))}function F(V,_,te){return E(V,_,te)>0}function U(V,_,te){return E(V,_,te)<0}function C(V,_,te){return E(V,_,te)===0}function G(V,_,te){return E(V,_,te)!==0}function J(V,_,te){return E(V,_,te)>=0}function ne(V,_,te){return E(V,_,te)<=0}function oe(V,_,te,$e){var Ee;switch(_){case"===":typeof V=="object"&&(V=V.version),typeof te=="object"&&(te=te.version),Ee=V===te;break;case"!==":typeof V=="object"&&(V=V.version),typeof te=="object"&&(te=te.version),Ee=V!==te;break;case"":case"=":case"==":Ee=C(V,te,$e);break;case"!=":Ee=G(V,te,$e);break;case">":Ee=F(V,te,$e);break;case">=":Ee=J(V,te,$e);break;case"<":Ee=U(V,te,$e);break;case"<=":Ee=ne(V,te,$e);break;default:throw new TypeError("Invalid operator: "+_)}return Ee}function fe(V,_){if(V instanceof fe){if(V.loose===_)return V;V=V.value}if(!(this instanceof fe))return new fe(V,_);y("comparator",V,_),this.loose=_,this.parse(V),this.semver===me?this.value="":this.value=this.operator+this.semver.version,y("comp",this)}e.rcompareIdentifiers=function(V,_){return q(_,V)},e.major=function(V,_){return new j(V,_).major},e.minor=function(V,_){return new j(V,_).minor},e.patch=function(V,_){return new j(V,_).patch},e.compare=E,e.compareLoose=function(V,_){return E(V,_,!0)},e.rcompare=function(V,_,te){return E(_,V,te)},e.sort=function(V,_){return V.sort(function(te,$e){return e.compare(te,$e,_)})},e.rsort=function(V,_){return V.sort(function(te,$e){return e.rcompare(te,$e,_)})},e.gt=F,e.lt=U,e.eq=C,e.neq=G,e.gte=J,e.lte=ne,e.cmp=oe,e.Comparator=fe;var me={};function ge(V,_){if(V instanceof ge)return V.loose===_?V:new ge(V.raw,_);if(V instanceof fe)return new ge(V.value,_);if(!(this instanceof ge))return new ge(V,_);if(this.loose=_,this.raw=V,this.set=V.split(/\s*\|\|\s*/).map(function(te){return this.parseRange(te.trim())},this).filter(function(te){return te.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+V);this.format()}function we(V){return!V||V.toLowerCase()==="x"||V==="*"}function he(V,_,te,$e,Ee,Ne,ke,Ce,Re,Le,ze,Ae,Te){return((_=we(te)?"":we($e)?">="+te+".0.0":we(Ee)?">="+te+"."+$e+".0":">="+_)+" "+(Ce=we(Re)?"":we(Le)?"<"+(+Re+1)+".0.0":we(ze)?"<"+Re+"."+(+Le+1)+".0":Ae?"<="+Re+"."+Le+"."+ze+"-"+Ae:"<="+Ce)).trim()}function pe(V,_){for(var te=0;te<V.length;te++)if(!V[te].test(_))return!1;if(_.prerelease.length){for(te=0;te<V.length;te++)if(y(V[te].semver),V[te].semver!==me&&V[te].semver.prerelease.length>0){var $e=V[te].semver;if($e.major===_.major&&$e.minor===_.minor&&$e.patch===_.patch)return!0}return!1}return!0}function be(V,_,te){try{_=new ge(_,te)}catch{return!1}return _.test(V)}function Se(V,_,te,$e){var Ee,Ne,ke,Ce,Re;switch(V=new j(V,$e),_=new ge(_,$e),te){case">":Ee=F,Ne=ne,ke=U,Ce=">",Re=">=";break;case"<":Ee=U,Ne=J,ke=F,Ce="<",Re="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(be(V,_,$e))return!1;for(var Le=0;Le<_.set.length;++Le){var ze=_.set[Le],Ae=null,Te=null;if(ze.forEach(function(je){je.semver===me&&(je=new fe(">=0.0.0")),Ae=Ae||je,Te=Te||je,Ee(je.semver,Ae.semver,$e)?Ae=je:ke(je.semver,Te.semver,$e)&&(Te=je)}),Ae.operator===Ce||Ae.operator===Re||(!Te.operator||Te.operator===Ce)&&Ne(V,Te.semver)||Te.operator===Re&&ke(V,Te.semver))return!1}return!0}fe.prototype.parse=function(V){var _=this.loose?O[H]:O[Z],te=V.match(_);if(!te)throw new TypeError("Invalid comparator: "+V);this.operator=te[1],this.operator==="="&&(this.operator=""),te[2]?this.semver=new j(te[2],this.loose):this.semver=me},fe.prototype.toString=function(){return this.value},fe.prototype.test=function(V){return y("Comparator.test",V,this.loose),this.semver===me||(typeof V=="string"&&(V=new j(V,this.loose)),oe(V,this.operator,this.semver,this.loose))},fe.prototype.intersects=function(V,_){if(!(V instanceof fe))throw new TypeError("a Comparator is required");var te;if(this.operator==="")return te=new ge(V.value,_),be(this.value,te,_);if(V.operator==="")return te=new ge(this.value,_),be(V.semver,te,_);var $e=!(this.operator!==">="&&this.operator!==">"||V.operator!==">="&&V.operator!==">"),Ee=!(this.operator!=="<="&&this.operator!=="<"||V.operator!=="<="&&V.operator!=="<"),Ne=this.semver.version===V.semver.version,ke=!(this.operator!==">="&&this.operator!=="<="||V.operator!==">="&&V.operator!=="<="),Ce=oe(this.semver,"<",V.semver,_)&&(this.operator===">="||this.operator===">")&&(V.operator==="<="||V.operator==="<"),Re=oe(this.semver,">",V.semver,_)&&(this.operator==="<="||this.operator==="<")&&(V.operator===">="||V.operator===">");return $e||Ee||Ne&&ke||Ce||Re},e.Range=ge,ge.prototype.format=function(){return this.range=this.set.map(function(V){return V.join(" ").trim()}).join("||").trim(),this.range},ge.prototype.toString=function(){return this.range},ge.prototype.parseRange=function(V){var _=this.loose;V=V.trim(),y("range",V,_);var te=_?O[x]:O[z];V=V.replace(te,he),y("hyphen replace",V),V=V.replace(O[B],"$1$2$3"),y("comparator trim",V,O[B]),V=(V=(V=V.replace(O[M],"$1~")).replace(O[ae],"$1^")).split(/\s+/).join(" ");var $e=_?O[H]:O[Z],Ee=V.split(" ").map(function(Ne){return function(ke,Ce){return y("comp",ke),ke=function(Re,Le){return Re.trim().split(/\s+/).map(function(ze){return function(Ae,Te){y("caret",Ae,Te);var je=Te?O[de]:O[ue];return Ae.replace(je,function(Ue,Pe,Ie,Oe,De){var Fe;return y("caret",Ae,Ue,Pe,Ie,Oe,De),we(Pe)?Fe="":we(Ie)?Fe=">="+Pe+".0.0 <"+(+Pe+1)+".0.0":we(Oe)?Fe=Pe==="0"?">="+Pe+"."+Ie+".0 <"+Pe+"."+(+Ie+1)+".0":">="+Pe+"."+Ie+".0 <"+(+Pe+1)+".0.0":De?(y("replaceCaret pr",De),De.charAt(0)!=="-"&&(De="-"+De),Fe=Pe==="0"?Ie==="0"?">="+Pe+"."+Ie+"."+Oe+De+" <"+Pe+"."+Ie+"."+(+Oe+1):">="+Pe+"."+Ie+"."+Oe+De+" <"+Pe+"."+(+Ie+1)+".0":">="+Pe+"."+Ie+"."+Oe+De+" <"+(+Pe+1)+".0.0"):(y("no pr"),Fe=Pe==="0"?Ie==="0"?">="+Pe+"."+Ie+"."+Oe+" <"+Pe+"."+Ie+"."+(+Oe+1):">="+Pe+"."+Ie+"."+Oe+" <"+Pe+"."+(+Ie+1)+".0":">="+Pe+"."+Ie+"."+Oe+" <"+(+Pe+1)+".0.0"),y("caret return",Fe),Fe})}(ze,Le)}).join(" ")}(ke,Ce),y("caret",ke),ke=function(Re,Le){return Re.trim().split(/\s+/).map(function(ze){return function(Ae,Te){var je=Te?O[K]:O[Y];return Ae.replace(je,function(Ue,Pe,Ie,Oe,De){var Fe;return y("tilde",Ae,Ue,Pe,Ie,Oe,De),we(Pe)?Fe="":we(Ie)?Fe=">="+Pe+".0.0 <"+(+Pe+1)+".0.0":we(Oe)?Fe=">="+Pe+"."+Ie+".0 <"+Pe+"."+(+Ie+1)+".0":De?(y("replaceTilde pr",De),De.charAt(0)!=="-"&&(De="-"+De),Fe=">="+Pe+"."+Ie+"."+Oe+De+" <"+Pe+"."+(+Ie+1)+".0"):Fe=">="+Pe+"."+Ie+"."+Oe+" <"+Pe+"."+(+Ie+1)+".0",y("tilde return",Fe),Fe})}(ze,Le)}).join(" ")}(ke,Ce),y("tildes",ke),ke=function(Re,Le){return y("replaceXRanges",Re,Le),Re.split(/\s+/).map(function(ze){return function(Ae,Te){Ae=Ae.trim();var je=Te?O[T]:O[A];return Ae.replace(je,function(Ue,Pe,Ie,Oe,De,Fe){y("xRange",Ae,Ue,Pe,Ie,Oe,De,Fe);var Ve=we(Ie),Me=Ve||we(Oe),Be=Me||we(De);return Pe==="="&&Be&&(Pe=""),Ve?Ue=Pe===">"||Pe==="<"?"<0.0.0":"*":Pe&&Be?(Me&&(Oe=0),Be&&(De=0),Pe===">"?(Pe=">=",Me?(Ie=+Ie+1,Oe=0,De=0):Be&&(Oe=+Oe+1,De=0)):Pe==="<="&&(Pe="<",Me?Ie=+Ie+1:Oe=+Oe+1),Ue=Pe+Ie+"."+Oe+"."+De):Me?Ue=">="+Ie+".0.0 <"+(+Ie+1)+".0.0":Be&&(Ue=">="+Ie+"."+Oe+".0 <"+Ie+"."+(+Oe+1)+".0"),y("xRange return",Ue),Ue})}(ze,Le)}).join(" ")}(ke,Ce),y("xrange",ke),ke=function(Re,Le){return y("replaceStars",Re,Le),Re.trim().replace(O[X],"")}(ke,Ce),y("stars",ke),ke}(Ne,_)}).join(" ").split(/\s+/);return this.loose&&(Ee=Ee.filter(function(Ne){return!!Ne.match($e)})),Ee=Ee.map(function(Ne){return new fe(Ne,_)})},ge.prototype.intersects=function(V,_){if(!(V instanceof ge))throw new TypeError("a Range is required");return this.set.some(function(te){return te.every(function($e){return V.set.some(function(Ee){return Ee.every(function(Ne){return $e.intersects(Ne,_)})})})})},e.toComparators=function(V,_){return new ge(V,_).set.map(function(te){return te.map(function($e){return $e.value}).join(" ").trim().split(" ")})},ge.prototype.test=function(V){if(!V)return!1;typeof V=="string"&&(V=new j(V,this.loose));for(var _=0;_<this.set.length;_++)if(pe(this.set[_],V))return!0;return!1},e.satisfies=be,e.maxSatisfying=function(V,_,te){var $e=null,Ee=null;try{var Ne=new ge(_,te)}catch{return null}return V.forEach(function(ke){Ne.test(ke)&&($e&&Ee.compare(ke)!==-1||(Ee=new j($e=ke,te)))}),$e},e.minSatisfying=function(V,_,te){var $e=null,Ee=null;try{var Ne=new ge(_,te)}catch{return null}return V.forEach(function(ke){Ne.test(ke)&&($e&&Ee.compare(ke)!==1||(Ee=new j($e=ke,te)))}),$e},e.validRange=function(V,_){try{return new ge(V,_).range||"*"}catch{return null}},e.ltr=function(V,_,te){return Se(V,_,"<",te)},e.gtr=function(V,_,te){return Se(V,_,">",te)},e.outside=Se,e.prerelease=function(V,_){var te=ie(V,_);return te&&te.prerelease.length?te.prerelease:null},e.intersects=function(V,_,te){return V=new ge(V,te),_=new ge(_,te),V.intersects(_)},e.coerce=function(V){if(V instanceof j)return V;if(typeof V!="string")return null;var _=V.match(O[D]);return _==null?null:ie((_[1]||"0")+"."+(_[2]||"0")+"."+(_[3]||"0"))}}).call(this,S(1))},function(Q,e){var S,P,y=Q.exports={};function k(){throw new Error("setTimeout has not been defined")}function L(){throw new Error("clearTimeout has not been defined")}function O(b){if(S===setTimeout)return setTimeout(b,0);if((S===k||!S)&&setTimeout)return S=setTimeout,setTimeout(b,0);try{return S(b,0)}catch{try{return S.call(null,b,0)}catch{return S.call(this,b,0)}}}(function(){try{S=typeof setTimeout=="function"?setTimeout:k}catch{S=k}try{P=typeof clearTimeout=="function"?clearTimeout:L}catch{P=L}})();var g,a=[],d=!1,c=-1;function f(){d&&g&&(d=!1,g.length?a=g.concat(a):c=-1,a.length&&m())}function m(){if(!d){var b=O(f);d=!0;for(var h=a.length;h;){for(g=a,a=[];++c<h;)g&&g[c].run();c=-1,h=a.length}g=null,d=!1,function(p){if(P===clearTimeout)return clearTimeout(p);if((P===L||!P)&&clearTimeout)return P=clearTimeout,clearTimeout(p);try{P(p)}catch{try{return P.call(null,p)}catch{return P.call(this,p)}}}(b)}}function $(b,h){this.fun=b,this.array=h}function I(){}y.nextTick=function(b){var h=new Array(arguments.length-1);if(arguments.length>1)for(var p=1;p<arguments.length;p++)h[p-1]=arguments[p];a.push(new $(b,h)),a.length!==1||d||O(m)},$.prototype.run=function(){this.fun.apply(null,this.array)},y.title="browser",y.browser=!0,y.env={},y.argv=[],y.version="",y.versions={},y.on=I,y.addListener=I,y.once=I,y.off=I,y.removeListener=I,y.removeAllListeners=I,y.emit=I,y.prependListener=I,y.prependOnceListener=I,y.listeners=function(b){return[]},y.binding=function(b){throw new Error("process.binding is not supported")},y.cwd=function(){return"/"},y.chdir=function(b){throw new Error("process.chdir is not supported")},y.umask=function(){return 0}}])}),define(ce[80],le([0,1]),function(Q,e){"use strict";var S;Object.defineProperty(e,"__esModule",{value:!0}),e.$Qs=void 0;class P{constructor(O,g,a){this.level=O,this.key=g,this.value=a,this.forward=[]}}const y=void 0;class k{constructor(O,g=2**16){this.comparator=O,this[S]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(g)|0),this.e=new P(this.c,y,y)}get size(){return this.f}clear(){this.e=new P(this.c,y,y),this.f=0}has(O){return!!k.g(this,O,this.comparator)}get(O){return k.g(this,O,this.comparator)?.value}set(O,g){return k.h(this,O,g,this.comparator)&&(this.f+=1),this}delete(O){const g=k.k(this,O,this.comparator);return g&&(this.f-=1),g}forEach(O,g){let a=this.e.forward[0];for(;a;)O.call(g,a.value,a.key,this),a=a.forward[0]}[(S=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let O=this.e.forward[0];for(;O;)yield[O.key,O.value],O=O.forward[0]}*keys(){let O=this.e.forward[0];for(;O;)yield O.key,O=O.forward[0]}*values(){let O=this.e.forward[0];for(;O;)yield O.value,O=O.forward[0]}toString(){let O="[SkipList]:",g=this.e.forward[0];for(;g;)O+=`node(${g.key}, ${g.value}, lvl:${g.level})`,g=g.forward[0];return O}static g(O,g,a){let d=O.e;for(let c=O.d-1;c>=0;c--)for(;d.forward[c]&&a(d.forward[c].key,g)<0;)d=d.forward[c];if(d=d.forward[0],d&&a(d.key,g)===0)return d}static h(O,g,a,d){const c=[];let f=O.e;for(let m=O.d-1;m>=0;m--){for(;f.forward[m]&&d(f.forward[m].key,g)<0;)f=f.forward[m];c[m]=f}if(f=f.forward[0],f&&d(f.key,g)===0)return f.value=a,!1;{const m=k.j(O);if(m>O.d){for(let $=O.d;$<m;$++)c[$]=O.e;O.d=m}f=new P(m,g,a);for(let $=0;$<m;$++)f.forward[$]=c[$].forward[$],c[$].forward[$]=f;return!0}}static j(O,g=.5){let a=1;for(;Math.random()<g&&a<O.c;)a+=1;return a}static k(O,g,a){const d=[];let c=O.e;for(let f=O.d-1;f>=0;f--){for(;c.forward[f]&&a(c.forward[f].key,g)<0;)c=c.forward[f];d[f]=c}if(c=c.forward[0],!c||a(c.key,g)!==0)return!1;for(let f=0;f<O.d&&d[f].forward[f]===c;f++)d[f].forward[f]=c.forward[f];for(;O.d>0&&O.e.forward[O.d-1]===y;)O.d-=1;return!0}}e.$Qs=k}),define(ce[47],le([0,1,7,2]),function(Q,e,S,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$we=y,e.$xe=k,e.$ye=L,e.$ze=O,e.$Ae=a,e.$Be=d,e.$Ce=c,e.$De=f,e.$Ee=m,e.$Fe=$,e.$Ge=I,e.$He=b,e.$Ie=h,e.$Je=p,e.$Ke=R;function y(v){const i=v;return i?typeof i.read=="function":!1}function k(v){const i=v;return i?[i.on,i.pause,i.resume,i.destroy].every(l=>typeof l=="function"):!1}function L(v){const i=v;return i?k(i.stream)&&Array.isArray(i.buffer)&&typeof i.ended=="boolean":!1}function O(v,i){return new g(v,i)}class g{constructor(i,l){this.e=i,this.f=l,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(i){if(!this.a.destroyed){if(this.a.flowing)this.g(i);else if(this.b.data.push(i),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(l=>this.d.push(l))}}error(i){this.a.destroyed||(this.a.flowing?this.h(i):this.b.error.push(i))}end(i){this.a.destroyed||(typeof i<"u"&&this.write(i),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(i){this.c.data.slice(0).forEach(l=>l(i))}h(i){this.c.error.length===0?(0,S.$Y)(i):this.c.error.slice(0).forEach(l=>l(i))}i(){this.c.end.slice(0).forEach(i=>i())}on(i,l){if(!this.a.destroyed)switch(i){case"data":this.c.data.push(l),this.resume();break;case"end":this.c.end.push(l),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(l),this.a.flowing&&this.k();break}}removeListener(i,l){if(this.a.destroyed)return;let n;switch(i){case"data":n=this.c.data;break;case"end":n=this.c.end;break;case"error":n=this.c.error;break}if(n){const r=n.indexOf(l);r>=0&&n.splice(r,1)}}j(){if(this.b.data.length>0){const i=this.e(this.b.data);this.g(i),this.b.data.length=0;const l=[...this.d];this.d.length=0,l.forEach(n=>n())}}k(){if(this.c.error.length>0){for(const i of this.b.error)this.h(i);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function a(v,i){const l=[];let n;for(;(n=v.read())!==null;)l.push(n);return i(l)}function d(v,i,l){const n=[];let r;for(;(r=v.read())!==null&&n.length<l;)n.push(r);return r===null&&n.length>0?i(n):{read:()=>{if(n.length>0)return n.shift();if(typeof r<"u"){const t=r;return r=void 0,t}return v.read()}}}function c(v,i){return new Promise((l,n)=>{const r=[];f(v,{onData:t=>{i&&r.push(t)},onError:t=>{i?n(t):l(void 0)},onEnd:()=>{l(i?i(r):void 0)}})})}function f(v,i,l){v.on("error",n=>{l?.isCancellationRequested||i.onError(n)}),v.on("end",()=>{l?.isCancellationRequested||i.onEnd()}),v.on("data",n=>{l?.isCancellationRequested||i.onData(n)})}function m(v,i){return new Promise((l,n)=>{const r=new P.$Sc,t=[],s=w=>{if(t.push(w),t.length>i)return r.dispose(),v.pause(),l({stream:v,buffer:t,ended:!1})},o=w=>(r.dispose(),n(w)),u=()=>(r.dispose(),l({stream:v,buffer:t,ended:!0}));r.add((0,P.$Rc)(()=>v.removeListener("error",o))),v.on("error",o),r.add((0,P.$Rc)(()=>v.removeListener("end",u))),v.on("end",u),r.add((0,P.$Rc)(()=>v.removeListener("data",s))),v.on("data",s)})}function $(v,i){const l=O(i);return l.end(v),l}function I(){const v=O(()=>{throw new Error("not supported")});return v.end(),v}function b(v){let i=!1;return{read:()=>i?null:(i=!0,v)}}function h(v,i,l){const n=O(l);return f(v,{onData:r=>n.write(i.data(r)),onError:r=>n.error(i.error?i.error(r):r),onEnd:()=>n.end()}),n}function p(v,i,l){let n=!1;return{read:()=>{const r=i.read();return n?r:(n=!0,r!==null?l([v,r]):v)}}}function R(v,i,l){let n=!1;const r=O(l);return f(i,{onData:t=>n?r.write(t):(n=!0,r.write(l([v,t]))),onError:t=>r.error(t),onEnd:()=>{n||(n=!0,r.write(v)),r.end()}}),r}});var We=this&&this.__createBinding||(Object.create?function(Q,e,S,P){P===void 0&&(P=S);var y=Object.getOwnPropertyDescriptor(e,S);(!y||("get"in y?!e.__esModule:y.writable||y.configurable))&&(y={enumerable:!0,get:function(){return e[S]}}),Object.defineProperty(Q,P,y)}:function(Q,e,S,P){P===void 0&&(P=S),Q[P]=e[S]}),He=this&&this.__setModuleDefault||(Object.create?function(Q,e){Object.defineProperty(Q,"default",{enumerable:!0,value:e})}:function(Q,e){Q.default=e}),ye=this&&this.__importStar||function(Q){if(Q&&Q.__esModule)return Q;var e={};if(Q!=null)for(var S in Q)S!=="default"&&Object.prototype.hasOwnProperty.call(Q,S)&&We(e,Q,S);return He(e,Q),e};define(ce[13],le([0,1,146,47]),function(Q,e,S,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Le=void 0,e.$Me=a,e.$Ne=d,e.$Oe=c,e.$Pe=f,e.$Qe=m,e.$Re=$,e.$Se=I,e.$Te=b,e.$Ue=h,e.$Ve=p,e.$We=R,e.$Xe=v,e.$Ye=i,e.$Ze=l,e.$1e=n,e.$2e=r,e.$3e=t,e.$4e=s,e.$5e=o,e.$6e=A,P=ye(P);const y=typeof Buffer<"u",k=new S.$T(()=>new Uint8Array(256));let L,O;class g{static alloc(D){return y?new g(Buffer.allocUnsafe(D)):new g(new Uint8Array(D))}static wrap(D){return y&&!Buffer.isBuffer(D)&&(D=Buffer.from(D.buffer,D.byteOffset,D.byteLength)),new g(D)}static fromString(D,N){return!(N?.dontUseNodeBuffer||!1)&&y?new g(Buffer.from(D)):(L||(L=new TextEncoder),new g(L.encode(D)))}static fromByteArray(D){const N=g.alloc(D.length);for(let M=0,Y=D.length;M<Y;M++)N.buffer[M]=D[M];return N}static concat(D,N){if(typeof N>"u"){N=0;for(let K=0,re=D.length;K<re;K++)N+=D[K].byteLength}const M=g.alloc(N);let Y=0;for(let K=0,re=D.length;K<re;K++){const ae=D[K];M.set(ae,Y),Y+=ae.byteLength}return M}constructor(D){this.buffer=D,this.byteLength=this.buffer.byteLength}clone(){const D=g.alloc(this.byteLength);return D.set(this),D}toString(){return y?this.buffer.toString():(O||(O=new TextDecoder),O.decode(this.buffer))}slice(D,N){return new g(this.buffer.subarray(D,N))}set(D,N){if(D instanceof g)this.buffer.set(D.buffer,N);else if(D instanceof Uint8Array)this.buffer.set(D,N);else if(D instanceof ArrayBuffer)this.buffer.set(new Uint8Array(D),N);else if(ArrayBuffer.isView(D))this.buffer.set(new Uint8Array(D.buffer,D.byteOffset,D.byteLength),N);else throw new Error("Unknown argument 'array'")}readUInt32BE(D){return f(this.buffer,D)}writeUInt32BE(D,N){m(this.buffer,D,N)}readUInt32LE(D){return $(this.buffer,D)}writeUInt32LE(D,N){I(this.buffer,D,N)}readUInt8(D){return b(this.buffer,D)}writeUInt8(D,N){h(this.buffer,D,N)}indexOf(D,N=0){return a(this.buffer,D instanceof g?D.buffer:D,N)}}e.$Le=g;function a(T,D,N=0){const M=D.byteLength,Y=T.byteLength;if(M===0)return 0;if(M===1)return T.indexOf(D[0]);if(M>Y-N)return-1;const K=k.value;K.fill(D.length);for(let de=0;de<D.length;de++)K[D[de]]=D.length-de-1;let re=N+D.length-1,ae=re,ue=-1;for(;re<Y;)if(T[re]===D[ae]){if(ae===0){ue=re;break}re--,ae--}else re+=Math.max(D.length-ae,K[T[re]]),ae=D.length-1;return ue}function d(T,D){return T[D+0]<<0>>>0|T[D+1]<<8>>>0}function c(T,D,N){T[N+0]=D&255,D=D>>>8,T[N+1]=D&255}function f(T,D){return T[D]*2**24+T[D+1]*2**16+T[D+2]*2**8+T[D+3]}function m(T,D,N){T[N+3]=D,D=D>>>8,T[N+2]=D,D=D>>>8,T[N+1]=D,D=D>>>8,T[N]=D}function $(T,D){return T[D+0]<<0>>>0|T[D+1]<<8>>>0|T[D+2]<<16>>>0|T[D+3]<<24>>>0}function I(T,D,N){T[N+0]=D&255,D=D>>>8,T[N+1]=D&255,D=D>>>8,T[N+2]=D&255,D=D>>>8,T[N+3]=D&255}function b(T,D){return T[D]}function h(T,D,N){T[N]=D}function p(T){return P.$Ae(T,D=>g.concat(D))}function R(T){return P.$He(T)}function v(T){return P.$Ce(T,D=>g.concat(D))}async function i(T){return T.ended?g.concat(T.buffer):g.concat([...T.buffer,await v(T.stream)])}function l(T){return P.$Fe(T,D=>g.concat(D))}function n(T){return P.$Ie(T,{data:D=>typeof D=="string"?g.fromString(D):g.wrap(D)},D=>g.concat(D))}function r(T){return P.$ze(D=>g.concat(D),T)}function t(T,D){return P.$Je(T,D,N=>g.concat(N))}function s(T,D){return P.$Ke(T,D,N=>g.concat(N))}function o(T){let D=0,N=0,M=0;const Y=new Uint8Array(Math.floor(T.length/4*3)),K=ae=>{switch(N){case 3:Y[M++]=D|ae,N=0;break;case 2:Y[M++]=D|ae>>>2,D=ae<<6,N=3;break;case 1:Y[M++]=D|ae>>>4,D=ae<<4,N=2;break;default:D=ae<<2,N=1}};for(let ae=0;ae<T.length;ae++){const ue=T.charCodeAt(ae);if(ue>=65&&ue<=90)K(ue-65);else if(ue>=97&&ue<=122)K(ue-97+26);else if(ue>=48&&ue<=57)K(ue-48+52);else if(ue===43||ue===45)K(62);else if(ue===47||ue===95)K(63);else{if(ue===61)break;throw new SyntaxError(`Unexpected base64 character ${T[ae]}`)}}const re=M;for(;N>0;)K(0);return g.wrap(Y).slice(0,re)}const u="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",w="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function A({buffer:T},D=!0,N=!1){const M=N?w:u;let Y="";const K=T.byteLength%3;let re=0;for(;re<T.byteLength-K;re+=3){const ae=T[re+0],ue=T[re+1],de=T[re+2];Y+=M[ae>>>2],Y+=M[(ae<<4|ue>>>4)&63],Y+=M[(ue<<2|de>>>6)&63],Y+=M[de&63]}if(K===1){const ae=T[re+0];Y+=M[ae>>>2],Y+=M[ae<<4&63],D&&(Y+="==")}else if(K===2){const ae=T[re+0],ue=T[re+1];Y+=M[ae>>>2],Y+=M[(ae<<4|ue>>>4)&63],Y+=M[ue<<2&63],D&&(Y+="=")}return Y}}),define(ce[26],le([0,1,3]),function(Q,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bo=P,e.$co=y,e.$do=L,e.$eo=g,e.$fo=a,e.$go=d,e.$ho=c,e.$io=f,e.$jo=m,e.$ko=$,e.$lo=I,e.$mo=b,e.$no=h;function P(p){if(!p||typeof p!="object"||p instanceof RegExp)return p;const R=Array.isArray(p)?[]:{};return Object.entries(p).forEach(([v,i])=>{R[v]=i&&typeof i=="object"?P(i):i}),R}function y(p){if(!p||typeof p!="object")return p;const R=[p];for(;R.length>0;){const v=R.shift();Object.freeze(v);for(const i in v)if(k.call(v,i)){const l=v[i];typeof l=="object"&&!Object.isFrozen(l)&&!(0,S.$fg)(l)&&R.push(l)}}return p}const k=Object.prototype.hasOwnProperty;function L(p,R){return O(p,R,new Set)}function O(p,R,v){if((0,S.$lg)(p))return p;const i=R(p);if(typeof i<"u")return i;if(Array.isArray(p)){const l=[];for(const n of p)l.push(O(n,R,v));return l}if((0,S.$eg)(p)){if(v.has(p))throw new Error("Cannot clone recursive data-structure");v.add(p);const l={};for(const n in p)k.call(p,n)&&(l[n]=O(p[n],R,v));return v.delete(p),l}return p}function g(p,R,v=!0){return(0,S.$eg)(p)?((0,S.$eg)(R)&&Object.keys(R).forEach(i=>{i in p?v&&((0,S.$eg)(p[i])&&(0,S.$eg)(R[i])?g(p[i],R[i],v):p[i]=R[i]):p[i]=R[i]}),p):R}function a(p,R){if(p===R)return!0;if(p==null||R===null||R===void 0||typeof p!=typeof R||typeof p!="object"||Array.isArray(p)!==Array.isArray(R))return!1;let v,i;if(Array.isArray(p)){if(p.length!==R.length)return!1;for(v=0;v<p.length;v++)if(!a(p[v],R[v]))return!1}else{const l=[];for(i in p)l.push(i);l.sort();const n=[];for(i in R)n.push(i);if(n.sort(),!a(l,n))return!1;for(v=0;v<l.length;v++)if(!a(p[l[v]],R[l[v]]))return!1}return!0}function d(p){const R=new Set;return JSON.stringify(p,(v,i)=>{if((0,S.$eg)(i)||Array.isArray(i)){if(R.has(i))return"[Circular]";R.add(i)}return typeof i=="bigint"?`[BigInt ${i.toString()}]`:i})}function c(p,R){const v=Object.create(null);return!p||!R||Object.keys(R).forEach(l=>{const n=p[l],r=R[l];a(n,r)||(v[l]=r)}),v}function f(p,R){const v=R.toLowerCase(),i=Object.keys(p).find(l=>l.toLowerCase()===v);return i?p[i]:p[R]}function m(p,R){const v=Object.create(null);for(const[i,l]of Object.entries(p))R(i,l)&&(v[i]=l);return v}function $(p){let R=[];for(;Object.prototype!==p;)R=R.concat(Object.getOwnPropertyNames(p)),p=Object.getPrototypeOf(p);return R}function I(p){const R=[];for(const v of $(p))typeof p[v]=="function"&&R.push(v);return R}function b(p,R){const v=l=>function(){const n=Array.prototype.slice.call(arguments,0);return R(l,n)},i={};for(const l of p)i[l]=v(l);return i}function h(p,R){const v={};for(const[i,l]of Object.entries(p))v[i]=R(l,i);return v}}),define(ce[43],le([0,1,31]),function(Q,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wj=e.$uj=void 0,e.$qj=P,e.$rj=y,e.$sj=k,e.$tj=O,e.$vj=I,S=ye(S);function P(h){return y(h,0)}function y(h,p){switch(typeof h){case"object":return h===null?k(349,p):Array.isArray(h)?g(h,p):a(h,p);case"string":return O(h,p);case"boolean":return L(h,p);case"number":return k(h,p);case"undefined":return k(937,p);default:return k(617,p)}}function k(h,p){return(p<<5)-p+h|0}function L(h,p){return k(h?433:863,p)}function O(h,p){p=k(149417,p);for(let R=0,v=h.length;R<v;R++)p=k(h.charCodeAt(R),p);return p}function g(h,p){return p=k(104579,p),h.reduce((R,v)=>y(v,R),p)}function a(h,p){return p=k(181387,p),Object.keys(h).sort().reduce((R,v)=>(R=O(v,R),y(h[v],R)),p)}class d{constructor(){this.g=0}get value(){return this.g}hash(p){return this.g=y(p,this.g),this.g}}e.$uj=d;var c;(function(h){h[h.BLOCK_SIZE=64]="BLOCK_SIZE",h[h.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(c||(c={}));function f(h,p,R=32){const v=R-p,i=~((1<<v)-1);return(h<<p|(i&h)>>>v)>>>0}function m(h,p=0,R=h.byteLength,v=0){for(let i=0;i<R;i++)h[p+i]=v}function $(h,p,R="0"){for(;h.length<p;)h=R+h;return h}function I(h,p=32){return h instanceof ArrayBuffer?Array.from(new Uint8Array(h)).map(R=>R.toString(16).padStart(2,"0")).join(""):$((h>>>0).toString(16),p/4)}class b{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(c.BLOCK_SIZE+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(p){const R=p.length;if(R===0)return;const v=this.p;let i=this.r,l=this.u,n,r;for(l!==0?(n=l,r=-1,l=0):(n=p.charCodeAt(0),r=0);;){let t=n;if(S.$Hf(n))if(r+1<R){const s=p.charCodeAt(r+1);S.$If(s)?(r++,t=S.$Jf(n,s)):t=c.UNICODE_REPLACEMENT}else{l=n;break}else S.$If(n)&&(t=c.UNICODE_REPLACEMENT);if(i=this.w(v,i,t),r++,r<R)n=p.charCodeAt(r);else break}this.r=i,this.u=l}w(p,R,v){return v<128?p[R++]=v:v<2048?(p[R++]=192|(v&1984)>>>6,p[R++]=128|(v&63)>>>0):v<65536?(p[R++]=224|(v&61440)>>>12,p[R++]=128|(v&4032)>>>6,p[R++]=128|(v&63)>>>0):(p[R++]=240|(v&1835008)>>>18,p[R++]=128|(v&258048)>>>12,p[R++]=128|(v&4032)>>>6,p[R++]=128|(v&63)>>>0),R>=c.BLOCK_SIZE&&(this.y(),R-=c.BLOCK_SIZE,this.t+=c.BLOCK_SIZE,p[0]=p[c.BLOCK_SIZE+0],p[1]=p[c.BLOCK_SIZE+1],p[2]=p[c.BLOCK_SIZE+2]),R}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,c.UNICODE_REPLACEMENT)),this.t+=this.r,this.x()),I(this.h)+I(this.l)+I(this.m)+I(this.n)+I(this.o)}x(){this.p[this.r++]=128,m(this.p,this.r),this.r>56&&(this.y(),m(this.p));const p=8*this.t;this.q.setUint32(56,Math.floor(p/4294967296),!1),this.q.setUint32(60,p%4294967296,!1),this.y()}y(){const p=b.g,R=this.q;for(let u=0;u<64;u+=4)p.setUint32(u,R.getUint32(u,!1),!1);for(let u=64;u<320;u+=4)p.setUint32(u,f(p.getUint32(u-12,!1)^p.getUint32(u-32,!1)^p.getUint32(u-56,!1)^p.getUint32(u-64,!1),1),!1);let v=this.h,i=this.l,l=this.m,n=this.n,r=this.o,t,s,o;for(let u=0;u<80;u++)u<20?(t=i&l|~i&n,s=1518500249):u<40?(t=i^l^n,s=1859775393):u<60?(t=i&l|i&n|l&n,s=2400959708):(t=i^l^n,s=3395469782),o=f(v,5)+t+r+s+p.getUint32(u*4,!1)&4294967295,r=n,n=l,l=f(i,30),i=v,v=o;this.h=this.h+v&4294967295,this.l=this.l+i&4294967295,this.m=this.m+l&4294967295,this.n=this.n+n&4294967295,this.o=this.o+r&4294967295}}e.$wj=b}),define(ce[57],le([0,1,31]),function(Q,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),S=ye(S);var P;(function(y){y[y.Ignore=0]="Ignore",y[y.Info=1]="Info",y[y.Warning=2]="Warning",y[y.Error=3]="Error"})(P||(P={})),function(y){const k="error",L="warning",O="warn",g="info",a="ignore";function d(f){return f?S.$Df(k,f)?y.Error:S.$Df(L,f)||S.$Df(O,f)?y.Warning:S.$Df(g,f)?y.Info:y.Ignore:y.Ignore}y.fromValue=d;function c(f){switch(f){case y.Error:return k;case y.Warning:return L;case y.Info:return g;default:return a}}y.toString=c}(P||(P={})),e.default=P}),define(ce[81],le([0,1,11]),function(Q,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ar=P,e.$br=y,e.$cr=k,e.log=O;function P(a){const d=a;return d&&typeof d.type=="string"&&typeof d.severity=="string"}function y(a){const d=[];let c;try{const f=JSON.parse(a.arguments),m=f[f.length-1];m&&m.__$stack&&(f.pop(),c=m.__$stack),d.push(...f)}catch{d.push("Unable to log remote console arguments",a.arguments)}return{args:d,stack:c}}function k(a){if(typeof a!="string")return k(y(a).stack);const d=a;if(d){const c=L(d),f=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(c||"");if(f&&f.length===4)return{uri:S.URI.file(f[1]),line:Number(f[2]),column:Number(f[3])}}}function L(a){if(!a)return a;const d=a.indexOf(`
`);return d===-1?a:a.substring(0,d)}function O(a,d){const{args:c,stack:f}=y(a),m=typeof c[0]=="string"&&c.length===1;let $=L(f);$&&($=`(${$.trim()})`);let I=[];if(typeof c[0]=="string"?$&&m?I=[`%c[${d}] %c${c[0]} %c${$}`,g("blue"),g(""),g("grey")]:I=[`%c[${d}] %c${c[0]}`,g("blue"),g(""),...c.slice(1)]:I=[`%c[${d}]%`,g("blue"),...c],$&&!m&&I.push($),typeof console[a.severity]!="function")throw new Error("Unknown console method");console[a.severity].apply(console,I)}function g(a){return`color: ${a}`}}),define(ce[48],le([0,1,13,11,147]),function(Q,e,S,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0h=k,e.$$h=L,e.$_h=g;function k(a){return JSON.stringify(a,O)}function L(a){let d=JSON.parse(a);return d=g(d),d}function O(a,d){return d instanceof RegExp?{$mid:y.MarshalledId.Regexp,source:d.source,flags:d.flags}:d}function g(a,d=0){if(!a||d>200)return a;if(typeof a=="object"){switch(a.$mid){case y.MarshalledId.Uri:return P.URI.revive(a);case y.MarshalledId.Regexp:return new RegExp(a.source,a.flags);case y.MarshalledId.Date:return new Date(a.source)}if(a instanceof S.$Le||a instanceof Uint8Array)return a;if(Array.isArray(a))for(let c=0;c<a.length;++c)a[c]=g(a[c],d+1);else for(const c in a)Object.hasOwnProperty.call(a,c)&&(a[c]=g(a[c],d+1))}return a}}),define(ce[82],le([0,1,74,14,12,3,11]),function(Q,e,S,P,y,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sE=c,e.$tE=f,y=ye(y);class O{constructor($,I,b){this.id=$,this.dependencies=I,this.callback=b}}class g{static{this.INSTANCE=new g}constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=($,I,b)=>{typeof $!="string"&&(b=I,I=$,$=null),(typeof I!="object"||!Array.isArray(I))&&(b=I,I=null),this.c.push(new O($,I,b))},globalThis.define.amd=!0,this.b?this.f=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL($){if($.startsWith(window.location.origin)||$.startsWith("vscode-file://vscode-app"))return $;throw new Error(`[trusted_script_src] Invalid script url: ${$}`)}}):this.a&&(this.f=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL($){return $}})))}async load($){this.g();const I=await(this.a?this.i($):this.b?this.h($):this.j($));if(!I)throw new Error(`Did not receive a define call from script ${$}`);if(Array.isArray(I.dependencies)&&I.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${$}. The dependencies are: ${I.dependencies.join(", ")}`);return typeof I.callback=="function"?I.callback([]):I.callback}h($){return new Promise((I,b)=>{const h=document.createElement("script");h.setAttribute("async","async"),h.setAttribute("type","text/javascript");const p=()=>{h.removeEventListener("load",R),h.removeEventListener("error",v)},R=i=>{p(),I(this.c.pop())},v=i=>{p(),b(i)};h.addEventListener("load",R),h.addEventListener("error",v),this.f&&($=this.f.createScriptURL($)),h.setAttribute("src",$),window.document.getElementsByTagName("head")[0].appendChild(h)})}i($){return new Promise((I,b)=>{try{this.f&&($=this.f.createScriptURL($)),importScripts($),I(this.c.pop())}catch(h){b(h)}})}async j($){try{const I=globalThis._VSCODE_NODE_MODULES.fs,b=globalThis._VSCODE_NODE_MODULES.vm,h=globalThis._VSCODE_NODE_MODULES.module,p=L.URI.parse($).fsPath,R=I.readFileSync(p).toString(),v=h.wrap(R.replace(/^#!.*/,""));return new b.Script(v).runInThisContext().apply(),this.c.pop()}catch(I){throw I}}}const a=new Map;let d={};typeof globalThis.require=="object"&&(d=globalThis.require.paths??{});async function c(m,$,I){if(S.$R){I===void 0&&(I=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),d[m]&&(m=d[m]);const b=$?`${m}/${$}`:m;if(a.has(b))return a.get(b);let h;if(/^\w[\w\d+.-]*:\/\//.test(b))h=b;else{const i=`${I&&!y.$p?P.$Tg:P.$Sg}/${b}`;h=P.$Wg.asBrowserUri(i).toString(!0)}const p=g.INSTANCE.load(h);return a.set(b,p),p}else return await new Promise((b,h)=>{Q([m],b,h)}).then(ye)}function f(m,$){(0,k.$mg)(S.$R);const h=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit&&!y.$p,p=`${m}/${$}`,v=`${h?P.$Tg:P.$Sg}/${p}`;return P.$Wg.asBrowserUri(v).toString(!0)}}),define(ce[27],le([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yg=void 0,e.$Xg=P;const S=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function P(y){return S.test(y)}e.$Yg=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let y;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?y=crypto.getRandomValues.bind(crypto):y=function(O){for(let g=0;g<O.length;g++)O[g]=Math.floor(Math.random()*256);return O};const k=new Uint8Array(16),L=[];for(let O=0;O<256;O++)L.push(O.toString(16).padStart(2,"0"));return function(){y(k),k[6]=k[6]&15|64,k[8]=k[8]&63|128;let g=0,a="";return a+=L[k[g++]],a+=L[k[g++]],a+=L[k[g++]],a+=L[k[g++]],a+="-",a+=L[k[g++]],a+=L[k[g++]],a+="-",a+=L[k[g++]],a+=L[k[g++]],a+="-",a+=L[k[g++]],a+=L[k[g++]],a+="-",a+=L[k[g++]],a+=L[k[g++]],a+=L[k[g++]],a+=L[k[g++]],a+=L[k[g++]],a+=L[k[g++]],a}}()}),define(ce[83],le([0,1,35]),function(Q,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$On=k;const P=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function y(L){const O=L.replace(/\-/g,":").toLowerCase();return!P.has(O)}function k(){const L=(0,S.networkInterfaces)();for(const O in L){const g=L[O];if(g){for(const{mac:a}of g)if(y(a))return a}}throw new Error("Unable to retrieve mac address (unexpected format)")}}),define(ce[84],le([0,1,35,49,27,83,12]),function(Q,e,S,P,y,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pn=void 0,e.$Qn=g,e.$Rn=c,e.$Sn=f,y=ye(y),e.$Pn=new class{c(m){return this.a||(this.a=P.$Ii.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr(m)}value(){if(this.b===void 0){let m=0,$=0;const I=(0,S.networkInterfaces)();for(const b in I){const h=I[b];if(h)for(const{mac:p,internal:R}of h)R||($+=1,this.c(p.toUpperCase())&&(m+=1))}this.b=$>0?m/$:0}return this.b}};let O;async function g(m){return O||(O=(async()=>await a(m)||y.$Yg())()),O}async function a(m){try{const $=await new Promise((b,h)=>{Q(["crypto"],b,h)}).then(ye),I=(0,k.$On)();return $.createHash("sha256").update(I,"utf8").digest("hex")}catch($){m($);return}}const d="Software\\Microsoft\\SQMClient";async function c(m){if(L.$j){const $=await new Promise((I,b)=>{Q(["@vscode/windows-registry"],I,b)}).then(ye);try{return $.GetStringRegKey("HKEY_LOCAL_MACHINE",d,"MachineId")||""}catch(I){return m(I),""}}return""}async function f(m){try{return await(await new Promise((b,h)=>{Q(["@vscode/deviceid"],b,h)}).then(ye)).getDeviceId()}catch($){return m($),""}}}),define(ce[85],le([0,1,35,15,28]),function(Q,e,S,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tm=p,e.$um=R,S=ye(S),P=ye(P),y=ye(y);const k=/^\d+$/,L=/^Microsoft.PowerShell_.*/,O=/^Microsoft.PowerShellPreview_.*/;var g;(function(v){v[v.x64=0]="x64",v[v.x86=1]="x86",v[v.ARM=2]="ARM"})(g||(g={}));let a;switch(process.arch){case"ia32":a=g.x86;break;case"arm":case"arm64":a=g.ARM;break;default:a=g.x64;break}let d;process.env.PROCESSOR_ARCHITEW6432?d=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?g.ARM:g.x64:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?d=g.ARM:process.env.PROCESSOR_ARCHITECTURE==="X86"?d=g.x86:d=g.x64;class c{constructor(i,l,n){this.exePath=i,this.displayName=l,this.a=n}async exists(){return this.a===void 0&&(this.a=await y.SymlinkSupport.existsFile(this.exePath)),this.a}}function f({useAlternateBitness:v=!1}={}){return v?a===g.x64?process.env["ProgramFiles(x86)"]||null:d===g.x64&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function m({useAlternateBitness:v=!1,findPreview:i=!1}={}){const l=f({useAlternateBitness:v});if(!l)return null;const n=P.$ic(l,"PowerShell");if(!await y.SymlinkSupport.existsDirectory(n))return null;let r=-1,t=null;for(const u of await y.Promises.readdir(n)){let w=-1;if(i){const T=u.indexOf("-");if(T<0)continue;const D=u.substring(0,T);if(!k.test(D)||u.substring(T+1)!=="preview")continue;w=parseInt(D,10)}else{if(!k.test(u))continue;w=parseInt(u,10)}if(w<=r)continue;const A=P.$ic(n,u,"pwsh.exe");await y.SymlinkSupport.existsFile(A)&&(t=A,r=w)}if(!t)return null;const s=l.includes("x86")?" (x86)":"",o=i?" Preview":"";return new c(t,`PowerShell${o}${s}`,!0)}async function $({findPreview:v}={}){if(!process.env.LOCALAPPDATA)return null;const i=P.$ic(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await y.SymlinkSupport.existsDirectory(i))return null;const{pwshMsixDirRegex:l,pwshMsixName:n}=v?{pwshMsixDirRegex:O,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:L,pwshMsixName:"PowerShell (Store)"};for(const r of await y.Promises.readdir(i))if(l.test(r)){const t=P.$ic(i,r,"pwsh.exe");return new c(t,n)}return null}function I(){const v=P.$ic(S.homedir(),".dotnet","tools","pwsh.exe");return new c(v,".NET Core PowerShell Global Tool")}function b(){const v=P.$ic(process.env.windir,a===g.x86&&d!==g.x86?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new c(v,"Windows PowerShell",!0)}async function*h(){let v=await m();v&&(yield v),v=await m({useAlternateBitness:!0}),v&&(yield v),v=await $(),v&&(yield v),v=I(),v&&(yield v),v=await m({findPreview:!0}),v&&(yield v),v=await $({findPreview:!0}),v&&(yield v),v=await m({useAlternateBitness:!0,findPreview:!0}),v&&(yield v),v=b(),v&&(yield v)}async function*p(){for await(const v of h())await v.exists()&&(yield v)}async function R(){for await(const v of p())return v;return null}}),define(ce[58],le([0,1,32,15,12,36,56,3,28]),function(Q,e,S,P,y,k,L,O,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.TerminateResponseCode=e.Source=void 0,e.$vm=a,e.$wm=d,P=ye(P),y=ye(y),k=ye(k),O=ye(O),g=ye(g),Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return L.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return L.TerminateResponseCode}});function a(f=k.env){return f.comspec||"cmd.exe"}function d(f){let m=[],$=!1;const I=function(b){if($){m.push(b);return}(!f.send(b,p=>{if(p&&console.error(p),$=!1,m.length>0){const R=m.slice(0);m=[],R.forEach(v=>I(v))}})||y.$j)&&($=!0)};return{send:I}}var c;(function(f){async function m($,I,b){if(P.$hc($))return $;if(I===void 0&&(I=k.cwd()),P.$lc($)!=="."||(b===void 0&&O.$cg(k.env.PATH)&&(b=k.env.PATH.split(P.$sc)),b===void 0||b.length===0))return P.$ic(I,$);async function p(R){if(await g.Promises.exists(R)){let v;try{v=await S.promises.stat(R)}catch(i){i.message.startsWith("EACCES")&&(v=await S.promises.lstat(R))}return v?!v.isDirectory():!1}return!1}for(const R of b){let v;if(P.$hc(R)?v=P.$ic(R,$):v=P.$ic(I,R,$),await p(v))return v;let i=v+".com";if(await p(i)||(i=v+".exe",await p(i)))return i}return P.$ic(I,$)}f.findExecutable=m})(c||(e.win32=c={}))}),define(ce[86],le([0,1,35,12,85,58]),function(Q,e,S,P,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xm=L,P=ye(P),k=ye(k);async function L(c,f){return c===P.OperatingSystem.Windows?P.$j?d():k.$vm(f):g(c,f)}let O=null;function g(c,f){if(P.$l&&c===P.OperatingSystem.Macintosh||P.$k&&c===P.OperatingSystem.Linux)return"/bin/bash";if(!O){let m;if(P.$j)m="/bin/bash";else{if(m=f.SHELL,!m)try{m=(0,S.userInfo)().shell}catch{}m||(m="sh"),m==="/bin/false"&&(m="/bin/bash")}O=m}return O}let a=null;async function d(){return a||(a=(await(0,y.$um)()).exePath),a}});var ve=this&&this.__decorate||function(Q,e,S,P){var y=arguments.length,k=y<3?e:P===null?P=Object.getOwnPropertyDescriptor(e,S):P,L;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")k=Reflect.decorate(Q,e,S,P);else for(var O=Q.length-1;O>=0;O--)(L=Q[O])&&(k=(y<3?L(k):y>3?L(e,S,k):L(e,S))||k);return y>3&&k&&Object.defineProperty(e,S,k),k};define(ce[59],le([0,1,19,8,13,21,55,7,4,2,48,31,3]),function(Q,e,S,P,y,k,L,O,g,a,d,c,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$li=e.ProxyChannel=e.$ki=e.$hi=e.$gi=e.$fi=e.RequestInitiator=e.$ei=e.$bi=e.$ai=void 0,e.$ci=o,e.$di=u,e.$ii=M,e.$ji=Y,c=ye(c);var m;(function(B){B[B.Promise=100]="Promise",B[B.PromiseCancel=101]="PromiseCancel",B[B.EventListen=102]="EventListen",B[B.EventDispose=103]="EventDispose"})(m||(m={}));function $(B){switch(B){case m.Promise:return"req";case m.PromiseCancel:return"cancel";case m.EventListen:return"subscribe";case m.EventDispose:return"unsubscribe"}}var I;(function(B){B[B.Initialize=200]="Initialize",B[B.PromiseSuccess=201]="PromiseSuccess",B[B.PromiseError=202]="PromiseError",B[B.PromiseErrorObj=203]="PromiseErrorObj",B[B.EventFire=204]="EventFire"})(I||(I={}));function b(B){switch(B){case I.Initialize:return"init";case I.PromiseSuccess:return"reply:";case I.PromiseError:case I.PromiseErrorObj:return"replyErr:";case I.EventFire:return"event:"}}var h;(function(B){B[B.Uninitialized=0]="Uninitialized",B[B.Idle=1]="Idle"})(h||(h={}));function p(B){let z=0;for(let x=0;;x+=7){const X=B.read(1);if(z|=(X.buffer[0]&127)<<x,!(X.buffer[0]&128))return z}}const R=r(0);function v(B,z){if(z===0){B.write(R);return}let x=0;for(let ee=z;ee!==0;ee=ee>>>7)x++;const X=y.$Le.alloc(x);for(let ee=0;z!==0;ee++)X.buffer[ee]=z&127,z=z>>>7,z>0&&(X.buffer[ee]|=128);B.write(X)}class i{constructor(z){this.b=z,this.a=0}read(z){const x=this.b.slice(this.a,this.a+z);return this.a+=x.byteLength,x}}e.$ai=i;class l{constructor(){this.a=[]}get buffer(){return y.$Le.concat(this.a)}write(z){this.a.push(z)}}e.$bi=l;var n;(function(B){B[B.Undefined=0]="Undefined",B[B.String=1]="String",B[B.Buffer=2]="Buffer",B[B.VSBuffer=3]="VSBuffer",B[B.Array=4]="Array",B[B.Object=5]="Object",B[B.Int=6]="Int"})(n||(n={}));function r(B){const z=y.$Le.alloc(1);return z.writeUInt8(B,0),z}const t={Undefined:r(n.Undefined),String:r(n.String),Buffer:r(n.Buffer),VSBuffer:r(n.VSBuffer),Array:r(n.Array),Object:r(n.Object),Uint:r(n.Int)},s=typeof Buffer<"u";function o(B,z){if(typeof z>"u")B.write(t.Undefined);else if(typeof z=="string"){const x=y.$Le.fromString(z);B.write(t.String),v(B,x.byteLength),B.write(x)}else if(s&&Buffer.isBuffer(z)){const x=y.$Le.wrap(z);B.write(t.Buffer),v(B,x.byteLength),B.write(x)}else if(z instanceof y.$Le)B.write(t.VSBuffer),v(B,z.byteLength),B.write(z);else if(Array.isArray(z)){B.write(t.Array),v(B,z.length);for(const x of z)o(B,x)}else if(typeof z=="number"&&(z|0)===z)B.write(t.Uint),v(B,z);else{const x=y.$Le.fromString(JSON.stringify(z));B.write(t.Object),v(B,x.byteLength),B.write(x)}}function u(B){switch(B.read(1).readUInt8(0)){case n.Undefined:return;case n.String:return B.read(p(B)).toString();case n.Buffer:return B.read(p(B)).buffer;case n.VSBuffer:return B.read(p(B));case n.Array:{const x=p(B),X=[];for(let ee=0;ee<x;ee++)X.push(u(B));return X}case n.Object:return JSON.parse(B.read(p(B)).toString());case n.Int:return p(B)}}class w{constructor(z,x,X=null,ee=1e3){this.h=z,this.j=x,this.k=X,this.l=ee,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(ie=>this.q(ie)),this.m({type:I.Initialize})}registerChannel(z,x){this.b.set(z,x),setTimeout(()=>this.w(z),0)}m(z){switch(z.type){case I.Initialize:{const x=this.o([z.type]);this.k?.logOutgoing(x,0,A.OtherSide,b(z.type));return}case I.PromiseSuccess:case I.PromiseError:case I.EventFire:case I.PromiseErrorObj:{const x=this.o([z.type,z.id],z.data);this.k?.logOutgoing(x,z.id,A.OtherSide,b(z.type),z.data);return}}}o(z,x=void 0){const X=new l;return o(X,z),o(X,x),this.p(X.buffer)}p(z){try{return this.h.send(z),z.byteLength}catch{return 0}}q(z){const x=new i(z),X=u(x),ee=u(x),ie=X[0];switch(ie){case m.Promise:return this.k?.logIncoming(z.byteLength,X[1],A.OtherSide,`${$(ie)}: ${X[2]}.${X[3]}`,ee),this.s({type:ie,id:X[1],channelName:X[2],name:X[3],arg:ee});case m.EventListen:return this.k?.logIncoming(z.byteLength,X[1],A.OtherSide,`${$(ie)}: ${X[2]}.${X[3]}`,ee),this.t({type:ie,id:X[1],channelName:X[2],name:X[3],arg:ee});case m.PromiseCancel:return this.k?.logIncoming(z.byteLength,X[1],A.OtherSide,`${$(ie)}`),this.u({type:ie,id:X[1]});case m.EventDispose:return this.k?.logIncoming(z.byteLength,X[1],A.OtherSide,`${$(ie)}`),this.u({type:ie,id:X[1]})}}s(z){const x=this.b.get(z.channelName);if(!x){this.v(z);return}const X=new k.$ue;let ee;try{ee=x.call(this.j,z.name,z.arg,X.token)}catch(W){ee=Promise.reject(W)}const ie=z.id;ee.then(W=>{this.m({id:ie,data:W,type:I.PromiseSuccess})},W=>{W instanceof Error?this.m({id:ie,data:{message:W.message,name:W.name,stack:W.stack?W.stack.split(`
`):void 0},type:I.PromiseError}):this.m({id:ie,data:W,type:I.PromiseErrorObj})}).finally(()=>{j.dispose(),this.d.delete(z.id)});const j=(0,a.$Rc)(()=>X.cancel());this.d.set(z.id,j)}t(z){const x=this.b.get(z.channelName);if(!x){this.v(z);return}const X=z.id,ie=x.listen(this.j,z.name,z.arg)(j=>this.m({id:X,data:j,type:I.EventFire}));this.d.set(z.id,ie)}u(z){const x=this.d.get(z.id);x&&(x.dispose(),this.d.delete(z.id))}v(z){let x=this.g.get(z.channelName);x||(x=[],this.g.set(z.channelName,x));const X=setTimeout(()=>{console.error(`Unknown channel: ${z.channelName}`),z.type===m.Promise&&this.m({id:z.id,data:{name:"Unknown channel",message:`Channel name '${z.channelName}' timed out after ${this.l}ms`,stack:void 0},type:I.PromiseError})},this.l);x.push({request:z,timeoutTimer:X})}w(z){const x=this.g.get(z);if(x){for(const X of x)switch(clearTimeout(X.timeoutTimer),X.request.type){case m.Promise:this.s(X.request);break;case m.EventListen:this.t(X.request);break}this.g.delete(z)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,a.$Oc)(this.d.values()),this.d.clear()}}e.$ei=w;var A;(function(B){B[B.LocalSide=0]="LocalSide",B[B.OtherSide=1]="OtherSide"})(A||(e.RequestInitiator=A={}));class T{constructor(z,x=null){this.l=z,this.a=!1,this.b=h.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new g.$je,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(X=>this.s(X)),this.j=x}getChannel(z){const x=this;return{call(X,ee,ie){return x.a?Promise.reject(new O.$4):x.m(z,X,ee,ie)},listen(X,ee){return x.a?g.Event.None:x.o(z,X,ee)}}}m(z,x,X,ee=k.CancellationToken.None){const ie=this.g++,j=m.Promise,W={id:ie,type:j,channelName:z,name:x,arg:X};if(ee.isCancellationRequested)return Promise.reject(new O.$4);let q;return new Promise((F,U)=>{if(ee.isCancellationRequested)return U(new O.$4);const C=()=>{const oe=fe=>{switch(fe.type){case I.PromiseSuccess:this.f.delete(ie),F(fe.data);break;case I.PromiseError:{this.f.delete(ie);const me=new Error(fe.data.message);me.stack=Array.isArray(fe.data.stack)?fe.data.stack.join(`
`):fe.data.stack,me.name=fe.data.name,U(me);break}case I.PromiseErrorObj:this.f.delete(ie),U(fe.data);break}};this.f.set(ie,oe),this.p(W)};let G=null;this.b===h.Idle?C():(G=(0,P.$ph)(oe=>this.u()),G.then(()=>{G=null,C()}));const J=()=>{G?(G.cancel(),G=null):this.p({id:ie,type:m.PromiseCancel}),U(new O.$4)},ne=ee.onCancellationRequested(J);q=(0,a.$Qc)((0,a.$Rc)(J),ne),this.d.add(q)}).finally(()=>{q.dispose(),this.d.delete(q)})}o(z,x,X){const ee=this.g++,ie=m.EventListen,j={id:ee,type:ie,channelName:z,name:x,arg:X};let W=null;const q=new g.$je({onWillAddFirstListener:()=>{W=(0,P.$ph)(F=>this.u()),W.then(()=>{W=null,this.d.add(q),this.p(j)})},onDidRemoveLastListener:()=>{W?(W.cancel(),W=null):(this.d.delete(q),this.p({id:ee,type:m.EventDispose}))}}),E=F=>q.fire(F.data);return this.f.set(ee,E),q.event}p(z){switch(z.type){case m.Promise:case m.EventListen:{const x=this.q([z.type,z.id,z.channelName,z.name],z.arg);this.j?.logOutgoing(x,z.id,A.LocalSide,`${$(z.type)}: ${z.channelName}.${z.name}`,z.arg);return}case m.PromiseCancel:case m.EventDispose:{const x=this.q([z.type,z.id]);this.j?.logOutgoing(x,z.id,A.LocalSide,$(z.type));return}}}q(z,x=void 0){const X=new l;return o(X,z),o(X,x),this.r(X.buffer)}r(z){try{return this.l.send(z),z.byteLength}catch{return 0}}s(z){const x=new i(z),X=u(x),ee=u(x),ie=X[0];switch(ie){case I.Initialize:return this.j?.logIncoming(z.byteLength,0,A.LocalSide,b(ie)),this.t({type:X[0]});case I.PromiseSuccess:case I.PromiseError:case I.EventFire:case I.PromiseErrorObj:return this.j?.logIncoming(z.byteLength,X[1],A.LocalSide,b(ie),ee),this.t({type:X[0],id:X[1],data:ee})}}t(z){if(z.type===I.Initialize){this.b=h.Idle,this.k.fire();return}this.f.get(z.id)?.(z)}get onDidInitializePromise(){return g.Event.toPromise(this.onDidInitialize)}u(){return this.b===h.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,a.$Oc)(this.d.values()),this.d.clear()}}e.$fi=T,ve([L.$7h],T.prototype,"onDidInitializePromise",null);class D{get connections(){const z=[];return this.f.forEach(x=>z.push(x)),z}constructor(z,x,X){this.a=new Map,this.f=new Set,this.g=new g.$je,this.onDidAddConnection=this.g.event,this.h=new g.$je,this.onDidRemoveConnection=this.h.event,this.j=new a.$Sc,this.j.add(z(({protocol:ee,onDidClientDisconnect:ie})=>{const j=g.Event.once(ee.onMessage);this.j.add(j(W=>{const q=new i(W),E=u(q),F=new w(ee,E,x,X),U=new T(ee,x);this.a.forEach((G,J)=>F.registerChannel(J,G));const C={channelServer:F,channelClient:U,ctx:E};this.f.add(C),this.g.fire(C),this.j.add(ie(()=>{F.dispose(),U.dispose(),this.f.delete(C),this.h.fire(C)}))}))}))}getChannel(z,x){const X=this;return{call(ee,ie,j){let W;if((0,f.$qg)(x)){const E=(0,S.$2b)(X.connections.filter(x));W=E?Promise.resolve(E):g.Event.toPromise(g.Event.filter(X.onDidAddConnection,x))}else W=x.routeCall(X,ee,ie);const q=W.then(E=>E.channelClient.getChannel(z));return M(q).call(ee,ie,j)},listen(ee,ie){if((0,f.$qg)(x))return X.k(z,x,ee,ie);const j=x.routeEvent(X,ee,ie).then(W=>W.channelClient.getChannel(z));return M(j).listen(ee,ie)}}}k(z,x,X,ee){const ie=this;let j;const W=new g.$je({onWillAddFirstListener:()=>{j=new a.$Sc;const q=new g.$pe,E=new Map,F=C=>{const J=C.channelClient.getChannel(z).listen(X,ee),ne=q.add(J);E.set(C,ne)},U=C=>{const G=E.get(C);G&&(G.dispose(),E.delete(C))};ie.connections.filter(x).forEach(F),g.Event.filter(ie.onDidAddConnection,x)(F,void 0,j),ie.onDidRemoveConnection(U,void 0,j),q.event(W.fire,W,j),j.add(q)},onDidRemoveLastListener:()=>{j?.dispose(),j=void 0}});return W.event}registerChannel(z,x){this.a.set(z,x);for(const X of this.f)X.channelServer.registerChannel(z,x)}dispose(){this.j.dispose();for(const z of this.f)z.channelClient.dispose(),z.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$gi=D;class N{constructor(z,x,X=null){const ee=new l;o(ee,x),z.send(ee.buffer),this.a=new T(z,X),this.d=new w(z,x,X)}getChannel(z){return this.a.getChannel(z)}registerChannel(z,x){this.d.registerChannel(z,x)}dispose(){this.a.dispose(),this.d.dispose()}}e.$hi=N;function M(B){return{call(z,x,X){return B.then(ee=>ee.call(z,x,X))},listen(z,x){const X=new g.$se;return B.then(ee=>X.input=ee.listen(z,x)),X.event}}}function Y(B){let z=!1;return{call(x,X,ee){return z?B.call(x,X,ee):(0,P.$Dh)(0).then(()=>z=!0).then(()=>B.call(x,X,ee))},listen(x,X){if(z)return B.listen(x,X);const ee=new g.$se;return(0,P.$Dh)(0).then(()=>z=!0).then(()=>ee.input=B.listen(x,X)),ee.event}}}class K{constructor(z){this.a=z}routeCall(z){return this.b(z)}routeEvent(z){return this.b(z)}async b(z){for(const x of z.connections)if(await Promise.resolve(this.a(x.ctx)))return Promise.resolve(x);return await g.Event.toPromise(z.onDidAddConnection),await this.b(z)}}e.$ki=K;var re;(function(B){function z(ie,j,W){const q=ie,E=W&&W.disableMarshalling,F=new Map;for(const U in q)X(U)&&F.set(U,g.Event.buffer(q[U],!0,void 0,j));return new class{listen(U,C,G){const J=F.get(C);if(J)return J;const ne=q[C];if(typeof ne=="function"){if(ee(C))return ne.call(q,G);if(X(C))return F.set(C,g.Event.buffer(q[C],!0,void 0,j)),F.get(C)}throw new O.$ab(`Event not found: ${C}`)}call(U,C,G){const J=q[C];if(typeof J=="function"){if(!E&&Array.isArray(G))for(let oe=0;oe<G.length;oe++)G[oe]=(0,d.$_h)(G[oe]);let ne=J.apply(q,G);return ne instanceof Promise||(ne=Promise.resolve(ne)),ne}throw new O.$ab(`Method not found: ${C}`)}}}B.fromService=z;function x(ie,j){const W=j&&j.disableMarshalling;return new Proxy({},{get(q,E){if(typeof E=="string")return j?.properties?.has(E)?j.properties.get(E):ee(E)?function(F){return ie.listen(E,F)}:X(E)?ie.listen(E):async function(...F){let U;j&&!(0,f.$lg)(j.context)?U=[j.context,...F]:U=F;const C=await ie.call(E,U);return W?C:(0,d.$_h)(C)};throw new O.$ab(`Property not found: ${String(E)}`)}})}B.toService=x;function X(ie){return ie[0]==="o"&&ie[1]==="n"&&c.$Cf(ie.charCodeAt(2))}function ee(ie){return/^onDynamic/.test(ie)&&c.$Cf(ie.charCodeAt(9))}})(re||(e.ProxyChannel=re={}));const ae=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function ue(B){if(Array.isArray(B))return B;if(B&&typeof B=="object"&&typeof B.toString=="function"){const z=B.toString();if(z!=="[object Object]")return z}return B}function de(B){return Array.isArray(B)?B.map(ue):ue(B)}function H(B,z,x,X,ee,ie,j){j=de(j);const W=ae[ee],q=W[X%W.length];let E=[`%c[${B}]%c[${String(z).padStart(7," ")}]%c[len: ${String(x).padStart(5," ")}]%c${String(X).padStart(5," ")} - ${ie}`,"color: darkgreen","color: grey","color: grey",`color: ${q}`];/\($/.test(ie)?(E=E.concat(j),E.push(")")):E.push(j),console.log.apply(console,E)}class Z{constructor(z,x){this.d=z,this.f=x,this.a=0,this.b=0}logOutgoing(z,x,X,ee,ie){this.b+=z,H(this.d,this.b,z,x,X,ee,ie)}logIncoming(z,x,X,ee,ie){this.a+=z,H(this.f,this.a,z,x,X,ee,ie)}}e.$li=Z}),define(ce[87],le([0,1,60,8,13,21,81,7,4,2,26,58,56,59]),function(Q,e,S,P,y,k,L,O,g,a,d,c,f,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fr=e.$er=void 0,O=ye(O);class $ extends m.$ei{constructor(h){super({send:p=>{try{process.send?.(p.buffer.toString("base64"))}catch{}},onMessage:g.Event.fromNodeEventEmitter(process,"message",p=>y.$Le.wrap(Buffer.from(p,"base64")))},h),process.once("disconnect",()=>this.dispose())}}e.$er=$;class I{constructor(h,p){this.i=h,this.j=p,this.c=new Set,this.g=new Map,this.h=new g.$je,this.onDidProcessExit=this.h.event;const R=p&&p.timeout?p.timeout:6e4;this.b=new P.$zh(R),this.d=null,this.f=null}getChannel(h){const p=this;return{call(R,v,i){return p.k(h,R,v,i)},listen(R,v){return p.l(h,R,v)}}}k(h,p,R,v=k.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(v.isCancellationRequested)return Promise.reject(O.$5());this.b.cancel();const i=this.n(h),l=(0,P.$ph)(t=>i.call(p,R,t)),n=v.onCancellationRequested(()=>l.cancel()),r=(0,a.$Rc)(()=>l.cancel());return this.c.add(r),l.finally(()=>{n.dispose(),this.c.delete(r),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),l}l(h,p,R){if(!this.b)return g.Event.None;this.b.cancel();let v;const i=new g.$je({onWillAddFirstListener:()=>{v=this.n(h).listen(p,R)(i.fire,i),this.c.add(v)},onDidRemoveLastListener:()=>{this.c.delete(v),v.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return i.event}get m(){if(!this.f){const h=this.j&&this.j.args?this.j.args:[],p=Object.create(null);p.env={...(0,d.$bo)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(p.env={...p.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(p.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(p.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(p.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),p.execArgv===void 0&&(p.execArgv=process.execArgv.filter(o=>!/^--inspect(-brk)?=/.test(o)).filter(o=>!o.startsWith("--vscode-"))),(0,f.$jm)(p.env),this.d=(0,S.fork)(this.i,h,p);const R=new g.$je,i=g.Event.fromNodeEventEmitter(this.d,"message",o=>o)(o=>{if((0,L.$ar)(o)){(0,L.log)(o,`IPC Library: ${this.j.serverName}`);return}R.fire(y.$Le.wrap(Buffer.from(o,"base64")))}),l=this.j.useQueue?(0,c.$wm)(this.d):this.d,n=o=>this.d&&this.d.connected&&l.send(o.buffer.toString("base64")),r=R.event,t={send:n,onMessage:r};this.f=new m.$fi(t);const s=()=>this.o();process.once("exit",s),this.d.on("error",o=>console.warn('IPC "'+this.j.serverName+'" errored with '+o)),this.d.on("exit",(o,u)=>{process.removeListener("exit",s),i.dispose(),this.c.forEach(w=>(0,a.$Oc)(w)),this.c.clear(),o!==0&&u!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+o+" and signal "+u),this.b?.cancel(),this.o(),this.h.fire({code:o,signal:u})})}return this.f}n(h){let p=this.g.get(h);return p||(p=this.m.getChannel(h),this.g.set(h,p)),p}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$fr=I}),define(ce[88],le([0,1,8,4,2,48,3]),function(Q,e,S,P,y,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cq=e.$bq=e.StorageState=e.StorageHint=void 0,e.$aq=g;var O;(function(f){f[f.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",f[f.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(O||(e.StorageHint=O={}));function g(f){const m=f;return m?.changed instanceof Map||m?.deleted instanceof Set}var a;(function(f){f[f.None=0]="None",f[f.Initialized=1]="Initialized",f[f.Closed=2]="Closed"})(a||(e.StorageState=a={}));class d extends y.$Tc{static{this.a=100}constructor(m,$=Object.create(null)){super(),this.r=m,this.s=$,this.b=this.B(new P.$me),this.onDidChangeStorage=this.b.event,this.c=a.None,this.f=new Map,this.g=this.B(new S.$Ah(d.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(m=>this.u(m)))}u(m){this.b.pause();try{m.changed?.forEach(($,I)=>this.w(I,$)),m.deleted?.forEach($=>this.w($,void 0))}finally{this.b.resume()}}w(m,$){if(this.c===a.Closed)return;let I=!1;(0,L.$lg)($)?I=this.f.delete(m):this.f.get(m)!==$&&(this.f.set(m,$),I=!0),I&&this.b.fire({key:m,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===a.None&&(this.c=a.Initialized,this.s.hint!==O.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(m,$){const I=this.f.get(m);return(0,L.$lg)(I)?$:I}getBoolean(m,$){const I=this.get(m);return(0,L.$lg)(I)?$:I==="true"}getNumber(m,$){const I=this.get(m);return(0,L.$lg)(I)?$:parseInt(I,10)}getObject(m,$){const I=this.get(m);return(0,L.$lg)(I)?$:(0,k.$$h)(I)}async set(m,$,I=!1){if(this.c===a.Closed)return;if((0,L.$lg)($))return this.delete(m,I);const b=(0,L.$eg)($)||Array.isArray($)?(0,k.$0h)($):String($);if(this.f.get(m)!==b)return this.f.set(m,b),this.j.set(m,b),this.h.delete(m),this.b.fire({key:m,external:I}),this.D()}async delete(m,$=!1){if(!(this.c===a.Closed||!this.f.delete(m)))return this.h.has(m)||this.h.add(m),this.j.delete(m),this.b.fire({key:m,external:$}),this.D()}async optimize(){if(this.c!==a.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=a.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const m={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(m).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(m){if(!(this.c===a.Closed||this.m))return this.D(m)}async D(m){return this.s.hint===O.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),m)}async whenFlushed(){if(this.z)return new Promise(m=>this.n.push(m))}isInMemory(){return this.s.hint===O.STORAGE_IN_MEMORY}}e.$bq=d;class c{constructor(){this.onDidChangeItemsExternal=P.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(m){m.insert?.forEach(($,I)=>this.a.set(I,$)),m.delete?.forEach($=>this.a.delete($))}async optimize(){}async close(){}}e.$cq=c}),define(ce[89],le([0,1,5]),function(Q,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ym=a,e.$Zm=d,e.$1m=c;const P=60,y=P*60,k=y*24,L=k*7,O=k*30,g=k*365;function a(f,m,$,I){typeof f!="number"&&(f=f.getTime());const b=Math.round((new Date().getTime()-f)/1e3);if(b<-30)return(0,S.localize)(12831,null,a(new Date().getTime()+b*1e3,!1));if(!I&&b<30)return(0,S.localize)(12832,null);let h;return b<P?(h=b,m?h===1?$?(0,S.localize)(12833,null,h):(0,S.localize)(12834,null,h):$?(0,S.localize)(12835,null,h):(0,S.localize)(12836,null,h):h===1?$?(0,S.localize)(12837,null,h):(0,S.localize)(12838,null,h):$?(0,S.localize)(12839,null,h):(0,S.localize)(12840,null,h)):b<y?(h=Math.floor(b/P),m?h===1?$?(0,S.localize)(12841,null,h):(0,S.localize)(12842,null,h):$?(0,S.localize)(12843,null,h):(0,S.localize)(12844,null,h):h===1?$?(0,S.localize)(12845,null,h):(0,S.localize)(12846,null,h):$?(0,S.localize)(12847,null,h):(0,S.localize)(12848,null,h)):b<k?(h=Math.floor(b/y),m?h===1?$?(0,S.localize)(12849,null,h):(0,S.localize)(12850,null,h):$?(0,S.localize)(12851,null,h):(0,S.localize)(12852,null,h):h===1?$?(0,S.localize)(12853,null,h):(0,S.localize)(12854,null,h):$?(0,S.localize)(12855,null,h):(0,S.localize)(12856,null,h)):b<L?(h=Math.floor(b/k),m?h===1?(0,S.localize)(12857,null,h):(0,S.localize)(12858,null,h):h===1?(0,S.localize)(12859,null,h):(0,S.localize)(12860,null,h)):b<O?(h=Math.floor(b/L),m?h===1?$?(0,S.localize)(12861,null,h):(0,S.localize)(12862,null,h):$?(0,S.localize)(12863,null,h):(0,S.localize)(12864,null,h):h===1?$?(0,S.localize)(12865,null,h):(0,S.localize)(12866,null,h):$?(0,S.localize)(12867,null,h):(0,S.localize)(12868,null,h)):b<g?(h=Math.floor(b/O),m?h===1?$?(0,S.localize)(12869,null,h):(0,S.localize)(12870,null,h):$?(0,S.localize)(12871,null,h):(0,S.localize)(12872,null,h):h===1?$?(0,S.localize)(12873,null,h):(0,S.localize)(12874,null,h):$?(0,S.localize)(12875,null,h):(0,S.localize)(12876,null,h)):(h=Math.floor(b/g),m?h===1?$?(0,S.localize)(12877,null,h):(0,S.localize)(12878,null,h):$?(0,S.localize)(12879,null,h):(0,S.localize)(12880,null,h):h===1?$?(0,S.localize)(12881,null,h):(0,S.localize)(12882,null,h):$?(0,S.localize)(12883,null,h):(0,S.localize)(12884,null,h))}function d(f,m){const $=Math.abs(f/1e3);return $<1?m?(0,S.localize)(12885,null,f):(0,S.localize)(12886,null,f):$<P?m?(0,S.localize)(12887,null,Math.round(f)/1e3):(0,S.localize)(12888,null,Math.round(f)/1e3):$<y?m?(0,S.localize)(12889,null,Math.round(f/(1e3*P))):(0,S.localize)(12890,null,Math.round(f/(1e3*P))):$<k?m?(0,S.localize)(12891,null,Math.round(f/(1e3*y))):(0,S.localize)(12892,null,Math.round(f/(1e3*y))):(0,S.localize)(12893,null,Math.round(f/(1e3*k)))}function c(f){return f.getFullYear()+"-"+String(f.getMonth()+1).padStart(2,"0")+"-"+String(f.getDate()).padStart(2,"0")+"T"+String(f.getHours()).padStart(2,"0")+":"+String(f.getMinutes()).padStart(2,"0")+":"+String(f.getSeconds()).padStart(2,"0")+"."+(f.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}}),define(ce[38],le([0,1,19,3,5]),function(Q,e,S,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nj=g,e.$oj=a,e.$pj=d,S=ye(S),P=ye(P),y=ye(y);function k(c,f){return f&&(c.stack||c.stacktrace)?y.localize(12825,null,O(c),L(c.stack)||L(c.stacktrace)):O(c)}function L(c){return Array.isArray(c)?c.join(`
`):c}function O(c){return c.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${c.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof c.code=="string"&&typeof c.errno=="number"&&typeof c.syscall=="string"?y.localize(12826,null,c.message):c.message||y.localize(12827,null)}function g(c=null,f=!1){if(!c)return y.localize(12828,null);if(Array.isArray(c)){const m=S.$Gb(c),$=g(m[0],f);return m.length>1?y.localize(12829,null,$,m.length):$}if(P.$cg(c))return c;if(c.detail){const m=c.detail;if(m.error)return k(m.error,f);if(m.exception)return k(m.exception,f)}return c.stack?k(c,f):c.message?c.message:y.localize(12830,null)}function a(c){const f=c;return f instanceof Error&&Array.isArray(f.actions)}function d(c,f){let m;return typeof c=="string"?m=new Error(c):m=c,m.actions=f,m}}),define(ce[90],le([0,1,5,34]),function(Q,e,S,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Iq=y;function y(k){switch(k){case P.ParseErrorCode.InvalidSymbol:return(0,S.localize)(12816,null);case P.ParseErrorCode.InvalidNumberFormat:return(0,S.localize)(12817,null);case P.ParseErrorCode.PropertyNameExpected:return(0,S.localize)(12818,null);case P.ParseErrorCode.ValueExpected:return(0,S.localize)(12819,null);case P.ParseErrorCode.ColonExpected:return(0,S.localize)(12820,null);case P.ParseErrorCode.CommaExpected:return(0,S.localize)(12821,null);case P.ParseErrorCode.CloseBraceExpected:return(0,S.localize)(12822,null);case P.ParseErrorCode.CloseBracketExpected:return(0,S.localize)(12823,null);case P.ParseErrorCode.EndOfFileExpected:return(0,S.localize)(12824,null);default:return""}}}),define(ce[50],le([0,1,32,8,15,3,28,5]),function(Q,e,S,P,y,k,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yq=e.$xq=void 0,e.zip=b,e.$Aq=h,e.$Bq=R,y=ye(y),O=ye(O),e.$xq="end of central directory record signature not found";const g=new RegExp(e.$xq);class a extends Error{constructor(i,l){let n=l.message;switch(i){case"CorruptZip":n=`Corrupt ZIP: ${n}`;break}super(n),this.type=i,this.cause=l}}e.$yq=a;function d(v){const i=v.externalFileAttributes>>16||33188;return[448,56,7].map(l=>i&l).reduce((l,n)=>l+n,i&61440)}function c(v){if(v instanceof a)return v;let i;return g.test(v.message)&&(i="CorruptZip"),new a(i,v)}function f(v,i,l,n,r,t){const s=y.$lc(i),o=y.$ic(n,s);if(!o.startsWith(n))return Promise.reject(new Error(O.localize(12793,null,i)));const u=y.$ic(n,i);let w;return t.onCancellationRequested(()=>{w?.destroy()}),Promise.resolve(S.promises.mkdir(o,{recursive:!0})).then(()=>new Promise((A,T)=>{if(!t.isCancellationRequested)try{w=(0,S.createWriteStream)(u,{mode:l}),w.once("close",()=>A()),w.once("error",T),v.once("error",T),v.pipe(w)}catch(D){T(D)}}))}function m(v,i,l,n){let r=(0,P.$ph)(()=>Promise.resolve()),t=0;const s=n.onCancellationRequested(()=>{r.cancel(),v.close()});return new Promise((o,u)=>{const w=new P.$xh,A=T=>{T.isCancellationRequested||(t++,v.readEntry())};v.once("error",u),v.once("close",()=>r.then(()=>{n.isCancellationRequested||v.entryCount===t?o():u(new a("Incomplete",new Error(O.localize(12794,null,t,v.entryCount))))},u)),v.readEntry(),v.on("entry",T=>{if(n.isCancellationRequested)return;if(!l.sourcePathRegex.test(T.fileName)){A(n);return}const D=T.fileName.replace(l.sourcePathRegex,"");if(/\/$/.test(D)){const Y=y.$ic(i,D);r=(0,P.$ph)(K=>S.promises.mkdir(Y,{recursive:!0}).then(()=>A(K)).then(void 0,u));return}const N=I(v,T),M=d(T);r=(0,P.$ph)(Y=>w.queue(()=>N.then(K=>f(K,D,M,i,l,Y).then(()=>A(Y)))).then(null,u))})}).finally(()=>s.dispose())}async function $(v,i=!1){const{open:l}=await new Promise((n,r)=>{Q(["yauzl"],n,r)}).then(ye);return new Promise((n,r)=>{l(v,i?{lazyEntries:!0}:void 0,(t,s)=>{t?r(c(t)):n((0,k.$ng)(s))})})}function I(v,i){return new Promise((l,n)=>{v.openReadStream(i,(r,t)=>{r?n(c(r)):l((0,k.$ng)(t))})})}async function b(v,i){const{ZipFile:l}=await new Promise((n,r)=>{Q(["yazl"],n,r)}).then(ye);return new Promise((n,r)=>{const t=new l;i.forEach(o=>{o.contents?t.addBuffer(typeof o.contents=="string"?Buffer.from(o.contents,"utf8"):o.contents,o.path):o.localPath&&t.addFile(o.localPath,o.path)}),t.end();const s=(0,S.createWriteStream)(v);t.outputStream.pipe(s),t.outputStream.once("error",r),s.once("error",r),s.once("finish",()=>n(v))})}function h(v,i,l={},n){const r=new RegExp(l.sourcePath?`^${l.sourcePath}`:"");let t=$(v,!0);return l.overwrite&&(t=t.then(s=>L.Promises.rm(i).then(()=>s))),t.then(s=>m(s,i,{sourcePathRegex:r},n))}function p(v,i){return $(v).then(l=>new Promise((n,r)=>{l.on("entry",t=>{t.fileName===i&&I(l,t).then(s=>n(s),s=>r(s))}),l.once("close",()=>r(new Error(O.localize(12795,null,i))))}))}function R(v,i){return p(v,i).then(l=>new Promise((n,r)=>{const t=[];l.once("error",r),l.on("data",s=>t.push(s)),l.on("end",()=>n(Buffer.concat(t)))}))}}),define(ce[91],le([0,1,92,7,5]),function(Q,e,S,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xj=e.TokenType=void 0;var k;(function(d){d[d.LParen=0]="LParen",d[d.RParen=1]="RParen",d[d.Neg=2]="Neg",d[d.Eq=3]="Eq",d[d.NotEq=4]="NotEq",d[d.Lt=5]="Lt",d[d.LtEq=6]="LtEq",d[d.Gt=7]="Gt",d[d.GtEq=8]="GtEq",d[d.RegexOp=9]="RegexOp",d[d.RegexStr=10]="RegexStr",d[d.True=11]="True",d[d.False=12]="False",d[d.In=13]="In",d[d.Not=14]="Not",d[d.And=15]="And",d[d.Or=16]="Or",d[d.Str=17]="Str",d[d.QuotedStr=18]="QuotedStr",d[d.Error=19]="Error",d[d.EOF=20]="EOF"})(k||(e.TokenType=k={}));function L(...d){switch(d.length){case 1:return(0,y.localize)(11432,null,d[0]);case 2:return(0,y.localize)(11433,null,d[0],d[1]);case 3:return(0,y.localize)(11434,null,d[0],d[1],d[2]);default:return}}const O=(0,y.localize)(11435,null),g=(0,y.localize)(11436,null);class a{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(c){switch(c.type){case k.LParen:return"(";case k.RParen:return")";case k.Neg:return"!";case k.Eq:return c.isTripleEq?"===":"==";case k.NotEq:return c.isTripleEq?"!==":"!=";case k.Lt:return"<";case k.LtEq:return"<=";case k.Gt:return">=";case k.GtEq:return">=";case k.RegexOp:return"=~";case k.RegexStr:return c.lexeme;case k.True:return"true";case k.False:return"false";case k.In:return"in";case k.Not:return"not";case k.And:return"&&";case k.Or:return"||";case k.Str:return c.lexeme;case k.QuotedStr:return c.lexeme;case k.Error:return c.lexeme;case k.EOF:return"EOF";default:throw(0,P.$7)(`unhandled token type: ${JSON.stringify(c)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(c=>c.charCodeAt(0)))}static{this.b=new Map([["not",k.Not],["in",k.In],["false",k.False],["true",k.True]])}get errors(){return this.g}reset(c){return this.c=c,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case S.CharCode.OpenParen:this.k(k.LParen);break;case S.CharCode.CloseParen:this.k(k.RParen);break;case S.CharCode.ExclamationMark:if(this.h(S.CharCode.Equals)){const f=this.h(S.CharCode.Equals);this.f.push({type:k.NotEq,offset:this.d,isTripleEq:f})}else this.k(k.Neg);break;case S.CharCode.SingleQuote:this.o();break;case S.CharCode.Slash:this.q();break;case S.CharCode.Equals:if(this.h(S.CharCode.Equals)){const f=this.h(S.CharCode.Equals);this.f.push({type:k.Eq,offset:this.d,isTripleEq:f})}else this.h(S.CharCode.Tilde)?this.k(k.RegexOp):this.l(L("==","=~"));break;case S.CharCode.LessThan:this.k(this.h(S.CharCode.Equals)?k.LtEq:k.Lt);break;case S.CharCode.GreaterThan:this.k(this.h(S.CharCode.Equals)?k.GtEq:k.Gt);break;case S.CharCode.Ampersand:this.h(S.CharCode.Ampersand)?this.k(k.And):this.l(L("&&"));break;case S.CharCode.Pipe:this.h(S.CharCode.Pipe)?this.k(k.Or):this.l(L("||"));break;case S.CharCode.Space:case S.CharCode.CarriageReturn:case S.CharCode.Tab:case S.CharCode.LineFeed:case S.CharCode.NoBreakSpace:break;default:this.n()}return this.d=this.e,this.k(k.EOF),Array.from(this.f)}h(c){return this.r()||this.c.charCodeAt(this.e)!==c?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?S.CharCode.Null:this.c.charCodeAt(this.e)}k(c){this.f.push({type:c,offset:this.d})}l(c){const f=this.d,m=this.c.substring(this.d,this.e),$={type:k.Error,offset:this.d,lexeme:m};this.g.push({offset:f,lexeme:m,additionalInfo:c}),this.f.push($)}n(){this.m.lastIndex=this.d;const c=this.m.exec(this.c);if(c){this.e=this.d+c[0].length;const f=this.c.substring(this.d,this.e),m=a.b.get(f);m?this.k(m):this.f.push({type:k.Str,lexeme:f,offset:this.d})}}o(){for(;this.j()!==S.CharCode.SingleQuote&&!this.r();)this.i();if(this.r()){this.l(O);return}this.i(),this.f.push({type:k.QuotedStr,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let c=this.e,f=!1,m=!1;for(;;){if(c>=this.c.length){this.e=c,this.l(g);return}const I=this.c.charCodeAt(c);if(f)f=!1;else if(I===S.CharCode.Slash&&!m){c++;break}else I===S.CharCode.OpenSquareBracket?m=!0:I===S.CharCode.Backslash?f=!0:I===S.CharCode.CloseSquareBracket&&(m=!1);c++}for(;c<this.c.length&&a.a.has(this.c.charCodeAt(c));)c++;this.e=c;const $=this.c.substring(this.d,this.e);this.f.push({type:k.RegexStr,lexeme:$,offset:this.d})}r(){return this.e>=this.c.length}}e.$xj=a}),define(ce[93],le([0,1,89,55,14,15,36,16,11]),function(Q,e,S,P,y,k,L,O,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3m=e.$2m=void 0,e.$4m=d,e.$5m=c,e.$2m=/^([^.]+\..+)[:=](.+)$/;class a{get appRoot(){return(0,k.$lc)(y.$Wg.asFileUri("").fsPath)}get userHome(){return g.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return g.URI.file((0,k.$ic)(this.userDataPath,"User"))}get tmpDir(){return g.URI.file(this.b.tmpDir)}get cacheHome(){return g.URI.file(this.userDataPath)}get stateResource(){return(0,O.$dh)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome.with({scheme:y.Schemas.vscodeUserData})}get userDataSyncHome(){return(0,O.$dh)(this.appSettingsHome,"sync")}get logsHome(){if(!this.args.logsPath){const m=(0,S.$1m)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,k.$ic)(this.userDataPath,"logs",m)}return g.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,O.$dh)(g.URI.file((0,k.$ic)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,O.$dh)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,O.$dh)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,O.$dh)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const m=L.env.VSCODE_PORTABLE;return m?g.URI.file((0,k.$ic)(m,"argv.json")):(0,O.$dh)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return g.URI.file((0,k.$ic)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const m=this.args["builtin-extensions-dir"];return m?(0,k.$jc)(m):(0,k.$gc)((0,k.$ic)(y.$Wg.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const m=this.args["extensions-download-dir"];return m?g.URI.file((0,k.$jc)(m)):g.URI.file((0,k.$ic)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const m=this.args["extensions-dir"];if(m)return(0,k.$jc)(m);const $=L.env.VSCODE_EXTENSIONS;if($)return $;const I=L.env.VSCODE_PORTABLE;return I?(0,k.$ic)(I,"extensions"):(0,O.$dh)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const m=this.args.extensionDevelopmentPath;if(Array.isArray(m))return m.map($=>/^[^:/?#]+?:\/\//.test($)?g.URI.parse($):g.URI.file((0,k.$gc)($)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(m=>m==="ui"||m==="workspace"||m==="web"?m:"workspace")}get extensionTestsLocationURI(){const m=this.args.extensionTestsPath;if(m)return/^[^:/?#]+?:\/\//.test(m)?g.URI.parse(m):g.URI.file((0,k.$gc)(m))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const m=this.args["disable-extension"];if(m){if(typeof m=="string")return[m];if(Array.isArray(m)&&m.length>0)return m}return!1}get debugExtensionHost(){return d(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!L.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(m=>!e.$2m.test(m))}get extensionLogLevel(){const m=[];for(const $ of this.args.log||[]){const I=e.$2m.exec($);I&&I[1]&&I[2]&&m.push([I[1],I[2]])}return m.length?m:void 0}get serviceMachineIdResource(){return(0,O.$dh)(g.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get useInMemorySecretStorage(){return!!this.args["use-inmemory-secretstorage"]}get policyFile(){if(this.args["__enable-file-policy"]){const m=L.env.VSCODE_PORTABLE;return m?g.URI.file((0,k.$ic)(m,"policy.json")):(0,O.$dh)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(m){this.args.continueOn=m}get args(){return this.a}constructor(m,$,I){this.a=m,this.b=$,this.c=I,this.editSessionId=this.args.editSessionId}}e.$3m=a,ve([P.$7h],a.prototype,"appRoot",null),ve([P.$7h],a.prototype,"userHome",null),ve([P.$7h],a.prototype,"userDataPath",null),ve([P.$7h],a.prototype,"appSettingsHome",null),ve([P.$7h],a.prototype,"tmpDir",null),ve([P.$7h],a.prototype,"cacheHome",null),ve([P.$7h],a.prototype,"stateResource",null),ve([P.$7h],a.prototype,"userRoamingDataHome",null),ve([P.$7h],a.prototype,"userDataSyncHome",null),ve([P.$7h],a.prototype,"sync",null),ve([P.$7h],a.prototype,"machineSettingsResource",null),ve([P.$7h],a.prototype,"workspaceStorageHome",null),ve([P.$7h],a.prototype,"localHistoryHome",null),ve([P.$7h],a.prototype,"keyboardLayoutResource",null),ve([P.$7h],a.prototype,"argvResource",null),ve([P.$7h],a.prototype,"isExtensionDevelopment",null),ve([P.$7h],a.prototype,"untitledWorkspacesHome",null),ve([P.$7h],a.prototype,"builtinExtensionsPath",null),ve([P.$7h],a.prototype,"extensionsPath",null),ve([P.$7h],a.prototype,"extensionDevelopmentLocationURI",null),ve([P.$7h],a.prototype,"extensionDevelopmentKind",null),ve([P.$7h],a.prototype,"extensionTestsLocationURI",null),ve([P.$7h],a.prototype,"debugExtensionHost",null),ve([P.$7h],a.prototype,"logLevel",null),ve([P.$7h],a.prototype,"extensionLogLevel",null),ve([P.$7h],a.prototype,"serviceMachineIdResource",null),ve([P.$7h],a.prototype,"disableTelemetry",null),ve([P.$7h],a.prototype,"disableWorkspaceTrust",null),ve([P.$7h],a.prototype,"useInMemorySecretStorage",null),ve([P.$7h],a.prototype,"policyFile",null);function d(f,m){return c(f["inspect-extensions"],f["inspect-brk-extensions"],5870,m,f.debugId,f.extensionEnvironment)}function c(f,m,$,I,b,h){const R=Number(m||f)||(I?null:$),v=R?!!m:!1;let i;if(h)try{i=JSON.parse(h)}catch{}return{port:R,break:v,debugId:b,env:i}}}),function(){function Q(e,S,P){function y(L,O){const g=k(L,O),a=[g];return e.isAbsolute(g)||a.unshift(P),e.resolve(...a)}function k(L,O){process.env.VSCODE_DEV&&(O="code-oss-dev");const g=process.env.VSCODE_PORTABLE;if(g)return e.join(g,"user-data");let a=process.env.VSCODE_APPDATA;if(a)return e.join(a,O);const d=L["user-data-dir"];if(d)return d;switch(process.platform){case"win32":if(a=process.env.APPDATA,!a){const c=process.env.USERPROFILE;if(typeof c!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");a=e.join(c,"AppData","Roaming")}break;case"darwin":a=e.join(S.homedir(),"Library","Application Support");break;case"linux":a=process.env.XDG_CONFIG_HOME||e.join(S.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(a,O)}return{getUserDataPath:y}}if(typeof define=="function")define(ce[94],le([148,35,36]),function(e,S,P){return Q(e,S,P.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),S=require("os");module.exports=Q(e,S,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(ce[95],le([0,1,35,93,94]),function(Q,e,S,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6m=void 0,e.$7m=L,e.$8m=O;class k extends P.$3m{constructor(a,d){super(a,{homeDir:(0,S.homedir)(),tmpDir:(0,S.tmpdir)(),userDataDir:(0,y.getUserDataPath)(a,d.nameShort)},d)}}e.$6m=k;function L(g,a){return(0,P.$5m)(g["inspect-ptyhost"],g["inspect-brk-ptyhost"],5877,a,g.extensionEnvironment)}function O(g,a){return(0,P.$5m)(g["inspect-sharedprocess"],g["inspect-brk-sharedprocess"],5879,a,g.extensionEnvironment)}}),define(ce[96],le([0,1,3,5]),function(Q,e,S,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jq=y;function y(L,O,g,a){try{k(L,O,g,a)}catch(d){L.error(d?.message??d)}return O}function k(L,O,g,a){const d=(c,f,m)=>{const $=c[f];if((0,S.$cg)($)){const I=$,b=I.length;if(b>1&&I[0]==="%"&&I[b-1]==="%"){const h=I.substr(1,b-2);let p=g[h];p===void 0&&a&&(p=a[h]);const R=typeof p=="string"?p:p?.message,v=a?.[h],i=typeof v=="string"?v:v?.message;if(!R){i||L.warn(`[${O.name}]: ${(0,P.localize)(11315,null,h)}`);return}if(m&&(f==="title"||f==="category")&&i&&i!==R){const l={value:R,original:i};c[f]=l}else c[f]=R}}else if((0,S.$eg)($))for(const I in $)$.hasOwnProperty(I)&&(I==="commands"?d($,I,!0):d($,I,m));else if(Array.isArray($))for(let I=0;I<$.length;I++)d($,I,m)};for(const c in O)O.hasOwnProperty(c)&&d(O,c)}}),define(ce[97],le([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0;const S={activeComment:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.activeComment.d.ts"},aiRelatedInformation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts"},aiTextSearchProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiTextSearchProvider.d.ts"},attributableCoverage:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.attributableCoverage.d.ts"},authGetSessions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts"},authLearnMore:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authLearnMore.d.ts"},authSession:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts"},canonicalUriProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts"},chatParticipantAdditions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantAdditions.d.ts"},chatParticipantPrivate:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantPrivate.d.ts",version:2},chatProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts"},chatTab:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatTab.d.ts"},chatVariableResolver:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatVariableResolver.d.ts"},codeActionAI:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionAI.d.ts"},codeActionRanges:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionRanges.d.ts"},codiconDecoration:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts"},commentReactor:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReactor.d.ts"},commentReveal:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReveal.d.ts"},commentThreadApplicability:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentThreadApplicability.d.ts"},commentingRangeHint:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentingRangeHint.d.ts"},commentsDraftState:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts"},contribAccessibilityHelpContent:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribAccessibilityHelpContent.d.ts"},contribCommentEditorActionsMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts"},contribCommentPeekContext:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts"},contribCommentThreadAdditionalMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts"},contribCommentsViewThreadMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentsViewThreadMenus.d.ts"},contribDiffEditorGutterToolBarMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribDiffEditorGutterToolBarMenus.d.ts"},contribEditSessions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts"},contribEditorContentMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts"},contribIssueReporter:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribIssueReporter.d.ts"},contribLabelFormatterWorkspaceTooltip:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts"},contribMenuBarHome:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts"},contribMergeEditorMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts"},contribMultiDiffEditorMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMultiDiffEditorMenus.d.ts"},contribNotebookStaticPreloads:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts"},contribRemoteHelp:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts"},contribShareMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts"},contribSourceControlHistoryItemChangesMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemChangesMenu.d.ts"},contribSourceControlHistoryItemGroupMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemGroupMenu.d.ts"},contribSourceControlHistoryItemMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemMenu.d.ts"},contribSourceControlInputBoxMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlInputBoxMenu.d.ts"},contribSourceControlTitleMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlTitleMenu.d.ts"},contribStatusBarItems:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts"},contribViewsRemote:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts"},contribViewsWelcome:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts"},createFileSystemWatcher:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.createFileSystemWatcher.d.ts"},customEditorMove:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts"},debugVisualization:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugVisualization.d.ts"},defaultChatParticipant:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.defaultChatParticipant.d.ts"},diffCommand:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts"},diffContentOptions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts"},documentFiltersExclusive:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts"},documentPaste:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts"},editSessionIdentityProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts"},editorHoverVerbosityLevel:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorHoverVerbosityLevel.d.ts"},editorInsets:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts"},embeddings:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.embeddings.d.ts"},extensionRuntime:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts"},extensionsAny:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts"},externalUriOpener:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts"},fileComments:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts"},fileSearchProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts"},findFiles2:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findFiles2.d.ts"},findTextInFiles:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts"},fsChunks:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts"},idToken:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts"},inlineCompletionsAdditions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts"},inlineEdit:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineEdit.d.ts"},interactive:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts"},interactiveWindow:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts"},ipc:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts"},languageModelSystem:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageModelSystem.d.ts"},languageStatusText:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageStatusText.d.ts"},lmTools:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.lmTools.d.ts",version:2},mappedEditsProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts"},multiDocumentHighlightProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.multiDocumentHighlightProvider.d.ts"},newSymbolNamesProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.newSymbolNamesProvider.d.ts"},notebookCellExecution:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecution.d.ts"},notebookCellExecutionState:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts"},notebookControllerAffinityHidden:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts"},notebookDeprecated:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts"},notebookExecution:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts"},notebookKernelSource:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts"},notebookLiveShare:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts"},notebookMessaging:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts"},notebookMime:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts"},notebookVariableProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookVariableProvider.d.ts"},portsAttributes:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts"},profileContentHandlers:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts"},quickDiffProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts"},quickPickItemTooltip:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts"},quickPickSortByLabel:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts"},resolvers:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts"},scmActionButton:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts"},scmHistoryProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts"},scmMultiDiffEditor:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmMultiDiffEditor.d.ts"},scmSelectedProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts"},scmTextDocument:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts"},scmValidation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts"},shareProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts"},showLocal:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts"},speech:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.speech.d.ts"},tabInputMultiDiff:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputMultiDiff.d.ts"},tabInputTextMerge:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts"},taskPresentationGroup:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts"},telemetry:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts"},terminalDataWriteEvent:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts"},terminalDimensions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts"},terminalExecuteCommandEvent:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts"},terminalQuickFixProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts"},terminalSelection:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts"},terminalShellIntegration:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalShellIntegration.d.ts"},testMessageStackTrace:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testMessageStackTrace.d.ts"},testObserver:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts"},textSearchProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts"},timeline:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts"},tokenInformation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts"},treeViewActiveItem:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts"},treeViewMarkdownMessage:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts"},treeViewReveal:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts"},tunnelFactory:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts"},tunnels:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts"},workspaceTrust:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"}};e.allApiProposals=Object.freeze(S)}),define(ce[51],le([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zi=void 0;class S{constructor(y,k=[],L=!1){this.ctor=y,this.staticArguments=k,this.supportsDelayedInstantiation=L}}e.$zi=S}),define(ce[98],le([0,1,51]),function(Q,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationType=void 0,e.$Os=k,e.$Ps=L;const P=[];var y;(function(O){O[O.Eager=0]="Eager",O[O.Delayed=1]="Delayed"})(y||(e.InstantiationType=y={}));function k(O,g,a){g instanceof S.$zi||(g=new S.$zi(g,[],!!a)),P.push([O,g])}function L(){return P}}),define(ce[99],le([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sr=e.$rr=void 0;class S{constructor(k,L){this.key=k,this.data=L,this.incoming=new Map,this.outgoing=new Map}}e.$rr=S;class P{constructor(k){this.b=k,this.a=new Map}roots(){const k=[];for(const L of this.a.values())L.outgoing.size===0&&k.push(L);return k}insertEdge(k,L){const O=this.lookupOrInsertNode(k),g=this.lookupOrInsertNode(L);O.outgoing.set(g.key,g),g.incoming.set(O.key,O)}removeNode(k){const L=this.b(k);this.a.delete(L);for(const O of this.a.values())O.outgoing.delete(L),O.incoming.delete(L)}lookupOrInsertNode(k){const L=this.b(k);let O=this.a.get(L);return O||(O=new S(L,k),this.a.set(L,O)),O}lookup(k){return this.a.get(this.b(k))}isEmpty(){return this.a.size===0}toString(){const k=[];for(const[L,O]of this.a)k.push(`${L}
	(-> incoming)[${[...O.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...O.outgoing.keys()].join(",")}]
`);return k.join(`
`)}findCycleSlow(){for(const[k,L]of this.a){const O=new Set([k]),g=this.c(L,O);if(g)return g}}c(k,L){for(const[O,g]of k.outgoing){if(L.has(O))return[...L,O].join(" -> ");L.add(O);const a=this.c(g,L);if(a)return a;L.delete(O)}}}e.$sr=P}),define(ce[29],le([0,1,3,11,10]),function(Q,e,S,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationTarget=e.$9i=void 0,e.$0i=k,e.$$i=L,e.$_i=g,e.$aj=a,e.$bj=d,e.$cj=c,e.$dj=f,e.$ej=$,e.$fj=I,e.$gj=b,S=ye(S),e.$9i=(0,y.$Ci)("configurationService");function k(h){return h&&typeof h=="object"&&(!h.overrideIdentifier||typeof h.overrideIdentifier=="string")&&(!h.resource||h.resource instanceof P.URI)}function L(h){return h&&typeof h=="object"&&(!h.overrideIdentifiers||Array.isArray(h.overrideIdentifiers))&&!h.overrideIdentifier&&(!h.resource||h.resource instanceof P.URI)}var O;(function(h){h[h.APPLICATION=1]="APPLICATION",h[h.USER=2]="USER",h[h.USER_LOCAL=3]="USER_LOCAL",h[h.USER_REMOTE=4]="USER_REMOTE",h[h.WORKSPACE=5]="WORKSPACE",h[h.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",h[h.DEFAULT=7]="DEFAULT",h[h.MEMORY=8]="MEMORY"})(O||(e.ConfigurationTarget=O={}));function g(h){switch(h){case O.APPLICATION:return"APPLICATION";case O.USER:return"USER";case O.USER_LOCAL:return"USER_LOCAL";case O.USER_REMOTE:return"USER_REMOTE";case O.WORKSPACE:return"WORKSPACE";case O.WORKSPACE_FOLDER:return"WORKSPACE_FOLDER";case O.DEFAULT:return"DEFAULT";case O.MEMORY:return"MEMORY"}}function a(h){return h.applicationValue!==void 0||h.userValue!==void 0||h.userLocalValue!==void 0||h.userRemoteValue!==void 0||h.workspaceValue!==void 0||h.workspaceFolderValue!==void 0}function d(h,p){const R=Object.create(null);for(const v in h)c(R,v,h[v],p);return R}function c(h,p,R,v){const i=p.split("."),l=i.pop();let n=h;for(let r=0;r<i.length;r++){const t=i[r];let s=n[t];switch(typeof s){case"undefined":s=n[t]=Object.create(null);break;case"object":if(s===null){v(`Ignoring ${p} as ${i.slice(0,r+1).join(".")} is null`);return}break;default:v(`Ignoring ${p} as ${i.slice(0,r+1).join(".")} is ${JSON.stringify(s)}`);return}n=s}if(typeof n=="object"&&n!==null)try{n[l]=R}catch{v(`Ignoring ${p} as ${i.join(".")} is ${JSON.stringify(n)}`)}else v(`Ignoring ${p} as ${i.join(".")} is ${JSON.stringify(n)}`)}function f(h,p){const R=p.split(".");m(h,R)}function m(h,p){const R=p.shift();if(p.length===0){delete h[R];return}if(Object.keys(h).indexOf(R)!==-1){const v=h[R];typeof v=="object"&&!Array.isArray(v)&&(m(v,p),Object.keys(v).length===0&&delete h[R])}}function $(h,p,R){function v(n,r){let t=n;for(const s of r){if(typeof t!="object"||t===null)return;t=t[s]}return t}const i=p.split("."),l=v(h,i);return typeof l>"u"?R:l}function I(h,p,R){Object.keys(p).forEach(v=>{v!=="__proto__"&&(v in h?S.$eg(h[v])&&S.$eg(p[v])?I(h[v],p[v],R):R&&(h[v]=p[v]):h[v]=p[v])})}function b(h){return h.replace(/[\[\]]/g,"")}}),define(ce[100],le([0,1,92,12,31,91,10,5,7]),function(Q,e,S,P,y,k,L,O,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uj=e.$Tj=e.$Sj=e.$Rj=e.$Qj=e.$Pj=e.$Oj=e.$Nj=e.$Mj=e.$Lj=e.$Kj=e.$Jj=e.$Ij=e.$Hj=e.$Gj=e.$Fj=e.$Ej=e.$Dj=e.$Aj=e.$zj=e.ContextKeyExprType=void 0,e.$yj=d,e.$Bj=r,e.$Cj=t,e.$Vj=ie;const a=new Map;a.set("false",!1),a.set("true",!0),a.set("isMac",P.$k),a.set("isLinux",P.$l),a.set("isWindows",P.$j),a.set("isWeb",P.$p),a.set("isMacNative",P.$k&&!P.$p),a.set("isEdge",P.$I),a.set("isFirefox",P.$G),a.set("isChrome",P.$F),a.set("isSafari",P.$H);function d(q,E){if(a.get(q)!==void 0)throw(0,g.$6)("contextkey.setConstant(k, v) invoked with already set constant `k`");a.set(q,E)}const c=Object.prototype.hasOwnProperty;var f;(function(q){q[q.False=0]="False",q[q.True=1]="True",q[q.Defined=2]="Defined",q[q.Not=3]="Not",q[q.Equals=4]="Equals",q[q.NotEquals=5]="NotEquals",q[q.And=6]="And",q[q.Regex=7]="Regex",q[q.NotRegex=8]="NotRegex",q[q.Or=9]="Or",q[q.In=10]="In",q[q.NotIn=11]="NotIn",q[q.Greater=12]="Greater",q[q.GreaterEquals=13]="GreaterEquals",q[q.Smaller=14]="Smaller",q[q.SmallerEquals=15]="SmallerEquals"})(f||(e.ContextKeyExprType=f={}));const m={regexParsingWithErrorRecovery:!0},$=(0,O.localize)(11446,null),I=(0,O.localize)(11447,null),b=(0,O.localize)(11448,null),h=(0,O.localize)(11449,null),p=(0,O.localize)(11450,null),R=(0,O.localize)(11451,null),v=(0,O.localize)(11452,null),i=(0,O.localize)(11453,null);class l{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(E=m){this.k=E,this.d=new k.$xj,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(E){if(E===""){this.h.push({message:$,offset:0,lexeme:"",additionalInfo:I});return}this.f=this.d.reset(E).scan(),this.g=0,this.h=[];try{const F=this.l();if(!this.E()){const U=this.D(),C=U.type===k.TokenType.Str?R:void 0;throw this.h.push({message:p,offset:U.offset,lexeme:k.$xj.getLexeme(U),additionalInfo:C}),l.c}return F}catch(F){if(F!==l.c)throw F;return}}l(){return this.m()}m(){const E=[this.o()];for(;this.y(k.TokenType.Or);){const F=this.o();E.push(F)}return E.length===1?E[0]:n.or(...E)}o(){const E=[this.s()];for(;this.y(k.TokenType.And);){const F=this.s();E.push(F)}return E.length===1?E[0]:n.and(...E)}s(){if(this.y(k.TokenType.Neg)){const E=this.D();switch(E.type){case k.TokenType.True:return this.z(),o.INSTANCE;case k.TokenType.False:return this.z(),u.INSTANCE;case k.TokenType.LParen:{this.z();const F=this.l();return this.A(k.TokenType.RParen,h),F?.negate()}case k.TokenType.Str:return this.z(),M.create(E.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",E)}}return this.t()}t(){const E=this.D();switch(E.type){case k.TokenType.True:return this.z(),n.true();case k.TokenType.False:return this.z(),n.false();case k.TokenType.LParen:{this.z();const F=this.l();return this.A(k.TokenType.RParen,h),F}case k.TokenType.Str:{const F=E.lexeme;if(this.z(),this.y(k.TokenType.RegexOp)){const C=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),C.type!==k.TokenType.RegexStr)throw this.B("REGEX",C);const G=C.lexeme,J=G.lastIndexOf("/"),ne=J===G.length-1?void 0:this.w(G.substring(J+1));let oe;try{oe=new RegExp(G.substring(1,J),ne)}catch{throw this.B("REGEX",C)}return de.create(F,oe)}switch(C.type){case k.TokenType.RegexStr:case k.TokenType.Error:{const G=[C.lexeme];this.z();let J=this.D(),ne=0;for(let we=0;we<C.lexeme.length;we++)C.lexeme.charCodeAt(we)===S.CharCode.OpenParen?ne++:C.lexeme.charCodeAt(we)===S.CharCode.CloseParen&&ne--;for(;!this.E()&&J.type!==k.TokenType.And&&J.type!==k.TokenType.Or;){switch(J.type){case k.TokenType.LParen:ne++;break;case k.TokenType.RParen:ne--;break;case k.TokenType.RegexStr:case k.TokenType.QuotedStr:for(let we=0;we<J.lexeme.length;we++)J.lexeme.charCodeAt(we)===S.CharCode.OpenParen?ne++:C.lexeme.charCodeAt(we)===S.CharCode.CloseParen&&ne--}if(ne<0)break;G.push(k.$xj.getLexeme(J)),this.z(),J=this.D()}const oe=G.join(""),fe=oe.lastIndexOf("/"),me=fe===oe.length-1?void 0:this.w(oe.substring(fe+1));let ge;try{ge=new RegExp(oe.substring(1,fe),me)}catch{throw this.B("REGEX",C)}return n.regex(F,ge)}case k.TokenType.QuotedStr:{const G=C.lexeme;this.z();let J=null;if(!(0,y.$af)(G)){const ne=G.indexOf("/"),oe=G.lastIndexOf("/");if(ne!==oe&&ne>=0){const fe=G.slice(ne+1,oe),me=G[oe+1]==="i"?"i":"";try{J=new RegExp(fe,me)}catch{throw this.B("REGEX",C)}}}if(J===null)throw this.B("REGEX",C);return de.create(F,J)}default:throw this.B("REGEX",this.D())}}if(this.y(k.TokenType.Not)){this.A(k.TokenType.In,b);const C=this.u();return n.notIn(F,C)}switch(this.D().type){case k.TokenType.Eq:{this.z();const C=this.u();if(this.x().type===k.TokenType.QuotedStr)return n.equals(F,C);switch(C){case"true":return n.has(F);case"false":return n.not(F);default:return n.equals(F,C)}}case k.TokenType.NotEq:{this.z();const C=this.u();if(this.x().type===k.TokenType.QuotedStr)return n.notEquals(F,C);switch(C){case"true":return n.not(F);case"false":return n.has(F);default:return n.notEquals(F,C)}}case k.TokenType.Lt:return this.z(),ae.create(F,this.u());case k.TokenType.LtEq:return this.z(),ue.create(F,this.u());case k.TokenType.Gt:return this.z(),K.create(F,this.u());case k.TokenType.GtEq:return this.z(),re.create(F,this.u());case k.TokenType.In:return this.z(),n.in(F,this.u());default:return n.has(F)}}case k.TokenType.EOF:throw this.h.push({message:v,offset:E.offset,lexeme:"",additionalInfo:i}),l.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const E=this.D();switch(E.type){case k.TokenType.Str:case k.TokenType.QuotedStr:return this.z(),E.lexeme;case k.TokenType.True:return this.z(),"true";case k.TokenType.False:return this.z(),"false";case k.TokenType.In:return this.z(),"in";default:return""}}w(E){return E.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(E){return this.C(E)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(E,F){if(this.C(E))return this.z();throw this.B(F,this.D())}B(E,F,U){const C=(0,O.localize)(11454,null,E,k.$xj.getLexeme(F)),G=F.offset,J=k.$xj.getLexeme(F);return this.h.push({message:C,offset:G,lexeme:J,additionalInfo:U}),l.c}C(E){return this.D().type===E}D(){return this.f[this.g]}E(){return this.D().type===k.TokenType.EOF}}e.$zj=l;class n{static false(){return o.INSTANCE}static true(){return u.INSTANCE}static has(E){return w.create(E)}static equals(E,F){return A.create(E,F)}static notEquals(E,F){return N.create(E,F)}static regex(E,F){return de.create(E,F)}static in(E,F){return T.create(E,F)}static notIn(E,F){return D.create(E,F)}static not(E){return M.create(E)}static and(...E){return B.create(E,null,!0)}static or(...E){return z.create(E,null,!0)}static greater(E,F){return K.create(E,F)}static greaterEquals(E,F){return re.create(E,F)}static smaller(E,F){return ae.create(E,F)}static smallerEquals(E,F){return ue.create(E,F)}static{this.c=new l({regexParsingWithErrorRecovery:!1})}static deserialize(E){return E==null?void 0:this.c.parse(E)}}e.$Aj=n;function r(q){const E=new l({regexParsingWithErrorRecovery:!1});return q.map(F=>(E.parse(F),E.lexingErrors.length>0?E.lexingErrors.map(U=>({errorMessage:U.additionalInfo?(0,O.localize)(11455,null,U.additionalInfo):(0,O.localize)(11456,null),offset:U.offset,length:U.lexeme.length})):E.parsingErrors.length>0?E.parsingErrors.map(U=>({errorMessage:U.additionalInfo?`${U.message}. ${U.additionalInfo}`:U.message,offset:U.offset,length:U.lexeme.length})):[]))}function t(q,E){const F=q?q.substituteConstants():void 0,U=E?E.substituteConstants():void 0;return!F&&!U?!0:!F||!U?!1:F.equals(U)}function s(q,E){return q.cmp(E)}class o{static{this.INSTANCE=new o}constructor(){this.type=f.False}cmp(E){return this.type-E.type}equals(E){return E.type===this.type}substituteConstants(){return this}evaluate(E){return!1}serialize(){return"false"}keys(){return[]}map(E){return this}negate(){return u.INSTANCE}}e.$Dj=o;class u{static{this.INSTANCE=new u}constructor(){this.type=f.True}cmp(E){return this.type-E.type}equals(E){return E.type===this.type}substituteConstants(){return this}evaluate(E){return!0}serialize(){return"true"}keys(){return[]}map(E){return this}negate(){return o.INSTANCE}}e.$Ej=u;class w{static create(E,F=null){const U=a.get(E);return typeof U=="boolean"?U?u.INSTANCE:o.INSTANCE:new w(E,F)}constructor(E,F){this.key=E,this.c=F,this.type=f.Defined}cmp(E){return E.type!==this.type?this.type-E.type:X(this.key,E.key)}equals(E){return E.type===this.type?this.key===E.key:!1}substituteConstants(){const E=a.get(this.key);return typeof E=="boolean"?E?u.INSTANCE:o.INSTANCE:this}evaluate(E){return!!E.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(E){return E.mapDefined(this.key)}negate(){return this.c||(this.c=M.create(this.key,this)),this.c}}e.$Fj=w;class A{static create(E,F,U=null){if(typeof F=="boolean")return F?w.create(E,U):M.create(E,U);const C=a.get(E);return typeof C=="boolean"?F===(C?"true":"false")?u.INSTANCE:o.INSTANCE:new A(E,F,U)}constructor(E,F,U){this.c=E,this.d=F,this.f=U,this.type=f.Equals}cmp(E){return E.type!==this.type?this.type-E.type:ee(this.c,this.d,E.c,E.d)}equals(E){return E.type===this.type?this.c===E.c&&this.d===E.d:!1}substituteConstants(){const E=a.get(this.c);if(typeof E=="boolean"){const F=E?"true":"false";return this.d===F?u.INSTANCE:o.INSTANCE}return this}evaluate(E){return E.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(E){return E.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=N.create(this.c,this.d,this)),this.f}}e.$Gj=A;class T{static create(E,F){return new T(E,F)}constructor(E,F){this.d=E,this.f=F,this.type=f.In,this.c=null}cmp(E){return E.type!==this.type?this.type-E.type:ee(this.d,this.f,E.d,E.f)}equals(E){return E.type===this.type?this.d===E.d&&this.f===E.f:!1}substituteConstants(){return this}evaluate(E){const F=E.getValue(this.f),U=E.getValue(this.d);return Array.isArray(F)?F.includes(U):typeof U=="string"&&typeof F=="object"&&F!==null?c.call(F,U):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(E){return E.mapIn(this.d,this.f)}negate(){return this.c||(this.c=D.create(this.d,this.f)),this.c}}e.$Hj=T;class D{static create(E,F){return new D(E,F)}constructor(E,F){this.d=E,this.f=F,this.type=f.NotIn,this.c=T.create(E,F)}cmp(E){return E.type!==this.type?this.type-E.type:this.c.cmp(E.c)}equals(E){return E.type===this.type?this.c.equals(E.c):!1}substituteConstants(){return this}evaluate(E){return!this.c.evaluate(E)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(E){return E.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$Ij=D;class N{static create(E,F,U=null){if(typeof F=="boolean")return F?M.create(E,U):w.create(E,U);const C=a.get(E);return typeof C=="boolean"?F===(C?"true":"false")?o.INSTANCE:u.INSTANCE:new N(E,F,U)}constructor(E,F,U){this.c=E,this.d=F,this.f=U,this.type=f.NotEquals}cmp(E){return E.type!==this.type?this.type-E.type:ee(this.c,this.d,E.c,E.d)}equals(E){return E.type===this.type?this.c===E.c&&this.d===E.d:!1}substituteConstants(){const E=a.get(this.c);if(typeof E=="boolean"){const F=E?"true":"false";return this.d===F?o.INSTANCE:u.INSTANCE}return this}evaluate(E){return E.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(E){return E.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=A.create(this.c,this.d,this)),this.f}}e.$Jj=N;class M{static create(E,F=null){const U=a.get(E);return typeof U=="boolean"?U?o.INSTANCE:u.INSTANCE:new M(E,F)}constructor(E,F){this.c=E,this.d=F,this.type=f.Not}cmp(E){return E.type!==this.type?this.type-E.type:X(this.c,E.c)}equals(E){return E.type===this.type?this.c===E.c:!1}substituteConstants(){const E=a.get(this.c);return typeof E=="boolean"?E?o.INSTANCE:u.INSTANCE:this}evaluate(E){return!E.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(E){return E.mapNot(this.c)}negate(){return this.d||(this.d=w.create(this.c,this)),this.d}}e.$Kj=M;function Y(q,E){if(typeof q=="string"){const F=parseFloat(q);isNaN(F)||(q=F)}return typeof q=="string"||typeof q=="number"?E(q):o.INSTANCE}class K{static create(E,F,U=null){return Y(F,C=>new K(E,C,U))}constructor(E,F,U){this.c=E,this.d=F,this.f=U,this.type=f.Greater}cmp(E){return E.type!==this.type?this.type-E.type:ee(this.c,this.d,E.c,E.d)}equals(E){return E.type===this.type?this.c===E.c&&this.d===E.d:!1}substituteConstants(){return this}evaluate(E){return typeof this.d=="string"?!1:parseFloat(E.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(E){return E.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=ue.create(this.c,this.d,this)),this.f}}e.$Lj=K;class re{static create(E,F,U=null){return Y(F,C=>new re(E,C,U))}constructor(E,F,U){this.c=E,this.d=F,this.f=U,this.type=f.GreaterEquals}cmp(E){return E.type!==this.type?this.type-E.type:ee(this.c,this.d,E.c,E.d)}equals(E){return E.type===this.type?this.c===E.c&&this.d===E.d:!1}substituteConstants(){return this}evaluate(E){return typeof this.d=="string"?!1:parseFloat(E.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(E){return E.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=ae.create(this.c,this.d,this)),this.f}}e.$Mj=re;class ae{static create(E,F,U=null){return Y(F,C=>new ae(E,C,U))}constructor(E,F,U){this.c=E,this.d=F,this.f=U,this.type=f.Smaller}cmp(E){return E.type!==this.type?this.type-E.type:ee(this.c,this.d,E.c,E.d)}equals(E){return E.type===this.type?this.c===E.c&&this.d===E.d:!1}substituteConstants(){return this}evaluate(E){return typeof this.d=="string"?!1:parseFloat(E.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(E){return E.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=re.create(this.c,this.d,this)),this.f}}e.$Nj=ae;class ue{static create(E,F,U=null){return Y(F,C=>new ue(E,C,U))}constructor(E,F,U){this.c=E,this.d=F,this.f=U,this.type=f.SmallerEquals}cmp(E){return E.type!==this.type?this.type-E.type:ee(this.c,this.d,E.c,E.d)}equals(E){return E.type===this.type?this.c===E.c&&this.d===E.d:!1}substituteConstants(){return this}evaluate(E){return typeof this.d=="string"?!1:parseFloat(E.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(E){return E.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=K.create(this.c,this.d,this)),this.f}}e.$Oj=ue;class de{static create(E,F){return new de(E,F)}constructor(E,F){this.d=E,this.f=F,this.type=f.Regex,this.c=null}cmp(E){if(E.type!==this.type)return this.type-E.type;if(this.d<E.d)return-1;if(this.d>E.d)return 1;const F=this.f?this.f.source:"",U=E.f?E.f.source:"";return F<U?-1:F>U?1:0}equals(E){if(E.type===this.type){const F=this.f?this.f.source:"",U=E.f?E.f.source:"";return this.d===E.d&&F===U}return!1}substituteConstants(){return this}evaluate(E){const F=E.getValue(this.d);return this.f?this.f.test(F):!1}serialize(){const E=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${E}`}keys(){return[this.d]}map(E){return E.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=H.create(this)),this.c}}e.$Pj=de;class H{static create(E){return new H(E)}constructor(E){this.c=E,this.type=f.NotRegex}cmp(E){return E.type!==this.type?this.type-E.type:this.c.cmp(E.c)}equals(E){return E.type===this.type?this.c.equals(E.c):!1}substituteConstants(){return this}evaluate(E){return!this.c.evaluate(E)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(E){return new H(this.c.map(E))}negate(){return this.c}}e.$Qj=H;function Z(q){let E=null;for(let F=0,U=q.length;F<U;F++){const C=q[F].substituteConstants();if(q[F]!==C&&E===null){E=[];for(let G=0;G<F;G++)E[G]=q[G]}E!==null&&(E[F]=C)}return E===null?q:E}class B{static create(E,F,U){return B.d(E,F,U)}constructor(E,F){this.expr=E,this.c=F,this.type=f.And}cmp(E){if(E.type!==this.type)return this.type-E.type;if(this.expr.length<E.expr.length)return-1;if(this.expr.length>E.expr.length)return 1;for(let F=0,U=this.expr.length;F<U;F++){const C=s(this.expr[F],E.expr[F]);if(C!==0)return C}return 0}equals(E){if(E.type===this.type){if(this.expr.length!==E.expr.length)return!1;for(let F=0,U=this.expr.length;F<U;F++)if(!this.expr[F].equals(E.expr[F]))return!1;return!0}return!1}substituteConstants(){const E=Z(this.expr);return E===this.expr?this:B.create(E,this.c,!1)}evaluate(E){for(let F=0,U=this.expr.length;F<U;F++)if(!this.expr[F].evaluate(E))return!1;return!0}static d(E,F,U){const C=[];let G=!1;for(const J of E)if(J){if(J.type===f.True){G=!0;continue}if(J.type===f.False)return o.INSTANCE;if(J.type===f.And){C.push(...J.expr);continue}C.push(J)}if(C.length===0&&G)return u.INSTANCE;if(C.length!==0){if(C.length===1)return C[0];C.sort(s);for(let J=1;J<C.length;J++)C[J-1].equals(C[J])&&(C.splice(J,1),J--);if(C.length===1)return C[0];for(;C.length>1;){const J=C[C.length-1];if(J.type!==f.Or)break;C.pop();const ne=C.pop(),oe=C.length===0,fe=z.create(J.expr.map(me=>B.create([me,ne],null,U)),null,oe);fe&&(C.push(fe),C.sort(s))}if(C.length===1)return C[0];if(U){for(let J=0;J<C.length;J++)for(let ne=J+1;ne<C.length;ne++)if(C[J].negate().equals(C[ne]))return o.INSTANCE;if(C.length===1)return C[0]}return new B(C,F)}}serialize(){return this.expr.map(E=>E.serialize()).join(" && ")}keys(){const E=[];for(const F of this.expr)E.push(...F.keys());return E}map(E){return new B(this.expr.map(F=>F.map(E)),null)}negate(){if(!this.c){const E=[];for(const F of this.expr)E.push(F.negate());this.c=z.create(E,this,!0)}return this.c}}e.$Rj=B;class z{static create(E,F,U){return z.d(E,F,U)}constructor(E,F){this.expr=E,this.c=F,this.type=f.Or}cmp(E){if(E.type!==this.type)return this.type-E.type;if(this.expr.length<E.expr.length)return-1;if(this.expr.length>E.expr.length)return 1;for(let F=0,U=this.expr.length;F<U;F++){const C=s(this.expr[F],E.expr[F]);if(C!==0)return C}return 0}equals(E){if(E.type===this.type){if(this.expr.length!==E.expr.length)return!1;for(let F=0,U=this.expr.length;F<U;F++)if(!this.expr[F].equals(E.expr[F]))return!1;return!0}return!1}substituteConstants(){const E=Z(this.expr);return E===this.expr?this:z.create(E,this.c,!1)}evaluate(E){for(let F=0,U=this.expr.length;F<U;F++)if(this.expr[F].evaluate(E))return!0;return!1}static d(E,F,U){let C=[],G=!1;if(E){for(let J=0,ne=E.length;J<ne;J++){const oe=E[J];if(oe){if(oe.type===f.False){G=!0;continue}if(oe.type===f.True)return u.INSTANCE;if(oe.type===f.Or){C=C.concat(oe.expr);continue}C.push(oe)}}if(C.length===0&&G)return o.INSTANCE;C.sort(s)}if(C.length!==0){if(C.length===1)return C[0];for(let J=1;J<C.length;J++)C[J-1].equals(C[J])&&(C.splice(J,1),J--);if(C.length===1)return C[0];if(U){for(let J=0;J<C.length;J++)for(let ne=J+1;ne<C.length;ne++)if(C[J].negate().equals(C[ne]))return u.INSTANCE;if(C.length===1)return C[0]}return new z(C,F)}}serialize(){return this.expr.map(E=>E.serialize()).join(" || ")}keys(){const E=[];for(const F of this.expr)E.push(...F.keys());return E}map(E){return new z(this.expr.map(F=>F.map(E)),null)}negate(){if(!this.c){const E=[];for(const F of this.expr)E.push(F.negate());for(;E.length>1;){const F=E.shift(),U=E.shift(),C=[];for(const G of W(F))for(const J of W(U))C.push(B.create([G,J],null,!1));E.unshift(z.create(C,null,!1))}this.c=z.create(E,this,!0)}return this.c}}e.$Sj=z;class x extends w{static{this.d=[]}static all(){return x.d.values()}constructor(E,F,U){super(E,null),this.f=F,typeof U=="object"?x.d.push({...U,key:E}):U!==!0&&x.d.push({key:E,description:U,type:F!=null?typeof F:void 0})}bindTo(E){return E.createKey(this.key,this.f)}getValue(E){return E.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(E){return A.create(this.key,E)}notEqualsTo(E){return N.create(this.key,E)}}e.$Tj=x,e.$Uj=(0,L.$Ci)("contextKeyService");function X(q,E){return q<E?-1:q>E?1:0}function ee(q,E,F,U){return q<F?-1:q>F?1:E<U?-1:E>U?1:0}function ie(q,E){if(q.type===f.False||E.type===f.True)return!0;if(q.type===f.Or)return E.type===f.Or?j(q.expr,E.expr):!1;if(E.type===f.Or){for(const F of E.expr)if(ie(q,F))return!0;return!1}if(q.type===f.And){if(E.type===f.And)return j(E.expr,q.expr);for(const F of q.expr)if(ie(F,E))return!0;return!1}return q.equals(E)}function j(q,E){let F=0,U=0;for(;F<q.length&&U<E.length;){const C=q[F].cmp(E[U]);if(C<0)return!1;C===0&&F++,U++}return F===q.length}function W(q){return q.type===f.Or?q.expr:[q]}}),define(ce[61],le([0,1,10]),function(Q,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yo=void 0,e.$Yo=(0,S.$Ci)("downloadService")}),define(ce[17],le([0,1,10]),function(Q,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ki=e.$Ji=void 0,e.$Ji=(0,S.$Ci)("environmentService"),e.$Ki=(0,S.$Di)(e.$Ji)}),define(ce[62],le([0,1,13,7,5,9]),function(Q,e,S,P,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yq=L;async function L(d,c,f,m,$,I){let b;try{await O(d,c,f,m,$,I)}catch(h){b=h}finally{b&&$.errorTransformer&&(b=$.errorTransformer(b)),typeof b<"u"&&f.error(b),f.end()}}async function O(d,c,f,m,$,I){g(I);const b=await d.open(c,{create:!1});try{g(I);let h=0,p=0,R=$&&typeof $.length=="number"?$.length:void 0,v=S.$Le.alloc(Math.min($.bufferSize,typeof R=="number"?R:$.bufferSize)),i=$&&typeof $.position=="number"?$.position:0,l=0;do p=await d.read(b,i,v.buffer,l,v.byteLength-l),i+=p,l+=p,h+=p,typeof R=="number"&&(R-=p),l===v.byteLength&&(await f.write(m(v)),v=S.$Le.alloc(Math.min($.bufferSize,typeof R=="number"?R:$.bufferSize)),l=0);while(p>0&&(typeof R!="number"||R>0)&&g(I)&&a(h,$));if(l>0){let n=l;typeof R=="number"&&(n=Math.min(l,R)),f.write(m(v.slice(0,n)))}}catch(h){throw(0,k.$ll)(h)}finally{await d.close(b)}}function g(d){if(d.isCancellationRequested)throw(0,P.$5)();return!0}function a(d,c){if(typeof c?.limits?.size=="number"&&d>c.limits.size)throw(0,k.$kl)((0,y.localize)(11232,null),k.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(ce[101],le([0,1,32,2,52,4,9,11,8]),function(Q,e,S,P,y,k,L,O,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hr=void 0;class a extends P.$Tc{constructor(){super(),this.a=this.B(new k.$je),this.onDidChangeFile=this.a.event,this.b=this.B(new k.$je),this.onDidLogMessage=this.b.event,this.c=this.B(new k.$je),this.f=this.c.event,this.g=new Set,this.h=new Map,this.j=this.B(new P.$3c),this.m=new Set,this.n=this.B(new g.$Ah(this.y())),this.r=5007,this.s=new g.$Zh,this.R=!1,this.B(this.f(c=>this.t(c)))}t(c){this.u(c)&&this.z(c)}u(c){return(0,y.$1q)(c)}async watch(c){this.s.isSettled||this.s.complete(),this.s=new g.$Zh;try{this.h.clear(),this.g.clear();for(const f of c)this.u(f)?this.h.set(f.correlationId,f):this.g.add(f);for(const[f]of this.j)this.h.has(f)||(this.j.deleteAndDispose(f),this.m.delete(f));return await this.w(!1)}finally{this.s.complete()}}w(c){return this.n.trigger(()=>this.N([...this.g,...Array.from(this.h.values()).filter(f=>!this.j.has(f.correlationId))]),c?this.y():0)}y(){return 800}isSuspended(c){return typeof c.correlationId!="number"?!1:this.m.has(c.correlationId)?"polling":this.j.has(c.correlationId)}async z(c){if(this.j.has(c.correlationId))return;const f=new P.$Sc;this.j.set(c.correlationId,f),await this.s.p,!f.isDisposed&&(this.D(c,f),this.w(!0))}C(c){this.j.deleteAndDispose(c.correlationId),this.m.delete(c.correlationId),this.w(!1)}D(c,f){this.F(c,f)?(this.P(`reusing an existing recursive watcher to monitor ${c.path}`),this.m.delete(c.correlationId)):(this.G(c,f),this.m.add(c.correlationId))}F(c,f){const m=this.O?.subscribe(c.path,($,I)=>{f.isDisposed||($?this.D(c,f):I?.type===L.FileChangeType.ADDED&&this.H(c))});return m?(f.add(m),!0):!1}G(c,f){let m=!1;const $=(I,b)=>{if(f.isDisposed)return;const h=this.I(I),p=this.I(b),R=m;m=h,!h&&(p||R)&&this.H(c)};this.P(`starting fs.watchFile() on ${c.path} (correlationId: ${c.correlationId})`);try{(0,S.watchFile)(c.path,{persistent:!1,interval:this.r},$)}catch(I){this.Q(`fs.watchFile() failed with error ${I} on path ${c.path} (correlationId: ${c.correlationId})`)}f.add((0,P.$Rc)(()=>{this.P(`stopping fs.watchFile() on ${c.path} (correlationId: ${c.correlationId})`);try{(0,S.unwatchFile)(c.path,$)}catch(I){this.Q(`fs.unwatchFile() failed with error ${I} on path ${c.path} (correlationId: ${c.correlationId})`)}}))}H(c){this.P(`detected ${c.path} exists again, resuming watcher (correlationId: ${c.correlationId})`);const f={resource:O.URI.file(c.path),type:L.FileChangeType.ADDED,cId:c.correlationId};this.a.fire([f]),this.J(f,c),this.C(c)}I(c){return c.ctimeMs===0&&c.ino===0}async stop(){this.j.clearAndDisposeAll(),this.m.clear()}J(c,f){if(this.R){const m=` >> normalized ${c.type===L.FileChangeType.ADDED?"[ADDED]":c.type===L.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${c.resource.fsPath}`;this.L(m,f)}}L(c,f){this.R&&this.P(`${c}${typeof f.correlationId=="number"?` <${f.correlationId}> `:""}`)}M(c){return`${c.path} (excludes: ${c.excludes.length>0?c.excludes:"<none>"}, includes: ${c.includes&&c.includes.length>0?JSON.stringify(c.includes):"<all>"}, filter: ${(0,y.$$q)(c.filter)}, correlationId: ${typeof c.correlationId=="number"?c.correlationId:"<none>"})`}async setVerboseLogging(c){this.R=c}}e.$hr=a}),define(ce[102],le([0,1,4,149,101,12,150,63]),function(Q,e,S,P,y,k,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$or=void 0;class g extends y.$hr{constructor(d){super(),this.O=d,this.onDidError=S.Event.None,this.watchers=new Set}async N(d){d=this.Z(d);const c=[],f=new Set(Array.from(this.watchers));for(const m of d){const $=this.W(m);$&&(0,P.$Bk)($.request.excludes,m.excludes)&&(0,P.$Bk)($.request.includes,m.includes)?f.delete($):c.push(m)}c.length&&this.P(`Request to start watching: ${c.map(m=>this.M(m)).join(",")}`),f.size&&this.P(`Request to stop watching: ${Array.from(f).map(m=>this.M(m.request)).join(",")}`);for(const m of f)this.Y(m);for(const m of c)this.X(m)}W(d){for(const c of this.watchers)if(typeof d.correlationId=="number"||typeof c.request.correlationId=="number"){if(c.request.correlationId===d.correlationId)return c}else if((0,O.$Ag)(c.request.path,d.path,!k.$l))return c}X(d){const c=new L.$mr(d,this.O,m=>this.a.fire(m),()=>this.c.fire(d),m=>this.b.fire(m),this.R),f={request:d,instance:c};this.watchers.add(f)}async stop(){await super.stop();for(const d of this.watchers)this.Y(d)}Y(d){this.P("stopping file watcher",d),this.watchers.delete(d),d.instance.dispose()}Z(d){const c=new Map;for(const f of d){const m=k.$l?f.path:f.path.toLowerCase();let $=c.get(f.correlationId);$||($=new Map,c.set(f.correlationId,$)),$.has(m)&&this.P(`ignoring a request for watching who's path is already watched: ${this.M(f)}`),$.set(m,f)}return Array.from(c.values()).map(f=>Array.from(f.values())).flat()}async setVerboseLogging(d){super.setVerboseLogging(d);for(const c of this.watchers)c.instance.setVerboseLogging(d)}P(d,c){this.R&&this.b.fire({type:"trace",message:this.bb(d,c)})}Q(d){this.b.fire({type:"warn",message:this.bb(d)})}bb(d,c){return c?`[File Watcher (node.js)] ${d} (${this.M(c.request)})`:`[File Watcher (node.js)] ${d}`}}e.$or=g}),define(ce[103],le([0,1,52,102]),function(Q,e,S,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pr=void 0;class y extends S.$4q{constructor(L,O,g){super(L,O,g),this.s()}r(L){return L.add(new P.$or(void 0))}}e.$pr=y}),define(ce[104],le([0,1,14,59,87,52]),function(Q,e,S,P,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gr=void 0;class L extends k.$5q{constructor(g,a,d){super(g,a,d),this.s()}r(g){const a=g.add(new y.$fr(S.$Wg.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return g.add(a.onDidProcessExit(({code:d,signal:c})=>this.t(`terminated by itself with code ${d}, signal: ${c} (ETERM)`))),P.ProxyChannel.toService((0,P.$ji)(a.getChannel("watcher")))}}e.$gr=L}),define(ce[64],le([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ai=void 0;class S{constructor(...y){this.a=new Map;for(const[k,L]of y)this.set(k,L)}set(y,k){const L=this.a.get(y);return this.a.set(y,k),L}has(y){return this.a.has(y)}get(y){return this.a.get(y)}}e.$Ai=S}),define(ce[105],le([0,1,8,7,2,51,99,10,64,151]),function(Q,e,S,P,y,k,L,O,g,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ur=e.$tr=void 0;const d=!1;class c extends Error{constructor(b){super("cyclic dependency between services"),this.message=b.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${b.toString()}`}}class f{constructor(b=new g.$Ai,h=!1,p,R=d){this.i=b,this.j=h,this.k=p,this.l=R,this.f=!1,this.g=new Set,this.h=new Set,this.t=new Set,this.i.set(O.$Bi,this),this._globalGraph=R?p?._globalGraph??new L.$sr(v=>v):void 0}dispose(){if(!this.f){this.f=!0,(0,y.$Oc)(this.h),this.h.clear();for(const b of this.g)(0,y.$Nc)(b)&&b.dispose();this.g.clear()}}m(){if(this.f)throw new Error("InstantiationService has been disposed")}createChild(b,h){this.m();const p=this,R=new class extends f{dispose(){p.h.delete(R),super.dispose()}}(b,this.j,this,this.l);return this.h.add(R),h?.add(R),R}invokeFunction(b,...h){this.m();const p=$.traceInvocation(this.l,b);let R=!1;try{return b({get:i=>{if(R)throw(0,P.$7)("service accessor is only valid during the invocation of its target method");const l=this.s(i,p);if(!l)throw new Error(`[invokeFunction] unknown service '${i}'`);return l}},...h)}finally{R=!0,p.stop()}}createInstance(b,...h){this.m();let p,R;return b instanceof k.$zi?(p=$.traceCreation(this.l,b.ctor),R=this.o(b.ctor,b.staticArguments.concat(h),p)):(p=$.traceCreation(this.l,b),R=this.o(b,h,p)),p.stop(),R}o(b,h=[],p){const R=O._util.getServiceDependencies(b).sort((l,n)=>l.index-n.index),v=[];for(const l of R){const n=this.s(l.id,p);n||this.y(`[createInstance] ${b.name} depends on UNKNOWN service ${l.id}.`,!1),v.push(n)}const i=R.length>0?R[0].index:h.length;if(h.length!==i){console.trace(`[createInstance] First service dependency of ${b.name} at position ${i+1} conflicts with ${h.length} static arguments`);const l=i-h.length;l>0?h=h.concat(new Array(l)):h=h.slice(0,i)}return Reflect.construct(b,h.concat(v))}q(b,h){if(this.i.get(b)instanceof k.$zi)this.i.set(b,h);else if(this.k)this.k.q(b,h);else throw new Error("illegalState - setting UNKNOWN service instance")}r(b){const h=this.i.get(b);return!h&&this.k?this.k.r(b):h}s(b,h){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(b));const p=this.r(b);return p instanceof k.$zi?this.u(b,p,h.branch(b,!0)):(h.branch(b,!1),p)}u(b,h,p){if(this.t.has(b))throw new Error(`illegal state - RECURSIVELY instantiating service '${b}'`);this.t.add(b);try{return this.v(b,h,p)}finally{this.t.delete(b)}}v(b,h,p){const R=new L.$sr(n=>n.id.toString());let v=0;const i=[{id:b,desc:h,_trace:p}],l=new Set;for(;i.length;){const n=i.pop();if(!l.has(String(n.id))){if(l.add(String(n.id)),R.lookupOrInsertNode(n),v++>1e3)throw new c(R);for(const r of O._util.getServiceDependencies(n.desc.ctor)){const t=this.r(r.id);if(t||this.y(`[createInstance] ${b} depends on ${r.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(n.id),String(r.id)),t instanceof k.$zi){const s={id:r.id,desc:t,_trace:n._trace.branch(r.id,!0)};R.insertEdge(n,s),i.push(s)}}}}for(;;){const n=R.roots();if(n.length===0){if(!R.isEmpty())throw new c(R);break}for(const{data:r}of n){if(this.r(r.id)instanceof k.$zi){const s=this.w(r.id,r.desc.ctor,r.desc.staticArguments,r.desc.supportsDelayedInstantiation,r._trace);this.q(r.id,s)}R.removeNode(r)}}return this.r(b)}w(b,h,p=[],R,v){if(this.i.get(b)instanceof k.$zi)return this.x(b,h,p,R,v,this.g);if(this.k)return this.k.w(b,h,p,R,v);throw new Error(`illegalState - creating UNKNOWN service instance ${h.name}`)}x(b,h,p=[],R,v,i){if(R){const l=new f(void 0,this.j,this,this.l);l.c=String(b);const n=new Map,r=new S.$Vh(()=>{const t=l.o(h,p,v);for(const[s,o]of n){const u=t[s];if(typeof u=="function")for(const w of o)w.disposable=u.apply(t,w.listener)}return n.clear(),i.add(t),t});return new Proxy(Object.create(null),{get(t,s){if(!r.isInitialized&&typeof s=="string"&&(s.startsWith("onDid")||s.startsWith("onWill"))){let w=n.get(s);return w||(w=new a.$4c,n.set(s,w)),(T,D,N)=>{if(r.isInitialized)return r.value[s](T,D,N);{const M={listener:[T,D,N],disposable:void 0},Y=w.push(M);return(0,y.$Rc)(()=>{Y(),M.disposable?.dispose()})}}}if(s in t)return t[s];const o=r.value;let u=o[s];return typeof u!="function"||(u=u.bind(o),t[s]=u),u},set(t,s,o){return r.value[s]=o,!0},getPrototypeOf(t){return h.prototype}})}else{const l=this.o(h,p,v);return i.add(l),l}}y(b,h){if(h&&console.warn(b),this.j)throw new Error(b)}}e.$tr=f;var m;(function(I){I[I.None=0]="None",I[I.Creation=1]="Creation",I[I.Invocation=2]="Invocation",I[I.Branch=3]="Branch"})(m||(m={}));class ${static{this.all=new Set}static{this.c=new class extends ${constructor(){super(m.None,null)}stop(){}branch(){return this}}}static traceInvocation(b,h){return b?new $(m.Invocation,h.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):$.c}static traceCreation(b,h){return b?new $(m.Creation,h.name):$.c}static{this.f=0}constructor(b,h){this.type=b,this.name=h,this.g=Date.now(),this.h=[]}branch(b,h){const p=new $(m.Branch,b.toString());return this.h.push([b,h,p]),p}stop(){const b=Date.now()-this.g;$.f+=b;let h=!1;function p(v,i){const l=[],n=new Array(v+1).join("	");for(const[r,t,s]of i.h)if(t&&s){h=!0,l.push(`${n}CREATES -> ${r}`);const o=p(v+1,s);o&&l.push(o)}else l.push(`${n}uses -> ${r}`);return l.join(`
`)}const R=[`${this.type===m.Creation?"CREATE":"CALL"} ${this.name}`,`${p(1,this)}`,`DONE, took ${b.toFixed(2)}ms (grand total ${$.f.toFixed(2)}ms)`];(b>2||h)&&$.all.add(R.join(`
`))}}e.$ur=$}),define(ce[6],le([0,1,5,38,4,43,2,30,12,16,3,11,100,10]),function(Q,e,S,P,y,k,L,O,g,a,d,c,f,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pk=e.$kk=e.$jk=e.$ik=e.$hk=e.$gk=e.$fk=e.$ek=e.$dk=e.$ck=e.$ak=e.LogLevel=e.$$j=e.$0j=void 0,e.$_j=I,e.log=h,e.$lk=u,e.$mk=w,e.$nk=A,e.$ok=T,S=ye(S),e.$0j=(0,m.$Ci)("logService"),e.$$j=(0,m.$Ci)("loggerService");function $(){return new Date().toISOString()}function I(D){return(0,d.$gg)(D)}var b;(function(D){D[D.Off=0]="Off",D[D.Trace=1]="Trace",D[D.Debug=2]="Debug",D[D.Info=3]="Info",D[D.Warning=4]="Warning",D[D.Error=5]="Error"})(b||(e.LogLevel=b={})),e.$ak=b.Info;function h(D,N,M){switch(N){case b.Trace:D.trace(M);break;case b.Debug:D.debug(M);break;case b.Info:D.info(M);break;case b.Warning:D.warn(M);break;case b.Error:D.error(M);break;case b.Off:break;default:throw new Error(`Invalid log level ${N}`)}}function p(D,N=!1){let M="";for(let Y=0;Y<D.length;Y++){let K=D[Y];if(K instanceof Error&&(K=(0,P.$nj)(K,N)),typeof K=="object")try{K=JSON.stringify(K)}catch{}M+=(Y>0?" ":"")+K}return M}class R extends L.$Tc{constructor(){super(...arguments),this.b=e.$ak,this.c=this.B(new y.$je),this.onDidChangeLogLevel=this.c.event}setLevel(N){this.b!==N&&(this.b=N,this.c.fire(this.b))}getLevel(){return this.b}f(N){return this.b!==b.Off&&this.b<=N}}e.$ck=R;class v extends R{constructor(N){super(),this.h=N}f(N){return this.h||super.f(N)}trace(N,...M){this.f(b.Trace)&&this.g(b.Trace,p([N,...M],!0))}debug(N,...M){this.f(b.Debug)&&this.g(b.Debug,p([N,...M]))}info(N,...M){this.f(b.Info)&&this.g(b.Info,p([N,...M]))}warn(N,...M){this.f(b.Warning)&&this.g(b.Warning,p([N,...M]))}error(N,...M){if(this.f(b.Error))if(N instanceof Error){const Y=Array.prototype.slice.call(arguments);Y[0]=N.stack,this.g(b.Error,p(Y))}else this.g(b.Error,p([N,...M]))}flush(){}}e.$dk=v;class i extends R{constructor(N=e.$ak){super(),this.setLevel(N),this.g=!g.$j}trace(N,...M){this.f(b.Trace)&&(this.g?console.log(`\x1B[90m[main ${$()}]\x1B[0m`,N,...M):console.log(`[main ${$()}]`,N,...M))}debug(N,...M){this.f(b.Debug)&&(this.g?console.log(`\x1B[90m[main ${$()}]\x1B[0m`,N,...M):console.log(`[main ${$()}]`,N,...M))}info(N,...M){this.f(b.Info)&&(this.g?console.log(`\x1B[90m[main ${$()}]\x1B[0m`,N,...M):console.log(`[main ${$()}]`,N,...M))}warn(N,...M){this.f(b.Warning)&&(this.g?console.warn(`\x1B[93m[main ${$()}]\x1B[0m`,N,...M):console.warn(`[main ${$()}]`,N,...M))}error(N,...M){this.f(b.Error)&&(this.g?console.error(`\x1B[91m[main ${$()}]\x1B[0m`,N,...M):console.error(`[main ${$()}]`,N,...M))}flush(){}}e.$ek=i;class l extends R{constructor(N=e.$ak,M=!0){super(),this.g=M,this.setLevel(N)}trace(N,...M){this.f(b.Trace)&&(this.g?console.log("%cTRACE","color: #888",N,...M):console.log(N,...M))}debug(N,...M){this.f(b.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",N,...M):console.log(N,...M))}info(N,...M){this.f(b.Info)&&(this.g?console.log("%c INFO","color: #33f",N,...M):console.log(N,...M))}warn(N,...M){this.f(b.Warning)&&(this.g?console.log("%c WARN","color: #993",N,...M):console.log(N,...M))}error(N,...M){this.f(b.Error)&&(this.g?console.log("%c  ERR","color: #f33",N,...M):console.error(N,...M))}flush(){}}e.$fk=l;class n extends R{constructor(N,M=e.$ak){super(),this.g=N,this.setLevel(M)}trace(N,...M){this.f(b.Trace)&&this.g.log(b.Trace,[this.h(N),...M])}debug(N,...M){this.f(b.Debug)&&this.g.log(b.Debug,[this.h(N),...M])}info(N,...M){this.f(b.Info)&&this.g.log(b.Info,[this.h(N),...M])}warn(N,...M){this.f(b.Warning)&&this.g.log(b.Warning,[this.h(N),...M])}error(N,...M){this.f(b.Error)&&this.g.log(b.Error,[this.h(N),...M])}h(N){return typeof N=="string"?N:(0,P.$nj)(N,this.f(b.Trace))}flush(){}}e.$gk=n;class r extends R{constructor(N){super(),this.g=N,N.length&&this.setLevel(N[0].getLevel())}setLevel(N){for(const M of this.g)M.setLevel(N);super.setLevel(N)}trace(N,...M){for(const Y of this.g)Y.trace(N,...M)}debug(N,...M){for(const Y of this.g)Y.debug(N,...M)}info(N,...M){for(const Y of this.g)Y.info(N,...M)}warn(N,...M){for(const Y of this.g)Y.warn(N,...M)}error(N,...M){for(const Y of this.g)Y.error(N,...M)}flush(){for(const N of this.g)N.flush()}dispose(){for(const N of this.g)N.dispose();super.dispose()}}e.$hk=r;class t extends L.$Tc{constructor(N,M,Y){if(super(),this.h=N,this.j=M,this.b=new O.$zc,this.c=this.B(new y.$je),this.onDidChangeLoggers=this.c.event,this.f=this.B(new y.$je),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new y.$je),this.onDidChangeVisibility=this.g.event,Y)for(const K of Y)this.b.set(K.resource,{logger:void 0,info:K})}m(N){return(0,d.$cg)(N)?[...this.b.values()].find(M=>M.info.id===N):this.b.get(N)}getLogger(N){return this.m(N)?.logger}createLogger(N,M){const Y=this.n(N),K=(0,d.$cg)(N)?N:M?.id??(0,k.$qj)(Y.toString()).toString(16);let re=this.b.get(Y)?.logger;const ae=M?.logLevel==="always"?b.Trace:M?.logLevel;re||(re=this.s(Y,ae??this.getLogLevel(Y)??this.h,{...M,id:K}));const ue={logger:re,info:{resource:Y,id:K,logLevel:ae,name:M?.name,hidden:M?.hidden,extensionId:M?.extensionId,when:M?.when}};return this.registerLogger(ue.info),this.b.set(Y,ue),re}n(N){return(0,d.$cg)(N)?(0,a.$dh)(this.j,`${N}.log`):N}setLogLevel(N,M){if(c.URI.isUri(N)){const Y=N,K=M,re=this.b.get(Y);re&&K!==re.info.logLevel&&(re.info.logLevel=K===this.h?void 0:K,re.logger?.setLevel(K),this.b.set(re.info.resource,re),this.f.fire([Y,K]))}else{this.h=N;for(const[Y,K]of this.b.entries())this.b.get(Y)?.info.logLevel===void 0&&K.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(N,M){const Y=this.m(N);Y&&M!==!Y.info.hidden&&(Y.info.hidden=!M,this.b.set(Y.info.resource,Y),this.g.fire([Y.info.resource,M]))}getLogLevel(N){let M;return N&&(M=this.b.get(N)?.info.logLevel),M??this.h}registerLogger(N){const M=this.b.get(N.resource);M?M.info.hidden!==N.hidden&&this.setVisibility(N.resource,!N.hidden):(this.b.set(N.resource,{info:N,logger:void 0}),this.c.fire({added:[N],removed:[]}))}deregisterLogger(N){const M=this.b.get(N);M&&(M.logger&&M.logger.dispose(),this.b.delete(N),this.c.fire({added:[],removed:[M.info]}))}*getRegisteredLoggers(){for(const N of this.b.values())yield N.info}getRegisteredLogger(N){return this.b.get(N)?.info}dispose(){this.b.forEach(N=>N.logger?.dispose()),this.b.clear(),super.dispose()}}e.$ik=t;class s{constructor(){this.onDidChangeLogLevel=new y.$je().event}setLevel(N){}getLevel(){return b.Info}trace(N,...M){}debug(N,...M){}info(N,...M){}warn(N,...M){}error(N,...M){}critical(N,...M){}dispose(){}flush(){}}e.$jk=s;class o extends s{}e.$kk=o;function u(D){if(D.verbose)return b.Trace;if(typeof D.logLevel=="string"){const N=T(D.logLevel.toLowerCase());if(N!==void 0)return N}return e.$ak}function w(D){switch(D){case b.Trace:return"trace";case b.Debug:return"debug";case b.Info:return"info";case b.Warning:return"warn";case b.Error:return"error";case b.Off:return"off"}}function A(D){switch(D){case b.Trace:return{original:"Trace",value:S.localize(11166,null)};case b.Debug:return{original:"Debug",value:S.localize(11167,null)};case b.Info:return{original:"Info",value:S.localize(11168,null)};case b.Warning:return{original:"Warning",value:S.localize(11169,null)};case b.Error:return{original:"Error",value:S.localize(11170,null)};case b.Off:return{original:"Off",value:S.localize(11171,null)}}}function T(D){switch(D){case"trace":return b.Trace;case"debug":return b.Debug;case"info":return b.Info;case"warn":return b.Warning;case"error":return b.Error;case"critical":return b.Error;case"off":return b.Off}}e.$pk=new f.$Tj("logLevel",w(b.Info))}),define(ce[106],le([0,1,19,8,7,4,63,2,15,52,6]),function(Q,e,S,P,y,k,L,O,g,a,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_q=void 0;class c extends O.$Tc{constructor(m,$){super(),this.a=m,this.b=$,this.c=this.B(new k.$je),this.onDidChangeFile=this.c.event,this.g=this.B(new k.$je),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new P.$Ah(0)),this.w=[],this.y=this.B(new P.$Ah(0))}watch(m,$){return $.recursive||this.b?.watcher?.forceUniversal?this.n(m,$):this.z(m,$)}n(m,$){const I={path:this.J(m),excludes:$.excludes,includes:$.includes,recursive:$.recursive,filter:$.filter,correlationId:$.correlationId},b=(0,S.$Sb)(this.j,I);return this.r(),(0,O.$Rc)(()=>{b(),this.r()})}r(){this.m.trigger(()=>this.s()).catch(m=>(0,y.$Y)(m))}s(){this.h||(this.h=this.B(this.t($=>this.c.fire((0,a.$6q)($)),$=>this.G($),this.a.getLevel()===d.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===d.LogLevel.Trace)})));const m=this.b?.watcher?.recursive?.usePolling;if(m===!0)for(const $ of this.j)(0,a.$2q)($)&&($.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(m))for(const $ of this.j)(0,a.$2q)($)&&m.includes($.path)&&($.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z(m,$){const I={path:this.J(m),excludes:$.excludes,includes:$.includes,recursive:!1,filter:$.filter,correlationId:$.correlationId},b=(0,S.$Sb)(this.w,I);return this.C(),(0,O.$Rc)(()=>{b(),this.C()})}C(){this.y.trigger(()=>this.D()).catch(m=>(0,y.$Y)(m))}D(){return this.u||(this.u=this.B(this.F(m=>this.c.fire((0,a.$6q)(m)),m=>this.G(m),this.a.getLevel()===d.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===d.LogLevel.Trace)}))),this.u.watch(this.w)}G(m){m.type==="error"&&this.g.fire(m.message),this.H(m)}H(m){this.a[m.type](m.message)}I(m){return(0,g.$gc)(m.fsPath)}J(m){const $=this.I(m);return(0,L.$Eg)($)}}e.$_q=c});var se=this&&this.__param||function(Q,e){return function(S,P){e(S,P,Q)}};define(ce[107],le([0,1,19,8,13,21,4,43,65,2,49,14,108,16,47,5,9,62,6,7]),function(Q,e,S,P,y,k,L,O,g,a,d,c,f,m,$,I,b,h,p,R){"use strict";var v;Object.defineProperty(e,"__esModule",{value:!0}),e.$Zq=void 0;let i=class extends a.$Tc{static{v=this}constructor(n){super(),this.b=n,this.a=256*1024,this.c=this.B(new L.$je),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new L.$je),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new L.$je),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.r=this.B(new L.$je),this.onDidRunOperation=this.r.event,this.X=this.B(new L.$je),this.Y=this.B(new L.$je),this.onDidFilesChange=this.Y.event,this.Z=this.B(new L.$je),this.onDidWatchError=this.Z.event,this.$=new Map,this.cb=this.B(new P.$Lh)}registerProvider(n,r){if(this.h.has(n))throw new Error(`A filesystem provider for the scheme '${n}' is already registered.`);(0,f.mark)(`code/registerFilesystem/${n}`);const t=new a.$Sc;return this.h.set(n,r),this.c.fire({added:!0,scheme:n,provider:r}),t.add(r.onDidChangeFile(s=>{const o=new b.$ql(s,!this.S(r));this.X.fire(o),o.hasCorrelation()||this.Y.fire(o)})),typeof r.onDidWatchError=="function"&&t.add(r.onDidWatchError(s=>this.Z.fire(new Error(s)))),t.add(r.onDidChangeCapabilities(()=>this.g.fire({provider:r,scheme:n}))),(0,a.$Rc)(()=>{this.c.fire({added:!1,scheme:n,provider:r}),this.h.delete(n),(0,a.$Oc)(t)})}getProvider(n){return this.h.get(n)}async activateProvider(n){const r=[];this.f.fire({scheme:n,join(t){r.push(t)}}),!this.h.has(n)&&await P.Promises.settled(r)}async canHandleResource(n){return await this.activateProvider(n.scheme),this.hasProvider(n)}hasProvider(n){return this.h.has(n.scheme)}hasCapability(n,r){const t=this.h.get(n.scheme);return!!(t&&t.capabilities&r)}listCapabilities(){return g.Iterable.map(this.h,([n,r])=>({scheme:n,capabilities:r.capabilities}))}async j(n){if(!(0,m.$hh)(n))throw new b.$sl((0,I.localize)(11239,null,this.sb(n)),b.FileOperationResult.FILE_INVALID_PATH);await this.activateProvider(n.scheme);const r=this.h.get(n.scheme);if(!r){const t=new R.$ab;throw t.message=(0,I.localize)(11240,null,n.toString()),t}return r}async m(n){const r=await this.j(n);if((0,b.$dl)(r)||(0,b.$al)(r)||(0,b.$el)(r))return r;throw new Error(`Filesystem provider for scheme '${n.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async n(n){const r=await this.j(n);if((0,b.$dl)(r)||(0,b.$al)(r))return r;throw new Error(`Filesystem provider for scheme '${n.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(n,r){try{return await this.s(n,r)}catch(t){throw(0,b.$nl)(t)===b.FileSystemProviderErrorCode.FileNotFound?new b.$sl((0,I.localize)(11241,null,this.sb(n)),b.FileOperationResult.FILE_NOT_FOUND):(0,b.$ll)(t)}}async s(n,r){const t=await this.j(n),s=this.S(t),o=r?.resolveTo,u=r?.resolveSingleChildDescendants,w=r?.resolveMetadata,A=await t.stat(n);let T;return this.t(t,n,A,void 0,!!w,(D,N)=>(T||(T=d.$Ii.forUris(()=>!s),T.set(n,!0),o&&T.fill(!0,o)),T.get(D.resource)||T.findSuperstr(D.resource.with({query:null,fragment:null}))?!0:D.isDirectory&&u?N===1:!1))}async t(n,r,t,s,o,u){const{providerExtUri:w}=this.R(n),A={resource:r,name:w.basename(r),isFile:(t.type&b.FileType.File)!==0,isDirectory:(t.type&b.FileType.Directory)!==0,isSymbolicLink:(t.type&b.FileType.SymbolicLink)!==0,mtime:t.mtime,ctime:t.ctime,size:t.size,readonly:!!((t.permissions??0)&b.FilePermission.Readonly)||!!(n.capabilities&b.FileSystemProviderCapabilities.Readonly),locked:!!((t.permissions??0)&b.FilePermission.Locked),etag:(0,b.$Dl)({mtime:t.mtime,size:t.size}),children:void 0};if(A.isDirectory&&u(A,s)){try{const T=await n.readdir(r),D=await P.Promises.settled(T.map(async([N,M])=>{try{const Y=w.joinPath(r,N),K=o?await n.stat(Y):{type:M};return await this.t(n,Y,K,T.length,o,u)}catch(Y){return this.b.trace(Y),null}}));A.children=(0,S.$Gb)(D)}catch(T){this.b.trace(T),A.children=[]}return A}return A}async resolveAll(n){return P.Promises.settled(n.map(async r=>{try{return{stat:await this.s(r.resource,r.options),success:!0}}catch(t){return this.b.trace(t),{stat:void 0,success:!1}}}))}async stat(n){const r=await this.j(n),t=await r.stat(n);return this.t(r,n,t,void 0,!0,()=>!1)}async exists(n){const r=await this.j(n);try{return!!await r.stat(n)}catch{return!1}}async canCreateFile(n,r){try{await this.u(n,r)}catch(t){return t}return!0}async u(n,r){if(!r?.overwrite&&await this.exists(n))throw new b.$sl((0,I.localize)(11242,null,this.sb(n)),b.FileOperationResult.FILE_MODIFIED_SINCE,r)}async createFile(n,r=y.$Le.fromString(""),t){await this.u(n,t);const s=await this.writeFile(n,r);return this.r.fire(new b.$pl(n,b.FileOperation.CREATE,s)),s}async writeFile(n,r,t){const s=this.qb(await this.n(n),n),{providerExtUri:o}=this.R(s);let u=t;if((0,b.$gl)(s)&&!u?.atomic){const w=s.enforceAtomicWriteFile?.(n);w&&(u={...t,atomic:w})}try{await this.w(s,n,u)||await this.U(s,o.dirname(n));let A;if((0,b.$al)(s)&&!(r instanceof y.$Le))if((0,$.$xe)(r)){const T=await(0,$.$Ee)(r,3);T.ended?A=y.$Le.concat(T.buffer):A=T}else A=(0,$.$Be)(r,T=>y.$Le.concat(T),3);else A=r;!(0,b.$dl)(s)||(0,b.$al)(s)&&A instanceof y.$Le||(0,b.$al)(s)&&(0,b.$gl)(s)&&u?.atomic?await this.hb(s,n,u,A):await this.db(s,n,u,A instanceof y.$Le?(0,y.$We)(A):A),this.r.fire(new b.$pl(n,b.FileOperation.WRITE))}catch(w){throw new b.$sl((0,I.localize)(11243,null,this.sb(n),(0,b.$ll)(w).toString()),(0,b.$ol)(w),u)}return this.resolve(n,{resolveMetadata:!0})}async w(n,r,t){const s=!!t?.unlock;if(s&&!(n.capabilities&b.FileSystemProviderCapabilities.FileWriteUnlock))throw new Error((0,I.localize)(11244,null,this.sb(r)));if(!!t?.atomic){if(!(n.capabilities&b.FileSystemProviderCapabilities.FileAtomicWrite))throw new Error((0,I.localize)(11245,null,this.sb(r)));if(!(n.capabilities&b.FileSystemProviderCapabilities.FileReadWrite))throw new Error((0,I.localize)(11246,null,this.sb(r)));if(s)throw new Error((0,I.localize)(11247,null,this.sb(r)))}let u;try{u=await n.stat(r)}catch{return}if(u.type&b.FileType.Directory)throw new b.$sl((0,I.localize)(11248,null,this.sb(r)),b.FileOperationResult.FILE_IS_DIRECTORY,t);if(this.rb(r,u),typeof t?.mtime=="number"&&typeof t.etag=="string"&&t.etag!==b.$Cl&&typeof u.mtime=="number"&&typeof u.size=="number"&&t.mtime<u.mtime&&t.etag!==(0,b.$Dl)({mtime:t.mtime,size:u.size}))throw new b.$sl((0,I.localize)(11249,null),b.FileOperationResult.FILE_MODIFIED_SINCE,t);return u}async readFile(n,r,t){const s=await this.m(n);return r?.atomic?this.z(s,n,r,t):this.C(s,n,r,t)}async z(n,r,t,s){return new Promise((o,u)=>{this.cb.queueFor(r,async()=>{try{const w=await this.C(n,r,t,s);o(w)}catch(w){u(w)}},this.R(n).providerExtUri)})}async C(n,r,t,s){const o=await this.D(n,r,{...t,preferUnbuffered:!0},s);return{...o,value:await(0,y.$Xe)(o.value)}}async readFileStream(n,r,t){const s=await this.m(n);return this.D(s,n,r,t)}async D(n,r,t,s){const o=new k.$ue(s);let u=t;(0,b.$fl)(n)&&n.enforceAtomicReadFile?.(r)&&(u={...t,atomic:!0});const w=this.J(r,u).then(T=>T,T=>{throw o.dispose(!0),T});let A;try{return typeof u?.etag=="string"&&u.etag!==b.$Cl&&await w,u?.atomic&&(0,b.$fl)(n)||!((0,b.$dl)(n)||(0,b.$el)(n))||(0,b.$al)(n)&&u?.preferUnbuffered?A=this.I(n,r,u):(0,b.$el)(n)?A=this.G(n,r,o.token,u):A=this.H(n,r,o.token,u),A.on("end",()=>o.dispose()),A.on("error",()=>o.dispose()),{...await w,value:A}}catch(T){throw A&&await(0,$.$Ce)(A),this.F(T,r,u)}}F(n,r,t){const s=(0,I.localize)(11250,null,this.sb(r),(0,b.$ll)(n).toString());return n instanceof b.$ul?new b.$ul(s,n.stat,t):n instanceof b.$tl?new b.$tl(s,n.fileOperationResult,n.size,n.options):new b.$sl(s,(0,b.$ol)(n),t)}G(n,r,t,s=Object.create(null)){const o=n.readFileStream(r,s,t);return(0,$.$Ie)(o,{data:u=>u instanceof y.$Le?u:y.$Le.wrap(u),error:u=>this.F(u,r,s)},u=>y.$Le.concat(u))}H(n,r,t,s=Object.create(null)){const o=(0,y.$2e)();return(0,h.$Yq)(n,r,o,u=>u,{...s,bufferSize:this.a,errorTransformer:u=>this.F(u,r,s)},t),o}I(n,r,t){const s=(0,$.$ze)(o=>y.$Le.concat(o));return(async()=>{try{let o;t?.atomic&&(0,b.$fl)(n)?o=await n.readFile(r,{atomic:!0}):o=await n.readFile(r),typeof t?.position=="number"&&(o=o.slice(t.position)),typeof t?.length=="number"&&(o=o.slice(0,t.length)),this.L(r,o.byteLength,t),s.end(y.$Le.wrap(o))}catch(o){s.error(o),s.end()}})(),s}async J(n,r){const t=await this.resolve(n,{resolveMetadata:!0});if(t.isDirectory)throw new b.$sl((0,I.localize)(11251,null,this.sb(n)),b.FileOperationResult.FILE_IS_DIRECTORY,r);if(typeof r?.etag=="string"&&r.etag!==b.$Cl&&r.etag===t.etag)throw new b.$ul((0,I.localize)(11252,null),t,r);return this.L(n,t.size,r),t}L(n,r,t){if(typeof t?.limits?.size=="number"&&r>t.limits.size)throw new b.$tl((0,I.localize)(11253,null,this.sb(n)),b.FileOperationResult.FILE_TOO_LARGE,r,t)}async canMove(n,r,t){return this.M(n,r,"move",t)}async canCopy(n,r,t){return this.M(n,r,"copy",t)}async M(n,r,t,s){if(n.toString()!==r.toString())try{const o=t==="move"?this.qb(await this.n(n),n):await this.m(n),u=this.qb(await this.n(r),r);await this.Q(o,n,u,r,t,s)}catch(o){return o}return!0}async move(n,r,t){const s=this.qb(await this.n(n),n),o=this.qb(await this.n(r),r),u=await this.N(s,n,o,r,"move",!!t),w=await this.resolve(r,{resolveMetadata:!0});return this.r.fire(new b.$pl(n,u==="move"?b.FileOperation.MOVE:b.FileOperation.COPY,w)),w}async copy(n,r,t){const s=await this.m(n),o=this.qb(await this.n(r),r),u=await this.N(s,n,o,r,"copy",!!t),w=await this.resolve(r,{resolveMetadata:!0});return this.r.fire(new b.$pl(n,u==="copy"?b.FileOperation.COPY:b.FileOperation.MOVE,w)),w}async N(n,r,t,s,o,u){if(r.toString()===s.toString())return o;const{exists:w,isSameResourceWithDifferentPathCase:A}=await this.Q(n,r,t,s,o,u);if(w&&!A&&u&&await this.del(s,{recursive:!0}),await this.U(t,this.R(t).providerExtUri.dirname(s)),o==="copy"){if(n===t&&(0,b.$bl)(n))await n.copy(r,s,{overwrite:u});else{const T=await this.resolve(r);T.isDirectory?await this.P(n,T,t,s):await this.O(n,r,t,s)}return o}else return n===t?(await n.rename(r,s,{overwrite:u}),o):(await this.N(n,r,t,s,"copy",u),await this.del(r,{recursive:!0}),"copy")}async O(n,r,t,s){if((0,b.$dl)(n)&&(0,b.$dl)(t))return this.jb(n,r,t,s);if((0,b.$dl)(n)&&(0,b.$al)(t))return this.pb(n,r,t,s);if((0,b.$al)(n)&&(0,b.$dl)(t))return this.nb(n,r,t,s);if((0,b.$al)(n)&&(0,b.$al)(t))return this.lb(n,r,t,s)}async P(n,r,t,s){await t.mkdir(s),Array.isArray(r.children)&&await P.Promises.settled(r.children.map(async o=>{const u=this.R(t).providerExtUri.joinPath(s,o.name);return o.isDirectory?this.P(n,await this.resolve(o.resource),t,u):this.O(n,o.resource,t,u)}))}async Q(n,r,t,s,o,u){let w=!1;if(n===t){const{providerExtUri:T,isPathCaseSensitive:D}=this.R(n);if(D||(w=T.isEqual(r,s)),w&&o==="copy")throw new Error((0,I.localize)(11254,null,this.sb(r),this.sb(s)));if(!w&&T.isEqualOrParent(s,r))throw new Error((0,I.localize)(11255,null,this.sb(r),this.sb(s)))}const A=await this.exists(s);if(A&&!w){if(!u)throw new b.$sl((0,I.localize)(11256,null,this.sb(r),this.sb(s)),b.FileOperationResult.FILE_MOVE_CONFLICT);if(n===t){const{providerExtUri:T}=this.R(n);if(T.isEqualOrParent(r,s))throw new Error((0,I.localize)(11257,null,this.sb(r),this.sb(s)))}}return{exists:A,isSameResourceWithDifferentPathCase:w}}R(n){const r=this.S(n);return{providerExtUri:r?m.$6g:m.$8g,isPathCaseSensitive:r}}S(n){return!!(n.capabilities&b.FileSystemProviderCapabilities.PathCaseSensitive)}async createFolder(n){const r=this.qb(await this.j(n),n);await this.U(r,n);const t=await this.resolve(n,{resolveMetadata:!0});return this.r.fire(new b.$pl(n,b.FileOperation.CREATE,t)),t}async U(n,r){const t=[],{providerExtUri:s}=this.R(n);for(;!s.isEqual(r,s.dirname(r));)try{if(!((await n.stat(r)).type&b.FileType.Directory))throw new Error((0,I.localize)(11258,null,this.sb(r)));break}catch(o){if((0,b.$nl)(o)!==b.FileSystemProviderErrorCode.FileNotFound)throw o;t.push(s.basename(r)),r=s.dirname(r)}for(let o=t.length-1;o>=0;o--){r=s.joinPath(r,t[o]);try{await n.mkdir(r)}catch(u){if((0,b.$nl)(u)!==b.FileSystemProviderErrorCode.FileExists)throw u}}}async canDelete(n,r){try{await this.W(n,r)}catch(t){return t}return!0}async W(n,r){const t=this.qb(await this.j(n),n),s=!!r?.useTrash;if(s&&!(t.capabilities&b.FileSystemProviderCapabilities.Trash))throw new Error((0,I.localize)(11259,null,this.sb(n)));const o=r?.atomic;if(o&&!(t.capabilities&b.FileSystemProviderCapabilities.FileAtomicDelete))throw new Error((0,I.localize)(11260,null,this.sb(n)));if(s&&o)throw new Error((0,I.localize)(11261,null,this.sb(n)));let u;try{u=await t.stat(n)}catch{}if(u)this.rb(n,u);else throw new b.$sl((0,I.localize)(11262,null,this.sb(n)),b.FileOperationResult.FILE_NOT_FOUND);if(!!!r?.recursive){const A=await this.resolve(n);if(A.isDirectory&&Array.isArray(A.children)&&A.children.length>0)throw new Error((0,I.localize)(11263,null,this.sb(n)))}return t}async del(n,r){const t=await this.W(n,r);let s=r;if((0,b.$hl)(t)&&!s?.atomic){const A=t.enforceAtomicDelete?.(n);A&&(s={...r,atomic:A})}const o=!!s?.useTrash,u=!!s?.recursive,w=s?.atomic??!1;await t.delete(n,{recursive:u,useTrash:o,atomic:w}),this.r.fire(new b.$pl(n,b.FileOperation.DELETE))}async cloneFile(n,r){const t=await this.j(n),s=this.qb(await this.n(r),r);if(!(t===s&&this.R(t).providerExtUri.isEqual(n,r)))return t===s&&(0,b.$cl)(t)?t.cloneFile(n,r):(await this.U(s,this.R(s).providerExtUri.dirname(r)),t===s&&(0,b.$bl)(t)?this.cb.queueFor(n,()=>t.copy(n,r,{overwrite:!0}),this.R(t).providerExtUri):this.cb.queueFor(n,()=>this.O(t,n,s,r),this.R(t).providerExtUri))}static{this.ab=0}createWatcher(n,r){return this.watch(n,{...r,correlationId:v.ab++})}watch(n,r={recursive:!1,excludes:[]}){const t=new a.$Sc;let s=!1,o=()=>{s=!0};t.add((0,a.$Rc)(()=>o())),(async()=>{try{const w=await this.bb(n,r);s?(0,a.$Oc)(w):o=()=>(0,a.$Oc)(w)}catch(w){this.b.error(w)}})();const u=r.correlationId;if(typeof u=="number"){const w=t.add(new L.$je);return t.add(this.X.event(T=>{T.correlates(u)&&w.fire(T)})),{onDidChange:w.event,dispose:()=>t.dispose()}}return t}async bb(n,r){const t=await this.j(n),s=(0,O.$qj)([this.R(t).providerExtUri.getComparisonKey(n),r]);let o=this.$.get(s);return o||(o={count:0,disposable:t.watch(n,r)},this.$.set(s,o)),o.count+=1,(0,a.$Rc)(()=>{o&&(o.count--,o.count===0&&((0,a.$Oc)(o.disposable),this.$.delete(s)))})}dispose(){super.dispose();for(const[,n]of this.$)(0,a.$Oc)(n.disposable);this.$.clear()}async db(n,r,t,s){return this.cb.queueFor(r,async()=>{const o=await n.open(r,{create:!0,unlock:t?.unlock??!1});try{(0,$.$xe)(s)||(0,$.$ye)(s)?await this.eb(n,o,s):await this.fb(n,o,s)}catch(u){throw(0,b.$ll)(u)}finally{await n.close(o)}},this.R(n).providerExtUri)}async eb(n,r,t){let s=0,o;if((0,$.$ye)(t)){if(t.buffer.length>0){const u=y.$Le.concat(t.buffer);await this.gb(n,r,u,u.byteLength,s,0),s+=u.byteLength}if(t.ended)return;o=t.stream}else o=t;return new Promise((u,w)=>{(0,$.$De)(o,{onData:async A=>{o.pause();try{await this.gb(n,r,A,A.byteLength,s,0)}catch(T){return w(T)}s+=A.byteLength,setTimeout(()=>o.resume())},onError:A=>w(A),onEnd:()=>u()})})}async fb(n,r,t){let s=0,o;for(;(o=t.read())!==null;)await this.gb(n,r,o,o.byteLength,s,0),s+=o.byteLength}async gb(n,r,t,s,o,u){let w=0;for(;w<s;){const A=await n.write(r,o+w,t.buffer,u+w,s-w);w+=A}}async hb(n,r,t,s){return this.cb.queueFor(r,()=>this.ib(n,r,t,s),this.R(n).providerExtUri)}async ib(n,r,t,s){let o;s instanceof y.$Le?o=s:(0,$.$xe)(s)?o=await(0,y.$Xe)(s):(0,$.$ye)(s)?o=await(0,y.$Ye)(s):o=(0,y.$Ve)(s),await n.writeFile(r,o.buffer,{create:!0,overwrite:!0,unlock:t?.unlock??!1,atomic:t?.atomic??!1})}async jb(n,r,t,s){return this.cb.queueFor(s,()=>this.kb(n,r,t,s),this.R(t).providerExtUri)}async kb(n,r,t,s){let o,u;try{o=await n.open(r,{create:!1}),u=await t.open(s,{create:!0,unlock:!1});const w=y.$Le.alloc(this.a);let A=0,T=0,D=0;do D=await n.read(o,A,w.buffer,T,w.byteLength-T),await this.gb(t,u,w,D,A,T),A+=D,T+=D,T===w.byteLength&&(T=0);while(D>0)}catch(w){throw(0,b.$ll)(w)}finally{await P.Promises.settled([typeof o=="number"?n.close(o):Promise.resolve(),typeof u=="number"?t.close(u):Promise.resolve()])}}async lb(n,r,t,s){return this.cb.queueFor(s,()=>this.mb(n,r,t,s),this.R(t).providerExtUri)}async mb(n,r,t,s){return t.writeFile(s,await n.readFile(r),{create:!0,overwrite:!0,unlock:!1,atomic:!1})}async nb(n,r,t,s){return this.cb.queueFor(s,()=>this.ob(n,r,t,s),this.R(t).providerExtUri)}async ob(n,r,t,s){const o=await t.open(s,{create:!0,unlock:!1});try{const u=await n.readFile(r);await this.gb(t,o,y.$Le.wrap(u),u.byteLength,0,0)}catch(u){throw(0,b.$ll)(u)}finally{await t.close(o)}}async pb(n,r,t,s){const o=await(0,y.$Xe)(this.H(n,r,k.CancellationToken.None));await this.hb(t,s,void 0,o)}qb(n,r){if(n.capabilities&b.FileSystemProviderCapabilities.Readonly)throw new b.$sl((0,I.localize)(11264,null,this.sb(r)),b.FileOperationResult.FILE_PERMISSION_DENIED);return n}rb(n,r){if((r.permissions??0)&b.FilePermission.Readonly)throw new b.$sl((0,I.localize)(11265,null,this.sb(n)),b.FileOperationResult.FILE_PERMISSION_DENIED)}sb(n){return n.scheme===c.Schemas.file?n.fsPath:n.toString(!0)}};e.$Zq=i,e.$Zq=i=v=ve([se(0,p.$0j)],i)}),define(ce[109],le([0,1,32,8,30,13,4,63,2,15,12,16,47,28,5,9,62,106,104,103]),function(Q,e,S,P,y,k,L,O,g,a,d,c,f,m,$,I,b,h,p,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qr=void 0;class v extends h.$_q{static{this.L=!1}constructor(l,n){super(l,n),this.onDidChangeCapabilities=L.Event.None,this.P=new y.$zc(r=>c.$7g.getComparisonKey(r)),this.X=new Map,this.Y=new Map,this.Z=new Map}get capabilities(){return this.M||(this.M=I.FileSystemProviderCapabilities.FileReadWrite|I.FileSystemProviderCapabilities.FileOpenReadWriteClose|I.FileSystemProviderCapabilities.FileReadStream|I.FileSystemProviderCapabilities.FileFolderCopy|I.FileSystemProviderCapabilities.FileWriteUnlock|I.FileSystemProviderCapabilities.FileAtomicRead|I.FileSystemProviderCapabilities.FileAtomicWrite|I.FileSystemProviderCapabilities.FileAtomicDelete|I.FileSystemProviderCapabilities.FileClone,d.$l&&(this.M|=I.FileSystemProviderCapabilities.PathCaseSensitive)),this.M}async stat(l){try{const{stat:n,symbolicLink:r}=await m.SymlinkSupport.stat(this.I(l));return{type:this.O(n,r),ctime:n.birthtime.getTime(),mtime:n.mtime.getTime(),size:n.size,permissions:n.mode&128?void 0:I.FilePermission.Locked}}catch(n){throw this.hb(n)}}async N(l){try{return await this.stat(l)}catch{return}}async readdir(l){try{const n=await m.Promises.readdir(this.I(l),{withFileTypes:!0}),r=[];return await Promise.all(n.map(async t=>{try{let s;t.isSymbolicLink()?s=(await this.stat((0,c.$dh)(l,t.name))).type:s=this.O(t),r.push([t.name,s])}catch(s){this.a.trace(s)}})),r}catch(n){throw this.hb(n)}}O(l,n){let r;return n?.dangling?r=I.FileType.Unknown:l.isFile()?r=I.FileType.File:l.isDirectory()?r=I.FileType.Directory:r=I.FileType.Unknown,n&&(r|=I.FileType.SymbolicLink),r}async Q(l){const n=this.I(l);this.R(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${n})`);let r;for(;r=this.P.get(l);)this.R(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${n})`),await r.wait();const t=new P.$Bh;return this.P.set(l,t),this.R(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${n})`),(0,g.$Rc)(()=>{this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${n})`),this.P.get(l)===t&&(this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${n})`),this.P.delete(l)),this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${n})`),t.open()})}async readFile(l,n){let r;try{n?.atomic&&(this.R(`[Disk FileSystemProvider]: atomic read operation started (${this.I(l)})`),r=await this.Q(l));const t=this.I(l);return await S.promises.readFile(t)}catch(t){throw this.hb(t)}finally{r?.dispose()}}R(l){v.L&&this.a.trace(l)}readFileStream(l,n,r){const t=(0,f.$ze)(s=>k.$Le.concat(s.map(o=>k.$Le.wrap(o))).buffer);return(0,b.$Yq)(this,l,t,s=>s.buffer,{...n,bufferSize:256*1024},r),t}async writeFile(l,n,r){return r?.atomic!==!1&&r?.atomic?.postfix&&await this.S(l)?this.U(l,(0,c.$dh)((0,c.$ch)(l),`${(0,c.$ah)(l)}${r.atomic.postfix}`),n,r):this.W(l,n,r)}async S(l){try{const n=this.I(l),{symbolicLink:r}=await m.SymlinkSupport.stat(n);if(r)return!1}catch{}return!0}async U(l,n,r,t){const s=new g.$Sc;try{s.add(await this.Q(l)),s.add(await this.Q(n)),await this.W(n,r,t,!0);try{await this.rename(n,l,{overwrite:!0})}catch(o){try{await this.delete(n,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw o}}finally{s.dispose()}}async W(l,n,r,t){let s;try{const o=this.I(l);if(!r.create||!r.overwrite){if(await m.Promises.exists(o)){if(!r.overwrite)throw(0,I.$kl)((0,$.localize)(11223,null),I.FileSystemProviderErrorCode.FileExists)}else if(!r.create)throw(0,I.$kl)((0,$.localize)(11224,null),I.FileSystemProviderErrorCode.FileNotFound)}s=await this.open(l,{create:!0,unlock:r.unlock},t),await this.write(s,0,n,0,n.byteLength)}catch(o){throw await this.ib(l,o)}finally{typeof s=="number"&&await this.close(s)}}static{this.$=!0}static configureFlushOnWrite(l){v.$=l}async open(l,n,r){const t=this.I(l);let s;(0,I.$$k)(n)&&!r&&(s=await this.Q(l));let o;try{if((0,I.$$k)(n)&&n.unlock)try{const{stat:w}=await m.SymlinkSupport.stat(t);w.mode&128||await S.promises.chmod(t,w.mode|128)}catch(w){w.code!=="ENOENT"&&this.a.trace(w)}let u;if((0,I.$$k)(n)){if(d.$j)try{await S.promises.truncate(t,0),u="r+"}catch(w){w.code!=="ENOENT"&&this.a.trace(w)}u||(u="w")}else u="r";o=await m.Promises.open(t,u)}catch(u){throw s?.dispose(),(0,I.$$k)(n)?await this.ib(l,u):this.hb(u)}if(this.X.set(o,0),(0,I.$$k)(n)&&this.Z.set(o,l),s){const u=this.Y.get(o);this.R(`[Disk FileSystemProvider]: open() - storing lock for handle ${o} (${t})`),this.Y.set(o,s),u&&(this.R(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${o} (${t})`),u.dispose())}return o}async close(l){const n=this.Y.get(l);try{if(this.X.delete(l),this.Z.delete(l)&&v.$)try{await m.Promises.fdatasync(l)}catch(r){v.configureFlushOnWrite(!1),this.a.error(r)}return await m.Promises.close(l)}catch(r){throw this.hb(r)}finally{n&&(this.Y.get(l)===n&&(this.R(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${l}`),this.Y.delete(l)),this.R(`[Disk FileSystemProvider]: close() - disposing lock for handle ${l}`),n.dispose())}}async read(l,n,r,t,s){const o=this.ab(l,n);let u=null;try{u=(await m.Promises.read(l,r,t,s,o)).bytesRead}catch(w){throw this.hb(w)}finally{this.bb(l,o,u)}return u}ab(l,n){return n===this.X.get(l)?null:n}bb(l,n,r){const t=this.X.get(l);typeof t=="number"&&(typeof n=="number"||(typeof r=="number"?this.X.set(l,t+r):this.X.delete(l)))}async write(l,n,r,t,s){return(0,P.$Wh)(()=>this.cb(l,n,r,t,s),100,3)}async cb(l,n,r,t,s){const o=this.ab(l,n);let u=null;try{u=(await m.Promises.write(l,r,t,s,o)).bytesWritten}catch(w){throw await this.ib(this.Z.get(l),w)}finally{this.bb(l,o,u)}return u}async mkdir(l){try{await S.promises.mkdir(this.I(l))}catch(n){throw this.hb(n)}}async delete(l,n){try{const r=this.I(l);if(n.recursive){let t;n?.atomic!==!1&&n.atomic.postfix&&(t=(0,a.$ic)((0,a.$lc)(r),`${(0,a.$mc)(r)}${n.atomic.postfix}`)),await m.Promises.rm(r,m.RimRafMode.MOVE,t)}else try{await S.promises.unlink(r)}catch(t){if(t.code==="EPERM"||t.code==="EISDIR"){let s=!1;try{const{stat:o,symbolicLink:u}=await m.SymlinkSupport.stat(r);s=o.isDirectory()&&!u}catch{}if(s)await S.promises.rmdir(r);else throw t}else throw t}}catch(r){throw this.hb(r)}}async rename(l,n,r){const t=this.I(l),s=this.I(n);if(t!==s)try{await this.db(l,n,"move",r.overwrite),await m.Promises.rename(t,s)}catch(o){throw(o.code==="EINVAL"||o.code==="EBUSY"||o.code==="ENAMETOOLONG")&&(o=new Error((0,$.localize)(11225,null,(0,a.$mc)(t),(0,a.$mc)((0,a.$lc)(s)),o.toString()))),this.hb(o)}}async copy(l,n,r){const t=this.I(l),s=this.I(n);if(t!==s)try{await this.db(l,n,"copy",r.overwrite),await m.Promises.copy(t,s,{preserveSymlinks:!0})}catch(o){throw(o.code==="EINVAL"||o.code==="EBUSY"||o.code==="ENAMETOOLONG")&&(o=new Error((0,$.localize)(11226,null,(0,a.$mc)(t),(0,a.$mc)((0,a.$lc)(s)),o.toString()))),this.hb(o)}}async db(l,n,r,t){const s=this.I(l),o=this.I(n);let u=!1;if(!!(this.capabilities&I.FileSystemProviderCapabilities.PathCaseSensitive)||(u=(0,O.$Ag)(s,o,!0)),u){if(r==="copy")throw(0,I.$kl)((0,$.localize)(11227,null),I.FileSystemProviderErrorCode.FileExists);if(r==="move")return}const A=await this.N(l);if(!A)throw(0,I.$kl)((0,$.localize)(11228,null),I.FileSystemProviderErrorCode.FileNotFound);const T=await this.N(n);if(T){if(!t)throw(0,I.$kl)((0,$.localize)(11229,null),I.FileSystemProviderErrorCode.FileExists);A.type&I.FileType.File&&T.type&I.FileType.File||await this.delete(n,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(l,n){return this.eb(l,n,!1)}async eb(l,n,r){const t=this.I(l),s=this.I(n),o=!!(this.capabilities&I.FileSystemProviderCapabilities.PathCaseSensitive);if((0,O.$Ag)(t,s,!o))return;const u=new g.$Sc;try{u.add(await this.Q(l)),u.add(await this.Q(n)),r&&await S.promises.mkdir((0,a.$lc)(s),{recursive:!0}),await S.promises.copyFile(t,s)}catch(w){if(w.code==="ENOENT"&&!r)return this.eb(l,n,!0);throw this.hb(w)}finally{u.dispose()}}t(l,n,r){return new p.$gr(t=>l(t),t=>n(t),r)}F(l,n,r){return new R.$pr(t=>l(t),t=>n(t),r)}hb(l){if(l instanceof I.$jl)return l;let n=l,r;switch(l.code){case"ENOENT":r=I.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":r=I.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":r=I.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":r=I.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":r=I.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":n=`${l.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,r=I.FileSystemProviderErrorCode.Unknown;break;default:r=I.FileSystemProviderErrorCode.Unknown}return(0,I.$kl)(n,r)}async ib(l,n){let r=this.hb(n);if(l&&r.code===I.FileSystemProviderErrorCode.NoPermissions)try{const{stat:t}=await m.SymlinkSupport.stat(this.I(l));t.mode&128||(r=(0,I.$kl)(n,I.FileSystemProviderErrorCode.FileWriteLocked))}catch(t){this.a.trace(t)}return r}}e.$qr=v}),define(ce[110],le([0,1,2,6]),function(Q,e,S,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vR=void 0;class y extends S.$Tc{constructor(L,O=[]){super(),this.a=new P.$hk([L,...O]),this.B(L.onDidChangeLogLevel(g=>this.setLevel(g)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(L){this.a.setLevel(L)}getLevel(){return this.a.getLevel()}trace(L,...O){this.a.trace(L,...O)}debug(L,...O){this.a.debug(L,...O)}info(L,...O){this.a.info(L,...O)}warn(L,...O){this.a.warn(L,...O)}error(L,...O){this.a.error(L,...O)}flush(){this.a.flush()}}e.$vR=y}),define(ce[111],le([0,1,9,6]),function(Q,e,S,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kR=void 0;var y;(function(a){a[a.Trace=0]="Trace",a[a.Debug=1]="Debug",a[a.Info=2]="Info",a[a.Warning=3]="Warning",a[a.Error=4]="Error",a[a.Critical=5]="Critical",a[a.Off=6]="Off"})(y||(y={}));async function k(a,d,c,f,m){try{const $=await new Promise((b,h)=>{Q(["@vscode/spdlog"],b,h)}).then(ye);$.setFlushOn(y.Trace);const I=await $.createAsyncRotatingLogger(a,d,c,f);return m?I.clearFormatters():I.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),I}catch($){console.error($)}return null}function L(a,d,c){switch(d){case P.LogLevel.Trace:a.trace(c);break;case P.LogLevel.Debug:a.debug(c);break;case P.LogLevel.Info:a.info(c);break;case P.LogLevel.Warning:a.warn(c);break;case P.LogLevel.Error:a.error(c);break;case P.LogLevel.Off:break;default:throw new Error(`Invalid log level ${d}`)}}function O(a,d){switch(d){case P.LogLevel.Trace:a.setLevel(y.Trace);break;case P.LogLevel.Debug:a.setLevel(y.Debug);break;case P.LogLevel.Info:a.setLevel(y.Info);break;case P.LogLevel.Warning:a.setLevel(y.Warning);break;case P.LogLevel.Error:a.setLevel(y.Error);break;case P.LogLevel.Off:a.setLevel(y.Off);break;default:throw new Error(`Invalid log level ${d}`)}}class g extends P.$dk{constructor(d,c,f,m,$){super(),this.m=[],this.setLevel($),this.n=this.s(d,c,f,m),this.B(this.onDidChangeLogLevel(I=>{this.r&&O(this.r,I)}))}async s(d,c,f,m){const $=f?6:1,I=30/$*S.$Fl.MB,b=await k(d,c,I,$,m);if(b){this.r=b,O(this.r,this.getLevel());for(const{level:h,message:p}of this.m)L(this.r,h,p);this.m=[]}}g(d,c){this.r?L(this.r,d,c):this.getLevel()<=d&&this.m.push({level:d,message:c})}flush(){this.r?this.r.flush():this.n.then(()=>this.flush())}dispose(){this.r?this.u():this.n.then(()=>this.u()),super.dispose()}u(){this.r&&(this.r.drop(),this.r=void 0)}}e.$kR=g}),define(ce[112],le([0,1,27,6,111]),function(Q,e,S,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lR=void 0;class k extends P.$ik{s(O,g,a){return new y.$kR((0,S.$Yg)(),O.fsPath,!a?.donotRotate,!!a?.donotUseFormatters,g)}}e.$lR=k}),define(ce[39],le([0,1,4,65,2,10]),function(Q,e,S,P,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$so=e.$ro=e.$qo=void 0,e.$qo=(0,k.$Ci)("policy");class L extends y.$Tc{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new S.$je),this.onDidChange=this.h.event}async updatePolicyDefinitions(a){const d=Object.keys(this.f).length;return this.f={...a,...this.f},d!==Object.keys(this.f).length&&await this.j(a),P.Iterable.reduce(this.g.entries(),(c,[f,m])=>({...c,[f]:m}),{})}getPolicyValue(a){return this.g.get(a)}serialize(){return P.Iterable.reduce(Object.entries(this.f),(a,[d,c])=>({...a,[d]:{definition:c,value:this.g.get(d)}}),{})}}e.$ro=L;class O{constructor(){this.onDidChange=S.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.$so=O}),define(ce[113],le([0,1,8,4,65,3,9,6,39]),function(Q,e,S,P,y,k,L,O,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ghc=void 0;function a(c,f){const m=[];for(const $ of new Set(y.Iterable.concat(c.keys(),f.keys())))c.get($)!==f.get($)&&m.push($);return m}let d=class extends g.$ro{constructor(f,m,$){super(),this.m=f,this.n=m,this.s=$,this.c=this.B(new S.$Ah(500));const I=P.Event.filter(m.onDidFilesChange,b=>b.affects(f));this.B(m.watch(f)),this.B(I(()=>this.c.trigger(()=>this.w())))}async j(){await this.w()}async u(){const f=new Map;try{const m=await this.n.readFile(this.m),$=JSON.parse(m.value.toString());if(!(0,k.$eg)($))throw new Error("Policy file isn't a JSON object");for(const I of Object.keys($))this.f[I]&&f.set(I,$[I])}catch(m){m.fileOperationResult!==L.FileOperationResult.FILE_NOT_FOUND&&this.s.error("[FilePolicyService] Failed to read policies",m)}return f}async w(){const f=await this.u(),m=a(this.g,f);this.g=f,m.length>0&&this.h.fire(m)}};e.$ghc=d,e.$ghc=d=ve([se(1,L.$0k),se(2,O.$0j)],d)}),define(ce[114],le([0,1,39,8,2,6]),function(Q,e,S,P,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fhc=void 0;let L=class extends S.$ro{constructor(g,a){super(),this.m=g,this.n=a,this.a=new P.$wh,this.b=this.B(new y.$Uc)}async j(g){this.m.trace(`NativePolicyService#_updatePolicyDefinitions - Found ${Object.keys(g).length} policy definitions`);const{createWatcher:a}=await new Promise((d,c)=>{Q(["@vscode/policy-watcher"],d,c)}).then(ye);await this.a.queue(()=>new Promise((d,c)=>{try{this.b.value=a(this.n,g,f=>{this.t(f),d()})}catch(f){this.m.error("NativePolicyService#_updatePolicyDefinitions - Error creating watcher:",f),c(f)}}))}t(g){this.m.trace(`NativePolicyService#_onDidPolicyChange - Updated policy values: ${JSON.stringify(g)}`);for(const a in g){const d=g[a];d===void 0?this.g.delete(a):this.g.set(a,d)}this.h.fire(Object.keys(g))}};e.$fhc=L,e.$fhc=L=ve([se(0,k.$0j)],L)}),define(ce[33],le([0,1,10]),function(Q,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rk=e.$qk=void 0,e.$qk=(0,S.$Ci)("productService"),e.$rk="vscode://schemas/vscode-product"}),define(ce[37],le([0,1,75,3]),function(Q,e,S,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oo=void 0,S=ye(S),P=ye(P);class y{constructor(){this.a=new Map}add(L,O){S.ok(P.$cg(L)),S.ok(P.$eg(O)),S.ok(!this.a.has(L),"There is already an extension with this id"),this.a.set(L,O)}knows(L){return this.a.has(L)}as(L){return this.a.get(L)||null}}e.$oo=new y}),define(ce[115],le([0,1,4,78,37]),function(Q,e,S,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$po=void 0,y=ye(y),e.$po={JSONContribution:"base.contributions.json"};function k(g){return g.length>0&&g.charAt(g.length-1)==="#"?g.substring(0,g.length-1):g}class L{constructor(){this.b=new S.$je,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(a,d){this.a[k(a)]=d,this.b.fire(a)}notifySchemaChanged(a){this.b.fire(a)}getSchemaContributions(){return{schemas:this.a}}getSchemaContent(a){const d=this.a[a];return d?(0,P.$5j)(d):void 0}hasSchemaContent(a){return!!this.a[a]}}const O=new L;y.$oo.add(e.$po.JSONContribution,O)}),define(ce[40],le([0,1,19,4,3,5,29,115,37]),function(Q,e,S,P,y,k,L,O,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Do=e.$Co=e.$Bo=e.$Ao=e.$zo=e.$yo=e.$xo=e.$wo=e.$vo=e.$uo=e.ConfigurationScope=e.$to=e.EditPresentationTypes=void 0,e.$Eo=I,e.$Fo=b,e.$Go=h,e.$Ho=R,e.$Io=v,e.$Jo=i,e.$Ko=l,y=ye(y),k=ye(k);var a;(function(n){n.Multiline="multilineText",n.Singleline="singlelineText"})(a||(e.EditPresentationTypes=a={})),e.$to={Configuration:"base.contributions.configuration"};var d;(function(n){n[n.APPLICATION=1]="APPLICATION",n[n.MACHINE=2]="MACHINE",n[n.WINDOW=3]="WINDOW",n[n.RESOURCE=4]="RESOURCE",n[n.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",n[n.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(d||(e.ConfigurationScope=d={})),e.$uo={properties:{},patternProperties:{}},e.$vo={properties:{},patternProperties:{}},e.$wo={properties:{},patternProperties:{}},e.$xo={properties:{},patternProperties:{}},e.$yo={properties:{},patternProperties:{}},e.$zo={properties:{},patternProperties:{}},e.$Ao="vscode://schemas/settings/resourceLanguage",e.$Bo="vscode://schemas/settings/configurationDefaults";const c=g.$oo.as(O.$po.JSONContribution);class f{constructor(){this.a=[],this.i=new Set,this.j=new P.$je,this.onDidSchemaChange=this.j.event,this.k=new P.$je,this.onDidUpdateConfiguration=this.k.event,this.b=new Map,this.c={id:"defaultOverrides",title:k.localize(11458,null),properties:{}},this.d=[this.c],this.h={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.e={},this.f=new Map,this.g={},c.registerSchema(e.$Ao,this.h),this.z()}registerConfiguration(r,t=!0){this.registerConfigurations([r],t)}registerConfigurations(r,t=!0){const s=new Set;this.r(r,t,s),c.registerSchema(e.$Ao,this.h),this.j.fire(),this.k.fire({properties:s})}deregisterConfigurations(r){const t=new Set;this.s(r,t),c.registerSchema(e.$Ao,this.h),this.j.fire(),this.k.fire({properties:t})}updateConfigurations({add:r,remove:t}){const s=new Set;this.s(t,s),this.r(r,!1,s),c.registerSchema(e.$Ao,this.h),this.j.fire(),this.k.fire({properties:s})}registerDefaultConfigurations(r){const t=new Set;this.l(r,t),this.j.fire(),this.k.fire({properties:t,defaultsOverrides:!0})}l(r,t){this.a.push(...r);const s=[];for(const{overrides:o,source:u}of r)for(const w in o){t.add(w);const A=this.b.get(w)??this.b.set(w,{configurationDefaultOverrides:[]}).get(w),T=o[w];if(A.configurationDefaultOverrides.push({value:T,source:u}),e.$Do.test(w)){const D=this.o(w,T,u,A.configurationDefaultOverrideValue);if(!D)continue;A.configurationDefaultOverrideValue=D,this.n(w,D,u),s.push(...I(w))}else{const D=this.p(w,T,u,A.configurationDefaultOverrideValue);if(!D)continue;A.configurationDefaultOverrideValue=D;const N=this.e[w];N&&(this.A(w,N),this.w(w,N))}}this.q(s)}deregisterDefaultConfigurations(r){const t=new Set;this.m(r,t),this.j.fire(),this.k.fire({properties:t,defaultsOverrides:!0})}m(r,t){for(const s of r){const o=this.a.indexOf(s);o!==-1&&this.a.splice(o,1)}for(const{overrides:s,source:o}of r)for(const u in s){const w=this.b.get(u);if(!w)continue;const A=w.configurationDefaultOverrides.findIndex(T=>o?T.source?.id===o.id:T.value===s[u]);if(A!==-1){if(w.configurationDefaultOverrides.splice(A,1),w.configurationDefaultOverrides.length===0&&this.b.delete(u),e.$Do.test(u)){let T;for(const D of w.configurationDefaultOverrides)T=this.o(u,D.value,D.source,T);T&&!y.$pg(T.value)?(w.configurationDefaultOverrideValue=T,this.n(u,T,o)):(this.b.delete(u),delete this.e[u],delete this.c.properties[u])}else{let T;for(const N of w.configurationDefaultOverrides)T=this.p(u,N.value,N.source,T);w.configurationDefaultOverrideValue=T;const D=this.e[u];D&&(this.A(u,D),this.w(u,D))}t.add(u)}}this.y()}n(r,t,s){const o={type:"object",default:t.value,description:k.localize(11459,null,(0,L.$gj)(r)),$ref:e.$Ao,defaultDefaultValue:t.value,source:s,defaultValueSource:s};this.e[r]=o,this.c.properties[r]=o}o(r,t,s,o){const u=o?.value||{},w=o?.source??new Map;if(!(w instanceof Map)){console.error("objectConfigurationSources is not a Map");return}for(const A of Object.keys(t)){const T=t[A];if(y.$eg(T)&&(y.$jg(u[A])||y.$eg(u[A]))){if(u[A]={...u[A]??{},...T},s)for(const N in T)w.set(`${A}.${N}`,s)}else u[A]=T,s?w.set(A,s):w.delete(A)}return{value:u,source:w}}p(r,t,s,o){const u=this.e[r],w=o?.value??u?.defaultDefaultValue;let A=s;if(y.$eg(t)&&(u!==void 0&&u.type==="object"||u===void 0&&(y.$jg(w)||y.$eg(w)))){if(A=o?.source??new Map,!(A instanceof Map)){console.error("defaultValueSource is not a Map");return}for(const D in t)s&&A.set(`${r}.${D}`,s);t={...y.$eg(w)?w:{},...t}}return{value:t,source:A}}deltaConfiguration(r){let t=!1;const s=new Set;r.removedDefaults&&(this.m(r.removedDefaults,s),t=!0),r.addedDefaults&&(this.l(r.addedDefaults,s),t=!0),r.removedConfigurations&&this.s(r.removedConfigurations,s),r.addedConfigurations&&this.r(r.addedConfigurations,!1,s),this.j.fire(),this.k.fire({properties:s,defaultsOverrides:t})}notifyConfigurationSchemaUpdated(...r){this.j.fire()}registerOverrideIdentifiers(r){this.q(r),this.j.fire()}q(r){for(const t of r)this.i.add(t);this.y()}r(r,t,s){r.forEach(o=>{this.u(o,t,o.extensionInfo,o.restrictedProperties,void 0,s),this.d.push(o),this.v(o)})}s(r,t){const s=o=>{if(o.properties)for(const u in o.properties){t.add(u);const w=this.e[u];w?.policy?.name&&this.f.delete(w.policy.name),delete this.e[u],this.x(u,o.properties[u])}o.allOf?.forEach(u=>s(u))};for(const o of r){s(o);const u=this.d.indexOf(o);u!==-1&&this.d.splice(u,1)}}u(r,t=!0,s,o,u=d.WINDOW,w){u=y.$lg(r.scope)?u:r.scope;const A=r.properties;if(A)for(const D in A){const N=A[D];if(t&&R(D,N)){delete A[D];continue}if(N.source=s,N.defaultDefaultValue=A[D].default,this.A(D,N),e.$Do.test(D)?N.scope=void 0:(N.scope=y.$lg(N.scope)?u:N.scope,N.restricted=y.$lg(N.restricted)?!!o?.includes(D):N.restricted),A[D].hasOwnProperty("included")&&!A[D].included){this.g[D]=A[D],delete A[D];continue}else this.e[D]=A[D],A[D].policy?.name&&this.f.set(A[D].policy.name,D);!A[D].deprecationMessage&&A[D].markdownDeprecationMessage&&(A[D].deprecationMessage=A[D].markdownDeprecationMessage),w.add(D)}const T=r.allOf;if(T)for(const D of T)this.u(D,t,s,o,u,w)}getConfigurations(){return this.d}getConfigurationProperties(){return this.e}getPolicyConfigurations(){return this.f}getExcludedConfigurationProperties(){return this.g}getRegisteredDefaultConfigurations(){return[...this.a]}getConfigurationDefaultsOverrides(){const r=new Map;for(const[t,s]of this.b)s.configurationDefaultOverrideValue&&r.set(t,s.configurationDefaultOverrideValue);return r}v(r){const t=s=>{const o=s.properties;if(o)for(const w in o)this.w(w,o[w]);s.allOf?.forEach(t)};t(r)}w(r,t){switch(e.$uo.properties[r]=t,t.scope){case d.APPLICATION:e.$vo.properties[r]=t;break;case d.MACHINE:e.$wo.properties[r]=t;break;case d.MACHINE_OVERRIDABLE:e.$xo.properties[r]=t;break;case d.WINDOW:e.$yo.properties[r]=t;break;case d.RESOURCE:e.$zo.properties[r]=t;break;case d.LANGUAGE_OVERRIDABLE:e.$zo.properties[r]=t,this.h.properties[r]=t;break}}x(r,t){switch(delete e.$uo.properties[r],t.scope){case d.APPLICATION:delete e.$vo.properties[r];break;case d.MACHINE:delete e.$wo.properties[r];break;case d.MACHINE_OVERRIDABLE:delete e.$xo.properties[r];break;case d.WINDOW:delete e.$yo.properties[r];break;case d.RESOURCE:case d.LANGUAGE_OVERRIDABLE:delete e.$zo.properties[r],delete this.h.properties[r];break}}y(){for(const r of this.i.values()){const t=`[${r}]`,s={type:"object",description:k.localize(11460,null),errorMessage:k.localize(11461,null),$ref:e.$Ao};this.A(t,s),e.$uo.properties[t]=s,e.$vo.properties[t]=s,e.$wo.properties[t]=s,e.$xo.properties[t]=s,e.$yo.properties[t]=s,e.$zo.properties[t]=s}}z(){const r={type:"object",description:k.localize(11462,null),errorMessage:k.localize(11463,null),$ref:e.$Ao};e.$uo.patternProperties[e.$Co]=r,e.$vo.patternProperties[e.$Co]=r,e.$wo.patternProperties[e.$Co]=r,e.$xo.patternProperties[e.$Co]=r,e.$yo.patternProperties[e.$Co]=r,e.$zo.patternProperties[e.$Co]=r,this.j.fire()}A(r,t){const s=this.b.get(r)?.configurationDefaultOverrideValue;let o,u;s&&(!t.disallowConfigurationDefault||!s.source)&&(o=s.value,u=s.source),y.$jg(o)&&(o=t.defaultDefaultValue,u=void 0),y.$jg(o)&&(o=h(t.type)),t.default=o,t.defaultValueSource=u}}const m="\\[([^\\]]+)\\]",$=new RegExp(m,"g");e.$Co=`^(${m})+$`,e.$Do=new RegExp(e.$Co);function I(n){const r=[];if(e.$Do.test(n)){let t=$.exec(n);for(;t?.length;){const s=t[1].trim();s&&r.push(s),t=$.exec(n)}}return(0,S.$Lb)(r)}function b(n){return n.reduce((r,t)=>`${r}[${t}]`,"")}function h(n){switch(Array.isArray(n)?n[0]:n){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}const p=new f;g.$oo.add(e.$to.Configuration,p);function R(n,r){return n.trim()?e.$Do.test(n)?k.localize(11465,null,n):p.getConfigurationProperties()[n]!==void 0?k.localize(11466,null,n):r.policy?.name&&p.getPolicyConfigurations().get(r.policy?.name)!==void 0?k.localize(11467,null,n,r.policy?.name,p.getPolicyConfigurations().get(r.policy?.name)):null:k.localize(11464,null)}function v(){const n=[],r=p.getConfigurationProperties();for(const t of Object.keys(r))n.push([t,r[t].scope]);return n.push(["launch",d.RESOURCE]),n.push(["task",d.RESOURCE]),n}function i(n){const r={};for(const t of n){const s=t.properties;if(y.$eg(s))for(const o in s)r[o]=s[o];t.allOf&&Object.assign(r,i(t.allOf))}return r}function l(n){switch(n){case"application":return d.APPLICATION;case"machine":return d.MACHINE;case"resource":return d.RESOURCE;case"machine-overridable":return d.MACHINE_OVERRIDABLE;case"language-overridable":return d.LANGUAGE_OVERRIDABLE;default:return d.WINDOW}}}),define(ce[66],le([0,1,19,4,34,2,30,26,3,11,29,40,9,37]),function(Q,e,S,P,y,k,L,O,g,a,d,c,f,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qo=e.$Oo=e.$No=e.$Mo=e.$Lo=void 0,e.$Po=v,S=ye(S),y=ye(y),O=ye(O),g=ye(g);function $(r){return Object.isFrozen(r)?r:O.$co(r)}class I{static createEmptyModel(t){return new I({},[],[],void 0,t)}constructor(t,s,o,u,w){this.b=t,this.c=s,this.d=o,this.raw=u,this.f=w,this.a=new Map}get rawConfiguration(){if(!this.g)if(this.raw?.length){const t=this.raw.map(s=>{if(s instanceof I)return s;const o=new b("",this.f);return o.parseRaw(s),o.configurationModel});this.g=t.reduce((s,o)=>o===s?o:s.merge(o),t[0])}else this.g=this;return this.g}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(t){return t?(0,d.$ej)(this.contents,t):this.contents}inspect(t,s){const o=this;return{get value(){return $(o.rawConfiguration.getValue(t))},get override(){return s?$(o.rawConfiguration.getOverrideValue(t,s)):void 0},get merged(){return $(s?o.rawConfiguration.override(s).getValue(t):o.rawConfiguration.getValue(t))},get overrides(){const u=[];for(const{contents:w,identifiers:A,keys:T}of o.rawConfiguration.overrides){const D=new I(w,T,[],void 0,o.f).getValue(t);D!==void 0&&u.push({identifiers:A,value:D})}return u.length?$(u):void 0}}}getOverrideValue(t,s){const o=this.j(s);return o?t?(0,d.$ej)(o,t):o:void 0}getKeysForOverrideIdentifier(t){const s=[];for(const o of this.overrides)o.identifiers.includes(t)&&s.push(...o.keys);return S.$Lb(s)}getAllOverrideIdentifiers(){const t=[];for(const s of this.overrides)t.push(...s.identifiers);return S.$Lb(t)}override(t){let s=this.a.get(t);return s||(s=this.h(t),this.a.set(t,s)),s}merge(...t){const s=O.$bo(this.contents),o=O.$bo(this.overrides),u=[...this.keys],w=this.raw?.length?[...this.raw]:[this];for(const A of t)if(w.push(...A.raw?.length?A.raw:[A]),!A.isEmpty()){this.i(s,A.contents);for(const T of A.overrides){const[D]=o.filter(N=>S.$tb(N.identifiers,T.identifiers));D?(this.i(D.contents,T.contents),D.keys.push(...T.keys),D.keys=S.$Lb(D.keys)):o.push(O.$bo(T))}for(const T of A.keys)u.indexOf(T)===-1&&u.push(T)}return new I(s,u,o,w.every(A=>A instanceof I)?void 0:w,this.f)}h(t){const s=this.j(t);if(!s||typeof s!="object"||!Object.keys(s).length)return this;const o={};for(const u of S.$Lb([...Object.keys(this.contents),...Object.keys(s)])){let w=this.contents[u];const A=s[u];A&&(typeof w=="object"&&typeof A=="object"?(w=O.$bo(w),this.i(w,A)):w=A),o[u]=w}return new I(o,this.keys,this.overrides,void 0,this.f)}i(t,s){for(const o of Object.keys(s)){if(o in t&&g.$eg(t[o])&&g.$eg(s[o])){this.i(t[o],s[o]);continue}t[o]=O.$bo(s[o])}}j(t){let s=null,o=null;const u=w=>{w&&(o?this.i(o,w):o=O.$bo(w))};for(const w of this.overrides)w.identifiers.length===1&&w.identifiers[0]===t?s=w.contents:w.identifiers.includes(t)&&u(w.contents);return u(s),o}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(t,s){this.k(t,s,!0)}setValue(t,s){this.k(t,s,!1)}removeValue(t){const s=this.keys.indexOf(t);s!==-1&&(this.keys.splice(s,1),(0,d.$dj)(this.contents,t),c.$Do.test(t)&&this.overrides.splice(this.overrides.findIndex(o=>S.$tb(o.identifiers,(0,c.$Eo)(t))),1))}k(t,s,o){if((0,d.$cj)(this.contents,t,s,u=>this.f.error(u)),o=o||this.keys.indexOf(t)===-1,o&&this.keys.push(t),c.$Do.test(t)){const u=(0,c.$Eo)(t),w={identifiers:u,keys:Object.keys(this.contents[t]),contents:(0,d.$bj)(this.contents[t],T=>this.f.error(T))},A=this.overrides.findIndex(T=>S.$tb(T.identifiers,u));A!==-1?this.overrides[A]=w:this.overrides.push(w)}}}e.$Lo=I;class b{constructor(t,s){this.f=t,this.g=s,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||I.createEmptyModel(this.g)}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(t,s){if(!g.$lg(t)){const o=this.h(t);this.parseRaw(o,s)}}reparse(t){this.a&&this.parseRaw(this.a,t)}parseRaw(t,s){this.a=t;const{contents:o,keys:u,overrides:w,restricted:A,hasExcludedProperties:T}=this.i(t,s);this.b=new I(o,u,w,T?[t]:void 0,this.g),this.c=A||[]}h(t){let s={},o=null,u=[];const w=[],A=[];function T(N){Array.isArray(u)?u.push(N):o!==null&&(u[o]=N)}const D={onObjectBegin:()=>{const N={};T(N),w.push(u),u=N,o=null},onObjectProperty:N=>{o=N},onObjectEnd:()=>{u=w.pop()},onArrayBegin:()=>{const N=[];T(N),w.push(u),u=N,o=null},onArrayEnd:()=>{u=w.pop()},onLiteralValue:T,onError:(N,M,Y)=>{A.push({error:N,offset:M,length:Y})}};if(t)try{y.$3n(t,D),s=u[0]||{}}catch(N){this.g.error(`Error while parsing settings file ${this.f}: ${N}`),this.d=[N]}return s}i(t,s){const o=m.$oo.as(c.$to.Configuration).getConfigurationProperties(),u=this.j(t,o,!0,s);t=u.raw;const w=(0,d.$bj)(t,D=>this.g.error(`Conflict in settings file ${this.f}: ${D}`)),A=Object.keys(t),T=this.l(t,D=>this.g.error(`Conflict in settings file ${this.f}: ${D}`));return{contents:w,keys:A,overrides:T,restricted:u.restricted,hasExcludedProperties:u.hasExcludedProperties}}j(t,s,o,u){let w=!1;if(!u?.scopes&&!u?.skipRestricted&&!u?.exclude?.length)return{raw:t,restricted:[],hasExcludedProperties:w};const A={},T=[];for(const D in t)if(c.$Do.test(D)&&o){const N=this.j(t[D],s,!1,u);A[D]=N.raw,w=w||N.hasExcludedProperties,T.push(...N.restricted)}else{const N=s[D],M=N?typeof N.scope<"u"?N.scope:c.ConfigurationScope.WINDOW:void 0;N?.restricted&&T.push(D),!u.exclude?.includes(D)&&(u.include?.includes(D)||(M===void 0||u.scopes===void 0||u.scopes.includes(M))&&!(u.skipRestricted&&N?.restricted))?A[D]=t[D]:w=!0}return{raw:A,restricted:T,hasExcludedProperties:w}}l(t,s){const o=[];for(const u of Object.keys(t))if(c.$Do.test(u)){const w={};for(const A in t[u])w[A]=t[u][A];o.push({identifiers:(0,c.$Eo)(u),keys:Object.keys(w),contents:(0,d.$bj)(w,s)})}return o}}e.$Mo=b;class h extends k.$Tc{constructor(t,s,o,u,w){super(),this.c=t,this.f=s,this.g=u,this.h=w,this.b=this.B(new P.$je),this.onDidChange=this.b.event,this.a=new b(this.c.toString(),w),this.B(this.g.watch(o.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(P.Event.any(P.Event.filter(this.g.onDidFilesChange,A=>A.contains(this.c)),P.Event.filter(this.g.onDidRunOperation,A=>(A.isOperation(f.FileOperation.CREATE)||A.isOperation(f.FileOperation.COPY)||A.isOperation(f.FileOperation.DELETE)||A.isOperation(f.FileOperation.WRITE))&&o.isEqual(A.resource,t)))(()=>this.b.fire()))}async loadConfiguration(){try{const t=await this.g.readFile(this.c);return this.a.parse(t.value.toString()||"{}",this.f),this.a.configurationModel}catch{return I.createEmptyModel(this.h)}}reparse(t){return t&&(this.f=t),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$No=h;class p{constructor(t,s,o,u,w,A,T,D,N,M,Y,K,re){this.a=t,this.b=s,this.c=o,this.overrideIdentifiers=u,this.d=w,this.f=A,this.g=T,this.h=D,this.i=N,this.j=M,this.k=Y,this.l=K,this.m=re}get value(){return $(this.c)}n(t){return t?.value!==void 0||t?.override!==void 0||t?.overrides!==void 0?t:void 0}get q(){return this.p||(this.p=this.d.inspect(this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.n(this.q)}get s(){return this.r===void 0&&(this.r=this.f?this.f.inspect(this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.g.inspect(this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.n(this.u)}get w(){return this.v||(this.v=this.h.inspect(this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.n(this.w)}get y(){return this.x||(this.x=this.i.inspect(this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.n(this.y)}get A(){return this.z||(this.z=this.j.inspect(this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.n(this.A)}get D(){return this.B===void 0&&(this.B=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.n(this.D)}get F(){return this.E===void 0&&(this.E=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.n(this.F)}get H(){return this.G===void 0&&(this.G=this.m.inspect(this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.n(this.H)}}class R{constructor(t,s,o,u,w,A,T,D,N,M){this.j=t,this.l=s,this.m=o,this.n=u,this.p=w,this.q=A,this.r=T,this.s=D,this.t=N,this.u=M,this.h=null,this.i=new L.$zc,this.v=null}getValue(t,s,o){return this.w(t,s,o).getValue(t)}updateValue(t,s,o={}){let u;o.resource?(u=this.t.get(o.resource),u||(u=I.createEmptyModel(this.u),this.t.set(o.resource,u))):u=this.s,s===void 0?u.removeValue(t):u.setValue(t,s),o.resource||(this.h=null)}inspect(t,s,o){const u=this.w(t,s,o),w=this.A(s.resource,o),A=s.resource?this.t.get(s.resource)||this.s:this.s,T=new Set;for(const D of u.overrides)for(const N of D.identifiers)u.getOverrideValue(t,N)!==void 0&&T.add(N);return new p(t,s,u.getValue(t),T.size?[...T]:void 0,this.j,this.l.isEmpty()?void 0:this.l,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,o?this.q:void 0,w||void 0,A)}keys(t){const s=this.A(void 0,t);return{default:this.j.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.q.keys.slice(0),workspaceFolder:s?s.keys.slice(0):[]}}updateDefaultConfiguration(t){this.j=t,this.h=null,this.i.clear()}updatePolicyConfiguration(t){this.l=t}updateApplicationConfiguration(t){this.m=t,this.h=null,this.i.clear()}updateLocalUserConfiguration(t){this.n=t,this.v=null,this.h=null,this.i.clear()}updateRemoteUserConfiguration(t){this.p=t,this.v=null,this.h=null,this.i.clear()}updateWorkspaceConfiguration(t){this.q=t,this.h=null,this.i.clear()}updateFolderConfiguration(t,s){this.r.set(t,s),this.i.delete(t)}deleteFolderConfiguration(t){this.folderConfigurations.delete(t),this.i.delete(t)}compareAndUpdateDefaultConfiguration(t,s){const o=[];if(!s){const{added:u,updated:w,removed:A}=l(this.j,t);s=[...u,...w,...A]}for(const u of s)for(const w of(0,c.$Eo)(u)){const A=this.j.getKeysForOverrideIdentifier(w),T=t.getKeysForOverrideIdentifier(w),D=[...T.filter(N=>A.indexOf(N)===-1),...A.filter(N=>T.indexOf(N)===-1),...A.filter(N=>!O.$fo(this.j.override(w).getValue(N),t.override(w).getValue(N)))];o.push([w,D])}return this.updateDefaultConfiguration(t),{keys:s,overrides:o}}compareAndUpdatePolicyConfiguration(t){const{added:s,updated:o,removed:u}=l(this.l,t),w=[...s,...o,...u];return w.length&&this.updatePolicyConfiguration(t),{keys:w,overrides:[]}}compareAndUpdateApplicationConfiguration(t){const{added:s,updated:o,removed:u,overrides:w}=l(this.applicationConfiguration,t),A=[...s,...o,...u];return A.length&&this.updateApplicationConfiguration(t),{keys:A,overrides:w}}compareAndUpdateLocalUserConfiguration(t){const{added:s,updated:o,removed:u,overrides:w}=l(this.localUserConfiguration,t),A=[...s,...o,...u];return A.length&&this.updateLocalUserConfiguration(t),{keys:A,overrides:w}}compareAndUpdateRemoteUserConfiguration(t){const{added:s,updated:o,removed:u,overrides:w}=l(this.remoteUserConfiguration,t),A=[...s,...o,...u];return A.length&&this.updateRemoteUserConfiguration(t),{keys:A,overrides:w}}compareAndUpdateWorkspaceConfiguration(t){const{added:s,updated:o,removed:u,overrides:w}=l(this.workspaceConfiguration,t),A=[...s,...o,...u];return A.length&&this.updateWorkspaceConfiguration(t),{keys:A,overrides:w}}compareAndUpdateFolderConfiguration(t,s){const o=this.folderConfigurations.get(t),{added:u,updated:w,removed:A,overrides:T}=l(o,s),D=[...u,...w,...A];return(D.length||!o)&&this.updateFolderConfiguration(t,s),{keys:D,overrides:T}}compareAndDeleteFolderConfiguration(t){const s=this.folderConfigurations.get(t);if(!s)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:o,updated:u,removed:w,overrides:A}=l(s,void 0);return{keys:[...o,...u,...w],overrides:A}}get defaults(){return this.j}get applicationConfiguration(){return this.m}get userConfiguration(){return this.v||(this.v=this.p.isEmpty()?this.n:this.n.merge(this.p)),this.v}get localUserConfiguration(){return this.n}get remoteUserConfiguration(){return this.p}get workspaceConfiguration(){return this.q}get folderConfigurations(){return this.r}w(t,s,o){let u=this.x(s,o);return s.overrideIdentifier&&(u=u.override(s.overrideIdentifier)),!this.l.isEmpty()&&this.l.getValue(t)!==void 0&&(u=u.merge(this.l)),u}x({resource:t},s){let o=this.y();if(s&&t){const u=s.getFolder(t);u&&(o=this.z(u.uri)||o);const w=this.t.get(t);w&&(o=o.merge(w))}return o}y(){return this.h||(this.h=this.j.merge(this.applicationConfiguration,this.userConfiguration,this.q,this.s)),this.h}z(t){let s=this.i.get(t);if(!s){const o=this.y(),u=this.r.get(t);u?(s=o.merge(u),this.i.set(t,s)):s=o}return s}A(t,s){if(s&&t){const o=s.getFolder(t);if(o)return this.r.get(o.uri)}}toData(){return{defaults:{contents:this.j.contents,overrides:this.j.overrides,keys:this.j.keys},policy:{contents:this.l.contents,overrides:this.l.overrides,keys:this.l.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.q.contents,overrides:this.q.overrides,keys:this.q.keys},folders:[...this.r.keys()].reduce((t,s)=>{const{contents:o,overrides:u,keys:w}=this.r.get(s);return t.push([s,{contents:o,overrides:u,keys:w}]),t},[])}}allKeys(){const t=new Set;return this.j.keys.forEach(s=>t.add(s)),this.userConfiguration.keys.forEach(s=>t.add(s)),this.q.keys.forEach(s=>t.add(s)),this.r.forEach(s=>s.keys.forEach(o=>t.add(o))),[...t.values()]}B(){const t=new Set;return this.j.getAllOverrideIdentifiers().forEach(s=>t.add(s)),this.userConfiguration.getAllOverrideIdentifiers().forEach(s=>t.add(s)),this.q.getAllOverrideIdentifiers().forEach(s=>t.add(s)),this.r.forEach(s=>s.getAllOverrideIdentifiers().forEach(o=>t.add(o))),[...t.values()]}D(t){const s=new Set;return this.j.getKeysForOverrideIdentifier(t).forEach(o=>s.add(o)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(o=>s.add(o)),this.q.getKeysForOverrideIdentifier(t).forEach(o=>s.add(o)),this.r.forEach(o=>o.getKeysForOverrideIdentifier(t).forEach(u=>s.add(u))),[...s.values()]}static parse(t,s){const o=this.E(t.defaults,s),u=this.E(t.policy,s),w=this.E(t.application,s),A=this.E(t.user,s),T=this.E(t.workspace,s),D=t.folders.reduce((N,M)=>(N.set(a.URI.revive(M[0]),this.E(M[1],s)),N),new L.$zc);return new R(o,u,w,A,I.createEmptyModel(s),T,D,I.createEmptyModel(s),new L.$zc,s)}static E(t,s){return new I(t.contents,t.keys,t.overrides,void 0,s)}}e.$Oo=R;function v(...r){if(r.length===0)return{keys:[],overrides:[]};if(r.length===1)return r[0];const t=new Set,s=new Map;for(const u of r)u.keys.forEach(w=>t.add(w)),u.overrides.forEach(([w,A])=>{const T=(0,L.$wc)(s,w,new Set);A.forEach(D=>T.add(D))});const o=[];return s.forEach((u,w)=>o.push([w,[...u.values()]])),{keys:[...t.values()],overrides:o}}class i{constructor(t,s,o,u,w){this.change=t,this.f=s,this.g=o,this.h=u,this.i=w,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=46,this.affectedKeys=new Set,this.j=void 0;for(const A of t.keys)this.affectedKeys.add(A);for(const[,A]of t.overrides)for(const T of A)this.affectedKeys.add(T);this.d=this.a;for(const A of this.affectedKeys)this.d+=A+this.a}get previousConfiguration(){return!this.j&&this.f&&(this.j=R.parse(this.f.data,this.i)),this.j}affectsConfiguration(t,s){const o=this.a+t,u=this.d.indexOf(o);if(u<0)return!1;const w=u+o.length;if(w>=this.d.length)return!1;const A=this.d.charCodeAt(w);if(A!==this.b&&A!==this.c)return!1;if(s){const T=this.previousConfiguration?this.previousConfiguration.getValue(t,s,this.f?.workspace):void 0,D=this.g.getValue(t,s,this.h);return!O.$fo(T,D)}return!0}}e.$Qo=i;function l(r,t){const{added:s,removed:o,updated:u}=n(t?.rawConfiguration,r?.rawConfiguration),w=[],A=r?.getAllOverrideIdentifiers()||[],T=t?.getAllOverrideIdentifiers()||[];if(t){const D=T.filter(N=>!A.includes(N));for(const N of D)w.push([N,t.getKeysForOverrideIdentifier(N)])}if(r){const D=A.filter(N=>!T.includes(N));for(const N of D)w.push([N,r.getKeysForOverrideIdentifier(N)])}if(t&&r){for(const D of A)if(T.includes(D)){const N=n({contents:r.getOverrideValue(void 0,D)||{},keys:r.getKeysForOverrideIdentifier(D)},{contents:t.getOverrideValue(void 0,D)||{},keys:t.getKeysForOverrideIdentifier(D)});w.push([D,[...N.added,...N.removed,...N.updated]])}}return{added:s,removed:o,updated:u,overrides:w}}function n(r,t){const s=r?t?r.keys.filter(w=>t.keys.indexOf(w)===-1):[...r.keys]:[],o=t?r?t.keys.filter(w=>r.keys.indexOf(w)===-1):[...t.keys]:[],u=[];if(r&&t){for(const w of t.keys)if(r.keys.indexOf(w)!==-1){const A=(0,d.$ej)(t.contents,w),T=(0,d.$ej)(r.contents,w);O.$fo(A,T)||u.push(w)}}return{added:s,removed:o,updated:u}}}),define(ce[116],le([0,1,19,4,2,26,3,66,40,6,39,37]),function(Q,e,S,P,y,k,L,O,g,a,d,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$To=e.$So=e.$Ro=void 0;class f extends y.$Tc{get configurationModel(){return this.b}constructor(b){super(),this.c=b,this.a=this.B(new P.$je),this.onDidChangeConfiguration=this.a.event,this.b=O.$Lo.createEmptyModel(this.c)}async initialize(){return this.h(),this.B(c.$oo.as(g.$to.Configuration).onDidUpdateConfiguration(({properties:b,defaultsOverrides:h})=>this.f(Array.from(b),h))),this.configurationModel}reload(){return this.h(),this.configurationModel}f(b,h){this.j(b,c.$oo.as(g.$to.Configuration).getConfigurationProperties()),this.a.fire({defaults:this.configurationModel,properties:b})}g(){return{}}h(){this.b=O.$Lo.createEmptyModel(this.c);const b=c.$oo.as(g.$to.Configuration).getConfigurationProperties();this.j(Object.keys(b),b)}j(b,h){const p=this.g();for(const R of b){const v=p[R],i=h[R];v!==void 0?this.b.setValue(R,v):i?this.b.setValue(R,i.default):this.b.removeValue(R)}}}e.$Ro=f;class m{constructor(){this.onDidChangeConfiguration=P.Event.None,this.configurationModel=O.$Lo.createEmptyModel(new a.$kk)}async initialize(){return this.configurationModel}}e.$So=m;let $=class extends y.$Tc{get configurationModel(){return this.b}constructor(b,h,p){super(),this.c=b,this.f=h,this.g=p,this.a=this.B(new P.$je),this.onDidChangeConfiguration=this.a.event,this.b=O.$Lo.createEmptyModel(this.g)}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.m(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange(b=>this.j(b))),this.B(this.c.onDidChangeConfiguration(async({properties:b})=>this.m(await this.h(b),!0))),this.b}async h(b){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",b);const h={},p=[],R=c.$oo.as(g.$to.Configuration).getConfigurationProperties();for(const v of b){const i=R[v];if(!i){p.push(v);continue}if(i.policy){if(i.type!=="string"&&i.type!=="number"){this.g.warn(`Policy ${i.policy.name} has unsupported type ${i.type}`);continue}p.push(v),h[i.policy.name]={type:i.type}}}return(0,L.$pg)(h)||await this.f.updatePolicyDefinitions(h),p}j(b){this.g.trace("PolicyConfiguration#onDidChangePolicies",b);const h=c.$oo.as(g.$to.Configuration).getPolicyConfigurations(),p=(0,S.$Gb)(b.map(R=>h.get(R)));this.m(p,!0)}m(b,h){this.g.trace("PolicyConfiguration#update",b);const p=c.$oo.as(g.$to.Configuration).getConfigurationProperties(),R=[],v=this.b.isEmpty();for(const i of b){const l=p[i]?.policy?.name;if(l){const n=this.f.getPolicyValue(l);(v?n!==void 0:!(0,k.$fo)(this.b.getValue(i),n))&&R.push([i,n])}else this.b.getValue(i)!==void 0&&R.push([i,void 0])}if(R.length){this.g.trace("PolicyConfiguration#changed",R);const i=this.b;this.b=O.$Lo.createEmptyModel(this.g);for(const l of i.keys)this.b.setValue(l,i.getValue(l));for(const[l,n]of R)n===void 0?this.b.removeValue(l):this.b.setValue(l,n);h&&this.a.fire(this.b)}}};e.$To=$,e.$To=$=ve([se(1,d.$qo),se(2,a.$0j)],$)}),define(ce[117],le([0,1,19,8,13,4,34,77,2,30,26,12,16,29,66,40,116,9,39]),function(Q,e,S,P,y,k,L,O,g,a,d,c,f,m,$,I,b,h,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uo=void 0;class R extends g.$Tc{constructor(l,n,r,t){super(),this.m=l,this.n=t,this.h=this.B(new k.$je),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new b.$Ro(t)),this.c=r instanceof p.$so?new b.$So:this.B(new b.$To(this.b,r,t)),this.f=this.B(new $.$No(this.m,{},f.$7g,n,t)),this.a=new $.$Oo(this.b.configurationModel,this.c.configurationModel,$.$Lo.createEmptyModel(t),$.$Lo.createEmptyModel(t),$.$Lo.createEmptyModel(t),$.$Lo.createEmptyModel(t),new a.$zc,$.$Lo.createEmptyModel(t),new a.$zc,t),this.j=new v(l,n,this),this.g=this.B(new P.$Oh(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:s,properties:o})=>this.s(s,o))),this.B(this.c.onDidChangeConfiguration(s=>this.t(s))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[l,n,r]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new $.$Oo(l,n,$.$Lo.createEmptyModel(this.n),r,$.$Lo.createEmptyModel(this.n),$.$Lo.createEmptyModel(this.n),new a.$zc,$.$Lo.createEmptyModel(this.n),new a.$zc,this.n)}getConfigurationData(){return this.a.toData()}getValue(l,n){const r=typeof l=="string"?l:void 0,t=(0,m.$0i)(l)?l:(0,m.$0i)(n)?n:{};return this.a.getValue(r,t,void 0)}async updateValue(l,n,r,t,s){const o=(0,m.$$i)(r)?r:(0,m.$0i)(r)?{resource:r.resource,overrideIdentifiers:r.overrideIdentifier?[r.overrideIdentifier]:void 0}:void 0,u=o?t:r;if(u!==void 0&&u!==m.ConfigurationTarget.USER_LOCAL&&u!==m.ConfigurationTarget.USER)throw new Error(`Unable to write ${l} to target ${u}.`);o?.overrideIdentifiers&&(o.overrideIdentifiers=(0,S.$Lb)(o.overrideIdentifiers),o.overrideIdentifiers=o.overrideIdentifiers.length?o.overrideIdentifiers:void 0);const w=this.inspect(l,{resource:o?.resource,overrideIdentifier:o?.overrideIdentifiers?o.overrideIdentifiers[0]:void 0});if(w.policyValue!==void 0)throw new Error(`Unable to write ${l} because it is configured in system policy.`);if((0,d.$fo)(n,w.defaultValue)&&(n=void 0),o?.overrideIdentifiers?.length&&o.overrideIdentifiers.length>1){const T=o.overrideIdentifiers.sort(),D=this.a.localUserConfiguration.overrides.find(N=>(0,S.$tb)([...N.identifiers].sort(),T));D&&(o.overrideIdentifiers=D.identifiers)}const A=o?.overrideIdentifiers?.length?[(0,I.$Fo)(o.overrideIdentifiers),l]:[l];await this.j.write(A,n),await this.reloadConfiguration()}inspect(l,n={}){return this.a.inspect(l,n,void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const l=await this.f.loadConfiguration();this.r(l)}r(l){const n=this.a.toData(),r=this.a.compareAndUpdateLocalUserConfiguration(l);this.u(r,n,m.ConfigurationTarget.USER)}s(l,n){const r=this.a.toData(),t=this.a.compareAndUpdateDefaultConfiguration(l,n);this.u(t,r,m.ConfigurationTarget.DEFAULT)}t(l){const n=this.a.toData(),r=this.a.compareAndUpdatePolicyConfiguration(l);this.u(r,n,m.ConfigurationTarget.DEFAULT)}u(l,n,r){const t=new $.$Qo(l,{data:n},this.a,void 0,this.n);t.source=r,this.h.fire(t)}}e.$Uo=R;class v{constructor(l,n,r){this.b=l,this.c=n,this.d=r,this.a=new P.$Jh}write(l,n){return this.a.queue(()=>this.e(l,n))}async e(l,n){let r;try{r=(await this.c.readFile(this.b)).value.toString()}catch(o){if(o.fileOperationResult===h.FileOperationResult.FILE_NOT_FOUND)r="{}";else throw o}const t=[];if((0,L.$Vn)(r,t,{allowTrailingComma:!0,allowEmptyContent:!0}),t.length>0)throw new Error("Unable to write into the settings file. Please open the file to correct errors/warnings in the file and try again.");const s=this.f(r,l,n);r=(0,O.$ao)(r,s),await this.c.writeFile(this.b,y.$Le.fromString(r))}f(l,n,r){const{tabSize:t,insertSpaces:s,eol:o}=this.h;if(!n.length){const u=JSON.stringify(r,null,s?" ".repeat(t):"	");return[{content:u,length:u.length,offset:0}]}return(0,O.$0n)(l,n,r,{tabSize:t,insertSpaces:s,eol:o})}get h(){if(!this.g){let l=c.OS===c.OperatingSystem.Linux||c.OS===c.OperatingSystem.Macintosh?`
`:`\r
`;const n=this.d.getValue("files.eol",{overrideIdentifier:"jsonc"});n&&typeof n=="string"&&n!=="auto"&&(l=n),this.g={eol:l,insertSpaces:!!this.d.getValue("editor.insertSpaces",{overrideIdentifier:"jsonc"}),tabSize:this.d.getValue("editor.tabSize",{overrideIdentifier:"jsonc"})}}return this.g}}}),define(ce[67],le([0,1,14]),function(Q,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$en=P,e.$fn=y,e.$gn=k,e.$hn=L;function P(g){return g.scheme===S.Schemas.vscodeRemote?g.authority:void 0}function y(g){if(!g)return;const a=g.indexOf("+");return a<0?g:g.substr(0,a)}function k(g){const{host:a,port:d}=O(g);if(typeof d>"u")throw new Error(`Invalid remote authority: ${g}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:a,port:d}}function L(g,a){let{host:d,port:c}=O(g);return typeof c>"u"&&(c=a),{host:d,port:c}}function O(g){const a=g.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(a)return{host:a[1],port:parseInt(a[2],10)};const d=g.match(/^(\[[0-9a-z:]+\])$/);if(d)return{host:d[1],port:void 0};const c=g.match(/(.*):(\d+)$/);return c?{host:c[1],port:parseInt(c[2],10)}:{host:g,port:void 0}}}),define(ce[22],le([0,1,31,10,67]),function(Q,e,S,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xn=e.$qn=e.$pn=e.$on=e.TargetPlatform=e.ExtensionType=e.$nn=e.$ln=e.$kn=e.$jn=e.$in=void 0,e.$mn=k,e.$rn=c,e.$sn=f,e.$tn=m,e.$un=$,e.$vn=I,e.$wn=b,S=ye(S),e.$in="extensions.user.cache",e.$jn="extensions.builtin.cache",e.$kn="undefined_publisher",e.$ln=["ui","workspace","web"];function k(h){if(typeof h=="object"&&h!==null&&h.supported!==!0)return h.description}e.$nn=["AI","Azure","Chat","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var L;(function(h){h[h.System=0]="System",h[h.User=1]="User"})(L||(e.ExtensionType=L={}));var O;(function(h){h.WIN32_X64="win32-x64",h.WIN32_ARM64="win32-arm64",h.LINUX_X64="linux-x64",h.LINUX_ARM64="linux-arm64",h.LINUX_ARMHF="linux-armhf",h.ALPINE_X64="alpine-x64",h.ALPINE_ARM64="alpine-arm64",h.DARWIN_X64="darwin-x64",h.DARWIN_ARM64="darwin-arm64",h.WEB="web",h.UNIVERSAL="universal",h.UNKNOWN="unknown",h.UNDEFINED="undefined"})(O||(e.TargetPlatform=O={}));class g{constructor(p){this.value=p,this._lower=p.toLowerCase()}static equals(p,R){if(typeof p>"u"||p===null)return typeof R>"u"||R===null;if(typeof R>"u"||R===null)return!1;if(typeof p=="string"||typeof R=="string"){const v=typeof p=="string"?p:p.value,i=typeof R=="string"?R:R.value;return S.$Df(v,i)}return p._lower===R._lower}static toKey(p){return typeof p=="string"?p.toLowerCase():p._lower}}e.$on=g;class a{get size(){return this.c.size}constructor(p){if(this.c=new Set,p)for(const R of p)this.add(R)}add(p){this.c.add(g.toKey(p))}delete(p){return this.c.delete(g.toKey(p))}has(p){return this.c.has(g.toKey(p))}}e.$pn=a;class d{constructor(){this.c=new Map}clear(){this.c.clear()}delete(p){this.c.delete(g.toKey(p))}get(p){return this.c.get(g.toKey(p))}has(p){return this.c.has(g.toKey(p))}set(p,R){this.c.set(g.toKey(p),R)}values(){return this.c.values()}forEach(p){this.c.forEach(p)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$qn=d;function c(h){return f(h)}function f(h){return h.contributes&&h.contributes.localizations?h.contributes.localizations.length>0:!1}function m(h){return h.contributes&&h.contributes.authentication?h.contributes.authentication.length>0:!1}function $(h,p){if(p){const R=`onResolveRemoteAuthority:${(0,y.$fn)(p)}`;return!!h.activationEvents?.includes(R)}return!1}function I(h){return h.map(p=>{const[R,v]=p.split("@");return{proposalName:R,version:v?parseInt(v):void 0}})}function b(h){return h.map(p=>p.split("@")[0])}e.$xn=(0,P.$Ci)("IBuiltinExtensionsScannerService")}),define(ce[20],le([0,1,12,5,22,10]),function(Q,e,S,P,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rp=e.$qp=e.$pp=e.$op=e.$np=e.$mp=e.$lp=e.$kp=e.ExtensionManagementErrorCode=e.$jp=e.ExtensionGalleryErrorCode=e.$ip=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.ExtensionInstallSource=e.$bp=e.$ap=e.$_o=e.$$o=e.$0o=e.$9o=e.$8o=void 0,e.$cp=O,e.$dp=g,e.$ep=a,e.$fp=d,e.$gp=c,e.$hp=f,e.$8o="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$9o=new RegExp(e.$8o),e.$0o="__web_extension",e.$$o="skipWalkthrough",e.$_o="extensionInstallSource",e.$ap="dependecyOrPackExtensionInstall",e.$bp="clientTargetPlatform";var L;(function(i){i.COMMAND="command",i.SETTINGS_SYNC="settingsSync"})(L||(e.ExtensionInstallSource=L={}));function O(i){switch(i){case y.TargetPlatform.WIN32_X64:return"Windows 64 bit";case y.TargetPlatform.WIN32_ARM64:return"Windows ARM";case y.TargetPlatform.LINUX_X64:return"Linux 64 bit";case y.TargetPlatform.LINUX_ARM64:return"Linux ARM 64";case y.TargetPlatform.LINUX_ARMHF:return"Linux ARM";case y.TargetPlatform.ALPINE_X64:return"Alpine Linux 64 bit";case y.TargetPlatform.ALPINE_ARM64:return"Alpine ARM 64";case y.TargetPlatform.DARWIN_X64:return"Mac";case y.TargetPlatform.DARWIN_ARM64:return"Mac Silicon";case y.TargetPlatform.WEB:return"Web";case y.TargetPlatform.UNIVERSAL:return y.TargetPlatform.UNIVERSAL;case y.TargetPlatform.UNKNOWN:return y.TargetPlatform.UNKNOWN;case y.TargetPlatform.UNDEFINED:return y.TargetPlatform.UNDEFINED}}function g(i){switch(i){case y.TargetPlatform.WIN32_X64:return y.TargetPlatform.WIN32_X64;case y.TargetPlatform.WIN32_ARM64:return y.TargetPlatform.WIN32_ARM64;case y.TargetPlatform.LINUX_X64:return y.TargetPlatform.LINUX_X64;case y.TargetPlatform.LINUX_ARM64:return y.TargetPlatform.LINUX_ARM64;case y.TargetPlatform.LINUX_ARMHF:return y.TargetPlatform.LINUX_ARMHF;case y.TargetPlatform.ALPINE_X64:return y.TargetPlatform.ALPINE_X64;case y.TargetPlatform.ALPINE_ARM64:return y.TargetPlatform.ALPINE_ARM64;case y.TargetPlatform.DARWIN_X64:return y.TargetPlatform.DARWIN_X64;case y.TargetPlatform.DARWIN_ARM64:return y.TargetPlatform.DARWIN_ARM64;case y.TargetPlatform.WEB:return y.TargetPlatform.WEB;case y.TargetPlatform.UNIVERSAL:return y.TargetPlatform.UNIVERSAL;default:return y.TargetPlatform.UNKNOWN}}function a(i,l){switch(i){case S.Platform.Windows:return l==="x64"?y.TargetPlatform.WIN32_X64:l==="arm64"?y.TargetPlatform.WIN32_ARM64:y.TargetPlatform.UNKNOWN;case S.Platform.Linux:return l==="x64"?y.TargetPlatform.LINUX_X64:l==="arm64"?y.TargetPlatform.LINUX_ARM64:l==="arm"?y.TargetPlatform.LINUX_ARMHF:y.TargetPlatform.UNKNOWN;case"alpine":return l==="x64"?y.TargetPlatform.ALPINE_X64:l==="arm64"?y.TargetPlatform.ALPINE_ARM64:y.TargetPlatform.UNKNOWN;case S.Platform.Mac:return l==="x64"?y.TargetPlatform.DARWIN_X64:l==="arm64"?y.TargetPlatform.DARWIN_ARM64:y.TargetPlatform.UNKNOWN;case S.Platform.Web:return y.TargetPlatform.WEB}}function d(i,l){return l===y.TargetPlatform.WEB&&!i.includes(y.TargetPlatform.WEB)}function c(i,l,n){return d(l,n)?!1:i===y.TargetPlatform.UNDEFINED||i===y.TargetPlatform.UNIVERSAL?!0:i===y.TargetPlatform.UNKNOWN?!1:i===n}function f(i){return i&&typeof i=="object"&&typeof i.id=="string"&&(!i.uuid||typeof i.uuid=="string")}var m;(function(i){i[i.NoneOrRelevance=0]="NoneOrRelevance",i[i.LastUpdatedDate=1]="LastUpdatedDate",i[i.Title=2]="Title",i[i.PublisherName=3]="PublisherName",i[i.InstallCount=4]="InstallCount",i[i.PublishedDate=10]="PublishedDate",i[i.AverageRating=6]="AverageRating",i[i.WeightedRating=12]="WeightedRating"})(m||(e.SortBy=m={}));var $;(function(i){i[i.Default=0]="Default",i[i.Ascending=1]="Ascending",i[i.Descending=2]="Descending"})($||(e.SortOrder=$={}));var I;(function(i){i.Install="install",i.Uninstall="uninstall"})(I||(e.StatisticType=I={}));var b;(function(i){i[i.None=1]="None",i[i.Install=2]="Install",i[i.Update=3]="Update",i[i.Migrate=4]="Migrate"})(b||(e.InstallOperation=b={})),e.$ip=(0,k.$Ci)("extensionGalleryService");var h;(function(i){i.Timeout="Timeout",i.Cancelled="Cancelled",i.Failed="Failed",i.DownloadFailedWriting="DownloadFailedWriting"})(h||(e.ExtensionGalleryErrorCode=h={}));class p extends Error{constructor(l,n){super(l),this.code=n,this.name=n}}e.$jp=p;var R;(function(i){i.Unsupported="Unsupported",i.Deprecated="Deprecated",i.Malicious="Malicious",i.Incompatible="Incompatible",i.IncompatibleApi="IncompatibleApi",i.IncompatibleTargetPlatform="IncompatibleTargetPlatform",i.ReleaseVersionNotFound="ReleaseVersionNotFound",i.Invalid="Invalid",i.Download="Download",i.DownloadSignature="DownloadSignature",i.DownloadFailedWriting="DownloadFailedWriting",i.UpdateMetadata="UpdateMetadata",i.Extract="Extract",i.Scanning="Scanning",i.ScanningExtension="ScanningExtension",i.ReadUninstalled="ReadUninstalled",i.UnsetUninstalled="UnsetUninstalled",i.Delete="Delete",i.Rename="Rename",i.IntializeDefaultProfile="IntializeDefaultProfile",i.AddToProfile="AddToProfile",i.InstalledExtensionNotFound="InstalledExtensionNotFound",i.PostInstall="PostInstall",i.CorruptZip="CorruptZip",i.IncompleteZip="IncompleteZip",i.Signature="Signature",i.NotAllowed="NotAllowed",i.Gallery="Gallery",i.Cancelled="Cancelled",i.Unknown="Unknown",i.Internal="Internal"})(R||(e.ExtensionManagementErrorCode=R={}));class v extends Error{constructor(l,n){super(l),this.code=n,this.name=n}}e.$kp=v,e.$lp=(0,k.$Ci)("extensionManagementService"),e.$mp="extensionsIdentifiers/disabled",e.$np="extensionsIdentifiers/enabled",e.$op=(0,k.$Ci)("IGlobalExtensionEnablementService"),e.$pp=(0,k.$Ci)("IExtensionTipsService"),e.$qp=(0,P.localize2)(11348,"Extensions"),e.$rp=(0,P.localize2)(11349,"Preferences")}),define(ce[118],le([0,1,2,22,9]),function(Q,e,S,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tq=void 0;class k extends S.$Tc{constructor(O,g,a,d,c){super(),this.a=O,this.b=g,this.c=a,this.f=c,this.B(d.onDidInstallExtensions(f=>this.g(f))),this.B(d.onDidUninstallExtension(f=>this.h(f)))}g(O){for(const g of O)g.local&&this.invalidate(g.profileLocation)}h(O){O.error||this.invalidate(O.profileLocation)}async invalidate(O){if(O)for(const g of this.a.profiles)this.c.extUri.isEqual(g.extensionsResource,O)&&await this.j(g);else await this.j(this.a.defaultProfile)}async j(O){try{await this.b.del(this.c.extUri.joinPath(O.cacheHome,P.$in))}catch(g){(0,y.$ol)(g)!==y.FileOperationResult.FILE_NOT_FOUND&&this.f.error(g)}}}e.$Tq=k});var qe=this&&this.__importDefault||function(Q){return Q&&Q.__esModule?Q:{default:Q}};define(ce[44],le([0,1,16,57,5,45,22,97]),function(Q,e,S,P,y,k,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wp=d,e.$Xp=c,e.$Yp=f,e.$Zp=m,e.$1p=$,e.$2p=I,e.$3p=b,e.$4p=h,P=qe(P),y=ye(y),k=ye(k);const g=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,a=/^-(\d{4})(\d{2})(\d{2})$/;function d(v){return v=v.trim(),v==="*"||g.test(v)}function c(v){if(!d(v))return null;if(v=v.trim(),v==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const i=v.match(g);return i?{hasCaret:i[1]==="^",hasGreaterEquals:i[1]===">=",majorBase:i[2]==="x"?0:parseInt(i[2],10),majorMustEqual:i[2]!=="x",minorBase:i[4]==="x"?0:parseInt(i[4],10),minorMustEqual:i[4]!=="x",patchBase:i[6]==="x"?0:parseInt(i[6],10),patchMustEqual:i[6]!=="x",preRelease:i[8]||null}:null}function f(v){if(!v)return null;const i=v.majorBase,l=v.majorMustEqual,n=v.minorBase;let r=v.minorMustEqual;const t=v.patchBase;let s=v.patchMustEqual;v.hasCaret&&(i===0||(r=!1),s=!1);let o=0;if(v.preRelease){const u=a.exec(v.preRelease);if(u){const[,w,A,T]=u;o=Date.UTC(Number(w),Number(A)-1,Number(T))}}return{majorBase:i,majorMustEqual:l,minorBase:n,minorMustEqual:r,patchBase:t,patchMustEqual:s,isMinimum:v.hasGreaterEquals,notBefore:o}}function m(v,i,l){let n;typeof v=="string"?n=f(c(v)):n=v;let r;i instanceof Date?r=i.getTime():typeof i=="string"&&(r=new Date(i).getTime());let t;if(typeof l=="string"?t=f(c(l)):t=l,!n||!t)return!1;const s=n.majorBase,o=n.minorBase,u=n.patchBase;let w=t.majorBase,A=t.minorBase,T=t.patchBase;const D=t.notBefore;let N=t.majorMustEqual,M=t.minorMustEqual,Y=t.patchMustEqual;return t.isMinimum?s>w?!0:s<w?!1:o>A?!0:o<A||r&&r<D?!1:u>=T:(s===1&&w===0&&(!N||!M||!Y)&&(w=1,A=0,T=0,N=!0,M=!1,Y=!1),s<w?!1:s>w?!N:o<A?!1:o>A?!M:u<T?!1:u>T?!Y:!(r&&r<D))}function $(v,i,l,n,r,t){const s=[];if(typeof n.publisher<"u"&&typeof n.publisher!="string")return s.push([P.default.Error,y.localize(11280,null)]),s;if(typeof n.name!="string")return s.push([P.default.Error,y.localize(11281,null,"name")]),s;if(typeof n.version!="string")return s.push([P.default.Error,y.localize(11282,null,"version")]),s;if(!n.engines)return s.push([P.default.Error,y.localize(11283,null,"engines")]),s;if(typeof n.engines.vscode!="string")return s.push([P.default.Error,y.localize(11284,null,"engines.vscode")]),s;if(typeof n.extensionDependencies<"u"&&!R(n.extensionDependencies))return s.push([P.default.Error,y.localize(11285,null,"extensionDependencies")]),s;if(typeof n.activationEvents<"u"){if(!R(n.activationEvents))return s.push([P.default.Error,y.localize(11286,null,"activationEvents")]),s;if(typeof n.main>"u"&&typeof n.browser>"u")return s.push([P.default.Error,y.localize(11287,null,"activationEvents","main","browser")]),s}if(typeof n.extensionKind<"u"&&typeof n.main>"u"&&s.push([P.default.Warning,y.localize(11288,null,"extensionKind")]),typeof n.main<"u"){if(typeof n.main!="string")return s.push([P.default.Error,y.localize(11289,null,"main")]),s;{const w=(0,S.$dh)(l,n.main);(0,S.$0g)(w,l)||s.push([P.default.Warning,y.localize(11290,null,w.path,l.path)])}}if(typeof n.browser<"u"){if(typeof n.browser!="string")return s.push([P.default.Error,y.localize(11291,null,"browser")]),s;{const w=(0,S.$dh)(l,n.browser);(0,S.$0g)(w,l)||s.push([P.default.Warning,y.localize(11292,null,w.path,l.path)])}}if(!k.valid(n.version))return s.push([P.default.Error,y.localize(11293,null)]),s;const o=[];if(!I(v,i,n,r,o))for(const w of o)s.push([P.default.Error,w]);if(t&&n.enabledApiProposals?.length){const w=[];if(!h([...n.enabledApiProposals],w))for(const A of w)s.push([P.default.Error,A])}return s}function I(v,i,l,n,r){return n||typeof l.main>"u"&&typeof l.browser>"u"?!0:p(v,i,l.engines.vscode,r)}function b(v,i,l){return v==="*"||p(i,l,v)}function h(v,i){if(v.length===0)return!0;const l=Array.isArray(i)?i:void 0,n=(l?void 0:i)??O.allApiProposals,r=[],t=(0,L.$vn)(v);for(const{proposalName:s,version:o}of t){const u=n[s];u&&o&&u.version!==o&&r.push(y.localize(11294,null,s))}return l?.push(...r),r.length===0}function p(v,i,l,n=[]){const r=f(c(l));if(!r)return n.push(y.localize(11295,null,l)),!1;if(r.majorBase===0){if(!r.majorMustEqual||!r.minorMustEqual)return n.push(y.localize(11296,null,l)),!1}else if(!r.majorMustEqual)return n.push(y.localize(11297,null,l)),!1;return m(v,i,r)?!0:(n.push(y.localize(11298,null,v,l)),!1)}function R(v){if(!Array.isArray(v))return!1;for(let i=0,l=v.length;i<l;i++)if(typeof v[i]!="string")return!1;return!0}}),define(ce[68],le([0,1,21,2,12,5,20,10]),function(Q,e,S,P,y,k,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0r=e.$9r=void 0,e.$8r=g;function g(d){return d.tags.find(c=>c.startsWith("lp-"))?.split("lp-")[1]}e.$9r=(0,O.$Ci)("languagePackService");let a=class extends P.$Tc{constructor(c){super(),this.c=c}async getAvailableLanguages(){const c=new S.$ue;setTimeout(()=>c.cancel(),1e3);let f;try{f=await this.c.query({text:'category:"language packs"',pageSize:20},c.token)}catch{return[]}const $=f.firstPage.filter(I=>I.properties.localizedLanguages?.length&&I.tags.some(b=>b.startsWith("lp-"))).map(I=>{const b=I.properties.localizedLanguages?.[0],h=g(I);return{...this.f(h,b,I),extensionId:I.identifier.id,galleryExtension:I}});return $.push(this.f("en","English")),$}f(c,f,m){const $=f??c;let I;if($!==c&&(I=`(${c})`),c.toLowerCase()===y.$x.toLowerCase()&&(I??="",I+=(0,k.localize)(11202,null)),m?.installCount){I??="";const b=m.installCount;let h;b>1e6?h=`${Math.floor(b/1e5)/10}M`:b>1e3?h=`${Math.floor(b/1e3)}K`:h=String(b),I+=` $(cloud-download) ${h}`}return{id:c,label:$,description:I}}};e.$0r=a,e.$0r=a=ve([se(0,L.$ip)],a)}),define(ce[46],le([0,1,13,7,2,5,40,10,6,37]),function(Q,e,S,P,y,k,L,O,g,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6p=e.$5p=void 0,e.$7p=f,e.$8p=m,e.$9p=$,e.$0p=I,e.$$p=b,e.$_p=h,e.$5p=(0,O.$Ci)("requestService");class d{constructor(i){this.b=i}toJSON(){if(!this.a){const i=Object.create(null);for(const l in this.b)l.toLowerCase()==="authorization"||l.toLowerCase()==="proxy-authorization"?i[l]="*****":i[l]=this.b[l];this.a=i}return this.a}}class c extends y.$Tc{constructor(i){super(),this.b=0,this.a=i.createLogger("network",{name:(0,k.localize)(11067,null),when:g.$pk.isEqualTo((0,g.$mk)(g.LogLevel.Trace)).serialize()})}async c(i,l,n){const r=`${i} #${++this.b}: ${l.url}`;this.a.trace(`${r} - begin`,l.type,new d(l.headers??{}));try{const t=await n();return this.a.trace(`${r} - end`,l.type,t.res.statusCode,t.res.headers),t}catch(t){throw this.a.error(`${r} - error`,l.type,(0,P.$9)(t)),t}}}e.$6p=c;function f(v){return v.res.statusCode&&v.res.statusCode>=200&&v.res.statusCode<300||v.res.statusCode===1223}function m(v){return v.res.statusCode===204}async function $(v){return m(v)?null:(await(0,S.$Xe)(v.stream)).toString()}async function I(v){if(!f(v))throw new Error("Server returned "+v.res.statusCode);return $(v)}async function b(v){if(!f(v))throw new Error("Server returned "+v.res.statusCode);if(m(v))return null;const l=(await(0,S.$Xe)(v.stream)).toString();try{return JSON.parse(l)}catch(n){throw n.message+=`:
`+l,n}}function h(v){R(v)}let p;function R(v){const i=a.$oo.as(L.$to.Configuration),l=p;p={id:"http",order:15,title:(0,k.localize)(11068,null),type:"object",scope:v,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,k.localize)(11069,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,k.localize)(11070,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,k.localize)(11071,null),restricted:!0},"http.noProxy":{type:"array",items:{type:"string"},markdownDescription:(0,k.localize)(11072,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,k.localize)(11073,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,k.localize)(11074,null),(0,k.localize)(11075,null),(0,k.localize)(11076,null),(0,k.localize)(11077,null)],default:"override",description:(0,k.localize)(11078,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,k.localize)(11079,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,k.localize)(11080,null),restricted:!0}}},i.updateConfigurations({add:[p],remove:l?[l]:[]})}R(L.ConfigurationScope.APPLICATION)}),define(ce[119],le([0,1,21,14,9,46]),function(Q,e,S,P,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KR=void 0;let L=class{constructor(g,a){this.a=g,this.b=a}async download(g,a,d=S.CancellationToken.None){if(g.scheme===P.Schemas.file||g.scheme===P.Schemas.vscodeRemote){await this.b.copy(g,a);return}const c={type:"GET",url:g.toString(!0)},f=await this.a.request(c,d);if(f.res.statusCode===200)await this.b.writeFile(a,f.stream);else{const m=await(0,k.$0p)(f);throw new Error(`Expected 200, got back ${f.res.statusCode} instead.

${m}`)}}};e.$KR=L,e.$KR=L=ve([se(0,k.$5p),se(1,y.$0k)],L)}),define(ce[120],le([0,1,121,3]),function(Q,e,S,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bs=k;function y(L,O){return L.protocol==="http:"?O.HTTP_PROXY||O.http_proxy||null:L.protocol==="https:"&&(O.HTTPS_PROXY||O.https_proxy||O.HTTP_PROXY||O.http_proxy)||null}async function k(L,O,g={}){const a=(0,S.parse)(L),d=g.proxyUrl||y(a,O);if(!d)return null;const c=(0,S.parse)(d);if(!/^https?:$/.test(c.protocol||""))return null;const f={host:c.hostname||"",port:(c.port?+c.port:0)||(c.protocol==="https"?443:80),auth:c.auth,rejectUnauthorized:(0,P.$ig)(g.strictSSL)?g.strictSSL:!0};if(a.protocol==="http:"){const m=await new Promise(($,I)=>{Q(["http-proxy-agent"],$,I)}).then(ye);return new m.HttpProxyAgent(d,f)}else{const m=await new Promise(($,I)=>{Q(["https-proxy-agent"],$,I)}).then(ye);return new m.HttpsProxyAgent(d,f)}}}),define(ce[122],le([0,1,60,15,5,21,38,7,12,27,86,152,8,79]),function(Q,e,S,P,y,k,L,O,g,a,d,c,f,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Om=I;let $;async function I(h,p,R,v){return R["force-disable-user-env"]?(p.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):g.$j?(p.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,c.$Hm)(v)&&!R["force-user-env"]?(p.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,c.$Hm)(v)?p.trace("resolveShellEnv(): running (--force-user-env)"):p.trace("resolveShellEnv(): running (macOS/Linux)"),$||($=f.Promises.withAsyncBody(async(i,l)=>{const n=new k.$ue;let r=1e4;const t=h.getValue("application.shellEnvironmentResolutionTimeout");typeof t=="number"&&(r=(0,m.$Im)(t,1,120)*1e3);const s=setTimeout(()=>{n.dispose(!0),l(new Error((0,y.localize)(11064,null)))},r);try{i(await b(p,n.token))}catch(o){!(0,O.$3)(o)&&!n.token.isCancellationRequested?l(new Error((0,y.localize)(11065,null,(0,L.$nj)(o)))):i({})}finally{clearTimeout(s),n.dispose()}})),$)}async function b(h,p){const R=process.env.ELECTRON_RUN_AS_NODE;h.trace("getUnixShellEnvironment#runAsNode",R);const v=process.env.ELECTRON_NO_ATTACH_CONSOLE;h.trace("getUnixShellEnvironment#noAttach",v);const i=(0,a.$Yg)().replace(/-/g,"").substr(0,12),l=new RegExp(i+"({.*})"+i),n={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1",VSCODE_RESOLVING_ENVIRONMENT:"1"};h.trace("getUnixShellEnvironment#env",n);const r=await(0,d.$xm)(g.OS,n);return h.trace("getUnixShellEnvironment#shell",r),new Promise((t,s)=>{if(p.isCancellationRequested)return s(new O.$4);const o=(0,P.$mc)(r);let u,w;const A="";/^pwsh(-preview)?$/.test(o)?(u=`& '${process.execPath}' ${A} -p '''${i}'' + JSON.stringify(process.env) + ''${i}'''`,w=["-Login","-Command"]):o==="nu"?(u=`^'${process.execPath}' ${A} -p '"${i}" + JSON.stringify(process.env) + "${i}"'`,w=["-i","-l","-c"]):o==="xonsh"?(u=`import os, json; print("${i}", json.dumps(dict(os.environ)), "${i}")`,w=["-i","-l","-c"]):(u=`'${process.execPath}' ${A} -p '"${i}" + JSON.stringify(process.env) + "${i}"'`,o==="tcsh"||o==="csh"?w=["-ic"]:w=["-i","-l","-c"]),h.trace("getUnixShellEnvironment#spawn",JSON.stringify(w),u);const T=(0,S.spawn)(r,[...w,u],{detached:!0,stdio:["ignore","pipe","pipe"],env:n});p.onCancellationRequested(()=>(T.kill(),s(new O.$4))),T.on("error",M=>{h.error("getUnixShellEnvironment#errorChildProcess",(0,L.$nj)(M)),s(M)});const D=[];T.stdout.on("data",M=>D.push(M));const N=[];T.stderr.on("data",M=>N.push(M)),T.on("close",(M,Y)=>{const K=Buffer.concat(D).toString("utf8");h.trace("getUnixShellEnvironment#raw",K);const re=Buffer.concat(N).toString("utf8");if(re.trim()&&h.trace("getUnixShellEnvironment#stderr",re),M||Y)return s(new Error((0,y.localize)(11066,null,M,Y)));const ae=l.exec(K),ue=ae?ae[1]:"{}";try{const de=JSON.parse(ue);R?de.ELECTRON_RUN_AS_NODE=R:delete de.ELECTRON_RUN_AS_NODE,v?de.ELECTRON_NO_ATTACH_CONSOLE=v:delete de.ELECTRON_NO_ATTACH_CONSOLE,delete de.VSCODE_RESOLVING_ENVIRONMENT,delete de.XDG_RUNTIME_DIR,h.trace("getUnixShellEnvironment#result",de),t(de)}catch(de){h.error("getUnixShellEnvironment#errorCaught",(0,L.$nj)(de)),s(de)}})})}}),define(ce[123],le([0,1,10]),function(Q,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nR=e.$mR=void 0,e.$mR=(0,S.$Ci)("stateReadService"),e.$nR=(0,S.$Ci)("stateService")}),define(ce[69],le([0,1,8,13,2,3,17,9,6]),function(Q,e,S,P,y,k,L,O,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qR=e.$pR=e.$oR=e.SaveStrategy=void 0;var a;(function(m){m[m.IMMEDIATE=0]="IMMEDIATE",m[m.DELAYED=1]="DELAYED"})(a||(e.SaveStrategy=a={}));class d extends y.$Tc{constructor($,I,b,h){super(),this.h=$,this.j=I,this.m=b,this.n=h,this.a=Object.create(null),this.b="",this.c=this.B(new S.$Ah(this.j===a.IMMEDIATE?0:100)),this.f=void 0,this.g=void 0}init(){return this.f||(this.f=this.r()),this.f}async r(){try{this.b=(await this.n.readFile(this.h)).value.toString(),this.a=JSON.parse(this.b)}catch($){$.fileOperationResult!==O.FileOperationResult.FILE_NOT_FOUND&&this.m.error($)}}getItem($,I){const b=this.a[$];return(0,k.$lg)(b)?I:b}setItem($,I){this.setItems([{key:$,data:I}])}setItems($){let I=!1;for(const{key:b,data:h}of $)this.a[b]!==h&&((0,k.$lg)(h)?(0,k.$jg)(this.a[b])||(this.a[b]=void 0,I=!0):(this.a[b]=h,I=!0));I&&this.s()}removeItem($){(0,k.$jg)(this.a[$])||(this.a[$]=void 0,this.s())}async s(){if(!this.g)return this.c.trigger(()=>this.t())}async t(){if(!this.f)return;await this.f;const $=JSON.stringify(this.a,null,4);if($!==this.b)try{await this.n.writeFile(this.h,P.$Le.fromString($),{atomic:{postfix:".vsctmp"}}),this.b=$}catch(I){this.m.error(I)}}async close(){return this.g||(this.g=this.c.trigger(()=>this.t(),0)),this.g}}e.$oR=d;let c=class extends y.$Tc{constructor($,I,b,h){super(),this.a=this.B(new d(I.stateResource,$,b,h))}async init(){await this.a.init()}getItem($,I){return this.a.getItem($,I)}};e.$pR=c,e.$pR=c=ve([se(1,L.$Ji),se(2,g.$0j),se(3,O.$0k)],c);class f extends c{setItem($,I){this.a.setItem($,I)}setItems($){this.a.setItems($)}removeItem($){this.a.removeItem($)}close(){return this.a.close()}}e.$qR=f}),define(ce[70],le([0,1,12,36,27]),function(Q,e,S,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sp=L,e.$tp=O;function k(g){if(S.$v===S.Platform.Linux&&/^penguin(\.|$)/i.test(g))return"chromebook"}function L(g,a,d,c,f,m,$,I,b,h){const p=Object.create(null);p["common.machineId"]=m,p["common.sqmId"]=$,p["common.devDeviceId"]=I,p.sessionID=(0,y.$Yg)()+Date.now(),p.commitHash=c,p.version=f,p["common.platformVersion"]=(g||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),p["common.platform"]=(0,S.$i)(S.$v),p["common.nodePlatform"]=P.$cc,p["common.nodeArch"]=d,p["common.product"]=h||"desktop",b&&(p["common.msftInternal"]=b);let R=0;const v=Date.now();Object.defineProperties(p,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-v,enumerable:!0},"common.sequence":{get:()=>R++,enumerable:!0}}),S.$m&&(p["common.snap"]="true");const i=k(a);return i&&(p["common.platformDetail"]=i),p}function O(g){const a=P.env.USERDNSDOMAIN;if(!a)return!1;const d=a.toLowerCase();return g.some(c=>d===c)}}),define(ce[18],le([0,1,10]),function(Q,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$hm=e.$gm=e.$fm=e.$em=e.$dm=e.$cm=e.$bm=e.$am=e.$_l=e.$$l=e.$0l=e.$9l=void 0,e.$9l=(0,S.$Ci)("telemetryService"),e.$0l=(0,S.$Ci)("customEndpointTelemetryService"),e.$$l="telemetry.currentSessionDate",e.$_l="telemetry.firstSessionDate",e.$am="telemetry.lastSessionDate",e.$bm="telemetry.machineId",e.$cm="telemetry.sqmId",e.$dm="telemetry.devDeviceId",e.$em="telemetry",e.$fm="telemetry.telemetryLevel",e.$gm="telemetry.enableCrashReporter",e.$hm="telemetry.enableTelemetry";var P;(function(k){k[k.NONE=0]="NONE",k[k.CRASH=1]="CRASH",k[k.ERROR=2]="ERROR",k[k.USAGE=3]="USAGE"})(P||(e.TelemetryLevel=P={}));var y;(function(k){k.OFF="off",k.CRASH="crash",k.ERROR="error",k.ON="all"})(y||(e.TelemetryConfiguration=y={}))}),define(ce[71],le([0,1,7,10,6,18]),function(Q,e,S,P,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sq=e.$rq=e.ExtensionSignatureVerificationCode=e.$qq=void 0,e.$qq=(0,P.$Ci)("IExtensionSignatureVerificationService");var L;(function(a){a.Success="Success",a.RequiredArgumentMissing="RequiredArgumentMissing",a.InvalidArgument="InvalidArgument",a.PackageIsUnreadable="PackageIsUnreadable",a.UnhandledException="UnhandledException",a.SignatureManifestIsMissing="SignatureManifestIsMissing",a.SignatureManifestIsUnreadable="SignatureManifestIsUnreadable",a.SignatureIsMissing="SignatureIsMissing",a.SignatureIsUnreadable="SignatureIsUnreadable",a.CertificateIsUnreadable="CertificateIsUnreadable",a.SignatureArchiveIsUnreadable="SignatureArchiveIsUnreadable",a.FileAlreadyExists="FileAlreadyExists",a.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip",a.SignatureArchiveHasSameSignatureFile="SignatureArchiveHasSameSignatureFile",a.PackageIntegrityCheckFailed="PackageIntegrityCheckFailed",a.SignatureIsInvalid="SignatureIsInvalid",a.SignatureManifestIsInvalid="SignatureManifestIsInvalid",a.SignatureIntegrityCheckFailed="SignatureIntegrityCheckFailed",a.EntryIsMissing="EntryIsMissing",a.EntryIsTampered="EntryIsTampered",a.Untrusted="Untrusted",a.CertificateRevoked="CertificateRevoked",a.SignatureIsNotValid="SignatureIsNotValid",a.UnknownError="UnknownError",a.PackageIsInvalidZip="PackageIsInvalidZip",a.SignatureArchiveHasTooManyEntries="SignatureArchiveHasTooManyEntries"})(L||(e.ExtensionSignatureVerificationCode=L={}));class O extends Error{constructor(d){super(d),this.code=d}}e.$rq=O;let g=class{constructor(d,c){this.b=d,this.c=c}d(){return this.a||(this.a=new Promise((d,c)=>Q(["@vscode/vsce-sign"],async f=>d(f),c))),this.a}async verify(d,c,f,m){let $;const I=d.identifier.id;try{$=await this.d()}catch(R){return this.b.error("Could not load vsce-sign module",(0,S.$9)(R)),this.b.info(`Extension signature verification is not done: ${I}`),!1}const b=new Date().getTime();let h;try{this.b.trace(`Verifying extension signature for ${I}...`),h=await $.verify(c,f,this.b.getLevel()===y.LogLevel.Trace)}catch(R){h={code:L.UnknownError,didExecute:!1,output:(0,S.$9)(R)}}const p=new Date().getTime()-b;if(this.b.info(`Extension signature verification result for ${I}: ${h.code}. Executed: ${h.didExecute}. Duration: ${p}ms.`),this.b.trace(`Extension signature verification output for ${I}:
${h.output}`),this.c.publicLog2("extensionsignature:verification",{extensionId:I,extensionVersion:d.version,code:h.code,internalCode:h.internalCode,duration:p,didExecute:h.didExecute,clientTargetPlatform:m}),h.code===L.Success)return!0;throw new O(h.code)}};e.$sq=g,e.$sq=g=ve([se(0,y.$0j),se(1,k.$9l)],g)}),define(ce[41],le([0,1,26,3,67,70,18]),function(Q,e,S,P,y,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ap=e.$zp=e.$yp=e.$xp=e.$wp=e.$vp=e.$up=void 0,e.$Bp=d,e.$Cp=c,e.$Dp=f,e.$Ep=m,e.$Fp=I,e.$Gp=h,e.$Hp=p,e.$Ip=i;class O{constructor(n){this.value=n,this.isTrustedTelemetryValue=!0}}e.$up=O;class g{constructor(){this.telemetryLevel=L.TelemetryLevel.NONE,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.devDeviceId="someValue.devDeviceId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$vp=g,e.$wp=new g;class a{async publicLog(n,r,t){}async publicLogError(n,r,t){}}e.$xp=a,e.$yp="telemetry",e.$zp="extensionTelemetryLog",e.$Ap={log:()=>null,flush:()=>Promise.resolve(null)};function d(l,n){return!n.isBuilt&&!n.disableTelemetry?!0:!(n.disableTelemetry||!l.enableTelemetry)}function c(l,n){return n.extensionTestsLocationURI?!0:!(n.isBuilt||n.disableTelemetry||l.enableTelemetry&&l.aiConfig?.ariaKey)}function f(l){const n=l.getValue(L.$fm),r=l.getValue(L.$gm);if(l.getValue(L.$hm)===!1||r===!1)return L.TelemetryLevel.NONE;switch(n??L.TelemetryConfiguration.ON){case L.TelemetryConfiguration.ON:return L.TelemetryLevel.USAGE;case L.TelemetryConfiguration.ERROR:return L.TelemetryLevel.ERROR;case L.TelemetryConfiguration.CRASH:return L.TelemetryLevel.CRASH;case L.TelemetryConfiguration.OFF:return L.TelemetryLevel.NONE}}function m(l){const n={},r={},t={};b(l,t);for(let s in t){s=s.length>150?s.substr(s.length-149):s;const o=t[s];typeof o=="number"?r[s]=o:typeof o=="boolean"?r[s]=o?1:0:typeof o=="string"?(o.length>8192&&console.warn(`Telemetry property: ${s} has been trimmed to 8192, the original length is ${o.length}`),n[s]=o.substring(0,8191)):typeof o<"u"&&o!==null&&(n[s]=o)}return{properties:n,measurements:r}}const $=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function I(l){if(!l)return"none";const n=(0,y.$fn)(l);return $.has(n)?n:"other"}function b(l,n,r=0,t){if(l)for(const s of Object.getOwnPropertyNames(l)){const o=l[s],u=t?t+s:s;Array.isArray(o)?n[u]=(0,S.$go)(o):o instanceof Date?n[u]=o.toISOString():(0,P.$eg)(o)?r<2?b(o,n,r+1,u+"."):n[u]=(0,S.$go)(o):n[u]=o}}function h(l,n){const r=l.msftInternalDomains||[],t=n.getValue("telemetry.internalTesting");return(0,k.$tp)(r)||t}function p(l){return[l.appRoot,l.extensionsPath,l.userHome.fsPath,l.tmpDir.fsPath,l.userDataPath]}function R(l,n){if(!l||!l.includes("/")&&!l.includes("\\"))return l;let r=l;const t=[];for(const w of n)for(;;){const A=w.exec(l);if(!A)break;t.push([A.index,w.lastIndex])}const s=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,o=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let u=0;for(r="";;){const w=o.exec(l);if(!w)break;const A=t.some(([T,D])=>w.index<D&&T<o.lastIndex);!s.test(w[0])&&!A&&(r+=l.substring(u,w.index)+"<REDACTED: user-file-path>",u=o.lastIndex)}return u<l.length&&(r+=l.substr(u)),r}function v(l){if(!l)return l;const n=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"CLI Credentials",regex:/((login|psexec|(certutil|psexec)\.exe).{1,50}(\s-u(ser(name)?)?\s+.{3,100})?\s-(admin|user|vm|root)?p(ass(word)?)?\s+["']?[^$\-\/\s]|(^|[\s\r\n\\])net(\.exe)?.{1,5}(user\s+|share\s+\/user:| user -? secrets ? set) \s + [^ $\s \/])/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const r of n)if(r.regex.test(l))return`<REDACTED: ${r.label}>`;return l}function i(l,n){return(0,S.$do)(l,r=>{if(r instanceof O||Object.hasOwnProperty.call(r,"isTrustedTelemetryValue"))return r.value;if(typeof r=="string"){let t=r.replaceAll("%20"," ");t=R(t,n);for(const s of n)t=t.replace(s,"");return t=v(t),t}})}}),define(ce[25],le([0,1,31,20,22,12,11,7,36,41]),function(Q,e,S,P,y,k,L,O,g,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sp=e.$Kp=void 0,e.$Jp=d,e.$Lp=$,e.$Mp=I,e.$Np=b,e.$Op=h,e.$Pp=p,e.$Qp=R,e.$Rp=v,e.$Tp=i,e.$Up=n;function d(r,t){return r.uuid&&t.uuid?r.uuid===t.uuid:r.id===t.id?!0:(0,S.$yf)(r.id,t.id)===0}const c=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class f{static create(t){const s=t.manifest?t.manifest.version:t.version,o=t.manifest?t.targetPlatform:t.properties.targetPlatform;return new f(t.identifier,s,o)}static parse(t){const s=c.exec(t);return s&&s[1]&&s[2]?new f({id:s[1]},s[2],s[4]||void 0):null}constructor(t,s,o=y.TargetPlatform.UNDEFINED){this.identifier=t,this.version=s,this.targetPlatform=o,this.id=t.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!==y.TargetPlatform.UNDEFINED?`-${this.targetPlatform}`:""}`}equals(t){return t instanceof f?d(this,t)&&this.version===t.version&&this.targetPlatform===t.targetPlatform:!1}}e.$Kp=f;const m=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function $(r){const t=m.exec(r);return t&&t[1]?[b(t[1]),t[2]]:[b(r),void 0]}function I(r,t){return`${r}.${t}`}function b(r){return r.toLowerCase()}function h(r,t){return b(I(r??y.$kn,t))}function p(r,t){const s=[],o=u=>{for(const w of s)if(w.some(A=>d(t(A),t(u))))return w;return null};for(const u of r){const w=o(u);w?w.push(u):s.push([u])}return s}function R(r){return{id:r.identifier.id,name:r.manifest.name,galleryId:null,publisherId:r.publisherId,publisherName:r.manifest.publisher,publisherDisplayName:r.publisherDisplayName,dependencies:r.manifest.extensionDependencies&&r.manifest.extensionDependencies.length>0}}function v(r){return{id:new a.$up(r.identifier.id),name:new a.$up(r.name),version:r.version,galleryId:r.identifier.uuid,publisherId:r.publisherId,publisherName:r.publisher,publisherDisplayName:r.publisherDisplayName,isPreReleaseVersion:r.properties.isPreReleaseVersion,dependencies:!!(r.properties.dependencies&&r.properties.dependencies.length>0),isSigned:r.isSigned,...r.telemetryData}}e.$Sp=new y.$on("pprice.better-merge");function i(r,t){const s=[],o=t.manifest.extensionDependencies?.slice(0)??[];for(;o.length;){const u=o.shift();if(u&&s.every(w=>!d(w.identifier,{id:u}))){const w=r.filter(A=>d(A.identifier,{id:u}));w.length===1&&(s.push(w[0]),o.push(...w[0].manifest.extensionDependencies?.slice(0)??[]))}}return s}async function l(r,t){if(!k.$l)return!1;let s;try{s=(await r.readFile(L.URI.file("/etc/os-release"))).value.toString()}catch{try{s=(await r.readFile(L.URI.file("/usr/lib/os-release"))).value.toString()}catch(u){t.debug("Error while getting the os-release file.",(0,O.$9)(u))}}return!!s&&(s.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function n(r,t){const s=await l(r,t),o=(0,P.$ep)(s?"alpine":k.$v,g.$dc);return t.debug("ComputeTargetPlatform:",o),o}}),define(ce[124],le([0,1,21,7,14,16,45,11,5,20,25,22]),function(Q,e,S,P,y,k,L,O,g,a,d,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tq=void 0;const f=I=>(0,g.localize)(11316,null,I),m=(0,g.localize)(11317,null,"ms-dotnettools.csharp");let $=class{constructor(b,h,p){this.a=b,this.b=h,this.d=p}get f(){}async listExtensions(b,h,p){let R=await this.b.getInstalled(c.ExtensionType.User,p);const v=c.$nn.map(l=>l.toLowerCase());if(h&&h!==""){if(v.indexOf(h.toLowerCase())<0){this.a.info("Invalid category please enter a valid category. To list valid categories run --category without a category specified");return}R=R.filter(l=>l.manifest.categories?l.manifest.categories.map(r=>r.toLowerCase()).indexOf(h.toLowerCase())>-1:!1)}else if(h===""){this.a.info("Possible Categories: "),v.forEach(l=>{this.a.info(l)});return}this.f&&this.a.info((0,g.localize)(11318,null,this.f)),R=R.sort((l,n)=>l.identifier.id.localeCompare(n.identifier.id));let i;for(const l of R)i!==l.identifier.id&&(i=l.identifier.id,this.a.info(b?`${i}@${l.manifest.version}`:i))}async installExtensions(b,h,p,R){const v=[];try{b.length&&this.a.info(this.f?(0,g.localize)(11319,null,this.f):(0,g.localize)(11320,null));const i=[],l=[],n=(t,s,o)=>{l.push({id:t,version:s!=="prerelease"?s:void 0,installOptions:{...p,isBuiltin:o,installPreReleaseVersion:s==="prerelease"||p.installPreReleaseVersion}})};for(const t of b)if(t instanceof O.URI)i.push({vsix:t,installOptions:p});else{const[s,o]=(0,d.$Lp)(t);n(s,o,!1)}for(const t of h)if(t instanceof O.URI)i.push({vsix:t,installOptions:{...p,isBuiltin:!0,donotIncludePackAndDependencies:!0}});else{const[s,o]=(0,d.$Lp)(t);n(s,o,!0)}const r=await this.b.getInstalled(void 0,p.profileLocation);if(i.length&&await Promise.all(i.map(async({vsix:t,installOptions:s})=>{try{await this.h(t,s,R,r)}catch(o){this.a.error(o),v.push(t.toString())}})),l.length){const t=await this.g(l,r,R);v.push(...t)}}catch(i){throw this.a.error((0,g.localize)(11321,null,(0,P.$9)(i))),i}if(v.length)throw new Error((0,g.localize)(11322,null,v.join(", ")))}async updateExtensions(b){const h=await this.b.getInstalled(c.ExtensionType.User,b),p=[];for(const l of h)l.identifier.uuid&&p.push({...l.identifier,preRelease:l.preRelease});this.a.trace((0,g.localize)(11323,null,p.length));const R=await this.d.getExtensions(p,{compatible:!0},S.CancellationToken.None),v=[];for(const l of R)for(const n of h)(0,d.$Jp)(n.identifier,l.identifier)&&(0,L.gt)(l.version,n.manifest.version)&&v.push({extension:l,options:{operation:a.InstallOperation.Update,installPreReleaseVersion:n.preRelease,profileLocation:b,isApplicationScoped:n.isApplicationScoped}});if(!v.length){this.a.info((0,g.localize)(11324,null));return}this.a.info((0,g.localize)(11325,null,v.map(l=>l.extension.identifier.id).join(", ")));const i=await this.b.installGalleryExtensions(v);for(const l of i)l.error?this.a.error((0,g.localize)(11326,null,l.identifier.id,(0,P.$9)(l.error))):this.a.info((0,g.localize)(11327,null,l.identifier.id,l.local?.manifest.version))}async g(b,h,p){if(b=b.filter(({id:l,version:n})=>{const r=h.find(t=>(0,d.$Jp)(t.identifier,{id:l}));if(r){if(!p&&(!n||n==="prerelease"&&r.preRelease))return this.a.info((0,g.localize)(11328,null,l,r.manifest.version,l)),!1;if(n&&r.manifest.version===n)return this.a.info((0,g.localize)(11329,null,`${l}@${n}`)),!1}return!0}),!b.length)return[];const R=[],v=[],i=await this.j(b);if(await Promise.all(b.map(async({id:l,version:n,installOptions:r})=>{const t=i.get(l.toLowerCase());if(!t){this.a.error(`${f(n?`${l}@${n}`:l)}
${m}`),R.push(l);return}try{const o=await this.d.getManifest(t,S.CancellationToken.None);if(o&&!this.k(o))return}catch(o){this.a.error(o.message||o.stack||o),R.push(l);return}const s=h.find(o=>(0,d.$Jp)(o.identifier,t.identifier));if(s){if(t.version===s.manifest.version){this.a.info((0,g.localize)(11330,null,n?`${l}@${n}`:l));return}this.a.info((0,g.localize)(11331,null,l,t.version))}r.isBuiltin?this.a.info(n?(0,g.localize)(11332,null,l,n):(0,g.localize)(11333,null,l)):this.a.info(n?(0,g.localize)(11334,null,l,n):(0,g.localize)(11335,null,l)),v.push({extension:t,options:{...r,installGivenVersion:!!n,isApplicationScoped:r.isApplicationScoped||s?.isApplicationScoped}})})),v.length){const l=await this.b.installGalleryExtensions(v);for(const n of l)n.error?(this.a.error((0,g.localize)(11336,null,n.identifier.id,(0,P.$9)(n.error))),R.push(n.identifier.id)):this.a.info((0,g.localize)(11337,null,n.identifier.id,n.local?.manifest.version))}return R}async h(b,h,p,R){const v=await this.b.getManifest(b);if(!v)throw new Error("Invalid vsix");if(await this.l(v,p,h.profileLocation,R))try{await this.b.install(b,{...h,installGivenVersion:!0}),this.a.info((0,g.localize)(11338,null,(0,k.$ah)(b)))}catch(l){if((0,P.$3)(l))this.a.info((0,g.localize)(11339,null,(0,k.$ah)(b)));else throw l}}async j(b){const h=new Map,p=b.some(i=>i.installOptions.installPreReleaseVersion),R=await this.b.getTargetPlatform(),v=[];for(const i of b)a.$9o.test(i.id)&&v.push({...i,preRelease:p});if(v.length){const i=await this.d.getExtensions(v,{targetPlatform:R},S.CancellationToken.None);for(const l of i)h.set(l.identifier.id.toLowerCase(),l)}return h}k(b){return!0}async l(b,h,p,R){if(!h){const v={id:(0,d.$Op)(b.publisher,b.name)},i=R.find(l=>(0,d.$Jp)(v,l.identifier)&&(0,L.gt)(l.manifest.version,b.version));if(i)return this.a.info((0,g.localize)(11340,null,i.identifier.id,i.manifest.version,b.version)),!1}return this.k(b)}async uninstallExtensions(b,h,p){const R=async i=>{if(i instanceof O.URI){const l=await this.b.getManifest(i);return(0,d.$Mp)(l.publisher,l.name)}return i},v=[];for(const i of b){const l=await R(i),r=(await this.b.getInstalled(void 0,p)).filter(t=>(0,d.$Jp)(t.identifier,{id:l}));if(!r.length)throw new Error(`${this.m(l)}
${m}`);if(r.some(t=>t.type===c.ExtensionType.System)){this.a.info((0,g.localize)(11341,null,l));return}if(!h&&r.some(t=>t.isBuiltin)){this.a.info((0,g.localize)(11342,null,l));return}this.a.info((0,g.localize)(11343,null,l));for(const t of r)await this.b.uninstall(t,{profileLocation:p}),v.push(t);this.f?this.a.info((0,g.localize)(11344,null,l,this.f)):this.a.info((0,g.localize)(11345,null,l))}}async locateExtension(b){const h=await this.b.getInstalled();b.forEach(p=>{h.forEach(R=>{if(R.identifier.id===p&&R.location.scheme===y.Schemas.file){this.a.info(R.location.fsPath);return}})})}m(b){return this.f?(0,g.localize)(11346,null,b,this.f):(0,g.localize)(11347,null,b)}};e.$tq=$,e.$tq=$=ve([se(1,a.$lp),se(2,a.$ip)],$)}),define(ce[125],le([0,1,7,4,2,30,25,22,9]),function(Q,e,S,P,y,k,L,O,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uq=void 0;class a extends y.$Tc{constructor(c,f,m,$,I,b,h){super(),this.f=c,this.g=f,this.h=m,this.j=$,this.m=I,this.n=b,this.r=h,this.a=this.B(new P.$je),this.onDidChangeExtensionsByAnotherSource=this.a.event,this.b=new Map,this.c=this.B(new y.$3c),this.s().then(null,p=>h.error("Error while initializing Extensions Watcher",(0,S.$9)(p)))}async s(){await this.g.initializeDefaultProfileExtensions(),await this.u(this.h.profiles),this.t(),await this.H()}t(){this.B(this.h.onDidChangeProfiles(c=>this.u(c.added))),this.B(this.j.onAddExtensions(c=>this.w(c))),this.B(this.j.onDidAddExtensions(c=>this.y(c))),this.B(this.j.onRemoveExtensions(c=>this.z(c))),this.B(this.j.onDidRemoveExtensions(c=>this.C(c))),this.B(this.n.onDidFilesChange(c=>this.D(c)))}async u(c){try{c.length&&await Promise.all(c.map(f=>(this.c.set(f.id,(0,y.$Qc)(this.n.watch(this.m.extUri.dirname(f.extensionsResource)),this.n.watch(f.extensionsResource))),this.G(f.extensionsResource))))}catch(f){throw this.r.error(f),f}}async w(c){for(const f of c.extensions)this.I(this.L(f.identifier,f.version),c.profileLocation)}async y(c){for(const f of c.extensions){const m=this.L(f.identifier,f.version);c.error?this.J(m,c.profileLocation):this.I(m,c.profileLocation)}}async z(c){for(const f of c.extensions)this.J(this.L(f.identifier,f.version),c.profileLocation)}async C(c){const f=[],m=[];for(const $ of c.extensions){const I=this.L($.identifier,$.version);c.error?this.I(I,c.profileLocation):(this.J(I,c.profileLocation),this.b.has(I)||(this.r.debug("Extension is removed from all profiles",$.identifier.id,$.version),m.push(this.f.scanInstalledExtensionAtLocation($.location).then(b=>{b?f.push(b):this.r.info("Extension not found at the location",$.location.toString())},b=>this.r.error(b)))))}try{await Promise.all(m),f.length&&await this.H(f)}catch($){this.r.error($)}}D(c){for(const f of this.h.profiles)c.contains(f.extensionsResource,g.FileChangeType.UPDATED,g.FileChangeType.ADDED)&&this.F(f.extensionsResource)}async F(c){const f=[],m=[],$=await this.j.scanProfileExtensions(c),I=new Set,b=new Set;for(const[h,p]of this.b)p.has(c)&&b.add(h);for(const h of $){const p=this.L(h.identifier,h.version);I.add(p),b.has(p)||(f.push(h.identifier),this.I(p,c))}for(const h of b)if(!I.has(h)){const p=this.M(h);p&&(m.push(p.identifier),this.J(h,c))}(f.length||m.length)&&this.a.fire({added:f.length?{extensions:f,profileLocation:c}:void 0,removed:m.length?{extensions:m,profileLocation:c}:void 0})}async G(c){const f=await this.j.scanProfileExtensions(c);for(const m of f)this.I(this.L(m.identifier,m.version),c)}async H(c){c||(c=(await this.f.scanAllUserInstalledExtensions()).filter(m=>!this.b.has(this.L(m.identifier,m.manifest.version)))),c.length&&await this.f.markAsUninstalled(...c)}I(c,f){let m=this.b.get(c);m||this.b.set(c,m=new k.$Ac($=>this.m.extUri.getComparisonKey($))),m.add(f)}J(c,f){const m=this.b.get(c);m&&m.delete(f),m?.size||this.b.delete(c)}L(c,f){return`${O.$on.toKey(c.id)}@${f}`}M(c){const[f,m]=(0,L.$Lp)(c);return m?{identifier:{id:f},version:m}:void 0}}e.$Uq=a}),define(ce[126],le([0,1,32,153,19,8,2,14,15,28,17,20,25,6,68,11]),function(Q,e,S,P,y,k,L,O,g,a,d,c,f,m,$,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$r=void 0,S=ye(S);let b=class extends $.$0r{constructor(v,i,l,n){super(l),this.h=v,this.j=n,this.g=this.B(new h(i,n)),this.h.registerParticipant({postInstall:async r=>this.m(r),postUninstall:async r=>this.n(r)})}async getBuiltInExtensionTranslationsUri(v,i){const n=(await this.g.getLanguagePacks())[i];if(!n){this.j.warn(`No language pack found for ${i}`);return}const r=n.translations[v];return r?I.URI.file(r):void 0}async getInstalledLanguages(){const v=await this.g.getLanguagePacks(),i=Object.keys(v).map(l=>{const n=v[l];return{...this.f(l,n.label),extensionId:n.extensions[0].extensionIdentifier.id}});return i.push(this.f("en","English")),i.sort((l,n)=>l.label.localeCompare(n.label)),i}async m(v){v&&v.manifest&&v.manifest.contributes&&v.manifest.contributes.localizations&&v.manifest.contributes.localizations.length&&(this.j.info("Adding language packs from the extension",v.identifier.id),await this.update())}async n(v){const i=await this.g.getLanguagePacks();Object.keys(i).some(l=>i[l]&&i[l].extensions.some(n=>(0,f.$Jp)(n.extensionIdentifier,v.identifier)))&&(this.j.info("Removing language packs from the extension",v.identifier.id),await this.update())}async update(){const[v,i]=await Promise.all([this.g.getLanguagePacks(),this.h.getInstalled()]),l=await this.g.update(i);return!(0,y.$tb)(Object.keys(v),Object.keys(l))}};e.$$r=b,e.$$r=b=ve([se(0,c.$lp),se(1,d.$Ki),se(2,c.$ip),se(3,m.$0j)],b);let h=class extends L.$Tc{constructor(v,i){super(),this.j=i,this.c={},this.f=(0,g.$ic)(v.userDataPath,"languagepacks.json"),this.g=new k.$Jh}getLanguagePacks(){return this.g.size||!this.h?this.s().then(()=>this.c):Promise.resolve(this.c)}update(v){return this.s(i=>{Object.keys(i).forEach(l=>delete i[l]),this.m(i,...v)}).then(()=>this.c)}m(v,...i){for(const l of i)l&&l.manifest&&l.manifest.contributes&&l.manifest.contributes.localizations&&l.manifest.contributes.localizations.length&&this.n(v,l);Object.keys(v).forEach(l=>this.r(v[l]))}n(v,i){const l=i.identifier,n=i.manifest.contributes&&i.manifest.contributes.localizations?i.manifest.contributes.localizations:[];for(const r of n)if(i.location.scheme===O.Schemas.file&&p(r)){let t=v[r.languageId];t||(t={hash:"",extensions:[],translations:{},label:r.localizedLanguageName??r.languageName},v[r.languageId]=t);const s=t.extensions.filter(o=>(0,f.$Jp)(o.extensionIdentifier,l))[0];s?s.version=i.manifest.version:t.extensions.push({extensionIdentifier:l,version:i.manifest.version});for(const o of r.translations)t.translations[o.id]=(0,g.$ic)(i.location.fsPath,o.path)}}r(v){if(v){const i=(0,P.createHash)("md5");for(const l of v.extensions)i.update(l.extensionIdentifier.uuid||l.extensionIdentifier.id).update(l.version);v.hash=i.digest("hex")}}s(v=()=>null){return this.g.queue(()=>{let i=null;return S.promises.readFile(this.f,"utf8").then(void 0,l=>l.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(l)).then(l=>{try{return JSON.parse(l)}catch{return{}}}).then(l=>(i=v(l),l)).then(l=>{for(const r of Object.keys(l))l[r]||delete l[r];this.c=l,this.h=!0;const n=JSON.stringify(this.c);return this.j.debug("Writing language packs",n),a.Promises.writeFile(this.f,n)}).then(()=>i,l=>this.j.error(l))})}};h=ve([se(0,d.$Ki),se(1,m.$0j)],h);function p(R){if(typeof R.languageId!="string"||!Array.isArray(R.translations)||R.translations.length===0)return!1;for(const v of R.translations)if(typeof v.id!="string"||typeof v.path!="string")return!1;return!(R.languageName&&typeof R.languageName!="string"||R.localizedLanguageName&&typeof R.localizedLanguageName!="string")}}),define(ce[127],le([0,1,82,7,26,41]),function(Q,e,S,P,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iR=void 0;const L="https://mobile.events.data.microsoft.com/OneCollector/1.0",O="https://mobile.events.data.microsoft.com/ping";async function g(d,c,f){const m=await(0,S.$sE)("@microsoft/1ds-core-js","dist/ms.core.js"),$=await(0,S.$sE)("@microsoft/1ds-post-js","dist/ms.post.js"),I=new m.AppInsightsCore,b=new $.PostChannel,h={instrumentationKey:d,endpointUrl:L,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[b]]};if(f){h.extensionConfig={};const p={alwaysUseXhrOverride:!0,ignoreMc1Ms0CookieProcessing:!0,httpXHROverride:f};h.extensionConfig[b.identifier]=p}return I.initialize(h,[]),I.addTelemetryInitializer(p=>{p.ext=p.ext??{},p.ext.web=p.ext.web??{},p.ext.web.consentDetails='{"GPC_DataSharingOptIn":false}',c&&(p.ext.utc=p.ext.utc??{},p.ext.utc.flags=8462029)}),I}class a{constructor(c,f,m,$,I){this.e=c,this.f=f,this.g=m,this.h=I,this.c=L,this.d=O,this.g||(this.g={}),typeof $=="function"?this.a=$():this.a=$,this.b=null}i(c){if(this.a){if(typeof this.a!="string"){c(this.a);return}this.b||(this.b=g(this.a,this.e,this.h)),this.b.then(f=>{c(f)},f=>{(0,P.$Y)(f),console.error(f)})}}log(c,f){if(!this.a)return;f=(0,y.$eo)(f,this.g),f=(0,k.$Ep)(f);const m=this.f+"/"+c;try{this.i($=>{$.pluginVersionString=f?.properties.version??"Unknown",$.track({name:m,baseData:{name:m,properties:f?.properties,measurements:f?.measurements}})})}catch{}}flush(){return this.a?new Promise(c=>{this.i(f=>{f.unload(!0,()=>{this.a=void 0,c(void 0)})})}):Promise.resolve(void 0)}}e.$iR=a});var qe=this&&this.__importDefault||function(Q){return Q&&Q.__esModule?Q:{default:Q}};define(ce[128],le([0,1,2,26,12,31,5,29,40,129,33,37,18,41]),function(Q,e,S,P,y,k,L,O,g,a,d,c,f,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$es=void 0,a=qe(a);let $=class{static{this.IDLE_START_EVENT_NAME="UserIdleStart"}static{this.IDLE_STOP_EVENT_NAME="UserIdleStop"}constructor(h,p,R){this.k=p,this.l=R,this.d={},this.i=new S.$Sc,this.j=[],this.b=h.appenders,this.c=h.commonProperties??Object.create(null),this.sessionId=this.c.sessionID,this.machineId=this.c["common.machineId"],this.sqmId=this.c["common.sqmId"],this.devDeviceId=this.c["common.devDeviceId"],this.firstSessionDate=this.c["common.firstSessionDate"],this.msftInternal=this.c["common.msftInternal"],this.f=h.piiPaths||[],this.g=f.TelemetryLevel.USAGE,this.h=!!h.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const v of this.f)this.j.push(new RegExp((0,k.$ff)(v),"gi")),v.indexOf("\\")>=0&&this.j.push(new RegExp((0,k.$ff)(v.replace(/\\/g,"/")),"gi"));this.m(),this.i.add(this.k.onDidChangeConfiguration(v=>{(v.affectsConfiguration(f.$fm)||v.affectsConfiguration(f.$hm)||v.affectsConfiguration(f.$gm))&&this.m()}))}setExperimentProperty(h,p){this.d[h]=p}m(){let h=(0,m.$Dp)(this.k);const p=this.l.enabledTelemetryLevels;if(p){this.h=this.sendErrorTelemetry?p.error:!1;const R=p.usage?f.TelemetryLevel.USAGE:p.error?f.TelemetryLevel.ERROR:f.TelemetryLevel.NONE;h=Math.min(h,R)}this.g=h}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}dispose(){this.i.dispose()}n(h,p,R){this.g<p||(R=(0,P.$eo)(R,this.d),R=(0,m.$Ip)(R,this.j),R=(0,P.$eo)(R,this.c),this.b.forEach(v=>v.log(h,R)))}publicLog(h,p){this.n(h,f.TelemetryLevel.USAGE,p)}publicLog2(h,p){this.publicLog(h,p)}publicLogError(h,p){this.h&&this.n(h,f.TelemetryLevel.ERROR,p)}publicLogError2(h,p){this.publicLogError(h,p)}};e.$es=$,e.$es=$=ve([se(1,O.$9i),se(2,d.$qk)],$);function I(){const b=(0,L.localize)(11045,null,a.default.nameLong),h=a.default.privacyStatementUrl?(0,L.localize)(11047,null,"https://aka.ms/vscode-telemetry",a.default.privacyStatementUrl):(0,L.localize)(11046,null,"https://aka.ms/vscode-telemetry"),p=y.$p?"":(0,L.localize)(11048,null),R=(0,L.localize)(11049,null),v=(0,L.localize)(11050,null),i=(0,L.localize)(11051,null),l=(0,L.localize)(11052,null),n=`
|       | ${R} | ${v} | ${i} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,r=(0,L.localize)(11053,null);return`
${b} ${h} ${p}

&nbsp;

${l}
${n}

&nbsp;

${r}
`}c.$oo.as(g.$to.Configuration).registerConfiguration({id:f.$em,order:1,type:"object",title:(0,L.localize)(11054,null),properties:{[f.$fm]:{type:"string",enum:[f.TelemetryConfiguration.ON,f.TelemetryConfiguration.ERROR,f.TelemetryConfiguration.CRASH,f.TelemetryConfiguration.OFF],enumDescriptions:[(0,L.localize)(11055,null),(0,L.localize)(11056,null),(0,L.localize)(11057,null),(0,L.localize)(11058,null)],markdownDescription:I(),default:f.TelemetryConfiguration.ON,restricted:!0,scope:g.ConfigurationScope.APPLICATION,tags:["usesOnlineServices","telemetry"]}}}),c.$oo.as(g.$to.Configuration).registerConfiguration({id:f.$em,order:110,type:"object",title:(0,L.localize)(11059,null),properties:{[f.$hm]:{type:"boolean",markdownDescription:a.default.privacyStatementUrl?(0,L.localize)(11061,null,a.default.nameLong,a.default.privacyStatementUrl):(0,L.localize)(11060,null,a.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,L.localize)(11062,null,`\`#${f.$fm}#\``),scope:g.ConfigurationScope.APPLICATION,tags:["usesOnlineServices","telemetry"]}}})}),define(ce[130],le([0,1,13,21,154,127]),function(Q,e,S,P,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jR=void 0,y=ye(y);async function L(d,c){const f=await c.request(d,P.CancellationToken.None),m=(await(0,S.$Xe)(f.stream)).toString(),$=f.res.statusCode??200;return{headers:f.res.headers,statusCode:$,responseData:m}}async function O(d){const c={method:d.type,headers:d.headers};return new Promise((m,$)=>{const I=y.request(d.url??"",c,b=>{b.on("data",function(h){m({headers:b.headers,statusCode:b.statusCode??200,responseData:h.toString()})}),b.on("error",function(h){$(h)})});I.write(d.data,b=>{b&&$(b)}),I.end()})}async function g(d,c,f){const m=typeof c.data=="string"?c.data:new TextDecoder().decode(c.data),$={type:"POST",headers:{...c.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(c.data).toString()},url:c.urlString,data:m};try{const I=d?await L($,d):await O($);f(I.statusCode,I.headers,I.responseData)}catch{f(0,{})}}class a extends k.$iR{constructor(c,f,m,$,I){const b={sendPOST:(h,p)=>{g(c,h,p)}};super(f,m,$,I,b)}}e.$jR=a}),define(ce[131],le([0,1,32,15,28]),function(Q,e,S,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$whc=k,S=ye(S);async function k(L,O){const g=Object.create(null),a=(c,f)=>{const m=JSON.parse(c);g[f]=m};if(O){const c=[],f=await y.Promises.readdir(O);for(const $ of f)try{(await S.promises.stat((0,P.$ic)(O,$))).isDirectory()&&c.push($)}catch{}const m=[];for(const $ of c)(await y.Promises.readdir((0,P.$ic)(O,$))).filter(b=>b==="telemetry.json").length===1&&m.push($);for(const $ of m){const I=(await S.promises.readFile((0,P.$ic)(O,$,"telemetry.json"))).toString();a(I,$)}}let d=(await S.promises.readFile((0,P.$ic)(L,"telemetry-core.json"))).toString();return a(d,"vscode-core"),d=(await S.promises.readFile((0,P.$ic)(L,"telemetry-extensions.json"))).toString(),a(d,"vscode-extensions"),JSON.stringify(g,null,4)}}),define(ce[132],le([0,1,12,84,18]),function(Q,e,S,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tgc=k,e.$Ugc=L,e.$Vgc=O;async function k(g,a){let d=g.getItem(y.$bm);return(typeof d!="string"||S.$k&&d==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(d=await(0,P.$Qn)(a.error.bind(a))),d}async function L(g,a){let d=g.getItem(y.$cm);return typeof d!="string"&&(d=await(0,P.$Rn)(a.error.bind(a))),d}async function O(g,a){let d=g.getItem(y.$dm);return typeof d!="string"&&(d=await(0,P.$Sn)(a.error.bind(a))),d}}),define(ce[23],le([0,1,10]),function(Q,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hl=void 0,e.$Hl=(0,S.$Ci)("IUriIdentityService")}),define(ce[133],le([0,1,23,98,9,16,80,4,2]),function(Q,e,S,P,y,k,L,O,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rs=void 0;class a{static{this._clock=0}constructor(f){this.uri=f,this.time=a._clock++}touch(){return this.time=a._clock++,this}}let d=class{constructor(f){this.g=f,this.c=new g.$Sc,this.f=2**16;const m=new Map,$=I=>{let b=m.get(I.scheme);return b===void 0&&(b=f.hasProvider(I)&&!this.g.hasCapability(I,y.FileSystemProviderCapabilities.PathCaseSensitive),m.set(I.scheme,b)),b};this.c.add(O.Event.any(f.onDidChangeFileSystemProviderRegistrations,f.onDidChangeFileSystemProviderCapabilities)(I=>{m.delete(I.scheme)})),this.extUri=new k.$5g($),this.d=new L.$Qs((I,b)=>this.extUri.compare(I,b,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(f){this.g.hasProvider(f)&&(f=(0,k.$eh)(f));const m=this.d.get(f);return m?m.touch().uri.with({fragment:f.fragment}):(this.d.set(f,new a(f)),this.h(),f)}h(){if(this.d.size<this.f)return;const f=[...this.d.entries()].sort(($,I)=>$[1].time<I[1].time?1:$[1].time>I[1].time?-1:0);a._clock=0,this.d.clear();const m=this.f*.5;for(let $=0;$<m;$++)this.d.set(f[$][0],f[$][1].touch())}};e.$Rs=d,e.$Rs=d=ve([se(0,y.$0k)],d),(0,P.$Os)(S.$Hl,d,P.InstantiationType.Delayed)}),define(ce[134],le([0,1,4,2,9,49,30]),function(Q,e,S,P,y,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hhc=void 0;class O extends P.$Tc{constructor(a,d,c,f,m,$){super(),this.f=a,this.g=d,this.h=c,this.j=f,this.m=m,this.n=$,this.capabilities=this.g.capabilities,this.onDidChangeCapabilities=this.g.onDidChangeCapabilities,this.a=this.B(new S.$je),this.onDidChangeFile=this.a.event,this.b=k.$Ii.forUris(()=>!(this.capabilities&y.FileSystemProviderCapabilities.PathCaseSensitive)),this.c=new L.$Ac(I=>this.m.extUri.getComparisonKey(this.t(I))),this.r(),this.B(f.onDidChangeProfiles(()=>this.r())),this.B(this.g.onDidChangeFile(I=>this.s(I)))}r(){this.c.clear();for(const a of this.j.profiles)this.c.add(a.settingsResource),this.c.add(a.keybindingsResource),this.c.add(a.tasksResource),this.c.add(a.extensionsResource)}open(a,d){return this.g.open(this.t(a),d)}close(a){return this.g.close(a)}read(a,d,c,f,m){return this.g.read(a,d,c,f,m)}write(a,d,c,f,m){return this.g.write(a,d,c,f,m)}watch(a,d){this.b.set(a,a);const c=this.g.watch(this.t(a),d);return(0,P.$Rc)(()=>{this.b.delete(a),c.dispose()})}stat(a){return this.g.stat(this.t(a))}mkdir(a){return this.g.mkdir(this.t(a))}rename(a,d,c){return this.g.rename(this.t(a),this.t(d),c)}readFile(a,d){return this.g.readFile(this.t(a),d)}readFileStream(a,d,c){return this.g.readFileStream(this.t(a),d,c)}readdir(a){return this.g.readdir(this.t(a))}enforceAtomicReadFile(a){return this.c.has(a)}writeFile(a,d,c){return this.g.writeFile(this.t(a),d,c)}enforceAtomicWriteFile(a){return this.c.has(a)?{postfix:".vsctmp"}:!1}delete(a,d){return this.g.delete(this.t(a),d)}copy(a,d,c){if((0,y.$bl)(this.g))return this.g.copy(this.t(a),this.t(d),c);throw new Error("copy not supported")}cloneFile(a,d){if((0,y.$cl)(this.g))return this.g.cloneFile(this.t(a),this.t(d));throw new Error("clone not supported")}s(a){const d=[];for(const c of a){if(c.resource.scheme!==this.f)continue;const f=this.u(c.resource);this.b.findSubstr(f)&&d.push({resource:f,type:c.type,cId:c.cId})}d.length&&(this.n.debug("User data changed"),this.a.fire(d))}t(a){return a.with({scheme:this.f})}u(a){return a.with({scheme:this.h})}}e.$hhc=O}),define(ce[135],le([0,1,5,15,49,16,11,10,14]),function(Q,e,S,P,y,k,L,O,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5i=e.$2i=e.$1i=e.$Zi=e.$Yi=e.$Wi=e.$Vi=e.WorkbenchState=e.$Pi=e.$Oi=e.$Li=void 0,e.$Mi=a,e.$Ni=d,e.$Qi=c,e.$Ri=f,e.$Si=m,e.$Ti=I,e.$Ui=b,e.$Xi=R,e.$3i=v,e.$4i=i,e.$6i=l,e.$7i=n,e.$8i=r,e.$Li=(0,O.$Ci)("contextService");function a(t){const s=t;return typeof s?.id=="string"&&L.URI.isUri(s.uri)}function d(t){return typeof t?.id=="string"&&!a(t)&&!f(t)}e.$Oi={id:"ext-dev"},e.$Pi={id:"empty-window"};function c(t,s){if(typeof t=="string"||typeof t>"u")return typeof t=="string"?{id:(0,P.$mc)(t)}:s?e.$Oi:e.$Pi;const o=t;return o.configuration?{id:o.id,configPath:o.configuration}:o.folders.length===1?{id:o.id,uri:o.folders[0].uri}:{id:o.id}}function f(t){const s=t;return typeof s?.id=="string"&&L.URI.isUri(s.configPath)}function m(t){const s=t;if(s?.uri)return{id:s.id,uri:L.URI.revive(s.uri)};const o=t;if(o?.configPath)return{id:o.id,configPath:L.URI.revive(o.configPath)};if(t?.id)return{id:t.id}}var $;(function(t){t[t.EMPTY=1]="EMPTY",t[t.FOLDER=2]="FOLDER",t[t.WORKSPACE=3]="WORKSPACE"})($||(e.WorkbenchState=$={}));function I(t){const s=t;return!!(s&&typeof s=="object"&&typeof s.id=="string"&&Array.isArray(s.folders))}function b(t){const s=t;return!!(s&&typeof s=="object"&&L.URI.isUri(s.uri)&&typeof s.name=="string"&&typeof s.toResource=="function")}class h{constructor(s,o,u,w,A){this.h=s,this.j=u,this.k=w,this.l=A,this.c=y.$Ii.forUris(this.l,()=>!0),this.folders=o}update(s){this.h=s.id,this.k=s.configuration,this.j=s.transient,this.l=s.l,this.folders=s.folders}get folders(){return this.g}set folders(s){this.g=s,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(s){this.k=s}getFolder(s){return s&&this.c.findSubstr(s)||null}n(){this.c=y.$Ii.forUris(this.l,()=>!0);for(const s of this.folders)this.c.set(s.uri,s)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$Vi=h;class p{constructor(s,o){this.raw=o,this.uri=s.uri,this.index=s.index,this.name=s.name}toResource(s){return(0,k.$dh)(this.uri,s)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$Wi=p;function R(t){return new p({uri:t,index:0,name:(0,k.$_g)(t)},{uri:t.toString()})}e.$Yi="code-workspace",e.$Zi=`.${e.$Yi}`,e.$1i=[{name:(0,S.localize)(10878,null),extensions:[e.$Yi]}],e.$2i="workspace.json";function v(t,s){return k.$7g.isEqualOrParent(t,s.untitledWorkspacesHome)}function i(t){let s;return L.URI.isUri(t)?s=t:s=t.configuration,s?.scheme===g.Schemas.tmp}e.$5i="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function l(t){return t.id===e.$5i}function n(t,s){return!v(t,s)&&!i(t)}function r(t){return(typeof t=="string"?(0,P.$nc)(t):(0,k.$bh)(t))===e.$Zi}}),define(ce[24],le([0,1,43,4,2,16,11,5,17,9,10,6,135,30,23,8,27,31,3]),function(Q,e,S,P,y,k,L,O,g,a,d,c,f,m,$,I,b,h,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nl=e.$Ml=e.$Jl=e.ProfileResourceType=void 0,e.$Il=v,e.$Kl=i,e.$Ll=l;var R;(function(t){t.Settings="settings",t.Keybindings="keybindings",t.Snippets="snippets",t.Tasks="tasks",t.Extensions="extensions",t.GlobalState="globalState"})(R||(e.ProfileResourceType=R={}));function v(t){const s=t;return!!(s&&typeof s=="object"&&typeof s.id=="string"&&typeof s.isDefault=="boolean"&&typeof s.name=="string"&&L.URI.isUri(s.location)&&L.URI.isUri(s.globalStorageHome)&&L.URI.isUri(s.settingsResource)&&L.URI.isUri(s.keybindingsResource)&&L.URI.isUri(s.tasksResource)&&L.URI.isUri(s.snippetsHome)&&L.URI.isUri(s.extensionsResource))}e.$Jl=(0,d.$Ci)("IUserDataProfilesService");function i(t,s){return{id:t.id,isDefault:t.isDefault,name:t.name,shortName:t.shortName,icon:t.icon,location:L.URI.revive(t.location).with({scheme:s}),globalStorageHome:L.URI.revive(t.globalStorageHome).with({scheme:s}),settingsResource:L.URI.revive(t.settingsResource).with({scheme:s}),keybindingsResource:L.URI.revive(t.keybindingsResource).with({scheme:s}),tasksResource:L.URI.revive(t.tasksResource).with({scheme:s}),snippetsHome:L.URI.revive(t.snippetsHome).with({scheme:s}),extensionsResource:L.URI.revive(t.extensionsResource).with({scheme:s}),cacheHome:L.URI.revive(t.cacheHome).with({scheme:s}),useDefaultFlags:t.useDefaultFlags,isTransient:t.isTransient}}function l(t,s,o,u,w,A){return{id:t,name:s,location:o,isDefault:!1,shortName:w?.shortName,icon:w?.icon,globalStorageHome:A&&w?.useDefaultFlags?.globalState?A.globalStorageHome:(0,k.$dh)(o,"globalStorage"),settingsResource:A&&w?.useDefaultFlags?.settings?A.settingsResource:(0,k.$dh)(o,"settings.json"),keybindingsResource:A&&w?.useDefaultFlags?.keybindings?A.keybindingsResource:(0,k.$dh)(o,"keybindings.json"),tasksResource:A&&w?.useDefaultFlags?.tasks?A.tasksResource:(0,k.$dh)(o,"tasks.json"),snippetsHome:A&&w?.useDefaultFlags?.snippets?A.snippetsHome:(0,k.$dh)(o,"snippets"),extensionsResource:A&&w?.useDefaultFlags?.extensions?A.extensionsResource:(0,k.$dh)(o,"extensions.json"),cacheHome:(0,k.$dh)(u,t),useDefaultFlags:w?.useDefaultFlags,isTransient:w?.transient}}let n=class extends y.$Tc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(s,o,u,w){super(),this.t=s,this.u=o,this.w=u,this.y=w,this.f=!0,this.h=this.B(new P.$je),this.onDidChangeProfiles=this.h.event,this.j=this.B(new P.$je),this.onWillCreateProfile=this.j.event,this.m=this.B(new P.$je),this.onWillRemoveProfile=this.m.event,this.n=this.B(new P.$je),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],folders:new m.$zc,workspaces:new m.$zc,emptyWindows:new Map},this.profilesHome=(0,k.$dh)(this.t.userRoamingDataHome,"profiles"),this.g=(0,k.$dh)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(s){this.f!==s&&(this.z=void 0,this.f=s)}isEnabled(){return this.f}get C(){if(!this.z){const s=this.D(),o=[s];if(this.f)try{for(const A of this.O()){if(!A.name||!(0,p.$cg)(A.name)||!A.location){this.y.warn("Skipping the invalid stored profile",A.location||A.name);continue}o.push(l((0,k.$ah)(A.location),A.name,A.location,this.g,{shortName:A.shortName,icon:A.icon,useDefaultFlags:A.useDefaultFlags},s))}}catch(A){this.y.error(A)}const u=new m.$zc,w=new Map;if(o.length)try{const A=this.Q();if(A.workspaces)for(const[T,D]of Object.entries(A.workspaces)){const N=L.URI.parse(T),M=o.find(Y=>Y.id===D);M&&u.set(N,M)}if(A.emptyWindows)for(const[T,D]of Object.entries(A.emptyWindows)){const N=o.find(M=>M.id===D);N&&w.set(T,N)}}catch(A){this.y.error(A)}this.z={profiles:o,workspaces:u,emptyWindows:w}}return this.z}D(){const s=l("__default__profile__",(0,O.localize)(10925,null),this.t.userRoamingDataHome,this.g);return{...s,extensionsResource:this.S()??s.extensionsResource,isDefault:!0}}async createTransientProfile(s){const o="Temp",u=new RegExp(`${(0,h.$ff)(o)}\\s(\\d+)`);let w=0;for(const T of this.profiles){const D=u.exec(T.name),N=D?parseInt(D[1]):0;w=N>w?N:w}const A=`${o} ${w+1}`;return this.createProfile((0,S.$qj)((0,b.$Yg)()).toString(16),A,{transient:!0},s)}async createNamedProfile(s,o,u){return this.createProfile((0,S.$qj)((0,b.$Yg)()).toString(16),s,o,u)}async createProfile(s,o,u,w){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const A=await this.F(s,o,u);return w&&await this.setProfileForWorkspace(w,A),A}async F(s,o,u){if(!(0,p.$cg)(o)||!o)throw new Error("Name of the profile is mandatory and must be of type `string`");let w=this.r.get(o);return w||(w=(async()=>{try{if(this.profiles.find(N=>N.name===o||N.id===s))throw new Error(`Profile with ${o} name already exists`);const T=l(s,o,(0,k.$dh)(this.profilesHome,s),this.g,u,this.defaultProfile);await this.u.createFolder(T.location);const D=[];return this.j.fire({profile:T,join(N){D.push(N)}}),await I.Promises.settled(D),this.I([T],[],[]),T}finally{this.r.delete(o)}})(),this.r.set(o,w)),w}async updateProfile(s,o){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let u=this.profiles.find(w=>w.id===s.id);if(!u)throw new Error(`Profile '${s.name}' does not exist`);return u=l(u.id,o.name??u.name,u.location,this.g,{shortName:o.shortName??u.shortName,icon:o.icon===null?void 0:o.icon??u.icon,transient:o.transient??u.isTransient,useDefaultFlags:o.useDefaultFlags??u.useDefaultFlags},this.defaultProfile),this.I([],[],[u]),u}async removeProfile(s){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(s.isDefault)throw new Error("Cannot remove default profile");const o=this.profiles.find(w=>w.id===s.id);if(!o)throw new Error(`Profile '${s.name}' does not exist`);const u=[];this.m.fire({profile:o,join(w){u.push(w)}});try{await Promise.allSettled(u)}catch(w){this.y.error(w)}for(const w of[...this.C.emptyWindows.keys()])o.id===this.C.emptyWindows.get(w)?.id&&this.C.emptyWindows.delete(w);for(const w of[...this.C.workspaces.keys()])o.id===this.C.workspaces.get(w)?.id&&this.C.workspaces.delete(w);this.M(),this.I([],[o],[]);try{await this.u.del(o.cacheHome,{recursive:!0})}catch(w){(0,a.$ol)(w)!==a.FileOperationResult.FILE_NOT_FOUND&&this.y.error(w)}}async setProfileForWorkspace(s,o){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const u=this.profiles.find(w=>w.id===o.id);if(!u)throw new Error(`Profile '${o.name}' does not exist`);this.L(s,u)}unsetWorkspace(s,o){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(s,void 0,o)}async resetWorkspaces(){this.s.folders.clear(),this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const s=await this.u.resolve(this.profilesHome);await Promise.all((s.children||[]).filter(o=>o.isDirectory&&this.profiles.every(u=>!this.w.extUri.isEqual(u.location,o.resource))).map(o=>this.u.del(o.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const s=this.s.profiles.filter(o=>!this.H(o));await Promise.allSettled(s.map(o=>this.removeProfile(o)))}getProfileForWorkspace(s){const o=this.G(s),u=L.URI.isUri(o)?this.C.workspaces.get(o):this.C.emptyWindows.get(o);return u||((0,f.$Mi)(s)?this.s.folders.get(s.uri):(0,f.$Ri)(s)?this.s.workspaces.get(s.configPath):this.s.emptyWindows.get(s.id))}G(s){return(0,f.$Mi)(s)?s.uri:(0,f.$Ri)(s)?s.configPath:s.id}H(s){return!!([...this.C.emptyWindows.values()].some(o=>this.w.extUri.isEqual(o.location,s.location))||[...this.C.workspaces.values()].some(o=>this.w.extUri.isEqual(o.location,s.location))||[...this.s.emptyWindows.values()].some(o=>this.w.extUri.isEqual(o.location,s.location))||[...this.s.workspaces.values()].some(o=>this.w.extUri.isEqual(o.location,s.location))||[...this.s.folders.values()].some(o=>this.w.extUri.isEqual(o.location,s.location)))}I(s,o,u){const w=[...this.profiles,...s],A=[],T=this.s.profiles;this.s.profiles=[];for(let D of w){if(D.isDefault||o.some(M=>D.id===M.id))continue;D=u.find(M=>D.id===M.id)??D;const N=T.find(M=>D.id===M.id);if(D.isTransient)this.s.profiles.push(D);else{if(N){for(const[M,Y]of this.s.emptyWindows.entries())if(D.id===Y.id){this.L({id:M},D);break}for(const[M,Y]of this.s.workspaces.entries())if(D.id===Y.id){this.L({id:"",configPath:M},D);break}for(const[M,Y]of this.s.folders.entries())if(D.id===Y.id){this.L({id:"",uri:M},D);break}}A.push({location:D.location,name:D.name,shortName:D.shortName,icon:D.icon,useDefaultFlags:D.useDefaultFlags})}}this.P(A),this.z=void 0,this.J(s,o,u)}J(s,o,u){this.h.fire({added:s,removed:o,updated:u,all:this.profiles})}L(s,o,u){if(u=o?.isTransient?!0:u,u)(0,f.$Mi)(s)?(this.s.folders.delete(s.uri),o&&this.s.folders.set(s.uri,o)):(0,f.$Ri)(s)?(this.s.workspaces.delete(s.configPath),o&&this.s.workspaces.set(s.configPath,o)):(this.s.emptyWindows.delete(s.id),o&&this.s.emptyWindows.set(s.id,o));else{this.L(s,void 0,!0);const w=this.G(s);L.URI.isUri(w)?(this.C.workspaces.delete(w),o&&this.C.workspaces.set(w,o)):(this.C.emptyWindows.delete(w),o&&this.C.emptyWindows.set(w,o)),this.M()}}M(){const s={};for(const[u,w]of this.C.workspaces.entries())s[u.toString()]=w.id;const o={};for(const[u,w]of this.C.emptyWindows.entries())o[u.toString()]=w.id;this.R({workspaces:s,emptyWindows:o}),this.z=void 0}N(s){const o={},u=this.D();if(s.workspaces)for(const[A,T]of Object.entries(s.workspaces)){const D=L.URI.parse(T);o[A]=this.w.extUri.isEqual(D,u.location)?u.id:this.w.extUri.basename(D)}const w={};if(s.emptyWindows)for(const[A,T]of Object.entries(s.emptyWindows)){const D=L.URI.parse(T);w[A]=this.w.extUri.isEqual(D,u.location)?u.id:this.w.extUri.basename(D)}return{workspaces:o,emptyWindows:w}}O(){return[]}P(s){throw new Error("not implemented")}Q(){return{}}R(s){throw new Error("not implemented")}S(){}};e.$Ml=n,e.$Ml=n=ve([se(0,g.$Ji),se(1,a.$0k),se(2,$.$Hl),se(3,c.$0j)],n);class r extends n{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(s){this.a=s}Q(){return this.X}R(s){this.X=s}}e.$Nl=r}),define(ce[53],le([0,1,19,8,21,7,4,2,12,3,11,5,20,25,22,44,6,33,18,23,24]),function(Q,e,S,P,y,k,L,O,g,a,d,c,f,m,$,I,b,h,p,R,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Eq=e.$Cq=void 0,e.$Dq=l,c=ye(c);let i=class extends O.$Tc{get onInstallExtension(){return this.n.event}get onDidInstallExtensions(){return this.s.event}get onUninstallExtension(){return this.t.event}get onDidUninstallExtension(){return this.u.event}get onDidUpdateExtensionMetadata(){return this.w.event}constructor(s,o,u,w,A,T){super(),this.z=s,this.C=o,this.D=u,this.F=w,this.G=A,this.H=T,this.h=0,this.j=new Map,this.m=new Map,this.n=this.B(new L.$je),this.s=this.B(new L.$je),this.t=this.B(new L.$je),this.u=this.B(new L.$je),this.w=this.B(new L.$je),this.y=[],this.B((0,O.$Rc)(()=>{this.j.forEach(({task:D})=>D.cancel()),this.m.forEach(D=>D.cancel()),this.j.clear(),this.m.clear()}))}async canInstall(s){const o=await this.getTargetPlatform();return s.allTargetPlatforms.some(u=>(0,f.$gp)(u,s.allTargetPlatforms,o))}async installFromGallery(s,o={}){try{const w=(await this.installGalleryExtensions([{extension:s,options:o}])).find(({identifier:A})=>(0,m.$Jp)(A,s.identifier));if(w?.local)return w?.local;throw w?.error?w.error:new f.$kp(`Unknown error while installing extension ${s.identifier.id}`,f.ExtensionManagementErrorCode.Unknown)}catch(u){throw l(u)}}async installGalleryExtensions(s){if(!this.z.isEnabled())throw new f.$kp(c.localize(11350,null),f.ExtensionManagementErrorCode.NotAllowed);const o=[],u=[];return await Promise.allSettled(s.map(async({extension:w,options:A})=>{try{const T=await this.N(w,!!A?.installGivenVersion,!!A?.installPreReleaseVersion,A.productVersion??{version:this.G.version,date:this.G.date});u.push({...T,options:A})}catch(T){o.push({identifier:w.identifier,operation:f.InstallOperation.Install,source:w,error:T,profileLocation:A.profileLocation??this.X()})}})),u.length&&o.push(...await this.I(u)),o}async uninstall(s,o={}){return this.F.trace("ExtensionManagementService#uninstall",s.identifier.id),this.P(s,o)}async toggleAppliationScope(s,o){if((0,$.$rn)(s.manifest)||s.isBuiltin)return s;if(s.isApplicationScoped){let u=await this.updateMetadata(s,{isApplicationScoped:!1},this.H.defaultProfile.extensionsResource);this.D.extUri.isEqual(o,this.H.defaultProfile.extensionsResource)||(u=await this.$(s,this.H.defaultProfile.extensionsResource,o));for(const w of this.H.profiles){const A=(await this.getInstalled($.ExtensionType.User,w.extensionsResource)).find(T=>(0,m.$Jp)(T.identifier,s.identifier));A?this.w.fire({local:A,profileLocation:w.extensionsResource}):this.u.fire({identifier:s.identifier,profileLocation:w.extensionsResource})}return u}else{const u=this.D.extUri.isEqual(o,this.H.defaultProfile.extensionsResource)?await this.updateMetadata(s,{isApplicationScoped:!0},this.H.defaultProfile.extensionsResource):await this.$(s,o,this.H.defaultProfile.extensionsResource,{isApplicationScoped:!0});return this.s.fire([{identifier:u.identifier,operation:f.InstallOperation.Install,local:u,profileLocation:this.H.defaultProfile.extensionsResource,applicationScoped:!0}]),u}}getExtensionsControlManifest(){const s=new Date().getTime();return(!this.g||s-this.h>1e3*60*5)&&(this.g=this.W(),this.h=s),this.g}registerParticipant(s){this.y.push(s)}async resetPinnedStateForAllUserExtensions(s){try{await this.L(this.H.profiles.map(async o=>{const u=await this.getInstalled($.ExtensionType.User,o.extensionsResource);await this.L(u.map(async w=>{w.pinned!==s&&await this.updateMetadata(w,{pinned:s},o.extensionsResource)}))}))}catch(o){throw this.F.error("Error while resetting pinned state for all user extensions",(0,k.$9)(o)),o}}async I(s){const o=new Map,u=new Map,w=[],A=(D,N)=>`${m.$Kp.create(D).toString()}-${N.toString()}`,T=(D,N,M,Y)=>{const K=this.Y(D,N,M),re=`${(0,m.$Op)(D.publisher,D.name)}-${M.profileLocation.toString()}`;u.set(re,{task:K,root:Y}),this.n.fire({identifier:K.identifier,source:N,profileLocation:M.profileLocation}),this.F.info("Installing extension:",K.identifier.id,M),d.URI.isUri(N)||this.j.set(A(N,M.profileLocation),{task:K,waitingTasks:[]})};try{for(const{manifest:D,extension:N,options:M}of s){const Y=M.isApplicationScoped||M.isBuiltin||(0,$.$rn)(D),K={...M,installOnlyNewlyAddedFromExtensionPack:M.installOnlyNewlyAddedFromExtensionPack??!d.URI.isUri(N),isApplicationScoped:Y,profileLocation:Y?this.H.defaultProfile.extensionsResource:M.profileLocation??this.X(),productVersion:M.productVersion??{version:this.G.version,date:this.G.date}},re=d.URI.isUri(N)?void 0:this.j.get(A(N,K.profileLocation));re?(this.F.info("Extension is already requested to install",re.task.identifier.id,K.profileLocation.toString()),w.push(re.task.waitUntilTaskIsFinished())):T(D,N,K,void 0)}return await Promise.all([...u.values()].map(async({task:D})=>{if(D.options.donotIncludePackAndDependencies)this.F.info("Installing the extension without checking dependencies and pack",D.identifier.id);else try{const N=await this.M(D.identifier,D.manifest,!!D.options.installOnlyNewlyAddedFromExtensionPack,!!D.options.installPreReleaseVersion,D.options.profileLocation,D.options.productVersion),M=await this.getInstalled(void 0,D.options.profileLocation,D.options.productVersion),Y={...D.options,context:{...D.options.context,[f.$ap]:!0}};for(const{gallery:K,manifest:re}of(0,S.$Lb)(N,({gallery:ae})=>ae.identifier.id)){if(u.has(`${K.identifier.id.toLowerCase()}-${Y.profileLocation.toString()}`))continue;const ae=this.j.get(A(K,Y.profileLocation));if(ae){if(this.J(D,ae.task)){const ue=ae.task.identifier;this.F.info("Waiting for already requested installing extension",ue.id,D.identifier.id,Y.profileLocation.toString()),ae.waitingTasks.push(D),w.push(L.Event.toPromise(L.Event.filter(this.onDidInstallExtensions,de=>de.some(H=>(0,m.$Jp)(H.identifier,ue)))).then(de=>{if(this.F.info("Finished waiting for already requested installing extension",ue.id,D.identifier.id,Y.profileLocation.toString()),!de.find(Z=>(0,m.$Jp)(Z.identifier,ue))?.local)throw new Error(`Extension ${ue.id} is not installed`)}))}}else M.some(({identifier:ue})=>(0,m.$Jp)(ue,K.identifier))||T(re,K,Y,D)}}catch(N){if(d.URI.isUri(D.source))(0,S.$Kb)(D.manifest.extensionDependencies)&&this.F.warn("Cannot install dependencies of extension:",D.identifier.id,N.message),(0,S.$Kb)(D.manifest.extensionPack)&&this.F.warn("Cannot install packed extensions of extension:",D.identifier.id,N.message);else throw this.F.error("Error while preparing to install dependencies and extension packs of the extension:",D.identifier.id),N}})),await this.L([...u.entries()].map(async([D,{task:N}])=>{const M=new Date().getTime();let Y;try{Y=await N.run(),await this.L(this.y.map(K=>K.postInstall(Y,N.source,N.options,y.CancellationToken.None)),f.ExtensionManagementErrorCode.PostInstall)}catch(K){const re=l(K);throw d.URI.isUri(N.source)||n(this.C,N.operation===f.InstallOperation.Update?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,m.$Rp)(N.source),error:re,source:N.options.context?.[f.$_o]}),o.set(D,{error:re,identifier:N.identifier,operation:N.operation,source:N.source,context:N.options.context,profileLocation:N.options.profileLocation,applicationScoped:N.options.isApplicationScoped}),this.F.error("Error while installing the extension",N.identifier.id,(0,k.$9)(re),N.options.profileLocation.toString()),re}if(!d.URI.isUri(N.source)){const K=N.operation===f.InstallOperation.Update,re=K?void 0:(new Date().getTime()-N.source.lastUpdated)/1e3;if(n(this.C,K?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,m.$Rp)(N.source),verificationStatus:N.verificationStatus,duration:new Date().getTime()-M,durationSinceUpdate:re,source:N.options.context?.[f.$_o]}),g.$p&&N.operation!==f.InstallOperation.Update)try{await this.z.reportStatistic(Y.manifest.publisher,Y.manifest.name,Y.manifest.version,f.StatisticType.Install)}catch{}}o.set(D,{local:Y,identifier:N.identifier,operation:N.operation,source:N.source,context:N.options.context,profileLocation:N.options.profileLocation,applicationScoped:Y.isApplicationScoped})})),w.length&&await this.L(w),[...o.values()]}catch(D){const N=(K,re,ae)=>{const ue=[];K.manifest.extensionDependencies?.length&&ue.push(...K.manifest.extensionDependencies),K.manifest.extensionPack?.length&&ue.push(...K.manifest.extensionPack);for(const de of ue){if(ae.includes(de.toLowerCase()))continue;ae.push(de.toLowerCase());const H=o.get(`${de.toLowerCase()}-${re.toString()}`);H?.local&&(ae=N(H.local,re,ae))}return ae},M=K=>({identifier:K.identifier,operation:f.InstallOperation.Install,source:K.source,context:K.options.context,profileLocation:K.options.profileLocation,error:D}),Y=[];for(const[K,{task:re,root:ae}]of u){const ue=o.get(K);ue?ue.local&&ae&&!o.get(`${ae.identifier.id.toLowerCase()}-${re.options.profileLocation.toString()}`)?.local&&(Y.push(this.Z(ue.local,{versionOnly:!0,profileLocation:re.options.profileLocation})),o.set(K,M(re))):(re.cancel(),o.set(K,M(re)))}for(const[K,{task:re}]of u){const ae=o.get(K);if(!ae?.local||re.options.donotIncludePackAndDependencies)continue;N(ae.local,re.options.profileLocation,[ae.local.identifier.id.toLowerCase()]).slice(1).some(de=>u.has(`${de.toLowerCase()}-${re.options.profileLocation.toString()}`)&&!o.get(`${de.toLowerCase()}-${re.options.profileLocation.toString()}`)?.local)&&(Y.push(this.Z(ae.local,{versionOnly:!0,profileLocation:re.options.profileLocation})),o.set(K,M(re)))}throw Y.length&&await Promise.allSettled(Y.map(async K=>{try{await K.run(),this.F.info("Rollback: Uninstalled extension",K.extension.identifier.id)}catch(re){this.F.warn("Rollback: Error while uninstalling extension",K.extension.identifier.id,(0,k.$9)(re))}})),D}finally{for(const{task:D}of u.values())D.source&&!d.URI.isUri(D.source)&&this.j.delete(A(D.source,D.options.profileLocation));if(o.size){const D=[...o.values()];for(const N of D)N.local&&this.F.info("Extension installed successfully:",N.identifier.id,N.profileLocation.toString());this.s.fire(D)}}}J(s,o){for(const[,{task:u,waitingTasks:w}]of this.j.entries())if(u===s&&(w.includes(o)||w.some(A=>this.J(A,o)))||u===o&&w[0]&&!this.J(s,w[0]))return!1;return!0}async L(s,o){const u=[],w=[],A=await Promise.allSettled(s);for(const D of A)D.status==="fulfilled"?u.push(D.value):w.push(l(D.reason,o));if(!w.length)return u;if(w.length===1)throw w[0];let T=new f.$kp("",f.ExtensionManagementErrorCode.Unknown);for(const D of w)T=new f.$kp(T.message?`${T.message}, ${D.message}`:D.message,D.code!==f.ExtensionManagementErrorCode.Unknown&&D.code!==f.ExtensionManagementErrorCode.Internal?D.code:T.code);throw T}async M(s,o,u,w,A,T){if(!this.z.isEnabled())return[];const D=await this.getInstalled(void 0,A,T),N=[],M=[],Y=async(K,re)=>{N.push(K);const ae=re.extensionDependencies||[],ue=[...ae];if(re.extensionPack){const de=u?D.find(H=>(0,m.$Jp)(H.identifier,K)):void 0;for(const H of re.extensionPack)de&&de.manifest.extensionPack&&de.manifest.extensionPack.some(Z=>(0,m.$Jp)({id:Z},{id:H}))||ue.every(Z=>!(0,m.$Jp)({id:Z},{id:H}))&&ue.push(H)}if(ue.length){const de=ue.filter(H=>N.every(Z=>!(0,m.$Jp)(Z,{id:H})));if(de.length){const H=await this.z.getExtensions(de.map(Z=>({id:Z,preRelease:w})),y.CancellationToken.None);for(const Z of H){if(N.find(x=>(0,m.$Jp)(x,Z.identifier)))continue;const B=ae.some(x=>(0,m.$Jp)({id:x},Z.identifier));let z;try{z=await this.N(Z,!1,w,T)}catch(x){if(B)throw x;this.F.info("Skipping the packed extension as it cannot be installed",Z.identifier.id,(0,k.$9)(x));continue}M.push({gallery:z.extension,manifest:z.manifest}),await Y(z.extension.identifier,z.manifest)}}}};return await Y(s,o),M}async N(s,o,u,w){let A;const T=await this.getExtensionsControlManifest();if(T.malicious.some(M=>(0,m.$Jp)(s.identifier,M)))throw new f.$kp(c.localize(11351,null,s.identifier.id),f.ExtensionManagementErrorCode.Malicious);const D=T.deprecated[s.identifier.id.toLowerCase()];if(D?.extension?.autoMigrate){if(this.F.info(`The '${s.identifier.id}' extension is deprecated, fetching the compatible '${D.extension.id}' extension instead.`),A=(await this.z.getExtensions([{id:D.extension.id,preRelease:D.extension.preRelease}],{targetPlatform:await this.getTargetPlatform(),compatible:!0,productVersion:w},y.CancellationToken.None))[0],!A)throw new f.$kp(c.localize(11352,null,s.identifier.id,D.extension.id),f.ExtensionManagementErrorCode.Deprecated)}else{if(!await this.canInstall(s)){const M=await this.getTargetPlatform();throw new f.$kp(c.localize(11353,null,s.identifier.id,this.G.nameLong,(0,f.$cp)(M)),f.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}if(A=await this.O(s,o,u,w),!A){const M=[];throw(0,I.$4p)(s.properties.enabledApiProposals??[],M)?!u&&s.properties.isPreReleaseVersion&&(await this.z.getExtensions([s.identifier],y.CancellationToken.None))[0]?new f.$kp(c.localize(11355,null,s.displayName??s.identifier.id),f.ExtensionManagementErrorCode.ReleaseVersionNotFound):new f.$kp(c.localize(11356,null,s.identifier.id,this.G.nameLong,this.G.version),f.ExtensionManagementErrorCode.Incompatible):new f.$kp(c.localize(11354,null,s.displayName??s.identifier.id,M[0]),f.ExtensionManagementErrorCode.IncompatibleApi)}}this.F.info("Getting Manifest...",A.identifier.id);const N=await this.z.getManifest(A,y.CancellationToken.None);if(N===null)throw new f.$kp(`Missing manifest for extension ${A.identifier.id}`,f.ExtensionManagementErrorCode.Invalid);if(N.version!==A.version)throw new f.$kp(`Cannot install '${A.identifier.id}' extension because of version mismatch in Marketplace`,f.ExtensionManagementErrorCode.Invalid);return{extension:A,manifest:N}}async O(s,o,u,w){const A=await this.getTargetPlatform();let T=null;return!o&&s.hasPreReleaseVersion&&s.properties.isPreReleaseVersion!==u&&(T=(await this.z.getExtensions([{...s.identifier,preRelease:u}],{targetPlatform:A,compatible:!0,productVersion:w},y.CancellationToken.None))[0]||null),!T&&await this.z.isExtensionCompatible(s,u,A,w)&&(T=s),T||(o?T=(await this.z.getExtensions([{...s.identifier,version:s.version}],{targetPlatform:A,compatible:!0,productVersion:w},y.CancellationToken.None))[0]||null:T=await this.z.getCompatibleExtension(s,u,A,w)),T}async P(s,o){const u={...o,profileLocation:s.isApplicationScoped?this.H.defaultProfile.extensionsResource:o.profileLocation??this.X()},w=Y=>`${Y.id.toLowerCase()}${u.versionOnly?`-${s.manifest.version}`:""}${u.profileLocation?`@${u.profileLocation.toString()}`:""}`,A=this.m.get(w(s.identifier));if(A)return this.F.info("Extensions is already requested to uninstall",s.identifier.id),A.waitUntilTaskIsFinished();const T=Y=>{const K=this.Z(Y,u);return this.m.set(w(K.extension.identifier),K),u.profileLocation?this.F.info("Uninstalling extension from the profile:",`${Y.identifier.id}@${Y.manifest.version}`,u.profileLocation.toString()):this.F.info("Uninstalling extension:",`${Y.identifier.id}@${Y.manifest.version}`),this.t.fire({identifier:Y.identifier,profileLocation:u.profileLocation,applicationScoped:Y.isApplicationScoped}),K},D=(Y,K)=>{K?u.profileLocation?this.F.error("Failed to uninstall extension from the profile:",`${Y.identifier.id}@${Y.manifest.version}`,u.profileLocation.toString(),K.message):this.F.error("Failed to uninstall extension:",`${Y.identifier.id}@${Y.manifest.version}`,K.message):u.profileLocation?this.F.info("Successfully uninstalled extension from the profile",`${Y.identifier.id}@${Y.manifest.version}`,u.profileLocation.toString()):this.F.info("Successfully uninstalled extension:",`${Y.identifier.id}@${Y.manifest.version}`),n(this.C,"extensionGallery:uninstall",{extensionData:(0,m.$Qp)(Y),error:K}),this.u.fire({identifier:Y.identifier,error:K?.code,profileLocation:u.profileLocation,applicationScoped:Y.isApplicationScoped})},N=[],M=[];try{N.push(T(s));const Y=await this.getInstalled($.ExtensionType.User,u.profileLocation);if(u.donotIncludePack)this.F.info("Uninstalling the extension without including packed extension",`${s.identifier.id}@${s.manifest.version}`);else{const K=this.S(s,Y);for(const re of K)this.m.has(w(re.identifier))?this.F.info("Extensions is already requested to uninstall",re.identifier.id):N.push(T(re))}u.donotCheckDependents?this.F.info("Uninstalling the extension without checking dependents",`${s.identifier.id}@${s.manifest.version}`):this.Q(N.map(K=>K.extension),Y,s),await this.L(N.map(async K=>{try{if(await K.run(),await this.L(this.y.map(re=>re.postUninstall(K.extension,u,y.CancellationToken.None))),K.extension.identifier.uuid)try{await this.z.reportStatistic(K.extension.manifest.publisher,K.extension.manifest.name,K.extension.manifest.version,f.StatisticType.Uninstall)}catch{}D(K.extension)}catch(re){const ae=l(re);throw D(K.extension,ae),ae}finally{M.push(K)}}))}catch(Y){const K=l(Y);for(const re of N){try{re.cancel()}catch{}M.includes(re)||D(re.extension,K)}throw K}finally{for(const Y of N)this.m.delete(w(Y.extension.identifier))||this.F.warn("Uninstallation task is not found in the cache",Y.extension.identifier.id)}}Q(s,o,u){for(const w of s){const A=this.U(w,o);if(A.length){const T=A.filter(D=>!s.some(N=>(0,m.$Jp)(N.identifier,D.identifier)));if(T.length)throw new Error(this.R(w,T,u))}}}R(s,o,u){return u===s?o.length===1?c.localize(11357,null,u.manifest.displayName||u.manifest.name,o[0].manifest.displayName||o[0].manifest.name):o.length===2?c.localize(11358,null,u.manifest.displayName||u.manifest.name,o[0].manifest.displayName||o[0].manifest.name,o[1].manifest.displayName||o[1].manifest.name):c.localize(11359,null,u.manifest.displayName||u.manifest.name,o[0].manifest.displayName||o[0].manifest.name,o[1].manifest.displayName||o[1].manifest.name):o.length===1?c.localize(11360,null,u.manifest.displayName||u.manifest.name,s.manifest.displayName||s.manifest.name,o[0].manifest.displayName||o[0].manifest.name):o.length===2?c.localize(11361,null,u.manifest.displayName||u.manifest.name,s.manifest.displayName||s.manifest.name,o[0].manifest.displayName||o[0].manifest.name,o[1].manifest.displayName||o[1].manifest.name):c.localize(11362,null,u.manifest.displayName||u.manifest.name,s.manifest.displayName||s.manifest.name,o[0].manifest.displayName||o[0].manifest.name,o[1].manifest.displayName||o[1].manifest.name)}S(s,o,u=[]){if(u.indexOf(s)!==-1)return[];u.push(s);const w=s.manifest.extensionPack?s.manifest.extensionPack:[];if(w.length){const A=o.filter(D=>!D.isBuiltin&&w.some(N=>(0,m.$Jp)({id:N},D.identifier))),T=[];for(const D of A)T.push(...this.S(D,o,u));return[...A,...T]}return[]}U(s,o){return o.filter(u=>u.manifest.extensionDependencies&&u.manifest.extensionDependencies.some(w=>(0,m.$Jp)({id:w},s.identifier)))}async W(){try{return this.F.trace("ExtensionManagementService.updateControlCache"),await this.z.getExtensionsControlManifest()}catch(s){return this.F.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest",(0,k.$9)(s)),{malicious:[],deprecated:{},search:[]}}}};e.$Cq=i,e.$Cq=i=ve([se(0,f.$ip),se(1,p.$9l),se(2,R.$Hl),se(3,b.$0j),se(4,h.$qk),se(5,v.$Jl)],i);function l(t,s){if(t instanceof f.$kp)return t;let o;return t instanceof f.$jp?o=new f.$kp(t.message,t.code===f.ExtensionGalleryErrorCode.DownloadFailedWriting?f.ExtensionManagementErrorCode.DownloadFailedWriting:f.ExtensionManagementErrorCode.Gallery):o=new f.$kp(t.message,(0,k.$3)(t)?f.ExtensionManagementErrorCode.Cancelled:s??f.ExtensionManagementErrorCode.Internal),o.stack=t.stack,o}function n(t,s,{extensionData:o,verificationStatus:u,duration:w,error:A,source:T,durationSinceUpdate:D}){let N,M;(0,a.$kg)(u)&&(u===!0?u="Verified":(u===!1||(N=f.ExtensionManagementErrorCode.Signature,M=u),u="Unverified")),A&&(N=A.code,A.code===f.ExtensionManagementErrorCode.Signature&&(M=A.message)),t.publicLog(s,{...o,verificationStatus:u,success:!A,duration:w,errorcode:N,errorcodeDetail:M,durationSinceUpdate:D,source:T})}class r{constructor(){this.d=new P.$Bh}async waitUntilTaskIsFinished(){return await this.d.wait(),this.g}run(){return this.g||(this.g=(0,P.$ph)(s=>this.h(s))),this.d.open(),this.g}cancel(){this.g||(this.g=(0,P.$ph)(s=>new Promise((o,u)=>{const w=s.onCancellationRequested(()=>{w.dispose(),u(new k.$4)})})),this.d.open()),this.g.cancel()}}e.$Eq=r}),define(ce[42],le([0,1,8,13,2,4,30,11,20,25,9,10,6,24,23,3,7,18]),function(Q,e,S,P,y,k,L,O,g,a,d,c,f,m,$,I,b,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hq=e.$Gq=e.$Fq=e.ExtensionsProfileScanningErrorCode=void 0;var p;(function(n){n.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",n.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(p||(e.ExtensionsProfileScanningErrorCode=p={}));class R extends Error{constructor(r,t){super(r),this.code=t}}e.$Fq=R,e.$Gq=(0,c.$Ci)("IExtensionsProfileScannerService");let v=class extends y.$Tc{constructor(r,t,s,o,u,w){super(),this.j=r,this.m=t,this.n=s,this.r=o,this.s=u,this.t=w,this.b=this.B(new k.$je),this.onAddExtensions=this.b.event,this.c=this.B(new k.$je),this.onDidAddExtensions=this.c.event,this.f=this.B(new k.$je),this.onRemoveExtensions=this.f.event,this.g=this.B(new k.$je),this.onDidRemoveExtensions=this.g.event,this.h=new L.$zc}scanProfileExtensions(r,t){return this.u(r,void 0,t)}async addExtensionsToProfile(r,t,s){const o=[],u=[];try{return await this.u(t,w=>{const A=[];if(s)A.push(...w);else for(const T of w)r.some(([D])=>(0,a.$Jp)(D.identifier,T.identifier)&&D.manifest.version!==T.version)?o.push(T):A.push(T);for(const[T,D]of r){const N=A.findIndex(Y=>(0,a.$Jp)(Y.identifier,T.identifier)&&Y.version===T.manifest.version),M={identifier:T.identifier,version:T.manifest.version,location:T.location,metadata:D};N===-1?(u.push(M),A.push(M)):A.splice(N,1,M)}return u.length&&this.b.fire({extensions:u,profileLocation:t}),o.length&&this.f.fire({extensions:o,profileLocation:t}),A}),u.length&&this.c.fire({extensions:u,profileLocation:t}),o.length&&this.g.fire({extensions:o,profileLocation:t}),u}catch(w){throw u.length&&this.c.fire({extensions:u,error:w,profileLocation:t}),o.length&&this.g.fire({extensions:o,error:w,profileLocation:t}),w}}async updateMetadata(r,t){const s=[];return await this.u(t,o=>{const u=[];for(const w of o){const A=r.find(([T])=>(0,a.$Jp)(T.identifier,w.identifier)&&T.manifest.version===w.version);A&&(w.metadata={...w.metadata,...A[1]},s.push(w)),u.push(w)}return u}),s}async removeExtensionFromProfile(r,t){const s=[];try{await this.u(t,o=>{const u=[];for(const w of o)(0,a.$Jp)(w.identifier,r.identifier)?s.push(w):u.push(w);return s.length&&this.f.fire({extensions:s,profileLocation:t}),u}),s.length&&this.g.fire({extensions:s,profileLocation:t})}catch(o){throw s.length&&this.g.fire({extensions:s,error:o,profileLocation:t}),o}}async u(r,t,s){return this.F(r).queue(async()=>{let o=[],u;try{const w=await this.m.readFile(r);u=JSON.parse(w.value.toString().trim()||"[]")}catch(w){if((0,d.$ol)(w)!==d.FileOperationResult.FILE_NOT_FOUND)throw w;if(this.r.extUri.isEqual(r,this.n.defaultProfile.extensionsResource)&&(u=await this.D()),!u&&s?.bailOutWhenFileNotFound)throw new R((0,b.$9)(w),p.ERROR_PROFILE_NOT_FOUND)}if(u){Array.isArray(u)||this.w(r);let w=!1;for(const A of u){i(A)||this.w(r);let T;if((0,I.$cg)(A.relativeLocation)&&A.relativeLocation)T=this.z(A.relativeLocation);else if((0,I.$cg)(A.location)){this.t.warn(`Extensions profile: Ignoring extension with invalid location: ${A.location}`);continue}else{T=O.URI.revive(A.location);const D=this.y(T);D&&(w=!0,A.relativeLocation=D)}(0,I.$jg)(A.metadata?.hasPreReleaseVersion)&&A.metadata?.preRelease&&(w=!0,A.metadata.hasPreReleaseVersion=!0),o.push({identifier:A.identifier,location:T,version:A.version,metadata:A.metadata})}w&&await this.m.writeFile(r,P.$Le.fromString(JSON.stringify(u)))}if(t){o=t(o);const w=o.map(A=>({identifier:A.identifier,version:A.version,location:A.location.toJSON(),relativeLocation:this.y(A.location),metadata:A.metadata}));await this.m.writeFile(r,P.$Le.fromString(JSON.stringify(w)))}return o})}w(r){const t=new R(`Invalid extensions content in ${r.toString()}`,p.ERROR_INVALID_CONTENT);throw this.s.publicLogError2("extensionsProfileScanningError",{code:t.code}),t}y(r){return this.r.extUri.isEqual(this.r.extUri.dirname(r),this.j)?this.r.extUri.basename(r):void 0}z(r){return this.r.extUri.joinPath(this.j,r)}async D(){return this.C||(this.C=(async()=>{const r=this.r.extUri.joinPath(this.n.defaultProfile.location,"extensions.json"),t=this.r.extUri.joinPath(this.j,".init-default-profile-extensions");let s;try{s=(await this.m.readFile(r)).value.toString()}catch(u){if((0,d.$ol)(u)===d.FileOperationResult.FILE_NOT_FOUND)return;throw u}this.t.info("Migrating extensions from old default profile location",r.toString());let o;try{const u=JSON.parse(s);Array.isArray(u)&&u.every(w=>i(w))?o=u:this.t.warn("Skipping migrating from old default profile locaiton: Found invalid data",u)}catch(u){this.t.error(u)}if(o)try{await this.m.createFile(this.n.defaultProfile.extensionsResource,P.$Le.fromString(JSON.stringify(o)),{overwrite:!1}),this.t.info("Migrated extensions from old default profile location to new location",r.toString(),this.n.defaultProfile.extensionsResource.toString())}catch(u){if((0,d.$ol)(u)===d.FileOperationResult.FILE_MODIFIED_SINCE)this.t.info("Migration from old default profile location to new location is done by another window",r.toString(),this.n.defaultProfile.extensionsResource.toString());else throw u}try{await this.m.del(r)}catch(u){(0,d.$ol)(u)!==d.FileOperationResult.FILE_NOT_FOUND&&this.t.error(u)}try{await this.m.del(t)}catch(u){(0,d.$ol)(u)!==d.FileOperationResult.FILE_NOT_FOUND&&this.t.error(u)}return o})()),this.C}F(r){let t=this.h.get(r);return t||(t=new S.$Jh,this.h.set(r,t)),t}};e.$Hq=v,e.$Hq=v=ve([se(1,d.$0k),se(2,m.$Jl),se(3,$.$Hl),se(4,h.$9l),se(5,f.$0j)],v);function i(n){return(0,I.$eg)(n)&&(0,g.$hp)(n.identifier)&&(l(n.location)||(0,I.$cg)(n.location)&&n.location)&&((0,I.$jg)(n.relativeLocation)||(0,I.$cg)(n.relativeLocation))&&n.version&&(0,I.$cg)(n.version)}function l(n){return n?(0,I.$cg)(n.path)&&(0,I.$cg)(n.scheme):!1}});var qe=this&&this.__importDefault||function(Q){return Q&&Q.__esModule?Q:{default:Q}};define(ce[54],le([0,1,19,8,26,13,7,34,90,2,14,15,12,16,45,57,3,11,5,17,25,22,44,9,10,6,33,4,48,42,24,23,96]),function(Q,e,S,P,y,k,L,O,g,a,d,c,f,m,$,I,b,h,p,R,v,i,l,n,r,t,s,o,u,w,A,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oq=e.$Mq=e.$Lq=e.$Kq=e.Translations=void 0,e.$Nq=ae,y=ye(y),c=ye(c),f=ye(f),$=ye($),I=qe(I);var N;(function(de){function H(Z,B){if(Z===B)return!0;const z=Object.keys(Z),x=new Set;for(const X of Object.keys(B))x.add(X);if(z.length!==x.size)return!1;for(const X of z){if(Z[X]!==B[X])return!1;x.delete(X)}return x.size===0}de.equals=H})(N||(e.Translations=N={})),e.$Kq=(0,r.$Ci)("IExtensionsScannerService");let M=class extends a.$Tc{constructor(H,Z,B,z,x,X,ee,ie,j,W,q,E){super(),this.systemExtensionsLocation=H,this.userExtensionsLocation=Z,this.r=B,this.s=z,this.t=x,this.u=X,this.w=ee,this.y=ie,this.z=j,this.C=W,this.D=q,this.F=E,this.g=this.B(new o.$je),this.onDidChangeCache=this.g.event,this.h=(0,m.$dh)(this.userExtensionsLocation,".obsolete"),this.j=this.B(this.F.createInstance(re,this.s,this.h)),this.m=this.B(this.F.createInstance(re,this.s,this.h)),this.n=this.B(this.F.createInstance(K,this.h)),this.H=void 0,this.B(this.j.onDidChangeCache(()=>this.g.fire(i.ExtensionType.System))),this.B(this.m.onDidChangeCache(()=>this.g.fire(i.ExtensionType.User)))}getTargetPlatform(){return this.G||(this.G=(0,v.$Up)(this.w,this.y)),this.G}async scanAllExtensions(H,Z,B){const[z,x]=await Promise.all([this.scanSystemExtensions(H),this.scanUserExtensions(Z)]),X=B?await this.scanExtensionsUnderDevelopment(H,[...z,...x]):[];return this.L(z,x,X,await this.getTargetPlatform(),!0)}async scanSystemExtensions(H){const Z=[];Z.push(this.M(!!H.useCache,H.language)),Z.push(this.N(H.language,!!H.checkControlFile));const[B,z]=await Promise.all(Z);return this.J([...B,...z],i.ExtensionType.System,H,!1)}async scanUserExtensions(H){const Z=H.profileLocation??this.userExtensionsLocation;this.y.trace("Started scanning user extensions",Z);const B=this.D.extUri.isEqual(H.profileLocation,this.t.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,z=await this.P(Z,!!H.profileLocation,i.ExtensionType.User,!H.includeUninstalled,H.language,!0,B,H.productVersion??this.R()),x=H.useCache&&!z.devMode&&z.excludeObsolete?this.m:this.n;let X;try{X=await x.scanExtensions(z)}catch(ee){if(ee instanceof w.$Fq&&ee.code===w.ExtensionsProfileScanningErrorCode.ERROR_PROFILE_NOT_FOUND)await this.I(),X=await x.scanExtensions(z);else throw ee}return X=await this.J(X,i.ExtensionType.User,H,!0),this.y.trace("Scanned user extensions:",X.length),X}async scanExtensionsUnderDevelopment(H,Z){if(this.z.isExtensionDevelopment&&this.z.extensionDevelopmentLocationURI){const B=(await Promise.all(this.z.extensionDevelopmentLocationURI.filter(z=>z.scheme===d.Schemas.file).map(async z=>{const x=await this.P(z,!1,i.ExtensionType.User,!0,H.language,!1,void 0,H.productVersion??this.R());return(await this.n.scanOneOrMultipleExtensions(x)).map(ee=>(ee.type=Z.find(ie=>(0,v.$Jp)(ie.identifier,ee.identifier))?.type??ee.type,this.n.validate(ee,x)))}))).flat();return this.J(B,"development",H,!0)}return[]}async scanExistingExtension(H,Z,B){const z=await this.P(H,!1,Z,!0,B.language,!0,void 0,B.productVersion??this.R()),x=await this.n.scanExtension(z);return!x||!B.includeInvalid&&!x.isValid?null:x}async scanOneOrMultipleExtensions(H,Z,B){const z=await this.P(H,!1,Z,!0,B.language,!0,void 0,B.productVersion??this.R()),x=await this.n.scanOneOrMultipleExtensions(z);return this.J(x,Z,B,!0)}async scanMultipleExtensions(H,Z,B){const z=[];return await Promise.all(H.map(async x=>{const X=await this.scanOneOrMultipleExtensions(x,Z,B);z.push(...X)})),this.J(z,Z,B,!0)}async scanMetadata(H){const Z=(0,m.$dh)(H,"package.json"),B=(await this.w.readFile(Z)).value.toString();return JSON.parse(B).__metadata}async updateMetadata(H,Z){const B=(0,m.$dh)(H,"package.json"),z=(await this.w.readFile(B)).value.toString(),x=JSON.parse(z);Z.isMachineScoped===!1&&delete Z.isMachineScoped,Z.isBuiltin===!1&&delete Z.isBuiltin,x.__metadata={...x.__metadata,...Z},await this.w.writeFile((0,m.$dh)(H,"package.json"),k.$Le.fromString(JSON.stringify(x,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.u.scanProfileExtensions(this.t.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(H){if(H instanceof w.$Fq&&H.code===w.ExtensionsProfileScanningErrorCode.ERROR_PROFILE_NOT_FOUND)await this.I();else throw H}}async I(){return this.H||(this.H=(async()=>{try{this.y.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const H=await this.scanUserExtensions({includeInvalid:!0});if(H.length)await this.u.addExtensionsToProfile(H.map(Z=>[Z,Z.metadata]),this.t.defaultProfile.extensionsResource);else try{await this.w.createFile(this.t.defaultProfile.extensionsResource,k.$Le.fromString(JSON.stringify([])))}catch(Z){(0,n.$ol)(Z)!==n.FileOperationResult.FILE_NOT_FOUND&&this.y.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,L.$9)(Z))}this.y.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(H){this.y.error(H)}finally{this.H=void 0}})()),this.H}async J(H,Z,B,z){return B.includeAllVersions||(H=this.L(Z===i.ExtensionType.System?H:void 0,Z===i.ExtensionType.User?H:void 0,Z==="development"?H:void 0,await this.getTargetPlatform(),z)),B.includeInvalid||(H=H.filter(x=>x.isValid)),H.sort((x,X)=>{const ee=c.$mc(x.location.fsPath),ie=c.$mc(X.location.fsPath);return ee<ie?-1:ee>ie?1:0})}L(H,Z,B,z,x){const X=(ie,j,W)=>{if(ie.isValid&&!j.isValid)return!1;if(ie.isValid===j.isValid){if(x&&$.gt(ie.manifest.version,j.manifest.version))return this.y.debug(`Skipping extension ${j.location.path} with lower version ${j.manifest.version} in favour of ${ie.location.path} with version ${ie.manifest.version}`),!1;if($.eq(ie.manifest.version,j.manifest.version)){if(ie.type===i.ExtensionType.System)return this.y.debug(`Skipping extension ${j.location.path} in favour of system extension ${ie.location.path} with same version`),!1;if(ie.targetPlatform===z)return this.y.debug(`Skipping extension ${j.location.path} from different target platform ${j.targetPlatform}`),!1}}return W?this.y.warn(`Overwriting user extension ${ie.location.path} with ${j.location.path}.`):this.y.debug(`Overwriting user extension ${ie.location.path} with ${j.location.path}.`),!0},ee=new i.$qn;return H?.forEach(ie=>{const j=ee.get(ie.identifier.id);(!j||X(j,ie,!1))&&ee.set(ie.identifier.id,ie)}),Z?.forEach(ie=>{const j=ee.get(ie.identifier.id);if(!j&&H&&ie.type===i.ExtensionType.System){this.y.debug(`Skipping obsolete system extension ${ie.location.path}.`);return}(!j||X(j,ie,!1))&&ee.set(ie.identifier.id,ie)}),B?.forEach(ie=>{const j=ee.get(ie.identifier.id);(!j||X(j,ie,!0))&&ee.set(ie.identifier.id,ie),ee.set(ie.identifier.id,ie)}),[...ee.values()]}async M(H,Z){this.y.trace("Started scanning system extensions");const B=await this.P(this.systemExtensionsLocation,!1,i.ExtensionType.System,!0,Z,!0,void 0,this.R()),x=await(H&&!B.devMode?this.j:this.n).scanExtensions(B);return this.y.trace("Scanned system extensions:",x.length),x}async N(H,Z){const B=this.z.isBuilt?[]:this.C.builtInExtensions;if(!B?.length)return[];this.y.trace("Started scanning dev system extensions");const z=Z?await this.O():{},x=[],X=h.URI.file(c.$gc(c.$ic(d.$Wg.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const ie of B){const j=z[ie.name]||"marketplace";switch(j){case"disabled":break;case"marketplace":x.push((0,m.$dh)(X,ie.name));break;default:x.push(h.URI.file(j));break}}const ee=await Promise.all(x.map(async ie=>this.n.scanExtension(await this.P(ie,!1,i.ExtensionType.System,!0,H,!0,void 0,this.R()))));return this.y.trace("Scanned dev system extensions:",ee.length),(0,S.$Gb)(ee)}async O(){try{const H=await this.w.readFile(this.r);return JSON.parse(H.value.toString())}catch{return{}}}async P(H,Z,B,z,x,X,ee,ie){const j=await this.f(x??f.$x),W=await this.Q(H),q=Z&&!this.D.extUri.isEqual(H,this.t.defaultProfile.extensionsResource)?this.t.defaultProfile.extensionsResource:void 0,E=q?await this.Q(q):void 0;return new Y(H,W,q,E,Z,ee,B,z,X,ie.version,ie.date,this.C.commit,!this.z.isBuilt,x,j)}async Q(H){try{const Z=await this.w.stat(H);if(typeof Z.mtime=="number")return Z.mtime}catch{}}R(){return{version:this.C.version,date:this.C.date}}};e.$Lq=M,e.$Lq=M=ve([se(4,A.$Jl),se(5,w.$Gq),se(6,n.$0k),se(7,t.$0j),se(8,R.$Ji),se(9,s.$qk),se(10,T.$Hl),se(11,r.$Bi)],M);class Y{constructor(H,Z,B,z,x,X,ee,ie,j,W,q,E,F,U,C){this.location=H,this.mtime=Z,this.applicationExtensionslocation=B,this.applicationExtensionslocationMtime=z,this.profile=x,this.profileScanOptions=X,this.type=ee,this.excludeObsolete=ie,this.validate=j,this.productVersion=W,this.productDate=q,this.productCommit=E,this.devMode=F,this.language=U,this.translations=C}static createNlsConfiguration(H){return{language:H.language,pseudo:H.language==="pseudo",devMode:H.devMode,translations:H.translations}}static equals(H,Z){return(0,m.$9g)(H.location,Z.location)&&H.mtime===Z.mtime&&(0,m.$9g)(H.applicationExtensionslocation,Z.applicationExtensionslocation)&&H.applicationExtensionslocationMtime===Z.applicationExtensionslocationMtime&&H.profile===Z.profile&&y.$fo(H.profileScanOptions,Z.profileScanOptions)&&H.type===Z.type&&H.excludeObsolete===Z.excludeObsolete&&H.validate===Z.validate&&H.productVersion===Z.productVersion&&H.productDate===Z.productDate&&H.productCommit===Z.productCommit&&H.devMode===Z.devMode&&H.language===Z.language&&N.equals(H.translations,Z.translations)}}e.$Mq=Y;let K=class extends a.$Tc{constructor(H,Z,B,z,x,X,ee){super(),this.g=H,this.h=Z,this.j=B,this.m=z,this.n=X,this.r=ee,this.f=x.extensionsEnabledWithApiProposalVersion?.map(ie=>ie.toLowerCase())??[]}async scanExtensions(H){const Z=H.profile?await this.t(H):await this.s(H);let B={};if(H.excludeObsolete&&H.type===i.ExtensionType.User)try{const z=(await this.m.readFile(this.g)).value.toString();B=JSON.parse(z)}catch{}return(0,b.$pg)(B)?Z:Z.filter(z=>!B[v.$Kp.create(z).toString()])}async s(H){const Z=await this.m.resolve(H.location);if(!Z.children?.length)return[];const B=await Promise.all(Z.children.map(async z=>{if(!z.isDirectory||H.type===i.ExtensionType.User&&(0,m.$ah)(z.resource).indexOf(".")===0)return null;const x=new Y(z.resource,H.mtime,H.applicationExtensionslocation,H.applicationExtensionslocationMtime,H.profile,H.profileScanOptions,H.type,H.excludeObsolete,H.validate,H.productVersion,H.productDate,H.productCommit,H.devMode,H.language,H.translations);return this.scanExtension(x)}));return(0,S.$Gb)(B).sort((z,x)=>z.location.path<x.location.path?-1:1)}async t(H){let Z=await this.u(H.location,()=>!0,H);if(H.applicationExtensionslocation&&!this.j.extUri.isEqual(H.location,H.applicationExtensionslocation)){Z=Z.filter(z=>!z.metadata?.isApplicationScoped);const B=await this.u(H.applicationExtensionslocation,z=>!!z.metadata?.isBuiltin||!!z.metadata?.isApplicationScoped,H);Z.push(...B)}return Z}async u(H,Z,B){const z=await this.h.scanProfileExtensions(H,B.profileScanOptions);if(!z.length)return[];const x=await Promise.all(z.map(async X=>{if(Z(X)){const ee=new Y(X.location,B.mtime,B.applicationExtensionslocation,B.applicationExtensionslocationMtime,B.profile,B.profileScanOptions,B.type,B.excludeObsolete,B.validate,B.productVersion,B.productDate,B.productCommit,B.devMode,B.language,B.translations);return this.scanExtension(ee,X.metadata)}return null}));return(0,S.$Gb)(x)}async scanOneOrMultipleExtensions(H){try{if(await this.m.exists((0,m.$dh)(H.location,"package.json"))){const Z=await this.scanExtension(H);return Z?[Z]:[]}else return await this.scanExtensions(H)}catch(Z){return this.r.error(`Error scanning extensions at ${H.location.path}:`,(0,L.$9)(Z)),[]}}async scanExtension(H,Z){try{let B=await this.w(H.location);if(B){B.publisher||(B.publisher=i.$kn),Z=Z??B.__metadata,delete B.__metadata;const z=(0,v.$Op)(B.publisher,B.name),x=Z?.id?{id:z,uuid:Z.id}:{id:z},X=Z?.isSystem?i.ExtensionType.System:H.type,ee=X===i.ExtensionType.System||!!Z?.isBuiltin;B=await this.y(H.location,B,Y.createNlsConfiguration(H));let ie={type:X,identifier:x,manifest:B,location:H.location,isBuiltin:ee,targetPlatform:Z?.targetPlatform??i.TargetPlatform.UNDEFINED,publisherDisplayName:Z?.publisherDisplayName,metadata:Z,isValid:!0,validations:[]};return H.validate&&(ie=this.validate(ie,H)),B.enabledApiProposals&&(!this.n.isBuilt||this.f.includes(z.toLowerCase()))&&(B.originalEnabledApiProposals=B.enabledApiProposals,B.enabledApiProposals=(0,i.$wn)([...B.enabledApiProposals])),ie}}catch(B){H.type!==i.ExtensionType.System&&this.r.error(B)}return null}validate(H,Z){let B=!0;const z=this.n.isBuilt&&this.f.includes(H.identifier.id.toLowerCase()),x=(0,l.$1p)(Z.productVersion,Z.productDate,Z.location,H.manifest,H.isBuiltin,z);for(const[X,ee]of x)X===I.default.Error&&(B=!1,this.r.error(this.F(Z.location,ee)));return H.isValid=B,H.validations=x,H}async w(H){const Z=(0,m.$dh)(H,"package.json");let B;try{B=(await this.m.readFile(Z)).value.toString()}catch(x){return(0,n.$ol)(x)!==n.FileOperationResult.FILE_NOT_FOUND&&this.r.error(this.F(H,(0,p.localize)(11308,null,Z.path,x.message))),null}let z;try{z=JSON.parse(B)}catch{const X=[];(0,O.$Vn)(B,X);for(const ee of X)this.r.error(this.F(H,(0,p.localize)(11309,null,Z.path,ee.offset,ee.length,(0,g.$Iq)(ee.error))));return null}return(0,O.$4n)(z)!=="object"?(this.r.error(this.F(H,(0,p.localize)(11310,null,Z.path))),null):z}async y(H,Z,B){const z=await this.z(H,Z,B);if(z)try{const x=[],X=await this.C(z.default,x);if(x.length>0)return x.forEach(ie=>{this.r.error(this.F(H,(0,p.localize)(11311,null,z.default?.path,(0,g.$Iq)(ie.error))))}),Z;if((0,O.$4n)(z)!=="object")return this.r.error(this.F(H,(0,p.localize)(11312,null,z.default?.path))),Z;const ee=z.values||Object.create(null);return(0,D.$Jq)(this.r,Z,ee,X)}catch{}return Z}async z(H,Z,B){const z=(0,m.$dh)(H,"package.nls.json"),x=(j,W)=>{W.forEach(q=>{this.r.error(this.F(H,(0,p.localize)(11313,null,j?.path,(0,g.$Iq)(q.error))))})},X=j=>{this.r.error(this.F(H,(0,p.localize)(11314,null,j?.path)))},ee=`${Z.publisher}.${Z.name}`,ie=B.translations[ee];if(ie)try{const j=h.URI.file(ie),W=(await this.m.readFile(j)).value.toString(),q=[],E=(0,O.$Vn)(W,q);return q.length>0?(x(j,q),{values:void 0,default:z}):(0,O.$4n)(E)!=="object"?(X(j),{values:void 0,default:z}):{values:E.contents?E.contents.package:void 0,default:z}}catch{return{values:void 0,default:z}}else{if(!await this.m.exists(z))return;let W;try{W=await this.D(H,B)}catch{return}if(!W.localized)return{values:void 0,default:W.original};try{const q=(await this.m.readFile(W.localized)).value.toString(),E=[],F=(0,O.$Vn)(q,E);return E.length>0?(x(W.localized,E),{values:void 0,default:W.original}):(0,O.$4n)(F)!=="object"?(X(W.localized),{values:void 0,default:W.original}):{values:F,default:W.original}}catch{return{values:void 0,default:W.original}}}}async C(H,Z){if(H)try{const B=(await this.m.readFile(H)).value.toString();return(0,O.$Vn)(B,Z)}catch{}}D(H,Z){return new Promise((B,z)=>{const x=X=>{const ee=(0,m.$dh)(H,`package.nls.${X}.json`);this.m.exists(ee).then(ie=>{ie&&B({localized:ee,original:(0,m.$dh)(H,"package.nls.json")});const j=X.lastIndexOf("-");j===-1?B({localized:(0,m.$dh)(H,"package.nls.json"),original:null}):(X=X.substring(0,j),x(X))})};if(Z.devMode||Z.pseudo||!Z.language)return B({localized:(0,m.$dh)(H,"package.nls.json"),original:null});x(Z.language)})}F(H,Z){return`[${H.path}]: ${Z}`}};K=ve([se(1,w.$Gq),se(2,T.$Hl),se(3,n.$0k),se(4,s.$qk),se(5,R.$Ji),se(6,t.$0j)],K);let re=class extends K{constructor(H,Z,B,z,x,X,ee,ie,j){super(Z,z,x,X,ee,ie,j),this.J=H,this.L=B,this.H=this.B(new P.$Ah(3e3)),this.I=this.B(new o.$je),this.onDidChangeCache=this.I.event}async scanExtensions(H){const Z=this.P(H),B=await this.M(Z);if(this.G=H,B&&B.input&&Y.equals(B.input,this.G))return this.r.debug("Using cached extensions scan result",H.type===i.ExtensionType.System?"system":"user",H.location.toString()),this.H.trigger(()=>this.O()),B.result.map(x=>(x.location=h.URI.revive(x.location),x));const z=await super.scanExtensions(H);return await this.N(Z,{input:H,result:z}),z}async M(H){try{const Z=await this.m.readFile(H),B=JSON.parse(Z.value.toString());return{result:B.result,input:(0,u.$_h)(B.input)}}catch(Z){this.r.debug("Error while reading the extension cache file:",H.path,(0,L.$9)(Z))}return null}async N(H,Z){try{await this.m.writeFile(H,k.$Le.fromString(JSON.stringify(Z)))}catch(B){this.r.debug("Error while writing the extension cache file:",H.path,(0,L.$9)(B))}}async O(){if(!this.G)return;const H=this.P(this.G),Z=await this.M(H);if(!Z)return;const B=Z.result,z=JSON.parse(JSON.stringify(await super.scanExtensions(this.G)));if(!y.$fo(z,B))try{this.r.info("Invalidating Cache",B,z),await this.m.del(H),this.I.fire()}catch(x){this.r.error(x)}}P(H){const Z=this.Q(H);return this.j.extUri.joinPath(Z.cacheHome,H.type===i.ExtensionType.System?i.$jn:i.$in)}Q(H){return H.type===i.ExtensionType.System?this.L.defaultProfile:H.profile?this.j.extUri.isEqual(H.location,this.J.extensionsResource)?this.J:this.L.profiles.find(Z=>this.j.extUri.isEqual(H.location,Z.extensionsResource))??this.J:this.L.defaultProfile}};re=ve([se(2,A.$Jl),se(3,w.$Gq),se(4,T.$Hl),se(5,n.$0k),se(6,s.$qk),se(7,R.$Ji),se(8,t.$0j)],re);function ae(de,H){const Z=(0,v.$Mp)(de.manifest.publisher,de.manifest.name);return{id:Z,identifier:new i.$on(Z),isBuiltin:de.type===i.ExtensionType.System,isUserBuiltin:de.type===i.ExtensionType.User&&de.isBuiltin,isUnderDevelopment:H,extensionLocation:de.location,uuid:de.identifier.uuid,targetPlatform:de.targetPlatform,publisherDisplayName:de.publisherDisplayName,...de.manifest}}class ue extends M{constructor(H,Z,B,z,x,X,ee,ie,j,W,q,E){super(H,Z,(0,m.$dh)(B,".vscode-oss-dev","extensions","control.json"),z,x,X,ee,ie,j,W,q,E),this.S=(async()=>{if(f.$A)try{const F=await this.w.readFile(h.URI.file(f.$A));return JSON.parse(F.value.toString())}catch{}return Object.create(null)})()}f(H){return this.S}}e.$Oq=ue}),define(ce[136],le([0,1,60,8,38,4,2,14,15,28,6,24]),function(Q,e,S,P,y,k,L,O,g,a,d,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sq=void 0;let f=class extends L.$Tc{constructor($,I){super(),this.b=$,this.f=I,this.a=new P.$Ih(5)}async postUninstall($){const I=this.g($,"uninstall");I&&(this.f.info($.identifier.id,$.manifest.version,"Running post uninstall script"),await this.a.queue(async()=>{try{await this.h(I.script,"uninstall",I.args,!0,$),this.f.info("Finished running post uninstall script",$.identifier.id,$.manifest.version)}catch(b){this.f.error("Failed to run post uninstall script",$.identifier.id,$.manifest.version),this.f.error(b)}}));try{await a.Promises.rm(this.m($))}catch(b){this.f.error("Error while removing extension storage path",$.identifier.id),this.f.error(b)}}g($,I){const b=`vscode:${I}`;if($.location.scheme===O.Schemas.file&&$.manifest&&$.manifest.scripts&&typeof $.manifest.scripts[b]=="string"){const h=$.manifest.scripts[b].split(" ");return h.length<2||h[0]!=="node"||!h[1]?(this.f.warn($.identifier.id,$.manifest.version,`${b} should be a node script`),null):{script:(0,g.$ic)($.location.fsPath,h[1]),args:h.slice(2)||[]}}return null}h($,I,b,h,p){return new Promise((R,v)=>{const i=this.j($,I,b,p);let l;const n=r=>{l&&(clearTimeout(l),l=null),r?v(r):R(void 0)};i.on("error",r=>{n((0,y.$nj)(r)||"Unknown")}),i.on("exit",(r,t)=>{n(r?`post-${I} process exited with code ${r}`:void 0)}),h&&(l=setTimeout(()=>{l=null,i.kill(),v("timed out")},5e3))})}j($,I,b,h){const p={silent:!0,execArgv:void 0},R=(0,S.fork)($,[`--type=extension-post-${I}`,...b],p);R.stdout.setEncoding("utf8"),R.stderr.setEncoding("utf8");const v=k.Event.fromNodeEventEmitter(R.stdout,"data"),i=k.Event.fromNodeEventEmitter(R.stderr,"data");this.B(v(r=>this.f.info(h.identifier.id,h.manifest.version,`post-${I}`,r))),this.B(i(r=>this.f.error(h.identifier.id,h.manifest.version,`post-${I}`,r)));const l=k.Event.any(k.Event.map(v,r=>({data:`%c${r}`,format:[""]}),this.q),k.Event.map(i,r=>({data:`%c${r}`,format:["color: red"]}),this.q));return k.Event.debounce(l,(r,t)=>r?{data:r.data+t.data,format:[...r.format,...t.format]}:{data:t.data,format:t.format},100,void 0,void 0,void 0,this.q)(r=>{console.group(h.identifier.id),console.log(r.data,...r.format),console.groupEnd()}),R}m($){return(0,g.$ic)(this.b.defaultProfile.globalStorageHome.fsPath,$.identifier.id.toLowerCase())}};e.$Sq=f,e.$Sq=f=ve([se(0,c.$Jl),se(1,d.$0j)],f)}),define(ce[72],le([0,1,50,5,53,20]),function(Q,e,S,P,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pq=L,e.$Qq=O;function L(g){let a=k.ExtensionManagementErrorCode.Extract;return g instanceof S.$yq&&(g.type==="CorruptZip"?a=k.ExtensionManagementErrorCode.CorruptZip:g.type==="Incomplete"&&(a=k.ExtensionManagementErrorCode.IncompleteZip)),(0,y.$Dq)(g,a)}async function O(g){let a;try{a=await(0,S.$Bq)(g,"extension/package.json")}catch(d){throw L(d)}try{return JSON.parse(a.toString("utf8"))}catch{throw new k.$kp((0,P.localize)(11299,null),k.ExtensionManagementErrorCode.Invalid)}}}),define(ce[137],le([0,1,8,7,2,14,16,45,3,27,28,50,29,17,53,20,25,72,71,9,6,18]),function(Q,e,S,P,y,k,L,O,g,a,d,c,f,m,$,I,b,h,p,R,v,i){"use strict";var l;Object.defineProperty(e,"__esModule",{value:!0}),e.$Rq=void 0,O=ye(O);let n=class extends y.$Tc{static{l=this}static{this.c=".sigzip"}constructor(t,s,o,u,w,A,T){super(),this.h=s,this.j=o,this.m=u,this.n=w,this.r=A,this.t=T,this.extensionsDownloadDir=t.extensionsDownloadLocation,this.f=20,this.g=this.F()}async download(t,s,o,u){await this.g;const w=await this.w(t,s);let A=!1;if(o&&this.u(t)){let T;try{T=await this.y(t)}catch(D){try{await this.delete(w)}catch(N){this.t.error(N)}throw D}try{A=await this.n.verify(t,w.fsPath,T.fsPath,u)}catch(D){if(A=D.code,A===p.ExtensionSignatureVerificationCode.PackageIsInvalidZip||A===p.ExtensionSignatureVerificationCode.SignatureArchiveIsInvalidZip){try{await this.delete(w)}catch(N){this.t.error(N)}throw new I.$kp(c.$xq,I.ExtensionManagementErrorCode.CorruptZip)}}finally{try{await this.delete(T)}catch(D){this.t.error(D)}}}return{location:w,verificationStatus:A}}u(t){if(!t.isSigned)return this.t.info(`Extension is not signed: ${t.identifier.id}`),!1;const s=this.m.getValue("extensions.verifySignature");return(0,g.$ig)(s)?s:!0}async w(t,s){try{const o=(0,L.$dh)(this.extensionsDownloadDir,this.G(t)),u=await this.C(t,"vsix",async()=>{await this.z(t,o,w=>this.j.download(t,w,s));try{await this.D(o.fsPath,"extension/package.json")}catch(w){try{await this.h.del(o)}catch(A){this.t.warn(`Error while deleting: ${o.path}`,(0,P.$9)(A))}throw w}},2);return u>1&&this.r.publicLog2("extensiongallery:downloadvsix:retry",{extensionId:t.identifier.id,attempts:u}),o}catch(o){throw(0,$.$Dq)(o,I.ExtensionManagementErrorCode.Download)}}async y(t){try{const s=(0,L.$dh)(this.extensionsDownloadDir,`.${(0,a.$Yg)()}`),o=await this.C(t,"sigzip",async()=>{await this.j.downloadSignatureArchive(t,s);try{await this.D(s.fsPath,".signature.p7s")}catch(u){try{await this.h.del(s)}catch(w){this.t.warn(`Error while deleting: ${s.path}`,(0,P.$9)(w))}throw u}},2);return o>1&&this.r.publicLog2("extensiongallery:downloadsigzip:retry",{extensionId:t.identifier.id,attempts:o}),s}catch(s){throw(0,$.$Dq)(s,I.ExtensionManagementErrorCode.DownloadSignature)}}async z(t,s,o){if(await this.h.exists(s))return;if(s.scheme!==k.Schemas.file){await o(s);return}const u=(0,L.$dh)(this.extensionsDownloadDir,`.${(0,a.$Yg)()}`);try{await o(u)}catch(w){try{await this.h.del(u)}catch{}throw w}try{await d.Promises.rename(u.fsPath,s.fsPath,2*60*1e3)}catch(w){try{await this.h.del(u)}catch{}let A=!1;try{A=await this.h.exists(s)}catch{}if(A)this.t.info("Rename failed because the file was downloaded by another source. So ignoring renaming.",t.identifier.id,s.path);else throw this.t.info(`Rename failed because of ${(0,P.$9)(w)}. Deleted the file from downloaded location`,u.path),w}}async C(t,s,o,u){let w=1;for(;;)try{return await o(),w}catch(A){if(w++>u)throw A;this.t.warn(`Failed downloading ${s}. ${(0,P.$9)(A)}. Retry again...`,t.identifier.id)}}async D(t,s){try{await(0,c.$Bq)(t,s)}catch(o){throw(0,h.$Pq)(o)}}async delete(t){await this.g,await this.h.del(t)}async F(){try{if(!await this.h.exists(this.extensionsDownloadDir)){this.t.trace("Extension VSIX downloads cache dir does not exist");return}const t=await this.h.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(t.children){const s=[],o=[],u=[];for(const T of t.children)if(T.name.endsWith(l.c))u.push(T.resource);else{const D=b.$Kp.parse(T.name);D&&o.push([D,T])}const w=(0,b.$Pp)(o,([T])=>T),A=[];for(const T of w)T.sort((D,N)=>O.rcompare(D[0].version,N[0].version)),s.push(...T.slice(1).map(D=>D[1].resource)),A.push(T[0][1]);A.sort((T,D)=>T.mtime-D.mtime),s.push(...A.slice(0,Math.max(0,A.length-this.f)).map(T=>T.resource)),s.push(...u),await S.Promises.settled(s.map(T=>(this.t.trace("Deleting from cache",T.path),this.h.del(T))))}}catch(t){this.t.error(t)}}G(t){return this.f?b.$Kp.create(t).toString().toLowerCase():(0,a.$Yg)()}};e.$Rq=n,e.$Rq=n=l=ve([se(0,m.$Ki),se(1,R.$0k),se(2,I.$ip),se(3,f.$9i),se(4,p.$qq),se(5,i.$9l),se(6,v.$0j)],n)}),define(ce[138],le([0,1,32,8,13,21,38,7,4,43,2,30,14,15,16,45,3,11,27,28,50,5,61,17,53,20,25,42,54,137,136,72,118,125,22,44,9,10,6,33,18,23,24]),function(Q,e,S,P,y,k,L,O,g,a,d,c,f,m,$,I,b,h,p,R,v,i,l,n,r,t,s,o,u,w,A,T,D,N,M,Y,K,re,ae,ue,de,H,Z){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xq=e.$Wq=e.$Vq=void 0,S=ye(S),m=ye(m),I=ye(I),R=ye(R),i=ye(i),e.$Vq=(0,re.$Di)(t.$lp);const B=".vsctmp";let z=class extends r.$Cq{constructor(j,W,q,E,F,U,C,G,J,ne,oe,fe){super(j,W,oe,q,ne,fe),this.eb=F,this.fb=U,this.gb=C,this.hb=G,this.ib=J,this.db=new Map,this.tb=new c.$Ac;const me=this.B(G.createInstance(A.$Sq));this.ab=this.B(G.createInstance(x,we=>me.postUninstall(we))),this.bb=this.B(new D.$Tq(fe,J,oe,this,this.F)),this.cb=this.B(G.createInstance(w.$Rq));const ge=this.B(new N.$Uq(this,this.eb,fe,U,oe,J,q));this.B(ge.onDidChangeExtensionsByAnotherSource(we=>this.sb(we))),this.ub()}getTargetPlatform(){return this.jb||(this.jb=(0,s.$Up)(this.ib,this.F)),this.jb}async zip(j){this.F.trace("ExtensionManagementService#zip",j.identifier.id);const W=await this.rb(j),q=await(0,v.zip)((0,$.$dh)(this.cb.extensionsDownloadDir,(0,p.$Yg)()).fsPath,W);return h.URI.file(q)}async getManifest(j){const{location:W,cleanup:q}=await this.lb(j),E=m.$jc(W.fsPath);try{return await(0,T.$Qq)(E)}finally{await q()}}getInstalled(j,W=this.H.defaultProfile.extensionsResource,q={version:this.G.version,date:this.G.date}){return this.ab.scanExtensions(j??null,W,q)}scanAllUserInstalledExtensions(){return this.ab.scanAllUserExtensions(!1)}scanInstalledExtensionAtLocation(j){return this.ab.scanUserExtensionAtLocation(j)}async install(j,W={}){this.F.trace("ExtensionManagementService#install",j.toString());const{location:q,cleanup:E}=await this.lb(j);try{const F=await(0,T.$Qq)(m.$jc(q.fsPath)),U=(0,s.$Op)(F.publisher,F.name);if(F.engines&&F.engines.vscode&&!(0,Y.$3p)(F.engines.vscode,this.G.version,this.G.date))throw new Error(i.localize(11300,null,U,this.G.version));const G=(await this.I([{manifest:F,extension:q,options:W}])).find(({identifier:J})=>(0,s.$Jp)(J,{id:U}));if(G?.local)return G.local;throw G?.error?G.error:(0,r.$Dq)(new Error(`Unknown error while installing extension ${U}`))}finally{await E()}}async installFromLocation(j,W){this.F.trace("ExtensionManagementService#installFromLocation",j.toString());const q=await this.ab.scanUserExtensionAtLocation(j);if(!q||!q.manifest.name||!q.manifest.version)throw new Error(`Cannot find a valid extension from the location ${j.toString()}`);return await this.wb([[q,{source:"resource"}]],W),this.F.info("Successfully installed extension",q.identifier.id,W.toString()),q}async installExtensionsFromProfile(j,W,q){this.F.trace("ExtensionManagementService#installExtensionsFromProfile",j,W.toString(),q.toString());const E=(await this.getInstalled(M.ExtensionType.User,W)).filter(F=>j.some(U=>(0,s.$Jp)(U,F.identifier)));if(E.length){const F=await Promise.all(E.map(U=>this.ab.scanMetadata(U,W)));await this.wb(E.map((U,C)=>[U,F[C]]),q),this.F.info("Successfully installed extensions",E.map(U=>U.identifier.id),q.toString())}return E}async updateMetadata(j,W,q){return this.F.trace("ExtensionManagementService#updateMetadata",j.identifier.id),W.isPreReleaseVersion&&(W.preRelease=!0,W.hasPreReleaseVersion=!0),W.isMachineScoped===!1&&(W.isMachineScoped=void 0),W.isBuiltin===!1&&(W.isBuiltin=void 0),W.pinned===!1&&(W.pinned=void 0),j=await this.ab.updateMetadata(j,W,q),this.bb.invalidate(q),this.w.fire({local:j,profileLocation:q}),j}async reinstallFromGallery(j){if(this.F.trace("ExtensionManagementService#reinstallFromGallery",j.identifier.id),!this.z.isEnabled())throw new Error(i.localize(11301,null));const W=await this.getTargetPlatform(),[q]=await this.z.getExtensions([{...j.identifier,preRelease:j.preRelease}],{targetPlatform:W,compatible:!0},k.CancellationToken.None);if(!q)throw new Error(i.localize(11302,null));await this.ab.setUninstalled(j);try{await this.ab.removeUninstalledExtension(j)}catch(E){throw new Error(i.localize(11303,null,(0,L.$nj)(E)))}return this.installFromGallery(q)}$(j,W,q,E){return this.ab.copyExtension(j,W,q,E)}copyExtensions(j,W){return this.ab.copyExtensions(j,W,{version:this.G.version,date:this.G.date})}markAsUninstalled(...j){return this.ab.setUninstalled(...j)}async cleanUp(){this.F.trace("ExtensionManagementService#cleanUp");try{await this.ab.cleanUp()}catch(j){this.F.error(j)}}async download(j,W,q){const{location:E}=await this.cb.download(j,W,!q);return E}async lb(j){if(j.scheme===f.Schemas.file)return{location:j,async cleanup(){}};this.F.trace("Downloading extension from",j.toString());const W=(0,$.$dh)(this.cb.extensionsDownloadDir,(0,p.$Yg)());return await this.gb.download(j,W),this.F.info("Downloaded extension to",W.toString()),{location:W,cleanup:async()=>{try{await this.ib.del(W)}catch(E){this.F.error(E)}}}}X(){return this.H.defaultProfile.extensionsResource}Y(j,W,q){const E=W instanceof h.URI?new s.$Kp({id:(0,s.$Op)(j.publisher,j.name)},j.version):s.$Kp.create(W);return this.hb.createInstance(X,E,j,W,q,(F,U)=>{if(W instanceof h.URI)return this.qb(E,W,q,U);let C=this.db.get(E.toString());return C||(this.db.set(E.toString(),C=this.pb(E,W,F,q,U)),C.finally(()=>this.db.delete(E.toString()))),C},this.ab)}Z(j,W){return new ee(j,W.profileLocation,this.fb)}async pb(j,W,q,E,F){const{verificationStatus:U,location:C}=await this.cb.download(W,q,!E.donotVerifySignature,E.context?.[t.$bp]);try{if(F.isCancellationRequested)throw new O.$4;return await(0,T.$Qq)(C.fsPath),{local:await this.ab.extractUserExtension(j,C.fsPath,{id:W.identifier.uuid,publisherId:W.publisherId,publisherDisplayName:W.publisherDisplayName,targetPlatform:W.properties.targetPlatform,isApplicationScoped:E.isApplicationScoped,isMachineScoped:E.isMachineScoped,isBuiltin:E.isBuiltin,isPreReleaseVersion:W.properties.isPreReleaseVersion,hasPreReleaseVersion:W.properties.isPreReleaseVersion,installedTimestamp:Date.now(),pinned:E.installGivenVersion?!0:!!E.pinned,preRelease:(0,b.$ig)(E.preRelease)?E.preRelease:E.installPreReleaseVersion||W.properties.isPreReleaseVersion,source:"gallery"},!1,F),verificationStatus:U}}catch(G){try{await this.cb.delete(C)}catch(J){this.F.warn("Error while deleting the downloaded file",C.toString(),(0,O.$9)(J))}throw(0,r.$Dq)(G)}}async qb(j,W,q,E){return{local:await this.ab.extractUserExtension(j,m.$jc(W.fsPath),{isApplicationScoped:q.isApplicationScoped,isMachineScoped:q.isMachineScoped,isBuiltin:q.isBuiltin,installedTimestamp:Date.now(),pinned:q.installGivenVersion?!0:!!q.pinned,source:"vsix"},q.keepExisting??!0,E)}}async rb(j){const W=async E=>{let F=await R.Promises.readdir(E);F=F.map(G=>m.$ic(E,G));const U=await Promise.all(F.map(G=>S.promises.stat(G)));let C=Promise.resolve([]);return U.forEach((G,J)=>{const ne=F[J];G.isFile()&&(C=C.then(oe=>[...oe,ne])),G.isDirectory()&&(C=C.then(oe=>W(ne).then(fe=>[...oe,...fe])))}),C};return(await W(j.location.fsPath)).map(E=>({path:`extension/${m.$kc(j.location.fsPath,E)}`,localPath:E}))}async sb({added:j,removed:W}){if(W){const q=j&&this.D.extUri.isEqual(W.profileLocation,j.profileLocation)?W.extensions.filter(E=>j.extensions.every(F=>!(0,s.$Jp)(F,E))):W.extensions;for(const E of q)this.F.info("Extensions removed from another source",E.id,W.profileLocation.toString()),this.u.fire({identifier:E,profileLocation:W.profileLocation})}if(j){const E=(await this.getInstalled(M.ExtensionType.User,j.profileLocation)).filter(F=>j.extensions.some(U=>(0,s.$Jp)(U,F.identifier)));this.s.fire(E.map(F=>(this.F.info("Extensions added from another source",F.identifier.id,j.profileLocation.toString()),{identifier:F.identifier,local:F,profileLocation:j.profileLocation,operation:t.InstallOperation.None})))}}async ub(){this.B(this.ab.onExtract(W=>this.tb.add(W)));const j=await this.ib.resolve(this.eb.userExtensionsLocation);for(const W of j.children??[])W.isDirectory&&this.tb.add(W.resource);this.B(this.ib.watch(this.eb.userExtensionsLocation)),this.B(this.ib.onDidFilesChange(W=>this.vb(W)))}async vb(j){if(!j.affects(this.eb.userExtensionsLocation,K.FileChangeType.ADDED))return;const W=[];for(const q of j.rawAdded){if(this.tb.has(q)||!this.D.extUri.isEqual(this.D.extUri.dirname(q),this.eb.userExtensionsLocation)||this.D.extUri.isEqual(q,this.D.extUri.joinPath(this.eb.userExtensionsLocation,".obsolete"))||this.D.extUri.basename(q).startsWith(".")||!(await this.ib.stat(q)).isDirectory)continue;const E=await this.ab.scanUserExtensionAtLocation(q);E&&E.installedTimestamp===void 0&&(this.tb.add(q),W.push(E))}W.length&&(await this.wb(W.map(q=>[q,void 0]),this.H.defaultProfile.extensionsResource),this.F.info("Added extensions to default profile from external source",W.map(q=>q.identifier.id)))}async wb(j,W){const q=j.map(E=>E[0]);await this.xb(q),await this.fb.addExtensionsToProfile(j,W),this.s.fire(q.map(E=>({local:E,identifier:E.identifier,operation:t.InstallOperation.None,profileLocation:W})))}async xb(j){const W=await this.ab.getUninstalledExtensions();for(const q of j){const E=s.$Kp.create(q);W[E.toString()]&&(this.F.trace("Removing the extension from uninstalled list:",E.id),await this.ab.setInstalled(E),this.F.info("Removed the extension from uninstalled list:",E.id))}}};e.$Wq=z,e.$Wq=z=ve([se(0,t.$ip),se(1,de.$9l),se(2,ae.$0j),se(3,n.$Ki),se(4,u.$Kq),se(5,o.$Gq),se(6,l.$Yo),se(7,re.$Bi),se(8,K.$0k),se(9,ue.$qk),se(10,H.$Hl),se(11,Z.$Jl)],z);let x=class extends d.$Tc{constructor(j,W,q,E,F,U,C){super(),this.n=j,this.s=W,this.t=q,this.u=E,this.w=F,this.y=U,this.z=C,this.h=this.B(new g.$je),this.onExtract=this.h.event,this.j=new c.$zc,this.m=new c.$zc,this.c=(0,$.$dh)(this.t.userExtensionsLocation,".obsolete"),this.g=new P.$Jh}async cleanUp(){await this.J(),await this.I()}async scanExtensions(j,W,q){try{const E={includeInvalid:!0,profileLocation:W,productVersion:q};let F=[];if(j===null||j===M.ExtensionType.System){let U=this.j.get(W);U||(U=this.t.scanAllExtensions({includeInvalid:!0,useCache:!0},E,!1).finally(()=>this.j.delete(W)),this.j.set(W,U)),F.push(...await U)}else if(j===M.ExtensionType.User){let U=this.m.get(W);U||(U=this.t.scanUserExtensions(E).finally(()=>this.m.delete(W)),this.m.set(W,U)),F.push(...await U)}return F=j!==null?F.filter(U=>U.type===j):F,await Promise.all(F.map(U=>this.H(U)))}catch(E){throw(0,r.$Dq)(E,t.ExtensionManagementErrorCode.Scanning)}}async scanAllUserExtensions(j){try{const W=await this.t.scanUserExtensions({includeAllVersions:!j,includeInvalid:!0});return await Promise.all(W.map(q=>this.H(q)))}catch(W){throw(0,r.$Dq)(W,t.ExtensionManagementErrorCode.Scanning)}}async scanUserExtensionAtLocation(j){try{const W=await this.t.scanExistingExtension(j,M.ExtensionType.User,{includeInvalid:!0});if(W)return await this.H(W)}catch(W){this.z.error(W)}return null}async extractUserExtension(j,W,q,E,F){const U=j.toString(),C=h.URI.file(m.$ic(this.t.userExtensionsLocation.fsPath,`.${(0,p.$Yg)()}`)),G=h.URI.file(m.$ic(this.t.userExtensionsLocation.fsPath,U));if(await this.s.exists(G)){if(!E)try{return await this.scanLocalExtension(G,M.ExtensionType.User)}catch(J){this.z.warn(`Error while scanning the existing extension at ${G.path}. Deleting the existing extension and extracting it.`,(0,O.$9)(J))}try{await this.D(j.id,G,"removeExisting")}catch{throw new t.$kp(i.localize(11304,null,G.fsPath,j.id),t.ExtensionManagementErrorCode.Delete)}}try{if(F.isCancellationRequested)throw new O.$4;try{this.z.trace(`Started extracting the extension from ${W} to ${G.fsPath}`),await(0,v.$Aq)(W,C.fsPath,{sourcePath:"extension",overwrite:!0},F),this.z.info(`Extracted extension to ${G}:`,j.id)}catch(J){throw(0,T.$Pq)(J)}try{await this.t.updateMetadata(C,q)}catch(J){throw this.y.publicLog2("extension:extract",{extensionId:j.id,code:`${(0,K.$ol)(J)}`}),(0,r.$Dq)(J,t.ExtensionManagementErrorCode.UpdateMetadata)}if(F.isCancellationRequested)throw new O.$4;try{this.z.trace(`Started renaming the extension from ${C.fsPath} to ${G.fsPath}`),await this.G(C.fsPath,G.fsPath),this.z.info("Renamed to",G.fsPath)}catch(J){if(J.code==="ENOTEMPTY"){this.z.info("Rename failed because extension was installed by another source. So ignoring renaming.",j.id);try{await this.s.del(C,{recursive:!0})}catch{}}else throw this.z.info(`Rename failed because of ${(0,O.$9)(J)}. Deleted from extracted location`,C),J}this.h.fire(G)}catch(J){try{await this.s.del(C,{recursive:!0})}catch{}throw J}return this.scanLocalExtension(G,M.ExtensionType.User)}async scanMetadata(j,W){return W?(await this.C(j,W))?.metadata:this.t.scanMetadata(j.location)}async C(j,W){return(await this.u.scanProfileExtensions(W)).find(E=>(0,s.$Jp)(E.identifier,j.identifier))}async updateMetadata(j,W,q){try{q?await this.u.updateMetadata([[j,W]],q):await this.t.updateMetadata(j.location,W)}catch(E){throw this.y.publicLog2("extension:extract",{extensionId:j.identifier.id,code:`${(0,K.$ol)(E)}`,isProfile:!!q}),(0,r.$Dq)(E,t.ExtensionManagementErrorCode.UpdateMetadata)}return this.scanLocalExtension(j.location,j.type,q)}async getUninstalledExtensions(){try{return await this.F()}catch(j){throw(0,r.$Dq)(j,t.ExtensionManagementErrorCode.ReadUninstalled)}}async setUninstalled(...j){const W=j.map(q=>s.$Kp.create(q));await this.F(q=>W.forEach(E=>{q[E.toString()]=!0,this.z.info("Marked extension as uninstalled",E.toString())}))}async setInstalled(j){try{await this.F(W=>delete W[j.toString()])}catch(W){throw(0,r.$Dq)(W,t.ExtensionManagementErrorCode.UnsetUninstalled)}}async removeExtension(j,W){if(this.w.extUri.isEqualOrParent(j.location,this.t.userExtensionsLocation))return this.D(j.identifier.id,j.location,W)}async removeUninstalledExtension(j){await this.removeExtension(j,"uninstalled"),await this.F(W=>delete W[s.$Kp.create(j).toString()])}async copyExtension(j,W,q,E){const F=await this.C(j,W),U=await this.C(j,q);if(E={...F?.metadata,...E},U)if(this.w.extUri.isEqual(U.location,j.location))await this.u.updateMetadata([[j,{...U.metadata,...E}]],q);else{const C=await this.scanLocalExtension(U.location,j.type,q);await this.u.removeExtensionFromProfile(C,q),await this.u.addExtensionsToProfile([[j,{...U.metadata,...E}]],q)}else await this.u.addExtensionsToProfile([[j,E]],q);return this.scanLocalExtension(j.location,j.type,q)}async copyExtensions(j,W,q){const E=await this.scanExtensions(M.ExtensionType.User,j,q),F=await Promise.all(E.filter(U=>!U.isApplicationScoped).map(async U=>[U,await this.scanMetadata(U,j)]));await this.u.addExtensionsToProfile(F,W)}async D(j,W,q){this.z.trace(`Deleting ${q} extension from disk`,j,W.fsPath);const E=this.w.extUri.joinPath(this.w.extUri.dirname(W),`${this.w.extUri.basename(W)}.${(0,a.$qj)((0,p.$Yg)()).toString(16)}${B}`);await this.G(W.fsPath,E.fsPath),await this.s.del(E,{recursive:!0}),this.z.info(`Deleted ${q} extension from disk`,j,W.fsPath)}F(j){return this.g.queue(async()=>{let W;try{W=(await this.s.readFile(this.c,"utf8")).value.toString()}catch(E){if((0,K.$ol)(E)!==K.FileOperationResult.FILE_NOT_FOUND)throw E}let q={};if(W)try{q=JSON.parse(W)}catch{}return j&&(j(q),Object.keys(q).length?await this.s.writeFile(this.c,y.$Le.fromString(JSON.stringify(q))):await this.s.del(this.c)),q})}async G(j,W){try{await R.Promises.rename(j,W,2*60*1e3)}catch(q){throw(0,r.$Dq)(q,t.ExtensionManagementErrorCode.Rename)}}async scanLocalExtension(j,W,q){try{if(q){const F=(await this.t.scanUserExtensions({profileLocation:q})).find(U=>this.w.extUri.isEqual(U.location,j));if(F)return await this.H(F)}else{const E=await this.t.scanExistingExtension(j,W,{includeInvalid:!0});if(E)return await this.H(E)}throw new t.$kp(i.localize(11305,null,j.path),t.ExtensionManagementErrorCode.ScanningExtension)}catch(E){throw(0,r.$Dq)(E,t.ExtensionManagementErrorCode.ScanningExtension)}}async H(j){const W=await this.s.resolve(j.location);let q,E;return W.children&&(q=W.children.find(({name:F})=>/^readme(\.txt|\.md|)$/i.test(F))?.resource,E=W.children.find(({name:F})=>/^changelog(\.txt|\.md|)$/i.test(F))?.resource),{identifier:j.identifier,type:j.type,isBuiltin:j.isBuiltin||!!j.metadata?.isBuiltin,location:j.location,manifest:j.manifest,targetPlatform:j.targetPlatform,validations:j.validations,isValid:j.isValid,readmeUrl:q,changelogUrl:E,publisherDisplayName:j.metadata?.publisherDisplayName,publisherId:j.metadata?.publisherId||null,isApplicationScoped:!!j.metadata?.isApplicationScoped,isMachineScoped:!!j.metadata?.isMachineScoped,isPreReleaseVersion:!!j.metadata?.isPreReleaseVersion,hasPreReleaseVersion:!!j.metadata?.hasPreReleaseVersion,preRelease:!!j.metadata?.preRelease,installedTimestamp:j.metadata?.installedTimestamp,updated:!!j.metadata?.updated,pinned:!!j.metadata?.pinned,isWorkspaceScoped:!1,source:j.metadata?.source??(j.identifier.uuid?"gallery":"vsix")}}async I(){const j=await this.getUninstalledExtensions();if(Object.keys(j).length===0){this.z.debug("No uninstalled extensions found.");return}this.z.debug("Removing uninstalled extensions:",Object.keys(j));const W=await this.t.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),q=new Set;for(const F of W)j[s.$Kp.create(F).toString()]||q.add(F.identifier.id.toLowerCase());try{const F=(0,s.$Pp)(W,U=>U.identifier);await P.Promises.settled(F.map(async U=>{const C=U.sort((G,J)=>I.rcompare(G.manifest.version,J.manifest.version))[0];q.has(C.identifier.id.toLowerCase())||await this.n(await this.H(C))}))}catch(F){this.z.error(F)}const E=W.filter(F=>F.metadata&&j[s.$Kp.create(F).toString()]);await Promise.allSettled(E.map(F=>this.removeUninstalledExtension(F)))}async J(){this.z.trace("ExtensionManagementService#removeTempDeleteFolders");let j;try{j=await this.s.resolve(this.t.userExtensionsLocation)}catch(W){(0,K.$ol)(W)!==K.FileOperationResult.FILE_NOT_FOUND&&this.z.error(W);return}if(j?.children)try{await Promise.allSettled(j.children.map(async W=>{if(!(!W.isDirectory||!W.name.endsWith(B))){this.z.trace("Deleting the temporarily deleted folder",W.resource.toString());try{await this.s.del(W.resource,{recursive:!0}),this.z.trace("Deleted the temporarily deleted folder",W.resource.toString())}catch(q){(0,K.$ol)(q)!==K.FileOperationResult.FILE_NOT_FOUND&&this.z.error(q)}}}))}catch{}}};e.$Xq=x,e.$Xq=x=ve([se(1,K.$0k),se(2,u.$Kq),se(3,o.$Gq),se(4,H.$Hl),se(5,de.$9l),se(6,ae.$0j)],x);let X=class extends r.$Eq{get operation(){return this.options.operation??this.j}get verificationStatus(){return this.k}constructor(j,W,q,E,F,U,C,G,J,ne,oe,fe){super(),this.l=j,this.manifest=W,this.source=q,this.options=E,this.m=F,this.n=U,this.o=C,this.p=G,this.q=J,this.s=ne,this.t=oe,this.u=fe,this.j=t.InstallOperation.Install,this.identifier=this.l.identifier}async h(j){const q=(await this.n.scanExtensions(M.ExtensionType.User,this.options.profileLocation,this.options.productVersion)).find(C=>(0,s.$Jp)(C.identifier,this.identifier));q&&(this.j=t.InstallOperation.Update);const E={isApplicationScoped:this.options.isApplicationScoped||q?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||q?.isMachineScoped,isBuiltin:this.options.isBuiltin||q?.isBuiltin,isSystem:q?.type===M.ExtensionType.System?!0:void 0,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:this.options.pinned??q?.pinned,source:this.source instanceof h.URI?"vsix":"gallery"};let F;if(this.source instanceof h.URI){if(q&&this.l.equals(new s.$Kp(q.identifier,q.manifest.version)))try{await this.n.removeExtension(q,"existing")}catch{throw new Error(i.localize(11306,null,this.manifest.displayName||this.manifest.name))}const C=await this.w(this.l);if(C)try{await this.n.removeExtension(C,"existing")}catch{throw new Error(i.localize(11307,null,this.manifest.displayName||this.manifest.name))}}else{if(E.id=this.source.identifier.uuid,E.publisherId=this.source.publisherId,E.publisherDisplayName=this.source.publisherDisplayName,E.targetPlatform=this.source.properties.targetPlatform,E.updated=!!q,E.isPreReleaseVersion=this.source.properties.isPreReleaseVersion,E.hasPreReleaseVersion=q?.hasPreReleaseVersion||this.source.properties.isPreReleaseVersion,E.preRelease=(0,b.$ig)(this.options.preRelease)?this.options.preRelease:this.options.installPreReleaseVersion||this.source.properties.isPreReleaseVersion||q?.preRelease,q&&q.type!==M.ExtensionType.System&&q.manifest.version===this.source.version)return this.n.updateMetadata(q,E,this.options.profileLocation);F=await this.w(this.l)}if(j.isCancellationRequested)throw(0,r.$Dq)(new O.$4);if(!F){const C=await this.m(this.operation,j);F=C.local,this.k=C.verificationStatus}if(this.o.extUri.isEqual(this.q.defaultProfile.extensionsResource,this.options.profileLocation))try{await this.s.initializeDefaultProfileExtensions()}catch(C){throw(0,r.$Dq)(C,t.ExtensionManagementErrorCode.IntializeDefaultProfile)}if(j.isCancellationRequested)throw(0,r.$Dq)(new O.$4);try{await this.t.addExtensionsToProfile([[F,E]],this.options.profileLocation,!F.isValid)}catch(C){throw(0,r.$Dq)(C,t.ExtensionManagementErrorCode.AddToProfile)}const U=await this.n.scanLocalExtension(F.location,M.ExtensionType.User,this.options.profileLocation);if(!U)throw new t.$kp("Cannot find the installed extension",t.ExtensionManagementErrorCode.InstalledExtensionNotFound);return this.source instanceof h.URI&&this.x(F,j),U}async w(j){return(await this.n.getUninstalledExtensions())[j.toString()]?(this.u.trace("Removing the extension from uninstalled list:",j.id),await this.n.setInstalled(j),this.u.info("Removed the extension from uninstalled list:",j.id),(await this.n.scanAllUserExtensions(!0)).find(E=>s.$Kp.create(E).equals(j))):void 0}async x(j,W){try{let[q]=await this.p.getExtensions([{id:j.identifier.id,version:j.manifest.version}],W);if(q||([q]=await this.p.getExtensions([{id:j.identifier.id}],W)),q){const E={id:q.identifier.uuid,publisherDisplayName:q.publisherDisplayName,publisherId:q.publisherId,isPreReleaseVersion:q.properties.isPreReleaseVersion,hasPreReleaseVersion:j.hasPreReleaseVersion||q.properties.isPreReleaseVersion,preRelease:q.properties.isPreReleaseVersion||this.options.installPreReleaseVersion};await this.n.updateMetadata(j,E,this.options.profileLocation)}}catch{}}};X=ve([se(6,H.$Hl),se(7,t.$ip),se(8,Z.$Jl),se(9,u.$Kq),se(10,o.$Gq),se(11,ae.$0j)],X);class ee extends r.$Eq{constructor(j,W,q){super(),this.extension=j,this.j=W,this.k=q}async h(j){await this.k.removeExtensionFromProfile(this.extension,this.j)}}}),define(ce[139],le([0,1,6,24,23,18,42,9,17,11]),function(Q,e,S,P,y,k,L,O,g,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uR=void 0;let d=class extends L.$Hq{constructor(f,m,$,I,b,h){super(a.URI.file(f.extensionsPath),m,$,I,b,h)}};e.$uR=d,e.$uR=d=ve([se(0,g.$Ki),se(1,O.$0k),se(2,P.$Jl),se(3,y.$Hl),se(4,k.$9l),se(5,S.$0j)],d)}),define(ce[140],le([0,1,11,17,42,54,9,10,6,33,23,24]),function(Q,e,S,P,y,k,L,O,g,a,d,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qgc=void 0;let f=class extends k.$Oq{constructor($,I,b,h,p,R,v,i){super(S.URI.file(p.builtinExtensionsPath),S.URI.file(p.extensionsPath),p.userHome,$.defaultProfile,$,I,b,h,p,R,v,i)}};e.$Qgc=f,e.$Qgc=f=ve([se(0,c.$Jl),se(1,y.$Gq),se(2,L.$0k),se(3,g.$0j),se(4,P.$Ki),se(5,a.$qk),se(6,d.$Hl),se(7,O.$Bi)],f)}),define(ce[73],le([0,1,8,4,2,108,3,88,10,24]),function(Q,e,S,P,y,k,L,O,g,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jq=e.$hq=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$fq=e.$eq=e.$dq=void 0,e.$gq=m,e.$iq=I,e.$kq=h,e.$dq="__$__isNewStorageMarker",e.$eq="__$__targetStorageMarker",e.$fq=(0,g.$Ci)("storageService");var d;(function(p){p[p.NONE=0]="NONE",p[p.SHUTDOWN=1]="SHUTDOWN"})(d||(e.WillSaveStateReason=d={}));var c;(function(p){p[p.APPLICATION=-1]="APPLICATION",p[p.PROFILE=0]="PROFILE",p[p.WORKSPACE=1]="WORKSPACE"})(c||(e.StorageScope=c={}));var f;(function(p){p[p.USER=0]="USER",p[p.MACHINE=1]="MACHINE"})(f||(e.StorageTarget=f={}));function m(p){const R=p.get(e.$eq);if(R)try{return JSON.parse(R)}catch{}return Object.create(null)}class $ extends y.$Tc{static{this.a=60*1e3}constructor(R={flushInterval:$.a}){super(),this.m=R,this.b=this.B(new P.$me),this.c=this.B(new P.$me),this.onDidChangeTarget=this.c.event,this.f=this.B(new P.$je),this.onWillSaveState=this.f.event,this.h=this.B(new S.$Oh(()=>this.n(),this.m.flushInterval)),this.j=this.B(new y.$Uc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(R,v,i){return P.Event.filter(this.b.event,l=>l.scope===R&&(v===void 0||l.key===v),i)}n(){this.j.value=(0,S.$Sh)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,y.$Oc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,k.mark)("code/willInitStorage");try{await this.O()}finally{(0,k.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(R,v){const{key:i,external:l}=v;if(i===e.$eq){switch(R){case c.APPLICATION:this.H=void 0;break;case c.PROFILE:this.F=void 0;break;case c.WORKSPACE:this.C=void 0;break}this.c.fire({scope:R})}else this.b.fire({scope:R,key:i,target:this.J(R)[i],external:l})}w(R){this.f.fire({reason:R})}get(R,v,i){return this.P(v)?.get(R,i)}getBoolean(R,v,i){return this.P(v)?.getBoolean(R,i)}getNumber(R,v,i){return this.P(v)?.getNumber(R,i)}getObject(R,v,i){return this.P(v)?.getObject(R,i)}storeAll(R,v){this.y(()=>{for(const i of R)this.store(i.key,i.value,i.scope,i.target,v)})}store(R,v,i,l,n=!1){if((0,L.$lg)(v)){this.remove(R,i,n);return}this.y(()=>{this.z(R,i,l),this.P(i)?.set(R,v,n)})}remove(R,v,i=!1){this.y(()=>{this.z(R,v,void 0),this.P(v)?.delete(R,i)})}y(R){this.b.pause(),this.c.pause();try{R()}finally{this.b.resume(),this.c.resume()}}keys(R,v){const i=[],l=this.J(R);for(const n of Object.keys(l))l[n]===v&&i.push(n);return i}z(R,v,i,l=!1){const n=this.J(v);typeof i=="number"?n[R]!==i&&(n[R]=i,this.P(v)?.set(e.$eq,JSON.stringify(n),l)):typeof n[R]=="number"&&(delete n[R],this.P(v)?.set(e.$eq,JSON.stringify(n),l))}get D(){return this.C||(this.C=this.L(c.WORKSPACE)),this.C}get G(){return this.F||(this.F=this.L(c.PROFILE)),this.F}get I(){return this.H||(this.H=this.L(c.APPLICATION)),this.H}J(R){switch(R){case c.APPLICATION:return this.I;case c.PROFILE:return this.G;default:return this.D}}L(R){const v=this.P(R);return v?m(v):Object.create(null)}isNew(R){return this.getBoolean(e.$dq,R)===!0}async flush(R=d.NONE){this.f.fire({reason:R});const v=this.P(c.APPLICATION),i=this.P(c.PROFILE),l=this.P(c.WORKSPACE);switch(R){case d.NONE:await S.Promises.settled([v?.whenFlushed()??Promise.resolve(),i?.whenFlushed()??Promise.resolve(),l?.whenFlushed()??Promise.resolve()]);break;case d.SHUTDOWN:await S.Promises.settled([v?.flush(0)??Promise.resolve(),i?.flush(0)??Promise.resolve(),l?.flush(0)??Promise.resolve()]);break}}async log(){const R=this.P(c.APPLICATION)?.items??new Map,v=this.P(c.PROFILE)?.items??new Map,i=this.P(c.WORKSPACE)?.items??new Map;return h(R,v,i,this.Q(c.APPLICATION)??"",this.Q(c.PROFILE)??"",this.Q(c.WORKSPACE)??"")}async optimize(R){return await this.flush(),this.P(R)?.optimize()}async switch(R,v){return this.w(d.NONE),(0,a.$Il)(R)?this.R(R,v):this.S(R,v)}M(R,v){return!(R.id===v.id||I(v)&&I(R))}N(R,v,i){this.y(()=>{const l=new Set;for(const[n,r]of R)l.add(n),v.get(n)!==r&&this.u(i,{key:n,external:!0});for(const[n]of v.items)l.has(n)||this.u(i,{key:n,external:!0})})}}e.$hq=$;function I(p){return p.isDefault||!!p.useDefaultFlags?.globalState}class b extends ${constructor(){super(),this.U=this.B(new O.$bq(new O.$cq,{hint:O.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new O.$bq(new O.$cq,{hint:O.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new O.$bq(new O.$cq,{hint:O.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(R=>this.u(c.WORKSPACE,R))),this.B(this.W.onDidChangeStorage(R=>this.u(c.PROFILE,R))),this.B(this.U.onDidChangeStorage(R=>this.u(c.APPLICATION,R)))}P(R){switch(R){case c.APPLICATION:return this.U;case c.PROFILE:return this.W;default:return this.X}}Q(R){switch(R){case c.APPLICATION:return"inMemory (application)";case c.PROFILE:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(R){return!1}}e.$jq=b;async function h(p,R,v,i,l,n){const r=N=>{try{return JSON.parse(N)}catch{return N}},t=new Map,s=new Map;p.forEach((N,M)=>{t.set(M,N),s.set(M,r(N))});const o=new Map,u=new Map;R.forEach((N,M)=>{o.set(M,N),u.set(M,r(N))});const w=new Map,A=new Map;v.forEach((N,M)=>{w.set(M,N),A.set(M,r(N))}),console.group(i!==l?`Storage: Application (path: ${i})`:`Storage: Application & Profile (path: ${i}, default profile)`);const T=[];if(t.forEach((N,M)=>{T.push({key:M,value:N})}),console.table(T),console.groupEnd(),console.log(s),i!==l){console.group(`Storage: Profile (path: ${l}, profile specific)`);const N=[];o.forEach((M,Y)=>{N.push({key:Y,value:M})}),console.table(N),console.groupEnd(),console.log(u)}console.group(`Storage: Workspace (path: ${n})`);const D=[];w.forEach((N,M)=>{D.push({key:M,value:N})}),console.table(D),console.groupEnd(),console.log(A)}}),define(ce[141],le([0,1,13,27,73]),function(Q,e,S,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lq=k;async function k(L,O,g){let a=g&&g.get("storage.serviceMachineId",y.StorageScope.APPLICATION)||null;if(a)return a;try{const c=(await O.readFile(L.serviceMachineIdResource)).value.toString();a=(0,P.$Xg)(c)?c:null}catch{a=null}if(!a){a=(0,P.$Yg)();try{await O.writeFile(L.serviceMachineIdResource,S.$Le.fromString(a))}catch{}}return g?.store("storage.serviceMachineId",a,y.StorageScope.APPLICATION,y.StorageTarget.MACHINE),a}}),define(ce[142],le([0,1,141,18,41]),function(Q,e,S,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mq=k;async function k(L,O,g,a,d,c,f){const m={"X-Market-Client-Id":`VSCode ${L}`,"User-Agent":`VSCode ${L} (${O.nameShort})`};if((0,y.$Bp)(O,g)&&(0,y.$Dp)(a)===P.TelemetryLevel.USAGE){const $=await(0,S.$lq)(g,d,c);m["X-Market-User-Id"]=$,m["VSCode-SessionId"]=f.machineId||$}return m}}),define(ce[143],le([0,1,19,21,7,12,36,3,11,29,17,20,25,22,44,9,6,33,46,142,73,18,155]),function(Q,e,S,P,y,k,L,O,g,a,d,c,f,m,$,I,b,h,p,R,v,i,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pq=e.$oq=void 0,e.$nq=ie;const n=k.$p?m.TargetPlatform.WEB:(0,c.$ep)(k.$v,L.$dc),r="X-Market-Search-Activity-Id";var t;(function(U){U[U.None=0]="None",U[U.IncludeVersions=1]="IncludeVersions",U[U.IncludeFiles=2]="IncludeFiles",U[U.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",U[U.IncludeSharedAccounts=8]="IncludeSharedAccounts",U[U.IncludeVersionProperties=16]="IncludeVersionProperties",U[U.ExcludeNonValidated=32]="ExcludeNonValidated",U[U.IncludeInstallationTargets=64]="IncludeInstallationTargets",U[U.IncludeAssetUri=128]="IncludeAssetUri",U[U.IncludeStatistics=256]="IncludeStatistics",U[U.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",U[U.Unpublished=4096]="Unpublished",U[U.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(t||(t={}));function s(...U){return String(U.reduce((C,G)=>C|G,0))}var o;(function(U){U[U.Tag=1]="Tag",U[U.ExtensionId=4]="ExtensionId",U[U.Category=5]="Category",U[U.ExtensionName=7]="ExtensionName",U[U.Target=8]="Target",U[U.Featured=9]="Featured",U[U.SearchText=10]="SearchText",U[U.ExcludeWithFlags=12]="ExcludeWithFlags"})(o||(o={}));const u={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source",Signature:"Microsoft.VisualStudio.Services.VsixSignature"},w={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",EnabledApiProposals:"Microsoft.VisualStudio.Code.EnabledApiProposals",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink",SupportLink:"Microsoft.VisualStudio.Services.Links.Support"},T={pageNumber:1,pageSize:10,sortBy:c.SortBy.NoneOrRelevance,sortOrder:c.SortOrder.Default,flags:t.None,criteria:[],assetTypes:[]};class D{constructor(C=T){this.d=C}get pageNumber(){return this.d.pageNumber}get pageSize(){return this.d.pageSize}get sortBy(){return this.d.sortBy}get sortOrder(){return this.d.sortOrder}get flags(){return this.d.flags}get criteria(){return this.d.criteria}withPage(C,G=this.d.pageSize){return new D({...this.d,pageNumber:C,pageSize:G})}withFilter(C,...G){const J=[...this.d.criteria,...G.length?G.map(ne=>({filterType:C,value:ne})):[{filterType:C}]];return new D({...this.d,criteria:J})}withSortBy(C){return new D({...this.d,sortBy:C})}withSortOrder(C){return new D({...this.d,sortOrder:C})}withFlags(...C){return new D({...this.d,flags:C.reduce((G,J)=>G|J,0)})}withAssetTypes(...C){return new D({...this.d,assetTypes:C})}withSource(C){return new D({...this.d,source:C})}get raw(){const{criteria:C,pageNumber:G,pageSize:J,sortBy:ne,sortOrder:oe,flags:fe,assetTypes:me}=this.d;return{filters:[{criteria:C,pageNumber:G,pageSize:J,sortBy:ne,sortOrder:oe}],assetTypes:me,flags:fe}}get searchText(){const C=this.d.criteria.filter(G=>G.filterType===o.SearchText)[0];return C&&C.value?C.value:""}get telemetryData(){return{filterTypes:this.d.criteria.map(C=>String(C.filterType)),flags:this.d.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.d.source,searchTextLength:this.searchText.length}}}function N(U,C){const G=(U||[]).filter(J=>J.statisticName===C)[0];return G?G.value:0}function M(U){const C="Microsoft.VisualStudio.Code.Translation.";return U.files.filter(J=>J.assetType.indexOf(C)===0).reduce((J,ne)=>{const oe=re(U,ne.assetType);return oe&&J.push([ne.assetType.substring(C.length),oe]),J},[])}function Y(U){if(U.properties){const C=U.properties.filter(ne=>ne.key===u.Repository),G=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),J=C.filter(ne=>G.test(ne.value))[0];return J?{uri:J.value,fallbackUri:J.value}:null}return re(U,u.Repository)}function K(U){return{uri:`${U.fallbackAssetUri}/${u.VSIX}?redirect=true${U.targetPlatform?`&targetPlatform=${U.targetPlatform}`:""}`,fallbackUri:`${U.fallbackAssetUri}/${u.VSIX}${U.targetPlatform?`?targetPlatform=${U.targetPlatform}`:""}`}}function re(U,C){return U.files.filter(J=>J.assetType===C)[0]?{uri:`${U.assetUri}/${C}${U.targetPlatform?`?targetPlatform=${U.targetPlatform}`:""}`,fallbackUri:`${U.fallbackAssetUri}/${C}${U.targetPlatform?`?targetPlatform=${U.targetPlatform}`:""}`}:null}function ae(U,C){const G=U.properties?U.properties.filter(ne=>ne.key===C):[],J=G.length>0&&G[0].value;return J?J.split(",").map(ne=>(0,f.$Np)(ne)):[]}function ue(U){const C=U.properties?U.properties.filter(G=>G.key===w.Engine):[];return C.length>0&&C[0].value||""}function de(U){const C=U.properties?U.properties.filter(G=>G.key===w.PreRelease):[];return C.length>0&&C[0].value==="true"}function H(U){const C=U.properties?U.properties.filter(J=>J.key===w.EnabledApiProposals):[],G=C.length>0&&C[0].value||"";return G?G.split(","):[]}function Z(U){const C=U.properties?U.properties.filter(J=>J.key===w.LocalizedLanguages):[],G=C.length>0&&C[0].value||"";return G?G.split(","):[]}function B(U){return U.properties?.find(C=>C.key===w.SponsorLink)?.value}function z(U){return U.properties?.find(C=>C.key===w.SupportLink)?.value}function x(U){return U.indexOf("preview")!==-1}function X(U){return U.targetPlatform?(0,c.$dp)(U.targetPlatform):m.TargetPlatform.UNDEFINED}function ee(U){const C=(0,S.$Lb)(U.versions.map(X)),G=!!U.tags?.includes(c.$0o),J=C.indexOf(m.TargetPlatform.WEB);return G?J===-1&&C.push(m.TargetPlatform.WEB):J!==-1&&C.splice(J,1),C}function ie(U,C){for(let G=0;G<U.length;G++){const J=U[G];if(J.version===U[G-1]?.version){let ne=G;if(X(J)===C)for(;ne>0&&U[ne-1].version===J.version;)ne--;ne!==G&&(U.splice(G,1),U.splice(ne,0,J))}}return U}function j(U,C,G){U.telemetryData={index:C,querySource:G,queryActivityId:U.queryContext?.[r]}}function W(U,C,G,J){const ne=U.versions[0],oe={manifest:re(C,u.Manifest),readme:re(C,u.Details),changelog:re(C,u.Changelog),license:re(C,u.License),repository:Y(C),download:K(C),icon:re(C,u.Icon),signature:re(C,u.Signature),coreTranslations:M(C)};return{type:"gallery",identifier:{id:(0,f.$Op)(U.publisher.publisherName,U.extensionName),uuid:U.extensionId},name:U.extensionName,version:C.version,displayName:U.displayName,publisherId:U.publisher.publisherId,publisher:U.publisher.publisherName,publisherDisplayName:U.publisher.displayName,publisherDomain:U.publisher.domain?{link:U.publisher.domain,verified:!!U.publisher.isDomainVerified}:void 0,publisherSponsorLink:B(ne),description:U.shortDescription??"",installCount:N(U.statistics,"install"),rating:N(U.statistics,"averagerating"),ratingCount:N(U.statistics,"ratingcount"),categories:U.categories||[],tags:U.tags||[],releaseDate:Date.parse(U.releaseDate),lastUpdated:Date.parse(U.lastUpdated),allTargetPlatforms:G,assets:oe,properties:{dependencies:ae(C,w.Dependency),extensionPack:ae(C,w.ExtensionPack),engine:ue(C),enabledApiProposals:H(C),localizedLanguages:Z(C),targetPlatform:X(C),isPreReleaseVersion:de(C)},hasPreReleaseVersion:de(ne),hasReleaseVersion:!0,preview:x(U.flags),isSigned:!!oe.signature,queryContext:J,supportLink:z(ne)}}let q=class{constructor(C,G,J,ne,oe,fe,me,ge){this.l=G,this.n=J,this.o=ne,this.q=oe,this.u=fe,this.w=me,this.x=ge;const we=me.extensionsGallery,he=we?.servicePPEUrl&&ge.getValue("_extensionsGallery.enablePPE");this.d=he?we.servicePPEUrl:we?.serviceUrl,this.g=he?void 0:we?.searchUrl,this.h=we?.controlUrl,this.k=me.extensionsEnabledWithApiProposalVersion?.map(pe=>pe.toLowerCase())??[],this.j=(0,R.$mq)(me.version,me,this.o,this.x,this.u,C,this.q)}y(C=""){return`${this.d}${C}`}isEnabled(){return!!this.d}async getExtensions(C,G,J){const ne=P.CancellationToken.isCancellationToken(G)?{}:G,oe=P.CancellationToken.isCancellationToken(G)?G:J,fe=[],me=[],ge=[],we=[];let he=!0;for(const Se of C){Se.uuid?me.push(Se.uuid):fe.push(Se.id);const V=!!(Se.version||Se.preRelease);ge.push({id:Se.id,uuid:Se.uuid,includePreRelease:V}),Se.version&&we.push({id:Se.id,uuid:Se.uuid,version:Se.version}),he=he&&!!Se.hasPreRelease&&!V}if(!me.length&&!fe.length)return[];let pe=new D().withPage(1,C.length);me.length&&(pe=pe.withFilter(o.ExtensionId,...me)),fe.length&&(pe=pe.withFilter(o.ExtensionName,...fe)),(ne.queryAllVersions||he)&&(pe=pe.withFlags(pe.flags,t.IncludeVersions)),ne.source&&(pe=pe.withSource(ne.source));const{extensions:be}=await this.B(pe,{targetPlatform:ne.targetPlatform??n,includePreRelease:ge,versions:we,compatible:!!ne.compatible,productVersion:ne.productVersion??{version:this.w.version,date:this.w.date}},oe);return ne.source&&be.forEach((Se,V)=>j(Se,V,ne.source)),be}async getCompatibleExtension(C,G,J,ne={version:this.w.version,date:this.w.date}){if((0,c.$fp)(C.allTargetPlatforms,J))return null;if(await this.isExtensionCompatible(C,G,J))return C;const oe=new D().withFlags(t.IncludeVersions).withPage(1,1).withFilter(o.ExtensionId,C.identifier.uuid),{extensions:fe}=await this.B(oe,{targetPlatform:J,compatible:!0,includePreRelease:G,productVersion:ne},P.CancellationToken.None);return fe[0]||null}async isExtensionCompatible(C,G,J,ne={version:this.w.version,date:this.w.date}){if(!(0,c.$gp)(C.properties.targetPlatform,C.allTargetPlatforms,J)||!G&&C.properties.isPreReleaseVersion)return!1;let oe=C.properties.engine;if(!oe){const fe=await this.getManifest(C,P.CancellationToken.None);if(!fe)throw new Error("Manifest was not found");oe=fe.engines.vscode}return!(!(0,$.$3p)(oe,ne.version,ne.date)||!this.z(C.identifier,C.properties.enabledApiProposals))}z(C,G){return!G||!this.k.includes(C.id.toLowerCase())?!0:(0,$.$4p)(G)}async A(C,G,J,ne,oe,fe,me={version:this.w.version,date:this.w.date}){if(!(0,c.$gp)(X(G),oe,fe)||J!=="any"&&de(G)!==(J==="prerelease"))return!1;if(ne)try{const ge=await this.G(C,G);if(!(0,$.$3p)(ge,me.version,me.date))return!1}catch(ge){return this.n.error(`Error while getting the engine for the version ${G.version}.`,(0,y.$9)(ge)),!1}return!0}async query(C,G){let J=C.text||"";const ne=C.pageSize??50;let oe=new D().withPage(1,ne);J?(J=J.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(he,pe,be)=>(oe=oe.withFilter(o.Category,be||pe),"")),J=J.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(he,pe,be)=>(oe=oe.withFilter(o.Tag,be||pe),"")),J=J.replace(/\bfeatured(\s+|\b|$)/g,()=>(oe=oe.withFilter(o.Featured),"")),J=J.trim(),J&&(J=J.length<200?J:J.substring(0,200),oe=oe.withFilter(o.SearchText,J)),oe=oe.withSortBy(c.SortBy.NoneOrRelevance)):C.ids?oe=oe.withFilter(o.ExtensionId,...C.ids):C.names?oe=oe.withFilter(o.ExtensionName,...C.names):oe=oe.withSortBy(c.SortBy.InstallCount),typeof C.sortBy=="number"&&(oe=oe.withSortBy(C.sortBy)),typeof C.sortOrder=="number"&&(oe=oe.withSortOrder(C.sortOrder)),C.source&&(oe=oe.withSource(C.source));const fe=async(he,pe)=>{const{extensions:be,total:Se}=await this.B(he,{targetPlatform:n,compatible:!1,includePreRelease:!!C.includePreRelease,productVersion:C.productVersion??{version:this.w.version,date:this.w.date}},pe);return be.forEach((V,_)=>j(V,(he.pageNumber-1)*he.pageSize+_,C.source)),{extensions:be,total:Se}},{extensions:me,total:ge}=await fe(oe,G),we=async(he,pe)=>{if(pe.isCancellationRequested)throw new y.$4;const{extensions:be}=await fe(oe.withPage(he+1),pe);return be};return{firstPage:me,total:ge,pageSize:oe.pageSize,getPage:we}}async B(C,G,J){const ne=C.flags;C.flags&t.IncludeLatestVersionOnly&&C.flags&t.IncludeVersions&&(C=C.withFlags(C.flags&~t.IncludeVersions,t.IncludeLatestVersionOnly)),!(C.flags&t.IncludeLatestVersionOnly)&&!(C.flags&t.IncludeVersions)&&(C=C.withFlags(C.flags,t.IncludeLatestVersionOnly)),G.versions?.length&&(C=C.withFlags(C.flags&~t.IncludeLatestVersionOnly,t.IncludeVersions)),C=C.withFlags(C.flags,t.IncludeAssetUri,t.IncludeCategoryAndTags,t.IncludeFiles,t.IncludeStatistics,t.IncludeVersionProperties);const{galleryExtensions:oe,total:fe,context:me}=await this.D(C,J);if(!(C.flags&t.IncludeLatestVersionOnly)){const pe=[];for(const be of oe){const Se=await this.C(be,G,me);Se&&pe.push(Se)}return{extensions:pe,total:fe}}const we=[],he=new Map;for(let pe=0;pe<oe.length;pe++){const be=oe[pe],Se={id:(0,f.$Op)(be.publisher.publisherName,be.extensionName),uuid:be.extensionId},V=(0,O.$ig)(G.includePreRelease)?G.includePreRelease:!!G.includePreRelease.find(te=>(0,f.$Jp)(te,Se))?.includePreRelease;if(G.compatible&&(0,c.$fp)(ee(be),G.targetPlatform))continue;const _=await this.C(be,G,me);!_||_.properties.isPreReleaseVersion&&(!V||!_.hasReleaseVersion)||!_.properties.isPreReleaseVersion&&_.properties.targetPlatform!==G.targetPlatform&&_.hasPreReleaseVersion?he.set(be.extensionId,pe):we.push([pe,_])}if(he.size){const pe=new l.$de,be=new D().withFlags(ne&~t.IncludeLatestVersionOnly,t.IncludeVersions).withPage(1,he.size).withFilter(o.ExtensionId,...he.keys()),{extensions:Se}=await this.B(be,G,J);this.q.publicLog2("galleryService:additionalQuery",{duration:pe.elapsed(),count:he.size});for(const V of Se){const _=he.get(V.identifier.uuid);we.push([_,V])}}return{extensions:we.sort((pe,be)=>pe[0]-be[0]).map(([,pe])=>pe),total:fe}}async C(C,G,J){const ne={id:(0,f.$Op)(C.publisher.publisherName,C.extensionName),uuid:C.extensionId},oe=G.versions?.find(we=>(0,f.$Jp)(we,ne))?.version,fe=(0,O.$ig)(G.includePreRelease)?G.includePreRelease:!!G.includePreRelease.find(we=>(0,f.$Jp)(we,ne))?.includePreRelease,me=ee(C),ge=ie(C.versions,G.targetPlatform);if(G.compatible&&(0,c.$fp)(me,G.targetPlatform))return null;for(let we=0;we<ge.length;we++){const he=ge[we];if(!(oe&&he.version!==oe)){if(await this.A(ne.id,he,fe?"any":"release",G.compatible,me,G.targetPlatform,G.productVersion))return G.compatible&&!this.z(ne,H(he))?null:W(C,he,me,J);if(oe&&he.version===oe)return null}}return oe||G.compatible?null:W(C,C.versions[0],me)}async D(C,G){if(!this.isEnabled())throw new Error("No extension gallery service configured.");C=C.withFlags(C.flags,t.ExcludeNonValidated).withFilter(o.Target,"Microsoft.VisualStudio.Code").withFilter(o.ExcludeWithFlags,s(t.Unpublished));const J=await this.j,ne=JSON.stringify(C.raw),oe={...J,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(ne.length)},fe=new l.$de;let me,ge,we=0;try{if(me=await this.l.request({type:"POST",url:this.g&&C.criteria.some(pe=>pe.filterType===o.SearchText)?this.g:this.y("/extensionquery"),data:ne,headers:oe},G),me.res.statusCode&&me.res.statusCode>=400&&me.res.statusCode<500)return{galleryExtensions:[],total:we};const he=await(0,p.$$p)(me);if(he){const pe=he.results[0],be=pe.extensions,Se=pe.resultMetadata&&pe.resultMetadata.filter(V=>V.metadataType==="ResultCount")[0];return we=Se&&Se.metadataItems.filter(V=>V.name==="TotalCount")[0].count||0,{galleryExtensions:be,total:we,context:{[r]:me.res.headers.activityid}}}return{galleryExtensions:[],total:we}}catch(he){if((0,y.$3)(he))throw ge=c.ExtensionGalleryErrorCode.Cancelled,he;{const pe=(0,y.$9)(he);throw ge=pe.startsWith("XHR timeout")?c.ExtensionGalleryErrorCode.Timeout:c.ExtensionGalleryErrorCode.Failed,new c.$jp(pe,ge)}}finally{this.q.publicLog2("galleryService:query",{...C.telemetryData,requestBodySize:String(ne.length),duration:fe.elapsed(),success:!!me&&(0,p.$7p)(me),responseBodySize:me?.res.headers["Content-Length"],statusCode:me?String(me.res.statusCode):void 0,errorCode:ge,count:String(we)})}}async reportStatistic(C,G,J,ne){if(!this.isEnabled())return;const oe=k.$p?this.y(`/itemName/${C}.${G}/version/${J}/statType/${ne===c.StatisticType.Install?"1":"3"}/vscodewebextension`):this.y(`/publishers/${C}/extensions/${G}/${J}/stats?statType=${ne}`),fe=k.$p?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",ge={...await this.j,Accept:fe};try{await this.l.request({type:"POST",url:oe,headers:ge},P.CancellationToken.None)}catch{}}async download(C,G,J){this.n.trace("ExtensionGalleryService#download",C.identifier.id);const ne=(0,f.$Rp)(C),oe=new Date().getTime(),fe=J===c.InstallOperation.Install?"install":J===c.InstallOperation.Update?"update":"",me=fe?{uri:`${C.assets.download.uri}${g.URI.parse(C.assets.download.uri).query?"&":"?"}${fe}=true`,fallbackUri:`${C.assets.download.fallbackUri}${g.URI.parse(C.assets.download.fallbackUri).query?"&":"?"}${fe}=true`}:C.assets.download,ge=C.queryContext?.[r]?{[r]:C.queryContext[r]}:void 0,we=await this.F(C.identifier.id,me,u.VSIX,ge?{headers:ge}:void 0);try{await this.u.writeFile(G,we.stream)}catch(he){try{await this.u.del(G)}catch(pe){this.n.warn(`Error while deleting the file ${G.toString()}`,(0,y.$9)(pe))}throw new c.$jp((0,y.$9)(he),c.ExtensionGalleryErrorCode.DownloadFailedWriting)}this.q.publicLog("galleryService:downloadVSIX",{...ne,duration:new Date().getTime()-oe})}async downloadSignatureArchive(C,G){if(!C.assets.signature)throw new Error("No signature asset found");this.n.trace("ExtensionGalleryService#downloadSignatureArchive",C.identifier.id);const J=await this.F(C.identifier.id,C.assets.signature,u.Signature);try{await this.u.writeFile(G,J.stream)}catch(ne){try{await this.u.del(G)}catch(oe){this.n.warn(`Error while deleting the file ${G.toString()}`,(0,y.$9)(oe))}throw new c.$jp((0,y.$9)(ne),c.ExtensionGalleryErrorCode.DownloadFailedWriting)}}async getReadme(C,G){if(C.assets.readme){const J=await this.F(C.identifier.id,C.assets.readme,u.Details,{},G);return await(0,p.$0p)(J)||""}return""}async getManifest(C,G){if(C.assets.manifest){const J=await this.F(C.identifier.id,C.assets.manifest,u.Manifest,{},G),ne=await(0,p.$0p)(J);return ne?JSON.parse(ne):null}return null}async E(C,G,J){const ne=re(G,u.Manifest);if(!ne)throw new Error("Manifest was not found");const oe={"Accept-Encoding":"gzip"},fe=await this.F(C,ne,u.Manifest,{headers:oe});return await(0,p.$$p)(fe)}async getCoreTranslation(C,G){const J=C.assets.coreTranslations.filter(ne=>ne[0]===G.toUpperCase())[0];if(J){const ne=await this.F(C.identifier.id,J[1],J[0]),oe=await(0,p.$0p)(ne);return oe?JSON.parse(oe):null}return null}async getChangelog(C,G){if(C.assets.changelog){const J=await this.F(C.identifier.id,C.assets.changelog,u.Changelog,{},G);return await(0,p.$0p)(J)||""}return""}async getAllCompatibleVersions(C,G,J){let ne=new D().withFlags(t.IncludeVersions,t.IncludeCategoryAndTags,t.IncludeFiles,t.IncludeVersionProperties).withPage(1,1);C.uuid?ne=ne.withFilter(o.ExtensionId,C.uuid):ne=ne.withFilter(o.ExtensionName,C.id);const{galleryExtensions:oe}=await this.D(ne,P.CancellationToken.None);if(!oe.length)return[];const fe=ee(oe[0]);if((0,c.$fp)(fe,J))return[];const me=[];await Promise.all(oe[0].versions.map(async he=>{try{await this.A(C.id,he,G?"any":"release",!0,fe,J)&&this.z(C,H(he))&&me.push(he)}catch{}}));const ge=[],we=new Set;for(const he of ie(me,J))we.has(he.version)||(we.add(he.version),ge.push({version:he.version,date:he.lastUpdated,isPreReleaseVersion:de(he)}));return ge}async F(C,G,J,ne={},oe=P.CancellationToken.None){const fe=await this.j,me={type:"GET"},ge={...fe,...ne.headers||{}};ne={...ne,...me,headers:ge};const we=G.uri,he=G.fallbackUri,pe={...ne,url:we};try{const be=await this.l.request(pe,oe);if(be.res.statusCode===200)return be;const Se=await(0,p.$0p)(be);throw new Error(`Expected 200, got back ${be.res.statusCode} instead.

${Se}`)}catch(be){if((0,y.$3)(be))throw be;const Se=(0,y.$9)(be);this.q.publicLog2("galleryService:cdnFallback",{extension:C,assetType:J,message:Se});const V={...ne,url:he};return this.l.request(V,oe)}}async G(C,G){let J=ue(G);if(!J){this.q.publicLog2("galleryService:engineFallback",{extension:C,version:G.version});const ne=await this.E(C,G,P.CancellationToken.None);if(!ne)throw new Error("Manifest was not found");J=ne.engines.vscode}return J}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.h)return{malicious:[],deprecated:{},search:[]};const C=await this.l.request({type:"GET",url:this.h},P.CancellationToken.None);if(C.res.statusCode!==200)throw new Error("Could not get extensions report.");const G=await(0,p.$$p)(C),J=[],ne={},oe=[],fe=[];if(G){for(const me of G.malicious)J.push({id:me});if(G.migrateToPreRelease)for(const[me,ge]of Object.entries(G.migrateToPreRelease))(!ge.engine||(0,$.$3p)(ge.engine,this.w.version,this.w.date))&&(ne[me.toLowerCase()]={disallowInstall:!0,extension:{id:ge.id,displayName:ge.displayName,autoMigrate:{storage:!!ge.migrateStorage},preRelease:!0}});if(G.deprecated)for(const[me,ge]of Object.entries(G.deprecated))ge&&(ne[me.toLowerCase()]=(0,O.$ig)(ge)?{}:ge);if(G.search)for(const me of G.search)oe.push(me);if(Array.isArray(G.extensionsEnabledWithPreRelease))for(const me of G.extensionsEnabledWithPreRelease)fe.push(me.toLowerCase())}return{malicious:J,deprecated:ne,search:oe,extensionsEnabledWithPreRelease:fe}}};q=ve([se(1,p.$5p),se(2,b.$0j),se(3,d.$Ji),se(4,i.$9l),se(5,I.$0k),se(6,h.$qk),se(7,a.$9i)],q);let E=class extends q{constructor(C,G,J,ne,oe,fe,me,ge){super(C,G,J,ne,oe,fe,me,ge)}};e.$oq=E,e.$oq=E=ve([se(0,v.$fq),se(1,p.$5p),se(2,b.$0j),se(3,d.$Ji),se(4,i.$9l),se(5,I.$0k),se(6,h.$qk),se(7,a.$9i)],E);let F=class extends q{constructor(C,G,J,ne,oe,fe,me){super(void 0,C,G,J,ne,oe,fe,me)}};e.$pq=F,e.$pq=F=ve([se(0,p.$5p),se(1,b.$0j),se(2,d.$Ji),se(3,i.$9l),se(4,I.$0k),se(5,h.$qk),se(6,a.$9i)],F)}),define(ce[144],le([0,1,11,17,9,6,123,23,24,3,69]),function(Q,e,S,P,y,k,L,O,g,a,d){"use strict";var c,f;Object.defineProperty(e,"__esModule",{value:!0}),e.$tR=e.$sR=e.$rR=void 0;let m=class extends g.$Ml{static{c=this}static{this.a="profileAssociationsMigration"}constructor(h,p,R,v,i){super(R,v,p,i),this.U=h,this.W=R}O(){return this.U.getItem(c.b,[]).map(p=>({...p,location:(0,a.$cg)(p.location)?this.w.extUri.joinPath(this.profilesHome,p.location):S.URI.revive(p.location)}))}Q(){const h=this.U.getItem(c.c,{});return this.U.getItem(c.a,!1)?h:this.N(h)}S(){return this.w.extUri.joinPath(S.URI.file(this.W.extensionsPath).with({scheme:this.profilesHome.scheme}),"extensions.json")}};e.$rR=m,e.$rR=m=c=ve([se(0,L.$mR),se(1,O.$Hl),se(2,P.$Ki),se(3,y.$0k),se(4,k.$0j)],m);let $=f=class extends m{constructor(h,p,R,v,i){super(h,p,R,v,i),this.$=h}P(h){h.length?this.$.setItem(f.b,h.map(p=>({...p,location:this.w.extUri.basename(p.location)}))):this.$.removeItem(f.b)}O(){const h=super.O();return this.$.getItem("userDataProfilesMigration",!1)||(this.P(h),this.$.setItem("userDataProfilesMigration",!0)),h}R(h){h.emptyWindows||h.workspaces?this.$.setItem(f.c,h):this.$.removeItem(f.c)}Q(){const h="workspaceAndProfileInfo",p=this.$.getItem(h,void 0);if(p){this.$.removeItem(h);const v=p.reduce((i,{workspace:l,profile:n})=>(i[S.URI.revive(l).toString()]=S.URI.revive(n).toString(),i),{});this.$.setItem(f.c,{workspaces:v})}const R=super.Q();return this.$.getItem(f.a,!1)||(this.R(R),this.$.setItem(f.a,!0)),R}};e.$sR=$,e.$sR=$=f=ve([se(0,L.$nR),se(1,O.$Hl),se(2,P.$Ki),se(3,y.$0k),se(4,k.$0j)],$);let I=class extends ${constructor(h,p,R,v){super(new d.$qR(d.SaveStrategy.IMMEDIATE,p,v,R),h,p,R,v)}async init(){return await this.$.init(),super.init()}};e.$tR=I,e.$tR=I=ve([se(0,O.$Hl),se(1,P.$Ki),se(2,y.$0k),se(3,k.$0j)],I)}),define(ce[145],le([0,1,121,8,13,7,3,29,17,122,6,46,120,156]),function(Q,e,S,P,y,k,L,O,g,a,d,c,f,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cs=void 0,e.$ds=b;let $=class extends c.$6p{constructor(p,R,v,i){super(i),this.m=p,this.n=R,this.r=v,this.s(),this.B(p.onDidChangeConfiguration(l=>{l.affectsConfiguration("http")&&this.s()}))}s(){const p=this.m.getValue("http");this.f=p?.proxy,this.g=!!p?.proxyStrictSSL,this.h=p?.proxyAuthorization}async request(p,R){const{f:v,g:i}=this;let l;try{l=await(0,a.$Om)(this.m,this.r,this.n.args,process.env)}catch(t){this.j||(this.j=!0,this.r.error("resolving shell environment failed",(0,k.$9)(t)))}const n={...process.env,...l},r=p.agent?p.agent:await(0,f.$bs)(p.url||"",n,{proxyUrl:v,strictSSL:i});return p.agent=r,p.strictSSL=i,this.h&&(p.headers={...p.headers||{},"Proxy-Authorization":this.h}),this.c(p.isChromiumNetwork?"electron":"node",p,()=>b(p,R))}async resolveProxy(p){}async lookupAuthorization(p){}async loadCertificates(){return(await new Promise((R,v)=>{Q(["@vscode/proxy-agent"],R,v)}).then(ye)).loadSystemCertificates({log:this.r})}};e.$cs=$,e.$cs=$=ve([se(0,O.$9i),se(1,g.$Ki),se(2,d.$0j),se(3,d.$$j)],$);async function I(h){return((0,S.parse)(h.url).protocol==="https:"?await new Promise((v,i)=>{Q(["https"],v,i)}).then(ye):await new Promise((v,i)=>{Q(["http"],v,i)}).then(ye)).request}async function b(h,p){return P.Promises.withAsyncBody(async(R,v)=>{const i=(0,S.parse)(h.url),l=h.getRawRequest?h.getRawRequest(h):await I(h),n={hostname:i.hostname,port:i.port?parseInt(i.port):i.protocol==="https:"?443:80,protocol:i.protocol,path:i.path,method:h.type||"GET",headers:h.headers,agent:h.agent,rejectUnauthorized:(0,L.$ig)(h.strictSSL)?h.strictSSL:!0};h.user&&h.password&&(n.auth=h.user+":"+h.password);const r=l(n,t=>{const s=(0,L.$gg)(h.followRedirects)?h.followRedirects:3;if(t.statusCode&&t.statusCode>=300&&t.statusCode<400&&s>0&&t.headers.location)b({...h,url:t.headers.location,followRedirects:s-1},p).then(R,v);else{let o=t;!h.isChromiumNetwork&&t.headers["content-encoding"]==="gzip"&&(o=t.pipe((0,m.createGunzip)())),R({res:t,stream:(0,y.$1e)(o)})}});r.on("error",v),h.timeout&&r.setTimeout(h.timeout),h.isChromiumNetwork&&r.removeHeader("Content-Length"),h.data&&typeof h.data=="string"&&r.write(h.data),r.end(),p.onCancellationRequested(()=>{r.abort(),v(new k.$4)})})}});var qe=this&&this.__importDefault||function(Q){return Q&&Q.__esModule?Q:{default:Q}};define(ce[157],le([0,1,32,35,8,38,7,2,14,15,12,36,11,29,117,61,119,17,95,143,20,71,124,42,54,138,140,9,107,109,51,105,64,68,126,6,113,39,114,129,33,46,145,69,70,18,128,41,130,131,23,133,24,144,132,139,110,112,5,134,158]),function(Q,e,S,P,y,k,L,O,g,a,d,c,f,m,$,I,b,h,p,R,v,i,l,n,r,t,s,o,u,w,A,T,D,N,M,Y,K,re,ae,ue,de,H,Z,B,z,x,X,ee,ie,j,W,q,E,F,U,C,G,J,ne,oe,fe){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=ge,S=ye(S),ue=qe(ue);class me extends O.$Tc{constructor(he){super(),this.b=he,this.c()}c(){process.once("exit",()=>this.dispose())}async run(){const[he,pe]=await this.f();return he.invokeFunction(async be=>{const Se=be.get(Y.$0j),V=be.get(o.$0k),_=be.get(h.$Ki),te=be.get(E.$Jl);Se.info("CLI main",this.b),this.h(Se),await this.j(_,V,te,he),await Promise.all(pe.map($e=>{(0,y.$th)($e.flush(),1e3)}))})}async f(){const he=new D.$Ai,pe={_serviceBrand:void 0,...ue.default};he.set(de.$qk,pe);const be=new p.$6m(this.b,pe);he.set(h.$Ki,be),await Promise.all([this.g(be.appSettingsHome.with({scheme:g.Schemas.file}).fsPath),this.g(be.extensionsPath)].map(Ie=>Ie?S.promises.mkdir(Ie,{recursive:!0}):void 0));const Se=new J.$lR((0,Y.$lk)(be),be.logsHome);he.set(Y.$$j,Se);const V=this.B(Se.createLogger("cli",{name:(0,ne.localize)(12775,null)})),_=[];Se.getLogLevel()===Y.LogLevel.Trace&&_.push(new Y.$fk(Se.getLogLevel()));const te=this.B(new G.$vR(V,_));he.set(Y.$0j,te);const $e=this.B(new u.$Zq(te));he.set(o.$0k,$e);const Ee=this.B(new w.$qr(te));$e.registerProvider(g.Schemas.file,Ee);const Ne=new q.$Rs($e);he.set(W.$Hl,Ne);const ke=new B.$pR(B.SaveStrategy.DELAYED,be,te,$e),Ce=new F.$rR(ke,Ne,be,$e,te);he.set(E.$Jl,Ce),$e.registerProvider(g.Schemas.vscodeUserData,new oe.$hhc(g.Schemas.file,Ee,g.Schemas.vscodeUserData,Ce,Ne,te));const Re=d.$j&&pe.win32RegValueName?this.B(new ae.$fhc(te,pe.win32RegValueName)):be.policyFile?this.B(new K.$ghc(be.policyFile,$e,te)):new re.$so;he.set(re.$qo,Re);const Le=this.B(new $.$Uo(Ce.defaultProfile.settingsResource,$e,Re,te));he.set(m.$9i,Le),await Promise.all([ke.init(),Le.initialize()]);let ze;try{ze=await(0,U.$Tgc)(ke,te)}catch(Ie){Ie.code!=="ENOENT"&&te.error(Ie)}const Ae=await(0,U.$Ugc)(ke,te),Te=await(0,U.$Vgc)(ke,te);Ce.init(),he.set(W.$Hl,new q.$Rs($e));const je=new Z.$cs(Le,be,te,Se);he.set(H.$5p,je),he.set(I.$Yo,new A.$zi(b.$KR,void 0,!0)),he.set(n.$Gq,new A.$zi(C.$uR,void 0,!0)),he.set(r.$Kq,new A.$zi(s.$Qgc,void 0,!0)),he.set(i.$qq,new A.$zi(i.$sq,void 0,!0)),he.set(t.$Vq,new A.$zi(t.$Wq,void 0,!0)),he.set(v.$ip,new A.$zi(R.$pq,void 0,!0)),he.set(N.$9r,new A.$zi(M.$$r,void 0,!1));const Ue=[],Pe=(0,ee.$Gp)(pe,Le);if((0,ee.$Bp)(pe,be)){pe.aiConfig&&pe.aiConfig.ariaKey&&Ue.push(new ie.$jR(je,Pe,"monacoworkbench",null,pe.aiConfig.ariaKey));const Ie={appenders:Ue,sendErrorTelemetry:!1,commonProperties:(0,z.$sp)((0,P.release)(),(0,P.hostname)(),process.arch,pe.commit,pe.version,ze,Ae,Te,Pe),piiPaths:(0,ee.$Hp)(be)};he.set(x.$9l,new A.$zi(X.$es,[Ie],!1))}else he.set(x.$9l,ee.$wp);return[new T.$tr(he),Ue]}g(he){if(d.$j){const pe=(0,fe.getUNCHost)(he);pe&&(0,fe.addUNCHostToAllowlist)(pe)}return he}h(he){(0,L.setUnexpectedErrorHandler)(pe=>{const be=(0,k.$nj)(pe,!0);be&&he.error(`[uncaught exception in CLI]: ${be}`)}),process.on("uncaughtException",pe=>{(0,L.$X)(pe)||(0,L.$Y)(pe)}),process.on("unhandledRejection",pe=>(0,L.$Y)(pe))}async j(he,pe,be,Se){let V;if(he.args.profile&&(V=be.profiles.find(te=>te.name===he.args.profile),!V))throw new Error(`Profile '${he.args.profile}' not found.`);const _=(V??be.defaultProfile).extensionsResource;if(this.b["list-extensions"])return Se.createInstance(l.$tq,new Y.$fk(Y.LogLevel.Info,!1)).listExtensions(!!this.b["show-versions"],this.b.category,_);if(this.b["install-extension"]||this.b["install-builtin-extension"]){const te={isMachineScoped:!!this.b["do-not-sync"],installPreReleaseVersion:!!this.b["pre-release"],profileLocation:_};return Se.createInstance(l.$tq,new Y.$fk(Y.LogLevel.Info,!1)).installExtensions(this.m(this.b["install-extension"]||[]),this.m(this.b["install-builtin-extension"]||[]),te,!!this.b.force)}else{if(this.b["uninstall-extension"])return Se.createInstance(l.$tq,new Y.$fk(Y.LogLevel.Info,!1)).uninstallExtensions(this.m(this.b["uninstall-extension"]),!!this.b.force,_);if(this.b["update-extensions"])return Se.createInstance(l.$tq,new Y.$fk(Y.LogLevel.Info,!1)).updateExtensions(_);if(this.b["locate-extension"])return Se.createInstance(l.$tq,new Y.$fk(Y.LogLevel.Info,!1)).locateExtension(this.b["locate-extension"]);this.b.telemetry&&console.log(await(0,j.$whc)(he.appRoot,he.extensionsPath))}}m(he){return he.map(pe=>/\.vsix$/i.test(pe)?f.URI.file((0,a.$hc)(pe)?pe:(0,a.$ic)((0,c.cwd)(),pe)):pe)}}async function ge(we){const he=new me(we);try{await he.run()}finally{he.dispose()}}})}).call(this);

//# sourceMappingURL=https://main.vscode-cdn.net/sourcemaps/8703a11164db333db471576d38ddc143d6ad7ead/core/vs/code/node/cliProcessMain.js.map
